/* BaseObject.c generated by valac 0.56.18, the Vala compiler
 * generated from BaseObject.vala, do not modify */

/*
* Copyright © 2023 Alain M. (https://github.com/alainm23/planify)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 3 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*
* Authored by: Alain M. <alainmh23@gmail.com>
*/

#include "planify.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gee.h>
#include <glib-object.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	OBJECTS_BASE_OBJECT_0_PROPERTY,
	OBJECTS_BASE_OBJECT_ID_PROPERTY,
	OBJECTS_BASE_OBJECT_NAME_PROPERTY,
	OBJECTS_BASE_OBJECT_KEYWORDS_PROPERTY,
	OBJECTS_BASE_OBJECT_ICON_NAME_PROPERTY,
	OBJECTS_BASE_OBJECT_UPDATE_TIMEOUT_ID_PROPERTY,
	OBJECTS_BASE_OBJECT_ID_STRING_PROPERTY,
	OBJECTS_BASE_OBJECT_LOADING_PROPERTY,
	OBJECTS_BASE_OBJECT_SENSITIVE_PROPERTY,
	OBJECTS_BASE_OBJECT_VIEW_ID_PROPERTY,
	OBJECTS_BASE_OBJECT_TYPE_DELETE_PROPERTY,
	OBJECTS_BASE_OBJECT_TYPE_ADD_PROPERTY,
	OBJECTS_BASE_OBJECT_TYPE_UPDATE_PROPERTY,
	OBJECTS_BASE_OBJECT_OBJECT_TYPE_PROPERTY,
	OBJECTS_BASE_OBJECT_OBJECT_TYPE_STRING_PROPERTY,
	OBJECTS_BASE_OBJECT_TABLE_NAME_PROPERTY,
	OBJECTS_BASE_OBJECT_COLUMN_ORDER_NAME_PROPERTY,
	OBJECTS_BASE_OBJECT_SOURCE_PROPERTY,
	OBJECTS_BASE_OBJECT_NUM_PROPERTIES
};
static GParamSpec* objects_base_object_properties[OBJECTS_BASE_OBJECT_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
enum  {
	OBJECTS_BASE_OBJECT_DELETED_SIGNAL,
	OBJECTS_BASE_OBJECT_UPDATED_SIGNAL,
	OBJECTS_BASE_OBJECT_ARCHIVED_SIGNAL,
	OBJECTS_BASE_OBJECT_UNARCHIVED_SIGNAL,
	OBJECTS_BASE_OBJECT_FILTER_ADDED_SIGNAL,
	OBJECTS_BASE_OBJECT_FILTER_REMOVED_SIGNAL,
	OBJECTS_BASE_OBJECT_FILTER_UPDATED_SIGNAL,
	OBJECTS_BASE_OBJECT_LOADING_CHANGE_SIGNAL,
	OBJECTS_BASE_OBJECT_SENSITIVE_CHANGE_SIGNAL,
	OBJECTS_BASE_OBJECT_NUM_SIGNALS
};
static guint objects_base_object_signals[OBJECTS_BASE_OBJECT_NUM_SIGNALS] = {0};

struct _ObjectsBaseObjectPrivate {
	gchar* _id;
	gchar* _name;
	gchar* _keywords;
	gchar* _icon_name;
	guint _update_timeout_id;
	gchar* _id_string;
	gboolean _loading;
	gboolean _sensitive;
	gchar* _view_id;
	ObjectsSource* _source;
};

static gint ObjectsBaseObject_private_offset;
static gpointer objects_base_object_parent_class = NULL;

static gchar* objects_base_object_real_get_update_json (ObjectsBaseObject* self,
                                                 const gchar* uuid,
                                                 const gchar* temp_id);
static gchar* objects_base_object_real_get_add_json (ObjectsBaseObject* self,
                                              const gchar* temp_id,
                                              const gchar* uuid);
static gchar* objects_base_object_real_get_move_json (ObjectsBaseObject* self,
                                               const gchar* uuid,
                                               const gchar* new_project_id);
static gchar* objects_base_object_real_to_json (ObjectsBaseObject* self);
static void objects_base_object_finalize (GObject * obj);
static GType objects_base_object_get_type_once (void);
static void _vala_objects_base_object_get_property (GObject * object,
                                             guint property_id,
                                             GValue * value,
                                             GParamSpec * pspec);
static void _vala_objects_base_object_set_property (GObject * object,
                                             guint property_id,
                                             const GValue * value,
                                             GParamSpec * pspec);

static inline gpointer
objects_base_object_get_instance_private (ObjectsBaseObject* self)
{
	return G_STRUCT_MEMBER_P (self, ObjectsBaseObject_private_offset);
}

static gchar*
objects_base_object_real_get_update_json (ObjectsBaseObject* self,
                                          const gchar* uuid,
                                          const gchar* temp_id)
{
	gchar* _tmp0_;
	gchar* result;
#line 224 "../core/Objects/BaseObject.vala"
	g_return_val_if_fail (uuid != NULL, NULL);
#line 225 "../core/Objects/BaseObject.vala"
	_tmp0_ = g_strdup ("");
#line 225 "../core/Objects/BaseObject.vala"
	result = _tmp0_;
#line 225 "../core/Objects/BaseObject.vala"
	return result;
#line 138 "BaseObject.c"
}

gchar*
objects_base_object_get_update_json (ObjectsBaseObject* self,
                                     const gchar* uuid,
                                     const gchar* temp_id)
{
	ObjectsBaseObjectClass* _klass_;
#line 224 "../core/Objects/BaseObject.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 224 "../core/Objects/BaseObject.vala"
	_klass_ = OBJECTS_BASE_OBJECT_GET_CLASS (self);
#line 224 "../core/Objects/BaseObject.vala"
	if (_klass_->get_update_json) {
#line 224 "../core/Objects/BaseObject.vala"
		return _klass_->get_update_json (self, uuid, temp_id);
#line 155 "BaseObject.c"
	}
#line 224 "../core/Objects/BaseObject.vala"
	return NULL;
#line 159 "BaseObject.c"
}

static gchar*
objects_base_object_real_get_add_json (ObjectsBaseObject* self,
                                       const gchar* temp_id,
                                       const gchar* uuid)
{
	gchar* _tmp0_;
	gchar* result;
#line 228 "../core/Objects/BaseObject.vala"
	g_return_val_if_fail (temp_id != NULL, NULL);
#line 228 "../core/Objects/BaseObject.vala"
	g_return_val_if_fail (uuid != NULL, NULL);
#line 229 "../core/Objects/BaseObject.vala"
	_tmp0_ = g_strdup ("");
#line 229 "../core/Objects/BaseObject.vala"
	result = _tmp0_;
#line 229 "../core/Objects/BaseObject.vala"
	return result;
#line 179 "BaseObject.c"
}

gchar*
objects_base_object_get_add_json (ObjectsBaseObject* self,
                                  const gchar* temp_id,
                                  const gchar* uuid)
{
	ObjectsBaseObjectClass* _klass_;
#line 228 "../core/Objects/BaseObject.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 228 "../core/Objects/BaseObject.vala"
	_klass_ = OBJECTS_BASE_OBJECT_GET_CLASS (self);
#line 228 "../core/Objects/BaseObject.vala"
	if (_klass_->get_add_json) {
#line 228 "../core/Objects/BaseObject.vala"
		return _klass_->get_add_json (self, temp_id, uuid);
#line 196 "BaseObject.c"
	}
#line 228 "../core/Objects/BaseObject.vala"
	return NULL;
#line 200 "BaseObject.c"
}

static gchar*
objects_base_object_real_get_move_json (ObjectsBaseObject* self,
                                        const gchar* uuid,
                                        const gchar* new_project_id)
{
	gchar* _tmp0_;
	gchar* result;
#line 232 "../core/Objects/BaseObject.vala"
	g_return_val_if_fail (uuid != NULL, NULL);
#line 232 "../core/Objects/BaseObject.vala"
	g_return_val_if_fail (new_project_id != NULL, NULL);
#line 233 "../core/Objects/BaseObject.vala"
	_tmp0_ = g_strdup ("");
#line 233 "../core/Objects/BaseObject.vala"
	result = _tmp0_;
#line 233 "../core/Objects/BaseObject.vala"
	return result;
#line 220 "BaseObject.c"
}

gchar*
objects_base_object_get_move_json (ObjectsBaseObject* self,
                                   const gchar* uuid,
                                   const gchar* new_project_id)
{
	ObjectsBaseObjectClass* _klass_;
#line 232 "../core/Objects/BaseObject.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 232 "../core/Objects/BaseObject.vala"
	_klass_ = OBJECTS_BASE_OBJECT_GET_CLASS (self);
#line 232 "../core/Objects/BaseObject.vala"
	if (_klass_->get_move_json) {
#line 232 "../core/Objects/BaseObject.vala"
		return _klass_->get_move_json (self, uuid, new_project_id);
#line 237 "BaseObject.c"
	}
#line 232 "../core/Objects/BaseObject.vala"
	return NULL;
#line 241 "BaseObject.c"
}

static gchar*
objects_base_object_real_to_json (ObjectsBaseObject* self)
{
	gchar* _tmp0_;
	gchar* result;
#line 237 "../core/Objects/BaseObject.vala"
	_tmp0_ = g_strdup ("");
#line 237 "../core/Objects/BaseObject.vala"
	result = _tmp0_;
#line 237 "../core/Objects/BaseObject.vala"
	return result;
#line 255 "BaseObject.c"
}

gchar*
objects_base_object_to_json (ObjectsBaseObject* self)
{
	ObjectsBaseObjectClass* _klass_;
#line 236 "../core/Objects/BaseObject.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 236 "../core/Objects/BaseObject.vala"
	_klass_ = OBJECTS_BASE_OBJECT_GET_CLASS (self);
#line 236 "../core/Objects/BaseObject.vala"
	if (_klass_->to_json) {
#line 236 "../core/Objects/BaseObject.vala"
		return _klass_->to_json (self);
#line 270 "BaseObject.c"
	}
#line 236 "../core/Objects/BaseObject.vala"
	return NULL;
#line 274 "BaseObject.c"
}

void
objects_base_object_add_filter (ObjectsBaseObject* self,
                                ObjectsFiltersFilterItem* filter)
{
	GeeHashMap* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
#line 240 "../core/Objects/BaseObject.vala"
	g_return_if_fail (self != NULL);
#line 240 "../core/Objects/BaseObject.vala"
	g_return_if_fail (filter != NULL);
#line 241 "../core/Objects/BaseObject.vala"
	_tmp0_ = self->filters;
#line 241 "../core/Objects/BaseObject.vala"
	_tmp1_ = objects_filters_filter_item_get_id (filter);
#line 241 "../core/Objects/BaseObject.vala"
	_tmp2_ = _tmp1_;
#line 241 "../core/Objects/BaseObject.vala"
	if (!gee_abstract_map_has_key ((GeeAbstractMap*) _tmp0_, _tmp2_)) {
#line 296 "BaseObject.c"
		GeeHashMap* _tmp3_;
		const gchar* _tmp4_;
		const gchar* _tmp5_;
		GeeHashMap* _tmp6_;
		const gchar* _tmp7_;
		const gchar* _tmp8_;
		gpointer _tmp9_;
		ObjectsFiltersFilterItem* _tmp10_;
#line 242 "../core/Objects/BaseObject.vala"
		_tmp3_ = self->filters;
#line 242 "../core/Objects/BaseObject.vala"
		_tmp4_ = objects_filters_filter_item_get_id (filter);
#line 242 "../core/Objects/BaseObject.vala"
		_tmp5_ = _tmp4_;
#line 242 "../core/Objects/BaseObject.vala"
		gee_abstract_map_set ((GeeAbstractMap*) _tmp3_, _tmp5_, filter);
#line 243 "../core/Objects/BaseObject.vala"
		_tmp6_ = self->filters;
#line 243 "../core/Objects/BaseObject.vala"
		_tmp7_ = objects_filters_filter_item_get_id (filter);
#line 243 "../core/Objects/BaseObject.vala"
		_tmp8_ = _tmp7_;
#line 243 "../core/Objects/BaseObject.vala"
		_tmp9_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp6_, _tmp8_);
#line 243 "../core/Objects/BaseObject.vala"
		_tmp10_ = (ObjectsFiltersFilterItem*) _tmp9_;
#line 243 "../core/Objects/BaseObject.vala"
		g_signal_emit (self, objects_base_object_signals[OBJECTS_BASE_OBJECT_FILTER_ADDED_SIGNAL], 0, _tmp10_);
#line 243 "../core/Objects/BaseObject.vala"
		_g_object_unref0 (_tmp10_);
#line 327 "BaseObject.c"
	}
}

void
objects_base_object_remove_filter (ObjectsBaseObject* self,
                                   ObjectsFiltersFilterItem* filter)
{
	GeeHashMap* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
#line 247 "../core/Objects/BaseObject.vala"
	g_return_if_fail (self != NULL);
#line 247 "../core/Objects/BaseObject.vala"
	g_return_if_fail (filter != NULL);
#line 248 "../core/Objects/BaseObject.vala"
	_tmp0_ = self->filters;
#line 248 "../core/Objects/BaseObject.vala"
	_tmp1_ = objects_filters_filter_item_get_id (filter);
#line 248 "../core/Objects/BaseObject.vala"
	_tmp2_ = _tmp1_;
#line 248 "../core/Objects/BaseObject.vala"
	if (gee_abstract_map_has_key ((GeeAbstractMap*) _tmp0_, _tmp2_)) {
#line 350 "BaseObject.c"
		GeeHashMap* _tmp3_;
		const gchar* _tmp4_;
		const gchar* _tmp5_;
#line 249 "../core/Objects/BaseObject.vala"
		_tmp3_ = self->filters;
#line 249 "../core/Objects/BaseObject.vala"
		_tmp4_ = objects_filters_filter_item_get_id (filter);
#line 249 "../core/Objects/BaseObject.vala"
		_tmp5_ = _tmp4_;
#line 249 "../core/Objects/BaseObject.vala"
		gee_abstract_map_unset ((GeeAbstractMap*) _tmp3_, _tmp5_, NULL);
#line 250 "../core/Objects/BaseObject.vala"
		g_signal_emit (self, objects_base_object_signals[OBJECTS_BASE_OBJECT_FILTER_REMOVED_SIGNAL], 0, filter);
#line 364 "BaseObject.c"
	}
}

void
objects_base_object_update_filter (ObjectsBaseObject* self,
                                   ObjectsFiltersFilterItem* filter)
{
	GeeHashMap* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
#line 254 "../core/Objects/BaseObject.vala"
	g_return_if_fail (self != NULL);
#line 254 "../core/Objects/BaseObject.vala"
	g_return_if_fail (filter != NULL);
#line 255 "../core/Objects/BaseObject.vala"
	_tmp0_ = self->filters;
#line 255 "../core/Objects/BaseObject.vala"
	_tmp1_ = objects_filters_filter_item_get_id (filter);
#line 255 "../core/Objects/BaseObject.vala"
	_tmp2_ = _tmp1_;
#line 255 "../core/Objects/BaseObject.vala"
	if (gee_abstract_map_has_key ((GeeAbstractMap*) _tmp0_, _tmp2_)) {
#line 387 "BaseObject.c"
		GeeHashMap* _tmp3_;
		const gchar* _tmp4_;
		const gchar* _tmp5_;
#line 256 "../core/Objects/BaseObject.vala"
		_tmp3_ = self->filters;
#line 256 "../core/Objects/BaseObject.vala"
		_tmp4_ = objects_filters_filter_item_get_id (filter);
#line 256 "../core/Objects/BaseObject.vala"
		_tmp5_ = _tmp4_;
#line 256 "../core/Objects/BaseObject.vala"
		gee_abstract_map_set ((GeeAbstractMap*) _tmp3_, _tmp5_, filter);
#line 257 "../core/Objects/BaseObject.vala"
		g_signal_emit (self, objects_base_object_signals[OBJECTS_BASE_OBJECT_FILTER_UPDATED_SIGNAL], 0, filter);
#line 401 "BaseObject.c"
	}
}

ObjectsFiltersFilterItem*
objects_base_object_get_filter (ObjectsBaseObject* self,
                                const gchar* id)
{
	GeeHashMap* _tmp0_;
	ObjectsFiltersFilterItem* result;
#line 261 "../core/Objects/BaseObject.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 261 "../core/Objects/BaseObject.vala"
	g_return_val_if_fail (id != NULL, NULL);
#line 262 "../core/Objects/BaseObject.vala"
	_tmp0_ = self->filters;
#line 262 "../core/Objects/BaseObject.vala"
	if (gee_abstract_map_has_key ((GeeAbstractMap*) _tmp0_, id)) {
#line 419 "BaseObject.c"
		GeeHashMap* _tmp1_;
		gpointer _tmp2_;
#line 263 "../core/Objects/BaseObject.vala"
		_tmp1_ = self->filters;
#line 263 "../core/Objects/BaseObject.vala"
		_tmp2_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp1_, id);
#line 263 "../core/Objects/BaseObject.vala"
		result = (ObjectsFiltersFilterItem*) _tmp2_;
#line 263 "../core/Objects/BaseObject.vala"
		return result;
#line 430 "BaseObject.c"
	}
#line 266 "../core/Objects/BaseObject.vala"
	result = NULL;
#line 266 "../core/Objects/BaseObject.vala"
	return result;
#line 436 "BaseObject.c"
}

ObjectsBaseObject*
objects_base_object_construct (GType object_type)
{
	ObjectsBaseObject * self = NULL;
#line 22 "../core/Objects/BaseObject.vala"
	self = (ObjectsBaseObject*) g_object_new (object_type, NULL);
#line 22 "../core/Objects/BaseObject.vala"
	return self;
#line 447 "BaseObject.c"
}

ObjectsBaseObject*
objects_base_object_new (void)
{
#line 22 "../core/Objects/BaseObject.vala"
	return objects_base_object_construct (OBJECTS_TYPE_BASE_OBJECT);
#line 455 "BaseObject.c"
}

const gchar*
objects_base_object_get_id (ObjectsBaseObject* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 23 "../core/Objects/BaseObject.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 23 "../core/Objects/BaseObject.vala"
	_tmp0_ = self->priv->_id;
#line 23 "../core/Objects/BaseObject.vala"
	result = _tmp0_;
#line 23 "../core/Objects/BaseObject.vala"
	return result;
#line 471 "BaseObject.c"
}

void
objects_base_object_set_id (ObjectsBaseObject* self,
                            const gchar* value)
{
	gchar* old_value;
#line 23 "../core/Objects/BaseObject.vala"
	g_return_if_fail (self != NULL);
#line 23 "../core/Objects/BaseObject.vala"
	old_value = objects_base_object_get_id (self);
#line 23 "../core/Objects/BaseObject.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 485 "BaseObject.c"
		gchar* _tmp0_;
#line 23 "../core/Objects/BaseObject.vala"
		_tmp0_ = g_strdup (value);
#line 23 "../core/Objects/BaseObject.vala"
		_g_free0 (self->priv->_id);
#line 23 "../core/Objects/BaseObject.vala"
		self->priv->_id = _tmp0_;
#line 23 "../core/Objects/BaseObject.vala"
		g_object_notify_by_pspec ((GObject *) self, objects_base_object_properties[OBJECTS_BASE_OBJECT_ID_PROPERTY]);
#line 495 "BaseObject.c"
	}
}

const gchar*
objects_base_object_get_name (ObjectsBaseObject* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 24 "../core/Objects/BaseObject.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 24 "../core/Objects/BaseObject.vala"
	_tmp0_ = self->priv->_name;
#line 24 "../core/Objects/BaseObject.vala"
	result = _tmp0_;
#line 24 "../core/Objects/BaseObject.vala"
	return result;
#line 512 "BaseObject.c"
}

void
objects_base_object_set_name (ObjectsBaseObject* self,
                              const gchar* value)
{
	gchar* old_value;
#line 24 "../core/Objects/BaseObject.vala"
	g_return_if_fail (self != NULL);
#line 24 "../core/Objects/BaseObject.vala"
	old_value = objects_base_object_get_name (self);
#line 24 "../core/Objects/BaseObject.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 526 "BaseObject.c"
		gchar* _tmp0_;
#line 24 "../core/Objects/BaseObject.vala"
		_tmp0_ = g_strdup (value);
#line 24 "../core/Objects/BaseObject.vala"
		_g_free0 (self->priv->_name);
#line 24 "../core/Objects/BaseObject.vala"
		self->priv->_name = _tmp0_;
#line 24 "../core/Objects/BaseObject.vala"
		g_object_notify_by_pspec ((GObject *) self, objects_base_object_properties[OBJECTS_BASE_OBJECT_NAME_PROPERTY]);
#line 536 "BaseObject.c"
	}
}

const gchar*
objects_base_object_get_keywords (ObjectsBaseObject* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 25 "../core/Objects/BaseObject.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 25 "../core/Objects/BaseObject.vala"
	_tmp0_ = self->priv->_keywords;
#line 25 "../core/Objects/BaseObject.vala"
	result = _tmp0_;
#line 25 "../core/Objects/BaseObject.vala"
	return result;
#line 553 "BaseObject.c"
}

void
objects_base_object_set_keywords (ObjectsBaseObject* self,
                                  const gchar* value)
{
	gchar* old_value;
#line 25 "../core/Objects/BaseObject.vala"
	g_return_if_fail (self != NULL);
#line 25 "../core/Objects/BaseObject.vala"
	old_value = objects_base_object_get_keywords (self);
#line 25 "../core/Objects/BaseObject.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 567 "BaseObject.c"
		gchar* _tmp0_;
#line 25 "../core/Objects/BaseObject.vala"
		_tmp0_ = g_strdup (value);
#line 25 "../core/Objects/BaseObject.vala"
		_g_free0 (self->priv->_keywords);
#line 25 "../core/Objects/BaseObject.vala"
		self->priv->_keywords = _tmp0_;
#line 25 "../core/Objects/BaseObject.vala"
		g_object_notify_by_pspec ((GObject *) self, objects_base_object_properties[OBJECTS_BASE_OBJECT_KEYWORDS_PROPERTY]);
#line 577 "BaseObject.c"
	}
}

const gchar*
objects_base_object_get_icon_name (ObjectsBaseObject* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 26 "../core/Objects/BaseObject.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 26 "../core/Objects/BaseObject.vala"
	_tmp0_ = self->priv->_icon_name;
#line 26 "../core/Objects/BaseObject.vala"
	result = _tmp0_;
#line 26 "../core/Objects/BaseObject.vala"
	return result;
#line 594 "BaseObject.c"
}

void
objects_base_object_set_icon_name (ObjectsBaseObject* self,
                                   const gchar* value)
{
	gchar* old_value;
#line 26 "../core/Objects/BaseObject.vala"
	g_return_if_fail (self != NULL);
#line 26 "../core/Objects/BaseObject.vala"
	old_value = objects_base_object_get_icon_name (self);
#line 26 "../core/Objects/BaseObject.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 608 "BaseObject.c"
		gchar* _tmp0_;
#line 26 "../core/Objects/BaseObject.vala"
		_tmp0_ = g_strdup (value);
#line 26 "../core/Objects/BaseObject.vala"
		_g_free0 (self->priv->_icon_name);
#line 26 "../core/Objects/BaseObject.vala"
		self->priv->_icon_name = _tmp0_;
#line 26 "../core/Objects/BaseObject.vala"
		g_object_notify_by_pspec ((GObject *) self, objects_base_object_properties[OBJECTS_BASE_OBJECT_ICON_NAME_PROPERTY]);
#line 618 "BaseObject.c"
	}
}

guint
objects_base_object_get_update_timeout_id (ObjectsBaseObject* self)
{
	guint result;
#line 33 "../core/Objects/BaseObject.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 33 "../core/Objects/BaseObject.vala"
	result = self->priv->_update_timeout_id;
#line 33 "../core/Objects/BaseObject.vala"
	return result;
#line 632 "BaseObject.c"
}

void
objects_base_object_set_update_timeout_id (ObjectsBaseObject* self,
                                           guint value)
{
	guint old_value;
#line 33 "../core/Objects/BaseObject.vala"
	g_return_if_fail (self != NULL);
#line 33 "../core/Objects/BaseObject.vala"
	old_value = objects_base_object_get_update_timeout_id (self);
#line 33 "../core/Objects/BaseObject.vala"
	if (old_value != value) {
#line 33 "../core/Objects/BaseObject.vala"
		self->priv->_update_timeout_id = value;
#line 33 "../core/Objects/BaseObject.vala"
		g_object_notify_by_pspec ((GObject *) self, objects_base_object_properties[OBJECTS_BASE_OBJECT_UPDATE_TIMEOUT_ID_PROPERTY]);
#line 650 "BaseObject.c"
	}
}

static const gchar*
string_to_string (const gchar* self)
{
	const gchar* result;
#line 1624 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1625 "glib-2.0.vapi"
	result = self;
#line 1625 "glib-2.0.vapi"
	return result;
#line 664 "BaseObject.c"
}

const gchar*
objects_base_object_get_id_string (ObjectsBaseObject* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	const gchar* _tmp3_;
#line 42 "../core/Objects/BaseObject.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 43 "../core/Objects/BaseObject.vala"
	_tmp0_ = self->priv->_id;
#line 43 "../core/Objects/BaseObject.vala"
	_tmp1_ = string_to_string (_tmp0_);
#line 43 "../core/Objects/BaseObject.vala"
	_tmp2_ = g_strdup (_tmp1_);
#line 43 "../core/Objects/BaseObject.vala"
	_g_free0 (self->priv->_id_string);
#line 43 "../core/Objects/BaseObject.vala"
	self->priv->_id_string = _tmp2_;
#line 44 "../core/Objects/BaseObject.vala"
	_tmp3_ = self->priv->_id_string;
#line 44 "../core/Objects/BaseObject.vala"
	result = _tmp3_;
#line 44 "../core/Objects/BaseObject.vala"
	return result;
#line 693 "BaseObject.c"
}

gboolean
objects_base_object_get_loading (ObjectsBaseObject* self)
{
	gboolean result;
#line 55 "../core/Objects/BaseObject.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 56 "../core/Objects/BaseObject.vala"
	result = self->priv->_loading;
#line 56 "../core/Objects/BaseObject.vala"
	return result;
#line 706 "BaseObject.c"
}

void
objects_base_object_set_loading (ObjectsBaseObject* self,
                                 gboolean value)
{
#line 50 "../core/Objects/BaseObject.vala"
	g_return_if_fail (self != NULL);
#line 51 "../core/Objects/BaseObject.vala"
	self->priv->_loading = value;
#line 52 "../core/Objects/BaseObject.vala"
	g_signal_emit (self, objects_base_object_signals[OBJECTS_BASE_OBJECT_LOADING_CHANGE_SIGNAL], 0);
#line 50 "../core/Objects/BaseObject.vala"
	g_object_notify_by_pspec ((GObject *) self, objects_base_object_properties[OBJECTS_BASE_OBJECT_LOADING_PROPERTY]);
#line 721 "BaseObject.c"
}

gboolean
objects_base_object_get_sensitive (ObjectsBaseObject* self)
{
	gboolean result;
#line 67 "../core/Objects/BaseObject.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 68 "../core/Objects/BaseObject.vala"
	result = self->priv->_sensitive;
#line 68 "../core/Objects/BaseObject.vala"
	return result;
#line 734 "BaseObject.c"
}

void
objects_base_object_set_sensitive (ObjectsBaseObject* self,
                                   gboolean value)
{
#line 62 "../core/Objects/BaseObject.vala"
	g_return_if_fail (self != NULL);
#line 63 "../core/Objects/BaseObject.vala"
	self->priv->_sensitive = value;
#line 64 "../core/Objects/BaseObject.vala"
	g_signal_emit (self, objects_base_object_signals[OBJECTS_BASE_OBJECT_SENSITIVE_CHANGE_SIGNAL], 0);
#line 62 "../core/Objects/BaseObject.vala"
	g_object_notify_by_pspec ((GObject *) self, objects_base_object_properties[OBJECTS_BASE_OBJECT_SENSITIVE_PROPERTY]);
#line 749 "BaseObject.c"
}

const gchar*
objects_base_object_get_view_id (ObjectsBaseObject* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 75 "../core/Objects/BaseObject.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 75 "../core/Objects/BaseObject.vala"
	_tmp0_ = self->priv->_view_id;
#line 75 "../core/Objects/BaseObject.vala"
	result = _tmp0_;
#line 75 "../core/Objects/BaseObject.vala"
	return result;
#line 765 "BaseObject.c"
}

void
objects_base_object_set_view_id (ObjectsBaseObject* self,
                                 const gchar* value)
{
	gchar* old_value;
#line 75 "../core/Objects/BaseObject.vala"
	g_return_if_fail (self != NULL);
#line 75 "../core/Objects/BaseObject.vala"
	old_value = objects_base_object_get_view_id (self);
#line 75 "../core/Objects/BaseObject.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 779 "BaseObject.c"
		gchar* _tmp0_;
#line 75 "../core/Objects/BaseObject.vala"
		_tmp0_ = g_strdup (value);
#line 75 "../core/Objects/BaseObject.vala"
		_g_free0 (self->priv->_view_id);
#line 75 "../core/Objects/BaseObject.vala"
		self->priv->_view_id = _tmp0_;
#line 75 "../core/Objects/BaseObject.vala"
		g_object_notify_by_pspec ((GObject *) self, objects_base_object_properties[OBJECTS_BASE_OBJECT_VIEW_ID_PROPERTY]);
#line 789 "BaseObject.c"
	}
}

const gchar*
objects_base_object_get_type_delete (ObjectsBaseObject* self)
{
	const gchar* result;
#line 78 "../core/Objects/BaseObject.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 79 "../core/Objects/BaseObject.vala"
	if (OBJECTS_IS_ITEM (self)) {
#line 80 "../core/Objects/BaseObject.vala"
		result = "item_delete";
#line 80 "../core/Objects/BaseObject.vala"
		return result;
#line 805 "BaseObject.c"
	} else {
#line 81 "../core/Objects/BaseObject.vala"
		if (OBJECTS_IS_PROJECT (self)) {
#line 82 "../core/Objects/BaseObject.vala"
			result = "project_delete";
#line 82 "../core/Objects/BaseObject.vala"
			return result;
#line 813 "BaseObject.c"
		} else {
#line 83 "../core/Objects/BaseObject.vala"
			if (OBJECTS_IS_SECTION (self)) {
#line 84 "../core/Objects/BaseObject.vala"
				result = "section_delete";
#line 84 "../core/Objects/BaseObject.vala"
				return result;
#line 821 "BaseObject.c"
			} else {
#line 85 "../core/Objects/BaseObject.vala"
				if (OBJECTS_IS_LABEL (self)) {
#line 86 "../core/Objects/BaseObject.vala"
					result = "label_delete";
#line 86 "../core/Objects/BaseObject.vala"
					return result;
#line 829 "BaseObject.c"
				} else {
#line 87 "../core/Objects/BaseObject.vala"
					if (OBJECTS_IS_REMINDER (self)) {
#line 88 "../core/Objects/BaseObject.vala"
						result = "reminder_delete";
#line 88 "../core/Objects/BaseObject.vala"
						return result;
#line 837 "BaseObject.c"
					} else {
#line 90 "../core/Objects/BaseObject.vala"
						result = "";
#line 90 "../core/Objects/BaseObject.vala"
						return result;
#line 843 "BaseObject.c"
					}
				}
			}
		}
	}
}

const gchar*
objects_base_object_get_type_add (ObjectsBaseObject* self)
{
	const gchar* result;
#line 96 "../core/Objects/BaseObject.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 97 "../core/Objects/BaseObject.vala"
	if (OBJECTS_IS_ITEM (self)) {
#line 98 "../core/Objects/BaseObject.vala"
		result = "item_add";
#line 98 "../core/Objects/BaseObject.vala"
		return result;
#line 863 "BaseObject.c"
	} else {
#line 99 "../core/Objects/BaseObject.vala"
		if (OBJECTS_IS_PROJECT (self)) {
#line 100 "../core/Objects/BaseObject.vala"
			result = "project_add";
#line 100 "../core/Objects/BaseObject.vala"
			return result;
#line 871 "BaseObject.c"
		} else {
#line 101 "../core/Objects/BaseObject.vala"
			if (OBJECTS_IS_SECTION (self)) {
#line 102 "../core/Objects/BaseObject.vala"
				result = "section_add";
#line 102 "../core/Objects/BaseObject.vala"
				return result;
#line 879 "BaseObject.c"
			} else {
#line 103 "../core/Objects/BaseObject.vala"
				if (OBJECTS_IS_LABEL (self)) {
#line 104 "../core/Objects/BaseObject.vala"
					result = "label_add";
#line 104 "../core/Objects/BaseObject.vala"
					return result;
#line 887 "BaseObject.c"
				} else {
#line 106 "../core/Objects/BaseObject.vala"
					result = "";
#line 106 "../core/Objects/BaseObject.vala"
					return result;
#line 893 "BaseObject.c"
				}
			}
		}
	}
}

const gchar*
objects_base_object_get_type_update (ObjectsBaseObject* self)
{
	const gchar* result;
#line 112 "../core/Objects/BaseObject.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 113 "../core/Objects/BaseObject.vala"
	if (OBJECTS_IS_ITEM (self)) {
#line 114 "../core/Objects/BaseObject.vala"
		result = "item_update";
#line 114 "../core/Objects/BaseObject.vala"
		return result;
#line 912 "BaseObject.c"
	} else {
#line 115 "../core/Objects/BaseObject.vala"
		if (OBJECTS_IS_PROJECT (self)) {
#line 116 "../core/Objects/BaseObject.vala"
			result = "project_update";
#line 116 "../core/Objects/BaseObject.vala"
			return result;
#line 920 "BaseObject.c"
		} else {
#line 117 "../core/Objects/BaseObject.vala"
			if (OBJECTS_IS_SECTION (self)) {
#line 118 "../core/Objects/BaseObject.vala"
				result = "section_update";
#line 118 "../core/Objects/BaseObject.vala"
				return result;
#line 928 "BaseObject.c"
			} else {
#line 119 "../core/Objects/BaseObject.vala"
				if (OBJECTS_IS_LABEL (self)) {
#line 120 "../core/Objects/BaseObject.vala"
					result = "label_update";
#line 120 "../core/Objects/BaseObject.vala"
					return result;
#line 936 "BaseObject.c"
				} else {
#line 122 "../core/Objects/BaseObject.vala"
					result = "";
#line 122 "../core/Objects/BaseObject.vala"
					return result;
#line 942 "BaseObject.c"
				}
			}
		}
	}
}

ObjectType
objects_base_object_get_object_type (ObjectsBaseObject* self)
{
	ObjectType result;
#line 128 "../core/Objects/BaseObject.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 129 "../core/Objects/BaseObject.vala"
	if (OBJECTS_IS_PROJECT (self)) {
#line 130 "../core/Objects/BaseObject.vala"
		result = OBJECT_TYPE_PROJECT;
#line 130 "../core/Objects/BaseObject.vala"
		return result;
#line 961 "BaseObject.c"
	} else {
#line 131 "../core/Objects/BaseObject.vala"
		if (OBJECTS_IS_SECTION (self)) {
#line 132 "../core/Objects/BaseObject.vala"
			result = OBJECT_TYPE_SECTION;
#line 132 "../core/Objects/BaseObject.vala"
			return result;
#line 969 "BaseObject.c"
		} else {
#line 133 "../core/Objects/BaseObject.vala"
			if (OBJECTS_IS_ITEM (self)) {
#line 134 "../core/Objects/BaseObject.vala"
				result = OBJECT_TYPE_ITEM;
#line 134 "../core/Objects/BaseObject.vala"
				return result;
#line 977 "BaseObject.c"
			} else {
#line 135 "../core/Objects/BaseObject.vala"
				if (OBJECTS_IS_LABEL (self)) {
#line 136 "../core/Objects/BaseObject.vala"
					result = OBJECT_TYPE_LABEL;
#line 136 "../core/Objects/BaseObject.vala"
					return result;
#line 985 "BaseObject.c"
				} else {
#line 138 "../core/Objects/BaseObject.vala"
					result = OBJECT_TYPE_FILTER;
#line 138 "../core/Objects/BaseObject.vala"
					return result;
#line 991 "BaseObject.c"
				}
			}
		}
	}
}

const gchar*
objects_base_object_get_object_type_string (ObjectsBaseObject* self)
{
	const gchar* result;
#line 144 "../core/Objects/BaseObject.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 145 "../core/Objects/BaseObject.vala"
	if (OBJECTS_IS_PROJECT (self)) {
#line 146 "../core/Objects/BaseObject.vala"
		result = "project";
#line 146 "../core/Objects/BaseObject.vala"
		return result;
#line 1010 "BaseObject.c"
	} else {
#line 147 "../core/Objects/BaseObject.vala"
		if (OBJECTS_IS_SECTION (self)) {
#line 148 "../core/Objects/BaseObject.vala"
			result = "section";
#line 148 "../core/Objects/BaseObject.vala"
			return result;
#line 1018 "BaseObject.c"
		} else {
#line 149 "../core/Objects/BaseObject.vala"
			if (OBJECTS_IS_ITEM (self)) {
#line 150 "../core/Objects/BaseObject.vala"
				result = "item";
#line 150 "../core/Objects/BaseObject.vala"
				return result;
#line 1026 "BaseObject.c"
			} else {
#line 151 "../core/Objects/BaseObject.vala"
				if (OBJECTS_IS_LABEL (self)) {
#line 152 "../core/Objects/BaseObject.vala"
					result = "label";
#line 152 "../core/Objects/BaseObject.vala"
					return result;
#line 1034 "BaseObject.c"
				} else {
#line 154 "../core/Objects/BaseObject.vala"
					result = "filter";
#line 154 "../core/Objects/BaseObject.vala"
					return result;
#line 1040 "BaseObject.c"
				}
			}
		}
	}
}

const gchar*
objects_base_object_get_table_name (ObjectsBaseObject* self)
{
	const gchar* result;
#line 160 "../core/Objects/BaseObject.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 161 "../core/Objects/BaseObject.vala"
	if (OBJECTS_IS_ITEM (self)) {
#line 162 "../core/Objects/BaseObject.vala"
		result = "Items";
#line 162 "../core/Objects/BaseObject.vala"
		return result;
#line 1059 "BaseObject.c"
	} else {
#line 163 "../core/Objects/BaseObject.vala"
		if (OBJECTS_IS_SECTION (self)) {
#line 164 "../core/Objects/BaseObject.vala"
			result = "Sections";
#line 164 "../core/Objects/BaseObject.vala"
			return result;
#line 1067 "BaseObject.c"
		} else {
#line 165 "../core/Objects/BaseObject.vala"
			if (OBJECTS_IS_PROJECT (self)) {
#line 166 "../core/Objects/BaseObject.vala"
				result = "Projects";
#line 166 "../core/Objects/BaseObject.vala"
				return result;
#line 1075 "BaseObject.c"
			} else {
#line 167 "../core/Objects/BaseObject.vala"
				if (OBJECTS_IS_LABEL (self)) {
#line 168 "../core/Objects/BaseObject.vala"
					result = "Labels";
#line 168 "../core/Objects/BaseObject.vala"
					return result;
#line 1083 "BaseObject.c"
				} else {
#line 170 "../core/Objects/BaseObject.vala"
					result = "";
#line 170 "../core/Objects/BaseObject.vala"
					return result;
#line 1089 "BaseObject.c"
				}
			}
		}
	}
}

const gchar*
objects_base_object_get_column_order_name (ObjectsBaseObject* self)
{
	const gchar* result;
#line 176 "../core/Objects/BaseObject.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 177 "../core/Objects/BaseObject.vala"
	if (OBJECTS_IS_ITEM (self)) {
#line 178 "../core/Objects/BaseObject.vala"
		result = "child_order";
#line 178 "../core/Objects/BaseObject.vala"
		return result;
#line 1108 "BaseObject.c"
	}
#line 181 "../core/Objects/BaseObject.vala"
	if (OBJECTS_IS_SECTION (self)) {
#line 182 "../core/Objects/BaseObject.vala"
		result = "section_order";
#line 182 "../core/Objects/BaseObject.vala"
		return result;
#line 1116 "BaseObject.c"
	}
#line 185 "../core/Objects/BaseObject.vala"
	if (OBJECTS_IS_PROJECT (self)) {
#line 186 "../core/Objects/BaseObject.vala"
		result = "child_order";
#line 186 "../core/Objects/BaseObject.vala"
		return result;
#line 1124 "BaseObject.c"
	}
#line 189 "../core/Objects/BaseObject.vala"
	if (OBJECTS_IS_LABEL (self)) {
#line 190 "../core/Objects/BaseObject.vala"
		result = "item_order";
#line 190 "../core/Objects/BaseObject.vala"
		return result;
#line 1132 "BaseObject.c"
	}
#line 193 "../core/Objects/BaseObject.vala"
	result = "";
#line 193 "../core/Objects/BaseObject.vala"
	return result;
#line 1138 "BaseObject.c"
}

ObjectsSource*
objects_base_object_get_source (ObjectsBaseObject* self)
{
	ObjectsSource* result;
	ObjectsSource* _tmp18_;
#line 199 "../core/Objects/BaseObject.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 200 "../core/Objects/BaseObject.vala"
	if (OBJECTS_IS_PROJECT (self)) {
#line 1150 "BaseObject.c"
		ObjectsSource* _tmp0_;
		ObjectsSource* _tmp1_;
#line 201 "../core/Objects/BaseObject.vala"
		_tmp0_ = objects_project_get_source (G_TYPE_CHECK_INSTANCE_CAST (self, OBJECTS_TYPE_PROJECT, ObjectsProject));
#line 201 "../core/Objects/BaseObject.vala"
		_tmp1_ = _tmp0_;
#line 201 "../core/Objects/BaseObject.vala"
		result = _tmp1_;
#line 201 "../core/Objects/BaseObject.vala"
		return result;
#line 1161 "BaseObject.c"
	}
#line 204 "../core/Objects/BaseObject.vala"
	if (OBJECTS_IS_SECTION (self)) {
#line 1165 "BaseObject.c"
		ObjectsProject* _tmp2_;
		ObjectsProject* _tmp3_;
		ObjectsSource* _tmp4_;
		ObjectsSource* _tmp5_;
#line 205 "../core/Objects/BaseObject.vala"
		_tmp2_ = objects_section_get_project (G_TYPE_CHECK_INSTANCE_CAST (self, OBJECTS_TYPE_SECTION, ObjectsSection));
#line 205 "../core/Objects/BaseObject.vala"
		_tmp3_ = _tmp2_;
#line 205 "../core/Objects/BaseObject.vala"
		_tmp4_ = objects_project_get_source (_tmp3_);
#line 205 "../core/Objects/BaseObject.vala"
		_tmp5_ = _tmp4_;
#line 205 "../core/Objects/BaseObject.vala"
		result = _tmp5_;
#line 205 "../core/Objects/BaseObject.vala"
		return result;
#line 1182 "BaseObject.c"
	}
#line 208 "../core/Objects/BaseObject.vala"
	if (OBJECTS_IS_ITEM (self)) {
#line 1186 "BaseObject.c"
		ObjectsProject* _tmp6_;
		ObjectsProject* _tmp7_;
		ObjectsSource* _tmp8_;
		ObjectsSource* _tmp9_;
#line 209 "../core/Objects/BaseObject.vala"
		_tmp6_ = objects_item_get_project (G_TYPE_CHECK_INSTANCE_CAST (self, OBJECTS_TYPE_ITEM, ObjectsItem));
#line 209 "../core/Objects/BaseObject.vala"
		_tmp7_ = _tmp6_;
#line 209 "../core/Objects/BaseObject.vala"
		_tmp8_ = objects_project_get_source (_tmp7_);
#line 209 "../core/Objects/BaseObject.vala"
		_tmp9_ = _tmp8_;
#line 209 "../core/Objects/BaseObject.vala"
		result = _tmp9_;
#line 209 "../core/Objects/BaseObject.vala"
		return result;
#line 1203 "BaseObject.c"
	}
#line 212 "../core/Objects/BaseObject.vala"
	if (OBJECTS_IS_LABEL (self)) {
#line 1207 "BaseObject.c"
		ObjectsSource* _tmp10_;
		ObjectsSource* _tmp11_;
#line 213 "../core/Objects/BaseObject.vala"
		_tmp10_ = objects_label_get_source (G_TYPE_CHECK_INSTANCE_CAST (self, OBJECTS_TYPE_LABEL, ObjectsLabel));
#line 213 "../core/Objects/BaseObject.vala"
		_tmp11_ = _tmp10_;
#line 213 "../core/Objects/BaseObject.vala"
		result = _tmp11_;
#line 213 "../core/Objects/BaseObject.vala"
		return result;
#line 1218 "BaseObject.c"
	}
#line 216 "../core/Objects/BaseObject.vala"
	if (OBJECTS_IS_REMINDER (self)) {
#line 1222 "BaseObject.c"
		ObjectsItem* _tmp12_;
		ObjectsItem* _tmp13_;
		ObjectsProject* _tmp14_;
		ObjectsProject* _tmp15_;
		ObjectsSource* _tmp16_;
		ObjectsSource* _tmp17_;
#line 217 "../core/Objects/BaseObject.vala"
		_tmp12_ = objects_reminder_get_item (G_TYPE_CHECK_INSTANCE_CAST (self, OBJECTS_TYPE_REMINDER, ObjectsReminder));
#line 217 "../core/Objects/BaseObject.vala"
		_tmp13_ = _tmp12_;
#line 217 "../core/Objects/BaseObject.vala"
		_tmp14_ = objects_item_get_project (_tmp13_);
#line 217 "../core/Objects/BaseObject.vala"
		_tmp15_ = _tmp14_;
#line 217 "../core/Objects/BaseObject.vala"
		_tmp16_ = objects_project_get_source (_tmp15_);
#line 217 "../core/Objects/BaseObject.vala"
		_tmp17_ = _tmp16_;
#line 217 "../core/Objects/BaseObject.vala"
		result = _tmp17_;
#line 217 "../core/Objects/BaseObject.vala"
		return result;
#line 1245 "BaseObject.c"
	}
#line 220 "../core/Objects/BaseObject.vala"
	_tmp18_ = self->priv->_source;
#line 220 "../core/Objects/BaseObject.vala"
	result = _tmp18_;
#line 220 "../core/Objects/BaseObject.vala"
	return result;
#line 1253 "BaseObject.c"
}

static void
objects_base_object_class_init (ObjectsBaseObjectClass * klass,
                                gpointer klass_data)
{
#line 22 "../core/Objects/BaseObject.vala"
	objects_base_object_parent_class = g_type_class_peek_parent (klass);
#line 22 "../core/Objects/BaseObject.vala"
	g_type_class_adjust_private_offset (klass, &ObjectsBaseObject_private_offset);
#line 22 "../core/Objects/BaseObject.vala"
	((ObjectsBaseObjectClass *) klass)->get_update_json = (gchar* (*) (ObjectsBaseObject*, const gchar*, const gchar*)) objects_base_object_real_get_update_json;
#line 22 "../core/Objects/BaseObject.vala"
	((ObjectsBaseObjectClass *) klass)->get_add_json = (gchar* (*) (ObjectsBaseObject*, const gchar*, const gchar*)) objects_base_object_real_get_add_json;
#line 22 "../core/Objects/BaseObject.vala"
	((ObjectsBaseObjectClass *) klass)->get_move_json = (gchar* (*) (ObjectsBaseObject*, const gchar*, const gchar*)) objects_base_object_real_get_move_json;
#line 22 "../core/Objects/BaseObject.vala"
	((ObjectsBaseObjectClass *) klass)->to_json = (gchar* (*) (ObjectsBaseObject*)) objects_base_object_real_to_json;
#line 22 "../core/Objects/BaseObject.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_objects_base_object_get_property;
#line 22 "../core/Objects/BaseObject.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_objects_base_object_set_property;
#line 22 "../core/Objects/BaseObject.vala"
	G_OBJECT_CLASS (klass)->finalize = objects_base_object_finalize;
#line 22 "../core/Objects/BaseObject.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), OBJECTS_BASE_OBJECT_ID_PROPERTY, objects_base_object_properties[OBJECTS_BASE_OBJECT_ID_PROPERTY] = g_param_spec_string ("id", "id", "id", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 22 "../core/Objects/BaseObject.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), OBJECTS_BASE_OBJECT_NAME_PROPERTY, objects_base_object_properties[OBJECTS_BASE_OBJECT_NAME_PROPERTY] = g_param_spec_string ("name", "name", "name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 22 "../core/Objects/BaseObject.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), OBJECTS_BASE_OBJECT_KEYWORDS_PROPERTY, objects_base_object_properties[OBJECTS_BASE_OBJECT_KEYWORDS_PROPERTY] = g_param_spec_string ("keywords", "keywords", "keywords", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 22 "../core/Objects/BaseObject.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), OBJECTS_BASE_OBJECT_ICON_NAME_PROPERTY, objects_base_object_properties[OBJECTS_BASE_OBJECT_ICON_NAME_PROPERTY] = g_param_spec_string ("icon-name", "icon-name", "icon-name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 22 "../core/Objects/BaseObject.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), OBJECTS_BASE_OBJECT_UPDATE_TIMEOUT_ID_PROPERTY, objects_base_object_properties[OBJECTS_BASE_OBJECT_UPDATE_TIMEOUT_ID_PROPERTY] = g_param_spec_uint ("update-timeout-id", "update-timeout-id", "update-timeout-id", 0, G_MAXUINT, (guint) 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 22 "../core/Objects/BaseObject.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), OBJECTS_BASE_OBJECT_ID_STRING_PROPERTY, objects_base_object_properties[OBJECTS_BASE_OBJECT_ID_STRING_PROPERTY] = g_param_spec_string ("id-string", "id-string", "id-string", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 22 "../core/Objects/BaseObject.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), OBJECTS_BASE_OBJECT_LOADING_PROPERTY, objects_base_object_properties[OBJECTS_BASE_OBJECT_LOADING_PROPERTY] = g_param_spec_boolean ("loading", "loading", "loading", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 22 "../core/Objects/BaseObject.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), OBJECTS_BASE_OBJECT_SENSITIVE_PROPERTY, objects_base_object_properties[OBJECTS_BASE_OBJECT_SENSITIVE_PROPERTY] = g_param_spec_boolean ("sensitive", "sensitive", "sensitive", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 22 "../core/Objects/BaseObject.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), OBJECTS_BASE_OBJECT_VIEW_ID_PROPERTY, objects_base_object_properties[OBJECTS_BASE_OBJECT_VIEW_ID_PROPERTY] = g_param_spec_string ("view-id", "view-id", "view-id", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 22 "../core/Objects/BaseObject.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), OBJECTS_BASE_OBJECT_TYPE_DELETE_PROPERTY, objects_base_object_properties[OBJECTS_BASE_OBJECT_TYPE_DELETE_PROPERTY] = g_param_spec_string ("type-delete", "type-delete", "type-delete", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 22 "../core/Objects/BaseObject.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), OBJECTS_BASE_OBJECT_TYPE_ADD_PROPERTY, objects_base_object_properties[OBJECTS_BASE_OBJECT_TYPE_ADD_PROPERTY] = g_param_spec_string ("type-add", "type-add", "type-add", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 22 "../core/Objects/BaseObject.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), OBJECTS_BASE_OBJECT_TYPE_UPDATE_PROPERTY, objects_base_object_properties[OBJECTS_BASE_OBJECT_TYPE_UPDATE_PROPERTY] = g_param_spec_string ("type-update", "type-update", "type-update", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 22 "../core/Objects/BaseObject.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), OBJECTS_BASE_OBJECT_OBJECT_TYPE_PROPERTY, objects_base_object_properties[OBJECTS_BASE_OBJECT_OBJECT_TYPE_PROPERTY] = g_param_spec_enum ("object-type", "object-type", "object-type", TYPE_OBJECT_TYPE, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 22 "../core/Objects/BaseObject.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), OBJECTS_BASE_OBJECT_OBJECT_TYPE_STRING_PROPERTY, objects_base_object_properties[OBJECTS_BASE_OBJECT_OBJECT_TYPE_STRING_PROPERTY] = g_param_spec_string ("object-type-string", "object-type-string", "object-type-string", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 22 "../core/Objects/BaseObject.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), OBJECTS_BASE_OBJECT_TABLE_NAME_PROPERTY, objects_base_object_properties[OBJECTS_BASE_OBJECT_TABLE_NAME_PROPERTY] = g_param_spec_string ("table-name", "table-name", "table-name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 22 "../core/Objects/BaseObject.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), OBJECTS_BASE_OBJECT_COLUMN_ORDER_NAME_PROPERTY, objects_base_object_properties[OBJECTS_BASE_OBJECT_COLUMN_ORDER_NAME_PROPERTY] = g_param_spec_string ("column-order-name", "column-order-name", "column-order-name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 22 "../core/Objects/BaseObject.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), OBJECTS_BASE_OBJECT_SOURCE_PROPERTY, objects_base_object_properties[OBJECTS_BASE_OBJECT_SOURCE_PROPERTY] = g_param_spec_object ("source", "source", "source", OBJECTS_TYPE_SOURCE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 22 "../core/Objects/BaseObject.vala"
	objects_base_object_signals[OBJECTS_BASE_OBJECT_DELETED_SIGNAL] = g_signal_new ("deleted", OBJECTS_TYPE_BASE_OBJECT, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 22 "../core/Objects/BaseObject.vala"
	objects_base_object_signals[OBJECTS_BASE_OBJECT_UPDATED_SIGNAL] = g_signal_new ("updated", OBJECTS_TYPE_BASE_OBJECT, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__STRING, G_TYPE_NONE, 1, G_TYPE_STRING);
#line 22 "../core/Objects/BaseObject.vala"
	objects_base_object_signals[OBJECTS_BASE_OBJECT_ARCHIVED_SIGNAL] = g_signal_new ("archived", OBJECTS_TYPE_BASE_OBJECT, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 22 "../core/Objects/BaseObject.vala"
	objects_base_object_signals[OBJECTS_BASE_OBJECT_UNARCHIVED_SIGNAL] = g_signal_new ("unarchived", OBJECTS_TYPE_BASE_OBJECT, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 22 "../core/Objects/BaseObject.vala"
	objects_base_object_signals[OBJECTS_BASE_OBJECT_FILTER_ADDED_SIGNAL] = g_signal_new ("filter-added", OBJECTS_TYPE_BASE_OBJECT, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, OBJECTS_FILTERS_TYPE_FILTER_ITEM);
#line 22 "../core/Objects/BaseObject.vala"
	objects_base_object_signals[OBJECTS_BASE_OBJECT_FILTER_REMOVED_SIGNAL] = g_signal_new ("filter-removed", OBJECTS_TYPE_BASE_OBJECT, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, OBJECTS_FILTERS_TYPE_FILTER_ITEM);
#line 22 "../core/Objects/BaseObject.vala"
	objects_base_object_signals[OBJECTS_BASE_OBJECT_FILTER_UPDATED_SIGNAL] = g_signal_new ("filter-updated", OBJECTS_TYPE_BASE_OBJECT, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, OBJECTS_FILTERS_TYPE_FILTER_ITEM);
#line 22 "../core/Objects/BaseObject.vala"
	objects_base_object_signals[OBJECTS_BASE_OBJECT_LOADING_CHANGE_SIGNAL] = g_signal_new ("loading-change", OBJECTS_TYPE_BASE_OBJECT, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 22 "../core/Objects/BaseObject.vala"
	objects_base_object_signals[OBJECTS_BASE_OBJECT_SENSITIVE_CHANGE_SIGNAL] = g_signal_new ("sensitive-change", OBJECTS_TYPE_BASE_OBJECT, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 1330 "BaseObject.c"
}

static void
objects_base_object_instance_init (ObjectsBaseObject * self,
                                   gpointer klass)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	GeeHashMap* _tmp4_;
	gchar* _tmp5_;
#line 22 "../core/Objects/BaseObject.vala"
	self->priv = objects_base_object_get_instance_private (self);
#line 23 "../core/Objects/BaseObject.vala"
	_tmp0_ = g_strdup ("");
#line 23 "../core/Objects/BaseObject.vala"
	self->priv->_id = _tmp0_;
#line 24 "../core/Objects/BaseObject.vala"
	_tmp1_ = g_strdup ("");
#line 24 "../core/Objects/BaseObject.vala"
	self->priv->_name = _tmp1_;
#line 25 "../core/Objects/BaseObject.vala"
	_tmp2_ = g_strdup ("");
#line 25 "../core/Objects/BaseObject.vala"
	self->priv->_keywords = _tmp2_;
#line 26 "../core/Objects/BaseObject.vala"
	_tmp3_ = g_strdup ("");
#line 26 "../core/Objects/BaseObject.vala"
	self->priv->_icon_name = _tmp3_;
#line 33 "../core/Objects/BaseObject.vala"
	self->priv->_update_timeout_id = (guint) 0;
#line 35 "../core/Objects/BaseObject.vala"
	_tmp4_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, OBJECTS_FILTERS_TYPE_FILTER_ITEM, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 35 "../core/Objects/BaseObject.vala"
	self->filters = _tmp4_;
#line 48 "../core/Objects/BaseObject.vala"
	self->priv->_loading = FALSE;
#line 60 "../core/Objects/BaseObject.vala"
	self->priv->_sensitive = TRUE;
#line 75 "../core/Objects/BaseObject.vala"
	_tmp5_ = g_strdup ("");
#line 75 "../core/Objects/BaseObject.vala"
	self->priv->_view_id = _tmp5_;
#line 1375 "BaseObject.c"
}

static void
objects_base_object_finalize (GObject * obj)
{
	ObjectsBaseObject * self;
#line 22 "../core/Objects/BaseObject.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, OBJECTS_TYPE_BASE_OBJECT, ObjectsBaseObject);
#line 23 "../core/Objects/BaseObject.vala"
	_g_free0 (self->priv->_id);
#line 24 "../core/Objects/BaseObject.vala"
	_g_free0 (self->priv->_name);
#line 25 "../core/Objects/BaseObject.vala"
	_g_free0 (self->priv->_keywords);
#line 26 "../core/Objects/BaseObject.vala"
	_g_free0 (self->priv->_icon_name);
#line 35 "../core/Objects/BaseObject.vala"
	_g_object_unref0 (self->filters);
#line 40 "../core/Objects/BaseObject.vala"
	_g_free0 (self->priv->_id_string);
#line 75 "../core/Objects/BaseObject.vala"
	_g_free0 (self->priv->_view_id);
#line 197 "../core/Objects/BaseObject.vala"
	_g_object_unref0 (self->priv->_source);
#line 22 "../core/Objects/BaseObject.vala"
	G_OBJECT_CLASS (objects_base_object_parent_class)->finalize (obj);
#line 1402 "BaseObject.c"
}

static GType
objects_base_object_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ObjectsBaseObjectClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) objects_base_object_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ObjectsBaseObject), 0, (GInstanceInitFunc) objects_base_object_instance_init, NULL };
	GType objects_base_object_type_id;
	objects_base_object_type_id = g_type_register_static (G_TYPE_OBJECT, "ObjectsBaseObject", &g_define_type_info, 0);
	ObjectsBaseObject_private_offset = g_type_add_instance_private (objects_base_object_type_id, sizeof (ObjectsBaseObjectPrivate));
	return objects_base_object_type_id;
}

GType
objects_base_object_get_type (void)
{
	static volatile gsize objects_base_object_type_id__once = 0;
	if (g_once_init_enter (&objects_base_object_type_id__once)) {
		GType objects_base_object_type_id;
		objects_base_object_type_id = objects_base_object_get_type_once ();
		g_once_init_leave (&objects_base_object_type_id__once, objects_base_object_type_id);
	}
	return objects_base_object_type_id__once;
}

static void
_vala_objects_base_object_get_property (GObject * object,
                                        guint property_id,
                                        GValue * value,
                                        GParamSpec * pspec)
{
	ObjectsBaseObject * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, OBJECTS_TYPE_BASE_OBJECT, ObjectsBaseObject);
#line 22 "../core/Objects/BaseObject.vala"
	switch (property_id) {
#line 22 "../core/Objects/BaseObject.vala"
		case OBJECTS_BASE_OBJECT_ID_PROPERTY:
#line 22 "../core/Objects/BaseObject.vala"
		g_value_set_string (value, objects_base_object_get_id (self));
#line 22 "../core/Objects/BaseObject.vala"
		break;
#line 22 "../core/Objects/BaseObject.vala"
		case OBJECTS_BASE_OBJECT_NAME_PROPERTY:
#line 22 "../core/Objects/BaseObject.vala"
		g_value_set_string (value, objects_base_object_get_name (self));
#line 22 "../core/Objects/BaseObject.vala"
		break;
#line 22 "../core/Objects/BaseObject.vala"
		case OBJECTS_BASE_OBJECT_KEYWORDS_PROPERTY:
#line 22 "../core/Objects/BaseObject.vala"
		g_value_set_string (value, objects_base_object_get_keywords (self));
#line 22 "../core/Objects/BaseObject.vala"
		break;
#line 22 "../core/Objects/BaseObject.vala"
		case OBJECTS_BASE_OBJECT_ICON_NAME_PROPERTY:
#line 22 "../core/Objects/BaseObject.vala"
		g_value_set_string (value, objects_base_object_get_icon_name (self));
#line 22 "../core/Objects/BaseObject.vala"
		break;
#line 22 "../core/Objects/BaseObject.vala"
		case OBJECTS_BASE_OBJECT_UPDATE_TIMEOUT_ID_PROPERTY:
#line 22 "../core/Objects/BaseObject.vala"
		g_value_set_uint (value, objects_base_object_get_update_timeout_id (self));
#line 22 "../core/Objects/BaseObject.vala"
		break;
#line 22 "../core/Objects/BaseObject.vala"
		case OBJECTS_BASE_OBJECT_ID_STRING_PROPERTY:
#line 22 "../core/Objects/BaseObject.vala"
		g_value_set_string (value, objects_base_object_get_id_string (self));
#line 22 "../core/Objects/BaseObject.vala"
		break;
#line 22 "../core/Objects/BaseObject.vala"
		case OBJECTS_BASE_OBJECT_LOADING_PROPERTY:
#line 22 "../core/Objects/BaseObject.vala"
		g_value_set_boolean (value, objects_base_object_get_loading (self));
#line 22 "../core/Objects/BaseObject.vala"
		break;
#line 22 "../core/Objects/BaseObject.vala"
		case OBJECTS_BASE_OBJECT_SENSITIVE_PROPERTY:
#line 22 "../core/Objects/BaseObject.vala"
		g_value_set_boolean (value, objects_base_object_get_sensitive (self));
#line 22 "../core/Objects/BaseObject.vala"
		break;
#line 22 "../core/Objects/BaseObject.vala"
		case OBJECTS_BASE_OBJECT_VIEW_ID_PROPERTY:
#line 22 "../core/Objects/BaseObject.vala"
		g_value_set_string (value, objects_base_object_get_view_id (self));
#line 22 "../core/Objects/BaseObject.vala"
		break;
#line 22 "../core/Objects/BaseObject.vala"
		case OBJECTS_BASE_OBJECT_TYPE_DELETE_PROPERTY:
#line 22 "../core/Objects/BaseObject.vala"
		g_value_set_string (value, objects_base_object_get_type_delete (self));
#line 22 "../core/Objects/BaseObject.vala"
		break;
#line 22 "../core/Objects/BaseObject.vala"
		case OBJECTS_BASE_OBJECT_TYPE_ADD_PROPERTY:
#line 22 "../core/Objects/BaseObject.vala"
		g_value_set_string (value, objects_base_object_get_type_add (self));
#line 22 "../core/Objects/BaseObject.vala"
		break;
#line 22 "../core/Objects/BaseObject.vala"
		case OBJECTS_BASE_OBJECT_TYPE_UPDATE_PROPERTY:
#line 22 "../core/Objects/BaseObject.vala"
		g_value_set_string (value, objects_base_object_get_type_update (self));
#line 22 "../core/Objects/BaseObject.vala"
		break;
#line 22 "../core/Objects/BaseObject.vala"
		case OBJECTS_BASE_OBJECT_OBJECT_TYPE_PROPERTY:
#line 22 "../core/Objects/BaseObject.vala"
		g_value_set_enum (value, objects_base_object_get_object_type (self));
#line 22 "../core/Objects/BaseObject.vala"
		break;
#line 22 "../core/Objects/BaseObject.vala"
		case OBJECTS_BASE_OBJECT_OBJECT_TYPE_STRING_PROPERTY:
#line 22 "../core/Objects/BaseObject.vala"
		g_value_set_string (value, objects_base_object_get_object_type_string (self));
#line 22 "../core/Objects/BaseObject.vala"
		break;
#line 22 "../core/Objects/BaseObject.vala"
		case OBJECTS_BASE_OBJECT_TABLE_NAME_PROPERTY:
#line 22 "../core/Objects/BaseObject.vala"
		g_value_set_string (value, objects_base_object_get_table_name (self));
#line 22 "../core/Objects/BaseObject.vala"
		break;
#line 22 "../core/Objects/BaseObject.vala"
		case OBJECTS_BASE_OBJECT_COLUMN_ORDER_NAME_PROPERTY:
#line 22 "../core/Objects/BaseObject.vala"
		g_value_set_string (value, objects_base_object_get_column_order_name (self));
#line 22 "../core/Objects/BaseObject.vala"
		break;
#line 22 "../core/Objects/BaseObject.vala"
		case OBJECTS_BASE_OBJECT_SOURCE_PROPERTY:
#line 22 "../core/Objects/BaseObject.vala"
		g_value_set_object (value, objects_base_object_get_source (self));
#line 22 "../core/Objects/BaseObject.vala"
		break;
#line 1539 "BaseObject.c"
		default:
#line 22 "../core/Objects/BaseObject.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 22 "../core/Objects/BaseObject.vala"
		break;
#line 1545 "BaseObject.c"
	}
}

static void
_vala_objects_base_object_set_property (GObject * object,
                                        guint property_id,
                                        const GValue * value,
                                        GParamSpec * pspec)
{
	ObjectsBaseObject * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, OBJECTS_TYPE_BASE_OBJECT, ObjectsBaseObject);
#line 22 "../core/Objects/BaseObject.vala"
	switch (property_id) {
#line 22 "../core/Objects/BaseObject.vala"
		case OBJECTS_BASE_OBJECT_ID_PROPERTY:
#line 22 "../core/Objects/BaseObject.vala"
		objects_base_object_set_id (self, g_value_get_string (value));
#line 22 "../core/Objects/BaseObject.vala"
		break;
#line 22 "../core/Objects/BaseObject.vala"
		case OBJECTS_BASE_OBJECT_NAME_PROPERTY:
#line 22 "../core/Objects/BaseObject.vala"
		objects_base_object_set_name (self, g_value_get_string (value));
#line 22 "../core/Objects/BaseObject.vala"
		break;
#line 22 "../core/Objects/BaseObject.vala"
		case OBJECTS_BASE_OBJECT_KEYWORDS_PROPERTY:
#line 22 "../core/Objects/BaseObject.vala"
		objects_base_object_set_keywords (self, g_value_get_string (value));
#line 22 "../core/Objects/BaseObject.vala"
		break;
#line 22 "../core/Objects/BaseObject.vala"
		case OBJECTS_BASE_OBJECT_ICON_NAME_PROPERTY:
#line 22 "../core/Objects/BaseObject.vala"
		objects_base_object_set_icon_name (self, g_value_get_string (value));
#line 22 "../core/Objects/BaseObject.vala"
		break;
#line 22 "../core/Objects/BaseObject.vala"
		case OBJECTS_BASE_OBJECT_UPDATE_TIMEOUT_ID_PROPERTY:
#line 22 "../core/Objects/BaseObject.vala"
		objects_base_object_set_update_timeout_id (self, g_value_get_uint (value));
#line 22 "../core/Objects/BaseObject.vala"
		break;
#line 22 "../core/Objects/BaseObject.vala"
		case OBJECTS_BASE_OBJECT_LOADING_PROPERTY:
#line 22 "../core/Objects/BaseObject.vala"
		objects_base_object_set_loading (self, g_value_get_boolean (value));
#line 22 "../core/Objects/BaseObject.vala"
		break;
#line 22 "../core/Objects/BaseObject.vala"
		case OBJECTS_BASE_OBJECT_SENSITIVE_PROPERTY:
#line 22 "../core/Objects/BaseObject.vala"
		objects_base_object_set_sensitive (self, g_value_get_boolean (value));
#line 22 "../core/Objects/BaseObject.vala"
		break;
#line 22 "../core/Objects/BaseObject.vala"
		case OBJECTS_BASE_OBJECT_VIEW_ID_PROPERTY:
#line 22 "../core/Objects/BaseObject.vala"
		objects_base_object_set_view_id (self, g_value_get_string (value));
#line 22 "../core/Objects/BaseObject.vala"
		break;
#line 1607 "BaseObject.c"
		default:
#line 22 "../core/Objects/BaseObject.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 22 "../core/Objects/BaseObject.vala"
		break;
#line 1613 "BaseObject.c"
	}
}

