/* ObjectEvent.c generated by valac 0.56.18, the Vala compiler
 * generated from ObjectEvent.vala, do not modify */

/*
 * Copyright © 2024 Alain M. (https://github.com/alainm23/planify)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA
 *
 * Authored by: Alain M. <alainmh23@gmail.com>
 */

#include "planify.h"
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <json-glib/json-glib.h>
#include <gee.h>
#include <glib-object.h>
#include <granite-7.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	OBJECTS_OBJECT_EVENT_0_PROPERTY,
	OBJECTS_OBJECT_EVENT_ID_PROPERTY,
	OBJECTS_OBJECT_EVENT_EVENT_TYPE_PROPERTY,
	OBJECTS_OBJECT_EVENT_EVENT_DATE_PROPERTY,
	OBJECTS_OBJECT_EVENT_OBJECT_ID_PROPERTY,
	OBJECTS_OBJECT_EVENT_OBJECT_TYPE_PROPERTY,
	OBJECTS_OBJECT_EVENT_OBJECT_KEY_PROPERTY,
	OBJECTS_OBJECT_EVENT_OBJECT_OLD_VALUE_PROPERTY,
	OBJECTS_OBJECT_EVENT_OBJECT_NEW_VALUE_PROPERTY,
	OBJECTS_OBJECT_EVENT_PARENT_ITEM_ID_PROPERTY,
	OBJECTS_OBJECT_EVENT_PARENT_PROJECT_ID_PROPERTY,
	OBJECTS_OBJECT_EVENT_ICON_NAME_PROPERTY,
	OBJECTS_OBJECT_EVENT_DATETIME_PROPERTY,
	OBJECTS_OBJECT_EVENT_DATE_PROPERTY,
	OBJECTS_OBJECT_EVENT_TIME_PROPERTY,
	OBJECTS_OBJECT_EVENT_NUM_PROPERTIES
};
static GParamSpec* objects_object_event_properties[OBJECTS_OBJECT_EVENT_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _ObjectsObjectEventPrivate {
	gint64 _id;
	ObjectEventType _event_type;
	gchar* _event_date;
	gchar* _object_id;
	gchar* _object_type;
	ObjectEventKeyType _object_key;
	gchar* _object_old_value;
	gchar* _object_new_value;
	gchar* _parent_item_id;
	gchar* _parent_project_id;
	GDateTime* _datetime;
	GDateTime* _date;
	gchar* _time;
};

static gint ObjectsObjectEvent_private_offset;
static gpointer objects_object_event_parent_class = NULL;

static void objects_object_event_finalize (GObject * obj);
static GType objects_object_event_get_type_once (void);
static void _vala_objects_object_event_get_property (GObject * object,
                                              guint property_id,
                                              GValue * value,
                                              GParamSpec * pspec);
static void _vala_objects_object_event_set_property (GObject * object,
                                              guint property_id,
                                              const GValue * value,
                                              GParamSpec * pspec);

static inline gpointer
objects_object_event_get_instance_private (ObjectsObjectEvent* self)
{
	return G_STRUCT_MEMBER_P (self, ObjectsObjectEvent_private_offset);
}

ObjectsDueDate*
objects_object_event_get_due_value (ObjectsObjectEvent* self,
                                    const gchar* value)
{
	JsonParser* parser = NULL;
	JsonParser* _tmp0_;
	ObjectsDueDate* due = NULL;
	ObjectsDueDate* _tmp6_;
	ObjectsDueDate* _tmp7_;
	JsonParser* _tmp8_;
	JsonNode* _tmp9_;
	JsonObject* _tmp10_;
	GError* _inner_error0_ = NULL;
	ObjectsDueDate* result;
#line 91 "../core/Objects/ObjectEvent.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 91 "../core/Objects/ObjectEvent.vala"
	g_return_val_if_fail (value != NULL, NULL);
#line 92 "../core/Objects/ObjectEvent.vala"
	_tmp0_ = json_parser_new ();
#line 92 "../core/Objects/ObjectEvent.vala"
	parser = _tmp0_;
#line 126 "ObjectEvent.c"
	{
		JsonParser* _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
#line 95 "../core/Objects/ObjectEvent.vala"
		_tmp1_ = parser;
#line 95 "../core/Objects/ObjectEvent.vala"
		_tmp2_ = strlen (value);
#line 95 "../core/Objects/ObjectEvent.vala"
		_tmp3_ = _tmp2_;
#line 95 "../core/Objects/ObjectEvent.vala"
		json_parser_load_from_data (_tmp1_, value, (gssize) _tmp3_, &_inner_error0_);
#line 95 "../core/Objects/ObjectEvent.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 141 "ObjectEvent.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp4_;
		const gchar* _tmp5_;
#line 94 "../core/Objects/ObjectEvent.vala"
		e = _inner_error0_;
#line 94 "../core/Objects/ObjectEvent.vala"
		_inner_error0_ = NULL;
#line 97 "../core/Objects/ObjectEvent.vala"
		_tmp4_ = e;
#line 97 "../core/Objects/ObjectEvent.vala"
		_tmp5_ = _tmp4_->message;
#line 97 "../core/Objects/ObjectEvent.vala"
		g_warning ("ObjectEvent.vala:97: %s", _tmp5_);
#line 98 "../core/Objects/ObjectEvent.vala"
		result = NULL;
#line 98 "../core/Objects/ObjectEvent.vala"
		_g_error_free0 (e);
#line 98 "../core/Objects/ObjectEvent.vala"
		_g_object_unref0 (parser);
#line 98 "../core/Objects/ObjectEvent.vala"
		return result;
#line 169 "ObjectEvent.c"
	}
	__finally0:
#line 94 "../core/Objects/ObjectEvent.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 94 "../core/Objects/ObjectEvent.vala"
		_g_object_unref0 (parser);
#line 94 "../core/Objects/ObjectEvent.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 94 "../core/Objects/ObjectEvent.vala"
		g_clear_error (&_inner_error0_);
#line 94 "../core/Objects/ObjectEvent.vala"
		return NULL;
#line 182 "ObjectEvent.c"
	}
#line 101 "../core/Objects/ObjectEvent.vala"
	_tmp6_ = objects_due_date_new ();
#line 101 "../core/Objects/ObjectEvent.vala"
	due = _tmp6_;
#line 102 "../core/Objects/ObjectEvent.vala"
	_tmp7_ = due;
#line 102 "../core/Objects/ObjectEvent.vala"
	_tmp8_ = parser;
#line 102 "../core/Objects/ObjectEvent.vala"
	_tmp9_ = json_parser_get_root (_tmp8_);
#line 102 "../core/Objects/ObjectEvent.vala"
	_tmp10_ = json_node_get_object (_tmp9_);
#line 102 "../core/Objects/ObjectEvent.vala"
	objects_due_date_update_from_json (_tmp7_, _tmp10_);
#line 104 "../core/Objects/ObjectEvent.vala"
	result = due;
#line 104 "../core/Objects/ObjectEvent.vala"
	_g_object_unref0 (parser);
#line 104 "../core/Objects/ObjectEvent.vala"
	return result;
#line 204 "ObjectEvent.c"
}

gchar*
objects_object_event_get_labels_value (ObjectsObjectEvent* self,
                                       const gchar* value)
{
	gchar* return_value = NULL;
	gchar* _tmp0_;
	GeeArrayList* labels = NULL;
	ServicesStore* _tmp1_;
	GeeArrayList* _tmp2_;
	GeeArrayList* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	gchar* result;
#line 107 "../core/Objects/ObjectEvent.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 107 "../core/Objects/ObjectEvent.vala"
	g_return_val_if_fail (value != NULL, NULL);
#line 108 "../core/Objects/ObjectEvent.vala"
	_tmp0_ = g_strdup ("");
#line 108 "../core/Objects/ObjectEvent.vala"
	return_value = _tmp0_;
#line 109 "../core/Objects/ObjectEvent.vala"
	_tmp1_ = services_store_instance ();
#line 109 "../core/Objects/ObjectEvent.vala"
	_tmp2_ = services_store_get_labels_by_item_labels (_tmp1_, value);
#line 109 "../core/Objects/ObjectEvent.vala"
	labels = _tmp2_;
#line 111 "../core/Objects/ObjectEvent.vala"
	_tmp3_ = labels;
#line 111 "../core/Objects/ObjectEvent.vala"
	_tmp4_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp3_);
#line 111 "../core/Objects/ObjectEvent.vala"
	_tmp5_ = _tmp4_;
#line 111 "../core/Objects/ObjectEvent.vala"
	if (_tmp5_ > 0) {
#line 242 "ObjectEvent.c"
		{
			gint index = 0;
#line 112 "../core/Objects/ObjectEvent.vala"
			index = 0;
#line 247 "ObjectEvent.c"
			{
				gboolean _tmp6_ = FALSE;
#line 112 "../core/Objects/ObjectEvent.vala"
				_tmp6_ = TRUE;
#line 112 "../core/Objects/ObjectEvent.vala"
				while (TRUE) {
#line 254 "ObjectEvent.c"
					GeeArrayList* _tmp8_;
					gint _tmp9_;
					gint _tmp10_;
					GeeArrayList* _tmp11_;
					gint _tmp12_;
					gint _tmp13_;
#line 112 "../core/Objects/ObjectEvent.vala"
					if (!_tmp6_) {
#line 263 "ObjectEvent.c"
						gint _tmp7_;
#line 112 "../core/Objects/ObjectEvent.vala"
						_tmp7_ = index;
#line 112 "../core/Objects/ObjectEvent.vala"
						index = _tmp7_ + 1;
#line 269 "ObjectEvent.c"
					}
#line 112 "../core/Objects/ObjectEvent.vala"
					_tmp6_ = FALSE;
#line 112 "../core/Objects/ObjectEvent.vala"
					_tmp8_ = labels;
#line 112 "../core/Objects/ObjectEvent.vala"
					_tmp9_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp8_);
#line 112 "../core/Objects/ObjectEvent.vala"
					_tmp10_ = _tmp9_;
#line 112 "../core/Objects/ObjectEvent.vala"
					if (!(index < _tmp10_)) {
#line 112 "../core/Objects/ObjectEvent.vala"
						break;
#line 283 "ObjectEvent.c"
					}
#line 113 "../core/Objects/ObjectEvent.vala"
					_tmp11_ = labels;
#line 113 "../core/Objects/ObjectEvent.vala"
					_tmp12_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp11_);
#line 113 "../core/Objects/ObjectEvent.vala"
					_tmp13_ = _tmp12_;
#line 113 "../core/Objects/ObjectEvent.vala"
					if (index < (_tmp13_ - 1)) {
#line 293 "ObjectEvent.c"
						const gchar* _tmp14_;
						GeeArrayList* _tmp15_;
						gpointer _tmp16_;
						ObjectsLabel* _tmp17_;
						const gchar* _tmp18_;
						const gchar* _tmp19_;
						gchar* _tmp20_;
						gchar* _tmp21_;
						gchar* _tmp22_;
#line 114 "../core/Objects/ObjectEvent.vala"
						_tmp14_ = return_value;
#line 114 "../core/Objects/ObjectEvent.vala"
						_tmp15_ = labels;
#line 114 "../core/Objects/ObjectEvent.vala"
						_tmp16_ = gee_abstract_list_get ((GeeAbstractList*) _tmp15_, index);
#line 114 "../core/Objects/ObjectEvent.vala"
						_tmp17_ = (ObjectsLabel*) _tmp16_;
#line 114 "../core/Objects/ObjectEvent.vala"
						_tmp18_ = objects_base_object_get_name ((ObjectsBaseObject*) _tmp17_);
#line 114 "../core/Objects/ObjectEvent.vala"
						_tmp19_ = _tmp18_;
#line 114 "../core/Objects/ObjectEvent.vala"
						_tmp20_ = g_strconcat (_tmp19_, ", ", NULL);
#line 114 "../core/Objects/ObjectEvent.vala"
						_tmp21_ = _tmp20_;
#line 114 "../core/Objects/ObjectEvent.vala"
						_tmp22_ = g_strconcat (_tmp14_, _tmp21_, NULL);
#line 114 "../core/Objects/ObjectEvent.vala"
						_g_free0 (return_value);
#line 114 "../core/Objects/ObjectEvent.vala"
						return_value = _tmp22_;
#line 114 "../core/Objects/ObjectEvent.vala"
						_g_free0 (_tmp21_);
#line 114 "../core/Objects/ObjectEvent.vala"
						_g_object_unref0 (_tmp17_);
#line 329 "ObjectEvent.c"
					} else {
						const gchar* _tmp23_;
						GeeArrayList* _tmp24_;
						gpointer _tmp25_;
						ObjectsLabel* _tmp26_;
						const gchar* _tmp27_;
						const gchar* _tmp28_;
						gchar* _tmp29_;
#line 116 "../core/Objects/ObjectEvent.vala"
						_tmp23_ = return_value;
#line 116 "../core/Objects/ObjectEvent.vala"
						_tmp24_ = labels;
#line 116 "../core/Objects/ObjectEvent.vala"
						_tmp25_ = gee_abstract_list_get ((GeeAbstractList*) _tmp24_, index);
#line 116 "../core/Objects/ObjectEvent.vala"
						_tmp26_ = (ObjectsLabel*) _tmp25_;
#line 116 "../core/Objects/ObjectEvent.vala"
						_tmp27_ = objects_base_object_get_name ((ObjectsBaseObject*) _tmp26_);
#line 116 "../core/Objects/ObjectEvent.vala"
						_tmp28_ = _tmp27_;
#line 116 "../core/Objects/ObjectEvent.vala"
						_tmp29_ = g_strconcat (_tmp23_, _tmp28_, NULL);
#line 116 "../core/Objects/ObjectEvent.vala"
						_g_free0 (return_value);
#line 116 "../core/Objects/ObjectEvent.vala"
						return_value = _tmp29_;
#line 116 "../core/Objects/ObjectEvent.vala"
						_g_object_unref0 (_tmp26_);
#line 358 "ObjectEvent.c"
					}
				}
			}
		}
	}
#line 121 "../core/Objects/ObjectEvent.vala"
	result = return_value;
#line 121 "../core/Objects/ObjectEvent.vala"
	_g_object_unref0 (labels);
#line 121 "../core/Objects/ObjectEvent.vala"
	return result;
#line 370 "ObjectEvent.c"
}

ObjectsObjectEvent*
objects_object_event_construct (GType object_type)
{
	ObjectsObjectEvent * self = NULL;
#line 22 "../core/Objects/ObjectEvent.vala"
	self = (ObjectsObjectEvent*) g_object_new (object_type, NULL);
#line 22 "../core/Objects/ObjectEvent.vala"
	return self;
#line 381 "ObjectEvent.c"
}

ObjectsObjectEvent*
objects_object_event_new (void)
{
#line 22 "../core/Objects/ObjectEvent.vala"
	return objects_object_event_construct (OBJECTS_TYPE_OBJECT_EVENT);
#line 389 "ObjectEvent.c"
}

gint64
objects_object_event_get_id (ObjectsObjectEvent* self)
{
	gint64 result;
#line 23 "../core/Objects/ObjectEvent.vala"
	g_return_val_if_fail (self != NULL, 0LL);
#line 23 "../core/Objects/ObjectEvent.vala"
	result = self->priv->_id;
#line 23 "../core/Objects/ObjectEvent.vala"
	return result;
#line 402 "ObjectEvent.c"
}

void
objects_object_event_set_id (ObjectsObjectEvent* self,
                             gint64 value)
{
	gint64 old_value;
#line 23 "../core/Objects/ObjectEvent.vala"
	g_return_if_fail (self != NULL);
#line 23 "../core/Objects/ObjectEvent.vala"
	old_value = objects_object_event_get_id (self);
#line 23 "../core/Objects/ObjectEvent.vala"
	if (old_value != value) {
#line 23 "../core/Objects/ObjectEvent.vala"
		self->priv->_id = value;
#line 23 "../core/Objects/ObjectEvent.vala"
		g_object_notify_by_pspec ((GObject *) self, objects_object_event_properties[OBJECTS_OBJECT_EVENT_ID_PROPERTY]);
#line 420 "ObjectEvent.c"
	}
}

ObjectEventType
objects_object_event_get_event_type (ObjectsObjectEvent* self)
{
	ObjectEventType result;
#line 24 "../core/Objects/ObjectEvent.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 24 "../core/Objects/ObjectEvent.vala"
	result = self->priv->_event_type;
#line 24 "../core/Objects/ObjectEvent.vala"
	return result;
#line 434 "ObjectEvent.c"
}

void
objects_object_event_set_event_type (ObjectsObjectEvent* self,
                                     ObjectEventType value)
{
	ObjectEventType old_value;
#line 24 "../core/Objects/ObjectEvent.vala"
	g_return_if_fail (self != NULL);
#line 24 "../core/Objects/ObjectEvent.vala"
	old_value = objects_object_event_get_event_type (self);
#line 24 "../core/Objects/ObjectEvent.vala"
	if (old_value != value) {
#line 24 "../core/Objects/ObjectEvent.vala"
		self->priv->_event_type = value;
#line 24 "../core/Objects/ObjectEvent.vala"
		g_object_notify_by_pspec ((GObject *) self, objects_object_event_properties[OBJECTS_OBJECT_EVENT_EVENT_TYPE_PROPERTY]);
#line 452 "ObjectEvent.c"
	}
}

const gchar*
objects_object_event_get_event_date (ObjectsObjectEvent* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 25 "../core/Objects/ObjectEvent.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 25 "../core/Objects/ObjectEvent.vala"
	_tmp0_ = self->priv->_event_date;
#line 25 "../core/Objects/ObjectEvent.vala"
	result = _tmp0_;
#line 25 "../core/Objects/ObjectEvent.vala"
	return result;
#line 469 "ObjectEvent.c"
}

void
objects_object_event_set_event_date (ObjectsObjectEvent* self,
                                     const gchar* value)
{
	gchar* old_value;
#line 25 "../core/Objects/ObjectEvent.vala"
	g_return_if_fail (self != NULL);
#line 25 "../core/Objects/ObjectEvent.vala"
	old_value = objects_object_event_get_event_date (self);
#line 25 "../core/Objects/ObjectEvent.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 483 "ObjectEvent.c"
		gchar* _tmp0_;
#line 25 "../core/Objects/ObjectEvent.vala"
		_tmp0_ = g_strdup (value);
#line 25 "../core/Objects/ObjectEvent.vala"
		_g_free0 (self->priv->_event_date);
#line 25 "../core/Objects/ObjectEvent.vala"
		self->priv->_event_date = _tmp0_;
#line 25 "../core/Objects/ObjectEvent.vala"
		g_object_notify_by_pspec ((GObject *) self, objects_object_event_properties[OBJECTS_OBJECT_EVENT_EVENT_DATE_PROPERTY]);
#line 493 "ObjectEvent.c"
	}
}

const gchar*
objects_object_event_get_object_id (ObjectsObjectEvent* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 26 "../core/Objects/ObjectEvent.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 26 "../core/Objects/ObjectEvent.vala"
	_tmp0_ = self->priv->_object_id;
#line 26 "../core/Objects/ObjectEvent.vala"
	result = _tmp0_;
#line 26 "../core/Objects/ObjectEvent.vala"
	return result;
#line 510 "ObjectEvent.c"
}

void
objects_object_event_set_object_id (ObjectsObjectEvent* self,
                                    const gchar* value)
{
	gchar* old_value;
#line 26 "../core/Objects/ObjectEvent.vala"
	g_return_if_fail (self != NULL);
#line 26 "../core/Objects/ObjectEvent.vala"
	old_value = objects_object_event_get_object_id (self);
#line 26 "../core/Objects/ObjectEvent.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 524 "ObjectEvent.c"
		gchar* _tmp0_;
#line 26 "../core/Objects/ObjectEvent.vala"
		_tmp0_ = g_strdup (value);
#line 26 "../core/Objects/ObjectEvent.vala"
		_g_free0 (self->priv->_object_id);
#line 26 "../core/Objects/ObjectEvent.vala"
		self->priv->_object_id = _tmp0_;
#line 26 "../core/Objects/ObjectEvent.vala"
		g_object_notify_by_pspec ((GObject *) self, objects_object_event_properties[OBJECTS_OBJECT_EVENT_OBJECT_ID_PROPERTY]);
#line 534 "ObjectEvent.c"
	}
}

const gchar*
objects_object_event_get_object_type (ObjectsObjectEvent* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 27 "../core/Objects/ObjectEvent.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 27 "../core/Objects/ObjectEvent.vala"
	_tmp0_ = self->priv->_object_type;
#line 27 "../core/Objects/ObjectEvent.vala"
	result = _tmp0_;
#line 27 "../core/Objects/ObjectEvent.vala"
	return result;
#line 551 "ObjectEvent.c"
}

void
objects_object_event_set_object_type (ObjectsObjectEvent* self,
                                      const gchar* value)
{
	gchar* old_value;
#line 27 "../core/Objects/ObjectEvent.vala"
	g_return_if_fail (self != NULL);
#line 27 "../core/Objects/ObjectEvent.vala"
	old_value = objects_object_event_get_object_type (self);
#line 27 "../core/Objects/ObjectEvent.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 565 "ObjectEvent.c"
		gchar* _tmp0_;
#line 27 "../core/Objects/ObjectEvent.vala"
		_tmp0_ = g_strdup (value);
#line 27 "../core/Objects/ObjectEvent.vala"
		_g_free0 (self->priv->_object_type);
#line 27 "../core/Objects/ObjectEvent.vala"
		self->priv->_object_type = _tmp0_;
#line 27 "../core/Objects/ObjectEvent.vala"
		g_object_notify_by_pspec ((GObject *) self, objects_object_event_properties[OBJECTS_OBJECT_EVENT_OBJECT_TYPE_PROPERTY]);
#line 575 "ObjectEvent.c"
	}
}

ObjectEventKeyType
objects_object_event_get_object_key (ObjectsObjectEvent* self)
{
	ObjectEventKeyType result;
#line 28 "../core/Objects/ObjectEvent.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 28 "../core/Objects/ObjectEvent.vala"
	result = self->priv->_object_key;
#line 28 "../core/Objects/ObjectEvent.vala"
	return result;
#line 589 "ObjectEvent.c"
}

void
objects_object_event_set_object_key (ObjectsObjectEvent* self,
                                     ObjectEventKeyType value)
{
	ObjectEventKeyType old_value;
#line 28 "../core/Objects/ObjectEvent.vala"
	g_return_if_fail (self != NULL);
#line 28 "../core/Objects/ObjectEvent.vala"
	old_value = objects_object_event_get_object_key (self);
#line 28 "../core/Objects/ObjectEvent.vala"
	if (old_value != value) {
#line 28 "../core/Objects/ObjectEvent.vala"
		self->priv->_object_key = value;
#line 28 "../core/Objects/ObjectEvent.vala"
		g_object_notify_by_pspec ((GObject *) self, objects_object_event_properties[OBJECTS_OBJECT_EVENT_OBJECT_KEY_PROPERTY]);
#line 607 "ObjectEvent.c"
	}
}

const gchar*
objects_object_event_get_object_old_value (ObjectsObjectEvent* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 29 "../core/Objects/ObjectEvent.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 29 "../core/Objects/ObjectEvent.vala"
	_tmp0_ = self->priv->_object_old_value;
#line 29 "../core/Objects/ObjectEvent.vala"
	result = _tmp0_;
#line 29 "../core/Objects/ObjectEvent.vala"
	return result;
#line 624 "ObjectEvent.c"
}

void
objects_object_event_set_object_old_value (ObjectsObjectEvent* self,
                                           const gchar* value)
{
	gchar* old_value;
#line 29 "../core/Objects/ObjectEvent.vala"
	g_return_if_fail (self != NULL);
#line 29 "../core/Objects/ObjectEvent.vala"
	old_value = objects_object_event_get_object_old_value (self);
#line 29 "../core/Objects/ObjectEvent.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 638 "ObjectEvent.c"
		gchar* _tmp0_;
#line 29 "../core/Objects/ObjectEvent.vala"
		_tmp0_ = g_strdup (value);
#line 29 "../core/Objects/ObjectEvent.vala"
		_g_free0 (self->priv->_object_old_value);
#line 29 "../core/Objects/ObjectEvent.vala"
		self->priv->_object_old_value = _tmp0_;
#line 29 "../core/Objects/ObjectEvent.vala"
		g_object_notify_by_pspec ((GObject *) self, objects_object_event_properties[OBJECTS_OBJECT_EVENT_OBJECT_OLD_VALUE_PROPERTY]);
#line 648 "ObjectEvent.c"
	}
}

const gchar*
objects_object_event_get_object_new_value (ObjectsObjectEvent* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 30 "../core/Objects/ObjectEvent.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 30 "../core/Objects/ObjectEvent.vala"
	_tmp0_ = self->priv->_object_new_value;
#line 30 "../core/Objects/ObjectEvent.vala"
	result = _tmp0_;
#line 30 "../core/Objects/ObjectEvent.vala"
	return result;
#line 665 "ObjectEvent.c"
}

void
objects_object_event_set_object_new_value (ObjectsObjectEvent* self,
                                           const gchar* value)
{
	gchar* old_value;
#line 30 "../core/Objects/ObjectEvent.vala"
	g_return_if_fail (self != NULL);
#line 30 "../core/Objects/ObjectEvent.vala"
	old_value = objects_object_event_get_object_new_value (self);
#line 30 "../core/Objects/ObjectEvent.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 679 "ObjectEvent.c"
		gchar* _tmp0_;
#line 30 "../core/Objects/ObjectEvent.vala"
		_tmp0_ = g_strdup (value);
#line 30 "../core/Objects/ObjectEvent.vala"
		_g_free0 (self->priv->_object_new_value);
#line 30 "../core/Objects/ObjectEvent.vala"
		self->priv->_object_new_value = _tmp0_;
#line 30 "../core/Objects/ObjectEvent.vala"
		g_object_notify_by_pspec ((GObject *) self, objects_object_event_properties[OBJECTS_OBJECT_EVENT_OBJECT_NEW_VALUE_PROPERTY]);
#line 689 "ObjectEvent.c"
	}
}

const gchar*
objects_object_event_get_parent_item_id (ObjectsObjectEvent* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 31 "../core/Objects/ObjectEvent.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 31 "../core/Objects/ObjectEvent.vala"
	_tmp0_ = self->priv->_parent_item_id;
#line 31 "../core/Objects/ObjectEvent.vala"
	result = _tmp0_;
#line 31 "../core/Objects/ObjectEvent.vala"
	return result;
#line 706 "ObjectEvent.c"
}

void
objects_object_event_set_parent_item_id (ObjectsObjectEvent* self,
                                         const gchar* value)
{
	gchar* old_value;
#line 31 "../core/Objects/ObjectEvent.vala"
	g_return_if_fail (self != NULL);
#line 31 "../core/Objects/ObjectEvent.vala"
	old_value = objects_object_event_get_parent_item_id (self);
#line 31 "../core/Objects/ObjectEvent.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 720 "ObjectEvent.c"
		gchar* _tmp0_;
#line 31 "../core/Objects/ObjectEvent.vala"
		_tmp0_ = g_strdup (value);
#line 31 "../core/Objects/ObjectEvent.vala"
		_g_free0 (self->priv->_parent_item_id);
#line 31 "../core/Objects/ObjectEvent.vala"
		self->priv->_parent_item_id = _tmp0_;
#line 31 "../core/Objects/ObjectEvent.vala"
		g_object_notify_by_pspec ((GObject *) self, objects_object_event_properties[OBJECTS_OBJECT_EVENT_PARENT_ITEM_ID_PROPERTY]);
#line 730 "ObjectEvent.c"
	}
}

const gchar*
objects_object_event_get_parent_project_id (ObjectsObjectEvent* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 32 "../core/Objects/ObjectEvent.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 32 "../core/Objects/ObjectEvent.vala"
	_tmp0_ = self->priv->_parent_project_id;
#line 32 "../core/Objects/ObjectEvent.vala"
	result = _tmp0_;
#line 32 "../core/Objects/ObjectEvent.vala"
	return result;
#line 747 "ObjectEvent.c"
}

void
objects_object_event_set_parent_project_id (ObjectsObjectEvent* self,
                                            const gchar* value)
{
	gchar* old_value;
#line 32 "../core/Objects/ObjectEvent.vala"
	g_return_if_fail (self != NULL);
#line 32 "../core/Objects/ObjectEvent.vala"
	old_value = objects_object_event_get_parent_project_id (self);
#line 32 "../core/Objects/ObjectEvent.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 761 "ObjectEvent.c"
		gchar* _tmp0_;
#line 32 "../core/Objects/ObjectEvent.vala"
		_tmp0_ = g_strdup (value);
#line 32 "../core/Objects/ObjectEvent.vala"
		_g_free0 (self->priv->_parent_project_id);
#line 32 "../core/Objects/ObjectEvent.vala"
		self->priv->_parent_project_id = _tmp0_;
#line 32 "../core/Objects/ObjectEvent.vala"
		g_object_notify_by_pspec ((GObject *) self, objects_object_event_properties[OBJECTS_OBJECT_EVENT_PARENT_PROJECT_ID_PROPERTY]);
#line 771 "ObjectEvent.c"
	}
}

const gchar*
objects_object_event_get_icon_name (ObjectsObjectEvent* self)
{
	const gchar* result;
	ObjectEventType _tmp0_;
#line 35 "../core/Objects/ObjectEvent.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 36 "../core/Objects/ObjectEvent.vala"
	_tmp0_ = self->priv->_event_type;
#line 36 "../core/Objects/ObjectEvent.vala"
	if (_tmp0_ == OBJECT_EVENT_TYPE_INSERT) {
#line 37 "../core/Objects/ObjectEvent.vala"
		result = "plus-large-symbolic";
#line 37 "../core/Objects/ObjectEvent.vala"
		return result;
#line 790 "ObjectEvent.c"
	} else {
		ObjectEventType _tmp1_;
#line 38 "../core/Objects/ObjectEvent.vala"
		_tmp1_ = self->priv->_event_type;
#line 38 "../core/Objects/ObjectEvent.vala"
		if (_tmp1_ == OBJECT_EVENT_TYPE_UPDATE) {
#line 797 "ObjectEvent.c"
			ObjectEventKeyType _tmp2_;
#line 39 "../core/Objects/ObjectEvent.vala"
			_tmp2_ = self->priv->_object_key;
#line 39 "../core/Objects/ObjectEvent.vala"
			if (_tmp2_ == OBJECT_EVENT_KEY_TYPE_CONTENT) {
#line 40 "../core/Objects/ObjectEvent.vala"
				result = "edit-symbolic";
#line 40 "../core/Objects/ObjectEvent.vala"
				return result;
#line 807 "ObjectEvent.c"
			} else {
				ObjectEventKeyType _tmp3_;
#line 41 "../core/Objects/ObjectEvent.vala"
				_tmp3_ = self->priv->_object_key;
#line 41 "../core/Objects/ObjectEvent.vala"
				if (_tmp3_ == OBJECT_EVENT_KEY_TYPE_DESCRIPTION) {
#line 42 "../core/Objects/ObjectEvent.vala"
					result = "paper-symbolic";
#line 42 "../core/Objects/ObjectEvent.vala"
					return result;
#line 818 "ObjectEvent.c"
				} else {
					ObjectEventKeyType _tmp4_;
#line 43 "../core/Objects/ObjectEvent.vala"
					_tmp4_ = self->priv->_object_key;
#line 43 "../core/Objects/ObjectEvent.vala"
					if (_tmp4_ == OBJECT_EVENT_KEY_TYPE_DUE) {
#line 44 "../core/Objects/ObjectEvent.vala"
						result = "month-symbolic";
#line 44 "../core/Objects/ObjectEvent.vala"
						return result;
#line 829 "ObjectEvent.c"
					} else {
						ObjectEventKeyType _tmp5_;
#line 45 "../core/Objects/ObjectEvent.vala"
						_tmp5_ = self->priv->_object_key;
#line 45 "../core/Objects/ObjectEvent.vala"
						if (_tmp5_ == OBJECT_EVENT_KEY_TYPE_PRIORITY) {
#line 46 "../core/Objects/ObjectEvent.vala"
							result = "flag-outline-thick-symbolic";
#line 46 "../core/Objects/ObjectEvent.vala"
							return result;
#line 840 "ObjectEvent.c"
						} else {
							ObjectEventKeyType _tmp6_;
#line 47 "../core/Objects/ObjectEvent.vala"
							_tmp6_ = self->priv->_object_key;
#line 47 "../core/Objects/ObjectEvent.vala"
							if (_tmp6_ == OBJECT_EVENT_KEY_TYPE_LABELS) {
#line 48 "../core/Objects/ObjectEvent.vala"
								result = "tag-outline-symbolic";
#line 48 "../core/Objects/ObjectEvent.vala"
								return result;
#line 851 "ObjectEvent.c"
							} else {
								ObjectEventKeyType _tmp7_;
#line 49 "../core/Objects/ObjectEvent.vala"
								_tmp7_ = self->priv->_object_key;
#line 49 "../core/Objects/ObjectEvent.vala"
								if (_tmp7_ == OBJECT_EVENT_KEY_TYPE_PINNED) {
#line 50 "../core/Objects/ObjectEvent.vala"
									result = "pin-symbolic";
#line 50 "../core/Objects/ObjectEvent.vala"
									return result;
#line 862 "ObjectEvent.c"
								} else {
									ObjectEventKeyType _tmp8_;
#line 51 "../core/Objects/ObjectEvent.vala"
									_tmp8_ = self->priv->_object_key;
#line 51 "../core/Objects/ObjectEvent.vala"
									if (_tmp8_ == OBJECT_EVENT_KEY_TYPE_CHECKED) {
#line 52 "../core/Objects/ObjectEvent.vala"
										result = "check-round-outline-symbolic";
#line 52 "../core/Objects/ObjectEvent.vala"
										return result;
#line 873 "ObjectEvent.c"
									} else {
										gboolean _tmp9_ = FALSE;
										ObjectEventKeyType _tmp10_;
#line 53 "../core/Objects/ObjectEvent.vala"
										_tmp10_ = self->priv->_object_key;
#line 53 "../core/Objects/ObjectEvent.vala"
										if (_tmp10_ == OBJECT_EVENT_KEY_TYPE_SECTION) {
#line 53 "../core/Objects/ObjectEvent.vala"
											_tmp9_ = TRUE;
#line 883 "ObjectEvent.c"
										} else {
											ObjectEventKeyType _tmp11_;
#line 53 "../core/Objects/ObjectEvent.vala"
											_tmp11_ = self->priv->_object_key;
#line 53 "../core/Objects/ObjectEvent.vala"
											_tmp9_ = _tmp11_ == OBJECT_EVENT_KEY_TYPE_PROJECT;
#line 890 "ObjectEvent.c"
										}
#line 53 "../core/Objects/ObjectEvent.vala"
										if (_tmp9_) {
#line 54 "../core/Objects/ObjectEvent.vala"
											result = "arrow3-right-symbolic";
#line 54 "../core/Objects/ObjectEvent.vala"
											return result;
#line 898 "ObjectEvent.c"
										}
									}
								}
							}
						}
					}
				}
			}
		}
	}
#line 58 "../core/Objects/ObjectEvent.vala"
	result = "plus-large-symbolic";
#line 58 "../core/Objects/ObjectEvent.vala"
	return result;
#line 913 "ObjectEvent.c"
}

GDateTime*
objects_object_event_get_datetime (ObjectsObjectEvent* self)
{
	GDateTime* result;
	const gchar* _tmp0_;
	GDateTime* _tmp1_;
	GDateTime* _tmp2_;
#line 64 "../core/Objects/ObjectEvent.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 65 "../core/Objects/ObjectEvent.vala"
	_tmp0_ = self->priv->_event_date;
#line 65 "../core/Objects/ObjectEvent.vala"
	_tmp1_ = utils_datetime_get_date_from_string (_tmp0_);
#line 65 "../core/Objects/ObjectEvent.vala"
	_g_date_time_unref0 (self->priv->_datetime);
#line 65 "../core/Objects/ObjectEvent.vala"
	self->priv->_datetime = _tmp1_;
#line 66 "../core/Objects/ObjectEvent.vala"
	_tmp2_ = self->priv->_datetime;
#line 66 "../core/Objects/ObjectEvent.vala"
	result = _tmp2_;
#line 66 "../core/Objects/ObjectEvent.vala"
	return result;
#line 939 "ObjectEvent.c"
}

GDateTime*
objects_object_event_get_date (ObjectsObjectEvent* self)
{
	GDateTime* result;
	const gchar* _tmp0_;
	GDateTime* _tmp1_;
	GDateTime* _tmp2_;
	GDateTime* _tmp3_;
	GDateTime* _tmp4_;
#line 72 "../core/Objects/ObjectEvent.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 73 "../core/Objects/ObjectEvent.vala"
	_tmp0_ = self->priv->_event_date;
#line 73 "../core/Objects/ObjectEvent.vala"
	_tmp1_ = utils_datetime_get_date_from_string (_tmp0_);
#line 73 "../core/Objects/ObjectEvent.vala"
	_tmp2_ = _tmp1_;
#line 73 "../core/Objects/ObjectEvent.vala"
	_tmp3_ = utils_datetime_format_date (_tmp2_);
#line 73 "../core/Objects/ObjectEvent.vala"
	_g_date_time_unref0 (self->priv->_date);
#line 73 "../core/Objects/ObjectEvent.vala"
	self->priv->_date = _tmp3_;
#line 73 "../core/Objects/ObjectEvent.vala"
	_g_date_time_unref0 (_tmp2_);
#line 74 "../core/Objects/ObjectEvent.vala"
	_tmp4_ = self->priv->_date;
#line 74 "../core/Objects/ObjectEvent.vala"
	result = _tmp4_;
#line 74 "../core/Objects/ObjectEvent.vala"
	return result;
#line 973 "ObjectEvent.c"
}

const gchar*
objects_object_event_get_time (ObjectsObjectEvent* self)
{
	const gchar* result;
	const gchar* _tmp10_;
#line 80 "../core/Objects/ObjectEvent.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 81 "../core/Objects/ObjectEvent.vala"
	if (utils_datetime_is_clock_format_12h ()) {
#line 985 "ObjectEvent.c"
		GDateTime* _tmp0_;
		GDateTime* _tmp1_;
		gchar* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
#line 82 "../core/Objects/ObjectEvent.vala"
		_tmp0_ = objects_object_event_get_datetime (self);
#line 82 "../core/Objects/ObjectEvent.vala"
		_tmp1_ = _tmp0_;
#line 82 "../core/Objects/ObjectEvent.vala"
		_tmp2_ = granite_date_time_get_default_time_format (TRUE, FALSE);
#line 82 "../core/Objects/ObjectEvent.vala"
		_tmp3_ = _tmp2_;
#line 82 "../core/Objects/ObjectEvent.vala"
		_tmp4_ = g_date_time_format (_tmp1_, _tmp3_);
#line 82 "../core/Objects/ObjectEvent.vala"
		_g_free0 (self->priv->_time);
#line 82 "../core/Objects/ObjectEvent.vala"
		self->priv->_time = _tmp4_;
#line 82 "../core/Objects/ObjectEvent.vala"
		_g_free0 (_tmp3_);
#line 1007 "ObjectEvent.c"
	} else {
		GDateTime* _tmp5_;
		GDateTime* _tmp6_;
		gchar* _tmp7_;
		gchar* _tmp8_;
		gchar* _tmp9_;
#line 84 "../core/Objects/ObjectEvent.vala"
		_tmp5_ = objects_object_event_get_datetime (self);
#line 84 "../core/Objects/ObjectEvent.vala"
		_tmp6_ = _tmp5_;
#line 84 "../core/Objects/ObjectEvent.vala"
		_tmp7_ = granite_date_time_get_default_time_format (FALSE, FALSE);
#line 84 "../core/Objects/ObjectEvent.vala"
		_tmp8_ = _tmp7_;
#line 84 "../core/Objects/ObjectEvent.vala"
		_tmp9_ = g_date_time_format (_tmp6_, _tmp8_);
#line 84 "../core/Objects/ObjectEvent.vala"
		_g_free0 (self->priv->_time);
#line 84 "../core/Objects/ObjectEvent.vala"
		self->priv->_time = _tmp9_;
#line 84 "../core/Objects/ObjectEvent.vala"
		_g_free0 (_tmp8_);
#line 1030 "ObjectEvent.c"
	}
#line 87 "../core/Objects/ObjectEvent.vala"
	_tmp10_ = self->priv->_time;
#line 87 "../core/Objects/ObjectEvent.vala"
	result = _tmp10_;
#line 87 "../core/Objects/ObjectEvent.vala"
	return result;
#line 1038 "ObjectEvent.c"
}

static void
objects_object_event_class_init (ObjectsObjectEventClass * klass,
                                 gpointer klass_data)
{
#line 22 "../core/Objects/ObjectEvent.vala"
	objects_object_event_parent_class = g_type_class_peek_parent (klass);
#line 22 "../core/Objects/ObjectEvent.vala"
	g_type_class_adjust_private_offset (klass, &ObjectsObjectEvent_private_offset);
#line 22 "../core/Objects/ObjectEvent.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_objects_object_event_get_property;
#line 22 "../core/Objects/ObjectEvent.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_objects_object_event_set_property;
#line 22 "../core/Objects/ObjectEvent.vala"
	G_OBJECT_CLASS (klass)->finalize = objects_object_event_finalize;
#line 22 "../core/Objects/ObjectEvent.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), OBJECTS_OBJECT_EVENT_ID_PROPERTY, objects_object_event_properties[OBJECTS_OBJECT_EVENT_ID_PROPERTY] = g_param_spec_int64 ("id", "id", "id", G_MININT64, G_MAXINT64, (gint64) 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 22 "../core/Objects/ObjectEvent.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), OBJECTS_OBJECT_EVENT_EVENT_TYPE_PROPERTY, objects_object_event_properties[OBJECTS_OBJECT_EVENT_EVENT_TYPE_PROPERTY] = g_param_spec_enum ("event-type", "event-type", "event-type", TYPE_OBJECT_EVENT_TYPE, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 22 "../core/Objects/ObjectEvent.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), OBJECTS_OBJECT_EVENT_EVENT_DATE_PROPERTY, objects_object_event_properties[OBJECTS_OBJECT_EVENT_EVENT_DATE_PROPERTY] = g_param_spec_string ("event-date", "event-date", "event-date", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 22 "../core/Objects/ObjectEvent.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), OBJECTS_OBJECT_EVENT_OBJECT_ID_PROPERTY, objects_object_event_properties[OBJECTS_OBJECT_EVENT_OBJECT_ID_PROPERTY] = g_param_spec_string ("object-id", "object-id", "object-id", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 22 "../core/Objects/ObjectEvent.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), OBJECTS_OBJECT_EVENT_OBJECT_TYPE_PROPERTY, objects_object_event_properties[OBJECTS_OBJECT_EVENT_OBJECT_TYPE_PROPERTY] = g_param_spec_string ("object-type", "object-type", "object-type", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 22 "../core/Objects/ObjectEvent.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), OBJECTS_OBJECT_EVENT_OBJECT_KEY_PROPERTY, objects_object_event_properties[OBJECTS_OBJECT_EVENT_OBJECT_KEY_PROPERTY] = g_param_spec_enum ("object-key", "object-key", "object-key", TYPE_OBJECT_EVENT_KEY_TYPE, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 22 "../core/Objects/ObjectEvent.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), OBJECTS_OBJECT_EVENT_OBJECT_OLD_VALUE_PROPERTY, objects_object_event_properties[OBJECTS_OBJECT_EVENT_OBJECT_OLD_VALUE_PROPERTY] = g_param_spec_string ("object-old-value", "object-old-value", "object-old-value", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 22 "../core/Objects/ObjectEvent.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), OBJECTS_OBJECT_EVENT_OBJECT_NEW_VALUE_PROPERTY, objects_object_event_properties[OBJECTS_OBJECT_EVENT_OBJECT_NEW_VALUE_PROPERTY] = g_param_spec_string ("object-new-value", "object-new-value", "object-new-value", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 22 "../core/Objects/ObjectEvent.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), OBJECTS_OBJECT_EVENT_PARENT_ITEM_ID_PROPERTY, objects_object_event_properties[OBJECTS_OBJECT_EVENT_PARENT_ITEM_ID_PROPERTY] = g_param_spec_string ("parent-item-id", "parent-item-id", "parent-item-id", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 22 "../core/Objects/ObjectEvent.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), OBJECTS_OBJECT_EVENT_PARENT_PROJECT_ID_PROPERTY, objects_object_event_properties[OBJECTS_OBJECT_EVENT_PARENT_PROJECT_ID_PROPERTY] = g_param_spec_string ("parent-project-id", "parent-project-id", "parent-project-id", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 22 "../core/Objects/ObjectEvent.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), OBJECTS_OBJECT_EVENT_ICON_NAME_PROPERTY, objects_object_event_properties[OBJECTS_OBJECT_EVENT_ICON_NAME_PROPERTY] = g_param_spec_string ("icon-name", "icon-name", "icon-name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 22 "../core/Objects/ObjectEvent.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), OBJECTS_OBJECT_EVENT_DATETIME_PROPERTY, objects_object_event_properties[OBJECTS_OBJECT_EVENT_DATETIME_PROPERTY] = g_param_spec_boxed ("datetime", "datetime", "datetime", G_TYPE_DATE_TIME, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 22 "../core/Objects/ObjectEvent.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), OBJECTS_OBJECT_EVENT_DATE_PROPERTY, objects_object_event_properties[OBJECTS_OBJECT_EVENT_DATE_PROPERTY] = g_param_spec_boxed ("date", "date", "date", G_TYPE_DATE_TIME, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 22 "../core/Objects/ObjectEvent.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), OBJECTS_OBJECT_EVENT_TIME_PROPERTY, objects_object_event_properties[OBJECTS_OBJECT_EVENT_TIME_PROPERTY] = g_param_spec_string ("time", "time", "time", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 1083 "ObjectEvent.c"
}

static void
objects_object_event_instance_init (ObjectsObjectEvent * self,
                                    gpointer klass)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
#line 22 "../core/Objects/ObjectEvent.vala"
	self->priv = objects_object_event_get_instance_private (self);
#line 23 "../core/Objects/ObjectEvent.vala"
	self->priv->_id = (gint64) 0;
#line 25 "../core/Objects/ObjectEvent.vala"
	_tmp0_ = g_strdup ("");
#line 25 "../core/Objects/ObjectEvent.vala"
	self->priv->_event_date = _tmp0_;
#line 26 "../core/Objects/ObjectEvent.vala"
	_tmp1_ = g_strdup ("");
#line 26 "../core/Objects/ObjectEvent.vala"
	self->priv->_object_id = _tmp1_;
#line 27 "../core/Objects/ObjectEvent.vala"
	_tmp2_ = g_strdup ("");
#line 27 "../core/Objects/ObjectEvent.vala"
	self->priv->_object_type = _tmp2_;
#line 29 "../core/Objects/ObjectEvent.vala"
	_tmp3_ = g_strdup ("");
#line 29 "../core/Objects/ObjectEvent.vala"
	self->priv->_object_old_value = _tmp3_;
#line 30 "../core/Objects/ObjectEvent.vala"
	_tmp4_ = g_strdup ("");
#line 30 "../core/Objects/ObjectEvent.vala"
	self->priv->_object_new_value = _tmp4_;
#line 31 "../core/Objects/ObjectEvent.vala"
	_tmp5_ = g_strdup ("");
#line 31 "../core/Objects/ObjectEvent.vala"
	self->priv->_parent_item_id = _tmp5_;
#line 32 "../core/Objects/ObjectEvent.vala"
	_tmp6_ = g_strdup ("");
#line 32 "../core/Objects/ObjectEvent.vala"
	self->priv->_parent_project_id = _tmp6_;
#line 1129 "ObjectEvent.c"
}

static void
objects_object_event_finalize (GObject * obj)
{
	ObjectsObjectEvent * self;
#line 22 "../core/Objects/ObjectEvent.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, OBJECTS_TYPE_OBJECT_EVENT, ObjectsObjectEvent);
#line 25 "../core/Objects/ObjectEvent.vala"
	_g_free0 (self->priv->_event_date);
#line 26 "../core/Objects/ObjectEvent.vala"
	_g_free0 (self->priv->_object_id);
#line 27 "../core/Objects/ObjectEvent.vala"
	_g_free0 (self->priv->_object_type);
#line 29 "../core/Objects/ObjectEvent.vala"
	_g_free0 (self->priv->_object_old_value);
#line 30 "../core/Objects/ObjectEvent.vala"
	_g_free0 (self->priv->_object_new_value);
#line 31 "../core/Objects/ObjectEvent.vala"
	_g_free0 (self->priv->_parent_item_id);
#line 32 "../core/Objects/ObjectEvent.vala"
	_g_free0 (self->priv->_parent_project_id);
#line 62 "../core/Objects/ObjectEvent.vala"
	_g_date_time_unref0 (self->priv->_datetime);
#line 70 "../core/Objects/ObjectEvent.vala"
	_g_date_time_unref0 (self->priv->_date);
#line 78 "../core/Objects/ObjectEvent.vala"
	_g_free0 (self->priv->_time);
#line 22 "../core/Objects/ObjectEvent.vala"
	G_OBJECT_CLASS (objects_object_event_parent_class)->finalize (obj);
#line 1160 "ObjectEvent.c"
}

static GType
objects_object_event_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ObjectsObjectEventClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) objects_object_event_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ObjectsObjectEvent), 0, (GInstanceInitFunc) objects_object_event_instance_init, NULL };
	GType objects_object_event_type_id;
	objects_object_event_type_id = g_type_register_static (G_TYPE_OBJECT, "ObjectsObjectEvent", &g_define_type_info, 0);
	ObjectsObjectEvent_private_offset = g_type_add_instance_private (objects_object_event_type_id, sizeof (ObjectsObjectEventPrivate));
	return objects_object_event_type_id;
}

GType
objects_object_event_get_type (void)
{
	static volatile gsize objects_object_event_type_id__once = 0;
	if (g_once_init_enter (&objects_object_event_type_id__once)) {
		GType objects_object_event_type_id;
		objects_object_event_type_id = objects_object_event_get_type_once ();
		g_once_init_leave (&objects_object_event_type_id__once, objects_object_event_type_id);
	}
	return objects_object_event_type_id__once;
}

static void
_vala_objects_object_event_get_property (GObject * object,
                                         guint property_id,
                                         GValue * value,
                                         GParamSpec * pspec)
{
	ObjectsObjectEvent * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, OBJECTS_TYPE_OBJECT_EVENT, ObjectsObjectEvent);
#line 22 "../core/Objects/ObjectEvent.vala"
	switch (property_id) {
#line 22 "../core/Objects/ObjectEvent.vala"
		case OBJECTS_OBJECT_EVENT_ID_PROPERTY:
#line 22 "../core/Objects/ObjectEvent.vala"
		g_value_set_int64 (value, objects_object_event_get_id (self));
#line 22 "../core/Objects/ObjectEvent.vala"
		break;
#line 22 "../core/Objects/ObjectEvent.vala"
		case OBJECTS_OBJECT_EVENT_EVENT_TYPE_PROPERTY:
#line 22 "../core/Objects/ObjectEvent.vala"
		g_value_set_enum (value, objects_object_event_get_event_type (self));
#line 22 "../core/Objects/ObjectEvent.vala"
		break;
#line 22 "../core/Objects/ObjectEvent.vala"
		case OBJECTS_OBJECT_EVENT_EVENT_DATE_PROPERTY:
#line 22 "../core/Objects/ObjectEvent.vala"
		g_value_set_string (value, objects_object_event_get_event_date (self));
#line 22 "../core/Objects/ObjectEvent.vala"
		break;
#line 22 "../core/Objects/ObjectEvent.vala"
		case OBJECTS_OBJECT_EVENT_OBJECT_ID_PROPERTY:
#line 22 "../core/Objects/ObjectEvent.vala"
		g_value_set_string (value, objects_object_event_get_object_id (self));
#line 22 "../core/Objects/ObjectEvent.vala"
		break;
#line 22 "../core/Objects/ObjectEvent.vala"
		case OBJECTS_OBJECT_EVENT_OBJECT_TYPE_PROPERTY:
#line 22 "../core/Objects/ObjectEvent.vala"
		g_value_set_string (value, objects_object_event_get_object_type (self));
#line 22 "../core/Objects/ObjectEvent.vala"
		break;
#line 22 "../core/Objects/ObjectEvent.vala"
		case OBJECTS_OBJECT_EVENT_OBJECT_KEY_PROPERTY:
#line 22 "../core/Objects/ObjectEvent.vala"
		g_value_set_enum (value, objects_object_event_get_object_key (self));
#line 22 "../core/Objects/ObjectEvent.vala"
		break;
#line 22 "../core/Objects/ObjectEvent.vala"
		case OBJECTS_OBJECT_EVENT_OBJECT_OLD_VALUE_PROPERTY:
#line 22 "../core/Objects/ObjectEvent.vala"
		g_value_set_string (value, objects_object_event_get_object_old_value (self));
#line 22 "../core/Objects/ObjectEvent.vala"
		break;
#line 22 "../core/Objects/ObjectEvent.vala"
		case OBJECTS_OBJECT_EVENT_OBJECT_NEW_VALUE_PROPERTY:
#line 22 "../core/Objects/ObjectEvent.vala"
		g_value_set_string (value, objects_object_event_get_object_new_value (self));
#line 22 "../core/Objects/ObjectEvent.vala"
		break;
#line 22 "../core/Objects/ObjectEvent.vala"
		case OBJECTS_OBJECT_EVENT_PARENT_ITEM_ID_PROPERTY:
#line 22 "../core/Objects/ObjectEvent.vala"
		g_value_set_string (value, objects_object_event_get_parent_item_id (self));
#line 22 "../core/Objects/ObjectEvent.vala"
		break;
#line 22 "../core/Objects/ObjectEvent.vala"
		case OBJECTS_OBJECT_EVENT_PARENT_PROJECT_ID_PROPERTY:
#line 22 "../core/Objects/ObjectEvent.vala"
		g_value_set_string (value, objects_object_event_get_parent_project_id (self));
#line 22 "../core/Objects/ObjectEvent.vala"
		break;
#line 22 "../core/Objects/ObjectEvent.vala"
		case OBJECTS_OBJECT_EVENT_ICON_NAME_PROPERTY:
#line 22 "../core/Objects/ObjectEvent.vala"
		g_value_set_string (value, objects_object_event_get_icon_name (self));
#line 22 "../core/Objects/ObjectEvent.vala"
		break;
#line 22 "../core/Objects/ObjectEvent.vala"
		case OBJECTS_OBJECT_EVENT_DATETIME_PROPERTY:
#line 22 "../core/Objects/ObjectEvent.vala"
		g_value_set_boxed (value, objects_object_event_get_datetime (self));
#line 22 "../core/Objects/ObjectEvent.vala"
		break;
#line 22 "../core/Objects/ObjectEvent.vala"
		case OBJECTS_OBJECT_EVENT_DATE_PROPERTY:
#line 22 "../core/Objects/ObjectEvent.vala"
		g_value_set_boxed (value, objects_object_event_get_date (self));
#line 22 "../core/Objects/ObjectEvent.vala"
		break;
#line 22 "../core/Objects/ObjectEvent.vala"
		case OBJECTS_OBJECT_EVENT_TIME_PROPERTY:
#line 22 "../core/Objects/ObjectEvent.vala"
		g_value_set_string (value, objects_object_event_get_time (self));
#line 22 "../core/Objects/ObjectEvent.vala"
		break;
#line 1279 "ObjectEvent.c"
		default:
#line 22 "../core/Objects/ObjectEvent.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 22 "../core/Objects/ObjectEvent.vala"
		break;
#line 1285 "ObjectEvent.c"
	}
}

static void
_vala_objects_object_event_set_property (GObject * object,
                                         guint property_id,
                                         const GValue * value,
                                         GParamSpec * pspec)
{
	ObjectsObjectEvent * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, OBJECTS_TYPE_OBJECT_EVENT, ObjectsObjectEvent);
#line 22 "../core/Objects/ObjectEvent.vala"
	switch (property_id) {
#line 22 "../core/Objects/ObjectEvent.vala"
		case OBJECTS_OBJECT_EVENT_ID_PROPERTY:
#line 22 "../core/Objects/ObjectEvent.vala"
		objects_object_event_set_id (self, g_value_get_int64 (value));
#line 22 "../core/Objects/ObjectEvent.vala"
		break;
#line 22 "../core/Objects/ObjectEvent.vala"
		case OBJECTS_OBJECT_EVENT_EVENT_TYPE_PROPERTY:
#line 22 "../core/Objects/ObjectEvent.vala"
		objects_object_event_set_event_type (self, g_value_get_enum (value));
#line 22 "../core/Objects/ObjectEvent.vala"
		break;
#line 22 "../core/Objects/ObjectEvent.vala"
		case OBJECTS_OBJECT_EVENT_EVENT_DATE_PROPERTY:
#line 22 "../core/Objects/ObjectEvent.vala"
		objects_object_event_set_event_date (self, g_value_get_string (value));
#line 22 "../core/Objects/ObjectEvent.vala"
		break;
#line 22 "../core/Objects/ObjectEvent.vala"
		case OBJECTS_OBJECT_EVENT_OBJECT_ID_PROPERTY:
#line 22 "../core/Objects/ObjectEvent.vala"
		objects_object_event_set_object_id (self, g_value_get_string (value));
#line 22 "../core/Objects/ObjectEvent.vala"
		break;
#line 22 "../core/Objects/ObjectEvent.vala"
		case OBJECTS_OBJECT_EVENT_OBJECT_TYPE_PROPERTY:
#line 22 "../core/Objects/ObjectEvent.vala"
		objects_object_event_set_object_type (self, g_value_get_string (value));
#line 22 "../core/Objects/ObjectEvent.vala"
		break;
#line 22 "../core/Objects/ObjectEvent.vala"
		case OBJECTS_OBJECT_EVENT_OBJECT_KEY_PROPERTY:
#line 22 "../core/Objects/ObjectEvent.vala"
		objects_object_event_set_object_key (self, g_value_get_enum (value));
#line 22 "../core/Objects/ObjectEvent.vala"
		break;
#line 22 "../core/Objects/ObjectEvent.vala"
		case OBJECTS_OBJECT_EVENT_OBJECT_OLD_VALUE_PROPERTY:
#line 22 "../core/Objects/ObjectEvent.vala"
		objects_object_event_set_object_old_value (self, g_value_get_string (value));
#line 22 "../core/Objects/ObjectEvent.vala"
		break;
#line 22 "../core/Objects/ObjectEvent.vala"
		case OBJECTS_OBJECT_EVENT_OBJECT_NEW_VALUE_PROPERTY:
#line 22 "../core/Objects/ObjectEvent.vala"
		objects_object_event_set_object_new_value (self, g_value_get_string (value));
#line 22 "../core/Objects/ObjectEvent.vala"
		break;
#line 22 "../core/Objects/ObjectEvent.vala"
		case OBJECTS_OBJECT_EVENT_PARENT_ITEM_ID_PROPERTY:
#line 22 "../core/Objects/ObjectEvent.vala"
		objects_object_event_set_parent_item_id (self, g_value_get_string (value));
#line 22 "../core/Objects/ObjectEvent.vala"
		break;
#line 22 "../core/Objects/ObjectEvent.vala"
		case OBJECTS_OBJECT_EVENT_PARENT_PROJECT_ID_PROPERTY:
#line 22 "../core/Objects/ObjectEvent.vala"
		objects_object_event_set_parent_project_id (self, g_value_get_string (value));
#line 22 "../core/Objects/ObjectEvent.vala"
		break;
#line 1359 "ObjectEvent.c"
		default:
#line 22 "../core/Objects/ObjectEvent.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 22 "../core/Objects/ObjectEvent.vala"
		break;
#line 1365 "ObjectEvent.c"
	}
}

