/* Queue.c generated by valac 0.56.18, the Vala compiler
 * generated from Queue.vala, do not modify */

/*
* Copyright © 2023 Alain M. (https://github.com/alainm23/planify)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 3 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*
* Authored by: Alain M. <alainmh23@gmail.com>
*/

#include "planify.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <glib-object.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	OBJECTS_QUEUE_0_PROPERTY,
	OBJECTS_QUEUE_UUID_PROPERTY,
	OBJECTS_QUEUE_OBJECT_ID_PROPERTY,
	OBJECTS_QUEUE_TEMP_ID_PROPERTY,
	OBJECTS_QUEUE_QUERY_PROPERTY,
	OBJECTS_QUEUE_ARGS_PROPERTY,
	OBJECTS_QUEUE_DATE_ADDED_PROPERTY,
	OBJECTS_QUEUE_NUM_PROPERTIES
};
static GParamSpec* objects_queue_properties[OBJECTS_QUEUE_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))

struct _ObjectsQueuePrivate {
	gchar* _uuid;
	gchar* _object_id;
	gchar* _temp_id;
	gchar* _query;
	gchar* _args;
	gchar* _date_added;
};

static gint ObjectsQueue_private_offset;
static gpointer objects_queue_parent_class = NULL;

static void objects_queue_finalize (GObject * obj);
static GType objects_queue_get_type_once (void);
static void _vala_objects_queue_get_property (GObject * object,
                                       guint property_id,
                                       GValue * value,
                                       GParamSpec * pspec);
static void _vala_objects_queue_set_property (GObject * object,
                                       guint property_id,
                                       const GValue * value,
                                       GParamSpec * pspec);

static inline gpointer
objects_queue_get_instance_private (ObjectsQueue* self)
{
	return G_STRUCT_MEMBER_P (self, ObjectsQueue_private_offset);
}

static gchar*
g_date_time_to_string (GDateTime* self)
{
	gchar* _tmp0_;
	gchar* result;
#line 3410 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 3411 "glib-2.0.vapi"
	_tmp0_ = g_date_time_format (self, "%FT%H:%M:%S%z");
#line 3411 "glib-2.0.vapi"
	result = _tmp0_;
#line 3411 "glib-2.0.vapi"
	return result;
#line 97 "Queue.c"
}

ObjectsQueue*
objects_queue_construct (GType object_type)
{
	ObjectsQueue * self = NULL;
#line 22 "../core/Objects/Queue.vala"
	self = (ObjectsQueue*) g_object_new (object_type, NULL);
#line 22 "../core/Objects/Queue.vala"
	return self;
#line 108 "Queue.c"
}

ObjectsQueue*
objects_queue_new (void)
{
#line 22 "../core/Objects/Queue.vala"
	return objects_queue_construct (OBJECTS_TYPE_QUEUE);
#line 116 "Queue.c"
}

const gchar*
objects_queue_get_uuid (ObjectsQueue* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 23 "../core/Objects/Queue.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 23 "../core/Objects/Queue.vala"
	_tmp0_ = self->priv->_uuid;
#line 23 "../core/Objects/Queue.vala"
	result = _tmp0_;
#line 23 "../core/Objects/Queue.vala"
	return result;
#line 132 "Queue.c"
}

void
objects_queue_set_uuid (ObjectsQueue* self,
                        const gchar* value)
{
	gchar* old_value;
#line 23 "../core/Objects/Queue.vala"
	g_return_if_fail (self != NULL);
#line 23 "../core/Objects/Queue.vala"
	old_value = objects_queue_get_uuid (self);
#line 23 "../core/Objects/Queue.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 146 "Queue.c"
		gchar* _tmp0_;
#line 23 "../core/Objects/Queue.vala"
		_tmp0_ = g_strdup (value);
#line 23 "../core/Objects/Queue.vala"
		_g_free0 (self->priv->_uuid);
#line 23 "../core/Objects/Queue.vala"
		self->priv->_uuid = _tmp0_;
#line 23 "../core/Objects/Queue.vala"
		g_object_notify_by_pspec ((GObject *) self, objects_queue_properties[OBJECTS_QUEUE_UUID_PROPERTY]);
#line 156 "Queue.c"
	}
}

const gchar*
objects_queue_get_object_id (ObjectsQueue* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 24 "../core/Objects/Queue.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 24 "../core/Objects/Queue.vala"
	_tmp0_ = self->priv->_object_id;
#line 24 "../core/Objects/Queue.vala"
	result = _tmp0_;
#line 24 "../core/Objects/Queue.vala"
	return result;
#line 173 "Queue.c"
}

void
objects_queue_set_object_id (ObjectsQueue* self,
                             const gchar* value)
{
	gchar* old_value;
#line 24 "../core/Objects/Queue.vala"
	g_return_if_fail (self != NULL);
#line 24 "../core/Objects/Queue.vala"
	old_value = objects_queue_get_object_id (self);
#line 24 "../core/Objects/Queue.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 187 "Queue.c"
		gchar* _tmp0_;
#line 24 "../core/Objects/Queue.vala"
		_tmp0_ = g_strdup (value);
#line 24 "../core/Objects/Queue.vala"
		_g_free0 (self->priv->_object_id);
#line 24 "../core/Objects/Queue.vala"
		self->priv->_object_id = _tmp0_;
#line 24 "../core/Objects/Queue.vala"
		g_object_notify_by_pspec ((GObject *) self, objects_queue_properties[OBJECTS_QUEUE_OBJECT_ID_PROPERTY]);
#line 197 "Queue.c"
	}
}

const gchar*
objects_queue_get_temp_id (ObjectsQueue* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 25 "../core/Objects/Queue.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 25 "../core/Objects/Queue.vala"
	_tmp0_ = self->priv->_temp_id;
#line 25 "../core/Objects/Queue.vala"
	result = _tmp0_;
#line 25 "../core/Objects/Queue.vala"
	return result;
#line 214 "Queue.c"
}

void
objects_queue_set_temp_id (ObjectsQueue* self,
                           const gchar* value)
{
	gchar* old_value;
#line 25 "../core/Objects/Queue.vala"
	g_return_if_fail (self != NULL);
#line 25 "../core/Objects/Queue.vala"
	old_value = objects_queue_get_temp_id (self);
#line 25 "../core/Objects/Queue.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 228 "Queue.c"
		gchar* _tmp0_;
#line 25 "../core/Objects/Queue.vala"
		_tmp0_ = g_strdup (value);
#line 25 "../core/Objects/Queue.vala"
		_g_free0 (self->priv->_temp_id);
#line 25 "../core/Objects/Queue.vala"
		self->priv->_temp_id = _tmp0_;
#line 25 "../core/Objects/Queue.vala"
		g_object_notify_by_pspec ((GObject *) self, objects_queue_properties[OBJECTS_QUEUE_TEMP_ID_PROPERTY]);
#line 238 "Queue.c"
	}
}

const gchar*
objects_queue_get_query (ObjectsQueue* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 26 "../core/Objects/Queue.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 26 "../core/Objects/Queue.vala"
	_tmp0_ = self->priv->_query;
#line 26 "../core/Objects/Queue.vala"
	result = _tmp0_;
#line 26 "../core/Objects/Queue.vala"
	return result;
#line 255 "Queue.c"
}

void
objects_queue_set_query (ObjectsQueue* self,
                         const gchar* value)
{
	gchar* old_value;
#line 26 "../core/Objects/Queue.vala"
	g_return_if_fail (self != NULL);
#line 26 "../core/Objects/Queue.vala"
	old_value = objects_queue_get_query (self);
#line 26 "../core/Objects/Queue.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 269 "Queue.c"
		gchar* _tmp0_;
#line 26 "../core/Objects/Queue.vala"
		_tmp0_ = g_strdup (value);
#line 26 "../core/Objects/Queue.vala"
		_g_free0 (self->priv->_query);
#line 26 "../core/Objects/Queue.vala"
		self->priv->_query = _tmp0_;
#line 26 "../core/Objects/Queue.vala"
		g_object_notify_by_pspec ((GObject *) self, objects_queue_properties[OBJECTS_QUEUE_QUERY_PROPERTY]);
#line 279 "Queue.c"
	}
}

const gchar*
objects_queue_get_args (ObjectsQueue* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 27 "../core/Objects/Queue.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 27 "../core/Objects/Queue.vala"
	_tmp0_ = self->priv->_args;
#line 27 "../core/Objects/Queue.vala"
	result = _tmp0_;
#line 27 "../core/Objects/Queue.vala"
	return result;
#line 296 "Queue.c"
}

void
objects_queue_set_args (ObjectsQueue* self,
                        const gchar* value)
{
	gchar* old_value;
#line 27 "../core/Objects/Queue.vala"
	g_return_if_fail (self != NULL);
#line 27 "../core/Objects/Queue.vala"
	old_value = objects_queue_get_args (self);
#line 27 "../core/Objects/Queue.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 310 "Queue.c"
		gchar* _tmp0_;
#line 27 "../core/Objects/Queue.vala"
		_tmp0_ = g_strdup (value);
#line 27 "../core/Objects/Queue.vala"
		_g_free0 (self->priv->_args);
#line 27 "../core/Objects/Queue.vala"
		self->priv->_args = _tmp0_;
#line 27 "../core/Objects/Queue.vala"
		g_object_notify_by_pspec ((GObject *) self, objects_queue_properties[OBJECTS_QUEUE_ARGS_PROPERTY]);
#line 320 "Queue.c"
	}
}

const gchar*
objects_queue_get_date_added (ObjectsQueue* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 28 "../core/Objects/Queue.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 28 "../core/Objects/Queue.vala"
	_tmp0_ = self->priv->_date_added;
#line 28 "../core/Objects/Queue.vala"
	result = _tmp0_;
#line 28 "../core/Objects/Queue.vala"
	return result;
#line 337 "Queue.c"
}

void
objects_queue_set_date_added (ObjectsQueue* self,
                              const gchar* value)
{
	gchar* old_value;
#line 28 "../core/Objects/Queue.vala"
	g_return_if_fail (self != NULL);
#line 28 "../core/Objects/Queue.vala"
	old_value = objects_queue_get_date_added (self);
#line 28 "../core/Objects/Queue.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 351 "Queue.c"
		gchar* _tmp0_;
#line 28 "../core/Objects/Queue.vala"
		_tmp0_ = g_strdup (value);
#line 28 "../core/Objects/Queue.vala"
		_g_free0 (self->priv->_date_added);
#line 28 "../core/Objects/Queue.vala"
		self->priv->_date_added = _tmp0_;
#line 28 "../core/Objects/Queue.vala"
		g_object_notify_by_pspec ((GObject *) self, objects_queue_properties[OBJECTS_QUEUE_DATE_ADDED_PROPERTY]);
#line 361 "Queue.c"
	}
}

static void
objects_queue_class_init (ObjectsQueueClass * klass,
                          gpointer klass_data)
{
#line 22 "../core/Objects/Queue.vala"
	objects_queue_parent_class = g_type_class_peek_parent (klass);
#line 22 "../core/Objects/Queue.vala"
	g_type_class_adjust_private_offset (klass, &ObjectsQueue_private_offset);
#line 22 "../core/Objects/Queue.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_objects_queue_get_property;
#line 22 "../core/Objects/Queue.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_objects_queue_set_property;
#line 22 "../core/Objects/Queue.vala"
	G_OBJECT_CLASS (klass)->finalize = objects_queue_finalize;
#line 22 "../core/Objects/Queue.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), OBJECTS_QUEUE_UUID_PROPERTY, objects_queue_properties[OBJECTS_QUEUE_UUID_PROPERTY] = g_param_spec_string ("uuid", "uuid", "uuid", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 22 "../core/Objects/Queue.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), OBJECTS_QUEUE_OBJECT_ID_PROPERTY, objects_queue_properties[OBJECTS_QUEUE_OBJECT_ID_PROPERTY] = g_param_spec_string ("object-id", "object-id", "object-id", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 22 "../core/Objects/Queue.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), OBJECTS_QUEUE_TEMP_ID_PROPERTY, objects_queue_properties[OBJECTS_QUEUE_TEMP_ID_PROPERTY] = g_param_spec_string ("temp-id", "temp-id", "temp-id", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 22 "../core/Objects/Queue.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), OBJECTS_QUEUE_QUERY_PROPERTY, objects_queue_properties[OBJECTS_QUEUE_QUERY_PROPERTY] = g_param_spec_string ("query", "query", "query", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 22 "../core/Objects/Queue.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), OBJECTS_QUEUE_ARGS_PROPERTY, objects_queue_properties[OBJECTS_QUEUE_ARGS_PROPERTY] = g_param_spec_string ("args", "args", "args", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 22 "../core/Objects/Queue.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), OBJECTS_QUEUE_DATE_ADDED_PROPERTY, objects_queue_properties[OBJECTS_QUEUE_DATE_ADDED_PROPERTY] = g_param_spec_string ("date-added", "date-added", "date-added", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 391 "Queue.c"
}

static void
objects_queue_instance_init (ObjectsQueue * self,
                             gpointer klass)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	GDateTime* _tmp5_;
	GDateTime* _tmp6_;
	gchar* _tmp7_;
#line 22 "../core/Objects/Queue.vala"
	self->priv = objects_queue_get_instance_private (self);
#line 23 "../core/Objects/Queue.vala"
	_tmp0_ = g_strdup ("");
#line 23 "../core/Objects/Queue.vala"
	self->priv->_uuid = _tmp0_;
#line 24 "../core/Objects/Queue.vala"
	_tmp1_ = g_strdup ("");
#line 24 "../core/Objects/Queue.vala"
	self->priv->_object_id = _tmp1_;
#line 25 "../core/Objects/Queue.vala"
	_tmp2_ = g_strdup ("");
#line 25 "../core/Objects/Queue.vala"
	self->priv->_temp_id = _tmp2_;
#line 26 "../core/Objects/Queue.vala"
	_tmp3_ = g_strdup ("");
#line 26 "../core/Objects/Queue.vala"
	self->priv->_query = _tmp3_;
#line 27 "../core/Objects/Queue.vala"
	_tmp4_ = g_strdup ("");
#line 27 "../core/Objects/Queue.vala"
	self->priv->_args = _tmp4_;
#line 28 "../core/Objects/Queue.vala"
	_tmp5_ = g_date_time_new_now_local ();
#line 28 "../core/Objects/Queue.vala"
	_tmp6_ = _tmp5_;
#line 28 "../core/Objects/Queue.vala"
	_tmp7_ = g_date_time_to_string (_tmp6_);
#line 28 "../core/Objects/Queue.vala"
	self->priv->_date_added = _tmp7_;
#line 28 "../core/Objects/Queue.vala"
	_g_date_time_unref0 (_tmp6_);
#line 438 "Queue.c"
}

static void
objects_queue_finalize (GObject * obj)
{
	ObjectsQueue * self;
#line 22 "../core/Objects/Queue.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, OBJECTS_TYPE_QUEUE, ObjectsQueue);
#line 23 "../core/Objects/Queue.vala"
	_g_free0 (self->priv->_uuid);
#line 24 "../core/Objects/Queue.vala"
	_g_free0 (self->priv->_object_id);
#line 25 "../core/Objects/Queue.vala"
	_g_free0 (self->priv->_temp_id);
#line 26 "../core/Objects/Queue.vala"
	_g_free0 (self->priv->_query);
#line 27 "../core/Objects/Queue.vala"
	_g_free0 (self->priv->_args);
#line 28 "../core/Objects/Queue.vala"
	_g_free0 (self->priv->_date_added);
#line 22 "../core/Objects/Queue.vala"
	G_OBJECT_CLASS (objects_queue_parent_class)->finalize (obj);
#line 461 "Queue.c"
}

static GType
objects_queue_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ObjectsQueueClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) objects_queue_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ObjectsQueue), 0, (GInstanceInitFunc) objects_queue_instance_init, NULL };
	GType objects_queue_type_id;
	objects_queue_type_id = g_type_register_static (G_TYPE_OBJECT, "ObjectsQueue", &g_define_type_info, 0);
	ObjectsQueue_private_offset = g_type_add_instance_private (objects_queue_type_id, sizeof (ObjectsQueuePrivate));
	return objects_queue_type_id;
}

GType
objects_queue_get_type (void)
{
	static volatile gsize objects_queue_type_id__once = 0;
	if (g_once_init_enter (&objects_queue_type_id__once)) {
		GType objects_queue_type_id;
		objects_queue_type_id = objects_queue_get_type_once ();
		g_once_init_leave (&objects_queue_type_id__once, objects_queue_type_id);
	}
	return objects_queue_type_id__once;
}

static void
_vala_objects_queue_get_property (GObject * object,
                                  guint property_id,
                                  GValue * value,
                                  GParamSpec * pspec)
{
	ObjectsQueue * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, OBJECTS_TYPE_QUEUE, ObjectsQueue);
#line 22 "../core/Objects/Queue.vala"
	switch (property_id) {
#line 22 "../core/Objects/Queue.vala"
		case OBJECTS_QUEUE_UUID_PROPERTY:
#line 22 "../core/Objects/Queue.vala"
		g_value_set_string (value, objects_queue_get_uuid (self));
#line 22 "../core/Objects/Queue.vala"
		break;
#line 22 "../core/Objects/Queue.vala"
		case OBJECTS_QUEUE_OBJECT_ID_PROPERTY:
#line 22 "../core/Objects/Queue.vala"
		g_value_set_string (value, objects_queue_get_object_id (self));
#line 22 "../core/Objects/Queue.vala"
		break;
#line 22 "../core/Objects/Queue.vala"
		case OBJECTS_QUEUE_TEMP_ID_PROPERTY:
#line 22 "../core/Objects/Queue.vala"
		g_value_set_string (value, objects_queue_get_temp_id (self));
#line 22 "../core/Objects/Queue.vala"
		break;
#line 22 "../core/Objects/Queue.vala"
		case OBJECTS_QUEUE_QUERY_PROPERTY:
#line 22 "../core/Objects/Queue.vala"
		g_value_set_string (value, objects_queue_get_query (self));
#line 22 "../core/Objects/Queue.vala"
		break;
#line 22 "../core/Objects/Queue.vala"
		case OBJECTS_QUEUE_ARGS_PROPERTY:
#line 22 "../core/Objects/Queue.vala"
		g_value_set_string (value, objects_queue_get_args (self));
#line 22 "../core/Objects/Queue.vala"
		break;
#line 22 "../core/Objects/Queue.vala"
		case OBJECTS_QUEUE_DATE_ADDED_PROPERTY:
#line 22 "../core/Objects/Queue.vala"
		g_value_set_string (value, objects_queue_get_date_added (self));
#line 22 "../core/Objects/Queue.vala"
		break;
#line 532 "Queue.c"
		default:
#line 22 "../core/Objects/Queue.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 22 "../core/Objects/Queue.vala"
		break;
#line 538 "Queue.c"
	}
}

static void
_vala_objects_queue_set_property (GObject * object,
                                  guint property_id,
                                  const GValue * value,
                                  GParamSpec * pspec)
{
	ObjectsQueue * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, OBJECTS_TYPE_QUEUE, ObjectsQueue);
#line 22 "../core/Objects/Queue.vala"
	switch (property_id) {
#line 22 "../core/Objects/Queue.vala"
		case OBJECTS_QUEUE_UUID_PROPERTY:
#line 22 "../core/Objects/Queue.vala"
		objects_queue_set_uuid (self, g_value_get_string (value));
#line 22 "../core/Objects/Queue.vala"
		break;
#line 22 "../core/Objects/Queue.vala"
		case OBJECTS_QUEUE_OBJECT_ID_PROPERTY:
#line 22 "../core/Objects/Queue.vala"
		objects_queue_set_object_id (self, g_value_get_string (value));
#line 22 "../core/Objects/Queue.vala"
		break;
#line 22 "../core/Objects/Queue.vala"
		case OBJECTS_QUEUE_TEMP_ID_PROPERTY:
#line 22 "../core/Objects/Queue.vala"
		objects_queue_set_temp_id (self, g_value_get_string (value));
#line 22 "../core/Objects/Queue.vala"
		break;
#line 22 "../core/Objects/Queue.vala"
		case OBJECTS_QUEUE_QUERY_PROPERTY:
#line 22 "../core/Objects/Queue.vala"
		objects_queue_set_query (self, g_value_get_string (value));
#line 22 "../core/Objects/Queue.vala"
		break;
#line 22 "../core/Objects/Queue.vala"
		case OBJECTS_QUEUE_ARGS_PROPERTY:
#line 22 "../core/Objects/Queue.vala"
		objects_queue_set_args (self, g_value_get_string (value));
#line 22 "../core/Objects/Queue.vala"
		break;
#line 22 "../core/Objects/Queue.vala"
		case OBJECTS_QUEUE_DATE_ADDED_PROPERTY:
#line 22 "../core/Objects/Queue.vala"
		objects_queue_set_date_added (self, g_value_get_string (value));
#line 22 "../core/Objects/Queue.vala"
		break;
#line 588 "Queue.c"
		default:
#line 22 "../core/Objects/Queue.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 22 "../core/Objects/Queue.vala"
		break;
#line 594 "Queue.c"
	}
}

