/* Source.c generated by valac 0.56.18, the Vala compiler
 * generated from Source.vala, do not modify */

/*
 * Copyright © 2023 Alain M. (https://github.com/alainm23/planify)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA
 *
 * Authored by: Alain M. <alainmh23@gmail.com>
 */

#include "planify.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <glib-object.h>
#include <json-glib/json-glib.h>
#include <gtk/gtk.h>
#include <adwaita.h>
#include <glib/gi18n-lib.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	OBJECTS_SOURCE_0_PROPERTY,
	OBJECTS_SOURCE_SOURCE_TYPE_PROPERTY,
	OBJECTS_SOURCE_ADDED_AT_PROPERTY,
	OBJECTS_SOURCE_UPDATED_AT_PROPERTY,
	OBJECTS_SOURCE_IS_VISIBLE_PROPERTY,
	OBJECTS_SOURCE_CHILD_ORDER_PROPERTY,
	OBJECTS_SOURCE_SYNC_SERVER_PROPERTY,
	OBJECTS_SOURCE_LAST_SYNC_PROPERTY,
	OBJECTS_SOURCE_DATA_PROPERTY,
	OBJECTS_SOURCE_DISPLAY_NAME_PROPERTY,
	OBJECTS_SOURCE_TODOIST_DATA_PROPERTY,
	OBJECTS_SOURCE_CALDAV_DATA_PROPERTY,
	OBJECTS_SOURCE_HEADER_TEXT_PROPERTY,
	OBJECTS_SOURCE_SUBHEADER_TEXT_PROPERTY,
	OBJECTS_SOURCE_AVATAR_PATH_PROPERTY,
	OBJECTS_SOURCE_USER_DISPLAYNAME_PROPERTY,
	OBJECTS_SOURCE_USER_EMAIL_PROPERTY,
	OBJECTS_SOURCE_NUM_PROPERTIES
};
static GParamSpec* objects_source_properties[OBJECTS_SOURCE_NUM_PROPERTIES];
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
enum  {
	OBJECTS_SOURCE_SYNC_STARTED_SIGNAL,
	OBJECTS_SOURCE_SYNC_FINISHED_SIGNAL,
	OBJECTS_SOURCE_SYNC_FAILED_SIGNAL,
	OBJECTS_SOURCE_NUM_SIGNALS
};
static guint objects_source_signals[OBJECTS_SOURCE_NUM_SIGNALS] = {0};
enum  {
	OBJECTS_SOURCE_DATA_0_PROPERTY,
	OBJECTS_SOURCE_DATA_BUILDER_PROPERTY,
	OBJECTS_SOURCE_DATA_NUM_PROPERTIES
};
static GParamSpec* objects_source_data_properties[OBJECTS_SOURCE_DATA_NUM_PROPERTIES];
enum  {
	OBJECTS_SOURCE_TODOIST_DATA_0_PROPERTY,
	OBJECTS_SOURCE_TODOIST_DATA_ACCESS_TOKEN_PROPERTY,
	OBJECTS_SOURCE_TODOIST_DATA_SYNC_TOKEN_PROPERTY,
	OBJECTS_SOURCE_TODOIST_DATA_USER_IMAGE_ID_PROPERTY,
	OBJECTS_SOURCE_TODOIST_DATA_USER_EMAIL_PROPERTY,
	OBJECTS_SOURCE_TODOIST_DATA_USER_NAME_PROPERTY,
	OBJECTS_SOURCE_TODOIST_DATA_USER_AVATAR_PROPERTY,
	OBJECTS_SOURCE_TODOIST_DATA_USER_IS_PREMIUM_PROPERTY,
	OBJECTS_SOURCE_TODOIST_DATA_NUM_PROPERTIES
};
static GParamSpec* objects_source_todoist_data_properties[OBJECTS_SOURCE_TODOIST_DATA_NUM_PROPERTIES];
#define _json_object_unref0(var) ((var == NULL) ? NULL : (var = (json_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define __vala_JsonNode_free0(var) ((var == NULL) ? NULL : (var = (_vala_JsonNode_free (var), NULL)))
enum  {
	OBJECTS_SOURCE_CAL_DAV_DATA_0_PROPERTY,
	OBJECTS_SOURCE_CAL_DAV_DATA_SERVER_URL_PROPERTY,
	OBJECTS_SOURCE_CAL_DAV_DATA_USERNAME_PROPERTY,
	OBJECTS_SOURCE_CAL_DAV_DATA_CREDENTIALS_PROPERTY,
	OBJECTS_SOURCE_CAL_DAV_DATA_USER_DISPLAYNAME_PROPERTY,
	OBJECTS_SOURCE_CAL_DAV_DATA_USER_EMAIL_PROPERTY,
	OBJECTS_SOURCE_CAL_DAV_DATA_CALDAV_TYPE_PROPERTY,
	OBJECTS_SOURCE_CAL_DAV_DATA_NUM_PROPERTIES
};
static GParamSpec* objects_source_cal_dav_data_properties[OBJECTS_SOURCE_CAL_DAV_DATA_NUM_PROPERTIES];

struct _ObjectsSourcePrivate {
	SourceType _source_type;
	gchar* _added_at;
	gchar* _updated_at;
	gboolean _is_visible;
	gint _child_order;
	gboolean _sync_server;
	gchar* _last_sync;
	ObjectsSourceData* _data;
	gchar* _display_name;
	ObjectsSourceTodoistData* _todoist_data;
	ObjectsSourceCalDAVData* _caldav_data;
	gchar* _subheader_text;
	guint server_timeout;
};

struct _ObjectsSourceDataPrivate {
	JsonBuilder* _builder;
};

struct _ObjectsSourceTodoistDataPrivate {
	gchar* _access_token;
	gchar* _sync_token;
	gchar* _user_image_id;
	gchar* _user_email;
	gchar* _user_name;
	gchar* _user_avatar;
	gboolean _user_is_premium;
};

struct _ObjectsSourceCalDAVDataPrivate {
	gchar* _server_url;
	gchar* _username;
	gchar* _credentials;
	gchar* _user_displayname;
	gchar* _user_email;
	CalDAVType _caldav_type;
};

static gint ObjectsSource_private_offset;
static gpointer objects_source_parent_class = NULL;
static gint ObjectsSourceData_private_offset;
static gpointer objects_source_data_parent_class = NULL;
static gint ObjectsSourceTodoistData_private_offset;
static gpointer objects_source_todoist_data_parent_class = NULL;
static gint ObjectsSourceCalDAVData_private_offset;
static gpointer objects_source_cal_dav_data_parent_class = NULL;

static void _objects_source_run_server (ObjectsSource* self);
static gboolean __lambda75_ (ObjectsSource* self);
static gboolean ___lambda75__gsource_func (gpointer self);
static void __lambda76_ (ObjectsSource* self,
                  const gchar* response);
static void _objects_source_delete_source (ObjectsSource* self);
static void ___lambda76__adw_alert_dialog_response (AdwAlertDialog* _sender,
                                             const gchar* response,
                                             gpointer self);
static void objects_source_finalize (GObject * obj);
static GType objects_source_get_type_once (void);
static void _vala_objects_source_get_property (GObject * object,
                                        guint property_id,
                                        GValue * value,
                                        GParamSpec * pspec);
static void _vala_objects_source_set_property (GObject * object,
                                        guint property_id,
                                        const GValue * value,
                                        GParamSpec * pspec);
static gchar* objects_source_data_real_to_json (ObjectsSourceData* self);
static void objects_source_data_finalize (GObject * obj);
static GType objects_source_data_get_type_once (void);
static void _vala_objects_source_data_get_property (GObject * object,
                                             guint property_id,
                                             GValue * value,
                                             GParamSpec * pspec);
static gchar* objects_source_todoist_data_real_to_json (ObjectsSourceData* base);
static void _vala_JsonNode_free (JsonNode* self);
static void objects_source_todoist_data_finalize (GObject * obj);
static GType objects_source_todoist_data_get_type_once (void);
static void _vala_objects_source_todoist_data_get_property (GObject * object,
                                                     guint property_id,
                                                     GValue * value,
                                                     GParamSpec * pspec);
static void _vala_objects_source_todoist_data_set_property (GObject * object,
                                                     guint property_id,
                                                     const GValue * value,
                                                     GParamSpec * pspec);
static gchar* objects_source_cal_dav_data_real_to_json (ObjectsSourceData* base);
static void objects_source_cal_dav_data_finalize (GObject * obj);
static GType objects_source_cal_dav_data_get_type_once (void);
static void _vala_objects_source_cal_dav_data_get_property (GObject * object,
                                                     guint property_id,
                                                     GValue * value,
                                                     GParamSpec * pspec);
static void _vala_objects_source_cal_dav_data_set_property (GObject * object,
                                                     guint property_id,
                                                     const GValue * value,
                                                     GParamSpec * pspec);

static inline gpointer
objects_source_get_instance_private (ObjectsSource* self)
{
	return G_STRUCT_MEMBER_P (self, ObjectsSource_private_offset);
}

static gchar*
g_date_time_to_string (GDateTime* self)
{
	gchar* _tmp0_;
	gchar* result;
#line 3410 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 3411 "glib-2.0.vapi"
	_tmp0_ = g_date_time_format (self, "%FT%H:%M:%S%z");
#line 3411 "glib-2.0.vapi"
	result = _tmp0_;
#line 3411 "glib-2.0.vapi"
	return result;
#line 226 "Source.c"
}

ObjectsSource*
objects_source_construct_from_import_json (GType object_type,
                                           JsonNode* node)
{
	ObjectsSource * self = NULL;
	JsonObject* _tmp0_;
	const gchar* _tmp1_;
	JsonObject* _tmp2_;
	const gchar* _tmp3_;
	JsonObject* _tmp4_;
	const gchar* _tmp5_;
	JsonObject* _tmp6_;
	const gchar* _tmp7_;
	JsonObject* _tmp8_;
	JsonObject* _tmp9_;
	JsonObject* _tmp10_;
	JsonObject* _tmp11_;
	const gchar* _tmp12_;
	JsonObject* _tmp13_;
	const gchar* _tmp14_;
	SourceType _tmp15_;
#line 111 "../core/Objects/Source.vala"
	g_return_val_if_fail (node != NULL, NULL);
#line 111 "../core/Objects/Source.vala"
	self = (ObjectsSource*) objects_base_object_construct (object_type);
#line 112 "../core/Objects/Source.vala"
	_tmp0_ = json_node_get_object (node);
#line 112 "../core/Objects/Source.vala"
	_tmp1_ = json_object_get_string_member (_tmp0_, "id");
#line 112 "../core/Objects/Source.vala"
	objects_base_object_set_id ((ObjectsBaseObject*) self, _tmp1_);
#line 113 "../core/Objects/Source.vala"
	_tmp2_ = json_node_get_object (node);
#line 113 "../core/Objects/Source.vala"
	_tmp3_ = json_object_get_string_member (_tmp2_, "source_type");
#line 113 "../core/Objects/Source.vala"
	objects_source_set_source_type (self, source_type_parse (_tmp3_));
#line 114 "../core/Objects/Source.vala"
	_tmp4_ = json_node_get_object (node);
#line 114 "../core/Objects/Source.vala"
	_tmp5_ = json_object_get_string_member (_tmp4_, "added_at");
#line 114 "../core/Objects/Source.vala"
	objects_source_set_added_at (self, _tmp5_);
#line 115 "../core/Objects/Source.vala"
	_tmp6_ = json_node_get_object (node);
#line 115 "../core/Objects/Source.vala"
	_tmp7_ = json_object_get_string_member (_tmp6_, "updated_at");
#line 115 "../core/Objects/Source.vala"
	objects_source_set_updated_at (self, _tmp7_);
#line 116 "../core/Objects/Source.vala"
	_tmp8_ = json_node_get_object (node);
#line 116 "../core/Objects/Source.vala"
	objects_source_set_is_visible (self, json_object_get_boolean_member (_tmp8_, "is_visible"));
#line 117 "../core/Objects/Source.vala"
	_tmp9_ = json_node_get_object (node);
#line 117 "../core/Objects/Source.vala"
	objects_source_set_child_order (self, (gint) ((gint32) json_object_get_int_member (_tmp9_, "is_visible")));
#line 118 "../core/Objects/Source.vala"
	_tmp10_ = json_node_get_object (node);
#line 118 "../core/Objects/Source.vala"
	objects_source_set_sync_server (self, json_object_get_boolean_member (_tmp10_, "sync_server"));
#line 119 "../core/Objects/Source.vala"
	_tmp11_ = json_node_get_object (node);
#line 119 "../core/Objects/Source.vala"
	_tmp12_ = json_object_get_string_member (_tmp11_, "last_sync");
#line 119 "../core/Objects/Source.vala"
	objects_source_set_last_sync (self, _tmp12_);
#line 120 "../core/Objects/Source.vala"
	_tmp13_ = json_node_get_object (node);
#line 120 "../core/Objects/Source.vala"
	_tmp14_ = json_object_get_string_member (_tmp13_, "display_name");
#line 120 "../core/Objects/Source.vala"
	objects_source_set_display_name (self, _tmp14_);
#line 122 "../core/Objects/Source.vala"
	_tmp15_ = self->priv->_source_type;
#line 122 "../core/Objects/Source.vala"
	if (_tmp15_ == SOURCE_TYPE_TODOIST) {
#line 306 "Source.c"
		JsonObject* _tmp16_;
		const gchar* _tmp17_;
		ObjectsSourceTodoistData* _tmp18_;
		ObjectsSourceTodoistData* _tmp19_;
#line 123 "../core/Objects/Source.vala"
		_tmp16_ = json_node_get_object (node);
#line 123 "../core/Objects/Source.vala"
		_tmp17_ = json_object_get_string_member (_tmp16_, "data");
#line 123 "../core/Objects/Source.vala"
		_tmp18_ = objects_source_todoist_data_new_from_json (_tmp17_);
#line 123 "../core/Objects/Source.vala"
		_tmp19_ = _tmp18_;
#line 123 "../core/Objects/Source.vala"
		objects_source_set_data (self, (ObjectsSourceData*) _tmp19_);
#line 123 "../core/Objects/Source.vala"
		_g_object_unref0 (_tmp19_);
#line 323 "Source.c"
	} else {
		SourceType _tmp20_;
#line 124 "../core/Objects/Source.vala"
		_tmp20_ = self->priv->_source_type;
#line 124 "../core/Objects/Source.vala"
		if (_tmp20_ == SOURCE_TYPE_CALDAV) {
#line 330 "Source.c"
			JsonObject* _tmp21_;
			const gchar* _tmp22_;
			ObjectsSourceCalDAVData* _tmp23_;
			ObjectsSourceCalDAVData* _tmp24_;
#line 125 "../core/Objects/Source.vala"
			_tmp21_ = json_node_get_object (node);
#line 125 "../core/Objects/Source.vala"
			_tmp22_ = json_object_get_string_member (_tmp21_, "data");
#line 125 "../core/Objects/Source.vala"
			_tmp23_ = objects_source_cal_dav_data_new_from_json (_tmp22_);
#line 125 "../core/Objects/Source.vala"
			_tmp24_ = _tmp23_;
#line 125 "../core/Objects/Source.vala"
			objects_source_set_data (self, (ObjectsSourceData*) _tmp24_);
#line 125 "../core/Objects/Source.vala"
			_g_object_unref0 (_tmp24_);
#line 347 "Source.c"
		}
	}
#line 111 "../core/Objects/Source.vala"
	return self;
#line 352 "Source.c"
}

ObjectsSource*
objects_source_new_from_import_json (JsonNode* node)
{
#line 111 "../core/Objects/Source.vala"
	return objects_source_construct_from_import_json (OBJECTS_TYPE_SOURCE, node);
#line 360 "Source.c"
}

static gboolean
__lambda75_ (ObjectsSource* self)
{
	gboolean _tmp0_;
	gboolean result;
#line 133 "../core/Objects/Source.vala"
	_tmp0_ = self->priv->_sync_server;
#line 133 "../core/Objects/Source.vala"
	if (_tmp0_) {
#line 134 "../core/Objects/Source.vala"
		_objects_source_run_server (self);
#line 374 "Source.c"
	}
#line 137 "../core/Objects/Source.vala"
	result = TRUE;
#line 137 "../core/Objects/Source.vala"
	return result;
#line 380 "Source.c"
}

static gboolean
___lambda75__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda75_ ((ObjectsSource*) self);
#line 132 "../core/Objects/Source.vala"
	return result;
#line 390 "Source.c"
}

void
objects_source_run_server (ObjectsSource* self)
{
#line 129 "../core/Objects/Source.vala"
	g_return_if_fail (self != NULL);
#line 130 "../core/Objects/Source.vala"
	_objects_source_run_server (self);
#line 132 "../core/Objects/Source.vala"
	self->priv->server_timeout = g_timeout_add_seconds_full (G_PRIORITY_DEFAULT, (guint) (15 * 60), ___lambda75__gsource_func, g_object_ref (self), g_object_unref);
#line 402 "Source.c"
}

static void
_objects_source_run_server (ObjectsSource* self)
{
	SourceType _tmp0_;
#line 141 "../core/Objects/Source.vala"
	g_return_if_fail (self != NULL);
#line 142 "../core/Objects/Source.vala"
	_tmp0_ = self->priv->_source_type;
#line 142 "../core/Objects/Source.vala"
	if (_tmp0_ == SOURCE_TYPE_TODOIST) {
#line 415 "Source.c"
		ServicesTodoist* _tmp1_;
		ServicesTodoist* _tmp2_;
#line 143 "../core/Objects/Source.vala"
		_tmp1_ = services_todoist_get_default ();
#line 143 "../core/Objects/Source.vala"
		_tmp2_ = _tmp1_;
#line 143 "../core/Objects/Source.vala"
		services_todoist_sync (_tmp2_, self, NULL, NULL);
#line 143 "../core/Objects/Source.vala"
		_g_object_unref0 (_tmp2_);
#line 426 "Source.c"
	} else {
		SourceType _tmp3_;
#line 144 "../core/Objects/Source.vala"
		_tmp3_ = self->priv->_source_type;
#line 144 "../core/Objects/Source.vala"
		if (_tmp3_ == SOURCE_TYPE_CALDAV) {
#line 433 "Source.c"
			ServicesCalDAVCore* _tmp4_;
			ServicesCalDAVCore* _tmp5_;
#line 145 "../core/Objects/Source.vala"
			_tmp4_ = services_cal_dav_core_get_default ();
#line 145 "../core/Objects/Source.vala"
			_tmp5_ = _tmp4_;
#line 145 "../core/Objects/Source.vala"
			services_cal_dav_core_sync (_tmp5_, self, NULL, NULL);
#line 145 "../core/Objects/Source.vala"
			_g_object_unref0 (_tmp5_);
#line 444 "Source.c"
		}
	}
}

void
objects_source_remove_sync_server (ObjectsSource* self)
{
#line 149 "../core/Objects/Source.vala"
	g_return_if_fail (self != NULL);
#line 151 "../core/Objects/Source.vala"
	g_source_remove (self->priv->server_timeout);
#line 152 "../core/Objects/Source.vala"
	self->priv->server_timeout = (guint) 0;
#line 458 "Source.c"
}

void
objects_source_save (ObjectsSource* self)
{
	GDateTime* _tmp0_;
	GDateTime* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	ServicesStore* _tmp4_;
#line 155 "../core/Objects/Source.vala"
	g_return_if_fail (self != NULL);
#line 156 "../core/Objects/Source.vala"
	_tmp0_ = g_date_time_new_now_local ();
#line 156 "../core/Objects/Source.vala"
	_tmp1_ = _tmp0_;
#line 156 "../core/Objects/Source.vala"
	_tmp2_ = g_date_time_to_string (_tmp1_);
#line 156 "../core/Objects/Source.vala"
	_tmp3_ = _tmp2_;
#line 156 "../core/Objects/Source.vala"
	objects_source_set_updated_at (self, _tmp3_);
#line 156 "../core/Objects/Source.vala"
	_g_free0 (_tmp3_);
#line 156 "../core/Objects/Source.vala"
	_g_date_time_unref0 (_tmp1_);
#line 157 "../core/Objects/Source.vala"
	_tmp4_ = services_store_instance ();
#line 157 "../core/Objects/Source.vala"
	services_store_update_source (_tmp4_, self);
#line 489 "Source.c"
}

static void
__lambda76_ (ObjectsSource* self,
             const gchar* response)
{
#line 172 "../core/Objects/Source.vala"
	g_return_if_fail (response != NULL);
#line 173 "../core/Objects/Source.vala"
	if (g_strcmp0 (response, "delete") == 0) {
#line 174 "../core/Objects/Source.vala"
		_objects_source_delete_source (self);
#line 502 "Source.c"
	}
}

static void
___lambda76__adw_alert_dialog_response (AdwAlertDialog* _sender,
                                        const gchar* response,
                                        gpointer self)
{
#line 172 "../core/Objects/Source.vala"
	__lambda76_ ((ObjectsSource*) self, response);
#line 513 "Source.c"
}

void
objects_source_delete_source (ObjectsSource* self,
                              GtkWindow* window)
{
	AdwAlertDialog* dialog = NULL;
	AdwAlertDialog* _tmp0_;
#line 160 "../core/Objects/Source.vala"
	g_return_if_fail (self != NULL);
#line 160 "../core/Objects/Source.vala"
	g_return_if_fail (window != NULL);
#line 161 "../core/Objects/Source.vala"
	_tmp0_ = (AdwAlertDialog*) adw_alert_dialog_new (_ ("Delete Source?"), _ ("This can not be undone"));
#line 161 "../core/Objects/Source.vala"
	g_object_ref_sink (_tmp0_);
#line 161 "../core/Objects/Source.vala"
	dialog = _tmp0_;
#line 166 "../core/Objects/Source.vala"
	adw_alert_dialog_add_response (dialog, "cancel", _ ("Cancel"));
#line 167 "../core/Objects/Source.vala"
	adw_alert_dialog_add_response (dialog, "delete", _ ("Delete"));
#line 168 "../core/Objects/Source.vala"
	adw_alert_dialog_set_close_response (dialog, "cancel");
#line 169 "../core/Objects/Source.vala"
	adw_alert_dialog_set_response_appearance (dialog, "delete", ADW_RESPONSE_DESTRUCTIVE);
#line 170 "../core/Objects/Source.vala"
	adw_dialog_present ((AdwDialog*) dialog, (GtkWidget*) window);
#line 172 "../core/Objects/Source.vala"
	g_signal_connect_object (dialog, "response", (GCallback) ___lambda76__adw_alert_dialog_response, self, 0);
#line 160 "../core/Objects/Source.vala"
	_g_object_unref0 (dialog);
#line 546 "Source.c"
}

static void
_objects_source_delete_source (ObjectsSource* self)
{
	ServicesStore* _tmp0_;
#line 179 "../core/Objects/Source.vala"
	g_return_if_fail (self != NULL);
#line 181 "../core/Objects/Source.vala"
	objects_source_remove_sync_server (self);
#line 184 "../core/Objects/Source.vala"
	_tmp0_ = services_store_instance ();
#line 184 "../core/Objects/Source.vala"
	services_store_delete_source (_tmp0_, self);
#line 561 "Source.c"
}

static gchar*
bool_to_string (gboolean self)
{
	gchar* result;
#line 37 "glib-2.0.vapi"
	if (self) {
#line 570 "Source.c"
		gchar* _tmp0_;
#line 38 "glib-2.0.vapi"
		_tmp0_ = g_strdup ("true");
#line 38 "glib-2.0.vapi"
		result = _tmp0_;
#line 38 "glib-2.0.vapi"
		return result;
#line 578 "Source.c"
	} else {
		gchar* _tmp1_;
#line 40 "glib-2.0.vapi"
		_tmp1_ = g_strdup ("false");
#line 40 "glib-2.0.vapi"
		result = _tmp1_;
#line 40 "glib-2.0.vapi"
		return result;
#line 587 "Source.c"
	}
}

gchar*
objects_source_to_string (ObjectsSource* self)
{
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	ObjectsSourceData* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	SourceType _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gboolean _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	gchar* result;
#line 187 "../core/Objects/Source.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 188 "../core/Objects/Source.vala"
	_tmp0_ = objects_base_object_get_id ((ObjectsBaseObject*) self);
#line 188 "../core/Objects/Source.vala"
	_tmp1_ = _tmp0_;
#line 188 "../core/Objects/Source.vala"
	_tmp2_ = self->priv->_data;
#line 188 "../core/Objects/Source.vala"
	_tmp3_ = objects_source_data_to_json (_tmp2_);
#line 188 "../core/Objects/Source.vala"
	_tmp4_ = _tmp3_;
#line 188 "../core/Objects/Source.vala"
	_tmp5_ = self->priv->_source_type;
#line 188 "../core/Objects/Source.vala"
	_tmp6_ = source_type_to_string (_tmp5_);
#line 188 "../core/Objects/Source.vala"
	_tmp7_ = _tmp6_;
#line 188 "../core/Objects/Source.vala"
	_tmp8_ = self->priv->_sync_server;
#line 188 "../core/Objects/Source.vala"
	_tmp9_ = bool_to_string (_tmp8_);
#line 188 "../core/Objects/Source.vala"
	_tmp10_ = _tmp9_;
#line 188 "../core/Objects/Source.vala"
	_tmp11_ = g_strdup_printf ("\n" \
"        _________________________________\n" \
"            ID: %s\n" \
"            DATA: %s\n" \
"            TYPE: %s\n" \
"            SYNC_SERVER: %s\n" \
"        ---------------------------------\n" \
"        ", _tmp1_, _tmp4_, _tmp7_, _tmp10_);
#line 188 "../core/Objects/Source.vala"
	_tmp12_ = _tmp11_;
#line 188 "../core/Objects/Source.vala"
	_g_free0 (_tmp10_);
#line 188 "../core/Objects/Source.vala"
	_g_free0 (_tmp7_);
#line 188 "../core/Objects/Source.vala"
	_g_free0 (_tmp4_);
#line 188 "../core/Objects/Source.vala"
	result = _tmp12_;
#line 188 "../core/Objects/Source.vala"
	return result;
#line 646 "Source.c"
}

ObjectsSource*
objects_source_construct (GType object_type)
{
	ObjectsSource * self = NULL;
#line 22 "../core/Objects/Source.vala"
	self = (ObjectsSource*) objects_base_object_construct (object_type);
#line 22 "../core/Objects/Source.vala"
	return self;
#line 657 "Source.c"
}

ObjectsSource*
objects_source_new (void)
{
#line 22 "../core/Objects/Source.vala"
	return objects_source_construct (OBJECTS_TYPE_SOURCE);
#line 665 "Source.c"
}

SourceType
objects_source_get_source_type (ObjectsSource* self)
{
	SourceType result;
#line 23 "../core/Objects/Source.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 23 "../core/Objects/Source.vala"
	result = self->priv->_source_type;
#line 23 "../core/Objects/Source.vala"
	return result;
#line 678 "Source.c"
}

void
objects_source_set_source_type (ObjectsSource* self,
                                SourceType value)
{
	SourceType old_value;
#line 23 "../core/Objects/Source.vala"
	g_return_if_fail (self != NULL);
#line 23 "../core/Objects/Source.vala"
	old_value = objects_source_get_source_type (self);
#line 23 "../core/Objects/Source.vala"
	if (old_value != value) {
#line 23 "../core/Objects/Source.vala"
		self->priv->_source_type = value;
#line 23 "../core/Objects/Source.vala"
		g_object_notify_by_pspec ((GObject *) self, objects_source_properties[OBJECTS_SOURCE_SOURCE_TYPE_PROPERTY]);
#line 696 "Source.c"
	}
}

const gchar*
objects_source_get_added_at (ObjectsSource* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 24 "../core/Objects/Source.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 24 "../core/Objects/Source.vala"
	_tmp0_ = self->priv->_added_at;
#line 24 "../core/Objects/Source.vala"
	result = _tmp0_;
#line 24 "../core/Objects/Source.vala"
	return result;
#line 713 "Source.c"
}

void
objects_source_set_added_at (ObjectsSource* self,
                             const gchar* value)
{
	gchar* old_value;
#line 24 "../core/Objects/Source.vala"
	g_return_if_fail (self != NULL);
#line 24 "../core/Objects/Source.vala"
	old_value = objects_source_get_added_at (self);
#line 24 "../core/Objects/Source.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 727 "Source.c"
		gchar* _tmp0_;
#line 24 "../core/Objects/Source.vala"
		_tmp0_ = g_strdup (value);
#line 24 "../core/Objects/Source.vala"
		_g_free0 (self->priv->_added_at);
#line 24 "../core/Objects/Source.vala"
		self->priv->_added_at = _tmp0_;
#line 24 "../core/Objects/Source.vala"
		g_object_notify_by_pspec ((GObject *) self, objects_source_properties[OBJECTS_SOURCE_ADDED_AT_PROPERTY]);
#line 737 "Source.c"
	}
}

const gchar*
objects_source_get_updated_at (ObjectsSource* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 25 "../core/Objects/Source.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 25 "../core/Objects/Source.vala"
	_tmp0_ = self->priv->_updated_at;
#line 25 "../core/Objects/Source.vala"
	result = _tmp0_;
#line 25 "../core/Objects/Source.vala"
	return result;
#line 754 "Source.c"
}

void
objects_source_set_updated_at (ObjectsSource* self,
                               const gchar* value)
{
	gchar* old_value;
#line 25 "../core/Objects/Source.vala"
	g_return_if_fail (self != NULL);
#line 25 "../core/Objects/Source.vala"
	old_value = objects_source_get_updated_at (self);
#line 25 "../core/Objects/Source.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 768 "Source.c"
		gchar* _tmp0_;
#line 25 "../core/Objects/Source.vala"
		_tmp0_ = g_strdup (value);
#line 25 "../core/Objects/Source.vala"
		_g_free0 (self->priv->_updated_at);
#line 25 "../core/Objects/Source.vala"
		self->priv->_updated_at = _tmp0_;
#line 25 "../core/Objects/Source.vala"
		g_object_notify_by_pspec ((GObject *) self, objects_source_properties[OBJECTS_SOURCE_UPDATED_AT_PROPERTY]);
#line 778 "Source.c"
	}
}

gboolean
objects_source_get_is_visible (ObjectsSource* self)
{
	gboolean result;
#line 26 "../core/Objects/Source.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 26 "../core/Objects/Source.vala"
	result = self->priv->_is_visible;
#line 26 "../core/Objects/Source.vala"
	return result;
#line 792 "Source.c"
}

void
objects_source_set_is_visible (ObjectsSource* self,
                               gboolean value)
{
	gboolean old_value;
#line 26 "../core/Objects/Source.vala"
	g_return_if_fail (self != NULL);
#line 26 "../core/Objects/Source.vala"
	old_value = objects_source_get_is_visible (self);
#line 26 "../core/Objects/Source.vala"
	if (old_value != value) {
#line 26 "../core/Objects/Source.vala"
		self->priv->_is_visible = value;
#line 26 "../core/Objects/Source.vala"
		g_object_notify_by_pspec ((GObject *) self, objects_source_properties[OBJECTS_SOURCE_IS_VISIBLE_PROPERTY]);
#line 810 "Source.c"
	}
}

gint
objects_source_get_child_order (ObjectsSource* self)
{
	gint result;
#line 27 "../core/Objects/Source.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 27 "../core/Objects/Source.vala"
	result = self->priv->_child_order;
#line 27 "../core/Objects/Source.vala"
	return result;
#line 824 "Source.c"
}

void
objects_source_set_child_order (ObjectsSource* self,
                                gint value)
{
	gint old_value;
#line 27 "../core/Objects/Source.vala"
	g_return_if_fail (self != NULL);
#line 27 "../core/Objects/Source.vala"
	old_value = objects_source_get_child_order (self);
#line 27 "../core/Objects/Source.vala"
	if (old_value != value) {
#line 27 "../core/Objects/Source.vala"
		self->priv->_child_order = value;
#line 27 "../core/Objects/Source.vala"
		g_object_notify_by_pspec ((GObject *) self, objects_source_properties[OBJECTS_SOURCE_CHILD_ORDER_PROPERTY]);
#line 842 "Source.c"
	}
}

gboolean
objects_source_get_sync_server (ObjectsSource* self)
{
	gboolean result;
#line 28 "../core/Objects/Source.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 28 "../core/Objects/Source.vala"
	result = self->priv->_sync_server;
#line 28 "../core/Objects/Source.vala"
	return result;
#line 856 "Source.c"
}

void
objects_source_set_sync_server (ObjectsSource* self,
                                gboolean value)
{
	gboolean old_value;
#line 28 "../core/Objects/Source.vala"
	g_return_if_fail (self != NULL);
#line 28 "../core/Objects/Source.vala"
	old_value = objects_source_get_sync_server (self);
#line 28 "../core/Objects/Source.vala"
	if (old_value != value) {
#line 28 "../core/Objects/Source.vala"
		self->priv->_sync_server = value;
#line 28 "../core/Objects/Source.vala"
		g_object_notify_by_pspec ((GObject *) self, objects_source_properties[OBJECTS_SOURCE_SYNC_SERVER_PROPERTY]);
#line 874 "Source.c"
	}
}

const gchar*
objects_source_get_last_sync (ObjectsSource* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 29 "../core/Objects/Source.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 29 "../core/Objects/Source.vala"
	_tmp0_ = self->priv->_last_sync;
#line 29 "../core/Objects/Source.vala"
	result = _tmp0_;
#line 29 "../core/Objects/Source.vala"
	return result;
#line 891 "Source.c"
}

void
objects_source_set_last_sync (ObjectsSource* self,
                              const gchar* value)
{
	gchar* old_value;
#line 29 "../core/Objects/Source.vala"
	g_return_if_fail (self != NULL);
#line 29 "../core/Objects/Source.vala"
	old_value = objects_source_get_last_sync (self);
#line 29 "../core/Objects/Source.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 905 "Source.c"
		gchar* _tmp0_;
#line 29 "../core/Objects/Source.vala"
		_tmp0_ = g_strdup (value);
#line 29 "../core/Objects/Source.vala"
		_g_free0 (self->priv->_last_sync);
#line 29 "../core/Objects/Source.vala"
		self->priv->_last_sync = _tmp0_;
#line 29 "../core/Objects/Source.vala"
		g_object_notify_by_pspec ((GObject *) self, objects_source_properties[OBJECTS_SOURCE_LAST_SYNC_PROPERTY]);
#line 915 "Source.c"
	}
}

ObjectsSourceData*
objects_source_get_data (ObjectsSource* self)
{
	ObjectsSourceData* result;
	ObjectsSourceData* _tmp0_;
#line 30 "../core/Objects/Source.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 30 "../core/Objects/Source.vala"
	_tmp0_ = self->priv->_data;
#line 30 "../core/Objects/Source.vala"
	result = _tmp0_;
#line 30 "../core/Objects/Source.vala"
	return result;
#line 932 "Source.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 30 "../core/Objects/Source.vala"
	return self ? g_object_ref (self) : NULL;
#line 940 "Source.c"
}

void
objects_source_set_data (ObjectsSource* self,
                         ObjectsSourceData* value)
{
	ObjectsSourceData* old_value;
#line 30 "../core/Objects/Source.vala"
	g_return_if_fail (self != NULL);
#line 30 "../core/Objects/Source.vala"
	old_value = objects_source_get_data (self);
#line 30 "../core/Objects/Source.vala"
	if (old_value != value) {
#line 954 "Source.c"
		ObjectsSourceData* _tmp0_;
#line 30 "../core/Objects/Source.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 30 "../core/Objects/Source.vala"
		_g_object_unref0 (self->priv->_data);
#line 30 "../core/Objects/Source.vala"
		self->priv->_data = _tmp0_;
#line 30 "../core/Objects/Source.vala"
		g_object_notify_by_pspec ((GObject *) self, objects_source_properties[OBJECTS_SOURCE_DATA_PROPERTY]);
#line 964 "Source.c"
	}
}

const gchar*
objects_source_get_display_name (ObjectsSource* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 31 "../core/Objects/Source.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 31 "../core/Objects/Source.vala"
	_tmp0_ = self->priv->_display_name;
#line 31 "../core/Objects/Source.vala"
	result = _tmp0_;
#line 31 "../core/Objects/Source.vala"
	return result;
#line 981 "Source.c"
}

void
objects_source_set_display_name (ObjectsSource* self,
                                 const gchar* value)
{
	gchar* old_value;
#line 31 "../core/Objects/Source.vala"
	g_return_if_fail (self != NULL);
#line 31 "../core/Objects/Source.vala"
	old_value = objects_source_get_display_name (self);
#line 31 "../core/Objects/Source.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 995 "Source.c"
		gchar* _tmp0_;
#line 31 "../core/Objects/Source.vala"
		_tmp0_ = g_strdup (value);
#line 31 "../core/Objects/Source.vala"
		_g_free0 (self->priv->_display_name);
#line 31 "../core/Objects/Source.vala"
		self->priv->_display_name = _tmp0_;
#line 31 "../core/Objects/Source.vala"
		g_object_notify_by_pspec ((GObject *) self, objects_source_properties[OBJECTS_SOURCE_DISPLAY_NAME_PROPERTY]);
#line 1005 "Source.c"
	}
}

ObjectsSourceTodoistData*
objects_source_get_todoist_data (ObjectsSource* self)
{
	ObjectsSourceTodoistData* result;
	ObjectsSourceData* _tmp0_;
	ObjectsSourceTodoistData* _tmp1_;
	ObjectsSourceTodoistData* _tmp2_;
#line 35 "../core/Objects/Source.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 36 "../core/Objects/Source.vala"
	_tmp0_ = self->priv->_data;
#line 36 "../core/Objects/Source.vala"
	_tmp1_ = _g_object_ref0 (OBJECTS_IS_SOURCE_TODOIST_DATA (_tmp0_) ? ((ObjectsSourceTodoistData*) _tmp0_) : NULL);
#line 36 "../core/Objects/Source.vala"
	_g_object_unref0 (self->priv->_todoist_data);
#line 36 "../core/Objects/Source.vala"
	self->priv->_todoist_data = _tmp1_;
#line 37 "../core/Objects/Source.vala"
	_tmp2_ = self->priv->_todoist_data;
#line 37 "../core/Objects/Source.vala"
	result = _tmp2_;
#line 37 "../core/Objects/Source.vala"
	return result;
#line 1032 "Source.c"
}

ObjectsSourceCalDAVData*
objects_source_get_caldav_data (ObjectsSource* self)
{
	ObjectsSourceCalDAVData* result;
	ObjectsSourceData* _tmp0_;
	ObjectsSourceCalDAVData* _tmp1_;
	ObjectsSourceCalDAVData* _tmp2_;
#line 43 "../core/Objects/Source.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 44 "../core/Objects/Source.vala"
	_tmp0_ = self->priv->_data;
#line 44 "../core/Objects/Source.vala"
	_tmp1_ = _g_object_ref0 (OBJECTS_IS_SOURCE_CAL_DAV_DATA (_tmp0_) ? ((ObjectsSourceCalDAVData*) _tmp0_) : NULL);
#line 44 "../core/Objects/Source.vala"
	_g_object_unref0 (self->priv->_caldav_data);
#line 44 "../core/Objects/Source.vala"
	self->priv->_caldav_data = _tmp1_;
#line 45 "../core/Objects/Source.vala"
	_tmp2_ = self->priv->_caldav_data;
#line 45 "../core/Objects/Source.vala"
	result = _tmp2_;
#line 45 "../core/Objects/Source.vala"
	return result;
#line 1058 "Source.c"
}

const gchar*
objects_source_get_header_text (ObjectsSource* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 50 "../core/Objects/Source.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 51 "../core/Objects/Source.vala"
	_tmp0_ = self->priv->_display_name;
#line 51 "../core/Objects/Source.vala"
	result = _tmp0_;
#line 51 "../core/Objects/Source.vala"
	return result;
#line 1074 "Source.c"
}

const gchar*
objects_source_get_subheader_text (ObjectsSource* self)
{
	const gchar* result;
	SourceType _tmp0_;
	SourceType _tmp1_;
#line 57 "../core/Objects/Source.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 58 "../core/Objects/Source.vala"
	_tmp0_ = self->priv->_source_type;
#line 58 "../core/Objects/Source.vala"
	if (_tmp0_ == SOURCE_TYPE_TODOIST) {
#line 59 "../core/Objects/Source.vala"
		result = _ ("Todoist");
#line 59 "../core/Objects/Source.vala"
		return result;
#line 1093 "Source.c"
	}
#line 62 "../core/Objects/Source.vala"
	_tmp1_ = self->priv->_source_type;
#line 62 "../core/Objects/Source.vala"
	if (_tmp1_ == SOURCE_TYPE_CALDAV) {
#line 1099 "Source.c"
		ObjectsSourceCalDAVData* _tmp2_;
		ObjectsSourceCalDAVData* _tmp3_;
		CalDAVType _tmp4_;
		CalDAVType _tmp5_;
		gchar* _tmp6_;
		const gchar* _tmp7_;
#line 63 "../core/Objects/Source.vala"
		_tmp2_ = objects_source_get_caldav_data (self);
#line 63 "../core/Objects/Source.vala"
		_tmp3_ = _tmp2_;
#line 63 "../core/Objects/Source.vala"
		_tmp4_ = objects_source_cal_dav_data_get_caldav_type (_tmp3_);
#line 63 "../core/Objects/Source.vala"
		_tmp5_ = _tmp4_;
#line 63 "../core/Objects/Source.vala"
		_tmp6_ = cal_dav_type_title (_tmp5_);
#line 63 "../core/Objects/Source.vala"
		_g_free0 (self->priv->_subheader_text);
#line 63 "../core/Objects/Source.vala"
		self->priv->_subheader_text = _tmp6_;
#line 64 "../core/Objects/Source.vala"
		_tmp7_ = self->priv->_subheader_text;
#line 64 "../core/Objects/Source.vala"
		result = _tmp7_;
#line 64 "../core/Objects/Source.vala"
		return result;
#line 1126 "Source.c"
	}
#line 67 "../core/Objects/Source.vala"
	result = "";
#line 67 "../core/Objects/Source.vala"
	return result;
#line 1132 "Source.c"
}

const gchar*
objects_source_get_avatar_path (ObjectsSource* self)
{
	const gchar* result;
	ObjectsSourceTodoistData* _tmp0_;
	ObjectsSourceTodoistData* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
#line 72 "../core/Objects/Source.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 73 "../core/Objects/Source.vala"
	_tmp0_ = objects_source_get_todoist_data (self);
#line 73 "../core/Objects/Source.vala"
	_tmp1_ = _tmp0_;
#line 73 "../core/Objects/Source.vala"
	_tmp2_ = objects_source_todoist_data_get_user_image_id (_tmp1_);
#line 73 "../core/Objects/Source.vala"
	_tmp3_ = _tmp2_;
#line 73 "../core/Objects/Source.vala"
	result = _tmp3_;
#line 73 "../core/Objects/Source.vala"
	return result;
#line 1157 "Source.c"
}

const gchar*
objects_source_get_user_displayname (ObjectsSource* self)
{
	const gchar* result;
	SourceType _tmp0_;
	SourceType _tmp5_;
#line 78 "../core/Objects/Source.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 79 "../core/Objects/Source.vala"
	_tmp0_ = self->priv->_source_type;
#line 79 "../core/Objects/Source.vala"
	if (_tmp0_ == SOURCE_TYPE_TODOIST) {
#line 1172 "Source.c"
		ObjectsSourceTodoistData* _tmp1_;
		ObjectsSourceTodoistData* _tmp2_;
		const gchar* _tmp3_;
		const gchar* _tmp4_;
#line 80 "../core/Objects/Source.vala"
		_tmp1_ = objects_source_get_todoist_data (self);
#line 80 "../core/Objects/Source.vala"
		_tmp2_ = _tmp1_;
#line 80 "../core/Objects/Source.vala"
		_tmp3_ = objects_source_todoist_data_get_user_name (_tmp2_);
#line 80 "../core/Objects/Source.vala"
		_tmp4_ = _tmp3_;
#line 80 "../core/Objects/Source.vala"
		result = _tmp4_;
#line 80 "../core/Objects/Source.vala"
		return result;
#line 1189 "Source.c"
	}
#line 83 "../core/Objects/Source.vala"
	_tmp5_ = self->priv->_source_type;
#line 83 "../core/Objects/Source.vala"
	if (_tmp5_ == SOURCE_TYPE_CALDAV) {
#line 1195 "Source.c"
		ObjectsSourceCalDAVData* _tmp6_;
		ObjectsSourceCalDAVData* _tmp7_;
		const gchar* _tmp8_;
		const gchar* _tmp9_;
#line 84 "../core/Objects/Source.vala"
		_tmp6_ = objects_source_get_caldav_data (self);
#line 84 "../core/Objects/Source.vala"
		_tmp7_ = _tmp6_;
#line 84 "../core/Objects/Source.vala"
		_tmp8_ = objects_source_cal_dav_data_get_user_displayname (_tmp7_);
#line 84 "../core/Objects/Source.vala"
		_tmp9_ = _tmp8_;
#line 84 "../core/Objects/Source.vala"
		result = _tmp9_;
#line 84 "../core/Objects/Source.vala"
		return result;
#line 1212 "Source.c"
	}
#line 87 "../core/Objects/Source.vala"
	result = "";
#line 87 "../core/Objects/Source.vala"
	return result;
#line 1218 "Source.c"
}

const gchar*
objects_source_get_user_email (ObjectsSource* self)
{
	const gchar* result;
	SourceType _tmp0_;
	SourceType _tmp5_;
#line 92 "../core/Objects/Source.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 93 "../core/Objects/Source.vala"
	_tmp0_ = self->priv->_source_type;
#line 93 "../core/Objects/Source.vala"
	if (_tmp0_ == SOURCE_TYPE_TODOIST) {
#line 1233 "Source.c"
		ObjectsSourceTodoistData* _tmp1_;
		ObjectsSourceTodoistData* _tmp2_;
		const gchar* _tmp3_;
		const gchar* _tmp4_;
#line 94 "../core/Objects/Source.vala"
		_tmp1_ = objects_source_get_todoist_data (self);
#line 94 "../core/Objects/Source.vala"
		_tmp2_ = _tmp1_;
#line 94 "../core/Objects/Source.vala"
		_tmp3_ = objects_source_todoist_data_get_user_email (_tmp2_);
#line 94 "../core/Objects/Source.vala"
		_tmp4_ = _tmp3_;
#line 94 "../core/Objects/Source.vala"
		result = _tmp4_;
#line 94 "../core/Objects/Source.vala"
		return result;
#line 1250 "Source.c"
	}
#line 97 "../core/Objects/Source.vala"
	_tmp5_ = self->priv->_source_type;
#line 97 "../core/Objects/Source.vala"
	if (_tmp5_ == SOURCE_TYPE_CALDAV) {
#line 1256 "Source.c"
		ObjectsSourceCalDAVData* _tmp6_;
		ObjectsSourceCalDAVData* _tmp7_;
		const gchar* _tmp8_;
		const gchar* _tmp9_;
#line 98 "../core/Objects/Source.vala"
		_tmp6_ = objects_source_get_caldav_data (self);
#line 98 "../core/Objects/Source.vala"
		_tmp7_ = _tmp6_;
#line 98 "../core/Objects/Source.vala"
		_tmp8_ = objects_source_cal_dav_data_get_user_email (_tmp7_);
#line 98 "../core/Objects/Source.vala"
		_tmp9_ = _tmp8_;
#line 98 "../core/Objects/Source.vala"
		result = _tmp9_;
#line 98 "../core/Objects/Source.vala"
		return result;
#line 1273 "Source.c"
	}
#line 101 "../core/Objects/Source.vala"
	result = "";
#line 101 "../core/Objects/Source.vala"
	return result;
#line 1279 "Source.c"
}

static void
objects_source_class_init (ObjectsSourceClass * klass,
                           gpointer klass_data)
{
#line 22 "../core/Objects/Source.vala"
	objects_source_parent_class = g_type_class_peek_parent (klass);
#line 22 "../core/Objects/Source.vala"
	g_type_class_adjust_private_offset (klass, &ObjectsSource_private_offset);
#line 22 "../core/Objects/Source.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_objects_source_get_property;
#line 22 "../core/Objects/Source.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_objects_source_set_property;
#line 22 "../core/Objects/Source.vala"
	G_OBJECT_CLASS (klass)->finalize = objects_source_finalize;
#line 22 "../core/Objects/Source.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), OBJECTS_SOURCE_SOURCE_TYPE_PROPERTY, objects_source_properties[OBJECTS_SOURCE_SOURCE_TYPE_PROPERTY] = g_param_spec_enum ("source-type", "source-type", "source-type", TYPE_SOURCE_TYPE, SOURCE_TYPE_NONE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 22 "../core/Objects/Source.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), OBJECTS_SOURCE_ADDED_AT_PROPERTY, objects_source_properties[OBJECTS_SOURCE_ADDED_AT_PROPERTY] = g_param_spec_string ("added-at", "added-at", "added-at", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 22 "../core/Objects/Source.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), OBJECTS_SOURCE_UPDATED_AT_PROPERTY, objects_source_properties[OBJECTS_SOURCE_UPDATED_AT_PROPERTY] = g_param_spec_string ("updated-at", "updated-at", "updated-at", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 22 "../core/Objects/Source.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), OBJECTS_SOURCE_IS_VISIBLE_PROPERTY, objects_source_properties[OBJECTS_SOURCE_IS_VISIBLE_PROPERTY] = g_param_spec_boolean ("is-visible", "is-visible", "is-visible", TRUE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 22 "../core/Objects/Source.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), OBJECTS_SOURCE_CHILD_ORDER_PROPERTY, objects_source_properties[OBJECTS_SOURCE_CHILD_ORDER_PROPERTY] = g_param_spec_int ("child-order", "child-order", "child-order", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 22 "../core/Objects/Source.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), OBJECTS_SOURCE_SYNC_SERVER_PROPERTY, objects_source_properties[OBJECTS_SOURCE_SYNC_SERVER_PROPERTY] = g_param_spec_boolean ("sync-server", "sync-server", "sync-server", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 22 "../core/Objects/Source.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), OBJECTS_SOURCE_LAST_SYNC_PROPERTY, objects_source_properties[OBJECTS_SOURCE_LAST_SYNC_PROPERTY] = g_param_spec_string ("last-sync", "last-sync", "last-sync", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 22 "../core/Objects/Source.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), OBJECTS_SOURCE_DATA_PROPERTY, objects_source_properties[OBJECTS_SOURCE_DATA_PROPERTY] = g_param_spec_object ("data", "data", "data", OBJECTS_TYPE_SOURCE_DATA, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 22 "../core/Objects/Source.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), OBJECTS_SOURCE_DISPLAY_NAME_PROPERTY, objects_source_properties[OBJECTS_SOURCE_DISPLAY_NAME_PROPERTY] = g_param_spec_string ("display-name", "display-name", "display-name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 22 "../core/Objects/Source.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), OBJECTS_SOURCE_TODOIST_DATA_PROPERTY, objects_source_properties[OBJECTS_SOURCE_TODOIST_DATA_PROPERTY] = g_param_spec_object ("todoist-data", "todoist-data", "todoist-data", OBJECTS_TYPE_SOURCE_TODOIST_DATA, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 22 "../core/Objects/Source.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), OBJECTS_SOURCE_CALDAV_DATA_PROPERTY, objects_source_properties[OBJECTS_SOURCE_CALDAV_DATA_PROPERTY] = g_param_spec_object ("caldav-data", "caldav-data", "caldav-data", OBJECTS_TYPE_SOURCE_CAL_DAV_DATA, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 22 "../core/Objects/Source.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), OBJECTS_SOURCE_HEADER_TEXT_PROPERTY, objects_source_properties[OBJECTS_SOURCE_HEADER_TEXT_PROPERTY] = g_param_spec_string ("header-text", "header-text", "header-text", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 22 "../core/Objects/Source.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), OBJECTS_SOURCE_SUBHEADER_TEXT_PROPERTY, objects_source_properties[OBJECTS_SOURCE_SUBHEADER_TEXT_PROPERTY] = g_param_spec_string ("subheader-text", "subheader-text", "subheader-text", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 22 "../core/Objects/Source.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), OBJECTS_SOURCE_AVATAR_PATH_PROPERTY, objects_source_properties[OBJECTS_SOURCE_AVATAR_PATH_PROPERTY] = g_param_spec_string ("avatar-path", "avatar-path", "avatar-path", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 22 "../core/Objects/Source.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), OBJECTS_SOURCE_USER_DISPLAYNAME_PROPERTY, objects_source_properties[OBJECTS_SOURCE_USER_DISPLAYNAME_PROPERTY] = g_param_spec_string ("user-displayname", "user-displayname", "user-displayname", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 22 "../core/Objects/Source.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), OBJECTS_SOURCE_USER_EMAIL_PROPERTY, objects_source_properties[OBJECTS_SOURCE_USER_EMAIL_PROPERTY] = g_param_spec_string ("user-email", "user-email", "user-email", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 22 "../core/Objects/Source.vala"
	objects_source_signals[OBJECTS_SOURCE_SYNC_STARTED_SIGNAL] = g_signal_new ("sync-started", OBJECTS_TYPE_SOURCE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 22 "../core/Objects/Source.vala"
	objects_source_signals[OBJECTS_SOURCE_SYNC_FINISHED_SIGNAL] = g_signal_new ("sync-finished", OBJECTS_TYPE_SOURCE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 22 "../core/Objects/Source.vala"
	objects_source_signals[OBJECTS_SOURCE_SYNC_FAILED_SIGNAL] = g_signal_new ("sync-failed", OBJECTS_TYPE_SOURCE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 1334 "Source.c"
}

static void
objects_source_instance_init (ObjectsSource * self,
                              gpointer klass)
{
	GDateTime* _tmp0_;
	GDateTime* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
#line 22 "../core/Objects/Source.vala"
	self->priv = objects_source_get_instance_private (self);
#line 23 "../core/Objects/Source.vala"
	self->priv->_source_type = SOURCE_TYPE_NONE;
#line 24 "../core/Objects/Source.vala"
	_tmp0_ = g_date_time_new_now_local ();
#line 24 "../core/Objects/Source.vala"
	_tmp1_ = _tmp0_;
#line 24 "../core/Objects/Source.vala"
	_tmp2_ = g_date_time_to_string (_tmp1_);
#line 24 "../core/Objects/Source.vala"
	self->priv->_added_at = _tmp2_;
#line 24 "../core/Objects/Source.vala"
	_g_date_time_unref0 (_tmp1_);
#line 25 "../core/Objects/Source.vala"
	_tmp3_ = g_strdup ("");
#line 25 "../core/Objects/Source.vala"
	self->priv->_updated_at = _tmp3_;
#line 26 "../core/Objects/Source.vala"
	self->priv->_is_visible = TRUE;
#line 27 "../core/Objects/Source.vala"
	self->priv->_child_order = 0;
#line 28 "../core/Objects/Source.vala"
	self->priv->_sync_server = FALSE;
#line 29 "../core/Objects/Source.vala"
	_tmp4_ = g_strdup ("");
#line 29 "../core/Objects/Source.vala"
	self->priv->_last_sync = _tmp4_;
#line 31 "../core/Objects/Source.vala"
	_tmp5_ = g_strdup ("");
#line 31 "../core/Objects/Source.vala"
	self->priv->_display_name = _tmp5_;
#line 105 "../core/Objects/Source.vala"
	self->priv->server_timeout = (guint) 0;
#line 1381 "Source.c"
}

static void
objects_source_finalize (GObject * obj)
{
	ObjectsSource * self;
#line 22 "../core/Objects/Source.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, OBJECTS_TYPE_SOURCE, ObjectsSource);
#line 24 "../core/Objects/Source.vala"
	_g_free0 (self->priv->_added_at);
#line 25 "../core/Objects/Source.vala"
	_g_free0 (self->priv->_updated_at);
#line 29 "../core/Objects/Source.vala"
	_g_free0 (self->priv->_last_sync);
#line 30 "../core/Objects/Source.vala"
	_g_object_unref0 (self->priv->_data);
#line 31 "../core/Objects/Source.vala"
	_g_free0 (self->priv->_display_name);
#line 33 "../core/Objects/Source.vala"
	_g_object_unref0 (self->priv->_todoist_data);
#line 41 "../core/Objects/Source.vala"
	_g_object_unref0 (self->priv->_caldav_data);
#line 55 "../core/Objects/Source.vala"
	_g_free0 (self->priv->_subheader_text);
#line 22 "../core/Objects/Source.vala"
	G_OBJECT_CLASS (objects_source_parent_class)->finalize (obj);
#line 1408 "Source.c"
}

static GType
objects_source_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ObjectsSourceClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) objects_source_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ObjectsSource), 0, (GInstanceInitFunc) objects_source_instance_init, NULL };
	GType objects_source_type_id;
	objects_source_type_id = g_type_register_static (OBJECTS_TYPE_BASE_OBJECT, "ObjectsSource", &g_define_type_info, 0);
	ObjectsSource_private_offset = g_type_add_instance_private (objects_source_type_id, sizeof (ObjectsSourcePrivate));
	return objects_source_type_id;
}

GType
objects_source_get_type (void)
{
	static volatile gsize objects_source_type_id__once = 0;
	if (g_once_init_enter (&objects_source_type_id__once)) {
		GType objects_source_type_id;
		objects_source_type_id = objects_source_get_type_once ();
		g_once_init_leave (&objects_source_type_id__once, objects_source_type_id);
	}
	return objects_source_type_id__once;
}

static void
_vala_objects_source_get_property (GObject * object,
                                   guint property_id,
                                   GValue * value,
                                   GParamSpec * pspec)
{
	ObjectsSource * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, OBJECTS_TYPE_SOURCE, ObjectsSource);
#line 22 "../core/Objects/Source.vala"
	switch (property_id) {
#line 22 "../core/Objects/Source.vala"
		case OBJECTS_SOURCE_SOURCE_TYPE_PROPERTY:
#line 22 "../core/Objects/Source.vala"
		g_value_set_enum (value, objects_source_get_source_type (self));
#line 22 "../core/Objects/Source.vala"
		break;
#line 22 "../core/Objects/Source.vala"
		case OBJECTS_SOURCE_ADDED_AT_PROPERTY:
#line 22 "../core/Objects/Source.vala"
		g_value_set_string (value, objects_source_get_added_at (self));
#line 22 "../core/Objects/Source.vala"
		break;
#line 22 "../core/Objects/Source.vala"
		case OBJECTS_SOURCE_UPDATED_AT_PROPERTY:
#line 22 "../core/Objects/Source.vala"
		g_value_set_string (value, objects_source_get_updated_at (self));
#line 22 "../core/Objects/Source.vala"
		break;
#line 22 "../core/Objects/Source.vala"
		case OBJECTS_SOURCE_IS_VISIBLE_PROPERTY:
#line 22 "../core/Objects/Source.vala"
		g_value_set_boolean (value, objects_source_get_is_visible (self));
#line 22 "../core/Objects/Source.vala"
		break;
#line 22 "../core/Objects/Source.vala"
		case OBJECTS_SOURCE_CHILD_ORDER_PROPERTY:
#line 22 "../core/Objects/Source.vala"
		g_value_set_int (value, objects_source_get_child_order (self));
#line 22 "../core/Objects/Source.vala"
		break;
#line 22 "../core/Objects/Source.vala"
		case OBJECTS_SOURCE_SYNC_SERVER_PROPERTY:
#line 22 "../core/Objects/Source.vala"
		g_value_set_boolean (value, objects_source_get_sync_server (self));
#line 22 "../core/Objects/Source.vala"
		break;
#line 22 "../core/Objects/Source.vala"
		case OBJECTS_SOURCE_LAST_SYNC_PROPERTY:
#line 22 "../core/Objects/Source.vala"
		g_value_set_string (value, objects_source_get_last_sync (self));
#line 22 "../core/Objects/Source.vala"
		break;
#line 22 "../core/Objects/Source.vala"
		case OBJECTS_SOURCE_DATA_PROPERTY:
#line 22 "../core/Objects/Source.vala"
		g_value_set_object (value, objects_source_get_data (self));
#line 22 "../core/Objects/Source.vala"
		break;
#line 22 "../core/Objects/Source.vala"
		case OBJECTS_SOURCE_DISPLAY_NAME_PROPERTY:
#line 22 "../core/Objects/Source.vala"
		g_value_set_string (value, objects_source_get_display_name (self));
#line 22 "../core/Objects/Source.vala"
		break;
#line 22 "../core/Objects/Source.vala"
		case OBJECTS_SOURCE_TODOIST_DATA_PROPERTY:
#line 22 "../core/Objects/Source.vala"
		g_value_set_object (value, objects_source_get_todoist_data (self));
#line 22 "../core/Objects/Source.vala"
		break;
#line 22 "../core/Objects/Source.vala"
		case OBJECTS_SOURCE_CALDAV_DATA_PROPERTY:
#line 22 "../core/Objects/Source.vala"
		g_value_set_object (value, objects_source_get_caldav_data (self));
#line 22 "../core/Objects/Source.vala"
		break;
#line 22 "../core/Objects/Source.vala"
		case OBJECTS_SOURCE_HEADER_TEXT_PROPERTY:
#line 22 "../core/Objects/Source.vala"
		g_value_set_string (value, objects_source_get_header_text (self));
#line 22 "../core/Objects/Source.vala"
		break;
#line 22 "../core/Objects/Source.vala"
		case OBJECTS_SOURCE_SUBHEADER_TEXT_PROPERTY:
#line 22 "../core/Objects/Source.vala"
		g_value_set_string (value, objects_source_get_subheader_text (self));
#line 22 "../core/Objects/Source.vala"
		break;
#line 22 "../core/Objects/Source.vala"
		case OBJECTS_SOURCE_AVATAR_PATH_PROPERTY:
#line 22 "../core/Objects/Source.vala"
		g_value_set_string (value, objects_source_get_avatar_path (self));
#line 22 "../core/Objects/Source.vala"
		break;
#line 22 "../core/Objects/Source.vala"
		case OBJECTS_SOURCE_USER_DISPLAYNAME_PROPERTY:
#line 22 "../core/Objects/Source.vala"
		g_value_set_string (value, objects_source_get_user_displayname (self));
#line 22 "../core/Objects/Source.vala"
		break;
#line 22 "../core/Objects/Source.vala"
		case OBJECTS_SOURCE_USER_EMAIL_PROPERTY:
#line 22 "../core/Objects/Source.vala"
		g_value_set_string (value, objects_source_get_user_email (self));
#line 22 "../core/Objects/Source.vala"
		break;
#line 1539 "Source.c"
		default:
#line 22 "../core/Objects/Source.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 22 "../core/Objects/Source.vala"
		break;
#line 1545 "Source.c"
	}
}

static void
_vala_objects_source_set_property (GObject * object,
                                   guint property_id,
                                   const GValue * value,
                                   GParamSpec * pspec)
{
	ObjectsSource * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, OBJECTS_TYPE_SOURCE, ObjectsSource);
#line 22 "../core/Objects/Source.vala"
	switch (property_id) {
#line 22 "../core/Objects/Source.vala"
		case OBJECTS_SOURCE_SOURCE_TYPE_PROPERTY:
#line 22 "../core/Objects/Source.vala"
		objects_source_set_source_type (self, g_value_get_enum (value));
#line 22 "../core/Objects/Source.vala"
		break;
#line 22 "../core/Objects/Source.vala"
		case OBJECTS_SOURCE_ADDED_AT_PROPERTY:
#line 22 "../core/Objects/Source.vala"
		objects_source_set_added_at (self, g_value_get_string (value));
#line 22 "../core/Objects/Source.vala"
		break;
#line 22 "../core/Objects/Source.vala"
		case OBJECTS_SOURCE_UPDATED_AT_PROPERTY:
#line 22 "../core/Objects/Source.vala"
		objects_source_set_updated_at (self, g_value_get_string (value));
#line 22 "../core/Objects/Source.vala"
		break;
#line 22 "../core/Objects/Source.vala"
		case OBJECTS_SOURCE_IS_VISIBLE_PROPERTY:
#line 22 "../core/Objects/Source.vala"
		objects_source_set_is_visible (self, g_value_get_boolean (value));
#line 22 "../core/Objects/Source.vala"
		break;
#line 22 "../core/Objects/Source.vala"
		case OBJECTS_SOURCE_CHILD_ORDER_PROPERTY:
#line 22 "../core/Objects/Source.vala"
		objects_source_set_child_order (self, g_value_get_int (value));
#line 22 "../core/Objects/Source.vala"
		break;
#line 22 "../core/Objects/Source.vala"
		case OBJECTS_SOURCE_SYNC_SERVER_PROPERTY:
#line 22 "../core/Objects/Source.vala"
		objects_source_set_sync_server (self, g_value_get_boolean (value));
#line 22 "../core/Objects/Source.vala"
		break;
#line 22 "../core/Objects/Source.vala"
		case OBJECTS_SOURCE_LAST_SYNC_PROPERTY:
#line 22 "../core/Objects/Source.vala"
		objects_source_set_last_sync (self, g_value_get_string (value));
#line 22 "../core/Objects/Source.vala"
		break;
#line 22 "../core/Objects/Source.vala"
		case OBJECTS_SOURCE_DATA_PROPERTY:
#line 22 "../core/Objects/Source.vala"
		objects_source_set_data (self, g_value_get_object (value));
#line 22 "../core/Objects/Source.vala"
		break;
#line 22 "../core/Objects/Source.vala"
		case OBJECTS_SOURCE_DISPLAY_NAME_PROPERTY:
#line 22 "../core/Objects/Source.vala"
		objects_source_set_display_name (self, g_value_get_string (value));
#line 22 "../core/Objects/Source.vala"
		break;
#line 1613 "Source.c"
		default:
#line 22 "../core/Objects/Source.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 22 "../core/Objects/Source.vala"
		break;
#line 1619 "Source.c"
	}
}

static inline gpointer
objects_source_data_get_instance_private (ObjectsSourceData* self)
{
	return G_STRUCT_MEMBER_P (self, ObjectsSourceData_private_offset);
}

static gchar*
objects_source_data_real_to_json (ObjectsSourceData* self)
{
	gchar* _tmp0_;
	gchar* result;
#line 217 "../core/Objects/Source.vala"
	_tmp0_ = g_strdup ("");
#line 217 "../core/Objects/Source.vala"
	result = _tmp0_;
#line 217 "../core/Objects/Source.vala"
	return result;
#line 1640 "Source.c"
}

gchar*
objects_source_data_to_json (ObjectsSourceData* self)
{
	ObjectsSourceDataClass* _klass_;
#line 216 "../core/Objects/Source.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 216 "../core/Objects/Source.vala"
	_klass_ = OBJECTS_SOURCE_DATA_GET_CLASS (self);
#line 216 "../core/Objects/Source.vala"
	if (_klass_->to_json) {
#line 216 "../core/Objects/Source.vala"
		return _klass_->to_json (self);
#line 1655 "Source.c"
	}
#line 216 "../core/Objects/Source.vala"
	return NULL;
#line 1659 "Source.c"
}

ObjectsSourceData*
objects_source_data_construct (GType object_type)
{
	ObjectsSourceData * self = NULL;
#line 204 "../core/Objects/Source.vala"
	self = (ObjectsSourceData*) g_object_new (object_type, NULL);
#line 204 "../core/Objects/Source.vala"
	return self;
#line 1670 "Source.c"
}

ObjectsSourceData*
objects_source_data_new (void)
{
#line 204 "../core/Objects/Source.vala"
	return objects_source_data_construct (OBJECTS_TYPE_SOURCE_DATA);
#line 1678 "Source.c"
}

JsonBuilder*
objects_source_data_get_builder (ObjectsSourceData* self)
{
	JsonBuilder* result;
	JsonBuilder* _tmp0_;
	JsonBuilder* _tmp2_;
#line 207 "../core/Objects/Source.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 208 "../core/Objects/Source.vala"
	_tmp0_ = self->priv->_builder;
#line 208 "../core/Objects/Source.vala"
	if (_tmp0_ == NULL) {
#line 1693 "Source.c"
		JsonBuilder* _tmp1_;
#line 209 "../core/Objects/Source.vala"
		_tmp1_ = json_builder_new ();
#line 209 "../core/Objects/Source.vala"
		_g_object_unref0 (self->priv->_builder);
#line 209 "../core/Objects/Source.vala"
		self->priv->_builder = _tmp1_;
#line 1701 "Source.c"
	}
#line 212 "../core/Objects/Source.vala"
	_tmp2_ = self->priv->_builder;
#line 212 "../core/Objects/Source.vala"
	result = _tmp2_;
#line 212 "../core/Objects/Source.vala"
	return result;
#line 1709 "Source.c"
}

static void
objects_source_data_class_init (ObjectsSourceDataClass * klass,
                                gpointer klass_data)
{
#line 204 "../core/Objects/Source.vala"
	objects_source_data_parent_class = g_type_class_peek_parent (klass);
#line 204 "../core/Objects/Source.vala"
	g_type_class_adjust_private_offset (klass, &ObjectsSourceData_private_offset);
#line 204 "../core/Objects/Source.vala"
	((ObjectsSourceDataClass *) klass)->to_json = (gchar* (*) (ObjectsSourceData*)) objects_source_data_real_to_json;
#line 204 "../core/Objects/Source.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_objects_source_data_get_property;
#line 204 "../core/Objects/Source.vala"
	G_OBJECT_CLASS (klass)->finalize = objects_source_data_finalize;
#line 204 "../core/Objects/Source.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), OBJECTS_SOURCE_DATA_BUILDER_PROPERTY, objects_source_data_properties[OBJECTS_SOURCE_DATA_BUILDER_PROPERTY] = g_param_spec_object ("builder", "builder", "builder", json_builder_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 1728 "Source.c"
}

static void
objects_source_data_instance_init (ObjectsSourceData * self,
                                   gpointer klass)
{
#line 204 "../core/Objects/Source.vala"
	self->priv = objects_source_data_get_instance_private (self);
#line 1737 "Source.c"
}

static void
objects_source_data_finalize (GObject * obj)
{
	ObjectsSourceData * self;
#line 204 "../core/Objects/Source.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, OBJECTS_TYPE_SOURCE_DATA, ObjectsSourceData);
#line 205 "../core/Objects/Source.vala"
	_g_object_unref0 (self->priv->_builder);
#line 204 "../core/Objects/Source.vala"
	G_OBJECT_CLASS (objects_source_data_parent_class)->finalize (obj);
#line 1750 "Source.c"
}

static GType
objects_source_data_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ObjectsSourceDataClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) objects_source_data_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ObjectsSourceData), 0, (GInstanceInitFunc) objects_source_data_instance_init, NULL };
	GType objects_source_data_type_id;
	objects_source_data_type_id = g_type_register_static (G_TYPE_OBJECT, "ObjectsSourceData", &g_define_type_info, 0);
	ObjectsSourceData_private_offset = g_type_add_instance_private (objects_source_data_type_id, sizeof (ObjectsSourceDataPrivate));
	return objects_source_data_type_id;
}

GType
objects_source_data_get_type (void)
{
	static volatile gsize objects_source_data_type_id__once = 0;
	if (g_once_init_enter (&objects_source_data_type_id__once)) {
		GType objects_source_data_type_id;
		objects_source_data_type_id = objects_source_data_get_type_once ();
		g_once_init_leave (&objects_source_data_type_id__once, objects_source_data_type_id);
	}
	return objects_source_data_type_id__once;
}

static void
_vala_objects_source_data_get_property (GObject * object,
                                        guint property_id,
                                        GValue * value,
                                        GParamSpec * pspec)
{
	ObjectsSourceData * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, OBJECTS_TYPE_SOURCE_DATA, ObjectsSourceData);
#line 204 "../core/Objects/Source.vala"
	switch (property_id) {
#line 204 "../core/Objects/Source.vala"
		case OBJECTS_SOURCE_DATA_BUILDER_PROPERTY:
#line 204 "../core/Objects/Source.vala"
		g_value_set_object (value, objects_source_data_get_builder (self));
#line 204 "../core/Objects/Source.vala"
		break;
#line 1791 "Source.c"
		default:
#line 204 "../core/Objects/Source.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 204 "../core/Objects/Source.vala"
		break;
#line 1797 "Source.c"
	}
}

static inline gpointer
objects_source_todoist_data_get_instance_private (ObjectsSourceTodoistData* self)
{
	return G_STRUCT_MEMBER_P (self, ObjectsSourceTodoistData_private_offset);
}

static gpointer
_json_object_ref0 (gpointer self)
{
#line 235 "../core/Objects/Source.vala"
	return self ? json_object_ref (self) : NULL;
#line 1812 "Source.c"
}

ObjectsSourceTodoistData*
objects_source_todoist_data_construct_from_json (GType object_type,
                                                 const gchar* json)
{
	ObjectsSourceTodoistData * self = NULL;
	JsonParser* parser = NULL;
	JsonParser* _tmp0_;
	GError* _inner_error0_ = NULL;
#line 230 "../core/Objects/Source.vala"
	g_return_val_if_fail (json != NULL, NULL);
#line 230 "../core/Objects/Source.vala"
	self = (ObjectsSourceTodoistData*) objects_source_data_construct (object_type);
#line 231 "../core/Objects/Source.vala"
	_tmp0_ = json_parser_new ();
#line 231 "../core/Objects/Source.vala"
	parser = _tmp0_;
#line 1831 "Source.c"
	{
		JsonObject* object = NULL;
		JsonNode* _tmp1_;
		JsonObject* _tmp2_;
		JsonObject* _tmp3_;
		JsonObject* _tmp4_;
		JsonObject* _tmp7_;
		JsonObject* _tmp10_;
		JsonObject* _tmp13_;
		JsonObject* _tmp16_;
		JsonObject* _tmp19_;
		JsonObject* _tmp22_;
#line 234 "../core/Objects/Source.vala"
		json_parser_load_from_data (parser, json, (gssize) -1, &_inner_error0_);
#line 234 "../core/Objects/Source.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1848 "Source.c"
			goto __catch0_g_error;
		}
#line 235 "../core/Objects/Source.vala"
		_tmp1_ = json_parser_get_root (parser);
#line 235 "../core/Objects/Source.vala"
		_tmp2_ = json_node_get_object (_tmp1_);
#line 235 "../core/Objects/Source.vala"
		_tmp3_ = _json_object_ref0 (_tmp2_);
#line 235 "../core/Objects/Source.vala"
		object = _tmp3_;
#line 237 "../core/Objects/Source.vala"
		_tmp4_ = object;
#line 237 "../core/Objects/Source.vala"
		if (json_object_has_member (_tmp4_, "access_token")) {
#line 1863 "Source.c"
			JsonObject* _tmp5_;
			const gchar* _tmp6_;
#line 238 "../core/Objects/Source.vala"
			_tmp5_ = object;
#line 238 "../core/Objects/Source.vala"
			_tmp6_ = json_object_get_string_member (_tmp5_, "access_token");
#line 238 "../core/Objects/Source.vala"
			objects_source_todoist_data_set_access_token (self, _tmp6_);
#line 1872 "Source.c"
		}
#line 241 "../core/Objects/Source.vala"
		_tmp7_ = object;
#line 241 "../core/Objects/Source.vala"
		if (json_object_has_member (_tmp7_, "sync_token")) {
#line 1878 "Source.c"
			JsonObject* _tmp8_;
			const gchar* _tmp9_;
#line 242 "../core/Objects/Source.vala"
			_tmp8_ = object;
#line 242 "../core/Objects/Source.vala"
			_tmp9_ = json_object_get_string_member (_tmp8_, "sync_token");
#line 242 "../core/Objects/Source.vala"
			objects_source_todoist_data_set_sync_token (self, _tmp9_);
#line 1887 "Source.c"
		}
#line 245 "../core/Objects/Source.vala"
		_tmp10_ = object;
#line 245 "../core/Objects/Source.vala"
		if (json_object_has_member (_tmp10_, "user_image_id")) {
#line 1893 "Source.c"
			JsonObject* _tmp11_;
			const gchar* _tmp12_;
#line 246 "../core/Objects/Source.vala"
			_tmp11_ = object;
#line 246 "../core/Objects/Source.vala"
			_tmp12_ = json_object_get_string_member (_tmp11_, "user_image_id");
#line 246 "../core/Objects/Source.vala"
			objects_source_todoist_data_set_user_image_id (self, _tmp12_);
#line 1902 "Source.c"
		}
#line 249 "../core/Objects/Source.vala"
		_tmp13_ = object;
#line 249 "../core/Objects/Source.vala"
		if (json_object_has_member (_tmp13_, "user_email")) {
#line 1908 "Source.c"
			JsonObject* _tmp14_;
			const gchar* _tmp15_;
#line 250 "../core/Objects/Source.vala"
			_tmp14_ = object;
#line 250 "../core/Objects/Source.vala"
			_tmp15_ = json_object_get_string_member (_tmp14_, "user_email");
#line 250 "../core/Objects/Source.vala"
			objects_source_todoist_data_set_user_email (self, _tmp15_);
#line 1917 "Source.c"
		}
#line 253 "../core/Objects/Source.vala"
		_tmp16_ = object;
#line 253 "../core/Objects/Source.vala"
		if (json_object_has_member (_tmp16_, "user_name")) {
#line 1923 "Source.c"
			JsonObject* _tmp17_;
			const gchar* _tmp18_;
#line 254 "../core/Objects/Source.vala"
			_tmp17_ = object;
#line 254 "../core/Objects/Source.vala"
			_tmp18_ = json_object_get_string_member (_tmp17_, "user_name");
#line 254 "../core/Objects/Source.vala"
			objects_source_todoist_data_set_user_name (self, _tmp18_);
#line 1932 "Source.c"
		}
#line 257 "../core/Objects/Source.vala"
		_tmp19_ = object;
#line 257 "../core/Objects/Source.vala"
		if (json_object_has_member (_tmp19_, "user_avatar")) {
#line 1938 "Source.c"
			JsonObject* _tmp20_;
			const gchar* _tmp21_;
#line 258 "../core/Objects/Source.vala"
			_tmp20_ = object;
#line 258 "../core/Objects/Source.vala"
			_tmp21_ = json_object_get_string_member (_tmp20_, "user_avatar");
#line 258 "../core/Objects/Source.vala"
			objects_source_todoist_data_set_user_avatar (self, _tmp21_);
#line 1947 "Source.c"
		}
#line 261 "../core/Objects/Source.vala"
		_tmp22_ = object;
#line 261 "../core/Objects/Source.vala"
		if (json_object_has_member (_tmp22_, "user_is_premium")) {
#line 1953 "Source.c"
			JsonObject* _tmp23_;
#line 262 "../core/Objects/Source.vala"
			_tmp23_ = object;
#line 262 "../core/Objects/Source.vala"
			objects_source_todoist_data_set_user_is_premium (self, json_object_get_boolean_member (_tmp23_, "user_is_premium"));
#line 1959 "Source.c"
		}
#line 233 "../core/Objects/Source.vala"
		_json_object_unref0 (object);
#line 1963 "Source.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp24_;
		const gchar* _tmp25_;
#line 233 "../core/Objects/Source.vala"
		e = _inner_error0_;
#line 233 "../core/Objects/Source.vala"
		_inner_error0_ = NULL;
#line 265 "../core/Objects/Source.vala"
		_tmp24_ = e;
#line 265 "../core/Objects/Source.vala"
		_tmp25_ = _tmp24_->message;
#line 265 "../core/Objects/Source.vala"
		g_debug ("Source.vala:265: %s", _tmp25_);
#line 233 "../core/Objects/Source.vala"
		_g_error_free0 (e);
#line 1983 "Source.c"
	}
	__finally0:
#line 233 "../core/Objects/Source.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 233 "../core/Objects/Source.vala"
		_g_object_unref0 (parser);
#line 233 "../core/Objects/Source.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 233 "../core/Objects/Source.vala"
		g_clear_error (&_inner_error0_);
#line 233 "../core/Objects/Source.vala"
		return NULL;
#line 1996 "Source.c"
	}
#line 230 "../core/Objects/Source.vala"
	_g_object_unref0 (parser);
#line 230 "../core/Objects/Source.vala"
	return self;
#line 2002 "Source.c"
}

ObjectsSourceTodoistData*
objects_source_todoist_data_new_from_json (const gchar* json)
{
#line 230 "../core/Objects/Source.vala"
	return objects_source_todoist_data_construct_from_json (OBJECTS_TYPE_SOURCE_TODOIST_DATA, json);
#line 2010 "Source.c"
}

static void
_vala_JsonNode_free (JsonNode* self)
{
#line 301 "../core/Objects/Source.vala"
	g_boxed_free (json_node_get_type (), self);
#line 2018 "Source.c"
}

static gchar*
objects_source_todoist_data_real_to_json (ObjectsSourceData* base)
{
	ObjectsSourceTodoistData * self;
	JsonBuilder* _tmp0_;
	JsonBuilder* _tmp1_;
	JsonBuilder* _tmp2_;
	JsonBuilder* _tmp3_;
	JsonBuilder* _tmp4_;
	JsonBuilder* _tmp5_;
	JsonBuilder* _tmp6_;
	JsonBuilder* _tmp7_;
	const gchar* _tmp8_;
	JsonBuilder* _tmp9_;
	JsonBuilder* _tmp10_;
	JsonBuilder* _tmp11_;
	JsonBuilder* _tmp12_;
	const gchar* _tmp13_;
	JsonBuilder* _tmp14_;
	JsonBuilder* _tmp15_;
	JsonBuilder* _tmp16_;
	JsonBuilder* _tmp17_;
	const gchar* _tmp18_;
	JsonBuilder* _tmp19_;
	JsonBuilder* _tmp20_;
	JsonBuilder* _tmp21_;
	JsonBuilder* _tmp22_;
	const gchar* _tmp23_;
	JsonBuilder* _tmp24_;
	JsonBuilder* _tmp25_;
	JsonBuilder* _tmp26_;
	JsonBuilder* _tmp27_;
	const gchar* _tmp28_;
	JsonBuilder* _tmp29_;
	JsonBuilder* _tmp30_;
	JsonBuilder* _tmp31_;
	JsonBuilder* _tmp32_;
	const gchar* _tmp33_;
	JsonBuilder* _tmp34_;
	JsonBuilder* _tmp35_;
	JsonBuilder* _tmp36_;
	JsonBuilder* _tmp37_;
	gboolean _tmp38_;
	JsonBuilder* _tmp39_;
	JsonBuilder* _tmp40_;
	JsonGenerator* generator = NULL;
	JsonGenerator* _tmp41_;
	JsonNode* root = NULL;
	JsonBuilder* _tmp42_;
	JsonBuilder* _tmp43_;
	JsonNode* _tmp44_;
	gchar* _tmp45_;
	gchar* result;
#line 269 "../core/Objects/Source.vala"
	self = (ObjectsSourceTodoistData*) base;
#line 270 "../core/Objects/Source.vala"
	_tmp0_ = objects_source_data_get_builder ((ObjectsSourceData*) self);
#line 270 "../core/Objects/Source.vala"
	_tmp1_ = _tmp0_;
#line 270 "../core/Objects/Source.vala"
	json_builder_reset (_tmp1_);
#line 272 "../core/Objects/Source.vala"
	_tmp2_ = objects_source_data_get_builder ((ObjectsSourceData*) self);
#line 272 "../core/Objects/Source.vala"
	_tmp3_ = _tmp2_;
#line 272 "../core/Objects/Source.vala"
	json_builder_begin_object (_tmp3_);
#line 274 "../core/Objects/Source.vala"
	_tmp4_ = objects_source_data_get_builder ((ObjectsSourceData*) self);
#line 274 "../core/Objects/Source.vala"
	_tmp5_ = _tmp4_;
#line 274 "../core/Objects/Source.vala"
	json_builder_set_member_name (_tmp5_, "access_token");
#line 275 "../core/Objects/Source.vala"
	_tmp6_ = objects_source_data_get_builder ((ObjectsSourceData*) self);
#line 275 "../core/Objects/Source.vala"
	_tmp7_ = _tmp6_;
#line 275 "../core/Objects/Source.vala"
	_tmp8_ = self->priv->_access_token;
#line 275 "../core/Objects/Source.vala"
	json_builder_add_string_value (_tmp7_, _tmp8_);
#line 277 "../core/Objects/Source.vala"
	_tmp9_ = objects_source_data_get_builder ((ObjectsSourceData*) self);
#line 277 "../core/Objects/Source.vala"
	_tmp10_ = _tmp9_;
#line 277 "../core/Objects/Source.vala"
	json_builder_set_member_name (_tmp10_, "sync_token");
#line 278 "../core/Objects/Source.vala"
	_tmp11_ = objects_source_data_get_builder ((ObjectsSourceData*) self);
#line 278 "../core/Objects/Source.vala"
	_tmp12_ = _tmp11_;
#line 278 "../core/Objects/Source.vala"
	_tmp13_ = self->priv->_sync_token;
#line 278 "../core/Objects/Source.vala"
	json_builder_add_string_value (_tmp12_, _tmp13_);
#line 280 "../core/Objects/Source.vala"
	_tmp14_ = objects_source_data_get_builder ((ObjectsSourceData*) self);
#line 280 "../core/Objects/Source.vala"
	_tmp15_ = _tmp14_;
#line 280 "../core/Objects/Source.vala"
	json_builder_set_member_name (_tmp15_, "user_image_id");
#line 281 "../core/Objects/Source.vala"
	_tmp16_ = objects_source_data_get_builder ((ObjectsSourceData*) self);
#line 281 "../core/Objects/Source.vala"
	_tmp17_ = _tmp16_;
#line 281 "../core/Objects/Source.vala"
	_tmp18_ = self->priv->_user_image_id;
#line 281 "../core/Objects/Source.vala"
	json_builder_add_string_value (_tmp17_, _tmp18_);
#line 283 "../core/Objects/Source.vala"
	_tmp19_ = objects_source_data_get_builder ((ObjectsSourceData*) self);
#line 283 "../core/Objects/Source.vala"
	_tmp20_ = _tmp19_;
#line 283 "../core/Objects/Source.vala"
	json_builder_set_member_name (_tmp20_, "user_email");
#line 284 "../core/Objects/Source.vala"
	_tmp21_ = objects_source_data_get_builder ((ObjectsSourceData*) self);
#line 284 "../core/Objects/Source.vala"
	_tmp22_ = _tmp21_;
#line 284 "../core/Objects/Source.vala"
	_tmp23_ = self->priv->_user_email;
#line 284 "../core/Objects/Source.vala"
	json_builder_add_string_value (_tmp22_, _tmp23_);
#line 286 "../core/Objects/Source.vala"
	_tmp24_ = objects_source_data_get_builder ((ObjectsSourceData*) self);
#line 286 "../core/Objects/Source.vala"
	_tmp25_ = _tmp24_;
#line 286 "../core/Objects/Source.vala"
	json_builder_set_member_name (_tmp25_, "user_name");
#line 287 "../core/Objects/Source.vala"
	_tmp26_ = objects_source_data_get_builder ((ObjectsSourceData*) self);
#line 287 "../core/Objects/Source.vala"
	_tmp27_ = _tmp26_;
#line 287 "../core/Objects/Source.vala"
	_tmp28_ = self->priv->_user_name;
#line 287 "../core/Objects/Source.vala"
	json_builder_add_string_value (_tmp27_, _tmp28_);
#line 289 "../core/Objects/Source.vala"
	_tmp29_ = objects_source_data_get_builder ((ObjectsSourceData*) self);
#line 289 "../core/Objects/Source.vala"
	_tmp30_ = _tmp29_;
#line 289 "../core/Objects/Source.vala"
	json_builder_set_member_name (_tmp30_, "user_avatar");
#line 290 "../core/Objects/Source.vala"
	_tmp31_ = objects_source_data_get_builder ((ObjectsSourceData*) self);
#line 290 "../core/Objects/Source.vala"
	_tmp32_ = _tmp31_;
#line 290 "../core/Objects/Source.vala"
	_tmp33_ = self->priv->_user_avatar;
#line 290 "../core/Objects/Source.vala"
	json_builder_add_string_value (_tmp32_, _tmp33_);
#line 292 "../core/Objects/Source.vala"
	_tmp34_ = objects_source_data_get_builder ((ObjectsSourceData*) self);
#line 292 "../core/Objects/Source.vala"
	_tmp35_ = _tmp34_;
#line 292 "../core/Objects/Source.vala"
	json_builder_set_member_name (_tmp35_, "user_is_premium");
#line 293 "../core/Objects/Source.vala"
	_tmp36_ = objects_source_data_get_builder ((ObjectsSourceData*) self);
#line 293 "../core/Objects/Source.vala"
	_tmp37_ = _tmp36_;
#line 293 "../core/Objects/Source.vala"
	_tmp38_ = self->priv->_user_is_premium;
#line 293 "../core/Objects/Source.vala"
	json_builder_add_boolean_value (_tmp37_, _tmp38_);
#line 295 "../core/Objects/Source.vala"
	_tmp39_ = objects_source_data_get_builder ((ObjectsSourceData*) self);
#line 295 "../core/Objects/Source.vala"
	_tmp40_ = _tmp39_;
#line 295 "../core/Objects/Source.vala"
	json_builder_end_object (_tmp40_);
#line 297 "../core/Objects/Source.vala"
	_tmp41_ = json_generator_new ();
#line 297 "../core/Objects/Source.vala"
	generator = _tmp41_;
#line 298 "../core/Objects/Source.vala"
	_tmp42_ = objects_source_data_get_builder ((ObjectsSourceData*) self);
#line 298 "../core/Objects/Source.vala"
	_tmp43_ = _tmp42_;
#line 298 "../core/Objects/Source.vala"
	_tmp44_ = json_builder_get_root (_tmp43_);
#line 298 "../core/Objects/Source.vala"
	root = _tmp44_;
#line 299 "../core/Objects/Source.vala"
	json_generator_set_root (generator, root);
#line 301 "../core/Objects/Source.vala"
	_tmp45_ = json_generator_to_data (generator, NULL);
#line 301 "../core/Objects/Source.vala"
	result = _tmp45_;
#line 301 "../core/Objects/Source.vala"
	__vala_JsonNode_free0 (root);
#line 301 "../core/Objects/Source.vala"
	_g_object_unref0 (generator);
#line 301 "../core/Objects/Source.vala"
	return result;
#line 2216 "Source.c"
}

ObjectsSourceTodoistData*
objects_source_todoist_data_construct (GType object_type)
{
	ObjectsSourceTodoistData * self = NULL;
#line 221 "../core/Objects/Source.vala"
	self = (ObjectsSourceTodoistData*) objects_source_data_construct (object_type);
#line 221 "../core/Objects/Source.vala"
	return self;
#line 2227 "Source.c"
}

ObjectsSourceTodoistData*
objects_source_todoist_data_new (void)
{
#line 221 "../core/Objects/Source.vala"
	return objects_source_todoist_data_construct (OBJECTS_TYPE_SOURCE_TODOIST_DATA);
#line 2235 "Source.c"
}

const gchar*
objects_source_todoist_data_get_access_token (ObjectsSourceTodoistData* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 222 "../core/Objects/Source.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 222 "../core/Objects/Source.vala"
	_tmp0_ = self->priv->_access_token;
#line 222 "../core/Objects/Source.vala"
	result = _tmp0_;
#line 222 "../core/Objects/Source.vala"
	return result;
#line 2251 "Source.c"
}

void
objects_source_todoist_data_set_access_token (ObjectsSourceTodoistData* self,
                                              const gchar* value)
{
	gchar* old_value;
#line 222 "../core/Objects/Source.vala"
	g_return_if_fail (self != NULL);
#line 222 "../core/Objects/Source.vala"
	old_value = objects_source_todoist_data_get_access_token (self);
#line 222 "../core/Objects/Source.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 2265 "Source.c"
		gchar* _tmp0_;
#line 222 "../core/Objects/Source.vala"
		_tmp0_ = g_strdup (value);
#line 222 "../core/Objects/Source.vala"
		_g_free0 (self->priv->_access_token);
#line 222 "../core/Objects/Source.vala"
		self->priv->_access_token = _tmp0_;
#line 222 "../core/Objects/Source.vala"
		g_object_notify_by_pspec ((GObject *) self, objects_source_todoist_data_properties[OBJECTS_SOURCE_TODOIST_DATA_ACCESS_TOKEN_PROPERTY]);
#line 2275 "Source.c"
	}
}

const gchar*
objects_source_todoist_data_get_sync_token (ObjectsSourceTodoistData* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 223 "../core/Objects/Source.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 223 "../core/Objects/Source.vala"
	_tmp0_ = self->priv->_sync_token;
#line 223 "../core/Objects/Source.vala"
	result = _tmp0_;
#line 223 "../core/Objects/Source.vala"
	return result;
#line 2292 "Source.c"
}

void
objects_source_todoist_data_set_sync_token (ObjectsSourceTodoistData* self,
                                            const gchar* value)
{
	gchar* old_value;
#line 223 "../core/Objects/Source.vala"
	g_return_if_fail (self != NULL);
#line 223 "../core/Objects/Source.vala"
	old_value = objects_source_todoist_data_get_sync_token (self);
#line 223 "../core/Objects/Source.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 2306 "Source.c"
		gchar* _tmp0_;
#line 223 "../core/Objects/Source.vala"
		_tmp0_ = g_strdup (value);
#line 223 "../core/Objects/Source.vala"
		_g_free0 (self->priv->_sync_token);
#line 223 "../core/Objects/Source.vala"
		self->priv->_sync_token = _tmp0_;
#line 223 "../core/Objects/Source.vala"
		g_object_notify_by_pspec ((GObject *) self, objects_source_todoist_data_properties[OBJECTS_SOURCE_TODOIST_DATA_SYNC_TOKEN_PROPERTY]);
#line 2316 "Source.c"
	}
}

const gchar*
objects_source_todoist_data_get_user_image_id (ObjectsSourceTodoistData* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 224 "../core/Objects/Source.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 224 "../core/Objects/Source.vala"
	_tmp0_ = self->priv->_user_image_id;
#line 224 "../core/Objects/Source.vala"
	result = _tmp0_;
#line 224 "../core/Objects/Source.vala"
	return result;
#line 2333 "Source.c"
}

void
objects_source_todoist_data_set_user_image_id (ObjectsSourceTodoistData* self,
                                               const gchar* value)
{
	gchar* old_value;
#line 224 "../core/Objects/Source.vala"
	g_return_if_fail (self != NULL);
#line 224 "../core/Objects/Source.vala"
	old_value = objects_source_todoist_data_get_user_image_id (self);
#line 224 "../core/Objects/Source.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 2347 "Source.c"
		gchar* _tmp0_;
#line 224 "../core/Objects/Source.vala"
		_tmp0_ = g_strdup (value);
#line 224 "../core/Objects/Source.vala"
		_g_free0 (self->priv->_user_image_id);
#line 224 "../core/Objects/Source.vala"
		self->priv->_user_image_id = _tmp0_;
#line 224 "../core/Objects/Source.vala"
		g_object_notify_by_pspec ((GObject *) self, objects_source_todoist_data_properties[OBJECTS_SOURCE_TODOIST_DATA_USER_IMAGE_ID_PROPERTY]);
#line 2357 "Source.c"
	}
}

const gchar*
objects_source_todoist_data_get_user_email (ObjectsSourceTodoistData* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 225 "../core/Objects/Source.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 225 "../core/Objects/Source.vala"
	_tmp0_ = self->priv->_user_email;
#line 225 "../core/Objects/Source.vala"
	result = _tmp0_;
#line 225 "../core/Objects/Source.vala"
	return result;
#line 2374 "Source.c"
}

void
objects_source_todoist_data_set_user_email (ObjectsSourceTodoistData* self,
                                            const gchar* value)
{
	gchar* old_value;
#line 225 "../core/Objects/Source.vala"
	g_return_if_fail (self != NULL);
#line 225 "../core/Objects/Source.vala"
	old_value = objects_source_todoist_data_get_user_email (self);
#line 225 "../core/Objects/Source.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 2388 "Source.c"
		gchar* _tmp0_;
#line 225 "../core/Objects/Source.vala"
		_tmp0_ = g_strdup (value);
#line 225 "../core/Objects/Source.vala"
		_g_free0 (self->priv->_user_email);
#line 225 "../core/Objects/Source.vala"
		self->priv->_user_email = _tmp0_;
#line 225 "../core/Objects/Source.vala"
		g_object_notify_by_pspec ((GObject *) self, objects_source_todoist_data_properties[OBJECTS_SOURCE_TODOIST_DATA_USER_EMAIL_PROPERTY]);
#line 2398 "Source.c"
	}
}

const gchar*
objects_source_todoist_data_get_user_name (ObjectsSourceTodoistData* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 226 "../core/Objects/Source.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 226 "../core/Objects/Source.vala"
	_tmp0_ = self->priv->_user_name;
#line 226 "../core/Objects/Source.vala"
	result = _tmp0_;
#line 226 "../core/Objects/Source.vala"
	return result;
#line 2415 "Source.c"
}

void
objects_source_todoist_data_set_user_name (ObjectsSourceTodoistData* self,
                                           const gchar* value)
{
	gchar* old_value;
#line 226 "../core/Objects/Source.vala"
	g_return_if_fail (self != NULL);
#line 226 "../core/Objects/Source.vala"
	old_value = objects_source_todoist_data_get_user_name (self);
#line 226 "../core/Objects/Source.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 2429 "Source.c"
		gchar* _tmp0_;
#line 226 "../core/Objects/Source.vala"
		_tmp0_ = g_strdup (value);
#line 226 "../core/Objects/Source.vala"
		_g_free0 (self->priv->_user_name);
#line 226 "../core/Objects/Source.vala"
		self->priv->_user_name = _tmp0_;
#line 226 "../core/Objects/Source.vala"
		g_object_notify_by_pspec ((GObject *) self, objects_source_todoist_data_properties[OBJECTS_SOURCE_TODOIST_DATA_USER_NAME_PROPERTY]);
#line 2439 "Source.c"
	}
}

const gchar*
objects_source_todoist_data_get_user_avatar (ObjectsSourceTodoistData* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 227 "../core/Objects/Source.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 227 "../core/Objects/Source.vala"
	_tmp0_ = self->priv->_user_avatar;
#line 227 "../core/Objects/Source.vala"
	result = _tmp0_;
#line 227 "../core/Objects/Source.vala"
	return result;
#line 2456 "Source.c"
}

void
objects_source_todoist_data_set_user_avatar (ObjectsSourceTodoistData* self,
                                             const gchar* value)
{
	gchar* old_value;
#line 227 "../core/Objects/Source.vala"
	g_return_if_fail (self != NULL);
#line 227 "../core/Objects/Source.vala"
	old_value = objects_source_todoist_data_get_user_avatar (self);
#line 227 "../core/Objects/Source.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 2470 "Source.c"
		gchar* _tmp0_;
#line 227 "../core/Objects/Source.vala"
		_tmp0_ = g_strdup (value);
#line 227 "../core/Objects/Source.vala"
		_g_free0 (self->priv->_user_avatar);
#line 227 "../core/Objects/Source.vala"
		self->priv->_user_avatar = _tmp0_;
#line 227 "../core/Objects/Source.vala"
		g_object_notify_by_pspec ((GObject *) self, objects_source_todoist_data_properties[OBJECTS_SOURCE_TODOIST_DATA_USER_AVATAR_PROPERTY]);
#line 2480 "Source.c"
	}
}

gboolean
objects_source_todoist_data_get_user_is_premium (ObjectsSourceTodoistData* self)
{
	gboolean result;
#line 228 "../core/Objects/Source.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 228 "../core/Objects/Source.vala"
	result = self->priv->_user_is_premium;
#line 228 "../core/Objects/Source.vala"
	return result;
#line 2494 "Source.c"
}

void
objects_source_todoist_data_set_user_is_premium (ObjectsSourceTodoistData* self,
                                                 gboolean value)
{
	gboolean old_value;
#line 228 "../core/Objects/Source.vala"
	g_return_if_fail (self != NULL);
#line 228 "../core/Objects/Source.vala"
	old_value = objects_source_todoist_data_get_user_is_premium (self);
#line 228 "../core/Objects/Source.vala"
	if (old_value != value) {
#line 228 "../core/Objects/Source.vala"
		self->priv->_user_is_premium = value;
#line 228 "../core/Objects/Source.vala"
		g_object_notify_by_pspec ((GObject *) self, objects_source_todoist_data_properties[OBJECTS_SOURCE_TODOIST_DATA_USER_IS_PREMIUM_PROPERTY]);
#line 2512 "Source.c"
	}
}

static void
objects_source_todoist_data_class_init (ObjectsSourceTodoistDataClass * klass,
                                        gpointer klass_data)
{
#line 221 "../core/Objects/Source.vala"
	objects_source_todoist_data_parent_class = g_type_class_peek_parent (klass);
#line 221 "../core/Objects/Source.vala"
	g_type_class_adjust_private_offset (klass, &ObjectsSourceTodoistData_private_offset);
#line 221 "../core/Objects/Source.vala"
	((ObjectsSourceDataClass *) klass)->to_json = (gchar* (*) (ObjectsSourceData*)) objects_source_todoist_data_real_to_json;
#line 221 "../core/Objects/Source.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_objects_source_todoist_data_get_property;
#line 221 "../core/Objects/Source.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_objects_source_todoist_data_set_property;
#line 221 "../core/Objects/Source.vala"
	G_OBJECT_CLASS (klass)->finalize = objects_source_todoist_data_finalize;
#line 221 "../core/Objects/Source.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), OBJECTS_SOURCE_TODOIST_DATA_ACCESS_TOKEN_PROPERTY, objects_source_todoist_data_properties[OBJECTS_SOURCE_TODOIST_DATA_ACCESS_TOKEN_PROPERTY] = g_param_spec_string ("access-token", "access-token", "access-token", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 221 "../core/Objects/Source.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), OBJECTS_SOURCE_TODOIST_DATA_SYNC_TOKEN_PROPERTY, objects_source_todoist_data_properties[OBJECTS_SOURCE_TODOIST_DATA_SYNC_TOKEN_PROPERTY] = g_param_spec_string ("sync-token", "sync-token", "sync-token", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 221 "../core/Objects/Source.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), OBJECTS_SOURCE_TODOIST_DATA_USER_IMAGE_ID_PROPERTY, objects_source_todoist_data_properties[OBJECTS_SOURCE_TODOIST_DATA_USER_IMAGE_ID_PROPERTY] = g_param_spec_string ("user-image-id", "user-image-id", "user-image-id", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 221 "../core/Objects/Source.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), OBJECTS_SOURCE_TODOIST_DATA_USER_EMAIL_PROPERTY, objects_source_todoist_data_properties[OBJECTS_SOURCE_TODOIST_DATA_USER_EMAIL_PROPERTY] = g_param_spec_string ("user-email", "user-email", "user-email", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 221 "../core/Objects/Source.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), OBJECTS_SOURCE_TODOIST_DATA_USER_NAME_PROPERTY, objects_source_todoist_data_properties[OBJECTS_SOURCE_TODOIST_DATA_USER_NAME_PROPERTY] = g_param_spec_string ("user-name", "user-name", "user-name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 221 "../core/Objects/Source.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), OBJECTS_SOURCE_TODOIST_DATA_USER_AVATAR_PROPERTY, objects_source_todoist_data_properties[OBJECTS_SOURCE_TODOIST_DATA_USER_AVATAR_PROPERTY] = g_param_spec_string ("user-avatar", "user-avatar", "user-avatar", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 221 "../core/Objects/Source.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), OBJECTS_SOURCE_TODOIST_DATA_USER_IS_PREMIUM_PROPERTY, objects_source_todoist_data_properties[OBJECTS_SOURCE_TODOIST_DATA_USER_IS_PREMIUM_PROPERTY] = g_param_spec_boolean ("user-is-premium", "user-is-premium", "user-is-premium", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 2546 "Source.c"
}

static void
objects_source_todoist_data_instance_init (ObjectsSourceTodoistData * self,
                                           gpointer klass)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
#line 221 "../core/Objects/Source.vala"
	self->priv = objects_source_todoist_data_get_instance_private (self);
#line 222 "../core/Objects/Source.vala"
	_tmp0_ = g_strdup ("");
#line 222 "../core/Objects/Source.vala"
	self->priv->_access_token = _tmp0_;
#line 223 "../core/Objects/Source.vala"
	_tmp1_ = g_strdup ("");
#line 223 "../core/Objects/Source.vala"
	self->priv->_sync_token = _tmp1_;
#line 224 "../core/Objects/Source.vala"
	_tmp2_ = g_strdup ("");
#line 224 "../core/Objects/Source.vala"
	self->priv->_user_image_id = _tmp2_;
#line 225 "../core/Objects/Source.vala"
	_tmp3_ = g_strdup ("");
#line 225 "../core/Objects/Source.vala"
	self->priv->_user_email = _tmp3_;
#line 226 "../core/Objects/Source.vala"
	_tmp4_ = g_strdup ("");
#line 226 "../core/Objects/Source.vala"
	self->priv->_user_name = _tmp4_;
#line 227 "../core/Objects/Source.vala"
	_tmp5_ = g_strdup ("");
#line 227 "../core/Objects/Source.vala"
	self->priv->_user_avatar = _tmp5_;
#line 228 "../core/Objects/Source.vala"
	self->priv->_user_is_premium = FALSE;
#line 2587 "Source.c"
}

static void
objects_source_todoist_data_finalize (GObject * obj)
{
	ObjectsSourceTodoistData * self;
#line 221 "../core/Objects/Source.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, OBJECTS_TYPE_SOURCE_TODOIST_DATA, ObjectsSourceTodoistData);
#line 222 "../core/Objects/Source.vala"
	_g_free0 (self->priv->_access_token);
#line 223 "../core/Objects/Source.vala"
	_g_free0 (self->priv->_sync_token);
#line 224 "../core/Objects/Source.vala"
	_g_free0 (self->priv->_user_image_id);
#line 225 "../core/Objects/Source.vala"
	_g_free0 (self->priv->_user_email);
#line 226 "../core/Objects/Source.vala"
	_g_free0 (self->priv->_user_name);
#line 227 "../core/Objects/Source.vala"
	_g_free0 (self->priv->_user_avatar);
#line 221 "../core/Objects/Source.vala"
	G_OBJECT_CLASS (objects_source_todoist_data_parent_class)->finalize (obj);
#line 2610 "Source.c"
}

static GType
objects_source_todoist_data_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ObjectsSourceTodoistDataClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) objects_source_todoist_data_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ObjectsSourceTodoistData), 0, (GInstanceInitFunc) objects_source_todoist_data_instance_init, NULL };
	GType objects_source_todoist_data_type_id;
	objects_source_todoist_data_type_id = g_type_register_static (OBJECTS_TYPE_SOURCE_DATA, "ObjectsSourceTodoistData", &g_define_type_info, 0);
	ObjectsSourceTodoistData_private_offset = g_type_add_instance_private (objects_source_todoist_data_type_id, sizeof (ObjectsSourceTodoistDataPrivate));
	return objects_source_todoist_data_type_id;
}

GType
objects_source_todoist_data_get_type (void)
{
	static volatile gsize objects_source_todoist_data_type_id__once = 0;
	if (g_once_init_enter (&objects_source_todoist_data_type_id__once)) {
		GType objects_source_todoist_data_type_id;
		objects_source_todoist_data_type_id = objects_source_todoist_data_get_type_once ();
		g_once_init_leave (&objects_source_todoist_data_type_id__once, objects_source_todoist_data_type_id);
	}
	return objects_source_todoist_data_type_id__once;
}

static void
_vala_objects_source_todoist_data_get_property (GObject * object,
                                                guint property_id,
                                                GValue * value,
                                                GParamSpec * pspec)
{
	ObjectsSourceTodoistData * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, OBJECTS_TYPE_SOURCE_TODOIST_DATA, ObjectsSourceTodoistData);
#line 221 "../core/Objects/Source.vala"
	switch (property_id) {
#line 221 "../core/Objects/Source.vala"
		case OBJECTS_SOURCE_TODOIST_DATA_ACCESS_TOKEN_PROPERTY:
#line 221 "../core/Objects/Source.vala"
		g_value_set_string (value, objects_source_todoist_data_get_access_token (self));
#line 221 "../core/Objects/Source.vala"
		break;
#line 221 "../core/Objects/Source.vala"
		case OBJECTS_SOURCE_TODOIST_DATA_SYNC_TOKEN_PROPERTY:
#line 221 "../core/Objects/Source.vala"
		g_value_set_string (value, objects_source_todoist_data_get_sync_token (self));
#line 221 "../core/Objects/Source.vala"
		break;
#line 221 "../core/Objects/Source.vala"
		case OBJECTS_SOURCE_TODOIST_DATA_USER_IMAGE_ID_PROPERTY:
#line 221 "../core/Objects/Source.vala"
		g_value_set_string (value, objects_source_todoist_data_get_user_image_id (self));
#line 221 "../core/Objects/Source.vala"
		break;
#line 221 "../core/Objects/Source.vala"
		case OBJECTS_SOURCE_TODOIST_DATA_USER_EMAIL_PROPERTY:
#line 221 "../core/Objects/Source.vala"
		g_value_set_string (value, objects_source_todoist_data_get_user_email (self));
#line 221 "../core/Objects/Source.vala"
		break;
#line 221 "../core/Objects/Source.vala"
		case OBJECTS_SOURCE_TODOIST_DATA_USER_NAME_PROPERTY:
#line 221 "../core/Objects/Source.vala"
		g_value_set_string (value, objects_source_todoist_data_get_user_name (self));
#line 221 "../core/Objects/Source.vala"
		break;
#line 221 "../core/Objects/Source.vala"
		case OBJECTS_SOURCE_TODOIST_DATA_USER_AVATAR_PROPERTY:
#line 221 "../core/Objects/Source.vala"
		g_value_set_string (value, objects_source_todoist_data_get_user_avatar (self));
#line 221 "../core/Objects/Source.vala"
		break;
#line 221 "../core/Objects/Source.vala"
		case OBJECTS_SOURCE_TODOIST_DATA_USER_IS_PREMIUM_PROPERTY:
#line 221 "../core/Objects/Source.vala"
		g_value_set_boolean (value, objects_source_todoist_data_get_user_is_premium (self));
#line 221 "../core/Objects/Source.vala"
		break;
#line 2687 "Source.c"
		default:
#line 221 "../core/Objects/Source.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 221 "../core/Objects/Source.vala"
		break;
#line 2693 "Source.c"
	}
}

static void
_vala_objects_source_todoist_data_set_property (GObject * object,
                                                guint property_id,
                                                const GValue * value,
                                                GParamSpec * pspec)
{
	ObjectsSourceTodoistData * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, OBJECTS_TYPE_SOURCE_TODOIST_DATA, ObjectsSourceTodoistData);
#line 221 "../core/Objects/Source.vala"
	switch (property_id) {
#line 221 "../core/Objects/Source.vala"
		case OBJECTS_SOURCE_TODOIST_DATA_ACCESS_TOKEN_PROPERTY:
#line 221 "../core/Objects/Source.vala"
		objects_source_todoist_data_set_access_token (self, g_value_get_string (value));
#line 221 "../core/Objects/Source.vala"
		break;
#line 221 "../core/Objects/Source.vala"
		case OBJECTS_SOURCE_TODOIST_DATA_SYNC_TOKEN_PROPERTY:
#line 221 "../core/Objects/Source.vala"
		objects_source_todoist_data_set_sync_token (self, g_value_get_string (value));
#line 221 "../core/Objects/Source.vala"
		break;
#line 221 "../core/Objects/Source.vala"
		case OBJECTS_SOURCE_TODOIST_DATA_USER_IMAGE_ID_PROPERTY:
#line 221 "../core/Objects/Source.vala"
		objects_source_todoist_data_set_user_image_id (self, g_value_get_string (value));
#line 221 "../core/Objects/Source.vala"
		break;
#line 221 "../core/Objects/Source.vala"
		case OBJECTS_SOURCE_TODOIST_DATA_USER_EMAIL_PROPERTY:
#line 221 "../core/Objects/Source.vala"
		objects_source_todoist_data_set_user_email (self, g_value_get_string (value));
#line 221 "../core/Objects/Source.vala"
		break;
#line 221 "../core/Objects/Source.vala"
		case OBJECTS_SOURCE_TODOIST_DATA_USER_NAME_PROPERTY:
#line 221 "../core/Objects/Source.vala"
		objects_source_todoist_data_set_user_name (self, g_value_get_string (value));
#line 221 "../core/Objects/Source.vala"
		break;
#line 221 "../core/Objects/Source.vala"
		case OBJECTS_SOURCE_TODOIST_DATA_USER_AVATAR_PROPERTY:
#line 221 "../core/Objects/Source.vala"
		objects_source_todoist_data_set_user_avatar (self, g_value_get_string (value));
#line 221 "../core/Objects/Source.vala"
		break;
#line 221 "../core/Objects/Source.vala"
		case OBJECTS_SOURCE_TODOIST_DATA_USER_IS_PREMIUM_PROPERTY:
#line 221 "../core/Objects/Source.vala"
		objects_source_todoist_data_set_user_is_premium (self, g_value_get_boolean (value));
#line 221 "../core/Objects/Source.vala"
		break;
#line 2749 "Source.c"
		default:
#line 221 "../core/Objects/Source.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 221 "../core/Objects/Source.vala"
		break;
#line 2755 "Source.c"
	}
}

static inline gpointer
objects_source_cal_dav_data_get_instance_private (ObjectsSourceCalDAVData* self)
{
	return G_STRUCT_MEMBER_P (self, ObjectsSourceCalDAVData_private_offset);
}

ObjectsSourceCalDAVData*
objects_source_cal_dav_data_construct_from_json (GType object_type,
                                                 const gchar* json)
{
	ObjectsSourceCalDAVData * self = NULL;
	JsonParser* parser = NULL;
	JsonParser* _tmp0_;
	GError* _inner_error0_ = NULL;
#line 313 "../core/Objects/Source.vala"
	g_return_val_if_fail (json != NULL, NULL);
#line 313 "../core/Objects/Source.vala"
	self = (ObjectsSourceCalDAVData*) objects_source_data_construct (object_type);
#line 314 "../core/Objects/Source.vala"
	_tmp0_ = json_parser_new ();
#line 314 "../core/Objects/Source.vala"
	parser = _tmp0_;
#line 2781 "Source.c"
	{
		JsonObject* object = NULL;
		JsonNode* _tmp1_;
		JsonObject* _tmp2_;
		JsonObject* _tmp3_;
		JsonObject* _tmp4_;
		JsonObject* _tmp7_;
		JsonObject* _tmp10_;
		JsonObject* _tmp13_;
		JsonObject* _tmp16_;
		JsonObject* _tmp19_;
#line 317 "../core/Objects/Source.vala"
		json_parser_load_from_data (parser, json, (gssize) -1, &_inner_error0_);
#line 317 "../core/Objects/Source.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2797 "Source.c"
			goto __catch0_g_error;
		}
#line 318 "../core/Objects/Source.vala"
		_tmp1_ = json_parser_get_root (parser);
#line 318 "../core/Objects/Source.vala"
		_tmp2_ = json_node_get_object (_tmp1_);
#line 318 "../core/Objects/Source.vala"
		_tmp3_ = _json_object_ref0 (_tmp2_);
#line 318 "../core/Objects/Source.vala"
		object = _tmp3_;
#line 320 "../core/Objects/Source.vala"
		_tmp4_ = object;
#line 320 "../core/Objects/Source.vala"
		if (json_object_has_member (_tmp4_, "server_url")) {
#line 2812 "Source.c"
			JsonObject* _tmp5_;
			const gchar* _tmp6_;
#line 321 "../core/Objects/Source.vala"
			_tmp5_ = object;
#line 321 "../core/Objects/Source.vala"
			_tmp6_ = json_object_get_string_member (_tmp5_, "server_url");
#line 321 "../core/Objects/Source.vala"
			objects_source_cal_dav_data_set_server_url (self, _tmp6_);
#line 2821 "Source.c"
		}
#line 324 "../core/Objects/Source.vala"
		_tmp7_ = object;
#line 324 "../core/Objects/Source.vala"
		if (json_object_has_member (_tmp7_, "username")) {
#line 2827 "Source.c"
			JsonObject* _tmp8_;
			const gchar* _tmp9_;
#line 325 "../core/Objects/Source.vala"
			_tmp8_ = object;
#line 325 "../core/Objects/Source.vala"
			_tmp9_ = json_object_get_string_member (_tmp8_, "username");
#line 325 "../core/Objects/Source.vala"
			objects_source_cal_dav_data_set_username (self, _tmp9_);
#line 2836 "Source.c"
		}
#line 328 "../core/Objects/Source.vala"
		_tmp10_ = object;
#line 328 "../core/Objects/Source.vala"
		if (json_object_has_member (_tmp10_, "credentials")) {
#line 2842 "Source.c"
			JsonObject* _tmp11_;
			const gchar* _tmp12_;
#line 329 "../core/Objects/Source.vala"
			_tmp11_ = object;
#line 329 "../core/Objects/Source.vala"
			_tmp12_ = json_object_get_string_member (_tmp11_, "credentials");
#line 329 "../core/Objects/Source.vala"
			objects_source_cal_dav_data_set_credentials (self, _tmp12_);
#line 2851 "Source.c"
		}
#line 332 "../core/Objects/Source.vala"
		_tmp13_ = object;
#line 332 "../core/Objects/Source.vala"
		if (json_object_has_member (_tmp13_, "user_displayname")) {
#line 2857 "Source.c"
			JsonObject* _tmp14_;
			const gchar* _tmp15_;
#line 333 "../core/Objects/Source.vala"
			_tmp14_ = object;
#line 333 "../core/Objects/Source.vala"
			_tmp15_ = json_object_get_string_member (_tmp14_, "user_displayname");
#line 333 "../core/Objects/Source.vala"
			objects_source_cal_dav_data_set_user_displayname (self, _tmp15_);
#line 2866 "Source.c"
		}
#line 336 "../core/Objects/Source.vala"
		_tmp16_ = object;
#line 336 "../core/Objects/Source.vala"
		if (json_object_has_member (_tmp16_, "user_email")) {
#line 2872 "Source.c"
			JsonObject* _tmp17_;
			const gchar* _tmp18_;
#line 337 "../core/Objects/Source.vala"
			_tmp17_ = object;
#line 337 "../core/Objects/Source.vala"
			_tmp18_ = json_object_get_string_member (_tmp17_, "user_email");
#line 337 "../core/Objects/Source.vala"
			objects_source_cal_dav_data_set_user_email (self, _tmp18_);
#line 2881 "Source.c"
		}
#line 340 "../core/Objects/Source.vala"
		_tmp19_ = object;
#line 340 "../core/Objects/Source.vala"
		if (json_object_has_member (_tmp19_, "caldav_type")) {
#line 2887 "Source.c"
			JsonObject* _tmp20_;
			const gchar* _tmp21_;
#line 341 "../core/Objects/Source.vala"
			_tmp20_ = object;
#line 341 "../core/Objects/Source.vala"
			_tmp21_ = json_object_get_string_member (_tmp20_, "caldav_type");
#line 341 "../core/Objects/Source.vala"
			objects_source_cal_dav_data_set_caldav_type (self, cal_dav_type_parse (_tmp21_));
#line 2896 "Source.c"
		}
#line 316 "../core/Objects/Source.vala"
		_json_object_unref0 (object);
#line 2900 "Source.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp22_;
		const gchar* _tmp23_;
#line 316 "../core/Objects/Source.vala"
		e = _inner_error0_;
#line 316 "../core/Objects/Source.vala"
		_inner_error0_ = NULL;
#line 344 "../core/Objects/Source.vala"
		_tmp22_ = e;
#line 344 "../core/Objects/Source.vala"
		_tmp23_ = _tmp22_->message;
#line 344 "../core/Objects/Source.vala"
		g_debug ("Source.vala:344: %s", _tmp23_);
#line 316 "../core/Objects/Source.vala"
		_g_error_free0 (e);
#line 2920 "Source.c"
	}
	__finally0:
#line 316 "../core/Objects/Source.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 316 "../core/Objects/Source.vala"
		_g_object_unref0 (parser);
#line 316 "../core/Objects/Source.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 316 "../core/Objects/Source.vala"
		g_clear_error (&_inner_error0_);
#line 316 "../core/Objects/Source.vala"
		return NULL;
#line 2933 "Source.c"
	}
#line 313 "../core/Objects/Source.vala"
	_g_object_unref0 (parser);
#line 313 "../core/Objects/Source.vala"
	return self;
#line 2939 "Source.c"
}

ObjectsSourceCalDAVData*
objects_source_cal_dav_data_new_from_json (const gchar* json)
{
#line 313 "../core/Objects/Source.vala"
	return objects_source_cal_dav_data_construct_from_json (OBJECTS_TYPE_SOURCE_CAL_DAV_DATA, json);
#line 2947 "Source.c"
}

static gchar*
objects_source_cal_dav_data_real_to_json (ObjectsSourceData* base)
{
	ObjectsSourceCalDAVData * self;
	JsonBuilder* _tmp0_;
	JsonBuilder* _tmp1_;
	JsonBuilder* _tmp2_;
	JsonBuilder* _tmp3_;
	JsonBuilder* _tmp4_;
	JsonBuilder* _tmp5_;
	JsonBuilder* _tmp6_;
	JsonBuilder* _tmp7_;
	const gchar* _tmp8_;
	JsonBuilder* _tmp9_;
	JsonBuilder* _tmp10_;
	JsonBuilder* _tmp11_;
	JsonBuilder* _tmp12_;
	const gchar* _tmp13_;
	JsonBuilder* _tmp14_;
	JsonBuilder* _tmp15_;
	JsonBuilder* _tmp16_;
	JsonBuilder* _tmp17_;
	const gchar* _tmp18_;
	JsonBuilder* _tmp19_;
	JsonBuilder* _tmp20_;
	JsonBuilder* _tmp21_;
	JsonBuilder* _tmp22_;
	CalDAVType _tmp23_;
	gchar* _tmp24_;
	gchar* _tmp25_;
	JsonBuilder* _tmp26_;
	JsonBuilder* _tmp27_;
	JsonBuilder* _tmp28_;
	JsonBuilder* _tmp29_;
	const gchar* _tmp30_;
	JsonBuilder* _tmp31_;
	JsonBuilder* _tmp32_;
	JsonBuilder* _tmp33_;
	JsonBuilder* _tmp34_;
	const gchar* _tmp35_;
	JsonBuilder* _tmp36_;
	JsonBuilder* _tmp37_;
	JsonGenerator* generator = NULL;
	JsonGenerator* _tmp38_;
	JsonNode* root = NULL;
	JsonBuilder* _tmp39_;
	JsonBuilder* _tmp40_;
	JsonNode* _tmp41_;
	gchar* _tmp42_;
	gchar* result;
#line 348 "../core/Objects/Source.vala"
	self = (ObjectsSourceCalDAVData*) base;
#line 349 "../core/Objects/Source.vala"
	_tmp0_ = objects_source_data_get_builder ((ObjectsSourceData*) self);
#line 349 "../core/Objects/Source.vala"
	_tmp1_ = _tmp0_;
#line 349 "../core/Objects/Source.vala"
	json_builder_reset (_tmp1_);
#line 351 "../core/Objects/Source.vala"
	_tmp2_ = objects_source_data_get_builder ((ObjectsSourceData*) self);
#line 351 "../core/Objects/Source.vala"
	_tmp3_ = _tmp2_;
#line 351 "../core/Objects/Source.vala"
	json_builder_begin_object (_tmp3_);
#line 353 "../core/Objects/Source.vala"
	_tmp4_ = objects_source_data_get_builder ((ObjectsSourceData*) self);
#line 353 "../core/Objects/Source.vala"
	_tmp5_ = _tmp4_;
#line 353 "../core/Objects/Source.vala"
	json_builder_set_member_name (_tmp5_, "server_url");
#line 354 "../core/Objects/Source.vala"
	_tmp6_ = objects_source_data_get_builder ((ObjectsSourceData*) self);
#line 354 "../core/Objects/Source.vala"
	_tmp7_ = _tmp6_;
#line 354 "../core/Objects/Source.vala"
	_tmp8_ = self->priv->_server_url;
#line 354 "../core/Objects/Source.vala"
	json_builder_add_string_value (_tmp7_, _tmp8_);
#line 356 "../core/Objects/Source.vala"
	_tmp9_ = objects_source_data_get_builder ((ObjectsSourceData*) self);
#line 356 "../core/Objects/Source.vala"
	_tmp10_ = _tmp9_;
#line 356 "../core/Objects/Source.vala"
	json_builder_set_member_name (_tmp10_, "username");
#line 357 "../core/Objects/Source.vala"
	_tmp11_ = objects_source_data_get_builder ((ObjectsSourceData*) self);
#line 357 "../core/Objects/Source.vala"
	_tmp12_ = _tmp11_;
#line 357 "../core/Objects/Source.vala"
	_tmp13_ = self->priv->_username;
#line 357 "../core/Objects/Source.vala"
	json_builder_add_string_value (_tmp12_, _tmp13_);
#line 359 "../core/Objects/Source.vala"
	_tmp14_ = objects_source_data_get_builder ((ObjectsSourceData*) self);
#line 359 "../core/Objects/Source.vala"
	_tmp15_ = _tmp14_;
#line 359 "../core/Objects/Source.vala"
	json_builder_set_member_name (_tmp15_, "credentials");
#line 360 "../core/Objects/Source.vala"
	_tmp16_ = objects_source_data_get_builder ((ObjectsSourceData*) self);
#line 360 "../core/Objects/Source.vala"
	_tmp17_ = _tmp16_;
#line 360 "../core/Objects/Source.vala"
	_tmp18_ = self->priv->_credentials;
#line 360 "../core/Objects/Source.vala"
	json_builder_add_string_value (_tmp17_, _tmp18_);
#line 362 "../core/Objects/Source.vala"
	_tmp19_ = objects_source_data_get_builder ((ObjectsSourceData*) self);
#line 362 "../core/Objects/Source.vala"
	_tmp20_ = _tmp19_;
#line 362 "../core/Objects/Source.vala"
	json_builder_set_member_name (_tmp20_, "caldav_type");
#line 363 "../core/Objects/Source.vala"
	_tmp21_ = objects_source_data_get_builder ((ObjectsSourceData*) self);
#line 363 "../core/Objects/Source.vala"
	_tmp22_ = _tmp21_;
#line 363 "../core/Objects/Source.vala"
	_tmp23_ = self->priv->_caldav_type;
#line 363 "../core/Objects/Source.vala"
	_tmp24_ = cal_dav_type_to_string (_tmp23_);
#line 363 "../core/Objects/Source.vala"
	_tmp25_ = _tmp24_;
#line 363 "../core/Objects/Source.vala"
	json_builder_add_string_value (_tmp22_, _tmp25_);
#line 363 "../core/Objects/Source.vala"
	_g_free0 (_tmp25_);
#line 365 "../core/Objects/Source.vala"
	_tmp26_ = objects_source_data_get_builder ((ObjectsSourceData*) self);
#line 365 "../core/Objects/Source.vala"
	_tmp27_ = _tmp26_;
#line 365 "../core/Objects/Source.vala"
	json_builder_set_member_name (_tmp27_, "user_displayname");
#line 366 "../core/Objects/Source.vala"
	_tmp28_ = objects_source_data_get_builder ((ObjectsSourceData*) self);
#line 366 "../core/Objects/Source.vala"
	_tmp29_ = _tmp28_;
#line 366 "../core/Objects/Source.vala"
	_tmp30_ = self->priv->_user_displayname;
#line 366 "../core/Objects/Source.vala"
	json_builder_add_string_value (_tmp29_, _tmp30_);
#line 368 "../core/Objects/Source.vala"
	_tmp31_ = objects_source_data_get_builder ((ObjectsSourceData*) self);
#line 368 "../core/Objects/Source.vala"
	_tmp32_ = _tmp31_;
#line 368 "../core/Objects/Source.vala"
	json_builder_set_member_name (_tmp32_, "user_email");
#line 369 "../core/Objects/Source.vala"
	_tmp33_ = objects_source_data_get_builder ((ObjectsSourceData*) self);
#line 369 "../core/Objects/Source.vala"
	_tmp34_ = _tmp33_;
#line 369 "../core/Objects/Source.vala"
	_tmp35_ = self->priv->_user_email;
#line 369 "../core/Objects/Source.vala"
	json_builder_add_string_value (_tmp34_, _tmp35_);
#line 371 "../core/Objects/Source.vala"
	_tmp36_ = objects_source_data_get_builder ((ObjectsSourceData*) self);
#line 371 "../core/Objects/Source.vala"
	_tmp37_ = _tmp36_;
#line 371 "../core/Objects/Source.vala"
	json_builder_end_object (_tmp37_);
#line 373 "../core/Objects/Source.vala"
	_tmp38_ = json_generator_new ();
#line 373 "../core/Objects/Source.vala"
	generator = _tmp38_;
#line 374 "../core/Objects/Source.vala"
	_tmp39_ = objects_source_data_get_builder ((ObjectsSourceData*) self);
#line 374 "../core/Objects/Source.vala"
	_tmp40_ = _tmp39_;
#line 374 "../core/Objects/Source.vala"
	_tmp41_ = json_builder_get_root (_tmp40_);
#line 374 "../core/Objects/Source.vala"
	root = _tmp41_;
#line 375 "../core/Objects/Source.vala"
	json_generator_set_root (generator, root);
#line 377 "../core/Objects/Source.vala"
	_tmp42_ = json_generator_to_data (generator, NULL);
#line 377 "../core/Objects/Source.vala"
	result = _tmp42_;
#line 377 "../core/Objects/Source.vala"
	__vala_JsonNode_free0 (root);
#line 377 "../core/Objects/Source.vala"
	_g_object_unref0 (generator);
#line 377 "../core/Objects/Source.vala"
	return result;
#line 3134 "Source.c"
}

ObjectsSourceCalDAVData*
objects_source_cal_dav_data_construct (GType object_type)
{
	ObjectsSourceCalDAVData * self = NULL;
#line 305 "../core/Objects/Source.vala"
	self = (ObjectsSourceCalDAVData*) objects_source_data_construct (object_type);
#line 305 "../core/Objects/Source.vala"
	return self;
#line 3145 "Source.c"
}

ObjectsSourceCalDAVData*
objects_source_cal_dav_data_new (void)
{
#line 305 "../core/Objects/Source.vala"
	return objects_source_cal_dav_data_construct (OBJECTS_TYPE_SOURCE_CAL_DAV_DATA);
#line 3153 "Source.c"
}

const gchar*
objects_source_cal_dav_data_get_server_url (ObjectsSourceCalDAVData* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 306 "../core/Objects/Source.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 306 "../core/Objects/Source.vala"
	_tmp0_ = self->priv->_server_url;
#line 306 "../core/Objects/Source.vala"
	result = _tmp0_;
#line 306 "../core/Objects/Source.vala"
	return result;
#line 3169 "Source.c"
}

void
objects_source_cal_dav_data_set_server_url (ObjectsSourceCalDAVData* self,
                                            const gchar* value)
{
	gchar* old_value;
#line 306 "../core/Objects/Source.vala"
	g_return_if_fail (self != NULL);
#line 306 "../core/Objects/Source.vala"
	old_value = objects_source_cal_dav_data_get_server_url (self);
#line 306 "../core/Objects/Source.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 3183 "Source.c"
		gchar* _tmp0_;
#line 306 "../core/Objects/Source.vala"
		_tmp0_ = g_strdup (value);
#line 306 "../core/Objects/Source.vala"
		_g_free0 (self->priv->_server_url);
#line 306 "../core/Objects/Source.vala"
		self->priv->_server_url = _tmp0_;
#line 306 "../core/Objects/Source.vala"
		g_object_notify_by_pspec ((GObject *) self, objects_source_cal_dav_data_properties[OBJECTS_SOURCE_CAL_DAV_DATA_SERVER_URL_PROPERTY]);
#line 3193 "Source.c"
	}
}

const gchar*
objects_source_cal_dav_data_get_username (ObjectsSourceCalDAVData* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 307 "../core/Objects/Source.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 307 "../core/Objects/Source.vala"
	_tmp0_ = self->priv->_username;
#line 307 "../core/Objects/Source.vala"
	result = _tmp0_;
#line 307 "../core/Objects/Source.vala"
	return result;
#line 3210 "Source.c"
}

void
objects_source_cal_dav_data_set_username (ObjectsSourceCalDAVData* self,
                                          const gchar* value)
{
	gchar* old_value;
#line 307 "../core/Objects/Source.vala"
	g_return_if_fail (self != NULL);
#line 307 "../core/Objects/Source.vala"
	old_value = objects_source_cal_dav_data_get_username (self);
#line 307 "../core/Objects/Source.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 3224 "Source.c"
		gchar* _tmp0_;
#line 307 "../core/Objects/Source.vala"
		_tmp0_ = g_strdup (value);
#line 307 "../core/Objects/Source.vala"
		_g_free0 (self->priv->_username);
#line 307 "../core/Objects/Source.vala"
		self->priv->_username = _tmp0_;
#line 307 "../core/Objects/Source.vala"
		g_object_notify_by_pspec ((GObject *) self, objects_source_cal_dav_data_properties[OBJECTS_SOURCE_CAL_DAV_DATA_USERNAME_PROPERTY]);
#line 3234 "Source.c"
	}
}

const gchar*
objects_source_cal_dav_data_get_credentials (ObjectsSourceCalDAVData* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 308 "../core/Objects/Source.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 308 "../core/Objects/Source.vala"
	_tmp0_ = self->priv->_credentials;
#line 308 "../core/Objects/Source.vala"
	result = _tmp0_;
#line 308 "../core/Objects/Source.vala"
	return result;
#line 3251 "Source.c"
}

void
objects_source_cal_dav_data_set_credentials (ObjectsSourceCalDAVData* self,
                                             const gchar* value)
{
	gchar* old_value;
#line 308 "../core/Objects/Source.vala"
	g_return_if_fail (self != NULL);
#line 308 "../core/Objects/Source.vala"
	old_value = objects_source_cal_dav_data_get_credentials (self);
#line 308 "../core/Objects/Source.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 3265 "Source.c"
		gchar* _tmp0_;
#line 308 "../core/Objects/Source.vala"
		_tmp0_ = g_strdup (value);
#line 308 "../core/Objects/Source.vala"
		_g_free0 (self->priv->_credentials);
#line 308 "../core/Objects/Source.vala"
		self->priv->_credentials = _tmp0_;
#line 308 "../core/Objects/Source.vala"
		g_object_notify_by_pspec ((GObject *) self, objects_source_cal_dav_data_properties[OBJECTS_SOURCE_CAL_DAV_DATA_CREDENTIALS_PROPERTY]);
#line 3275 "Source.c"
	}
}

const gchar*
objects_source_cal_dav_data_get_user_displayname (ObjectsSourceCalDAVData* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 309 "../core/Objects/Source.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 309 "../core/Objects/Source.vala"
	_tmp0_ = self->priv->_user_displayname;
#line 309 "../core/Objects/Source.vala"
	result = _tmp0_;
#line 309 "../core/Objects/Source.vala"
	return result;
#line 3292 "Source.c"
}

void
objects_source_cal_dav_data_set_user_displayname (ObjectsSourceCalDAVData* self,
                                                  const gchar* value)
{
	gchar* old_value;
#line 309 "../core/Objects/Source.vala"
	g_return_if_fail (self != NULL);
#line 309 "../core/Objects/Source.vala"
	old_value = objects_source_cal_dav_data_get_user_displayname (self);
#line 309 "../core/Objects/Source.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 3306 "Source.c"
		gchar* _tmp0_;
#line 309 "../core/Objects/Source.vala"
		_tmp0_ = g_strdup (value);
#line 309 "../core/Objects/Source.vala"
		_g_free0 (self->priv->_user_displayname);
#line 309 "../core/Objects/Source.vala"
		self->priv->_user_displayname = _tmp0_;
#line 309 "../core/Objects/Source.vala"
		g_object_notify_by_pspec ((GObject *) self, objects_source_cal_dav_data_properties[OBJECTS_SOURCE_CAL_DAV_DATA_USER_DISPLAYNAME_PROPERTY]);
#line 3316 "Source.c"
	}
}

const gchar*
objects_source_cal_dav_data_get_user_email (ObjectsSourceCalDAVData* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 310 "../core/Objects/Source.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 310 "../core/Objects/Source.vala"
	_tmp0_ = self->priv->_user_email;
#line 310 "../core/Objects/Source.vala"
	result = _tmp0_;
#line 310 "../core/Objects/Source.vala"
	return result;
#line 3333 "Source.c"
}

void
objects_source_cal_dav_data_set_user_email (ObjectsSourceCalDAVData* self,
                                            const gchar* value)
{
	gchar* old_value;
#line 310 "../core/Objects/Source.vala"
	g_return_if_fail (self != NULL);
#line 310 "../core/Objects/Source.vala"
	old_value = objects_source_cal_dav_data_get_user_email (self);
#line 310 "../core/Objects/Source.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 3347 "Source.c"
		gchar* _tmp0_;
#line 310 "../core/Objects/Source.vala"
		_tmp0_ = g_strdup (value);
#line 310 "../core/Objects/Source.vala"
		_g_free0 (self->priv->_user_email);
#line 310 "../core/Objects/Source.vala"
		self->priv->_user_email = _tmp0_;
#line 310 "../core/Objects/Source.vala"
		g_object_notify_by_pspec ((GObject *) self, objects_source_cal_dav_data_properties[OBJECTS_SOURCE_CAL_DAV_DATA_USER_EMAIL_PROPERTY]);
#line 3357 "Source.c"
	}
}

CalDAVType
objects_source_cal_dav_data_get_caldav_type (ObjectsSourceCalDAVData* self)
{
	CalDAVType result;
#line 311 "../core/Objects/Source.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 311 "../core/Objects/Source.vala"
	result = self->priv->_caldav_type;
#line 311 "../core/Objects/Source.vala"
	return result;
#line 3371 "Source.c"
}

void
objects_source_cal_dav_data_set_caldav_type (ObjectsSourceCalDAVData* self,
                                             CalDAVType value)
{
	CalDAVType old_value;
#line 311 "../core/Objects/Source.vala"
	g_return_if_fail (self != NULL);
#line 311 "../core/Objects/Source.vala"
	old_value = objects_source_cal_dav_data_get_caldav_type (self);
#line 311 "../core/Objects/Source.vala"
	if (old_value != value) {
#line 311 "../core/Objects/Source.vala"
		self->priv->_caldav_type = value;
#line 311 "../core/Objects/Source.vala"
		g_object_notify_by_pspec ((GObject *) self, objects_source_cal_dav_data_properties[OBJECTS_SOURCE_CAL_DAV_DATA_CALDAV_TYPE_PROPERTY]);
#line 3389 "Source.c"
	}
}

static void
objects_source_cal_dav_data_class_init (ObjectsSourceCalDAVDataClass * klass,
                                        gpointer klass_data)
{
#line 305 "../core/Objects/Source.vala"
	objects_source_cal_dav_data_parent_class = g_type_class_peek_parent (klass);
#line 305 "../core/Objects/Source.vala"
	g_type_class_adjust_private_offset (klass, &ObjectsSourceCalDAVData_private_offset);
#line 305 "../core/Objects/Source.vala"
	((ObjectsSourceDataClass *) klass)->to_json = (gchar* (*) (ObjectsSourceData*)) objects_source_cal_dav_data_real_to_json;
#line 305 "../core/Objects/Source.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_objects_source_cal_dav_data_get_property;
#line 305 "../core/Objects/Source.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_objects_source_cal_dav_data_set_property;
#line 305 "../core/Objects/Source.vala"
	G_OBJECT_CLASS (klass)->finalize = objects_source_cal_dav_data_finalize;
#line 305 "../core/Objects/Source.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), OBJECTS_SOURCE_CAL_DAV_DATA_SERVER_URL_PROPERTY, objects_source_cal_dav_data_properties[OBJECTS_SOURCE_CAL_DAV_DATA_SERVER_URL_PROPERTY] = g_param_spec_string ("server-url", "server-url", "server-url", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 305 "../core/Objects/Source.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), OBJECTS_SOURCE_CAL_DAV_DATA_USERNAME_PROPERTY, objects_source_cal_dav_data_properties[OBJECTS_SOURCE_CAL_DAV_DATA_USERNAME_PROPERTY] = g_param_spec_string ("username", "username", "username", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 305 "../core/Objects/Source.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), OBJECTS_SOURCE_CAL_DAV_DATA_CREDENTIALS_PROPERTY, objects_source_cal_dav_data_properties[OBJECTS_SOURCE_CAL_DAV_DATA_CREDENTIALS_PROPERTY] = g_param_spec_string ("credentials", "credentials", "credentials", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 305 "../core/Objects/Source.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), OBJECTS_SOURCE_CAL_DAV_DATA_USER_DISPLAYNAME_PROPERTY, objects_source_cal_dav_data_properties[OBJECTS_SOURCE_CAL_DAV_DATA_USER_DISPLAYNAME_PROPERTY] = g_param_spec_string ("user-displayname", "user-displayname", "user-displayname", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 305 "../core/Objects/Source.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), OBJECTS_SOURCE_CAL_DAV_DATA_USER_EMAIL_PROPERTY, objects_source_cal_dav_data_properties[OBJECTS_SOURCE_CAL_DAV_DATA_USER_EMAIL_PROPERTY] = g_param_spec_string ("user-email", "user-email", "user-email", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 305 "../core/Objects/Source.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), OBJECTS_SOURCE_CAL_DAV_DATA_CALDAV_TYPE_PROPERTY, objects_source_cal_dav_data_properties[OBJECTS_SOURCE_CAL_DAV_DATA_CALDAV_TYPE_PROPERTY] = g_param_spec_enum ("caldav-type", "caldav-type", "caldav-type", TYPE_CAL_DAV_TYPE, CAL_DAV_TYPE_NEXTCLOUD, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 3421 "Source.c"
}

static void
objects_source_cal_dav_data_instance_init (ObjectsSourceCalDAVData * self,
                                           gpointer klass)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
#line 305 "../core/Objects/Source.vala"
	self->priv = objects_source_cal_dav_data_get_instance_private (self);
#line 306 "../core/Objects/Source.vala"
	_tmp0_ = g_strdup ("");
#line 306 "../core/Objects/Source.vala"
	self->priv->_server_url = _tmp0_;
#line 307 "../core/Objects/Source.vala"
	_tmp1_ = g_strdup ("");
#line 307 "../core/Objects/Source.vala"
	self->priv->_username = _tmp1_;
#line 308 "../core/Objects/Source.vala"
	_tmp2_ = g_strdup ("");
#line 308 "../core/Objects/Source.vala"
	self->priv->_credentials = _tmp2_;
#line 309 "../core/Objects/Source.vala"
	_tmp3_ = g_strdup ("");
#line 309 "../core/Objects/Source.vala"
	self->priv->_user_displayname = _tmp3_;
#line 310 "../core/Objects/Source.vala"
	_tmp4_ = g_strdup ("");
#line 310 "../core/Objects/Source.vala"
	self->priv->_user_email = _tmp4_;
#line 311 "../core/Objects/Source.vala"
	self->priv->_caldav_type = CAL_DAV_TYPE_NEXTCLOUD;
#line 3457 "Source.c"
}

static void
objects_source_cal_dav_data_finalize (GObject * obj)
{
	ObjectsSourceCalDAVData * self;
#line 305 "../core/Objects/Source.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, OBJECTS_TYPE_SOURCE_CAL_DAV_DATA, ObjectsSourceCalDAVData);
#line 306 "../core/Objects/Source.vala"
	_g_free0 (self->priv->_server_url);
#line 307 "../core/Objects/Source.vala"
	_g_free0 (self->priv->_username);
#line 308 "../core/Objects/Source.vala"
	_g_free0 (self->priv->_credentials);
#line 309 "../core/Objects/Source.vala"
	_g_free0 (self->priv->_user_displayname);
#line 310 "../core/Objects/Source.vala"
	_g_free0 (self->priv->_user_email);
#line 305 "../core/Objects/Source.vala"
	G_OBJECT_CLASS (objects_source_cal_dav_data_parent_class)->finalize (obj);
#line 3478 "Source.c"
}

static GType
objects_source_cal_dav_data_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ObjectsSourceCalDAVDataClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) objects_source_cal_dav_data_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ObjectsSourceCalDAVData), 0, (GInstanceInitFunc) objects_source_cal_dav_data_instance_init, NULL };
	GType objects_source_cal_dav_data_type_id;
	objects_source_cal_dav_data_type_id = g_type_register_static (OBJECTS_TYPE_SOURCE_DATA, "ObjectsSourceCalDAVData", &g_define_type_info, 0);
	ObjectsSourceCalDAVData_private_offset = g_type_add_instance_private (objects_source_cal_dav_data_type_id, sizeof (ObjectsSourceCalDAVDataPrivate));
	return objects_source_cal_dav_data_type_id;
}

GType
objects_source_cal_dav_data_get_type (void)
{
	static volatile gsize objects_source_cal_dav_data_type_id__once = 0;
	if (g_once_init_enter (&objects_source_cal_dav_data_type_id__once)) {
		GType objects_source_cal_dav_data_type_id;
		objects_source_cal_dav_data_type_id = objects_source_cal_dav_data_get_type_once ();
		g_once_init_leave (&objects_source_cal_dav_data_type_id__once, objects_source_cal_dav_data_type_id);
	}
	return objects_source_cal_dav_data_type_id__once;
}

static void
_vala_objects_source_cal_dav_data_get_property (GObject * object,
                                                guint property_id,
                                                GValue * value,
                                                GParamSpec * pspec)
{
	ObjectsSourceCalDAVData * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, OBJECTS_TYPE_SOURCE_CAL_DAV_DATA, ObjectsSourceCalDAVData);
#line 305 "../core/Objects/Source.vala"
	switch (property_id) {
#line 305 "../core/Objects/Source.vala"
		case OBJECTS_SOURCE_CAL_DAV_DATA_SERVER_URL_PROPERTY:
#line 305 "../core/Objects/Source.vala"
		g_value_set_string (value, objects_source_cal_dav_data_get_server_url (self));
#line 305 "../core/Objects/Source.vala"
		break;
#line 305 "../core/Objects/Source.vala"
		case OBJECTS_SOURCE_CAL_DAV_DATA_USERNAME_PROPERTY:
#line 305 "../core/Objects/Source.vala"
		g_value_set_string (value, objects_source_cal_dav_data_get_username (self));
#line 305 "../core/Objects/Source.vala"
		break;
#line 305 "../core/Objects/Source.vala"
		case OBJECTS_SOURCE_CAL_DAV_DATA_CREDENTIALS_PROPERTY:
#line 305 "../core/Objects/Source.vala"
		g_value_set_string (value, objects_source_cal_dav_data_get_credentials (self));
#line 305 "../core/Objects/Source.vala"
		break;
#line 305 "../core/Objects/Source.vala"
		case OBJECTS_SOURCE_CAL_DAV_DATA_USER_DISPLAYNAME_PROPERTY:
#line 305 "../core/Objects/Source.vala"
		g_value_set_string (value, objects_source_cal_dav_data_get_user_displayname (self));
#line 305 "../core/Objects/Source.vala"
		break;
#line 305 "../core/Objects/Source.vala"
		case OBJECTS_SOURCE_CAL_DAV_DATA_USER_EMAIL_PROPERTY:
#line 305 "../core/Objects/Source.vala"
		g_value_set_string (value, objects_source_cal_dav_data_get_user_email (self));
#line 305 "../core/Objects/Source.vala"
		break;
#line 305 "../core/Objects/Source.vala"
		case OBJECTS_SOURCE_CAL_DAV_DATA_CALDAV_TYPE_PROPERTY:
#line 305 "../core/Objects/Source.vala"
		g_value_set_enum (value, objects_source_cal_dav_data_get_caldav_type (self));
#line 305 "../core/Objects/Source.vala"
		break;
#line 3549 "Source.c"
		default:
#line 305 "../core/Objects/Source.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 305 "../core/Objects/Source.vala"
		break;
#line 3555 "Source.c"
	}
}

static void
_vala_objects_source_cal_dav_data_set_property (GObject * object,
                                                guint property_id,
                                                const GValue * value,
                                                GParamSpec * pspec)
{
	ObjectsSourceCalDAVData * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, OBJECTS_TYPE_SOURCE_CAL_DAV_DATA, ObjectsSourceCalDAVData);
#line 305 "../core/Objects/Source.vala"
	switch (property_id) {
#line 305 "../core/Objects/Source.vala"
		case OBJECTS_SOURCE_CAL_DAV_DATA_SERVER_URL_PROPERTY:
#line 305 "../core/Objects/Source.vala"
		objects_source_cal_dav_data_set_server_url (self, g_value_get_string (value));
#line 305 "../core/Objects/Source.vala"
		break;
#line 305 "../core/Objects/Source.vala"
		case OBJECTS_SOURCE_CAL_DAV_DATA_USERNAME_PROPERTY:
#line 305 "../core/Objects/Source.vala"
		objects_source_cal_dav_data_set_username (self, g_value_get_string (value));
#line 305 "../core/Objects/Source.vala"
		break;
#line 305 "../core/Objects/Source.vala"
		case OBJECTS_SOURCE_CAL_DAV_DATA_CREDENTIALS_PROPERTY:
#line 305 "../core/Objects/Source.vala"
		objects_source_cal_dav_data_set_credentials (self, g_value_get_string (value));
#line 305 "../core/Objects/Source.vala"
		break;
#line 305 "../core/Objects/Source.vala"
		case OBJECTS_SOURCE_CAL_DAV_DATA_USER_DISPLAYNAME_PROPERTY:
#line 305 "../core/Objects/Source.vala"
		objects_source_cal_dav_data_set_user_displayname (self, g_value_get_string (value));
#line 305 "../core/Objects/Source.vala"
		break;
#line 305 "../core/Objects/Source.vala"
		case OBJECTS_SOURCE_CAL_DAV_DATA_USER_EMAIL_PROPERTY:
#line 305 "../core/Objects/Source.vala"
		objects_source_cal_dav_data_set_user_email (self, g_value_get_string (value));
#line 305 "../core/Objects/Source.vala"
		break;
#line 305 "../core/Objects/Source.vala"
		case OBJECTS_SOURCE_CAL_DAV_DATA_CALDAV_TYPE_PROPERTY:
#line 305 "../core/Objects/Source.vala"
		objects_source_cal_dav_data_set_caldav_type (self, g_value_get_enum (value));
#line 305 "../core/Objects/Source.vala"
		break;
#line 3605 "Source.c"
		default:
#line 305 "../core/Objects/Source.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 305 "../core/Objects/Source.vala"
		break;
#line 3611 "Source.c"
	}
}

