/* Datetime.c generated by valac 0.56.18, the Vala compiler
 * generated from Datetime.vala, do not modify */

/*
* Copyright © 2023 Alain M. (https://github.com/alainm23/planify)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 3 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*
* Authored by: Alain M. <alainmh23@gmail.com>
*/

#include "planify.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <float.h>
#include <math.h>
#include <glib/gi18n-lib.h>
#include <granite-7.h>
#include <gio/gio.h>
#include <json-glib/json-glib.h>
#include <libical-glib/libical-glib.h>
#include <libecal/libecal.h>
#include <glib-object.h>
#include <gobject/gvaluecollector.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_time_zone_unref0(var) ((var == NULL) ? NULL : (var = (g_time_zone_unref (var), NULL)))
#define _g_array_unref0(var) ((var == NULL) ? NULL : (var = (g_array_unref (var), NULL)))
typedef struct _UtilsParamSpecDatetime UtilsParamSpecDatetime;
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _UtilsParamSpecDatetime {
	GParamSpec parent_instance;
};

static gpointer utils_datetime_parent_class = NULL;

static gboolean utils_datetime_check_by_day (const gchar* day,
                                      GArray* day_array);
static void utils_datetime_finalize (UtilsDatetime * obj);
static GType utils_datetime_get_type_once (void);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);

GDateTime*
utils_datetime_get_todoist_datetime (const gchar* date)
{
	GDateTime* datetime = NULL;
	gint _tmp0_;
	gint _tmp1_;
	GDateTime* result;
#line 23 "../core/Util/Datetime.vala"
	g_return_val_if_fail (date != NULL, NULL);
#line 24 "../core/Util/Datetime.vala"
	if (g_strcmp0 (date, "") == 0) {
#line 25 "../core/Util/Datetime.vala"
		result = NULL;
#line 25 "../core/Util/Datetime.vala"
		return result;
#line 94 "Datetime.c"
	}
#line 28 "../core/Util/Datetime.vala"
	datetime = NULL;
#line 31 "../core/Util/Datetime.vala"
	_tmp0_ = strlen (date);
#line 31 "../core/Util/Datetime.vala"
	_tmp1_ = _tmp0_;
#line 31 "../core/Util/Datetime.vala"
	if (_tmp1_ == 10) {
#line 104 "Datetime.c"
		gchar** _date = NULL;
		gchar** _tmp2_;
		gchar** _tmp3_;
		gint _date_length1;
		gint __date_size_;
		gchar** _tmp4_;
		gint _tmp4__length1;
		const gchar* _tmp5_;
		gchar** _tmp6_;
		gint _tmp6__length1;
		const gchar* _tmp7_;
		gchar** _tmp8_;
		gint _tmp8__length1;
		const gchar* _tmp9_;
		GDateTime* _tmp10_;
#line 32 "../core/Util/Datetime.vala"
		_tmp3_ = _tmp2_ = g_strsplit (date, "-", 0);
#line 32 "../core/Util/Datetime.vala"
		_date = _tmp3_;
#line 32 "../core/Util/Datetime.vala"
		_date_length1 = _vala_array_length (_tmp2_);
#line 32 "../core/Util/Datetime.vala"
		__date_size_ = _date_length1;
#line 34 "../core/Util/Datetime.vala"
		_tmp4_ = _date;
#line 34 "../core/Util/Datetime.vala"
		_tmp4__length1 = _date_length1;
#line 34 "../core/Util/Datetime.vala"
		_tmp5_ = _tmp4_[0];
#line 34 "../core/Util/Datetime.vala"
		_tmp6_ = _date;
#line 34 "../core/Util/Datetime.vala"
		_tmp6__length1 = _date_length1;
#line 34 "../core/Util/Datetime.vala"
		_tmp7_ = _tmp6_[1];
#line 34 "../core/Util/Datetime.vala"
		_tmp8_ = _date;
#line 34 "../core/Util/Datetime.vala"
		_tmp8__length1 = _date_length1;
#line 34 "../core/Util/Datetime.vala"
		_tmp9_ = _tmp8_[2];
#line 34 "../core/Util/Datetime.vala"
		_tmp10_ = g_date_time_new_local (atoi (_tmp5_), atoi (_tmp7_), atoi (_tmp9_), 0, 0, (gdouble) 0);
#line 34 "../core/Util/Datetime.vala"
		_g_date_time_unref0 (datetime);
#line 34 "../core/Util/Datetime.vala"
		datetime = _tmp10_;
#line 31 "../core/Util/Datetime.vala"
		_date = (_vala_array_free (_date, _date_length1, (GDestroyNotify) g_free), NULL);
#line 154 "Datetime.c"
	} else {
		gchar** _date = NULL;
		gchar** _tmp11_;
		gchar** _tmp12_;
		gchar** _tmp13_;
		gint _tmp13__length1;
		const gchar* _tmp14_;
		gchar** _tmp15_;
		gchar** _tmp16_;
		gchar** _tmp17_;
		gint _tmp17__length1;
		gint _date_length1;
		gint __date_size_;
		gchar** _time = NULL;
		gchar** _tmp18_;
		gchar** _tmp19_;
		gchar** _tmp20_;
		gint _tmp20__length1;
		const gchar* _tmp21_;
		gchar** _tmp22_;
		gchar** _tmp23_;
		gchar** _tmp24_;
		gint _tmp24__length1;
		gint _time_length1;
		gint __time_size_;
		gchar** _tmp25_;
		gint _tmp25__length1;
		const gchar* _tmp26_;
		gchar** _tmp27_;
		gint _tmp27__length1;
		const gchar* _tmp28_;
		gchar** _tmp29_;
		gint _tmp29__length1;
		const gchar* _tmp30_;
		gchar** _tmp31_;
		gint _tmp31__length1;
		const gchar* _tmp32_;
		gchar** _tmp33_;
		gint _tmp33__length1;
		const gchar* _tmp34_;
		gchar** _tmp35_;
		gint _tmp35__length1;
		const gchar* _tmp36_;
		GDateTime* _tmp37_;
#line 44 "../core/Util/Datetime.vala"
		_tmp12_ = _tmp11_ = g_strsplit (date, "T", 0);
#line 44 "../core/Util/Datetime.vala"
		_tmp13_ = _tmp12_;
#line 44 "../core/Util/Datetime.vala"
		_tmp13__length1 = _vala_array_length (_tmp11_);
#line 44 "../core/Util/Datetime.vala"
		_tmp14_ = _tmp13_[0];
#line 44 "../core/Util/Datetime.vala"
		_tmp16_ = _tmp15_ = g_strsplit (_tmp14_, "-", 0);
#line 44 "../core/Util/Datetime.vala"
		_tmp17_ = _tmp16_;
#line 44 "../core/Util/Datetime.vala"
		_tmp17__length1 = _vala_array_length (_tmp15_);
#line 44 "../core/Util/Datetime.vala"
		_tmp13_ = (_vala_array_free (_tmp13_, _tmp13__length1, (GDestroyNotify) g_free), NULL);
#line 44 "../core/Util/Datetime.vala"
		_date = _tmp17_;
#line 44 "../core/Util/Datetime.vala"
		_date_length1 = _tmp17__length1;
#line 44 "../core/Util/Datetime.vala"
		__date_size_ = _date_length1;
#line 45 "../core/Util/Datetime.vala"
		_tmp19_ = _tmp18_ = g_strsplit (date, "T", 0);
#line 45 "../core/Util/Datetime.vala"
		_tmp20_ = _tmp19_;
#line 45 "../core/Util/Datetime.vala"
		_tmp20__length1 = _vala_array_length (_tmp18_);
#line 45 "../core/Util/Datetime.vala"
		_tmp21_ = _tmp20_[1];
#line 45 "../core/Util/Datetime.vala"
		_tmp23_ = _tmp22_ = g_strsplit (_tmp21_, ":", 0);
#line 45 "../core/Util/Datetime.vala"
		_tmp24_ = _tmp23_;
#line 45 "../core/Util/Datetime.vala"
		_tmp24__length1 = _vala_array_length (_tmp22_);
#line 45 "../core/Util/Datetime.vala"
		_tmp20_ = (_vala_array_free (_tmp20_, _tmp20__length1, (GDestroyNotify) g_free), NULL);
#line 45 "../core/Util/Datetime.vala"
		_time = _tmp24_;
#line 45 "../core/Util/Datetime.vala"
		_time_length1 = _tmp24__length1;
#line 45 "../core/Util/Datetime.vala"
		__time_size_ = _time_length1;
#line 47 "../core/Util/Datetime.vala"
		_tmp25_ = _date;
#line 47 "../core/Util/Datetime.vala"
		_tmp25__length1 = _date_length1;
#line 47 "../core/Util/Datetime.vala"
		_tmp26_ = _tmp25_[0];
#line 47 "../core/Util/Datetime.vala"
		_tmp27_ = _date;
#line 47 "../core/Util/Datetime.vala"
		_tmp27__length1 = _date_length1;
#line 47 "../core/Util/Datetime.vala"
		_tmp28_ = _tmp27_[1];
#line 47 "../core/Util/Datetime.vala"
		_tmp29_ = _date;
#line 47 "../core/Util/Datetime.vala"
		_tmp29__length1 = _date_length1;
#line 47 "../core/Util/Datetime.vala"
		_tmp30_ = _tmp29_[2];
#line 47 "../core/Util/Datetime.vala"
		_tmp31_ = _time;
#line 47 "../core/Util/Datetime.vala"
		_tmp31__length1 = _time_length1;
#line 47 "../core/Util/Datetime.vala"
		_tmp32_ = _tmp31_[0];
#line 47 "../core/Util/Datetime.vala"
		_tmp33_ = _time;
#line 47 "../core/Util/Datetime.vala"
		_tmp33__length1 = _time_length1;
#line 47 "../core/Util/Datetime.vala"
		_tmp34_ = _tmp33_[1];
#line 47 "../core/Util/Datetime.vala"
		_tmp35_ = _time;
#line 47 "../core/Util/Datetime.vala"
		_tmp35__length1 = _time_length1;
#line 47 "../core/Util/Datetime.vala"
		_tmp36_ = _tmp35_[2];
#line 47 "../core/Util/Datetime.vala"
		_tmp37_ = g_date_time_new_local (atoi (_tmp26_), atoi (_tmp28_), atoi (_tmp30_), atoi (_tmp32_), atoi (_tmp34_), (gdouble) atoi (_tmp36_));
#line 47 "../core/Util/Datetime.vala"
		_g_date_time_unref0 (datetime);
#line 47 "../core/Util/Datetime.vala"
		datetime = _tmp37_;
#line 31 "../core/Util/Datetime.vala"
		_time = (_vala_array_free (_time, _time_length1, (GDestroyNotify) g_free), NULL);
#line 31 "../core/Util/Datetime.vala"
		_date = (_vala_array_free (_date, _date_length1, (GDestroyNotify) g_free), NULL);
#line 289 "Datetime.c"
	}
#line 57 "../core/Util/Datetime.vala"
	result = datetime;
#line 57 "../core/Util/Datetime.vala"
	return result;
#line 295 "Datetime.c"
}

gchar*
utils_datetime_get_relative_date_from_date (GDateTime* datetime)
{
	gchar* returned = NULL;
	gchar* _tmp1_;
	gchar* result;
#line 61 "../core/Util/Datetime.vala"
	if (datetime == NULL) {
#line 306 "Datetime.c"
		gchar* _tmp0_;
#line 62 "../core/Util/Datetime.vala"
		_tmp0_ = g_strdup ("");
#line 62 "../core/Util/Datetime.vala"
		result = _tmp0_;
#line 62 "../core/Util/Datetime.vala"
		return result;
#line 314 "Datetime.c"
	}
#line 65 "../core/Util/Datetime.vala"
	_tmp1_ = g_strdup ("");
#line 65 "../core/Util/Datetime.vala"
	returned = _tmp1_;
#line 67 "../core/Util/Datetime.vala"
	if (utils_datetime_is_today (datetime)) {
#line 322 "Datetime.c"
		gchar* _tmp2_;
#line 68 "../core/Util/Datetime.vala"
		_tmp2_ = g_strdup (_ ("Today"));
#line 68 "../core/Util/Datetime.vala"
		_g_free0 (returned);
#line 68 "../core/Util/Datetime.vala"
		returned = _tmp2_;
#line 330 "Datetime.c"
	} else {
#line 69 "../core/Util/Datetime.vala"
		if (utils_datetime_is_tomorrow (datetime)) {
#line 334 "Datetime.c"
			gchar* _tmp3_;
#line 70 "../core/Util/Datetime.vala"
			_tmp3_ = g_strdup (_ ("Tomorrow"));
#line 70 "../core/Util/Datetime.vala"
			_g_free0 (returned);
#line 70 "../core/Util/Datetime.vala"
			returned = _tmp3_;
#line 342 "Datetime.c"
		} else {
#line 71 "../core/Util/Datetime.vala"
			if (utils_datetime_is_yesterday (datetime)) {
#line 346 "Datetime.c"
				gchar* _tmp4_;
#line 72 "../core/Util/Datetime.vala"
				_tmp4_ = g_strdup (_ ("Yesterday"));
#line 72 "../core/Util/Datetime.vala"
				_g_free0 (returned);
#line 72 "../core/Util/Datetime.vala"
				returned = _tmp4_;
#line 354 "Datetime.c"
			} else {
				gchar* _tmp5_;
#line 74 "../core/Util/Datetime.vala"
				_tmp5_ = utils_datetime_get_default_date_format_from_date (datetime);
#line 74 "../core/Util/Datetime.vala"
				_g_free0 (returned);
#line 74 "../core/Util/Datetime.vala"
				returned = _tmp5_;
#line 363 "Datetime.c"
			}
		}
	}
#line 77 "../core/Util/Datetime.vala"
	if (utils_datetime_has_time (datetime)) {
#line 369 "Datetime.c"
		const gchar* _tmp6_;
		gchar* _tmp7_;
		gchar* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		gchar* _tmp11_;
#line 78 "../core/Util/Datetime.vala"
		_tmp6_ = returned;
#line 78 "../core/Util/Datetime.vala"
		_tmp7_ = utils_datetime_get_default_time_format ();
#line 78 "../core/Util/Datetime.vala"
		_tmp8_ = _tmp7_;
#line 78 "../core/Util/Datetime.vala"
		_tmp9_ = g_date_time_format (datetime, _tmp8_);
#line 78 "../core/Util/Datetime.vala"
		_tmp10_ = _tmp9_;
#line 78 "../core/Util/Datetime.vala"
		_tmp11_ = g_strdup_printf ("%s %s", _tmp6_, _tmp10_);
#line 78 "../core/Util/Datetime.vala"
		_g_free0 (returned);
#line 78 "../core/Util/Datetime.vala"
		returned = _tmp11_;
#line 78 "../core/Util/Datetime.vala"
		_g_free0 (_tmp10_);
#line 78 "../core/Util/Datetime.vala"
		_g_free0 (_tmp8_);
#line 396 "Datetime.c"
	}
#line 81 "../core/Util/Datetime.vala"
	result = returned;
#line 81 "../core/Util/Datetime.vala"
	return result;
#line 402 "Datetime.c"
}

gchar*
utils_datetime_get_relative_datetime (GDateTime* datetime)
{
	gchar* _tmp0_;
	gchar* result;
#line 84 "../core/Util/Datetime.vala"
	g_return_val_if_fail (datetime != NULL, NULL);
#line 85 "../core/Util/Datetime.vala"
	_tmp0_ = granite_date_time_get_relative_datetime (datetime);
#line 85 "../core/Util/Datetime.vala"
	result = _tmp0_;
#line 85 "../core/Util/Datetime.vala"
	return result;
#line 418 "Datetime.c"
}

gchar*
utils_datetime_days_left (GDateTime* datetime,
                          gboolean show_today)
{
	gchar* return_value = NULL;
	gchar* _tmp0_;
	GTimeSpan days = 0LL;
	GDateTime* _tmp1_;
	GDateTime* _tmp2_;
	GTimeSpan _tmp3_;
	gchar* result;
#line 88 "../core/Util/Datetime.vala"
	g_return_val_if_fail (datetime != NULL, NULL);
#line 89 "../core/Util/Datetime.vala"
	_tmp0_ = g_strdup ("");
#line 89 "../core/Util/Datetime.vala"
	return_value = _tmp0_;
#line 90 "../core/Util/Datetime.vala"
	_tmp1_ = g_date_time_new_now_local ();
#line 90 "../core/Util/Datetime.vala"
	_tmp2_ = _tmp1_;
#line 90 "../core/Util/Datetime.vala"
	_tmp3_ = g_date_time_difference (datetime, _tmp2_) / G_TIME_SPAN_DAY;
#line 90 "../core/Util/Datetime.vala"
	_g_date_time_unref0 (_tmp2_);
#line 90 "../core/Util/Datetime.vala"
	days = _tmp3_;
#line 92 "../core/Util/Datetime.vala"
	if (utils_datetime_is_today (datetime)) {
#line 450 "Datetime.c"
		const gchar* _tmp4_ = NULL;
		gchar* _tmp5_;
#line 93 "../core/Util/Datetime.vala"
		if (show_today) {
#line 93 "../core/Util/Datetime.vala"
			_tmp4_ = _ ("Today");
#line 457 "Datetime.c"
		} else {
#line 93 "../core/Util/Datetime.vala"
			_tmp4_ = "";
#line 461 "Datetime.c"
		}
#line 93 "../core/Util/Datetime.vala"
		_tmp5_ = g_strdup (_tmp4_);
#line 93 "../core/Util/Datetime.vala"
		_g_free0 (return_value);
#line 93 "../core/Util/Datetime.vala"
		return_value = _tmp5_;
#line 469 "Datetime.c"
	} else {
#line 94 "../core/Util/Datetime.vala"
		if (utils_datetime_is_overdue (datetime)) {
#line 473 "Datetime.c"
			const gchar* _tmp6_ = NULL;
			gchar* _tmp7_;
			gchar* _tmp8_;
			gchar* _tmp9_;
			gchar* _tmp10_;
			gchar* _tmp11_;
#line 95 "../core/Util/Datetime.vala"
			if (days > ((GTimeSpan) 1)) {
#line 95 "../core/Util/Datetime.vala"
				_tmp6_ = _ ("days");
#line 484 "Datetime.c"
			} else {
#line 95 "../core/Util/Datetime.vala"
				_tmp6_ = _ ("day");
#line 488 "Datetime.c"
			}
#line 95 "../core/Util/Datetime.vala"
			_tmp7_ = g_strdup_printf ("%" G_GINT64_FORMAT, (gint64) (days * -1));
#line 95 "../core/Util/Datetime.vala"
			_tmp8_ = _tmp7_;
#line 95 "../core/Util/Datetime.vala"
			_tmp9_ = g_strdup_printf ("%s %s ago", _tmp8_, _tmp6_);
#line 95 "../core/Util/Datetime.vala"
			_tmp10_ = _tmp9_;
#line 95 "../core/Util/Datetime.vala"
			_tmp11_ = g_strdup (_ (_tmp10_));
#line 95 "../core/Util/Datetime.vala"
			_g_free0 (return_value);
#line 95 "../core/Util/Datetime.vala"
			return_value = _tmp11_;
#line 95 "../core/Util/Datetime.vala"
			_g_free0 (_tmp10_);
#line 95 "../core/Util/Datetime.vala"
			_g_free0 (_tmp8_);
#line 508 "Datetime.c"
		} else {
			const gchar* _tmp12_ = NULL;
			gchar* _tmp13_;
			gchar* _tmp14_;
			gchar* _tmp15_;
			gchar* _tmp16_;
			gchar* _tmp17_;
#line 97 "../core/Util/Datetime.vala"
			if (days > ((GTimeSpan) 1)) {
#line 97 "../core/Util/Datetime.vala"
				_tmp12_ = _ ("days");
#line 520 "Datetime.c"
			} else {
#line 97 "../core/Util/Datetime.vala"
				_tmp12_ = _ ("day");
#line 524 "Datetime.c"
			}
#line 97 "../core/Util/Datetime.vala"
			_tmp13_ = g_strdup_printf ("%" G_GINT64_FORMAT, (gint64) (days + 1));
#line 97 "../core/Util/Datetime.vala"
			_tmp14_ = _tmp13_;
#line 97 "../core/Util/Datetime.vala"
			_tmp15_ = g_strdup_printf ("%s %s left", _tmp14_, _tmp12_);
#line 97 "../core/Util/Datetime.vala"
			_tmp16_ = _tmp15_;
#line 97 "../core/Util/Datetime.vala"
			_tmp17_ = g_strdup (_ (_tmp16_));
#line 97 "../core/Util/Datetime.vala"
			_g_free0 (return_value);
#line 97 "../core/Util/Datetime.vala"
			return_value = _tmp17_;
#line 97 "../core/Util/Datetime.vala"
			_g_free0 (_tmp16_);
#line 97 "../core/Util/Datetime.vala"
			_g_free0 (_tmp14_);
#line 544 "Datetime.c"
		}
	}
#line 100 "../core/Util/Datetime.vala"
	result = return_value;
#line 100 "../core/Util/Datetime.vala"
	return result;
#line 551 "Datetime.c"
}

gchar*
utils_datetime_get_default_time_format (void)
{
	gchar* _tmp0_;
	gchar* result;
#line 104 "../core/Util/Datetime.vala"
	_tmp0_ = granite_date_time_get_default_time_format (utils_datetime_is_clock_format_12h (), FALSE);
#line 104 "../core/Util/Datetime.vala"
	result = _tmp0_;
#line 104 "../core/Util/Datetime.vala"
	return result;
#line 565 "Datetime.c"
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gchar* _tmp0_;
	gboolean result;
#line 1584 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1584 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 1585 "glib-2.0.vapi"
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
#line 1585 "glib-2.0.vapi"
	result = _tmp0_ != NULL;
#line 1585 "glib-2.0.vapi"
	return result;
#line 584 "Datetime.c"
}

gboolean
utils_datetime_is_clock_format_12h (void)
{
	ServicesSettings* _tmp0_;
	ServicesSettings* _tmp1_;
	GSettings* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gboolean _tmp5_;
	gboolean result;
#line 110 "../core/Util/Datetime.vala"
	_tmp0_ = services_settings_get_default ();
#line 110 "../core/Util/Datetime.vala"
	_tmp1_ = _tmp0_;
#line 110 "../core/Util/Datetime.vala"
	_tmp2_ = _tmp1_->settings;
#line 110 "../core/Util/Datetime.vala"
	_tmp3_ = g_settings_get_string (_tmp2_, "clock-format");
#line 110 "../core/Util/Datetime.vala"
	_tmp4_ = _tmp3_;
#line 110 "../core/Util/Datetime.vala"
	_tmp5_ = string_contains (_tmp4_, "12h");
#line 110 "../core/Util/Datetime.vala"
	_g_free0 (_tmp4_);
#line 110 "../core/Util/Datetime.vala"
	_g_object_unref0 (_tmp1_);
#line 110 "../core/Util/Datetime.vala"
	result = _tmp5_;
#line 110 "../core/Util/Datetime.vala"
	return result;
#line 617 "Datetime.c"
}

gboolean
utils_datetime_is_yesterday (GDateTime* date)
{
	GDateTime* _tmp0_;
	GDateTime* _tmp1_;
	GDateTime* _tmp2_;
	GDateTime* _tmp3_;
	gboolean _tmp4_;
	gboolean result;
#line 113 "../core/Util/Datetime.vala"
	g_return_val_if_fail (date != NULL, FALSE);
#line 114 "../core/Util/Datetime.vala"
	_tmp0_ = g_date_time_new_now_local ();
#line 114 "../core/Util/Datetime.vala"
	_tmp1_ = _tmp0_;
#line 114 "../core/Util/Datetime.vala"
	_tmp2_ = g_date_time_add_days (_tmp1_, -1);
#line 114 "../core/Util/Datetime.vala"
	_tmp3_ = _tmp2_;
#line 114 "../core/Util/Datetime.vala"
	_tmp4_ = utils_datetime_is_same_day (date, _tmp3_);
#line 114 "../core/Util/Datetime.vala"
	_g_date_time_unref0 (_tmp3_);
#line 114 "../core/Util/Datetime.vala"
	_g_date_time_unref0 (_tmp1_);
#line 114 "../core/Util/Datetime.vala"
	result = _tmp4_;
#line 114 "../core/Util/Datetime.vala"
	return result;
#line 649 "Datetime.c"
}

gboolean
utils_datetime_is_same_day (GDateTime* day1,
                            GDateTime* day2)
{
	gboolean _tmp0_ = FALSE;
	gboolean result;
#line 117 "../core/Util/Datetime.vala"
	g_return_val_if_fail (day1 != NULL, FALSE);
#line 117 "../core/Util/Datetime.vala"
	g_return_val_if_fail (day2 != NULL, FALSE);
#line 118 "../core/Util/Datetime.vala"
	if (g_date_time_get_day_of_year (day1) == g_date_time_get_day_of_year (day2)) {
#line 118 "../core/Util/Datetime.vala"
		_tmp0_ = g_date_time_get_year (day1) == g_date_time_get_year (day2);
#line 666 "Datetime.c"
	} else {
#line 118 "../core/Util/Datetime.vala"
		_tmp0_ = FALSE;
#line 670 "Datetime.c"
	}
#line 118 "../core/Util/Datetime.vala"
	result = _tmp0_;
#line 118 "../core/Util/Datetime.vala"
	return result;
#line 676 "Datetime.c"
}

gboolean
utils_datetime_is_overdue (GDateTime* date)
{
	GDateTime* _tmp0_;
	GDateTime* _tmp1_;
	GDateTime* _tmp2_;
	GDateTime* _tmp3_;
	GDateTime* _tmp4_;
	GDateTime* _tmp5_;
	gboolean _tmp6_;
	gboolean result;
#line 121 "../core/Util/Datetime.vala"
	g_return_val_if_fail (date != NULL, FALSE);
#line 122 "../core/Util/Datetime.vala"
	_tmp0_ = utils_datetime_get_date_only (date);
#line 122 "../core/Util/Datetime.vala"
	_tmp1_ = _tmp0_;
#line 122 "../core/Util/Datetime.vala"
	_tmp2_ = g_date_time_new_now_local ();
#line 122 "../core/Util/Datetime.vala"
	_tmp3_ = _tmp2_;
#line 122 "../core/Util/Datetime.vala"
	_tmp4_ = utils_datetime_get_date_only (_tmp3_);
#line 122 "../core/Util/Datetime.vala"
	_tmp5_ = _tmp4_;
#line 122 "../core/Util/Datetime.vala"
	_tmp6_ = g_date_time_compare (_tmp1_, _tmp5_) == -1;
#line 122 "../core/Util/Datetime.vala"
	_g_date_time_unref0 (_tmp5_);
#line 122 "../core/Util/Datetime.vala"
	_g_date_time_unref0 (_tmp3_);
#line 122 "../core/Util/Datetime.vala"
	_g_date_time_unref0 (_tmp1_);
#line 122 "../core/Util/Datetime.vala"
	if (_tmp6_) {
#line 123 "../core/Util/Datetime.vala"
		result = TRUE;
#line 123 "../core/Util/Datetime.vala"
		return result;
#line 718 "Datetime.c"
	}
#line 126 "../core/Util/Datetime.vala"
	result = FALSE;
#line 126 "../core/Util/Datetime.vala"
	return result;
#line 724 "Datetime.c"
}

gchar*
utils_datetime_get_calendar_icon (GDateTime* date)
{
	gchar* result;
#line 129 "../core/Util/Datetime.vala"
	g_return_val_if_fail (date != NULL, NULL);
#line 130 "../core/Util/Datetime.vala"
	if (utils_datetime_is_today (date)) {
#line 735 "Datetime.c"
		gchar* _tmp0_;
#line 131 "../core/Util/Datetime.vala"
		_tmp0_ = g_strdup ("planner-today");
#line 131 "../core/Util/Datetime.vala"
		result = _tmp0_;
#line 131 "../core/Util/Datetime.vala"
		return result;
#line 743 "Datetime.c"
	} else {
		gchar* _tmp1_;
#line 133 "../core/Util/Datetime.vala"
		_tmp1_ = g_strdup ("planner-scheduled");
#line 133 "../core/Util/Datetime.vala"
		result = _tmp1_;
#line 133 "../core/Util/Datetime.vala"
		return result;
#line 752 "Datetime.c"
	}
}

void
utils_datetime_parse_todoist_recurrency (ObjectsDueDate* duedate,
                                         JsonObject* object)
{
	gboolean _tmp0_ = FALSE;
#line 137 "../core/Util/Datetime.vala"
	g_return_if_fail (duedate != NULL);
#line 137 "../core/Util/Datetime.vala"
	g_return_if_fail (object != NULL);
#line 138 "../core/Util/Datetime.vala"
	if (json_object_has_member (object, "lang")) {
#line 767 "Datetime.c"
		const gchar* _tmp1_;
#line 138 "../core/Util/Datetime.vala"
		_tmp1_ = json_object_get_string_member (object, "lang");
#line 138 "../core/Util/Datetime.vala"
		_tmp0_ = g_strcmp0 (_tmp1_, "en") != 0;
#line 773 "Datetime.c"
	} else {
#line 138 "../core/Util/Datetime.vala"
		_tmp0_ = FALSE;
#line 777 "Datetime.c"
	}
#line 138 "../core/Util/Datetime.vala"
	if (_tmp0_) {
#line 139 "../core/Util/Datetime.vala"
		objects_due_date_set_recurrence_supported (duedate, FALSE);
#line 140 "../core/Util/Datetime.vala"
		return;
#line 785 "Datetime.c"
	}
}

gboolean
utils_datetime_has_time (GDateTime* datetime)
{
	gboolean returned = FALSE;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean result;
#line 144 "../core/Util/Datetime.vala"
	g_return_val_if_fail (datetime != NULL, FALSE);
#line 145 "../core/Util/Datetime.vala"
	if (datetime == NULL) {
#line 146 "../core/Util/Datetime.vala"
		result = FALSE;
#line 146 "../core/Util/Datetime.vala"
		return result;
#line 804 "Datetime.c"
	}
#line 149 "../core/Util/Datetime.vala"
	returned = TRUE;
#line 151 "../core/Util/Datetime.vala"
	if (g_date_time_get_hour (datetime) == 0) {
#line 151 "../core/Util/Datetime.vala"
		_tmp1_ = g_date_time_get_minute (datetime) == 0;
#line 812 "Datetime.c"
	} else {
#line 151 "../core/Util/Datetime.vala"
		_tmp1_ = FALSE;
#line 816 "Datetime.c"
	}
#line 151 "../core/Util/Datetime.vala"
	if (_tmp1_) {
#line 151 "../core/Util/Datetime.vala"
		_tmp0_ = g_date_time_get_second (datetime) == 0;
#line 822 "Datetime.c"
	} else {
#line 151 "../core/Util/Datetime.vala"
		_tmp0_ = FALSE;
#line 826 "Datetime.c"
	}
#line 151 "../core/Util/Datetime.vala"
	if (_tmp0_) {
#line 152 "../core/Util/Datetime.vala"
		returned = FALSE;
#line 832 "Datetime.c"
	}
#line 155 "../core/Util/Datetime.vala"
	result = returned;
#line 155 "../core/Util/Datetime.vala"
	return result;
#line 838 "Datetime.c"
}

gboolean
utils_datetime_is_today (GDateTime* date)
{
	GDateTime* _tmp0_;
	GDateTime* _tmp1_;
	gboolean _tmp2_;
	gboolean result;
#line 158 "../core/Util/Datetime.vala"
	g_return_val_if_fail (date != NULL, FALSE);
#line 159 "../core/Util/Datetime.vala"
	if (date == NULL) {
#line 160 "../core/Util/Datetime.vala"
		result = FALSE;
#line 160 "../core/Util/Datetime.vala"
		return result;
#line 856 "Datetime.c"
	}
#line 163 "../core/Util/Datetime.vala"
	_tmp0_ = g_date_time_new_now_local ();
#line 163 "../core/Util/Datetime.vala"
	_tmp1_ = _tmp0_;
#line 163 "../core/Util/Datetime.vala"
	_tmp2_ = utils_datetime_is_same_day (date, _tmp1_);
#line 163 "../core/Util/Datetime.vala"
	_g_date_time_unref0 (_tmp1_);
#line 163 "../core/Util/Datetime.vala"
	result = _tmp2_;
#line 163 "../core/Util/Datetime.vala"
	return result;
#line 870 "Datetime.c"
}

gboolean
utils_datetime_is_tomorrow (GDateTime* date)
{
	GDateTime* _tmp0_;
	GDateTime* _tmp1_;
	GDateTime* _tmp2_;
	GDateTime* _tmp3_;
	gboolean _tmp4_;
	gboolean result;
#line 166 "../core/Util/Datetime.vala"
	g_return_val_if_fail (date != NULL, FALSE);
#line 167 "../core/Util/Datetime.vala"
	if (date == NULL) {
#line 168 "../core/Util/Datetime.vala"
		result = FALSE;
#line 168 "../core/Util/Datetime.vala"
		return result;
#line 890 "Datetime.c"
	}
#line 171 "../core/Util/Datetime.vala"
	_tmp0_ = g_date_time_new_now_local ();
#line 171 "../core/Util/Datetime.vala"
	_tmp1_ = _tmp0_;
#line 171 "../core/Util/Datetime.vala"
	_tmp2_ = g_date_time_add_days (_tmp1_, 1);
#line 171 "../core/Util/Datetime.vala"
	_tmp3_ = _tmp2_;
#line 171 "../core/Util/Datetime.vala"
	_tmp4_ = utils_datetime_is_same_day (date, _tmp3_);
#line 171 "../core/Util/Datetime.vala"
	_g_date_time_unref0 (_tmp3_);
#line 171 "../core/Util/Datetime.vala"
	_g_date_time_unref0 (_tmp1_);
#line 171 "../core/Util/Datetime.vala"
	result = _tmp4_;
#line 171 "../core/Util/Datetime.vala"
	return result;
#line 910 "Datetime.c"
}

gboolean
utils_datetime_is_next_week (GDateTime* date)
{
	GDateTime* _tmp0_;
	GDateTime* _tmp1_;
	GDateTime* _tmp2_;
	GDateTime* _tmp3_;
	gboolean _tmp4_;
	gboolean result;
#line 174 "../core/Util/Datetime.vala"
	g_return_val_if_fail (date != NULL, FALSE);
#line 175 "../core/Util/Datetime.vala"
	if (date == NULL) {
#line 176 "../core/Util/Datetime.vala"
		result = FALSE;
#line 176 "../core/Util/Datetime.vala"
		return result;
#line 930 "Datetime.c"
	}
#line 179 "../core/Util/Datetime.vala"
	_tmp0_ = g_date_time_new_now_local ();
#line 179 "../core/Util/Datetime.vala"
	_tmp1_ = _tmp0_;
#line 179 "../core/Util/Datetime.vala"
	_tmp2_ = g_date_time_add_days (_tmp1_, 7);
#line 179 "../core/Util/Datetime.vala"
	_tmp3_ = _tmp2_;
#line 179 "../core/Util/Datetime.vala"
	_tmp4_ = utils_datetime_is_same_day (date, _tmp3_);
#line 179 "../core/Util/Datetime.vala"
	_g_date_time_unref0 (_tmp3_);
#line 179 "../core/Util/Datetime.vala"
	_g_date_time_unref0 (_tmp1_);
#line 179 "../core/Util/Datetime.vala"
	result = _tmp4_;
#line 179 "../core/Util/Datetime.vala"
	return result;
#line 950 "Datetime.c"
}

GDateTime*
utils_datetime_get_date_from_string (const gchar* date)
{
	GTimeZone* _tmp0_;
	GTimeZone* _tmp1_;
	GDateTime* _tmp2_;
	GDateTime* _tmp3_;
	GDateTime* result;
#line 182 "../core/Util/Datetime.vala"
	g_return_val_if_fail (date != NULL, NULL);
#line 183 "../core/Util/Datetime.vala"
	_tmp0_ = g_time_zone_new_local ();
#line 183 "../core/Util/Datetime.vala"
	_tmp1_ = _tmp0_;
#line 183 "../core/Util/Datetime.vala"
	_tmp2_ = g_date_time_new_from_iso8601 (date, _tmp1_);
#line 183 "../core/Util/Datetime.vala"
	_tmp3_ = _tmp2_;
#line 183 "../core/Util/Datetime.vala"
	_g_time_zone_unref0 (_tmp1_);
#line 183 "../core/Util/Datetime.vala"
	result = _tmp3_;
#line 183 "../core/Util/Datetime.vala"
	return result;
#line 977 "Datetime.c"
}

static gchar*
g_date_time_to_string (GDateTime* self)
{
	gchar* _tmp0_;
	gchar* result;
#line 3410 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 3411 "glib-2.0.vapi"
	_tmp0_ = g_date_time_format (self, "%FT%H:%M:%S%z");
#line 3411 "glib-2.0.vapi"
	result = _tmp0_;
#line 3411 "glib-2.0.vapi"
	return result;
#line 993 "Datetime.c"
}

static gchar*
string_slice (const gchar* self,
              glong start,
              glong end)
{
	glong string_length = 0L;
	gint _tmp0_;
	gint _tmp1_;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gchar* _tmp4_;
	gchar* result;
#line 1534 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1535 "glib-2.0.vapi"
	_tmp0_ = strlen (self);
#line 1535 "glib-2.0.vapi"
	_tmp1_ = _tmp0_;
#line 1535 "glib-2.0.vapi"
	string_length = (glong) _tmp1_;
#line 1536 "glib-2.0.vapi"
	if (start < ((glong) 0)) {
#line 1537 "glib-2.0.vapi"
		start = string_length + start;
#line 1020 "Datetime.c"
	}
#line 1539 "glib-2.0.vapi"
	if (end < ((glong) 0)) {
#line 1540 "glib-2.0.vapi"
		end = string_length + end;
#line 1026 "Datetime.c"
	}
#line 1542 "glib-2.0.vapi"
	if (start >= ((glong) 0)) {
#line 1542 "glib-2.0.vapi"
		_tmp2_ = start <= string_length;
#line 1032 "Datetime.c"
	} else {
#line 1542 "glib-2.0.vapi"
		_tmp2_ = FALSE;
#line 1036 "Datetime.c"
	}
#line 1542 "glib-2.0.vapi"
	g_return_val_if_fail (_tmp2_, NULL);
#line 1543 "glib-2.0.vapi"
	if (end >= ((glong) 0)) {
#line 1543 "glib-2.0.vapi"
		_tmp3_ = end <= string_length;
#line 1044 "Datetime.c"
	} else {
#line 1543 "glib-2.0.vapi"
		_tmp3_ = FALSE;
#line 1048 "Datetime.c"
	}
#line 1543 "glib-2.0.vapi"
	g_return_val_if_fail (_tmp3_, NULL);
#line 1544 "glib-2.0.vapi"
	g_return_val_if_fail (start <= end, NULL);
#line 1545 "glib-2.0.vapi"
	_tmp4_ = g_strndup (((gchar*) self) + start, (gsize) (end - start));
#line 1545 "glib-2.0.vapi"
	result = _tmp4_;
#line 1545 "glib-2.0.vapi"
	return result;
#line 1060 "Datetime.c"
}

void
utils_datetime_recurrence_to_due (ICalRecurrence* recurrence,
                                  ObjectsDueDate* due)
{
	ICalRecurrenceFrequency freq = 0;
	gshort interval = 0;
	gint count = 0;
	ICalTime* until = NULL;
	ICalTime* _tmp0_;
	ICalTime* _tmp1_;
	RecurrencyType _tmp7_;
	RecurrencyType _tmp8_;
#line 186 "../core/Util/Datetime.vala"
	g_return_if_fail (recurrence != NULL);
#line 186 "../core/Util/Datetime.vala"
	g_return_if_fail (due != NULL);
#line 187 "../core/Util/Datetime.vala"
	objects_due_date_set_is_recurring (due, TRUE);
#line 189 "../core/Util/Datetime.vala"
	freq = i_cal_recurrence_get_freq (recurrence);
#line 190 "../core/Util/Datetime.vala"
	if (freq == I_CAL_MINUTELY_RECURRENCE) {
#line 191 "../core/Util/Datetime.vala"
		objects_due_date_set_recurrency_type (due, RECURRENCY_TYPE_MINUTELY);
#line 1087 "Datetime.c"
	} else {
#line 192 "../core/Util/Datetime.vala"
		if (freq == I_CAL_HOURLY_RECURRENCE) {
#line 193 "../core/Util/Datetime.vala"
			objects_due_date_set_recurrency_type (due, RECURRENCY_TYPE_HOURLY);
#line 1093 "Datetime.c"
		} else {
#line 194 "../core/Util/Datetime.vala"
			if (freq == I_CAL_DAILY_RECURRENCE) {
#line 195 "../core/Util/Datetime.vala"
				objects_due_date_set_recurrency_type (due, RECURRENCY_TYPE_EVERY_DAY);
#line 1099 "Datetime.c"
			} else {
#line 196 "../core/Util/Datetime.vala"
				if (freq == I_CAL_WEEKLY_RECURRENCE) {
#line 197 "../core/Util/Datetime.vala"
					objects_due_date_set_recurrency_type (due, RECURRENCY_TYPE_EVERY_WEEK);
#line 1105 "Datetime.c"
				} else {
#line 198 "../core/Util/Datetime.vala"
					if (freq == I_CAL_MONTHLY_RECURRENCE) {
#line 199 "../core/Util/Datetime.vala"
						objects_due_date_set_recurrency_type (due, RECURRENCY_TYPE_EVERY_MONTH);
#line 1111 "Datetime.c"
					} else {
#line 200 "../core/Util/Datetime.vala"
						if (freq == I_CAL_YEARLY_RECURRENCE) {
#line 201 "../core/Util/Datetime.vala"
							objects_due_date_set_recurrency_type (due, RECURRENCY_TYPE_EVERY_YEAR);
#line 1117 "Datetime.c"
						}
					}
				}
			}
		}
	}
#line 204 "../core/Util/Datetime.vala"
	interval = i_cal_recurrence_get_interval (recurrence);
#line 205 "../core/Util/Datetime.vala"
	objects_due_date_set_recurrency_interval (due, (gint) interval);
#line 207 "../core/Util/Datetime.vala"
	count = i_cal_recurrence_get_count (recurrence);
#line 208 "../core/Util/Datetime.vala"
	objects_due_date_set_recurrency_count (due, count);
#line 210 "../core/Util/Datetime.vala"
	_tmp0_ = i_cal_recurrence_get_until (recurrence);
#line 210 "../core/Util/Datetime.vala"
	until = _tmp0_;
#line 211 "../core/Util/Datetime.vala"
	_tmp1_ = until;
#line 211 "../core/Util/Datetime.vala"
	if (!i_cal_time_is_null_time (_tmp1_)) {
#line 1140 "Datetime.c"
		ICalTime* _tmp2_;
		GDateTime* _tmp3_;
		GDateTime* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
#line 212 "../core/Util/Datetime.vala"
		_tmp2_ = until;
#line 212 "../core/Util/Datetime.vala"
		_tmp3_ = utils_datetime_ical_to_date_time_local (_tmp2_);
#line 212 "../core/Util/Datetime.vala"
		_tmp4_ = _tmp3_;
#line 212 "../core/Util/Datetime.vala"
		_tmp5_ = g_date_time_to_string (_tmp4_);
#line 212 "../core/Util/Datetime.vala"
		_tmp6_ = _tmp5_;
#line 212 "../core/Util/Datetime.vala"
		objects_due_date_set_recurrency_end (due, _tmp6_);
#line 212 "../core/Util/Datetime.vala"
		_g_free0 (_tmp6_);
#line 212 "../core/Util/Datetime.vala"
		_g_date_time_unref0 (_tmp4_);
#line 1162 "Datetime.c"
	}
#line 215 "../core/Util/Datetime.vala"
	_tmp7_ = objects_due_date_get_recurrency_type (due);
#line 215 "../core/Util/Datetime.vala"
	_tmp8_ = _tmp7_;
#line 215 "../core/Util/Datetime.vala"
	if (_tmp8_ == RECURRENCY_TYPE_EVERY_WEEK) {
#line 1170 "Datetime.c"
		gchar* recurrency_weeks = NULL;
		gchar* _tmp9_;
		GArray* day_array = NULL;
		GArray* _tmp10_;
		GArray* _tmp11_;
		GArray* _tmp14_;
		GArray* _tmp17_;
		GArray* _tmp20_;
		GArray* _tmp23_;
		GArray* _tmp26_;
		GArray* _tmp29_;
		const gchar* _tmp32_;
		gchar** _tmp33_;
		gchar** _tmp34_;
		gchar** _tmp35_;
		gint _tmp35__length1;
		gboolean _tmp36_;
		const gchar* _tmp40_;
#line 216 "../core/Util/Datetime.vala"
		_tmp9_ = g_strdup ("");
#line 216 "../core/Util/Datetime.vala"
		recurrency_weeks = _tmp9_;
#line 217 "../core/Util/Datetime.vala"
		_tmp10_ = i_cal_recurrence_get_by_day_array (recurrence);
#line 217 "../core/Util/Datetime.vala"
		day_array = _tmp10_;
#line 219 "../core/Util/Datetime.vala"
		_tmp11_ = day_array;
#line 219 "../core/Util/Datetime.vala"
		if (utils_datetime_check_by_day ("1", _tmp11_)) {
#line 1201 "Datetime.c"
			const gchar* _tmp12_;
			gchar* _tmp13_;
#line 220 "../core/Util/Datetime.vala"
			_tmp12_ = recurrency_weeks;
#line 220 "../core/Util/Datetime.vala"
			_tmp13_ = g_strconcat (_tmp12_, "7,", NULL);
#line 220 "../core/Util/Datetime.vala"
			_g_free0 (recurrency_weeks);
#line 220 "../core/Util/Datetime.vala"
			recurrency_weeks = _tmp13_;
#line 1212 "Datetime.c"
		}
#line 223 "../core/Util/Datetime.vala"
		_tmp14_ = day_array;
#line 223 "../core/Util/Datetime.vala"
		if (utils_datetime_check_by_day ("2", _tmp14_)) {
#line 1218 "Datetime.c"
			const gchar* _tmp15_;
			gchar* _tmp16_;
#line 224 "../core/Util/Datetime.vala"
			_tmp15_ = recurrency_weeks;
#line 224 "../core/Util/Datetime.vala"
			_tmp16_ = g_strconcat (_tmp15_, "1,", NULL);
#line 224 "../core/Util/Datetime.vala"
			_g_free0 (recurrency_weeks);
#line 224 "../core/Util/Datetime.vala"
			recurrency_weeks = _tmp16_;
#line 1229 "Datetime.c"
		}
#line 228 "../core/Util/Datetime.vala"
		_tmp17_ = day_array;
#line 228 "../core/Util/Datetime.vala"
		if (utils_datetime_check_by_day ("3", _tmp17_)) {
#line 1235 "Datetime.c"
			const gchar* _tmp18_;
			gchar* _tmp19_;
#line 229 "../core/Util/Datetime.vala"
			_tmp18_ = recurrency_weeks;
#line 229 "../core/Util/Datetime.vala"
			_tmp19_ = g_strconcat (_tmp18_, "2,", NULL);
#line 229 "../core/Util/Datetime.vala"
			_g_free0 (recurrency_weeks);
#line 229 "../core/Util/Datetime.vala"
			recurrency_weeks = _tmp19_;
#line 1246 "Datetime.c"
		}
#line 233 "../core/Util/Datetime.vala"
		_tmp20_ = day_array;
#line 233 "../core/Util/Datetime.vala"
		if (utils_datetime_check_by_day ("4", _tmp20_)) {
#line 1252 "Datetime.c"
			const gchar* _tmp21_;
			gchar* _tmp22_;
#line 234 "../core/Util/Datetime.vala"
			_tmp21_ = recurrency_weeks;
#line 234 "../core/Util/Datetime.vala"
			_tmp22_ = g_strconcat (_tmp21_, "3,", NULL);
#line 234 "../core/Util/Datetime.vala"
			_g_free0 (recurrency_weeks);
#line 234 "../core/Util/Datetime.vala"
			recurrency_weeks = _tmp22_;
#line 1263 "Datetime.c"
		}
#line 238 "../core/Util/Datetime.vala"
		_tmp23_ = day_array;
#line 238 "../core/Util/Datetime.vala"
		if (utils_datetime_check_by_day ("5", _tmp23_)) {
#line 1269 "Datetime.c"
			const gchar* _tmp24_;
			gchar* _tmp25_;
#line 239 "../core/Util/Datetime.vala"
			_tmp24_ = recurrency_weeks;
#line 239 "../core/Util/Datetime.vala"
			_tmp25_ = g_strconcat (_tmp24_, "4,", NULL);
#line 239 "../core/Util/Datetime.vala"
			_g_free0 (recurrency_weeks);
#line 239 "../core/Util/Datetime.vala"
			recurrency_weeks = _tmp25_;
#line 1280 "Datetime.c"
		}
#line 243 "../core/Util/Datetime.vala"
		_tmp26_ = day_array;
#line 243 "../core/Util/Datetime.vala"
		if (utils_datetime_check_by_day ("6", _tmp26_)) {
#line 1286 "Datetime.c"
			const gchar* _tmp27_;
			gchar* _tmp28_;
#line 244 "../core/Util/Datetime.vala"
			_tmp27_ = recurrency_weeks;
#line 244 "../core/Util/Datetime.vala"
			_tmp28_ = g_strconcat (_tmp27_, "5,", NULL);
#line 244 "../core/Util/Datetime.vala"
			_g_free0 (recurrency_weeks);
#line 244 "../core/Util/Datetime.vala"
			recurrency_weeks = _tmp28_;
#line 1297 "Datetime.c"
		}
#line 248 "../core/Util/Datetime.vala"
		_tmp29_ = day_array;
#line 248 "../core/Util/Datetime.vala"
		if (utils_datetime_check_by_day ("7", _tmp29_)) {
#line 1303 "Datetime.c"
			const gchar* _tmp30_;
			gchar* _tmp31_;
#line 249 "../core/Util/Datetime.vala"
			_tmp30_ = recurrency_weeks;
#line 249 "../core/Util/Datetime.vala"
			_tmp31_ = g_strconcat (_tmp30_, "6,", NULL);
#line 249 "../core/Util/Datetime.vala"
			_g_free0 (recurrency_weeks);
#line 249 "../core/Util/Datetime.vala"
			recurrency_weeks = _tmp31_;
#line 1314 "Datetime.c"
		}
#line 252 "../core/Util/Datetime.vala"
		_tmp32_ = recurrency_weeks;
#line 252 "../core/Util/Datetime.vala"
		_tmp34_ = _tmp33_ = g_strsplit (_tmp32_, ",", 0);
#line 252 "../core/Util/Datetime.vala"
		_tmp35_ = _tmp34_;
#line 252 "../core/Util/Datetime.vala"
		_tmp35__length1 = _vala_array_length (_tmp33_);
#line 252 "../core/Util/Datetime.vala"
		_tmp36_ = _vala_array_length (_tmp33_) > 0;
#line 252 "../core/Util/Datetime.vala"
		_tmp35_ = (_vala_array_free (_tmp35_, _tmp35__length1, (GDestroyNotify) g_free), NULL);
#line 252 "../core/Util/Datetime.vala"
		if (_tmp36_) {
#line 1330 "Datetime.c"
			const gchar* _tmp37_;
			gchar* _tmp38_;
			gchar* _tmp39_;
#line 253 "../core/Util/Datetime.vala"
			_tmp37_ = recurrency_weeks;
#line 253 "../core/Util/Datetime.vala"
			_tmp38_ = string_slice (_tmp37_, (glong) 0, (glong) -1);
#line 253 "../core/Util/Datetime.vala"
			_tmp39_ = _tmp38_;
#line 253 "../core/Util/Datetime.vala"
			_g_free0 (_tmp39_);
#line 1342 "Datetime.c"
		}
#line 256 "../core/Util/Datetime.vala"
		_tmp40_ = recurrency_weeks;
#line 256 "../core/Util/Datetime.vala"
		objects_due_date_set_recurrency_weeks (due, _tmp40_);
#line 215 "../core/Util/Datetime.vala"
		_g_array_unref0 (day_array);
#line 215 "../core/Util/Datetime.vala"
		_g_free0 (recurrency_weeks);
#line 1352 "Datetime.c"
	}
#line 186 "../core/Util/Datetime.vala"
	_g_object_unref0 (until);
#line 1356 "Datetime.c"
}

static gboolean
utils_datetime_check_by_day (const gchar* day,
                             GArray* day_array)
{
	gboolean result;
#line 260 "../core/Util/Datetime.vala"
	g_return_val_if_fail (day != NULL, FALSE);
#line 260 "../core/Util/Datetime.vala"
	g_return_val_if_fail (day_array != NULL, FALSE);
#line 1368 "Datetime.c"
	{
		GArray* _day_collection = NULL;
		guint _day_index = 0U;
#line 261 "../core/Util/Datetime.vala"
		_day_collection = day_array;
#line 261 "../core/Util/Datetime.vala"
		for (_day_index = 0; _day_index < _day_collection->len; _day_index = _day_index + 1) {
#line 1376 "Datetime.c"
			gshort _day = 0;
#line 261 "../core/Util/Datetime.vala"
			_day = g_array_index (_day_collection, gshort, _day_index);
#line 1380 "Datetime.c"
			{
				gchar* _tmp0_;
				gchar* _tmp1_;
				gboolean _tmp2_;
#line 262 "../core/Util/Datetime.vala"
				_tmp0_ = g_strdup_printf ("%hi", _day);
#line 262 "../core/Util/Datetime.vala"
				_tmp1_ = _tmp0_;
#line 262 "../core/Util/Datetime.vala"
				_tmp2_ = g_strcmp0 (_tmp1_, day) == 0;
#line 262 "../core/Util/Datetime.vala"
				_g_free0 (_tmp1_);
#line 262 "../core/Util/Datetime.vala"
				if (_tmp2_) {
#line 263 "../core/Util/Datetime.vala"
					result = TRUE;
#line 263 "../core/Util/Datetime.vala"
					return result;
#line 1399 "Datetime.c"
				}
			}
		}
	}
#line 267 "../core/Util/Datetime.vala"
	result = FALSE;
#line 267 "../core/Util/Datetime.vala"
	return result;
#line 1408 "Datetime.c"
}

GDateTime*
utils_datetime_format_date (GDateTime* date)
{
	GDateTime* _tmp0_;
	GDateTime* result;
#line 270 "../core/Util/Datetime.vala"
	g_return_val_if_fail (date != NULL, NULL);
#line 271 "../core/Util/Datetime.vala"
	_tmp0_ = g_date_time_new_local (g_date_time_get_year (date), g_date_time_get_month (date), g_date_time_get_day_of_month (date), 0, 0, (gdouble) 0);
#line 271 "../core/Util/Datetime.vala"
	result = _tmp0_;
#line 271 "../core/Util/Datetime.vala"
	return result;
#line 1424 "Datetime.c"
}

gboolean
utils_datetime_is_this_week (GDateTime* date)
{
	GDateTime* current_date = NULL;
	GDateTime* _tmp0_;
	GDateTime* start_of_week = NULL;
	GDateTime* _tmp1_;
	GDateTime* _tmp2_;
	GDateTime* _tmp3_;
	GDateTime* end_of_week = NULL;
	GDateTime* _tmp4_;
	GDateTime* _tmp5_;
	gboolean _tmp6_ = FALSE;
	GDateTime* _tmp7_;
	GDateTime* _tmp8_;
	GDateTime* _tmp9_;
	gboolean _tmp10_;
	gboolean result;
#line 281 "../core/Util/Datetime.vala"
	g_return_val_if_fail (date != NULL, FALSE);
#line 282 "../core/Util/Datetime.vala"
	_tmp0_ = g_date_time_new_now_local ();
#line 282 "../core/Util/Datetime.vala"
	current_date = _tmp0_;
#line 284 "../core/Util/Datetime.vala"
	_tmp1_ = current_date;
#line 284 "../core/Util/Datetime.vala"
	_tmp2_ = current_date;
#line 284 "../core/Util/Datetime.vala"
	_tmp3_ = g_date_time_add_days (_tmp1_, (g_date_time_get_day_of_week (_tmp2_) - 1) * -1);
#line 284 "../core/Util/Datetime.vala"
	start_of_week = _tmp3_;
#line 285 "../core/Util/Datetime.vala"
	_tmp4_ = current_date;
#line 285 "../core/Util/Datetime.vala"
	_tmp5_ = g_date_time_add_days (_tmp4_, 6);
#line 285 "../core/Util/Datetime.vala"
	end_of_week = _tmp5_;
#line 287 "../core/Util/Datetime.vala"
	_tmp7_ = start_of_week;
#line 287 "../core/Util/Datetime.vala"
	_tmp8_ = utils_datetime_format_date (_tmp7_);
#line 287 "../core/Util/Datetime.vala"
	_tmp9_ = _tmp8_;
#line 287 "../core/Util/Datetime.vala"
	_tmp10_ = g_date_time_compare (date, _tmp9_) >= 0;
#line 287 "../core/Util/Datetime.vala"
	_g_date_time_unref0 (_tmp9_);
#line 287 "../core/Util/Datetime.vala"
	if (_tmp10_) {
#line 1477 "Datetime.c"
		GDateTime* _tmp11_;
		GDateTime* _tmp12_;
		GDateTime* _tmp13_;
#line 288 "../core/Util/Datetime.vala"
		_tmp11_ = end_of_week;
#line 288 "../core/Util/Datetime.vala"
		_tmp12_ = utils_datetime_format_date (_tmp11_);
#line 288 "../core/Util/Datetime.vala"
		_tmp13_ = _tmp12_;
#line 288 "../core/Util/Datetime.vala"
		_tmp6_ = g_date_time_compare (date, _tmp13_) <= 0;
#line 288 "../core/Util/Datetime.vala"
		_g_date_time_unref0 (_tmp13_);
#line 1491 "Datetime.c"
	} else {
#line 287 "../core/Util/Datetime.vala"
		_tmp6_ = FALSE;
#line 1495 "Datetime.c"
	}
#line 287 "../core/Util/Datetime.vala"
	if (_tmp6_) {
#line 289 "../core/Util/Datetime.vala"
		result = TRUE;
#line 289 "../core/Util/Datetime.vala"
		_g_date_time_unref0 (end_of_week);
#line 289 "../core/Util/Datetime.vala"
		_g_date_time_unref0 (start_of_week);
#line 289 "../core/Util/Datetime.vala"
		_g_date_time_unref0 (current_date);
#line 289 "../core/Util/Datetime.vala"
		return result;
#line 1509 "Datetime.c"
	}
#line 292 "../core/Util/Datetime.vala"
	result = FALSE;
#line 292 "../core/Util/Datetime.vala"
	_g_date_time_unref0 (end_of_week);
#line 292 "../core/Util/Datetime.vala"
	_g_date_time_unref0 (start_of_week);
#line 292 "../core/Util/Datetime.vala"
	_g_date_time_unref0 (current_date);
#line 292 "../core/Util/Datetime.vala"
	return result;
#line 1521 "Datetime.c"
}

gboolean
utils_datetime_is_next_x_week (GDateTime* date,
                               gint days)
{
	GDateTime* current_date = NULL;
	GDateTime* _tmp0_;
	GDateTime* end_date = NULL;
	GDateTime* _tmp1_;
	GDateTime* _tmp2_;
	gboolean _tmp3_ = FALSE;
	GDateTime* _tmp4_;
	GDateTime* _tmp5_;
	GDateTime* _tmp6_;
	gboolean _tmp7_;
	gboolean result;
#line 295 "../core/Util/Datetime.vala"
	g_return_val_if_fail (date != NULL, FALSE);
#line 296 "../core/Util/Datetime.vala"
	_tmp0_ = g_date_time_new_now_local ();
#line 296 "../core/Util/Datetime.vala"
	current_date = _tmp0_;
#line 297 "../core/Util/Datetime.vala"
	_tmp1_ = current_date;
#line 297 "../core/Util/Datetime.vala"
	_tmp2_ = g_date_time_add_days (_tmp1_, days);
#line 297 "../core/Util/Datetime.vala"
	end_date = _tmp2_;
#line 299 "../core/Util/Datetime.vala"
	_tmp4_ = current_date;
#line 299 "../core/Util/Datetime.vala"
	_tmp5_ = utils_datetime_format_date (_tmp4_);
#line 299 "../core/Util/Datetime.vala"
	_tmp6_ = _tmp5_;
#line 299 "../core/Util/Datetime.vala"
	_tmp7_ = g_date_time_compare (date, _tmp6_) >= 0;
#line 299 "../core/Util/Datetime.vala"
	_g_date_time_unref0 (_tmp6_);
#line 299 "../core/Util/Datetime.vala"
	if (_tmp7_) {
#line 1563 "Datetime.c"
		GDateTime* _tmp8_;
		GDateTime* _tmp9_;
		GDateTime* _tmp10_;
#line 300 "../core/Util/Datetime.vala"
		_tmp8_ = end_date;
#line 300 "../core/Util/Datetime.vala"
		_tmp9_ = utils_datetime_format_date (_tmp8_);
#line 300 "../core/Util/Datetime.vala"
		_tmp10_ = _tmp9_;
#line 300 "../core/Util/Datetime.vala"
		_tmp3_ = g_date_time_compare (date, _tmp10_) <= 0;
#line 300 "../core/Util/Datetime.vala"
		_g_date_time_unref0 (_tmp10_);
#line 1577 "Datetime.c"
	} else {
#line 299 "../core/Util/Datetime.vala"
		_tmp3_ = FALSE;
#line 1581 "Datetime.c"
	}
#line 299 "../core/Util/Datetime.vala"
	if (_tmp3_) {
#line 301 "../core/Util/Datetime.vala"
		result = TRUE;
#line 301 "../core/Util/Datetime.vala"
		_g_date_time_unref0 (end_date);
#line 301 "../core/Util/Datetime.vala"
		_g_date_time_unref0 (current_date);
#line 301 "../core/Util/Datetime.vala"
		return result;
#line 1593 "Datetime.c"
	}
#line 304 "../core/Util/Datetime.vala"
	result = FALSE;
#line 304 "../core/Util/Datetime.vala"
	_g_date_time_unref0 (end_date);
#line 304 "../core/Util/Datetime.vala"
	_g_date_time_unref0 (current_date);
#line 304 "../core/Util/Datetime.vala"
	return result;
#line 1603 "Datetime.c"
}

gboolean
utils_datetime_is_this_month (GDateTime* date)
{
	GDateTime* current_date = NULL;
	GDateTime* _tmp0_;
	gboolean _tmp1_ = FALSE;
	GDateTime* _tmp2_;
	gboolean result;
#line 307 "../core/Util/Datetime.vala"
	g_return_val_if_fail (date != NULL, FALSE);
#line 308 "../core/Util/Datetime.vala"
	_tmp0_ = g_date_time_new_now_local ();
#line 308 "../core/Util/Datetime.vala"
	current_date = _tmp0_;
#line 309 "../core/Util/Datetime.vala"
	_tmp2_ = current_date;
#line 309 "../core/Util/Datetime.vala"
	if (g_date_time_get_month (_tmp2_) == g_date_time_get_month (date)) {
#line 1624 "Datetime.c"
		GDateTime* _tmp3_;
#line 309 "../core/Util/Datetime.vala"
		_tmp3_ = current_date;
#line 309 "../core/Util/Datetime.vala"
		_tmp1_ = g_date_time_get_year (_tmp3_) == g_date_time_get_year (date);
#line 1630 "Datetime.c"
	} else {
#line 309 "../core/Util/Datetime.vala"
		_tmp1_ = FALSE;
#line 1634 "Datetime.c"
	}
#line 309 "../core/Util/Datetime.vala"
	result = _tmp1_;
#line 309 "../core/Util/Datetime.vala"
	_g_date_time_unref0 (current_date);
#line 309 "../core/Util/Datetime.vala"
	return result;
#line 1642 "Datetime.c"
}

static gpointer
_g_date_time_ref0 (gpointer self)
{
#line 313 "../core/Util/Datetime.vala"
	return self ? g_date_time_ref (self) : NULL;
#line 1650 "Datetime.c"
}

GDateTime*
utils_datetime_next_recurrency (GDateTime* datetime,
                                ObjectsDueDate* duedate)
{
	GDateTime* returned = NULL;
	GDateTime* _tmp0_;
	RecurrencyType _tmp1_;
	RecurrencyType _tmp2_;
	GDateTime* result;
#line 312 "../core/Util/Datetime.vala"
	g_return_val_if_fail (datetime != NULL, NULL);
#line 312 "../core/Util/Datetime.vala"
	g_return_val_if_fail (duedate != NULL, NULL);
#line 313 "../core/Util/Datetime.vala"
	_tmp0_ = _g_date_time_ref0 (datetime);
#line 313 "../core/Util/Datetime.vala"
	returned = _tmp0_;
#line 315 "../core/Util/Datetime.vala"
	_tmp1_ = objects_due_date_get_recurrency_type (duedate);
#line 315 "../core/Util/Datetime.vala"
	_tmp2_ = _tmp1_;
#line 315 "../core/Util/Datetime.vala"
	if (_tmp2_ == RECURRENCY_TYPE_MINUTELY) {
#line 1676 "Datetime.c"
		GDateTime* _tmp3_;
		gint _tmp4_;
		gint _tmp5_;
		GDateTime* _tmp6_;
#line 316 "../core/Util/Datetime.vala"
		_tmp3_ = returned;
#line 316 "../core/Util/Datetime.vala"
		_tmp4_ = objects_due_date_get_recurrency_interval (duedate);
#line 316 "../core/Util/Datetime.vala"
		_tmp5_ = _tmp4_;
#line 316 "../core/Util/Datetime.vala"
		_tmp6_ = g_date_time_add_minutes (_tmp3_, _tmp5_);
#line 316 "../core/Util/Datetime.vala"
		_g_date_time_unref0 (returned);
#line 316 "../core/Util/Datetime.vala"
		returned = _tmp6_;
#line 1693 "Datetime.c"
	} else {
		RecurrencyType _tmp7_;
		RecurrencyType _tmp8_;
#line 317 "../core/Util/Datetime.vala"
		_tmp7_ = objects_due_date_get_recurrency_type (duedate);
#line 317 "../core/Util/Datetime.vala"
		_tmp8_ = _tmp7_;
#line 317 "../core/Util/Datetime.vala"
		if (_tmp8_ == RECURRENCY_TYPE_HOURLY) {
#line 1703 "Datetime.c"
			GDateTime* _tmp9_;
			gint _tmp10_;
			gint _tmp11_;
			GDateTime* _tmp12_;
#line 318 "../core/Util/Datetime.vala"
			_tmp9_ = returned;
#line 318 "../core/Util/Datetime.vala"
			_tmp10_ = objects_due_date_get_recurrency_interval (duedate);
#line 318 "../core/Util/Datetime.vala"
			_tmp11_ = _tmp10_;
#line 318 "../core/Util/Datetime.vala"
			_tmp12_ = g_date_time_add_hours (_tmp9_, _tmp11_);
#line 318 "../core/Util/Datetime.vala"
			_g_date_time_unref0 (returned);
#line 318 "../core/Util/Datetime.vala"
			returned = _tmp12_;
#line 1720 "Datetime.c"
		} else {
			RecurrencyType _tmp13_;
			RecurrencyType _tmp14_;
#line 319 "../core/Util/Datetime.vala"
			_tmp13_ = objects_due_date_get_recurrency_type (duedate);
#line 319 "../core/Util/Datetime.vala"
			_tmp14_ = _tmp13_;
#line 319 "../core/Util/Datetime.vala"
			if (_tmp14_ == RECURRENCY_TYPE_EVERY_DAY) {
#line 1730 "Datetime.c"
				GDateTime* _tmp15_;
				gint _tmp16_;
				gint _tmp17_;
				GDateTime* _tmp18_;
#line 320 "../core/Util/Datetime.vala"
				_tmp15_ = returned;
#line 320 "../core/Util/Datetime.vala"
				_tmp16_ = objects_due_date_get_recurrency_interval (duedate);
#line 320 "../core/Util/Datetime.vala"
				_tmp17_ = _tmp16_;
#line 320 "../core/Util/Datetime.vala"
				_tmp18_ = g_date_time_add_days (_tmp15_, _tmp17_);
#line 320 "../core/Util/Datetime.vala"
				_g_date_time_unref0 (returned);
#line 320 "../core/Util/Datetime.vala"
				returned = _tmp18_;
#line 1747 "Datetime.c"
			} else {
				RecurrencyType _tmp19_;
				RecurrencyType _tmp20_;
#line 321 "../core/Util/Datetime.vala"
				_tmp19_ = objects_due_date_get_recurrency_type (duedate);
#line 321 "../core/Util/Datetime.vala"
				_tmp20_ = _tmp19_;
#line 321 "../core/Util/Datetime.vala"
				if (_tmp20_ == RECURRENCY_TYPE_EVERY_WEEK) {
#line 1757 "Datetime.c"
					const gchar* _tmp21_;
					const gchar* _tmp22_;
#line 322 "../core/Util/Datetime.vala"
					_tmp21_ = objects_due_date_get_recurrency_weeks (duedate);
#line 322 "../core/Util/Datetime.vala"
					_tmp22_ = _tmp21_;
#line 322 "../core/Util/Datetime.vala"
					if (g_strcmp0 (_tmp22_, "") == 0) {
#line 1766 "Datetime.c"
						GDateTime* _tmp23_;
						gint _tmp24_;
						gint _tmp25_;
						GDateTime* _tmp26_;
#line 323 "../core/Util/Datetime.vala"
						_tmp23_ = returned;
#line 323 "../core/Util/Datetime.vala"
						_tmp24_ = objects_due_date_get_recurrency_interval (duedate);
#line 323 "../core/Util/Datetime.vala"
						_tmp25_ = _tmp24_;
#line 323 "../core/Util/Datetime.vala"
						_tmp26_ = g_date_time_add_days (_tmp23_, _tmp25_ * 7);
#line 323 "../core/Util/Datetime.vala"
						_g_date_time_unref0 (returned);
#line 323 "../core/Util/Datetime.vala"
						returned = _tmp26_;
#line 1783 "Datetime.c"
					} else {
						GDateTime* _tmp27_;
#line 325 "../core/Util/Datetime.vala"
						_tmp27_ = utils_datetime_next_recurrency_week (datetime, duedate, TRUE);
#line 325 "../core/Util/Datetime.vala"
						_g_date_time_unref0 (returned);
#line 325 "../core/Util/Datetime.vala"
						returned = _tmp27_;
#line 1792 "Datetime.c"
					}
				} else {
					RecurrencyType _tmp28_;
					RecurrencyType _tmp29_;
#line 327 "../core/Util/Datetime.vala"
					_tmp28_ = objects_due_date_get_recurrency_type (duedate);
#line 327 "../core/Util/Datetime.vala"
					_tmp29_ = _tmp28_;
#line 327 "../core/Util/Datetime.vala"
					if (_tmp29_ == RECURRENCY_TYPE_EVERY_MONTH) {
#line 1803 "Datetime.c"
						GDateTime* _tmp30_;
						gint _tmp31_;
						gint _tmp32_;
						GDateTime* _tmp33_;
#line 328 "../core/Util/Datetime.vala"
						_tmp30_ = returned;
#line 328 "../core/Util/Datetime.vala"
						_tmp31_ = objects_due_date_get_recurrency_interval (duedate);
#line 328 "../core/Util/Datetime.vala"
						_tmp32_ = _tmp31_;
#line 328 "../core/Util/Datetime.vala"
						_tmp33_ = g_date_time_add_months (_tmp30_, _tmp32_);
#line 328 "../core/Util/Datetime.vala"
						_g_date_time_unref0 (returned);
#line 328 "../core/Util/Datetime.vala"
						returned = _tmp33_;
#line 1820 "Datetime.c"
					} else {
						RecurrencyType _tmp34_;
						RecurrencyType _tmp35_;
#line 329 "../core/Util/Datetime.vala"
						_tmp34_ = objects_due_date_get_recurrency_type (duedate);
#line 329 "../core/Util/Datetime.vala"
						_tmp35_ = _tmp34_;
#line 329 "../core/Util/Datetime.vala"
						if (_tmp35_ == RECURRENCY_TYPE_EVERY_YEAR) {
#line 1830 "Datetime.c"
							GDateTime* _tmp36_;
							gint _tmp37_;
							gint _tmp38_;
							GDateTime* _tmp39_;
#line 330 "../core/Util/Datetime.vala"
							_tmp36_ = returned;
#line 330 "../core/Util/Datetime.vala"
							_tmp37_ = objects_due_date_get_recurrency_interval (duedate);
#line 330 "../core/Util/Datetime.vala"
							_tmp38_ = _tmp37_;
#line 330 "../core/Util/Datetime.vala"
							_tmp39_ = g_date_time_add_years (_tmp36_, _tmp38_);
#line 330 "../core/Util/Datetime.vala"
							_g_date_time_unref0 (returned);
#line 330 "../core/Util/Datetime.vala"
							returned = _tmp39_;
#line 1847 "Datetime.c"
						}
					}
				}
			}
		}
	}
#line 333 "../core/Util/Datetime.vala"
	result = returned;
#line 333 "../core/Util/Datetime.vala"
	return result;
#line 1858 "Datetime.c"
}

gint
utils_datetime_get_next_day_of_week_from_recurrency_week (GDateTime* datetime,
                                                          ObjectsDueDate* duedate)
{
	gchar** weeks = NULL;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	gchar** _tmp2_;
	gchar** _tmp3_;
	gint weeks_length1;
	gint _weeks_size_;
	gint day_of_week = 0;
	gint index = 0;
	gchar** _tmp9_;
	gint _tmp9__length1;
	gchar** _tmp10_;
	gint _tmp10__length1;
	const gchar* _tmp11_;
	gint result;
#line 336 "../core/Util/Datetime.vala"
	g_return_val_if_fail (datetime != NULL, 0);
#line 336 "../core/Util/Datetime.vala"
	g_return_val_if_fail (duedate != NULL, 0);
#line 337 "../core/Util/Datetime.vala"
	_tmp0_ = objects_due_date_get_recurrency_weeks (duedate);
#line 337 "../core/Util/Datetime.vala"
	_tmp1_ = _tmp0_;
#line 337 "../core/Util/Datetime.vala"
	_tmp3_ = _tmp2_ = g_strsplit (_tmp1_, ",", 0);
#line 337 "../core/Util/Datetime.vala"
	weeks = _tmp3_;
#line 337 "../core/Util/Datetime.vala"
	weeks_length1 = _vala_array_length (_tmp2_);
#line 337 "../core/Util/Datetime.vala"
	_weeks_size_ = weeks_length1;
#line 338 "../core/Util/Datetime.vala"
	day_of_week = g_date_time_get_day_of_week (datetime);
#line 339 "../core/Util/Datetime.vala"
	index = 0;
#line 1900 "Datetime.c"
	{
		gint i = 0;
#line 341 "../core/Util/Datetime.vala"
		i = 0;
#line 1905 "Datetime.c"
		{
			gboolean _tmp4_ = FALSE;
#line 341 "../core/Util/Datetime.vala"
			_tmp4_ = TRUE;
#line 341 "../core/Util/Datetime.vala"
			while (TRUE) {
#line 1912 "Datetime.c"
				gchar** _tmp6_;
				gint _tmp6__length1;
				gchar** _tmp7_;
				gint _tmp7__length1;
				const gchar* _tmp8_;
#line 341 "../core/Util/Datetime.vala"
				if (!_tmp4_) {
#line 1920 "Datetime.c"
					gint _tmp5_;
#line 341 "../core/Util/Datetime.vala"
					_tmp5_ = i;
#line 341 "../core/Util/Datetime.vala"
					i = _tmp5_ + 1;
#line 1926 "Datetime.c"
				}
#line 341 "../core/Util/Datetime.vala"
				_tmp4_ = FALSE;
#line 341 "../core/Util/Datetime.vala"
				_tmp6_ = weeks;
#line 341 "../core/Util/Datetime.vala"
				_tmp6__length1 = weeks_length1;
#line 341 "../core/Util/Datetime.vala"
				if (!(i < _tmp6__length1)) {
#line 341 "../core/Util/Datetime.vala"
					break;
#line 1938 "Datetime.c"
				}
#line 342 "../core/Util/Datetime.vala"
				_tmp7_ = weeks;
#line 342 "../core/Util/Datetime.vala"
				_tmp7__length1 = weeks_length1;
#line 342 "../core/Util/Datetime.vala"
				_tmp8_ = _tmp7_[i];
#line 342 "../core/Util/Datetime.vala"
				if (day_of_week <= atoi (_tmp8_)) {
#line 343 "../core/Util/Datetime.vala"
					index = i;
#line 344 "../core/Util/Datetime.vala"
					break;
#line 1952 "Datetime.c"
				}
			}
		}
	}
#line 348 "../core/Util/Datetime.vala"
	_tmp9_ = weeks;
#line 348 "../core/Util/Datetime.vala"
	_tmp9__length1 = weeks_length1;
#line 348 "../core/Util/Datetime.vala"
	if (index > (_tmp9__length1 - 1)) {
#line 349 "../core/Util/Datetime.vala"
		index = 0;
#line 1965 "Datetime.c"
	}
#line 352 "../core/Util/Datetime.vala"
	_tmp10_ = weeks;
#line 352 "../core/Util/Datetime.vala"
	_tmp10__length1 = weeks_length1;
#line 352 "../core/Util/Datetime.vala"
	_tmp11_ = _tmp10_[index];
#line 352 "../core/Util/Datetime.vala"
	result = atoi (_tmp11_);
#line 352 "../core/Util/Datetime.vala"
	weeks = (_vala_array_free (weeks, weeks_length1, (GDestroyNotify) g_free), NULL);
#line 352 "../core/Util/Datetime.vala"
	return result;
#line 1979 "Datetime.c"
}

GDateTime*
utils_datetime_next_recurrency_week (GDateTime* datetime,
                                     ObjectsDueDate* duedate,
                                     gboolean user)
{
	gchar** weeks = NULL;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	gchar** _tmp2_;
	gchar** _tmp3_;
	gint weeks_length1;
	gint _weeks_size_;
	gint day_of_week = 0;
	gint days = 0;
	gint next_day = 0;
	gint index = 0;
	gint recurrency_interval = 0;
	gchar** _tmp9_;
	gint _tmp9__length1;
	const gchar* _tmp10_;
	gboolean _tmp11_ = FALSE;
	GDateTime* _tmp14_;
	GDateTime* _tmp15_;
	GDateTime* _tmp16_;
	GDateTime* _tmp17_;
	GDateTime* result;
#line 355 "../core/Util/Datetime.vala"
	g_return_val_if_fail (datetime != NULL, NULL);
#line 355 "../core/Util/Datetime.vala"
	g_return_val_if_fail (duedate != NULL, NULL);
#line 356 "../core/Util/Datetime.vala"
	_tmp0_ = objects_due_date_get_recurrency_weeks (duedate);
#line 356 "../core/Util/Datetime.vala"
	_tmp1_ = _tmp0_;
#line 356 "../core/Util/Datetime.vala"
	_tmp3_ = _tmp2_ = g_strsplit (_tmp1_, ",", 0);
#line 356 "../core/Util/Datetime.vala"
	weeks = _tmp3_;
#line 356 "../core/Util/Datetime.vala"
	weeks_length1 = _vala_array_length (_tmp2_);
#line 356 "../core/Util/Datetime.vala"
	_weeks_size_ = weeks_length1;
#line 357 "../core/Util/Datetime.vala"
	day_of_week = g_date_time_get_day_of_week (datetime);
#line 358 "../core/Util/Datetime.vala"
	days = 0;
#line 359 "../core/Util/Datetime.vala"
	next_day = 0;
#line 360 "../core/Util/Datetime.vala"
	index = 0;
#line 361 "../core/Util/Datetime.vala"
	recurrency_interval = 0;
#line 2034 "Datetime.c"
	{
		gint i = 0;
#line 363 "../core/Util/Datetime.vala"
		i = 0;
#line 2039 "Datetime.c"
		{
			gboolean _tmp4_ = FALSE;
#line 363 "../core/Util/Datetime.vala"
			_tmp4_ = TRUE;
#line 363 "../core/Util/Datetime.vala"
			while (TRUE) {
#line 2046 "Datetime.c"
				gchar** _tmp6_;
				gint _tmp6__length1;
				gchar** _tmp7_;
				gint _tmp7__length1;
				const gchar* _tmp8_;
#line 363 "../core/Util/Datetime.vala"
				if (!_tmp4_) {
#line 2054 "Datetime.c"
					gint _tmp5_;
#line 363 "../core/Util/Datetime.vala"
					_tmp5_ = i;
#line 363 "../core/Util/Datetime.vala"
					i = _tmp5_ + 1;
#line 2060 "Datetime.c"
				}
#line 363 "../core/Util/Datetime.vala"
				_tmp4_ = FALSE;
#line 363 "../core/Util/Datetime.vala"
				_tmp6_ = weeks;
#line 363 "../core/Util/Datetime.vala"
				_tmp6__length1 = weeks_length1;
#line 363 "../core/Util/Datetime.vala"
				if (!(i < _tmp6__length1)) {
#line 363 "../core/Util/Datetime.vala"
					break;
#line 2072 "Datetime.c"
				}
#line 364 "../core/Util/Datetime.vala"
				_tmp7_ = weeks;
#line 364 "../core/Util/Datetime.vala"
				_tmp7__length1 = weeks_length1;
#line 364 "../core/Util/Datetime.vala"
				_tmp8_ = _tmp7_[i];
#line 364 "../core/Util/Datetime.vala"
				if (day_of_week < atoi (_tmp8_)) {
#line 365 "../core/Util/Datetime.vala"
					index = i;
#line 366 "../core/Util/Datetime.vala"
					break;
#line 2086 "Datetime.c"
				}
			}
		}
	}
#line 370 "../core/Util/Datetime.vala"
	_tmp9_ = weeks;
#line 370 "../core/Util/Datetime.vala"
	_tmp9__length1 = weeks_length1;
#line 370 "../core/Util/Datetime.vala"
	_tmp10_ = _tmp9_[index];
#line 370 "../core/Util/Datetime.vala"
	next_day = atoi (_tmp10_);
#line 372 "../core/Util/Datetime.vala"
	if (day_of_week < next_day) {
#line 373 "../core/Util/Datetime.vala"
		days = next_day - day_of_week;
#line 2103 "Datetime.c"
	} else {
#line 375 "../core/Util/Datetime.vala"
		days = 7 - (day_of_week - next_day);
#line 2107 "Datetime.c"
	}
#line 378 "../core/Util/Datetime.vala"
	if (user) {
#line 378 "../core/Util/Datetime.vala"
		_tmp11_ = index == 0;
#line 2113 "Datetime.c"
	} else {
#line 378 "../core/Util/Datetime.vala"
		_tmp11_ = FALSE;
#line 2117 "Datetime.c"
	}
#line 378 "../core/Util/Datetime.vala"
	if (_tmp11_) {
#line 2121 "Datetime.c"
		gint _tmp12_;
		gint _tmp13_;
#line 379 "../core/Util/Datetime.vala"
		_tmp12_ = objects_due_date_get_recurrency_interval (duedate);
#line 379 "../core/Util/Datetime.vala"
		_tmp13_ = _tmp12_;
#line 379 "../core/Util/Datetime.vala"
		recurrency_interval = (_tmp13_ - 1) * 7;
#line 2130 "Datetime.c"
	}
#line 382 "../core/Util/Datetime.vala"
	_tmp14_ = g_date_time_add_days (datetime, days);
#line 382 "../core/Util/Datetime.vala"
	_tmp15_ = _tmp14_;
#line 382 "../core/Util/Datetime.vala"
	_tmp16_ = g_date_time_add_days (_tmp15_, recurrency_interval);
#line 382 "../core/Util/Datetime.vala"
	_tmp17_ = _tmp16_;
#line 382 "../core/Util/Datetime.vala"
	_g_date_time_unref0 (_tmp15_);
#line 382 "../core/Util/Datetime.vala"
	result = _tmp17_;
#line 382 "../core/Util/Datetime.vala"
	weeks = (_vala_array_free (weeks, weeks_length1, (GDestroyNotify) g_free), NULL);
#line 382 "../core/Util/Datetime.vala"
	return result;
#line 2148 "Datetime.c"
}

gchar*
utils_datetime_get_recurrency_weeks (RecurrencyType recurrency_type,
                                     gint recurrency_interval,
                                     const gchar* recurrency_weeks,
                                     const gchar* end)
{
	gchar* returned = NULL;
	gchar* _tmp0_;
	gboolean _tmp1_ = FALSE;
	const gchar* _tmp25_;
	gchar* _tmp26_;
	gchar* _tmp27_;
	gchar* _tmp28_;
	gchar* _tmp29_;
	gchar* result;
#line 385 "../core/Util/Datetime.vala"
	g_return_val_if_fail (recurrency_weeks != NULL, NULL);
#line 385 "../core/Util/Datetime.vala"
	g_return_val_if_fail (end != NULL, NULL);
#line 387 "../core/Util/Datetime.vala"
	_tmp0_ = recurrency_type_to_friendly_string (recurrency_type, &recurrency_interval);
#line 387 "../core/Util/Datetime.vala"
	returned = _tmp0_;
#line 389 "../core/Util/Datetime.vala"
	if (recurrency_type == RECURRENCY_TYPE_EVERY_WEEK) {
#line 2176 "Datetime.c"
		gchar** _tmp2_;
		gchar** _tmp3_;
		gchar** _tmp4_;
		gint _tmp4__length1;
#line 390 "../core/Util/Datetime.vala"
		_tmp3_ = _tmp2_ = g_strsplit (recurrency_weeks, ",", 0);
#line 390 "../core/Util/Datetime.vala"
		_tmp4_ = _tmp3_;
#line 390 "../core/Util/Datetime.vala"
		_tmp4__length1 = _vala_array_length (_tmp2_);
#line 390 "../core/Util/Datetime.vala"
		_tmp1_ = _vala_array_length (_tmp2_) > 0;
#line 390 "../core/Util/Datetime.vala"
		_tmp4_ = (_vala_array_free (_tmp4_, _tmp4__length1, (GDestroyNotify) g_free), NULL);
#line 2191 "Datetime.c"
	} else {
#line 389 "../core/Util/Datetime.vala"
		_tmp1_ = FALSE;
#line 2195 "Datetime.c"
	}
#line 389 "../core/Util/Datetime.vala"
	if (_tmp1_) {
#line 2199 "Datetime.c"
		gchar* weeks = NULL;
		gchar* _tmp5_;
		const gchar* _tmp20_;
		gchar* _tmp21_;
		const gchar* _tmp22_;
		const gchar* _tmp23_;
		gchar* _tmp24_;
#line 391 "../core/Util/Datetime.vala"
		_tmp5_ = g_strdup ("");
#line 391 "../core/Util/Datetime.vala"
		weeks = _tmp5_;
#line 392 "../core/Util/Datetime.vala"
		if (string_contains (recurrency_weeks, "1")) {
#line 2213 "Datetime.c"
			const gchar* _tmp6_;
			gchar* _tmp7_;
#line 393 "../core/Util/Datetime.vala"
			_tmp6_ = weeks;
#line 393 "../core/Util/Datetime.vala"
			_tmp7_ = g_strconcat (_tmp6_, _ ("Mo,"), NULL);
#line 393 "../core/Util/Datetime.vala"
			_g_free0 (weeks);
#line 393 "../core/Util/Datetime.vala"
			weeks = _tmp7_;
#line 2224 "Datetime.c"
		}
#line 396 "../core/Util/Datetime.vala"
		if (string_contains (recurrency_weeks, "2")) {
#line 2228 "Datetime.c"
			const gchar* _tmp8_;
			gchar* _tmp9_;
#line 397 "../core/Util/Datetime.vala"
			_tmp8_ = weeks;
#line 397 "../core/Util/Datetime.vala"
			_tmp9_ = g_strconcat (_tmp8_, _ ("Tu,"), NULL);
#line 397 "../core/Util/Datetime.vala"
			_g_free0 (weeks);
#line 397 "../core/Util/Datetime.vala"
			weeks = _tmp9_;
#line 2239 "Datetime.c"
		}
#line 400 "../core/Util/Datetime.vala"
		if (string_contains (recurrency_weeks, "3")) {
#line 2243 "Datetime.c"
			const gchar* _tmp10_;
			gchar* _tmp11_;
#line 401 "../core/Util/Datetime.vala"
			_tmp10_ = weeks;
#line 401 "../core/Util/Datetime.vala"
			_tmp11_ = g_strconcat (_tmp10_, _ ("We,"), NULL);
#line 401 "../core/Util/Datetime.vala"
			_g_free0 (weeks);
#line 401 "../core/Util/Datetime.vala"
			weeks = _tmp11_;
#line 2254 "Datetime.c"
		}
#line 404 "../core/Util/Datetime.vala"
		if (string_contains (recurrency_weeks, "4")) {
#line 2258 "Datetime.c"
			const gchar* _tmp12_;
			gchar* _tmp13_;
#line 405 "../core/Util/Datetime.vala"
			_tmp12_ = weeks;
#line 405 "../core/Util/Datetime.vala"
			_tmp13_ = g_strconcat (_tmp12_, _ ("Th,"), NULL);
#line 405 "../core/Util/Datetime.vala"
			_g_free0 (weeks);
#line 405 "../core/Util/Datetime.vala"
			weeks = _tmp13_;
#line 2269 "Datetime.c"
		}
#line 408 "../core/Util/Datetime.vala"
		if (string_contains (recurrency_weeks, "5")) {
#line 2273 "Datetime.c"
			const gchar* _tmp14_;
			gchar* _tmp15_;
#line 409 "../core/Util/Datetime.vala"
			_tmp14_ = weeks;
#line 409 "../core/Util/Datetime.vala"
			_tmp15_ = g_strconcat (_tmp14_, _ ("Fr,"), NULL);
#line 409 "../core/Util/Datetime.vala"
			_g_free0 (weeks);
#line 409 "../core/Util/Datetime.vala"
			weeks = _tmp15_;
#line 2284 "Datetime.c"
		}
#line 412 "../core/Util/Datetime.vala"
		if (string_contains (recurrency_weeks, "6")) {
#line 2288 "Datetime.c"
			const gchar* _tmp16_;
			gchar* _tmp17_;
#line 413 "../core/Util/Datetime.vala"
			_tmp16_ = weeks;
#line 413 "../core/Util/Datetime.vala"
			_tmp17_ = g_strconcat (_tmp16_, _ ("Sa,"), NULL);
#line 413 "../core/Util/Datetime.vala"
			_g_free0 (weeks);
#line 413 "../core/Util/Datetime.vala"
			weeks = _tmp17_;
#line 2299 "Datetime.c"
		}
#line 416 "../core/Util/Datetime.vala"
		if (string_contains (recurrency_weeks, "7")) {
#line 2303 "Datetime.c"
			const gchar* _tmp18_;
			gchar* _tmp19_;
#line 417 "../core/Util/Datetime.vala"
			_tmp18_ = weeks;
#line 417 "../core/Util/Datetime.vala"
			_tmp19_ = g_strconcat (_tmp18_, _ ("Su,"), NULL);
#line 417 "../core/Util/Datetime.vala"
			_g_free0 (weeks);
#line 417 "../core/Util/Datetime.vala"
			weeks = _tmp19_;
#line 2314 "Datetime.c"
		}
#line 420 "../core/Util/Datetime.vala"
		_tmp20_ = weeks;
#line 420 "../core/Util/Datetime.vala"
		_tmp21_ = string_slice (_tmp20_, (glong) 0, (glong) -1);
#line 420 "../core/Util/Datetime.vala"
		_g_free0 (weeks);
#line 420 "../core/Util/Datetime.vala"
		weeks = _tmp21_;
#line 421 "../core/Util/Datetime.vala"
		_tmp22_ = returned;
#line 421 "../core/Util/Datetime.vala"
		_tmp23_ = weeks;
#line 421 "../core/Util/Datetime.vala"
		_tmp24_ = g_strdup_printf ("%s (%s)", _tmp22_, _tmp23_);
#line 421 "../core/Util/Datetime.vala"
		_g_free0 (returned);
#line 421 "../core/Util/Datetime.vala"
		returned = _tmp24_;
#line 389 "../core/Util/Datetime.vala"
		_g_free0 (weeks);
#line 2336 "Datetime.c"
	}
#line 424 "../core/Util/Datetime.vala"
	_tmp25_ = returned;
#line 424 "../core/Util/Datetime.vala"
	_tmp26_ = g_strconcat (_tmp25_, " ", NULL);
#line 424 "../core/Util/Datetime.vala"
	_tmp27_ = _tmp26_;
#line 424 "../core/Util/Datetime.vala"
	_tmp28_ = g_strconcat (_tmp27_, end, NULL);
#line 424 "../core/Util/Datetime.vala"
	_tmp29_ = _tmp28_;
#line 424 "../core/Util/Datetime.vala"
	_g_free0 (_tmp27_);
#line 424 "../core/Util/Datetime.vala"
	result = _tmp29_;
#line 424 "../core/Util/Datetime.vala"
	_g_free0 (returned);
#line 424 "../core/Util/Datetime.vala"
	return result;
#line 2356 "Datetime.c"
}

GDateTime*
utils_datetime_get_today_format_date (void)
{
	GDateTime* _tmp0_;
	GDateTime* _tmp1_;
	GDateTime* _tmp2_;
	GDateTime* _tmp3_;
	GDateTime* result;
#line 428 "../core/Util/Datetime.vala"
	_tmp0_ = g_date_time_new_now_local ();
#line 428 "../core/Util/Datetime.vala"
	_tmp1_ = _tmp0_;
#line 428 "../core/Util/Datetime.vala"
	_tmp2_ = utils_datetime_get_date_only (_tmp1_);
#line 428 "../core/Util/Datetime.vala"
	_tmp3_ = _tmp2_;
#line 428 "../core/Util/Datetime.vala"
	_g_date_time_unref0 (_tmp1_);
#line 428 "../core/Util/Datetime.vala"
	result = _tmp3_;
#line 428 "../core/Util/Datetime.vala"
	return result;
#line 2381 "Datetime.c"
}

GDateTime*
utils_datetime_get_date_only (GDateTime* date)
{
	GDateTime* _tmp0_;
	GDateTime* result;
#line 431 "../core/Util/Datetime.vala"
	g_return_val_if_fail (date != NULL, NULL);
#line 432 "../core/Util/Datetime.vala"
	_tmp0_ = g_date_time_new_local (g_date_time_get_year (date), g_date_time_get_month (date), g_date_time_get_day_of_month (date), 0, 0, (gdouble) 0);
#line 432 "../core/Util/Datetime.vala"
	result = _tmp0_;
#line 432 "../core/Util/Datetime.vala"
	return result;
#line 2397 "Datetime.c"
}

gchar*
utils_datetime_get_default_date_format_from_date (GDateTime* date)
{
	gchar* format = NULL;
	GDateTime* _tmp1_;
	GDateTime* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* result;
#line 443 "../core/Util/Datetime.vala"
	if (date == NULL) {
#line 2413 "Datetime.c"
		gchar* _tmp0_;
#line 444 "../core/Util/Datetime.vala"
		_tmp0_ = g_strdup ("");
#line 444 "../core/Util/Datetime.vala"
		result = _tmp0_;
#line 444 "../core/Util/Datetime.vala"
		return result;
#line 2421 "Datetime.c"
	}
#line 447 "../core/Util/Datetime.vala"
	_tmp1_ = g_date_time_new_now_local ();
#line 447 "../core/Util/Datetime.vala"
	_tmp2_ = _tmp1_;
#line 447 "../core/Util/Datetime.vala"
	_tmp3_ = granite_date_time_get_default_date_format (FALSE, TRUE, g_date_time_get_year (date) != g_date_time_get_year (_tmp2_));
#line 447 "../core/Util/Datetime.vala"
	_tmp4_ = _tmp3_;
#line 447 "../core/Util/Datetime.vala"
	_tmp5_ = g_date_time_format (date, _tmp4_);
#line 447 "../core/Util/Datetime.vala"
	_tmp6_ = _tmp5_;
#line 447 "../core/Util/Datetime.vala"
	_g_free0 (_tmp4_);
#line 447 "../core/Util/Datetime.vala"
	_g_date_time_unref0 (_tmp2_);
#line 447 "../core/Util/Datetime.vala"
	format = _tmp6_;
#line 452 "../core/Util/Datetime.vala"
	result = format;
#line 452 "../core/Util/Datetime.vala"
	return result;
#line 2445 "Datetime.c"
}

gchar*
utils_datetime_get_todoist_datetime_format (GDateTime* date)
{
	gchar* returned = NULL;
	gchar* _tmp0_;
	gchar* result;
#line 455 "../core/Util/Datetime.vala"
	g_return_val_if_fail (date != NULL, NULL);
#line 456 "../core/Util/Datetime.vala"
	_tmp0_ = g_strdup ("");
#line 456 "../core/Util/Datetime.vala"
	returned = _tmp0_;
#line 458 "../core/Util/Datetime.vala"
	if (utils_datetime_has_time (date)) {
#line 2462 "Datetime.c"
		gchar* _tmp1_;
		gchar* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
#line 459 "../core/Util/Datetime.vala"
		_tmp1_ = g_date_time_format (date, "%F");
#line 459 "../core/Util/Datetime.vala"
		_tmp2_ = _tmp1_;
#line 459 "../core/Util/Datetime.vala"
		_tmp3_ = g_strconcat (_tmp2_, "T", NULL);
#line 459 "../core/Util/Datetime.vala"
		_tmp4_ = _tmp3_;
#line 459 "../core/Util/Datetime.vala"
		_tmp5_ = g_date_time_format (date, "%T");
#line 459 "../core/Util/Datetime.vala"
		_tmp6_ = _tmp5_;
#line 459 "../core/Util/Datetime.vala"
		_tmp7_ = g_strconcat (_tmp4_, _tmp6_, NULL);
#line 459 "../core/Util/Datetime.vala"
		_g_free0 (returned);
#line 459 "../core/Util/Datetime.vala"
		returned = _tmp7_;
#line 459 "../core/Util/Datetime.vala"
		_g_free0 (_tmp6_);
#line 459 "../core/Util/Datetime.vala"
		_g_free0 (_tmp4_);
#line 459 "../core/Util/Datetime.vala"
		_g_free0 (_tmp2_);
#line 2494 "Datetime.c"
	} else {
		gchar* _tmp8_;
#line 461 "../core/Util/Datetime.vala"
		_tmp8_ = g_date_time_format (date, "%F");
#line 461 "../core/Util/Datetime.vala"
		_g_free0 (returned);
#line 461 "../core/Util/Datetime.vala"
		returned = _tmp8_;
#line 2503 "Datetime.c"
	}
#line 464 "../core/Util/Datetime.vala"
	result = returned;
#line 464 "../core/Util/Datetime.vala"
	return result;
#line 2509 "Datetime.c"
}

gboolean
utils_datetime_has_time_from_string (const gchar* date)
{
	GTimeZone* _tmp0_;
	GTimeZone* _tmp1_;
	GDateTime* _tmp2_;
	GDateTime* _tmp3_;
	gboolean _tmp4_;
	gboolean result;
#line 467 "../core/Util/Datetime.vala"
	g_return_val_if_fail (date != NULL, FALSE);
#line 468 "../core/Util/Datetime.vala"
	_tmp0_ = g_time_zone_new_local ();
#line 468 "../core/Util/Datetime.vala"
	_tmp1_ = _tmp0_;
#line 468 "../core/Util/Datetime.vala"
	_tmp2_ = g_date_time_new_from_iso8601 (date, _tmp1_);
#line 468 "../core/Util/Datetime.vala"
	_tmp3_ = _tmp2_;
#line 468 "../core/Util/Datetime.vala"
	_tmp4_ = utils_datetime_has_time (_tmp3_);
#line 468 "../core/Util/Datetime.vala"
	_g_date_time_unref0 (_tmp3_);
#line 468 "../core/Util/Datetime.vala"
	_g_time_zone_unref0 (_tmp1_);
#line 468 "../core/Util/Datetime.vala"
	result = _tmp4_;
#line 468 "../core/Util/Datetime.vala"
	return result;
#line 2541 "Datetime.c"
}

gint
utils_datetime_get_days_of_month (gint index,
                                  gint year_nav)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gboolean _tmp4_ = FALSE;
	gboolean _tmp5_ = FALSE;
	gint result;
#line 472 "../core/Util/Datetime.vala"
	if (index == 1) {
#line 472 "../core/Util/Datetime.vala"
		_tmp5_ = TRUE;
#line 2559 "Datetime.c"
	} else {
#line 472 "../core/Util/Datetime.vala"
		_tmp5_ = index == 3;
#line 2563 "Datetime.c"
	}
#line 472 "../core/Util/Datetime.vala"
	if (_tmp5_) {
#line 472 "../core/Util/Datetime.vala"
		_tmp4_ = TRUE;
#line 2569 "Datetime.c"
	} else {
#line 472 "../core/Util/Datetime.vala"
		_tmp4_ = index == 5;
#line 2573 "Datetime.c"
	}
#line 472 "../core/Util/Datetime.vala"
	if (_tmp4_) {
#line 472 "../core/Util/Datetime.vala"
		_tmp3_ = TRUE;
#line 2579 "Datetime.c"
	} else {
#line 472 "../core/Util/Datetime.vala"
		_tmp3_ = index == 7;
#line 2583 "Datetime.c"
	}
#line 472 "../core/Util/Datetime.vala"
	if (_tmp3_) {
#line 472 "../core/Util/Datetime.vala"
		_tmp2_ = TRUE;
#line 2589 "Datetime.c"
	} else {
#line 472 "../core/Util/Datetime.vala"
		_tmp2_ = index == 8;
#line 2593 "Datetime.c"
	}
#line 472 "../core/Util/Datetime.vala"
	if (_tmp2_) {
#line 472 "../core/Util/Datetime.vala"
		_tmp1_ = TRUE;
#line 2599 "Datetime.c"
	} else {
#line 472 "../core/Util/Datetime.vala"
		_tmp1_ = index == 10;
#line 2603 "Datetime.c"
	}
#line 472 "../core/Util/Datetime.vala"
	if (_tmp1_) {
#line 472 "../core/Util/Datetime.vala"
		_tmp0_ = TRUE;
#line 2609 "Datetime.c"
	} else {
#line 472 "../core/Util/Datetime.vala"
		_tmp0_ = index == 12;
#line 2613 "Datetime.c"
	}
#line 472 "../core/Util/Datetime.vala"
	if (_tmp0_) {
#line 473 "../core/Util/Datetime.vala"
		result = 31;
#line 473 "../core/Util/Datetime.vala"
		return result;
#line 2621 "Datetime.c"
	} else {
#line 475 "../core/Util/Datetime.vala"
		if (index == 2) {
#line 476 "../core/Util/Datetime.vala"
			if ((year_nav % 4) == 0) {
#line 477 "../core/Util/Datetime.vala"
				result = 29;
#line 477 "../core/Util/Datetime.vala"
				return result;
#line 2631 "Datetime.c"
			} else {
#line 479 "../core/Util/Datetime.vala"
				result = 28;
#line 479 "../core/Util/Datetime.vala"
				return result;
#line 2637 "Datetime.c"
			}
		} else {
#line 482 "../core/Util/Datetime.vala"
			result = 30;
#line 482 "../core/Util/Datetime.vala"
			return result;
#line 2644 "Datetime.c"
		}
	}
}

GDateTime*
utils_datetime_get_start_of_month (GDateTime* date)
{
	GDateTime* _tmp1_;
	GDateTime* result;
#line 488 "../core/Util/Datetime.vala"
	if (date == NULL) {
#line 2656 "Datetime.c"
		GDateTime* _tmp0_;
#line 489 "../core/Util/Datetime.vala"
		_tmp0_ = g_date_time_new_now_local ();
#line 489 "../core/Util/Datetime.vala"
		_g_date_time_unref0 (date);
#line 489 "../core/Util/Datetime.vala"
		date = _tmp0_;
#line 2664 "Datetime.c"
	}
#line 492 "../core/Util/Datetime.vala"
	_tmp1_ = g_date_time_new_local (g_date_time_get_year (date), g_date_time_get_month (date), 1, 0, 0, (gdouble) 0);
#line 492 "../core/Util/Datetime.vala"
	result = _tmp1_;
#line 492 "../core/Util/Datetime.vala"
	_g_date_time_unref0 (date);
#line 492 "../core/Util/Datetime.vala"
	return result;
#line 2674 "Datetime.c"
}

gboolean
utils_datetime_is_current_month (GDateTime* date)
{
	GDateTime* now = NULL;
	GDateTime* _tmp0_;
	GDateTime* _tmp1_;
	gboolean result;
#line 495 "../core/Util/Datetime.vala"
	g_return_val_if_fail (date != NULL, FALSE);
#line 496 "../core/Util/Datetime.vala"
	_tmp0_ = g_date_time_new_now_local ();
#line 496 "../core/Util/Datetime.vala"
	now = _tmp0_;
#line 498 "../core/Util/Datetime.vala"
	_tmp1_ = now;
#line 498 "../core/Util/Datetime.vala"
	if (g_date_time_get_year (date) == g_date_time_get_year (_tmp1_)) {
#line 2694 "Datetime.c"
		GDateTime* _tmp2_;
#line 499 "../core/Util/Datetime.vala"
		_tmp2_ = now;
#line 499 "../core/Util/Datetime.vala"
		if (g_date_time_get_month (date) == g_date_time_get_month (_tmp2_)) {
#line 500 "../core/Util/Datetime.vala"
			result = TRUE;
#line 500 "../core/Util/Datetime.vala"
			_g_date_time_unref0 (now);
#line 500 "../core/Util/Datetime.vala"
			return result;
#line 2706 "Datetime.c"
		} else {
#line 502 "../core/Util/Datetime.vala"
			result = FALSE;
#line 502 "../core/Util/Datetime.vala"
			_g_date_time_unref0 (now);
#line 502 "../core/Util/Datetime.vala"
			return result;
#line 2714 "Datetime.c"
		}
	} else {
#line 505 "../core/Util/Datetime.vala"
		result = FALSE;
#line 505 "../core/Util/Datetime.vala"
		_g_date_time_unref0 (now);
#line 505 "../core/Util/Datetime.vala"
		return result;
#line 2723 "Datetime.c"
	}
}

/**
     * Converts the given ICal.Time to a GLib.DateTime, represented in the
     * system timezone.
     *
     * All timezone information in the original @date is lost. However, the
     * {@link GLib.TimeZone} contained in the resulting DateTime is correct,
     * since there is a well-defined local timezone between both libical and
     * GLib.
     */
GDateTime*
utils_datetime_ical_to_date_time_local (ICalTime* date)
{
	ICalTime* converted = NULL;
	ICalTime* _tmp0_;
	gint year = 0;
	gint month = 0;
	gint day = 0;
	gint hour = 0;
	gint minute = 0;
	gint second = 0;
	gint _tmp1_ = 0;
	gint _tmp2_ = 0;
	gint _tmp3_ = 0;
	gint _tmp4_ = 0;
	gint _tmp5_ = 0;
	gint _tmp6_ = 0;
	GDateTime* _tmp7_;
	GDateTime* result;
#line 519 "../core/Util/Datetime.vala"
	g_return_val_if_fail (date != NULL, NULL);
#line 520 "../core/Util/Datetime.vala"
	_vala_assert (!i_cal_time_is_null_time (date), "!date.is_null_time ()");
#line 521 "../core/Util/Datetime.vala"
	_tmp0_ = utils_datetime_ical_convert_to_local (date);
#line 521 "../core/Util/Datetime.vala"
	converted = _tmp0_;
#line 523 "../core/Util/Datetime.vala"
	i_cal_time_get_date (converted, &_tmp1_, &_tmp2_, &_tmp3_);
#line 523 "../core/Util/Datetime.vala"
	year = _tmp1_;
#line 523 "../core/Util/Datetime.vala"
	month = _tmp2_;
#line 523 "../core/Util/Datetime.vala"
	day = _tmp3_;
#line 524 "../core/Util/Datetime.vala"
	i_cal_time_get_time (converted, &_tmp4_, &_tmp5_, &_tmp6_);
#line 524 "../core/Util/Datetime.vala"
	hour = _tmp4_;
#line 524 "../core/Util/Datetime.vala"
	minute = _tmp5_;
#line 524 "../core/Util/Datetime.vala"
	second = _tmp6_;
#line 525 "../core/Util/Datetime.vala"
	_tmp7_ = g_date_time_new_local (year, month, day, hour, minute, (gdouble) second);
#line 525 "../core/Util/Datetime.vala"
	result = _tmp7_;
#line 525 "../core/Util/Datetime.vala"
	_g_object_unref0 (converted);
#line 525 "../core/Util/Datetime.vala"
	return result;
#line 2787 "Datetime.c"
}

/** Converts the given ICal.Time to the local (or system) timezone */
static gpointer
_g_object_ref0 (gpointer self)
{
#line 531 "../core/Util/Datetime.vala"
	return self ? g_object_ref (self) : NULL;
#line 2796 "Datetime.c"
}

ICalTime*
utils_datetime_ical_convert_to_local (ICalTime* time)
{
	ICalTimezone* system_tz = NULL;
	ICalTimezone* _tmp0_;
	ICalTimezone* _tmp1_;
	ICalTime* _tmp2_;
	ICalTime* result;
#line 530 "../core/Util/Datetime.vala"
	g_return_val_if_fail (time != NULL, NULL);
#line 531 "../core/Util/Datetime.vala"
	_tmp0_ = e_cal_util_get_system_timezone ();
#line 531 "../core/Util/Datetime.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 531 "../core/Util/Datetime.vala"
	system_tz = _tmp1_;
#line 532 "../core/Util/Datetime.vala"
	_tmp2_ = i_cal_time_convert_to_zone (time, system_tz);
#line 532 "../core/Util/Datetime.vala"
	result = _tmp2_;
#line 532 "../core/Util/Datetime.vala"
	_g_object_unref0 (system_tz);
#line 532 "../core/Util/Datetime.vala"
	return result;
#line 2823 "Datetime.c"
}

/**
     * Converts two DateTimes representing a date and a time to one TimeType.
     *
     * The first contains the date; its time settings are ignored. The second
     * one contains the time itself; its date settings are ignored. If the time
     * is `null`, the resulting TimeType is of `DATE` type; if it is given, the
     * TimeType is of `DATE-TIME` type.
     *
     * This also accepts an optional `timezone` argument. If it is given a
     * timezone, the resulting TimeType will be relative to the given timezone.
     * If it is `null`, the resulting TimeType will be "floating" with no
     * timezone. If the argument is not given, it will default to the system
     * timezone.
     */
ICalTime*
utils_datetime_datetimes_to_icaltime (GDateTime* date,
                                      GDateTime* time_local,
                                      ICalTimezone* timezone)
{
	ICalTime* _result_ = NULL;
	ICalTime* _tmp0_;
	ICalTime* result;
#line 550 "../core/Util/Datetime.vala"
	g_return_val_if_fail (date != NULL, NULL);
#line 552 "../core/Util/Datetime.vala"
	_tmp0_ = i_cal_time_new_from_day_of_year (g_date_time_get_day_of_year (date), g_date_time_get_year (date));
#line 552 "../core/Util/Datetime.vala"
	_result_ = _tmp0_;
#line 558 "../core/Util/Datetime.vala"
	if (time_local == NULL) {
#line 2856 "Datetime.c"
		ICalTime* _tmp1_;
#line 560 "../core/Util/Datetime.vala"
		_tmp1_ = _result_;
#line 560 "../core/Util/Datetime.vala"
		i_cal_time_set_is_date (_tmp1_, TRUE);
#line 2862 "Datetime.c"
	} else {
		ICalTime* _tmp2_;
		ICalTime* _tmp3_;
		ICalTime* _tmp4_;
#line 565 "../core/Util/Datetime.vala"
		_tmp2_ = _result_;
#line 565 "../core/Util/Datetime.vala"
		i_cal_time_set_is_date (_tmp2_, FALSE);
#line 569 "../core/Util/Datetime.vala"
		_tmp3_ = _result_;
#line 569 "../core/Util/Datetime.vala"
		i_cal_time_set_timezone (_tmp3_, timezone);
#line 572 "../core/Util/Datetime.vala"
		_tmp4_ = _result_;
#line 572 "../core/Util/Datetime.vala"
		i_cal_time_set_time (_tmp4_, g_date_time_get_hour (time_local), g_date_time_get_minute (time_local), g_date_time_get_second (time_local));
#line 2879 "Datetime.c"
	}
#line 575 "../core/Util/Datetime.vala"
	result = _result_;
#line 575 "../core/Util/Datetime.vala"
	return result;
#line 2885 "Datetime.c"
}

gchar*
utils_datetime_get_markdown_format_date (ObjectsItem* item)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
	ObjectsDueDate* _tmp3_;
	ObjectsDueDate* _tmp4_;
	GDateTime* _tmp5_;
	GDateTime* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	gchar* result;
#line 578 "../core/Util/Datetime.vala"
	g_return_val_if_fail (item != NULL, NULL);
#line 579 "../core/Util/Datetime.vala"
	_tmp0_ = objects_item_get_has_due (item);
#line 579 "../core/Util/Datetime.vala"
	_tmp1_ = _tmp0_;
#line 579 "../core/Util/Datetime.vala"
	if (!_tmp1_) {
#line 2912 "Datetime.c"
		gchar* _tmp2_;
#line 580 "../core/Util/Datetime.vala"
		_tmp2_ = g_strdup (" ");
#line 580 "../core/Util/Datetime.vala"
		result = _tmp2_;
#line 580 "../core/Util/Datetime.vala"
		return result;
#line 2920 "Datetime.c"
	}
#line 583 "../core/Util/Datetime.vala"
	_tmp3_ = objects_item_get_due (item);
#line 583 "../core/Util/Datetime.vala"
	_tmp4_ = _tmp3_;
#line 583 "../core/Util/Datetime.vala"
	_tmp5_ = objects_due_date_get_datetime (_tmp4_);
#line 583 "../core/Util/Datetime.vala"
	_tmp6_ = _tmp5_;
#line 583 "../core/Util/Datetime.vala"
	_tmp7_ = utils_datetime_get_relative_date_from_date (_tmp6_);
#line 583 "../core/Util/Datetime.vala"
	_tmp8_ = _tmp7_;
#line 583 "../core/Util/Datetime.vala"
	_tmp9_ = g_strconcat (" (", _tmp8_, NULL);
#line 583 "../core/Util/Datetime.vala"
	_tmp10_ = _tmp9_;
#line 583 "../core/Util/Datetime.vala"
	_tmp11_ = g_strconcat (_tmp10_, ") ", NULL);
#line 583 "../core/Util/Datetime.vala"
	_tmp12_ = _tmp11_;
#line 583 "../core/Util/Datetime.vala"
	_g_free0 (_tmp10_);
#line 583 "../core/Util/Datetime.vala"
	_g_free0 (_tmp8_);
#line 583 "../core/Util/Datetime.vala"
	result = _tmp12_;
#line 583 "../core/Util/Datetime.vala"
	return result;
#line 2950 "Datetime.c"
}

GDateTime*
utils_datetime_get_datetime_no_seconds (GDateTime* date,
                                        GDateTime* time)
{
	gint _tmp0_ = 0;
	gint _tmp1_ = 0;
	GDateTime* _tmp2_;
	GDateTime* result;
#line 586 "../core/Util/Datetime.vala"
	g_return_val_if_fail (date != NULL, NULL);
#line 591 "../core/Util/Datetime.vala"
	if (time == NULL) {
#line 591 "../core/Util/Datetime.vala"
		_tmp0_ = g_date_time_get_hour (date);
#line 2967 "Datetime.c"
	} else {
#line 591 "../core/Util/Datetime.vala"
		_tmp0_ = g_date_time_get_hour (time);
#line 2971 "Datetime.c"
	}
#line 592 "../core/Util/Datetime.vala"
	if (time == NULL) {
#line 592 "../core/Util/Datetime.vala"
		_tmp1_ = g_date_time_get_minute (date);
#line 2977 "Datetime.c"
	} else {
#line 592 "../core/Util/Datetime.vala"
		_tmp1_ = g_date_time_get_minute (time);
#line 2981 "Datetime.c"
	}
#line 587 "../core/Util/Datetime.vala"
	_tmp2_ = g_date_time_new_local (g_date_time_get_year (date), g_date_time_get_month (date), g_date_time_get_day_of_month (date), _tmp0_, _tmp1_, (gdouble) 0);
#line 587 "../core/Util/Datetime.vala"
	result = _tmp2_;
#line 587 "../core/Util/Datetime.vala"
	return result;
#line 2989 "Datetime.c"
}

UtilsDatetime*
utils_datetime_construct (GType object_type)
{
	UtilsDatetime* self = NULL;
#line 22 "../core/Util/Datetime.vala"
	self = (UtilsDatetime*) g_type_create_instance (object_type);
#line 22 "../core/Util/Datetime.vala"
	return self;
#line 3000 "Datetime.c"
}

UtilsDatetime*
utils_datetime_new (void)
{
#line 22 "../core/Util/Datetime.vala"
	return utils_datetime_construct (UTILS_TYPE_DATETIME);
#line 3008 "Datetime.c"
}

static void
utils_value_datetime_init (GValue* value)
{
#line 22 "../core/Util/Datetime.vala"
	value->data[0].v_pointer = NULL;
#line 3016 "Datetime.c"
}

static void
utils_value_datetime_free_value (GValue* value)
{
#line 22 "../core/Util/Datetime.vala"
	if (value->data[0].v_pointer) {
#line 22 "../core/Util/Datetime.vala"
		utils_datetime_unref (value->data[0].v_pointer);
#line 3026 "Datetime.c"
	}
}

static void
utils_value_datetime_copy_value (const GValue* src_value,
                                 GValue* dest_value)
{
#line 22 "../core/Util/Datetime.vala"
	if (src_value->data[0].v_pointer) {
#line 22 "../core/Util/Datetime.vala"
		dest_value->data[0].v_pointer = utils_datetime_ref (src_value->data[0].v_pointer);
#line 3038 "Datetime.c"
	} else {
#line 22 "../core/Util/Datetime.vala"
		dest_value->data[0].v_pointer = NULL;
#line 3042 "Datetime.c"
	}
}

static gpointer
utils_value_datetime_peek_pointer (const GValue* value)
{
#line 22 "../core/Util/Datetime.vala"
	return value->data[0].v_pointer;
#line 3051 "Datetime.c"
}

static gchar*
utils_value_datetime_collect_value (GValue* value,
                                    guint n_collect_values,
                                    GTypeCValue* collect_values,
                                    guint collect_flags)
{
#line 22 "../core/Util/Datetime.vala"
	if (collect_values[0].v_pointer) {
#line 3062 "Datetime.c"
		UtilsDatetime * object;
		object = collect_values[0].v_pointer;
#line 22 "../core/Util/Datetime.vala"
		if (object->parent_instance.g_class == NULL) {
#line 22 "../core/Util/Datetime.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 3069 "Datetime.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 22 "../core/Util/Datetime.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 3073 "Datetime.c"
		}
#line 22 "../core/Util/Datetime.vala"
		value->data[0].v_pointer = utils_datetime_ref (object);
#line 3077 "Datetime.c"
	} else {
#line 22 "../core/Util/Datetime.vala"
		value->data[0].v_pointer = NULL;
#line 3081 "Datetime.c"
	}
#line 22 "../core/Util/Datetime.vala"
	return NULL;
#line 3085 "Datetime.c"
}

static gchar*
utils_value_datetime_lcopy_value (const GValue* value,
                                  guint n_collect_values,
                                  GTypeCValue* collect_values,
                                  guint collect_flags)
{
	UtilsDatetime ** object_p;
	object_p = collect_values[0].v_pointer;
#line 22 "../core/Util/Datetime.vala"
	if (!object_p) {
#line 22 "../core/Util/Datetime.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 3100 "Datetime.c"
	}
#line 22 "../core/Util/Datetime.vala"
	if (!value->data[0].v_pointer) {
#line 22 "../core/Util/Datetime.vala"
		*object_p = NULL;
#line 3106 "Datetime.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 22 "../core/Util/Datetime.vala"
		*object_p = value->data[0].v_pointer;
#line 3110 "Datetime.c"
	} else {
#line 22 "../core/Util/Datetime.vala"
		*object_p = utils_datetime_ref (value->data[0].v_pointer);
#line 3114 "Datetime.c"
	}
#line 22 "../core/Util/Datetime.vala"
	return NULL;
#line 3118 "Datetime.c"
}

GParamSpec*
utils_param_spec_datetime (const gchar* name,
                           const gchar* nick,
                           const gchar* blurb,
                           GType object_type,
                           GParamFlags flags)
{
	UtilsParamSpecDatetime* spec;
#line 22 "../core/Util/Datetime.vala"
	g_return_val_if_fail (g_type_is_a (object_type, UTILS_TYPE_DATETIME), NULL);
#line 22 "../core/Util/Datetime.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 22 "../core/Util/Datetime.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 22 "../core/Util/Datetime.vala"
	return G_PARAM_SPEC (spec);
#line 3137 "Datetime.c"
}

gpointer
utils_value_get_datetime (const GValue* value)
{
#line 22 "../core/Util/Datetime.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, UTILS_TYPE_DATETIME), NULL);
#line 22 "../core/Util/Datetime.vala"
	return value->data[0].v_pointer;
#line 3147 "Datetime.c"
}

void
utils_value_set_datetime (GValue* value,
                          gpointer v_object)
{
	UtilsDatetime * old;
#line 22 "../core/Util/Datetime.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, UTILS_TYPE_DATETIME));
#line 22 "../core/Util/Datetime.vala"
	old = value->data[0].v_pointer;
#line 22 "../core/Util/Datetime.vala"
	if (v_object) {
#line 22 "../core/Util/Datetime.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, UTILS_TYPE_DATETIME));
#line 22 "../core/Util/Datetime.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 22 "../core/Util/Datetime.vala"
		value->data[0].v_pointer = v_object;
#line 22 "../core/Util/Datetime.vala"
		utils_datetime_ref (value->data[0].v_pointer);
#line 3169 "Datetime.c"
	} else {
#line 22 "../core/Util/Datetime.vala"
		value->data[0].v_pointer = NULL;
#line 3173 "Datetime.c"
	}
#line 22 "../core/Util/Datetime.vala"
	if (old) {
#line 22 "../core/Util/Datetime.vala"
		utils_datetime_unref (old);
#line 3179 "Datetime.c"
	}
}

void
utils_value_take_datetime (GValue* value,
                           gpointer v_object)
{
	UtilsDatetime * old;
#line 22 "../core/Util/Datetime.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, UTILS_TYPE_DATETIME));
#line 22 "../core/Util/Datetime.vala"
	old = value->data[0].v_pointer;
#line 22 "../core/Util/Datetime.vala"
	if (v_object) {
#line 22 "../core/Util/Datetime.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, UTILS_TYPE_DATETIME));
#line 22 "../core/Util/Datetime.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 22 "../core/Util/Datetime.vala"
		value->data[0].v_pointer = v_object;
#line 3200 "Datetime.c"
	} else {
#line 22 "../core/Util/Datetime.vala"
		value->data[0].v_pointer = NULL;
#line 3204 "Datetime.c"
	}
#line 22 "../core/Util/Datetime.vala"
	if (old) {
#line 22 "../core/Util/Datetime.vala"
		utils_datetime_unref (old);
#line 3210 "Datetime.c"
	}
}

static void
utils_datetime_class_init (UtilsDatetimeClass * klass,
                           gpointer klass_data)
{
#line 22 "../core/Util/Datetime.vala"
	utils_datetime_parent_class = g_type_class_peek_parent (klass);
#line 22 "../core/Util/Datetime.vala"
	((UtilsDatetimeClass *) klass)->finalize = utils_datetime_finalize;
#line 3222 "Datetime.c"
}

static void
utils_datetime_instance_init (UtilsDatetime * self,
                              gpointer klass)
{
#line 22 "../core/Util/Datetime.vala"
	self->ref_count = 1;
#line 3231 "Datetime.c"
}

static void
utils_datetime_finalize (UtilsDatetime * obj)
{
	UtilsDatetime * self;
#line 22 "../core/Util/Datetime.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, UTILS_TYPE_DATETIME, UtilsDatetime);
#line 22 "../core/Util/Datetime.vala"
	g_signal_handlers_destroy (self);
#line 3242 "Datetime.c"
}

static GType
utils_datetime_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { utils_value_datetime_init, utils_value_datetime_free_value, utils_value_datetime_copy_value, utils_value_datetime_peek_pointer, "p", utils_value_datetime_collect_value, "p", utils_value_datetime_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (UtilsDatetimeClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) utils_datetime_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (UtilsDatetime), 0, (GInstanceInitFunc) utils_datetime_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType utils_datetime_type_id;
	utils_datetime_type_id = g_type_register_fundamental (g_type_fundamental_next (), "UtilsDatetime", &g_define_type_info, &g_define_type_fundamental_info, 0);
	return utils_datetime_type_id;
}

GType
utils_datetime_get_type (void)
{
	static volatile gsize utils_datetime_type_id__once = 0;
	if (g_once_init_enter (&utils_datetime_type_id__once)) {
		GType utils_datetime_type_id;
		utils_datetime_type_id = utils_datetime_get_type_once ();
		g_once_init_leave (&utils_datetime_type_id__once, utils_datetime_type_id);
	}
	return utils_datetime_type_id__once;
}

gpointer
utils_datetime_ref (gpointer instance)
{
	UtilsDatetime * self;
	self = instance;
#line 22 "../core/Util/Datetime.vala"
	g_atomic_int_inc (&self->ref_count);
#line 22 "../core/Util/Datetime.vala"
	return instance;
#line 3277 "Datetime.c"
}

void
utils_datetime_unref (gpointer instance)
{
	UtilsDatetime * self;
	self = instance;
#line 22 "../core/Util/Datetime.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 22 "../core/Util/Datetime.vala"
		UTILS_DATETIME_GET_CLASS (self)->finalize (self);
#line 22 "../core/Util/Datetime.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 3291 "Datetime.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

