/* CalendarView.c generated by valac 0.56.18, the Vala compiler
 * generated from CalendarView.vala, do not modify */

/*
* Copyright © 2023 Alain M. (https://github.com/alainm23/planify)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 3 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*
* Authored by: Alain M. <alainmh23@gmail.com>
*/

#include "planify.h"
#include <gee.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <glib.h>
#include <adwaita.h>
#include <stdlib.h>
#include <string.h>
#include <float.h>
#include <math.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	WIDGETS_CALENDAR_CALENDAR_VIEW_0_PROPERTY,
	WIDGETS_CALENDAR_CALENDAR_VIEW_CURRENT_DATE_PROPERTY,
	WIDGETS_CALENDAR_CALENDAR_VIEW_NUM_PROPERTIES
};
static GParamSpec* widgets_calendar_calendar_view_properties[WIDGETS_CALENDAR_CALENDAR_VIEW_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _Block12Data Block12Data;
enum  {
	WIDGETS_CALENDAR_CALENDAR_VIEW_DAY_SELECTED_SIGNAL,
	WIDGETS_CALENDAR_CALENDAR_VIEW_NUM_SIGNALS
};
static guint widgets_calendar_calendar_view_signals[WIDGETS_CALENDAR_CALENDAR_VIEW_NUM_SIGNALS] = {0};

struct _WidgetsCalendarCalendarViewPrivate {
	GeeArrayList* days_arraylist;
	GtkGrid* days_grid;
	GDateTime* _current_date;
};

struct _Block12Data {
	int _ref_count_;
	WidgetsCalendarCalendarView* self;
	WidgetsCalendarCalendarDay* calendar_day;
};

static gint WidgetsCalendarCalendarView_private_offset;
static gpointer widgets_calendar_calendar_view_parent_class = NULL;

static GDateTime* widgets_calendar_calendar_view_generate_date (WidgetsCalendarCalendarView* self,
                                                         GDateTime* date,
                                                         gint day);
static void widgets_calendar_calendar_view_day_selected_style (WidgetsCalendarCalendarView* self,
                                                        gint day);
static GObject * widgets_calendar_calendar_view_constructor (GType type,
                                                      guint n_construct_properties,
                                                      GObjectConstructParam * construct_properties);
static Block12Data* block12_data_ref (Block12Data* _data12_);
static void block12_data_unref (void * _userdata_);
static void _widgets_calendar_calendar_view______lambda132_ (Block12Data* _data12_);
static void __widgets_calendar_calendar_view______lambda132__widgets_calendar_calendar_day_day_selected (WidgetsCalendarCalendarDay* _sender,
                                                                                                  gpointer self);
static void widgets_calendar_calendar_view_finalize (GObject * obj);
static GType widgets_calendar_calendar_view_get_type_once (void);
static void _vala_widgets_calendar_calendar_view_get_property (GObject * object,
                                                        guint property_id,
                                                        GValue * value,
                                                        GParamSpec * pspec);

static inline gpointer
widgets_calendar_calendar_view_get_instance_private (WidgetsCalendarCalendarView* self)
{
	return G_STRUCT_MEMBER_P (self, WidgetsCalendarCalendarView_private_offset);
}

WidgetsCalendarCalendarView*
widgets_calendar_calendar_view_construct (GType object_type)
{
	WidgetsCalendarCalendarView * self = NULL;
#line 47 "../core/Widgets/Calendar/CalendarView.vala"
	self = (WidgetsCalendarCalendarView*) g_object_new (object_type, "margin-start", 6, "margin-end", 6, NULL);
#line 46 "../core/Widgets/Calendar/CalendarView.vala"
	return self;
#line 111 "CalendarView.c"
}

WidgetsCalendarCalendarView*
widgets_calendar_calendar_view_new (void)
{
#line 46 "../core/Widgets/Calendar/CalendarView.vala"
	return widgets_calendar_calendar_view_construct (WIDGETS_CALENDAR_TYPE_CALENDAR_VIEW);
#line 119 "CalendarView.c"
}

void
widgets_calendar_calendar_view_fill_grid_days (WidgetsCalendarCalendarView* self,
                                               gint start_day,
                                               gint max_day,
                                               GDateTime* day,
                                               gboolean show_day,
                                               gboolean block_past_days)
{
	gint day_number = 0;
#line 86 "../core/Widgets/Calendar/CalendarView.vala"
	g_return_if_fail (self != NULL);
#line 86 "../core/Widgets/Calendar/CalendarView.vala"
	g_return_if_fail (day != NULL);
#line 88 "../core/Widgets/Calendar/CalendarView.vala"
	day_number = 1;
#line 137 "CalendarView.c"
	{
		gint i = 0;
#line 90 "../core/Widgets/Calendar/CalendarView.vala"
		i = 0;
#line 142 "CalendarView.c"
		{
			gboolean _tmp0_ = FALSE;
#line 90 "../core/Widgets/Calendar/CalendarView.vala"
			_tmp0_ = TRUE;
#line 90 "../core/Widgets/Calendar/CalendarView.vala"
			while (TRUE) {
#line 149 "CalendarView.c"
				WidgetsCalendarCalendarDay* item = NULL;
				GeeArrayList* _tmp2_;
				gpointer _tmp3_;
				WidgetsCalendarCalendarDay* _tmp4_;
				WidgetsCalendarCalendarDay* _tmp5_;
				WidgetsCalendarCalendarDay* _tmp6_;
				GtkWidget* _tmp7_;
				GtkWidget* _tmp8_;
				WidgetsCalendarCalendarDay* _tmp9_;
				GtkWidget* _tmp10_;
				GtkWidget* _tmp11_;
				gboolean _tmp12_ = FALSE;
#line 90 "../core/Widgets/Calendar/CalendarView.vala"
				if (!_tmp0_) {
#line 164 "CalendarView.c"
					gint _tmp1_;
#line 90 "../core/Widgets/Calendar/CalendarView.vala"
					_tmp1_ = i;
#line 90 "../core/Widgets/Calendar/CalendarView.vala"
					i = _tmp1_ + 1;
#line 170 "CalendarView.c"
				}
#line 90 "../core/Widgets/Calendar/CalendarView.vala"
				_tmp0_ = FALSE;
#line 90 "../core/Widgets/Calendar/CalendarView.vala"
				if (!(i < 42)) {
#line 90 "../core/Widgets/Calendar/CalendarView.vala"
					break;
#line 178 "CalendarView.c"
				}
#line 91 "../core/Widgets/Calendar/CalendarView.vala"
				_tmp2_ = self->priv->days_arraylist;
#line 91 "../core/Widgets/Calendar/CalendarView.vala"
				_tmp3_ = gee_abstract_list_get ((GeeAbstractList*) _tmp2_, i);
#line 91 "../core/Widgets/Calendar/CalendarView.vala"
				item = (WidgetsCalendarCalendarDay*) _tmp3_;
#line 92 "../core/Widgets/Calendar/CalendarView.vala"
				_tmp4_ = item;
#line 92 "../core/Widgets/Calendar/CalendarView.vala"
				gtk_widget_set_sensitive ((GtkWidget*) _tmp4_, TRUE);
#line 93 "../core/Widgets/Calendar/CalendarView.vala"
				_tmp5_ = item;
#line 93 "../core/Widgets/Calendar/CalendarView.vala"
				gtk_widget_set_visible ((GtkWidget*) _tmp5_, TRUE);
#line 95 "../core/Widgets/Calendar/CalendarView.vala"
				_tmp6_ = item;
#line 95 "../core/Widgets/Calendar/CalendarView.vala"
				_tmp7_ = adw_bin_get_child ((AdwBin*) _tmp6_);
#line 95 "../core/Widgets/Calendar/CalendarView.vala"
				_tmp8_ = _tmp7_;
#line 95 "../core/Widgets/Calendar/CalendarView.vala"
				gtk_widget_remove_css_class (_tmp8_, "today");
#line 96 "../core/Widgets/Calendar/CalendarView.vala"
				_tmp9_ = item;
#line 96 "../core/Widgets/Calendar/CalendarView.vala"
				_tmp10_ = adw_bin_get_child ((AdwBin*) _tmp9_);
#line 96 "../core/Widgets/Calendar/CalendarView.vala"
				_tmp11_ = _tmp10_;
#line 96 "../core/Widgets/Calendar/CalendarView.vala"
				gtk_widget_remove_css_class (_tmp11_, "selected");
#line 98 "../core/Widgets/Calendar/CalendarView.vala"
				if (i < start_day) {
#line 98 "../core/Widgets/Calendar/CalendarView.vala"
					_tmp12_ = TRUE;
#line 214 "CalendarView.c"
				} else {
#line 98 "../core/Widgets/Calendar/CalendarView.vala"
					_tmp12_ = i >= (max_day + start_day);
#line 218 "CalendarView.c"
				}
#line 98 "../core/Widgets/Calendar/CalendarView.vala"
				if (_tmp12_) {
#line 222 "CalendarView.c"
					WidgetsCalendarCalendarDay* _tmp13_;
#line 99 "../core/Widgets/Calendar/CalendarView.vala"
					_tmp13_ = item;
#line 99 "../core/Widgets/Calendar/CalendarView.vala"
					gtk_widget_set_visible ((GtkWidget*) _tmp13_, FALSE);
#line 228 "CalendarView.c"
				} else {
					GDateTime* day_datetime = NULL;
					GDateTime* _tmp14_;
					gboolean _tmp15_ = FALSE;
					GDateTime* _tmp20_;
					GDateTime* _tmp21_;
					GDateTime* _tmp22_;
					gboolean _tmp26_ = FALSE;
					WidgetsCalendarCalendarDay* _tmp33_;
					WidgetsCalendarCalendarDay* _tmp34_;
					GDateTime* _tmp35_;
					gchar* _tmp36_;
					gchar* _tmp37_;
#line 101 "../core/Widgets/Calendar/CalendarView.vala"
					_tmp14_ = widgets_calendar_calendar_view_generate_date (self, day, day_number);
#line 101 "../core/Widgets/Calendar/CalendarView.vala"
					day_datetime = _tmp14_;
#line 103 "../core/Widgets/Calendar/CalendarView.vala"
					if (block_past_days) {
#line 248 "CalendarView.c"
						GDateTime* _tmp16_;
						GDateTime* _tmp17_;
						GDateTime* _tmp18_;
#line 103 "../core/Widgets/Calendar/CalendarView.vala"
						_tmp16_ = day_datetime;
#line 103 "../core/Widgets/Calendar/CalendarView.vala"
						_tmp17_ = widgets_calendar_calendar_view_get_current_date (self);
#line 103 "../core/Widgets/Calendar/CalendarView.vala"
						_tmp18_ = _tmp17_;
#line 103 "../core/Widgets/Calendar/CalendarView.vala"
						_tmp15_ = g_date_time_compare (_tmp16_, _tmp18_) <= -1;
#line 260 "CalendarView.c"
					} else {
#line 103 "../core/Widgets/Calendar/CalendarView.vala"
						_tmp15_ = FALSE;
#line 264 "CalendarView.c"
					}
#line 103 "../core/Widgets/Calendar/CalendarView.vala"
					if (_tmp15_) {
#line 268 "CalendarView.c"
						WidgetsCalendarCalendarDay* _tmp19_;
#line 104 "../core/Widgets/Calendar/CalendarView.vala"
						_tmp19_ = item;
#line 104 "../core/Widgets/Calendar/CalendarView.vala"
						gtk_widget_set_sensitive ((GtkWidget*) _tmp19_, FALSE);
#line 274 "CalendarView.c"
					}
#line 107 "../core/Widgets/Calendar/CalendarView.vala"
					_tmp20_ = day_datetime;
#line 107 "../core/Widgets/Calendar/CalendarView.vala"
					_tmp21_ = widgets_calendar_calendar_view_get_current_date (self);
#line 107 "../core/Widgets/Calendar/CalendarView.vala"
					_tmp22_ = _tmp21_;
#line 107 "../core/Widgets/Calendar/CalendarView.vala"
					if (g_date_time_compare (_tmp20_, _tmp22_) == 0) {
#line 284 "CalendarView.c"
						WidgetsCalendarCalendarDay* _tmp23_;
						GtkWidget* _tmp24_;
						GtkWidget* _tmp25_;
#line 108 "../core/Widgets/Calendar/CalendarView.vala"
						_tmp23_ = item;
#line 108 "../core/Widgets/Calendar/CalendarView.vala"
						_tmp24_ = adw_bin_get_child ((AdwBin*) _tmp23_);
#line 108 "../core/Widgets/Calendar/CalendarView.vala"
						_tmp25_ = _tmp24_;
#line 108 "../core/Widgets/Calendar/CalendarView.vala"
						gtk_widget_add_css_class (_tmp25_, "today");
#line 296 "CalendarView.c"
					}
#line 111 "../core/Widgets/Calendar/CalendarView.vala"
					if (show_day) {
#line 300 "CalendarView.c"
						GDateTime* _tmp27_;
						GDateTime* _tmp28_;
						GDateTime* _tmp29_;
#line 111 "../core/Widgets/Calendar/CalendarView.vala"
						_tmp27_ = utils_datetime_get_date_only (day);
#line 111 "../core/Widgets/Calendar/CalendarView.vala"
						_tmp28_ = _tmp27_;
#line 111 "../core/Widgets/Calendar/CalendarView.vala"
						_tmp29_ = day_datetime;
#line 111 "../core/Widgets/Calendar/CalendarView.vala"
						_tmp26_ = g_date_time_compare (_tmp28_, _tmp29_) == 0;
#line 111 "../core/Widgets/Calendar/CalendarView.vala"
						_g_date_time_unref0 (_tmp28_);
#line 314 "CalendarView.c"
					} else {
#line 111 "../core/Widgets/Calendar/CalendarView.vala"
						_tmp26_ = FALSE;
#line 318 "CalendarView.c"
					}
#line 111 "../core/Widgets/Calendar/CalendarView.vala"
					if (_tmp26_) {
#line 322 "CalendarView.c"
						WidgetsCalendarCalendarDay* _tmp30_;
						GtkWidget* _tmp31_;
						GtkWidget* _tmp32_;
#line 112 "../core/Widgets/Calendar/CalendarView.vala"
						_tmp30_ = item;
#line 112 "../core/Widgets/Calendar/CalendarView.vala"
						_tmp31_ = adw_bin_get_child ((AdwBin*) _tmp30_);
#line 112 "../core/Widgets/Calendar/CalendarView.vala"
						_tmp32_ = _tmp31_;
#line 112 "../core/Widgets/Calendar/CalendarView.vala"
						gtk_widget_add_css_class (_tmp32_, "selected");
#line 334 "CalendarView.c"
					}
#line 115 "../core/Widgets/Calendar/CalendarView.vala"
					_tmp33_ = item;
#line 115 "../core/Widgets/Calendar/CalendarView.vala"
					widgets_calendar_calendar_day_set_day (_tmp33_, day_number);
#line 116 "../core/Widgets/Calendar/CalendarView.vala"
					_tmp34_ = item;
#line 116 "../core/Widgets/Calendar/CalendarView.vala"
					_tmp35_ = day_datetime;
#line 116 "../core/Widgets/Calendar/CalendarView.vala"
					_tmp36_ = utils_datetime_get_relative_date_from_date (_tmp35_);
#line 116 "../core/Widgets/Calendar/CalendarView.vala"
					_tmp37_ = _tmp36_;
#line 116 "../core/Widgets/Calendar/CalendarView.vala"
					gtk_widget_set_tooltip_text ((GtkWidget*) _tmp34_, _tmp37_);
#line 116 "../core/Widgets/Calendar/CalendarView.vala"
					_g_free0 (_tmp37_);
#line 117 "../core/Widgets/Calendar/CalendarView.vala"
					day_number = day_number + 1;
#line 98 "../core/Widgets/Calendar/CalendarView.vala"
					_g_date_time_unref0 (day_datetime);
#line 356 "CalendarView.c"
				}
#line 90 "../core/Widgets/Calendar/CalendarView.vala"
				_g_object_unref0 (item);
#line 360 "CalendarView.c"
			}
		}
	}
}

void
widgets_calendar_calendar_view_clear_style (WidgetsCalendarCalendarView* self)
{
#line 122 "../core/Widgets/Calendar/CalendarView.vala"
	g_return_if_fail (self != NULL);
#line 371 "CalendarView.c"
	{
		gint i = 0;
#line 123 "../core/Widgets/Calendar/CalendarView.vala"
		i = 0;
#line 376 "CalendarView.c"
		{
			gboolean _tmp0_ = FALSE;
#line 123 "../core/Widgets/Calendar/CalendarView.vala"
			_tmp0_ = TRUE;
#line 123 "../core/Widgets/Calendar/CalendarView.vala"
			while (TRUE) {
#line 383 "CalendarView.c"
				WidgetsCalendarCalendarDay* item = NULL;
				GeeArrayList* _tmp2_;
				gpointer _tmp3_;
				WidgetsCalendarCalendarDay* _tmp4_;
				GtkWidget* _tmp5_;
				GtkWidget* _tmp6_;
#line 123 "../core/Widgets/Calendar/CalendarView.vala"
				if (!_tmp0_) {
#line 392 "CalendarView.c"
					gint _tmp1_;
#line 123 "../core/Widgets/Calendar/CalendarView.vala"
					_tmp1_ = i;
#line 123 "../core/Widgets/Calendar/CalendarView.vala"
					i = _tmp1_ + 1;
#line 398 "CalendarView.c"
				}
#line 123 "../core/Widgets/Calendar/CalendarView.vala"
				_tmp0_ = FALSE;
#line 123 "../core/Widgets/Calendar/CalendarView.vala"
				if (!(i < 42)) {
#line 123 "../core/Widgets/Calendar/CalendarView.vala"
					break;
#line 406 "CalendarView.c"
				}
#line 124 "../core/Widgets/Calendar/CalendarView.vala"
				_tmp2_ = self->priv->days_arraylist;
#line 124 "../core/Widgets/Calendar/CalendarView.vala"
				_tmp3_ = gee_abstract_list_get ((GeeAbstractList*) _tmp2_, i);
#line 124 "../core/Widgets/Calendar/CalendarView.vala"
				item = (WidgetsCalendarCalendarDay*) _tmp3_;
#line 125 "../core/Widgets/Calendar/CalendarView.vala"
				_tmp4_ = item;
#line 125 "../core/Widgets/Calendar/CalendarView.vala"
				_tmp5_ = adw_bin_get_child ((AdwBin*) _tmp4_);
#line 125 "../core/Widgets/Calendar/CalendarView.vala"
				_tmp6_ = _tmp5_;
#line 125 "../core/Widgets/Calendar/CalendarView.vala"
				gtk_widget_remove_css_class (_tmp6_, "selected");
#line 123 "../core/Widgets/Calendar/CalendarView.vala"
				_g_object_unref0 (item);
#line 424 "CalendarView.c"
			}
		}
	}
}

static GDateTime*
widgets_calendar_calendar_view_generate_date (WidgetsCalendarCalendarView* self,
                                              GDateTime* date,
                                              gint day)
{
	GDateTime* _tmp0_;
	GDateTime* result;
#line 129 "../core/Widgets/Calendar/CalendarView.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 129 "../core/Widgets/Calendar/CalendarView.vala"
	g_return_val_if_fail (date != NULL, NULL);
#line 130 "../core/Widgets/Calendar/CalendarView.vala"
	_tmp0_ = g_date_time_new_local (g_date_time_get_year (date), g_date_time_get_month (date), day, 0, 0, (gdouble) 0);
#line 130 "../core/Widgets/Calendar/CalendarView.vala"
	result = _tmp0_;
#line 130 "../core/Widgets/Calendar/CalendarView.vala"
	return result;
#line 447 "CalendarView.c"
}

static void
widgets_calendar_calendar_view_day_selected_style (WidgetsCalendarCalendarView* self,
                                                   gint day)
{
#line 140 "../core/Widgets/Calendar/CalendarView.vala"
	g_return_if_fail (self != NULL);
#line 141 "../core/Widgets/Calendar/CalendarView.vala"
	g_signal_emit (self, widgets_calendar_calendar_view_signals[WIDGETS_CALENDAR_CALENDAR_VIEW_DAY_SELECTED_SIGNAL], 0, day);
#line 458 "CalendarView.c"
	{
		gint i = 0;
#line 143 "../core/Widgets/Calendar/CalendarView.vala"
		i = 0;
#line 463 "CalendarView.c"
		{
			gboolean _tmp0_ = FALSE;
#line 143 "../core/Widgets/Calendar/CalendarView.vala"
			_tmp0_ = TRUE;
#line 143 "../core/Widgets/Calendar/CalendarView.vala"
			while (TRUE) {
#line 470 "CalendarView.c"
				WidgetsCalendarCalendarDay* day_item = NULL;
				GeeArrayList* _tmp2_;
				gpointer _tmp3_;
				WidgetsCalendarCalendarDay* _tmp4_;
				GtkWidget* _tmp5_;
				GtkWidget* _tmp6_;
#line 143 "../core/Widgets/Calendar/CalendarView.vala"
				if (!_tmp0_) {
#line 479 "CalendarView.c"
					gint _tmp1_;
#line 143 "../core/Widgets/Calendar/CalendarView.vala"
					_tmp1_ = i;
#line 143 "../core/Widgets/Calendar/CalendarView.vala"
					i = _tmp1_ + 1;
#line 485 "CalendarView.c"
				}
#line 143 "../core/Widgets/Calendar/CalendarView.vala"
				_tmp0_ = FALSE;
#line 143 "../core/Widgets/Calendar/CalendarView.vala"
				if (!(i < 42)) {
#line 143 "../core/Widgets/Calendar/CalendarView.vala"
					break;
#line 493 "CalendarView.c"
				}
#line 144 "../core/Widgets/Calendar/CalendarView.vala"
				_tmp2_ = self->priv->days_arraylist;
#line 144 "../core/Widgets/Calendar/CalendarView.vala"
				_tmp3_ = gee_abstract_list_get ((GeeAbstractList*) _tmp2_, i);
#line 144 "../core/Widgets/Calendar/CalendarView.vala"
				day_item = (WidgetsCalendarCalendarDay*) _tmp3_;
#line 145 "../core/Widgets/Calendar/CalendarView.vala"
				_tmp4_ = day_item;
#line 145 "../core/Widgets/Calendar/CalendarView.vala"
				_tmp5_ = adw_bin_get_child ((AdwBin*) _tmp4_);
#line 145 "../core/Widgets/Calendar/CalendarView.vala"
				_tmp6_ = _tmp5_;
#line 145 "../core/Widgets/Calendar/CalendarView.vala"
				gtk_widget_remove_css_class (_tmp6_, "selected");
#line 143 "../core/Widgets/Calendar/CalendarView.vala"
				_g_object_unref0 (day_item);
#line 511 "CalendarView.c"
			}
		}
	}
}

GDateTime*
widgets_calendar_calendar_view_get_current_date (WidgetsCalendarCalendarView* self)
{
	GDateTime* result;
	GDateTime* today = NULL;
	GDateTime* _tmp0_;
	GDateTime* _tmp1_;
	GDateTime* _tmp2_;
#line 28 "../core/Widgets/Calendar/CalendarView.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 29 "../core/Widgets/Calendar/CalendarView.vala"
	_tmp0_ = g_date_time_new_now_local ();
#line 29 "../core/Widgets/Calendar/CalendarView.vala"
	today = _tmp0_;
#line 31 "../core/Widgets/Calendar/CalendarView.vala"
	_tmp1_ = g_date_time_new_local (g_date_time_get_year (today), g_date_time_get_month (today), g_date_time_get_day_of_month (today), 0, 0, (gdouble) 0);
#line 31 "../core/Widgets/Calendar/CalendarView.vala"
	_g_date_time_unref0 (self->priv->_current_date);
#line 31 "../core/Widgets/Calendar/CalendarView.vala"
	self->priv->_current_date = _tmp1_;
#line 40 "../core/Widgets/Calendar/CalendarView.vala"
	_tmp2_ = self->priv->_current_date;
#line 40 "../core/Widgets/Calendar/CalendarView.vala"
	result = _tmp2_;
#line 40 "../core/Widgets/Calendar/CalendarView.vala"
	_g_date_time_unref0 (today);
#line 40 "../core/Widgets/Calendar/CalendarView.vala"
	return result;
#line 545 "CalendarView.c"
}

static Block12Data*
block12_data_ref (Block12Data* _data12_)
{
#line 64 "../core/Widgets/Calendar/CalendarView.vala"
	g_atomic_int_inc (&_data12_->_ref_count_);
#line 64 "../core/Widgets/Calendar/CalendarView.vala"
	return _data12_;
#line 555 "CalendarView.c"
}

static void
block12_data_unref (void * _userdata_)
{
	Block12Data* _data12_;
	_data12_ = (Block12Data*) _userdata_;
#line 64 "../core/Widgets/Calendar/CalendarView.vala"
	if (g_atomic_int_dec_and_test (&_data12_->_ref_count_)) {
#line 565 "CalendarView.c"
		WidgetsCalendarCalendarView* self;
#line 64 "../core/Widgets/Calendar/CalendarView.vala"
		self = _data12_->self;
#line 64 "../core/Widgets/Calendar/CalendarView.vala"
		_g_object_unref0 (_data12_->calendar_day);
#line 64 "../core/Widgets/Calendar/CalendarView.vala"
		_g_object_unref0 (self);
#line 64 "../core/Widgets/Calendar/CalendarView.vala"
		g_slice_free (Block12Data, _data12_);
#line 575 "CalendarView.c"
	}
}

static void
_widgets_calendar_calendar_view______lambda132_ (Block12Data* _data12_)
{
	WidgetsCalendarCalendarView* self;
	WidgetsCalendarCalendarDay* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
#line 67 "../core/Widgets/Calendar/CalendarView.vala"
	self = _data12_->self;
#line 68 "../core/Widgets/Calendar/CalendarView.vala"
	_tmp0_ = _data12_->calendar_day;
#line 68 "../core/Widgets/Calendar/CalendarView.vala"
	_tmp1_ = widgets_calendar_calendar_day_get_day (_tmp0_);
#line 68 "../core/Widgets/Calendar/CalendarView.vala"
	_tmp2_ = _tmp1_;
#line 68 "../core/Widgets/Calendar/CalendarView.vala"
	widgets_calendar_calendar_view_day_selected_style (self, _tmp2_);
#line 596 "CalendarView.c"
}

static void
__widgets_calendar_calendar_view______lambda132__widgets_calendar_calendar_day_day_selected (WidgetsCalendarCalendarDay* _sender,
                                                                                             gpointer self)
{
#line 67 "../core/Widgets/Calendar/CalendarView.vala"
	_widgets_calendar_calendar_view______lambda132_ (self);
#line 605 "CalendarView.c"
}

static GObject *
widgets_calendar_calendar_view_constructor (GType type,
                                            guint n_construct_properties,
                                            GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	WidgetsCalendarCalendarView * self;
	GeeArrayList* _tmp0_;
	GtkGrid* _tmp1_ = NULL;
	gint col = 0;
	gint row = 0;
	GtkGrid* _tmp12_;
#line 53 "../core/Widgets/Calendar/CalendarView.vala"
	parent_class = G_OBJECT_CLASS (widgets_calendar_calendar_view_parent_class);
#line 53 "../core/Widgets/Calendar/CalendarView.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 53 "../core/Widgets/Calendar/CalendarView.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, WIDGETS_CALENDAR_TYPE_CALENDAR_VIEW, WidgetsCalendarCalendarView);
#line 54 "../core/Widgets/Calendar/CalendarView.vala"
	_tmp0_ = gee_array_list_new (WIDGETS_CALENDAR_TYPE_CALENDAR_DAY, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 54 "../core/Widgets/Calendar/CalendarView.vala"
	_g_object_unref0 (self->priv->days_arraylist);
#line 54 "../core/Widgets/Calendar/CalendarView.vala"
	self->priv->days_arraylist = _tmp0_;
#line 56 "../core/Widgets/Calendar/CalendarView.vala"
	_tmp1_ = (GtkGrid*) gtk_grid_new ();
#line 56 "../core/Widgets/Calendar/CalendarView.vala"
	gtk_grid_set_column_homogeneous (_tmp1_, TRUE);
#line 56 "../core/Widgets/Calendar/CalendarView.vala"
	gtk_grid_set_row_homogeneous (_tmp1_, TRUE);
#line 56 "../core/Widgets/Calendar/CalendarView.vala"
	g_object_ref_sink (_tmp1_);
#line 56 "../core/Widgets/Calendar/CalendarView.vala"
	_g_object_unref0 (self->priv->days_grid);
#line 56 "../core/Widgets/Calendar/CalendarView.vala"
	self->priv->days_grid = _tmp1_;
#line 61 "../core/Widgets/Calendar/CalendarView.vala"
	col = 0;
#line 62 "../core/Widgets/Calendar/CalendarView.vala"
	row = 0;
#line 649 "CalendarView.c"
	{
		gint i = 0;
#line 64 "../core/Widgets/Calendar/CalendarView.vala"
		i = 0;
#line 654 "CalendarView.c"
		{
			gboolean _tmp2_ = FALSE;
#line 64 "../core/Widgets/Calendar/CalendarView.vala"
			_tmp2_ = TRUE;
#line 64 "../core/Widgets/Calendar/CalendarView.vala"
			while (TRUE) {
#line 661 "CalendarView.c"
				Block12Data* _data12_;
				WidgetsCalendarCalendarDay* _tmp4_;
				WidgetsCalendarCalendarDay* _tmp5_;
				GtkGrid* _tmp6_;
				WidgetsCalendarCalendarDay* _tmp7_;
				gboolean _tmp8_ = FALSE;
				WidgetsCalendarCalendarDay* _tmp9_;
				GeeArrayList* _tmp10_;
				WidgetsCalendarCalendarDay* _tmp11_;
#line 64 "../core/Widgets/Calendar/CalendarView.vala"
				_data12_ = g_slice_new0 (Block12Data);
#line 64 "../core/Widgets/Calendar/CalendarView.vala"
				_data12_->_ref_count_ = 1;
#line 64 "../core/Widgets/Calendar/CalendarView.vala"
				_data12_->self = g_object_ref (self);
#line 64 "../core/Widgets/Calendar/CalendarView.vala"
				if (!_tmp2_) {
#line 679 "CalendarView.c"
					gint _tmp3_;
#line 64 "../core/Widgets/Calendar/CalendarView.vala"
					_tmp3_ = i;
#line 64 "../core/Widgets/Calendar/CalendarView.vala"
					i = _tmp3_ + 1;
#line 685 "CalendarView.c"
				}
#line 64 "../core/Widgets/Calendar/CalendarView.vala"
				_tmp2_ = FALSE;
#line 64 "../core/Widgets/Calendar/CalendarView.vala"
				if (!(i < 42)) {
#line 64 "../core/Widgets/Calendar/CalendarView.vala"
					block12_data_unref (_data12_);
#line 64 "../core/Widgets/Calendar/CalendarView.vala"
					_data12_ = NULL;
#line 64 "../core/Widgets/Calendar/CalendarView.vala"
					break;
#line 697 "CalendarView.c"
				}
#line 65 "../core/Widgets/Calendar/CalendarView.vala"
				_tmp4_ = widgets_calendar_calendar_day_new ();
#line 65 "../core/Widgets/Calendar/CalendarView.vala"
				g_object_ref_sink (_tmp4_);
#line 65 "../core/Widgets/Calendar/CalendarView.vala"
				_data12_->calendar_day = _tmp4_;
#line 67 "../core/Widgets/Calendar/CalendarView.vala"
				_tmp5_ = _data12_->calendar_day;
#line 67 "../core/Widgets/Calendar/CalendarView.vala"
				g_signal_connect_data (_tmp5_, "day-selected", (GCallback) __widgets_calendar_calendar_view______lambda132__widgets_calendar_calendar_day_day_selected, block12_data_ref (_data12_), (GClosureNotify) block12_data_unref, 0);
#line 71 "../core/Widgets/Calendar/CalendarView.vala"
				_tmp6_ = self->priv->days_grid;
#line 71 "../core/Widgets/Calendar/CalendarView.vala"
				_tmp7_ = _data12_->calendar_day;
#line 71 "../core/Widgets/Calendar/CalendarView.vala"
				gtk_grid_attach (_tmp6_, (GtkWidget*) _tmp7_, col, row, 1, 1);
#line 72 "../core/Widgets/Calendar/CalendarView.vala"
				col = col + 1;
#line 74 "../core/Widgets/Calendar/CalendarView.vala"
				if (col != 0) {
#line 74 "../core/Widgets/Calendar/CalendarView.vala"
					_tmp8_ = (col % 7) == 0;
#line 721 "CalendarView.c"
				} else {
#line 74 "../core/Widgets/Calendar/CalendarView.vala"
					_tmp8_ = FALSE;
#line 725 "CalendarView.c"
				}
#line 74 "../core/Widgets/Calendar/CalendarView.vala"
				if (_tmp8_) {
#line 75 "../core/Widgets/Calendar/CalendarView.vala"
					row = row + 1;
#line 76 "../core/Widgets/Calendar/CalendarView.vala"
					col = 0;
#line 733 "CalendarView.c"
				}
#line 79 "../core/Widgets/Calendar/CalendarView.vala"
				_tmp9_ = _data12_->calendar_day;
#line 79 "../core/Widgets/Calendar/CalendarView.vala"
				gtk_widget_set_visible ((GtkWidget*) _tmp9_, FALSE);
#line 80 "../core/Widgets/Calendar/CalendarView.vala"
				_tmp10_ = self->priv->days_arraylist;
#line 80 "../core/Widgets/Calendar/CalendarView.vala"
				_tmp11_ = _data12_->calendar_day;
#line 80 "../core/Widgets/Calendar/CalendarView.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp10_, _tmp11_);
#line 64 "../core/Widgets/Calendar/CalendarView.vala"
				block12_data_unref (_data12_);
#line 64 "../core/Widgets/Calendar/CalendarView.vala"
				_data12_ = NULL;
#line 749 "CalendarView.c"
			}
		}
	}
#line 83 "../core/Widgets/Calendar/CalendarView.vala"
	_tmp12_ = self->priv->days_grid;
#line 83 "../core/Widgets/Calendar/CalendarView.vala"
	adw_bin_set_child ((AdwBin*) self, (GtkWidget*) _tmp12_);
#line 53 "../core/Widgets/Calendar/CalendarView.vala"
	return obj;
#line 759 "CalendarView.c"
}

static void
widgets_calendar_calendar_view_class_init (WidgetsCalendarCalendarViewClass * klass,
                                           gpointer klass_data)
{
#line 22 "../core/Widgets/Calendar/CalendarView.vala"
	widgets_calendar_calendar_view_parent_class = g_type_class_peek_parent (klass);
#line 22 "../core/Widgets/Calendar/CalendarView.vala"
	g_type_class_adjust_private_offset (klass, &WidgetsCalendarCalendarView_private_offset);
#line 22 "../core/Widgets/Calendar/CalendarView.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_widgets_calendar_calendar_view_get_property;
#line 22 "../core/Widgets/Calendar/CalendarView.vala"
	G_OBJECT_CLASS (klass)->constructor = widgets_calendar_calendar_view_constructor;
#line 22 "../core/Widgets/Calendar/CalendarView.vala"
	G_OBJECT_CLASS (klass)->finalize = widgets_calendar_calendar_view_finalize;
#line 22 "../core/Widgets/Calendar/CalendarView.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), WIDGETS_CALENDAR_CALENDAR_VIEW_CURRENT_DATE_PROPERTY, widgets_calendar_calendar_view_properties[WIDGETS_CALENDAR_CALENDAR_VIEW_CURRENT_DATE_PROPERTY] = g_param_spec_boxed ("current-date", "current-date", "current-date", G_TYPE_DATE_TIME, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 22 "../core/Widgets/Calendar/CalendarView.vala"
	widgets_calendar_calendar_view_signals[WIDGETS_CALENDAR_CALENDAR_VIEW_DAY_SELECTED_SIGNAL] = g_signal_new ("day-selected", WIDGETS_CALENDAR_TYPE_CALENDAR_VIEW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__INT, G_TYPE_NONE, 1, G_TYPE_INT);
#line 780 "CalendarView.c"
}

static void
widgets_calendar_calendar_view_instance_init (WidgetsCalendarCalendarView * self,
                                              gpointer klass)
{
#line 22 "../core/Widgets/Calendar/CalendarView.vala"
	self->priv = widgets_calendar_calendar_view_get_instance_private (self);
#line 789 "CalendarView.c"
}

static void
widgets_calendar_calendar_view_finalize (GObject * obj)
{
	WidgetsCalendarCalendarView * self;
#line 22 "../core/Widgets/Calendar/CalendarView.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, WIDGETS_CALENDAR_TYPE_CALENDAR_VIEW, WidgetsCalendarCalendarView);
#line 23 "../core/Widgets/Calendar/CalendarView.vala"
	_g_object_unref0 (self->priv->days_arraylist);
#line 24 "../core/Widgets/Calendar/CalendarView.vala"
	_g_object_unref0 (self->priv->days_grid);
#line 26 "../core/Widgets/Calendar/CalendarView.vala"
	_g_date_time_unref0 (self->priv->_current_date);
#line 22 "../core/Widgets/Calendar/CalendarView.vala"
	G_OBJECT_CLASS (widgets_calendar_calendar_view_parent_class)->finalize (obj);
#line 806 "CalendarView.c"
}

static GType
widgets_calendar_calendar_view_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (WidgetsCalendarCalendarViewClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) widgets_calendar_calendar_view_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (WidgetsCalendarCalendarView), 0, (GInstanceInitFunc) widgets_calendar_calendar_view_instance_init, NULL };
	GType widgets_calendar_calendar_view_type_id;
	widgets_calendar_calendar_view_type_id = g_type_register_static (adw_bin_get_type (), "WidgetsCalendarCalendarView", &g_define_type_info, 0);
	WidgetsCalendarCalendarView_private_offset = g_type_add_instance_private (widgets_calendar_calendar_view_type_id, sizeof (WidgetsCalendarCalendarViewPrivate));
	return widgets_calendar_calendar_view_type_id;
}

GType
widgets_calendar_calendar_view_get_type (void)
{
	static volatile gsize widgets_calendar_calendar_view_type_id__once = 0;
	if (g_once_init_enter (&widgets_calendar_calendar_view_type_id__once)) {
		GType widgets_calendar_calendar_view_type_id;
		widgets_calendar_calendar_view_type_id = widgets_calendar_calendar_view_get_type_once ();
		g_once_init_leave (&widgets_calendar_calendar_view_type_id__once, widgets_calendar_calendar_view_type_id);
	}
	return widgets_calendar_calendar_view_type_id__once;
}

static void
_vala_widgets_calendar_calendar_view_get_property (GObject * object,
                                                   guint property_id,
                                                   GValue * value,
                                                   GParamSpec * pspec)
{
	WidgetsCalendarCalendarView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, WIDGETS_CALENDAR_TYPE_CALENDAR_VIEW, WidgetsCalendarCalendarView);
#line 22 "../core/Widgets/Calendar/CalendarView.vala"
	switch (property_id) {
#line 22 "../core/Widgets/Calendar/CalendarView.vala"
		case WIDGETS_CALENDAR_CALENDAR_VIEW_CURRENT_DATE_PROPERTY:
#line 22 "../core/Widgets/Calendar/CalendarView.vala"
		g_value_set_boxed (value, widgets_calendar_calendar_view_get_current_date (self));
#line 22 "../core/Widgets/Calendar/CalendarView.vala"
		break;
#line 847 "CalendarView.c"
		default:
#line 22 "../core/Widgets/Calendar/CalendarView.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 22 "../core/Widgets/Calendar/CalendarView.vala"
		break;
#line 853 "CalendarView.c"
	}
}

