/* CircularProgressBar.c generated by valac 0.56.18, the Vala compiler
 * generated from CircularProgressBar.vala, do not modify */

/* -*- Mode: Vala; indent-tabs-mode: nil; c-basic-offset: 4; tab-width: 4 -*- */
/* vim: set tabstop=4 softtabstop=4 shiftwidth=4 expandtab : */
/*
 * Custom Gtk.Widget to provide a circular progress bar.
 * It extends/subclasses Gtk.Bin instead of Gtk.DrawingArea.
 *
 * Based on José Miguel Fonte's Vala Circular Progress Bar
 * https://github.com/phastmike/vala-circular-progress-bar
 */

#include "planify.h"
#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <float.h>
#include <math.h>
#include <stdlib.h>
#include <string.h>
#include <adwaita.h>
#include <cairo-gobject.h>
#include <gdk/gdk.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	WIDGETS_CIRCULAR_PROGRESS_BAR_0_PROPERTY,
	WIDGETS_CIRCULAR_PROGRESS_BAR_SIZE_PROPERTY,
	WIDGETS_CIRCULAR_PROGRESS_BAR_PERCENTAGE_PROPERTY,
	WIDGETS_CIRCULAR_PROGRESS_BAR_COLOR_PROPERTY,
	WIDGETS_CIRCULAR_PROGRESS_BAR_NUM_PROPERTIES
};
static GParamSpec* widgets_circular_progress_bar_properties[WIDGETS_CIRCULAR_PROGRESS_BAR_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
enum  {
	_CIRCULARPROGRESSBAR_0_PROPERTY,
	_CIRCULARPROGRESSBAR_SIZE_PROPERTY,
	_CIRCULARPROGRESSBAR_CENTER_FILLED_PROPERTY,
	_CIRCULARPROGRESSBAR_RADIUS_FILLED_PROPERTY,
	_CIRCULARPROGRESSBAR_FONT_PROPERTY,
	_CIRCULARPROGRESSBAR_LINE_CAP_PROPERTY,
	_CIRCULARPROGRESSBAR_CENTER_FILL_COLOR_PROPERTY,
	_CIRCULARPROGRESSBAR_RADIUS_FILL_COLOR_PROPERTY,
	_CIRCULARPROGRESSBAR_PROGRESS_FILL_COLOR_PROPERTY,
	_CIRCULARPROGRESSBAR_LINE_WIDTH_PROPERTY,
	_CIRCULARPROGRESSBAR_PERCENTAGE_PROPERTY,
	_CIRCULARPROGRESSBAR_NUM_PROPERTIES
};
static GParamSpec* _circularprogressbar_properties[_CIRCULARPROGRESSBAR_NUM_PROPERTIES];

struct _WidgetsCircularProgressBarPrivate {
	gint _size;
	_CircularProgressBar* circularProgressBar;
};

struct __CircularProgressBarPrivate {
	gint _size;
	gint _line_width;
	gdouble _percentage;
	gchar* _center_fill_color;
	gchar* _radius_fill_color;
	gchar* _progress_fill_color;
	gboolean _center_filled;
	gboolean _radius_filled;
	gchar* _font;
	cairo_line_cap_t _line_cap;
};

static gint WidgetsCircularProgressBar_private_offset;
static gpointer widgets_circular_progress_bar_parent_class = NULL;
static gint _CircularProgressBar_private_offset;
static gpointer _circularprogressbar_parent_class = NULL;

static GObject * widgets_circular_progress_bar_constructor (GType type,
                                                     guint n_construct_properties,
                                                     GObjectConstructParam * construct_properties);
static void widgets_circular_progress_bar_finalize (GObject * obj);
static GType widgets_circular_progress_bar_get_type_once (void);
static void _vala_widgets_circular_progress_bar_get_property (GObject * object,
                                                       guint property_id,
                                                       GValue * value,
                                                       GParamSpec * pspec);
static void _vala_widgets_circular_progress_bar_set_property (GObject * object,
                                                       guint property_id,
                                                       const GValue * value,
                                                       GParamSpec * pspec);
static void __circularprogressbar_draw_gtk_drawing_area_draw_func (GtkDrawingArea* drawing_area,
                                                            cairo_t* cr,
                                                            gint width,
                                                            gint height,
                                                            gpointer self);
static void __lambda97_ (_CircularProgressBar* self);
static void ___lambda97__g_object_notify (GObject* _sender,
                                   GParamSpec* pspec,
                                   gpointer self);
static gint _circularprogressbar_calculate_radius (_CircularProgressBar* self);
static GtkSizeRequestMode _circularprogressbar_real_get_request_mode (GtkWidget* base);
static GObject * _circularprogressbar_constructor (GType type,
                                            guint n_construct_properties,
                                            GObjectConstructParam * construct_properties);
static void _circularprogressbar_finalize (GObject * obj);
static GType _circularprogressbar_get_type_once (void);
static void _vala__circularprogressbar_get_property (GObject * object,
                                              guint property_id,
                                              GValue * value,
                                              GParamSpec * pspec);
static void _vala__circularprogressbar_set_property (GObject * object,
                                              guint property_id,
                                              const GValue * value,
                                              GParamSpec * pspec);

static inline gpointer
widgets_circular_progress_bar_get_instance_private (WidgetsCircularProgressBar* self)
{
	return G_STRUCT_MEMBER_P (self, WidgetsCircularProgressBar_private_offset);
}

WidgetsCircularProgressBar*
widgets_circular_progress_bar_construct (GType object_type,
                                         gint size)
{
	WidgetsCircularProgressBar * self = NULL;
#line 37 "../core/Widgets/CircularProgressBar.vala"
	self = (WidgetsCircularProgressBar*) g_object_new (object_type, "size", size, "halign", GTK_ALIGN_CENTER, "valign", GTK_ALIGN_CENTER, NULL);
#line 36 "../core/Widgets/CircularProgressBar.vala"
	return self;
#line 138 "CircularProgressBar.c"
}

WidgetsCircularProgressBar*
widgets_circular_progress_bar_new (gint size)
{
#line 36 "../core/Widgets/CircularProgressBar.vala"
	return widgets_circular_progress_bar_construct (WIDGETS_TYPE_CIRCULAR_PROGRESS_BAR, size);
#line 146 "CircularProgressBar.c"
}

gint
widgets_circular_progress_bar_get_size (WidgetsCircularProgressBar* self)
{
	gint result;
#line 15 "../core/Widgets/CircularProgressBar.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 15 "../core/Widgets/CircularProgressBar.vala"
	result = self->priv->_size;
#line 15 "../core/Widgets/CircularProgressBar.vala"
	return result;
#line 159 "CircularProgressBar.c"
}

static void
widgets_circular_progress_bar_set_size (WidgetsCircularProgressBar* self,
                                        gint value)
{
	gint old_value;
#line 15 "../core/Widgets/CircularProgressBar.vala"
	g_return_if_fail (self != NULL);
#line 15 "../core/Widgets/CircularProgressBar.vala"
	old_value = widgets_circular_progress_bar_get_size (self);
#line 15 "../core/Widgets/CircularProgressBar.vala"
	if (old_value != value) {
#line 15 "../core/Widgets/CircularProgressBar.vala"
		self->priv->_size = value;
#line 15 "../core/Widgets/CircularProgressBar.vala"
		g_object_notify_by_pspec ((GObject *) self, widgets_circular_progress_bar_properties[WIDGETS_CIRCULAR_PROGRESS_BAR_SIZE_PROPERTY]);
#line 177 "CircularProgressBar.c"
	}
}

gdouble
widgets_circular_progress_bar_get_percentage (WidgetsCircularProgressBar* self)
{
	gdouble result;
	_CircularProgressBar* _tmp0_;
	gdouble _tmp1_;
	gdouble _tmp2_;
#line 18 "../core/Widgets/CircularProgressBar.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 19 "../core/Widgets/CircularProgressBar.vala"
	_tmp0_ = self->priv->circularProgressBar;
#line 19 "../core/Widgets/CircularProgressBar.vala"
	_tmp1_ = _circularprogressbar_get_percentage (_tmp0_);
#line 19 "../core/Widgets/CircularProgressBar.vala"
	_tmp2_ = _tmp1_;
#line 19 "../core/Widgets/CircularProgressBar.vala"
	result = _tmp2_;
#line 19 "../core/Widgets/CircularProgressBar.vala"
	return result;
#line 200 "CircularProgressBar.c"
}

void
widgets_circular_progress_bar_set_percentage (WidgetsCircularProgressBar* self,
                                              gdouble value)
{
	_CircularProgressBar* _tmp0_;
#line 22 "../core/Widgets/CircularProgressBar.vala"
	g_return_if_fail (self != NULL);
#line 23 "../core/Widgets/CircularProgressBar.vala"
	_tmp0_ = self->priv->circularProgressBar;
#line 23 "../core/Widgets/CircularProgressBar.vala"
	_circularprogressbar_set_percentage (_tmp0_, value);
#line 22 "../core/Widgets/CircularProgressBar.vala"
	g_object_notify_by_pspec ((GObject *) self, widgets_circular_progress_bar_properties[WIDGETS_CIRCULAR_PROGRESS_BAR_PERCENTAGE_PROPERTY]);
#line 216 "CircularProgressBar.c"
}

void
widgets_circular_progress_bar_set_color (WidgetsCircularProgressBar* self,
                                         const gchar* value)
{
	_CircularProgressBar* _tmp0_;
	Util* _tmp1_;
	Util* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	Util* _tmp5_;
	Util* _tmp6_;
	Util* _tmp7_;
	Util* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
#line 28 "../core/Widgets/CircularProgressBar.vala"
	g_return_if_fail (self != NULL);
#line 29 "../core/Widgets/CircularProgressBar.vala"
	_tmp0_ = self->priv->circularProgressBar;
#line 29 "../core/Widgets/CircularProgressBar.vala"
	_tmp1_ = util_get_default ();
#line 29 "../core/Widgets/CircularProgressBar.vala"
	_tmp2_ = _tmp1_;
#line 29 "../core/Widgets/CircularProgressBar.vala"
	_tmp3_ = util_get_color (_tmp2_, value);
#line 29 "../core/Widgets/CircularProgressBar.vala"
	_tmp4_ = _tmp3_;
#line 29 "../core/Widgets/CircularProgressBar.vala"
	_circularprogressbar_set_progress_fill_color (_tmp0_, _tmp4_);
#line 29 "../core/Widgets/CircularProgressBar.vala"
	_g_free0 (_tmp4_);
#line 29 "../core/Widgets/CircularProgressBar.vala"
	_g_object_unref0 (_tmp2_);
#line 30 "../core/Widgets/CircularProgressBar.vala"
	_tmp5_ = util_get_default ();
#line 30 "../core/Widgets/CircularProgressBar.vala"
	_tmp6_ = _tmp5_;
#line 30 "../core/Widgets/CircularProgressBar.vala"
	_tmp7_ = util_get_default ();
#line 30 "../core/Widgets/CircularProgressBar.vala"
	_tmp8_ = _tmp7_;
#line 30 "../core/Widgets/CircularProgressBar.vala"
	_tmp9_ = util_get_color (_tmp8_, value);
#line 30 "../core/Widgets/CircularProgressBar.vala"
	_tmp10_ = _tmp9_;
#line 30 "../core/Widgets/CircularProgressBar.vala"
	util_set_widget_color (_tmp6_, _tmp10_, (GtkWidget*) self);
#line 30 "../core/Widgets/CircularProgressBar.vala"
	_g_free0 (_tmp10_);
#line 30 "../core/Widgets/CircularProgressBar.vala"
	_g_object_unref0 (_tmp8_);
#line 30 "../core/Widgets/CircularProgressBar.vala"
	_g_object_unref0 (_tmp6_);
#line 28 "../core/Widgets/CircularProgressBar.vala"
	g_object_notify_by_pspec ((GObject *) self, widgets_circular_progress_bar_properties[WIDGETS_CIRCULAR_PROGRESS_BAR_COLOR_PROPERTY]);
#line 274 "CircularProgressBar.c"
}

static GObject *
widgets_circular_progress_bar_constructor (GType type,
                                           guint n_construct_properties,
                                           GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	WidgetsCircularProgressBar * self;
	gint _tmp0_;
	_CircularProgressBar* _tmp1_ = NULL;
	_CircularProgressBar* _tmp2_;
#line 44 "../core/Widgets/CircularProgressBar.vala"
	parent_class = G_OBJECT_CLASS (widgets_circular_progress_bar_parent_class);
#line 44 "../core/Widgets/CircularProgressBar.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 44 "../core/Widgets/CircularProgressBar.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, WIDGETS_TYPE_CIRCULAR_PROGRESS_BAR, WidgetsCircularProgressBar);
#line 45 "../core/Widgets/CircularProgressBar.vala"
	gtk_widget_add_css_class ((GtkWidget*) self, "circular-progress-bar");
#line 47 "../core/Widgets/CircularProgressBar.vala"
	_tmp0_ = self->priv->_size;
#line 47 "../core/Widgets/CircularProgressBar.vala"
	_tmp1_ = _circularprogressbar_new (_tmp0_);
#line 47 "../core/Widgets/CircularProgressBar.vala"
	gtk_widget_set_margin_start ((GtkWidget*) _tmp1_, 2);
#line 47 "../core/Widgets/CircularProgressBar.vala"
	gtk_widget_set_margin_top ((GtkWidget*) _tmp1_, 2);
#line 47 "../core/Widgets/CircularProgressBar.vala"
	gtk_widget_set_margin_end ((GtkWidget*) _tmp1_, 2);
#line 47 "../core/Widgets/CircularProgressBar.vala"
	gtk_widget_set_margin_bottom ((GtkWidget*) _tmp1_, 2);
#line 47 "../core/Widgets/CircularProgressBar.vala"
	g_object_ref_sink (_tmp1_);
#line 47 "../core/Widgets/CircularProgressBar.vala"
	_g_object_unref0 (self->priv->circularProgressBar);
#line 47 "../core/Widgets/CircularProgressBar.vala"
	self->priv->circularProgressBar = _tmp1_;
#line 54 "../core/Widgets/CircularProgressBar.vala"
	_tmp2_ = self->priv->circularProgressBar;
#line 54 "../core/Widgets/CircularProgressBar.vala"
	adw_bin_set_child ((AdwBin*) self, (GtkWidget*) _tmp2_);
#line 44 "../core/Widgets/CircularProgressBar.vala"
	return obj;
#line 320 "CircularProgressBar.c"
}

static void
widgets_circular_progress_bar_class_init (WidgetsCircularProgressBarClass * klass,
                                          gpointer klass_data)
{
#line 14 "../core/Widgets/CircularProgressBar.vala"
	widgets_circular_progress_bar_parent_class = g_type_class_peek_parent (klass);
#line 14 "../core/Widgets/CircularProgressBar.vala"
	g_type_class_adjust_private_offset (klass, &WidgetsCircularProgressBar_private_offset);
#line 14 "../core/Widgets/CircularProgressBar.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_widgets_circular_progress_bar_get_property;
#line 14 "../core/Widgets/CircularProgressBar.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_widgets_circular_progress_bar_set_property;
#line 14 "../core/Widgets/CircularProgressBar.vala"
	G_OBJECT_CLASS (klass)->constructor = widgets_circular_progress_bar_constructor;
#line 14 "../core/Widgets/CircularProgressBar.vala"
	G_OBJECT_CLASS (klass)->finalize = widgets_circular_progress_bar_finalize;
#line 14 "../core/Widgets/CircularProgressBar.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), WIDGETS_CIRCULAR_PROGRESS_BAR_SIZE_PROPERTY, widgets_circular_progress_bar_properties[WIDGETS_CIRCULAR_PROGRESS_BAR_SIZE_PROPERTY] = g_param_spec_int ("size", "size", "size", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 14 "../core/Widgets/CircularProgressBar.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), WIDGETS_CIRCULAR_PROGRESS_BAR_PERCENTAGE_PROPERTY, widgets_circular_progress_bar_properties[WIDGETS_CIRCULAR_PROGRESS_BAR_PERCENTAGE_PROPERTY] = g_param_spec_double ("percentage", "percentage", "percentage", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 14 "../core/Widgets/CircularProgressBar.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), WIDGETS_CIRCULAR_PROGRESS_BAR_COLOR_PROPERTY, widgets_circular_progress_bar_properties[WIDGETS_CIRCULAR_PROGRESS_BAR_COLOR_PROPERTY] = g_param_spec_string ("color", "color", "color", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_WRITABLE));
#line 345 "CircularProgressBar.c"
}

static void
widgets_circular_progress_bar_instance_init (WidgetsCircularProgressBar * self,
                                             gpointer klass)
{
#line 14 "../core/Widgets/CircularProgressBar.vala"
	self->priv = widgets_circular_progress_bar_get_instance_private (self);
#line 354 "CircularProgressBar.c"
}

static void
widgets_circular_progress_bar_finalize (GObject * obj)
{
	WidgetsCircularProgressBar * self;
#line 14 "../core/Widgets/CircularProgressBar.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, WIDGETS_TYPE_CIRCULAR_PROGRESS_BAR, WidgetsCircularProgressBar);
#line 34 "../core/Widgets/CircularProgressBar.vala"
	_g_object_unref0 (self->priv->circularProgressBar);
#line 14 "../core/Widgets/CircularProgressBar.vala"
	G_OBJECT_CLASS (widgets_circular_progress_bar_parent_class)->finalize (obj);
#line 367 "CircularProgressBar.c"
}

static GType
widgets_circular_progress_bar_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (WidgetsCircularProgressBarClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) widgets_circular_progress_bar_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (WidgetsCircularProgressBar), 0, (GInstanceInitFunc) widgets_circular_progress_bar_instance_init, NULL };
	GType widgets_circular_progress_bar_type_id;
	widgets_circular_progress_bar_type_id = g_type_register_static (adw_bin_get_type (), "WidgetsCircularProgressBar", &g_define_type_info, 0);
	WidgetsCircularProgressBar_private_offset = g_type_add_instance_private (widgets_circular_progress_bar_type_id, sizeof (WidgetsCircularProgressBarPrivate));
	return widgets_circular_progress_bar_type_id;
}

GType
widgets_circular_progress_bar_get_type (void)
{
	static volatile gsize widgets_circular_progress_bar_type_id__once = 0;
	if (g_once_init_enter (&widgets_circular_progress_bar_type_id__once)) {
		GType widgets_circular_progress_bar_type_id;
		widgets_circular_progress_bar_type_id = widgets_circular_progress_bar_get_type_once ();
		g_once_init_leave (&widgets_circular_progress_bar_type_id__once, widgets_circular_progress_bar_type_id);
	}
	return widgets_circular_progress_bar_type_id__once;
}

static void
_vala_widgets_circular_progress_bar_get_property (GObject * object,
                                                  guint property_id,
                                                  GValue * value,
                                                  GParamSpec * pspec)
{
	WidgetsCircularProgressBar * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, WIDGETS_TYPE_CIRCULAR_PROGRESS_BAR, WidgetsCircularProgressBar);
#line 14 "../core/Widgets/CircularProgressBar.vala"
	switch (property_id) {
#line 14 "../core/Widgets/CircularProgressBar.vala"
		case WIDGETS_CIRCULAR_PROGRESS_BAR_SIZE_PROPERTY:
#line 14 "../core/Widgets/CircularProgressBar.vala"
		g_value_set_int (value, widgets_circular_progress_bar_get_size (self));
#line 14 "../core/Widgets/CircularProgressBar.vala"
		break;
#line 14 "../core/Widgets/CircularProgressBar.vala"
		case WIDGETS_CIRCULAR_PROGRESS_BAR_PERCENTAGE_PROPERTY:
#line 14 "../core/Widgets/CircularProgressBar.vala"
		g_value_set_double (value, widgets_circular_progress_bar_get_percentage (self));
#line 14 "../core/Widgets/CircularProgressBar.vala"
		break;
#line 414 "CircularProgressBar.c"
		default:
#line 14 "../core/Widgets/CircularProgressBar.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 14 "../core/Widgets/CircularProgressBar.vala"
		break;
#line 420 "CircularProgressBar.c"
	}
}

static void
_vala_widgets_circular_progress_bar_set_property (GObject * object,
                                                  guint property_id,
                                                  const GValue * value,
                                                  GParamSpec * pspec)
{
	WidgetsCircularProgressBar * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, WIDGETS_TYPE_CIRCULAR_PROGRESS_BAR, WidgetsCircularProgressBar);
#line 14 "../core/Widgets/CircularProgressBar.vala"
	switch (property_id) {
#line 14 "../core/Widgets/CircularProgressBar.vala"
		case WIDGETS_CIRCULAR_PROGRESS_BAR_SIZE_PROPERTY:
#line 14 "../core/Widgets/CircularProgressBar.vala"
		widgets_circular_progress_bar_set_size (self, g_value_get_int (value));
#line 14 "../core/Widgets/CircularProgressBar.vala"
		break;
#line 14 "../core/Widgets/CircularProgressBar.vala"
		case WIDGETS_CIRCULAR_PROGRESS_BAR_PERCENTAGE_PROPERTY:
#line 14 "../core/Widgets/CircularProgressBar.vala"
		widgets_circular_progress_bar_set_percentage (self, g_value_get_double (value));
#line 14 "../core/Widgets/CircularProgressBar.vala"
		break;
#line 14 "../core/Widgets/CircularProgressBar.vala"
		case WIDGETS_CIRCULAR_PROGRESS_BAR_COLOR_PROPERTY:
#line 14 "../core/Widgets/CircularProgressBar.vala"
		widgets_circular_progress_bar_set_color (self, g_value_get_string (value));
#line 14 "../core/Widgets/CircularProgressBar.vala"
		break;
#line 452 "CircularProgressBar.c"
		default:
#line 14 "../core/Widgets/CircularProgressBar.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 14 "../core/Widgets/CircularProgressBar.vala"
		break;
#line 458 "CircularProgressBar.c"
	}
}

static inline gpointer
_circularprogressbar_get_instance_private (_CircularProgressBar* self)
{
	return G_STRUCT_MEMBER_P (self, _CircularProgressBar_private_offset);
}

static void
__circularprogressbar_draw_gtk_drawing_area_draw_func (GtkDrawingArea* drawing_area,
                                                       cairo_t* cr,
                                                       gint width,
                                                       gint height,
                                                       gpointer self)
{
#line 165 "../core/Widgets/CircularProgressBar.vala"
	_circularprogressbar_draw ((_CircularProgressBar*) self, drawing_area, cr, width, height);
#line 477 "CircularProgressBar.c"
}

static void
__lambda97_ (_CircularProgressBar* self)
{
#line 168 "../core/Widgets/CircularProgressBar.vala"
	gtk_widget_queue_draw ((GtkWidget*) self);
#line 485 "CircularProgressBar.c"
}

static void
___lambda97__g_object_notify (GObject* _sender,
                              GParamSpec* pspec,
                              gpointer self)
{
#line 167 "../core/Widgets/CircularProgressBar.vala"
	__lambda97_ ((_CircularProgressBar*) self);
#line 495 "CircularProgressBar.c"
}

_CircularProgressBar*
_circularprogressbar_construct (GType object_type,
                                gint size)
{
	_CircularProgressBar * self = NULL;
#line 159 "../core/Widgets/CircularProgressBar.vala"
	self = (_CircularProgressBar*) g_object_new (object_type, "size", size, "height-request", size, "width-request", size, NULL);
#line 165 "../core/Widgets/CircularProgressBar.vala"
	gtk_drawing_area_set_draw_func ((GtkDrawingArea*) self, __circularprogressbar_draw_gtk_drawing_area_draw_func, g_object_ref (self), g_object_unref);
#line 167 "../core/Widgets/CircularProgressBar.vala"
	g_signal_connect_object ((GObject*) self, "notify", (GCallback) ___lambda97__g_object_notify, self, 0);
#line 158 "../core/Widgets/CircularProgressBar.vala"
	return self;
#line 511 "CircularProgressBar.c"
}

_CircularProgressBar*
_circularprogressbar_new (gint size)
{
#line 158 "../core/Widgets/CircularProgressBar.vala"
	return _circularprogressbar_construct (TYPE__CIRCULARPROGRESSBAR, size);
#line 519 "CircularProgressBar.c"
}

static gint
_circularprogressbar_calculate_radius (_CircularProgressBar* self)
{
	gint result;
#line 172 "../core/Widgets/CircularProgressBar.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 173 "../core/Widgets/CircularProgressBar.vala"
	result = MIN (gtk_widget_get_width ((GtkWidget*) self) / 2, gtk_widget_get_height ((GtkWidget*) self) / 2) - 1;
#line 173 "../core/Widgets/CircularProgressBar.vala"
	return result;
#line 532 "CircularProgressBar.c"
}

static GtkSizeRequestMode
_circularprogressbar_real_get_request_mode (GtkWidget* base)
{
	_CircularProgressBar * self;
	GtkSizeRequestMode result;
#line 176 "../core/Widgets/CircularProgressBar.vala"
	self = (_CircularProgressBar*) base;
#line 177 "../core/Widgets/CircularProgressBar.vala"
	result = GTK_SIZE_REQUEST_CONSTANT_SIZE;
#line 177 "../core/Widgets/CircularProgressBar.vala"
	return result;
#line 546 "CircularProgressBar.c"
}

void
_circularprogressbar_draw (_CircularProgressBar* self,
                           GtkDrawingArea* da,
                           cairo_t* cr,
                           gint width,
                           gint height)
{
	gint delta = 0;
	GdkRGBA color = {0};
	gint center_x = 0;
	gint center_y = 0;
	gint radius = 0;
	gint _tmp0_;
	gint _tmp1_;
	cairo_line_cap_t _tmp4_;
	gint _tmp5_;
	gint _tmp6_;
	gboolean _tmp7_;
	gboolean _tmp11_;
	gdouble _tmp15_;
	gdouble _tmp16_;
#line 180 "../core/Widgets/CircularProgressBar.vala"
	g_return_if_fail (self != NULL);
#line 180 "../core/Widgets/CircularProgressBar.vala"
	g_return_if_fail (da != NULL);
#line 180 "../core/Widgets/CircularProgressBar.vala"
	g_return_if_fail (cr != NULL);
#line 184 "../core/Widgets/CircularProgressBar.vala"
	cairo_save (cr);
#line 186 "../core/Widgets/CircularProgressBar.vala"
	memset (&color, 0, sizeof (GdkRGBA));
#line 188 "../core/Widgets/CircularProgressBar.vala"
	center_x = gtk_widget_get_width ((GtkWidget*) self) / 2;
#line 189 "../core/Widgets/CircularProgressBar.vala"
	center_y = gtk_widget_get_height ((GtkWidget*) self) / 2;
#line 190 "../core/Widgets/CircularProgressBar.vala"
	radius = _circularprogressbar_calculate_radius (self);
#line 192 "../core/Widgets/CircularProgressBar.vala"
	_tmp0_ = _circularprogressbar_get_line_width (self);
#line 192 "../core/Widgets/CircularProgressBar.vala"
	_tmp1_ = _tmp0_;
#line 192 "../core/Widgets/CircularProgressBar.vala"
	if ((radius - _tmp1_) < 0) {
#line 193 "../core/Widgets/CircularProgressBar.vala"
		delta = 0;
#line 194 "../core/Widgets/CircularProgressBar.vala"
		_circularprogressbar_set_line_width (self, radius);
#line 596 "CircularProgressBar.c"
	} else {
		gint _tmp2_;
		gint _tmp3_;
#line 196 "../core/Widgets/CircularProgressBar.vala"
		_tmp2_ = _circularprogressbar_get_line_width (self);
#line 196 "../core/Widgets/CircularProgressBar.vala"
		_tmp3_ = _tmp2_;
#line 196 "../core/Widgets/CircularProgressBar.vala"
		delta = radius - (_tmp3_ / 2);
#line 606 "CircularProgressBar.c"
	}
#line 199 "../core/Widgets/CircularProgressBar.vala"
	memset (&color, 0, sizeof (GdkRGBA));
#line 200 "../core/Widgets/CircularProgressBar.vala"
	_tmp4_ = self->priv->_line_cap;
#line 200 "../core/Widgets/CircularProgressBar.vala"
	cairo_set_line_cap (cr, _tmp4_);
#line 201 "../core/Widgets/CircularProgressBar.vala"
	_tmp5_ = _circularprogressbar_get_line_width (self);
#line 201 "../core/Widgets/CircularProgressBar.vala"
	_tmp6_ = _tmp5_;
#line 201 "../core/Widgets/CircularProgressBar.vala"
	cairo_set_line_width (cr, (gdouble) _tmp6_);
#line 204 "../core/Widgets/CircularProgressBar.vala"
	_tmp7_ = self->priv->_center_filled;
#line 204 "../core/Widgets/CircularProgressBar.vala"
	if (_tmp7_ == TRUE) {
#line 624 "CircularProgressBar.c"
		const gchar* _tmp8_;
		const gchar* _tmp9_;
		GdkRGBA _tmp10_;
#line 205 "../core/Widgets/CircularProgressBar.vala"
		cairo_arc (cr, (gdouble) center_x, (gdouble) center_y, (gdouble) delta, (gdouble) 0, 2 * G_PI);
#line 206 "../core/Widgets/CircularProgressBar.vala"
		_tmp8_ = _circularprogressbar_get_center_fill_color (self);
#line 206 "../core/Widgets/CircularProgressBar.vala"
		_tmp9_ = _tmp8_;
#line 206 "../core/Widgets/CircularProgressBar.vala"
		gdk_rgba_parse (&color, _tmp9_);
#line 207 "../core/Widgets/CircularProgressBar.vala"
		_tmp10_ = color;
#line 207 "../core/Widgets/CircularProgressBar.vala"
		gdk_cairo_set_source_rgba (cr, &_tmp10_);
#line 208 "../core/Widgets/CircularProgressBar.vala"
		cairo_fill (cr);
#line 642 "CircularProgressBar.c"
	}
#line 212 "../core/Widgets/CircularProgressBar.vala"
	_tmp11_ = self->priv->_radius_filled;
#line 212 "../core/Widgets/CircularProgressBar.vala"
	if (_tmp11_ == TRUE) {
#line 648 "CircularProgressBar.c"
		const gchar* _tmp12_;
		const gchar* _tmp13_;
		GdkRGBA _tmp14_;
#line 213 "../core/Widgets/CircularProgressBar.vala"
		cairo_arc (cr, (gdouble) center_x, (gdouble) center_y, (gdouble) delta, (gdouble) 0, 2 * G_PI);
#line 214 "../core/Widgets/CircularProgressBar.vala"
		_tmp12_ = _circularprogressbar_get_radius_fill_color (self);
#line 214 "../core/Widgets/CircularProgressBar.vala"
		_tmp13_ = _tmp12_;
#line 214 "../core/Widgets/CircularProgressBar.vala"
		gdk_rgba_parse (&color, _tmp13_);
#line 215 "../core/Widgets/CircularProgressBar.vala"
		_tmp14_ = color;
#line 215 "../core/Widgets/CircularProgressBar.vala"
		gdk_cairo_set_source_rgba (cr, &_tmp14_);
#line 216 "../core/Widgets/CircularProgressBar.vala"
		cairo_stroke (cr);
#line 666 "CircularProgressBar.c"
	}
#line 220 "../core/Widgets/CircularProgressBar.vala"
	_tmp15_ = _circularprogressbar_get_percentage (self);
#line 220 "../core/Widgets/CircularProgressBar.vala"
	_tmp16_ = _tmp15_;
#line 220 "../core/Widgets/CircularProgressBar.vala"
	if (_tmp16_ > ((gdouble) 0)) {
#line 674 "CircularProgressBar.c"
		const gchar* _tmp17_;
		const gchar* _tmp18_;
		GdkRGBA _tmp19_;
		gint _tmp20_;
		gint _tmp21_;
#line 221 "../core/Widgets/CircularProgressBar.vala"
		_tmp17_ = _circularprogressbar_get_progress_fill_color (self);
#line 221 "../core/Widgets/CircularProgressBar.vala"
		_tmp18_ = _tmp17_;
#line 221 "../core/Widgets/CircularProgressBar.vala"
		gdk_rgba_parse (&color, _tmp18_);
#line 222 "../core/Widgets/CircularProgressBar.vala"
		_tmp19_ = color;
#line 222 "../core/Widgets/CircularProgressBar.vala"
		gdk_cairo_set_source_rgba (cr, &_tmp19_);
#line 224 "../core/Widgets/CircularProgressBar.vala"
		_tmp20_ = _circularprogressbar_get_line_width (self);
#line 224 "../core/Widgets/CircularProgressBar.vala"
		_tmp21_ = _tmp20_;
#line 224 "../core/Widgets/CircularProgressBar.vala"
		if (_tmp21_ == 0) {
#line 696 "CircularProgressBar.c"
			gdouble _tmp22_;
			gdouble _tmp23_;
#line 225 "../core/Widgets/CircularProgressBar.vala"
			cairo_move_to (cr, (gdouble) center_x, (gdouble) center_y);
#line 226 "../core/Widgets/CircularProgressBar.vala"
			_tmp22_ = _circularprogressbar_get_percentage (self);
#line 226 "../core/Widgets/CircularProgressBar.vala"
			_tmp23_ = _tmp22_;
#line 226 "../core/Widgets/CircularProgressBar.vala"
			cairo_arc (cr, (gdouble) center_x, (gdouble) center_y, (gdouble) (delta + 1), 1.5 * G_PI, (1.5 + (_tmp23_ * 2)) * G_PI);
#line 231 "../core/Widgets/CircularProgressBar.vala"
			cairo_fill (cr);
#line 709 "CircularProgressBar.c"
		} else {
			gdouble _tmp24_;
			gdouble _tmp25_;
#line 233 "../core/Widgets/CircularProgressBar.vala"
			_tmp24_ = _circularprogressbar_get_percentage (self);
#line 233 "../core/Widgets/CircularProgressBar.vala"
			_tmp25_ = _tmp24_;
#line 233 "../core/Widgets/CircularProgressBar.vala"
			cairo_arc (cr, (gdouble) center_x, (gdouble) center_y, (gdouble) delta, 1.5 * G_PI, (1.5 + (_tmp25_ * 2)) * G_PI);
#line 238 "../core/Widgets/CircularProgressBar.vala"
			cairo_stroke (cr);
#line 721 "CircularProgressBar.c"
		}
	}
}

gint
_circularprogressbar_get_size (_CircularProgressBar* self)
{
	gint result;
#line 59 "../core/Widgets/CircularProgressBar.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 59 "../core/Widgets/CircularProgressBar.vala"
	result = self->priv->_size;
#line 59 "../core/Widgets/CircularProgressBar.vala"
	return result;
#line 736 "CircularProgressBar.c"
}

static void
_circularprogressbar_set_size (_CircularProgressBar* self,
                               gint value)
{
	gint old_value;
#line 59 "../core/Widgets/CircularProgressBar.vala"
	g_return_if_fail (self != NULL);
#line 59 "../core/Widgets/CircularProgressBar.vala"
	old_value = _circularprogressbar_get_size (self);
#line 59 "../core/Widgets/CircularProgressBar.vala"
	if (old_value != value) {
#line 59 "../core/Widgets/CircularProgressBar.vala"
		self->priv->_size = value;
#line 59 "../core/Widgets/CircularProgressBar.vala"
		g_object_notify_by_pspec ((GObject *) self, _circularprogressbar_properties[_CIRCULARPROGRESSBAR_SIZE_PROPERTY]);
#line 754 "CircularProgressBar.c"
	}
}

gboolean
_circularprogressbar_get_center_filled (_CircularProgressBar* self)
{
	gboolean result;
#line 68 "../core/Widgets/CircularProgressBar.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 68 "../core/Widgets/CircularProgressBar.vala"
	result = self->priv->_center_filled;
#line 68 "../core/Widgets/CircularProgressBar.vala"
	return result;
#line 768 "CircularProgressBar.c"
}

void
_circularprogressbar_set_center_filled (_CircularProgressBar* self,
                                        gboolean value)
{
	gboolean old_value;
#line 68 "../core/Widgets/CircularProgressBar.vala"
	g_return_if_fail (self != NULL);
#line 68 "../core/Widgets/CircularProgressBar.vala"
	old_value = _circularprogressbar_get_center_filled (self);
#line 68 "../core/Widgets/CircularProgressBar.vala"
	if (old_value != value) {
#line 68 "../core/Widgets/CircularProgressBar.vala"
		self->priv->_center_filled = value;
#line 68 "../core/Widgets/CircularProgressBar.vala"
		g_object_notify_by_pspec ((GObject *) self, _circularprogressbar_properties[_CIRCULARPROGRESSBAR_CENTER_FILLED_PROPERTY]);
#line 786 "CircularProgressBar.c"
	}
}

gboolean
_circularprogressbar_get_radius_filled (_CircularProgressBar* self)
{
	gboolean result;
#line 71 "../core/Widgets/CircularProgressBar.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 71 "../core/Widgets/CircularProgressBar.vala"
	result = self->priv->_radius_filled;
#line 71 "../core/Widgets/CircularProgressBar.vala"
	return result;
#line 800 "CircularProgressBar.c"
}

void
_circularprogressbar_set_radius_filled (_CircularProgressBar* self,
                                        gboolean value)
{
	gboolean old_value;
#line 71 "../core/Widgets/CircularProgressBar.vala"
	g_return_if_fail (self != NULL);
#line 71 "../core/Widgets/CircularProgressBar.vala"
	old_value = _circularprogressbar_get_radius_filled (self);
#line 71 "../core/Widgets/CircularProgressBar.vala"
	if (old_value != value) {
#line 71 "../core/Widgets/CircularProgressBar.vala"
		self->priv->_radius_filled = value;
#line 71 "../core/Widgets/CircularProgressBar.vala"
		g_object_notify_by_pspec ((GObject *) self, _circularprogressbar_properties[_CIRCULARPROGRESSBAR_RADIUS_FILLED_PROPERTY]);
#line 818 "CircularProgressBar.c"
	}
}

const gchar*
_circularprogressbar_get_font (_CircularProgressBar* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 74 "../core/Widgets/CircularProgressBar.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 74 "../core/Widgets/CircularProgressBar.vala"
	_tmp0_ = self->priv->_font;
#line 74 "../core/Widgets/CircularProgressBar.vala"
	result = _tmp0_;
#line 74 "../core/Widgets/CircularProgressBar.vala"
	return result;
#line 835 "CircularProgressBar.c"
}

void
_circularprogressbar_set_font (_CircularProgressBar* self,
                               const gchar* value)
{
	gchar* old_value;
#line 74 "../core/Widgets/CircularProgressBar.vala"
	g_return_if_fail (self != NULL);
#line 74 "../core/Widgets/CircularProgressBar.vala"
	old_value = _circularprogressbar_get_font (self);
#line 74 "../core/Widgets/CircularProgressBar.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 849 "CircularProgressBar.c"
		gchar* _tmp0_;
#line 74 "../core/Widgets/CircularProgressBar.vala"
		_tmp0_ = g_strdup (value);
#line 74 "../core/Widgets/CircularProgressBar.vala"
		_g_free0 (self->priv->_font);
#line 74 "../core/Widgets/CircularProgressBar.vala"
		self->priv->_font = _tmp0_;
#line 74 "../core/Widgets/CircularProgressBar.vala"
		g_object_notify_by_pspec ((GObject *) self, _circularprogressbar_properties[_CIRCULARPROGRESSBAR_FONT_PROPERTY]);
#line 859 "CircularProgressBar.c"
	}
}

cairo_line_cap_t
_circularprogressbar_get_line_cap (_CircularProgressBar* self)
{
	cairo_line_cap_t result;
#line 77 "../core/Widgets/CircularProgressBar.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 77 "../core/Widgets/CircularProgressBar.vala"
	result = self->priv->_line_cap;
#line 77 "../core/Widgets/CircularProgressBar.vala"
	return result;
#line 873 "CircularProgressBar.c"
}

void
_circularprogressbar_set_line_cap (_CircularProgressBar* self,
                                   cairo_line_cap_t value)
{
	cairo_line_cap_t old_value;
#line 77 "../core/Widgets/CircularProgressBar.vala"
	g_return_if_fail (self != NULL);
#line 77 "../core/Widgets/CircularProgressBar.vala"
	old_value = _circularprogressbar_get_line_cap (self);
#line 77 "../core/Widgets/CircularProgressBar.vala"
	if (old_value != value) {
#line 77 "../core/Widgets/CircularProgressBar.vala"
		self->priv->_line_cap = value;
#line 77 "../core/Widgets/CircularProgressBar.vala"
		g_object_notify_by_pspec ((GObject *) self, _circularprogressbar_properties[_CIRCULARPROGRESSBAR_LINE_CAP_PROPERTY]);
#line 891 "CircularProgressBar.c"
	}
}

const gchar*
_circularprogressbar_get_center_fill_color (_CircularProgressBar* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 81 "../core/Widgets/CircularProgressBar.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 82 "../core/Widgets/CircularProgressBar.vala"
	_tmp0_ = self->priv->_center_fill_color;
#line 82 "../core/Widgets/CircularProgressBar.vala"
	result = _tmp0_;
#line 82 "../core/Widgets/CircularProgressBar.vala"
	return result;
#line 908 "CircularProgressBar.c"
}

void
_circularprogressbar_set_center_fill_color (_CircularProgressBar* self,
                                            const gchar* value)
{
	GdkRGBA color = {0};
#line 84 "../core/Widgets/CircularProgressBar.vala"
	g_return_if_fail (self != NULL);
#line 85 "../core/Widgets/CircularProgressBar.vala"
	memset (&color, 0, sizeof (GdkRGBA));
#line 86 "../core/Widgets/CircularProgressBar.vala"
	if (gdk_rgba_parse (&color, value)) {
#line 922 "CircularProgressBar.c"
		gchar* _tmp0_;
#line 87 "../core/Widgets/CircularProgressBar.vala"
		_tmp0_ = g_strdup (value);
#line 87 "../core/Widgets/CircularProgressBar.vala"
		_g_free0 (self->priv->_center_fill_color);
#line 87 "../core/Widgets/CircularProgressBar.vala"
		self->priv->_center_fill_color = _tmp0_;
#line 930 "CircularProgressBar.c"
	}
#line 84 "../core/Widgets/CircularProgressBar.vala"
	g_object_notify_by_pspec ((GObject *) self, _circularprogressbar_properties[_CIRCULARPROGRESSBAR_CENTER_FILL_COLOR_PROPERTY]);
#line 934 "CircularProgressBar.c"
}

const gchar*
_circularprogressbar_get_radius_fill_color (_CircularProgressBar* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 94 "../core/Widgets/CircularProgressBar.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 95 "../core/Widgets/CircularProgressBar.vala"
	_tmp0_ = self->priv->_radius_fill_color;
#line 95 "../core/Widgets/CircularProgressBar.vala"
	result = _tmp0_;
#line 95 "../core/Widgets/CircularProgressBar.vala"
	return result;
#line 950 "CircularProgressBar.c"
}

void
_circularprogressbar_set_radius_fill_color (_CircularProgressBar* self,
                                            const gchar* value)
{
	GdkRGBA color = {0};
#line 97 "../core/Widgets/CircularProgressBar.vala"
	g_return_if_fail (self != NULL);
#line 98 "../core/Widgets/CircularProgressBar.vala"
	memset (&color, 0, sizeof (GdkRGBA));
#line 99 "../core/Widgets/CircularProgressBar.vala"
	if (gdk_rgba_parse (&color, value)) {
#line 964 "CircularProgressBar.c"
		gchar* _tmp0_;
#line 100 "../core/Widgets/CircularProgressBar.vala"
		_tmp0_ = g_strdup (value);
#line 100 "../core/Widgets/CircularProgressBar.vala"
		_g_free0 (self->priv->_radius_fill_color);
#line 100 "../core/Widgets/CircularProgressBar.vala"
		self->priv->_radius_fill_color = _tmp0_;
#line 972 "CircularProgressBar.c"
	}
#line 97 "../core/Widgets/CircularProgressBar.vala"
	g_object_notify_by_pspec ((GObject *) self, _circularprogressbar_properties[_CIRCULARPROGRESSBAR_RADIUS_FILL_COLOR_PROPERTY]);
#line 976 "CircularProgressBar.c"
}

const gchar*
_circularprogressbar_get_progress_fill_color (_CircularProgressBar* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 107 "../core/Widgets/CircularProgressBar.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 108 "../core/Widgets/CircularProgressBar.vala"
	_tmp0_ = self->priv->_progress_fill_color;
#line 108 "../core/Widgets/CircularProgressBar.vala"
	result = _tmp0_;
#line 108 "../core/Widgets/CircularProgressBar.vala"
	return result;
#line 992 "CircularProgressBar.c"
}

void
_circularprogressbar_set_progress_fill_color (_CircularProgressBar* self,
                                              const gchar* value)
{
	GdkRGBA color = {0};
#line 110 "../core/Widgets/CircularProgressBar.vala"
	g_return_if_fail (self != NULL);
#line 111 "../core/Widgets/CircularProgressBar.vala"
	memset (&color, 0, sizeof (GdkRGBA));
#line 112 "../core/Widgets/CircularProgressBar.vala"
	if (gdk_rgba_parse (&color, value)) {
#line 1006 "CircularProgressBar.c"
		gchar* _tmp0_;
#line 113 "../core/Widgets/CircularProgressBar.vala"
		_tmp0_ = g_strdup (value);
#line 113 "../core/Widgets/CircularProgressBar.vala"
		_g_free0 (self->priv->_progress_fill_color);
#line 113 "../core/Widgets/CircularProgressBar.vala"
		self->priv->_progress_fill_color = _tmp0_;
#line 1014 "CircularProgressBar.c"
	}
#line 110 "../core/Widgets/CircularProgressBar.vala"
	g_object_notify_by_pspec ((GObject *) self, _circularprogressbar_properties[_CIRCULARPROGRESSBAR_PROGRESS_FILL_COLOR_PROPERTY]);
#line 1018 "CircularProgressBar.c"
}

gint
_circularprogressbar_get_line_width (_CircularProgressBar* self)
{
	gint result;
#line 120 "../core/Widgets/CircularProgressBar.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 121 "../core/Widgets/CircularProgressBar.vala"
	result = self->priv->_line_width;
#line 121 "../core/Widgets/CircularProgressBar.vala"
	return result;
#line 1031 "CircularProgressBar.c"
}

void
_circularprogressbar_set_line_width (_CircularProgressBar* self,
                                     gint value)
{
#line 123 "../core/Widgets/CircularProgressBar.vala"
	g_return_if_fail (self != NULL);
#line 124 "../core/Widgets/CircularProgressBar.vala"
	if (value < 0) {
#line 125 "../core/Widgets/CircularProgressBar.vala"
		self->priv->_line_width = 0;
#line 1044 "CircularProgressBar.c"
	} else {
#line 126 "../core/Widgets/CircularProgressBar.vala"
		if (value > _circularprogressbar_calculate_radius (self)) {
#line 127 "../core/Widgets/CircularProgressBar.vala"
			self->priv->_line_width = _circularprogressbar_calculate_radius (self);
#line 1050 "CircularProgressBar.c"
		} else {
#line 129 "../core/Widgets/CircularProgressBar.vala"
			self->priv->_line_width = value;
#line 1054 "CircularProgressBar.c"
		}
	}
#line 123 "../core/Widgets/CircularProgressBar.vala"
	g_object_notify_by_pspec ((GObject *) self, _circularprogressbar_properties[_CIRCULARPROGRESSBAR_LINE_WIDTH_PROPERTY]);
#line 1059 "CircularProgressBar.c"
}

gdouble
_circularprogressbar_get_percentage (_CircularProgressBar* self)
{
	gdouble result;
#line 136 "../core/Widgets/CircularProgressBar.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 137 "../core/Widgets/CircularProgressBar.vala"
	result = self->priv->_percentage;
#line 137 "../core/Widgets/CircularProgressBar.vala"
	return result;
#line 1072 "CircularProgressBar.c"
}

void
_circularprogressbar_set_percentage (_CircularProgressBar* self,
                                     gdouble value)
{
#line 139 "../core/Widgets/CircularProgressBar.vala"
	g_return_if_fail (self != NULL);
#line 140 "../core/Widgets/CircularProgressBar.vala"
	if (value > 1.0) {
#line 141 "../core/Widgets/CircularProgressBar.vala"
		self->priv->_percentage = 1.0;
#line 1085 "CircularProgressBar.c"
	} else {
#line 142 "../core/Widgets/CircularProgressBar.vala"
		if (value < 0.0) {
#line 143 "../core/Widgets/CircularProgressBar.vala"
			self->priv->_percentage = 0.0;
#line 1091 "CircularProgressBar.c"
		} else {
#line 145 "../core/Widgets/CircularProgressBar.vala"
			self->priv->_percentage = value;
#line 1095 "CircularProgressBar.c"
		}
	}
#line 139 "../core/Widgets/CircularProgressBar.vala"
	g_object_notify_by_pspec ((GObject *) self, _circularprogressbar_properties[_CIRCULARPROGRESSBAR_PERCENTAGE_PROPERTY]);
#line 1100 "CircularProgressBar.c"
}

static GObject *
_circularprogressbar_constructor (GType type,
                                  guint n_construct_properties,
                                  GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	_CircularProgressBar * self;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
#line 150 "../core/Widgets/CircularProgressBar.vala"
	parent_class = G_OBJECT_CLASS (_circularprogressbar_parent_class);
#line 150 "../core/Widgets/CircularProgressBar.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 150 "../core/Widgets/CircularProgressBar.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE__CIRCULARPROGRESSBAR, _CircularProgressBar);
#line 151 "../core/Widgets/CircularProgressBar.vala"
	self->priv->_line_width = 0;
#line 152 "../core/Widgets/CircularProgressBar.vala"
	self->priv->_percentage = (gdouble) 0;
#line 153 "../core/Widgets/CircularProgressBar.vala"
	_tmp0_ = g_strdup ("#adadad");
#line 153 "../core/Widgets/CircularProgressBar.vala"
	_g_free0 (self->priv->_center_fill_color);
#line 153 "../core/Widgets/CircularProgressBar.vala"
	self->priv->_center_fill_color = _tmp0_;
#line 154 "../core/Widgets/CircularProgressBar.vala"
	_tmp1_ = g_strdup ("#d3d3d3");
#line 154 "../core/Widgets/CircularProgressBar.vala"
	_g_free0 (self->priv->_radius_fill_color);
#line 154 "../core/Widgets/CircularProgressBar.vala"
	self->priv->_radius_fill_color = _tmp1_;
#line 155 "../core/Widgets/CircularProgressBar.vala"
	_tmp2_ = g_strdup ("#4a90d9");
#line 155 "../core/Widgets/CircularProgressBar.vala"
	_g_free0 (self->priv->_progress_fill_color);
#line 155 "../core/Widgets/CircularProgressBar.vala"
	self->priv->_progress_fill_color = _tmp2_;
#line 150 "../core/Widgets/CircularProgressBar.vala"
	return obj;
#line 1144 "CircularProgressBar.c"
}

static void
_circularprogressbar_class_init (_CircularProgressBarClass * klass,
                                 gpointer klass_data)
{
#line 58 "../core/Widgets/CircularProgressBar.vala"
	_circularprogressbar_parent_class = g_type_class_peek_parent (klass);
#line 58 "../core/Widgets/CircularProgressBar.vala"
	g_type_class_adjust_private_offset (klass, &_CircularProgressBar_private_offset);
#line 58 "../core/Widgets/CircularProgressBar.vala"
	((GtkWidgetClass *) klass)->get_request_mode = (GtkSizeRequestMode (*) (GtkWidget*)) _circularprogressbar_real_get_request_mode;
#line 58 "../core/Widgets/CircularProgressBar.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala__circularprogressbar_get_property;
#line 58 "../core/Widgets/CircularProgressBar.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala__circularprogressbar_set_property;
#line 58 "../core/Widgets/CircularProgressBar.vala"
	G_OBJECT_CLASS (klass)->constructor = _circularprogressbar_constructor;
#line 58 "../core/Widgets/CircularProgressBar.vala"
	G_OBJECT_CLASS (klass)->finalize = _circularprogressbar_finalize;
#line 58 "../core/Widgets/CircularProgressBar.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), _CIRCULARPROGRESSBAR_SIZE_PROPERTY, _circularprogressbar_properties[_CIRCULARPROGRESSBAR_SIZE_PROPERTY] = g_param_spec_int ("size", "size", "size", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 58 "../core/Widgets/CircularProgressBar.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), _CIRCULARPROGRESSBAR_CENTER_FILLED_PROPERTY, _circularprogressbar_properties[_CIRCULARPROGRESSBAR_CENTER_FILLED_PROPERTY] = g_param_spec_boolean ("center-filled", "Center Fill", "Center Fill toggle", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 58 "../core/Widgets/CircularProgressBar.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), _CIRCULARPROGRESSBAR_RADIUS_FILLED_PROPERTY, _circularprogressbar_properties[_CIRCULARPROGRESSBAR_RADIUS_FILLED_PROPERTY] = g_param_spec_boolean ("radius-filled", "Radius Fill", "Radius Fill toggle", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 58 "../core/Widgets/CircularProgressBar.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), _CIRCULARPROGRESSBAR_FONT_PROPERTY, _circularprogressbar_properties[_CIRCULARPROGRESSBAR_FONT_PROPERTY] = g_param_spec_string ("font", "Font", "Font description without size, just the font name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 58 "../core/Widgets/CircularProgressBar.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), _CIRCULARPROGRESSBAR_LINE_CAP_PROPERTY, _circularprogressbar_properties[_CIRCULARPROGRESSBAR_LINE_CAP_PROPERTY] = g_param_spec_enum ("line-cap", "Line Cap", "Line Cap for stroke as in Cairo.LineCap", cairo_gobject_line_cap_get_type (), CAIRO_LINE_CAP_BUTT, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 58 "../core/Widgets/CircularProgressBar.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), _CIRCULARPROGRESSBAR_CENTER_FILL_COLOR_PROPERTY, _circularprogressbar_properties[_CIRCULARPROGRESSBAR_CENTER_FILL_COLOR_PROPERTY] = g_param_spec_string ("center-fill-color", "Inside circle fill color", "Center pad fill color (Check Gdk.RGBA parse method)", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 58 "../core/Widgets/CircularProgressBar.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), _CIRCULARPROGRESSBAR_RADIUS_FILL_COLOR_PROPERTY, _circularprogressbar_properties[_CIRCULARPROGRESSBAR_RADIUS_FILL_COLOR_PROPERTY] = g_param_spec_string ("radius-fill-color", "Circular radius fill color", "The circular pad fill color (Check GdkRGBA parse method)", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 58 "../core/Widgets/CircularProgressBar.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), _CIRCULARPROGRESSBAR_PROGRESS_FILL_COLOR_PROPERTY, _circularprogressbar_properties[_CIRCULARPROGRESSBAR_PROGRESS_FILL_COLOR_PROPERTY] = g_param_spec_string ("progress-fill-color", "Progress fill color", "Progress line color (Check GdkRGBA parse method)", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 58 "../core/Widgets/CircularProgressBar.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), _CIRCULARPROGRESSBAR_LINE_WIDTH_PROPERTY, _circularprogressbar_properties[_CIRCULARPROGRESSBAR_LINE_WIDTH_PROPERTY] = g_param_spec_int ("line-width", "Circle width", "The circle radius line width", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 58 "../core/Widgets/CircularProgressBar.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), _CIRCULARPROGRESSBAR_PERCENTAGE_PROPERTY, _circularprogressbar_properties[_CIRCULARPROGRESSBAR_PERCENTAGE_PROPERTY] = g_param_spec_double ("percentage", "Percentage/Value", "The percentage value [0.0 ... 1.0]", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 1185 "CircularProgressBar.c"
}

static void
_circularprogressbar_instance_init (_CircularProgressBar * self,
                                    gpointer klass)
{
	gchar* _tmp0_;
#line 58 "../core/Widgets/CircularProgressBar.vala"
	self->priv = _circularprogressbar_get_instance_private (self);
#line 68 "../core/Widgets/CircularProgressBar.vala"
	self->priv->_center_filled = FALSE;
#line 71 "../core/Widgets/CircularProgressBar.vala"
	self->priv->_radius_filled = FALSE;
#line 74 "../core/Widgets/CircularProgressBar.vala"
	_tmp0_ = g_strdup ("URW Gothic");
#line 74 "../core/Widgets/CircularProgressBar.vala"
	self->priv->_font = _tmp0_;
#line 77 "../core/Widgets/CircularProgressBar.vala"
	self->priv->_line_cap = CAIRO_LINE_CAP_BUTT;
#line 1205 "CircularProgressBar.c"
}

static void
_circularprogressbar_finalize (GObject * obj)
{
	_CircularProgressBar * self;
#line 58 "../core/Widgets/CircularProgressBar.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE__CIRCULARPROGRESSBAR, _CircularProgressBar);
#line 63 "../core/Widgets/CircularProgressBar.vala"
	_g_free0 (self->priv->_center_fill_color);
#line 64 "../core/Widgets/CircularProgressBar.vala"
	_g_free0 (self->priv->_radius_fill_color);
#line 65 "../core/Widgets/CircularProgressBar.vala"
	_g_free0 (self->priv->_progress_fill_color);
#line 74 "../core/Widgets/CircularProgressBar.vala"
	_g_free0 (self->priv->_font);
#line 58 "../core/Widgets/CircularProgressBar.vala"
	G_OBJECT_CLASS (_circularprogressbar_parent_class)->finalize (obj);
#line 1224 "CircularProgressBar.c"
}

static GType
_circularprogressbar_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (_CircularProgressBarClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) _circularprogressbar_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (_CircularProgressBar), 0, (GInstanceInitFunc) _circularprogressbar_instance_init, NULL };
	GType _circularprogressbar_type_id;
	_circularprogressbar_type_id = g_type_register_static (gtk_drawing_area_get_type (), "_CircularProgressBar", &g_define_type_info, 0);
	_CircularProgressBar_private_offset = g_type_add_instance_private (_circularprogressbar_type_id, sizeof (_CircularProgressBarPrivate));
	return _circularprogressbar_type_id;
}

GType
_circularprogressbar_get_type (void)
{
	static volatile gsize _circularprogressbar_type_id__once = 0;
	if (g_once_init_enter (&_circularprogressbar_type_id__once)) {
		GType _circularprogressbar_type_id;
		_circularprogressbar_type_id = _circularprogressbar_get_type_once ();
		g_once_init_leave (&_circularprogressbar_type_id__once, _circularprogressbar_type_id);
	}
	return _circularprogressbar_type_id__once;
}

static void
_vala__circularprogressbar_get_property (GObject * object,
                                         guint property_id,
                                         GValue * value,
                                         GParamSpec * pspec)
{
	_CircularProgressBar * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE__CIRCULARPROGRESSBAR, _CircularProgressBar);
#line 58 "../core/Widgets/CircularProgressBar.vala"
	switch (property_id) {
#line 58 "../core/Widgets/CircularProgressBar.vala"
		case _CIRCULARPROGRESSBAR_SIZE_PROPERTY:
#line 58 "../core/Widgets/CircularProgressBar.vala"
		g_value_set_int (value, _circularprogressbar_get_size (self));
#line 58 "../core/Widgets/CircularProgressBar.vala"
		break;
#line 58 "../core/Widgets/CircularProgressBar.vala"
		case _CIRCULARPROGRESSBAR_CENTER_FILLED_PROPERTY:
#line 58 "../core/Widgets/CircularProgressBar.vala"
		g_value_set_boolean (value, _circularprogressbar_get_center_filled (self));
#line 58 "../core/Widgets/CircularProgressBar.vala"
		break;
#line 58 "../core/Widgets/CircularProgressBar.vala"
		case _CIRCULARPROGRESSBAR_RADIUS_FILLED_PROPERTY:
#line 58 "../core/Widgets/CircularProgressBar.vala"
		g_value_set_boolean (value, _circularprogressbar_get_radius_filled (self));
#line 58 "../core/Widgets/CircularProgressBar.vala"
		break;
#line 58 "../core/Widgets/CircularProgressBar.vala"
		case _CIRCULARPROGRESSBAR_FONT_PROPERTY:
#line 58 "../core/Widgets/CircularProgressBar.vala"
		g_value_set_string (value, _circularprogressbar_get_font (self));
#line 58 "../core/Widgets/CircularProgressBar.vala"
		break;
#line 58 "../core/Widgets/CircularProgressBar.vala"
		case _CIRCULARPROGRESSBAR_LINE_CAP_PROPERTY:
#line 58 "../core/Widgets/CircularProgressBar.vala"
		g_value_set_enum (value, _circularprogressbar_get_line_cap (self));
#line 58 "../core/Widgets/CircularProgressBar.vala"
		break;
#line 58 "../core/Widgets/CircularProgressBar.vala"
		case _CIRCULARPROGRESSBAR_CENTER_FILL_COLOR_PROPERTY:
#line 58 "../core/Widgets/CircularProgressBar.vala"
		g_value_set_string (value, _circularprogressbar_get_center_fill_color (self));
#line 58 "../core/Widgets/CircularProgressBar.vala"
		break;
#line 58 "../core/Widgets/CircularProgressBar.vala"
		case _CIRCULARPROGRESSBAR_RADIUS_FILL_COLOR_PROPERTY:
#line 58 "../core/Widgets/CircularProgressBar.vala"
		g_value_set_string (value, _circularprogressbar_get_radius_fill_color (self));
#line 58 "../core/Widgets/CircularProgressBar.vala"
		break;
#line 58 "../core/Widgets/CircularProgressBar.vala"
		case _CIRCULARPROGRESSBAR_PROGRESS_FILL_COLOR_PROPERTY:
#line 58 "../core/Widgets/CircularProgressBar.vala"
		g_value_set_string (value, _circularprogressbar_get_progress_fill_color (self));
#line 58 "../core/Widgets/CircularProgressBar.vala"
		break;
#line 58 "../core/Widgets/CircularProgressBar.vala"
		case _CIRCULARPROGRESSBAR_LINE_WIDTH_PROPERTY:
#line 58 "../core/Widgets/CircularProgressBar.vala"
		g_value_set_int (value, _circularprogressbar_get_line_width (self));
#line 58 "../core/Widgets/CircularProgressBar.vala"
		break;
#line 58 "../core/Widgets/CircularProgressBar.vala"
		case _CIRCULARPROGRESSBAR_PERCENTAGE_PROPERTY:
#line 58 "../core/Widgets/CircularProgressBar.vala"
		g_value_set_double (value, _circularprogressbar_get_percentage (self));
#line 58 "../core/Widgets/CircularProgressBar.vala"
		break;
#line 1319 "CircularProgressBar.c"
		default:
#line 58 "../core/Widgets/CircularProgressBar.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 58 "../core/Widgets/CircularProgressBar.vala"
		break;
#line 1325 "CircularProgressBar.c"
	}
}

static void
_vala__circularprogressbar_set_property (GObject * object,
                                         guint property_id,
                                         const GValue * value,
                                         GParamSpec * pspec)
{
	_CircularProgressBar * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE__CIRCULARPROGRESSBAR, _CircularProgressBar);
#line 58 "../core/Widgets/CircularProgressBar.vala"
	switch (property_id) {
#line 58 "../core/Widgets/CircularProgressBar.vala"
		case _CIRCULARPROGRESSBAR_SIZE_PROPERTY:
#line 58 "../core/Widgets/CircularProgressBar.vala"
		_circularprogressbar_set_size (self, g_value_get_int (value));
#line 58 "../core/Widgets/CircularProgressBar.vala"
		break;
#line 58 "../core/Widgets/CircularProgressBar.vala"
		case _CIRCULARPROGRESSBAR_CENTER_FILLED_PROPERTY:
#line 58 "../core/Widgets/CircularProgressBar.vala"
		_circularprogressbar_set_center_filled (self, g_value_get_boolean (value));
#line 58 "../core/Widgets/CircularProgressBar.vala"
		break;
#line 58 "../core/Widgets/CircularProgressBar.vala"
		case _CIRCULARPROGRESSBAR_RADIUS_FILLED_PROPERTY:
#line 58 "../core/Widgets/CircularProgressBar.vala"
		_circularprogressbar_set_radius_filled (self, g_value_get_boolean (value));
#line 58 "../core/Widgets/CircularProgressBar.vala"
		break;
#line 58 "../core/Widgets/CircularProgressBar.vala"
		case _CIRCULARPROGRESSBAR_FONT_PROPERTY:
#line 58 "../core/Widgets/CircularProgressBar.vala"
		_circularprogressbar_set_font (self, g_value_get_string (value));
#line 58 "../core/Widgets/CircularProgressBar.vala"
		break;
#line 58 "../core/Widgets/CircularProgressBar.vala"
		case _CIRCULARPROGRESSBAR_LINE_CAP_PROPERTY:
#line 58 "../core/Widgets/CircularProgressBar.vala"
		_circularprogressbar_set_line_cap (self, g_value_get_enum (value));
#line 58 "../core/Widgets/CircularProgressBar.vala"
		break;
#line 58 "../core/Widgets/CircularProgressBar.vala"
		case _CIRCULARPROGRESSBAR_CENTER_FILL_COLOR_PROPERTY:
#line 58 "../core/Widgets/CircularProgressBar.vala"
		_circularprogressbar_set_center_fill_color (self, g_value_get_string (value));
#line 58 "../core/Widgets/CircularProgressBar.vala"
		break;
#line 58 "../core/Widgets/CircularProgressBar.vala"
		case _CIRCULARPROGRESSBAR_RADIUS_FILL_COLOR_PROPERTY:
#line 58 "../core/Widgets/CircularProgressBar.vala"
		_circularprogressbar_set_radius_fill_color (self, g_value_get_string (value));
#line 58 "../core/Widgets/CircularProgressBar.vala"
		break;
#line 58 "../core/Widgets/CircularProgressBar.vala"
		case _CIRCULARPROGRESSBAR_PROGRESS_FILL_COLOR_PROPERTY:
#line 58 "../core/Widgets/CircularProgressBar.vala"
		_circularprogressbar_set_progress_fill_color (self, g_value_get_string (value));
#line 58 "../core/Widgets/CircularProgressBar.vala"
		break;
#line 58 "../core/Widgets/CircularProgressBar.vala"
		case _CIRCULARPROGRESSBAR_LINE_WIDTH_PROPERTY:
#line 58 "../core/Widgets/CircularProgressBar.vala"
		_circularprogressbar_set_line_width (self, g_value_get_int (value));
#line 58 "../core/Widgets/CircularProgressBar.vala"
		break;
#line 58 "../core/Widgets/CircularProgressBar.vala"
		case _CIRCULARPROGRESSBAR_PERCENTAGE_PROPERTY:
#line 58 "../core/Widgets/CircularProgressBar.vala"
		_circularprogressbar_set_percentage (self, g_value_get_double (value));
#line 58 "../core/Widgets/CircularProgressBar.vala"
		break;
#line 1399 "CircularProgressBar.c"
		default:
#line 58 "../core/Widgets/CircularProgressBar.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 58 "../core/Widgets/CircularProgressBar.vala"
		break;
#line 1405 "CircularProgressBar.c"
	}
}

