/* LoadingButton.c generated by valac 0.56.18, the Vala compiler
 * generated from LoadingButton.vala, do not modify */

/*
* Copyright © 2023 Alain M. (https://github.com/alainm23/planify)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 3 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*
* Authored by: Alain M. <alainmh23@gmail.com>
*/

#include "planify.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gtk/gtk.h>
#include <glib-object.h>
#include <adwaita.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	WIDGETS_LOADING_BUTTON_0_PROPERTY,
	WIDGETS_LOADING_BUTTON_TEXT_ICON_PROPERTY,
	WIDGETS_LOADING_BUTTON_LOADING_TYPE_PROPERTY,
	WIDGETS_LOADING_BUTTON_ICON_SIZE_PROPERTY,
	WIDGETS_LOADING_BUTTON_IS_LOADING_PROPERTY,
	WIDGETS_LOADING_BUTTON_NUM_PROPERTIES
};
static GParamSpec* widgets_loading_button_properties[WIDGETS_LOADING_BUTTON_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _WidgetsLoadingButtonPrivate {
	gchar* _text_icon;
	LoadingButtonType _loading_type;
	gint _icon_size;
	gboolean _is_loading;
	GtkStack* submit_stack;
	GtkImage* icon;
};

static gint WidgetsLoadingButton_private_offset;
static gpointer widgets_loading_button_parent_class = NULL;

static GObject * widgets_loading_button_constructor (GType type,
                                              guint n_construct_properties,
                                              GObjectConstructParam * construct_properties);
static void widgets_loading_button_finalize (GObject * obj);
static GType widgets_loading_button_get_type_once (void);
static void _vala_widgets_loading_button_get_property (GObject * object,
                                                guint property_id,
                                                GValue * value,
                                                GParamSpec * pspec);
static void _vala_widgets_loading_button_set_property (GObject * object,
                                                guint property_id,
                                                const GValue * value,
                                                GParamSpec * pspec);

static inline gpointer
widgets_loading_button_get_instance_private (WidgetsLoadingButton* self)
{
	return G_STRUCT_MEMBER_P (self, WidgetsLoadingButton_private_offset);
}

WidgetsLoadingButton*
widgets_loading_button_construct (GType object_type,
                                  LoadingButtonType loading_type,
                                  const gchar* text_icon)
{
	WidgetsLoadingButton * self = NULL;
#line 48 "../core/Widgets/LoadingButton.vala"
	g_return_val_if_fail (text_icon != NULL, NULL);
#line 49 "../core/Widgets/LoadingButton.vala"
	self = (WidgetsLoadingButton*) g_object_new (object_type, "loading-type", loading_type, "text-icon", text_icon, NULL);
#line 48 "../core/Widgets/LoadingButton.vala"
	return self;
#line 99 "LoadingButton.c"
}

WidgetsLoadingButton*
widgets_loading_button_new (LoadingButtonType loading_type,
                            const gchar* text_icon)
{
#line 48 "../core/Widgets/LoadingButton.vala"
	return widgets_loading_button_construct (WIDGETS_TYPE_LOADING_BUTTON, loading_type, text_icon);
#line 108 "LoadingButton.c"
}

WidgetsLoadingButton*
widgets_loading_button_construct_with_label (GType object_type,
                                             const gchar* label)
{
	WidgetsLoadingButton * self = NULL;
#line 55 "../core/Widgets/LoadingButton.vala"
	g_return_val_if_fail (label != NULL, NULL);
#line 56 "../core/Widgets/LoadingButton.vala"
	self = (WidgetsLoadingButton*) g_object_new (object_type, "loading-type", LOADING_BUTTON_TYPE_LABEL, "text-icon", label, "icon-size", 16, NULL);
#line 55 "../core/Widgets/LoadingButton.vala"
	return self;
#line 122 "LoadingButton.c"
}

WidgetsLoadingButton*
widgets_loading_button_new_with_label (const gchar* label)
{
#line 55 "../core/Widgets/LoadingButton.vala"
	return widgets_loading_button_construct_with_label (WIDGETS_TYPE_LOADING_BUTTON, label);
#line 130 "LoadingButton.c"
}

WidgetsLoadingButton*
widgets_loading_button_construct_with_icon (GType object_type,
                                            const gchar* icon_name,
                                            gint icon_size)
{
	WidgetsLoadingButton * self = NULL;
#line 63 "../core/Widgets/LoadingButton.vala"
	g_return_val_if_fail (icon_name != NULL, NULL);
#line 64 "../core/Widgets/LoadingButton.vala"
	self = (WidgetsLoadingButton*) g_object_new (object_type, "loading-type", LOADING_BUTTON_TYPE_ICON, "text-icon", icon_name, "icon-size", icon_size, NULL);
#line 63 "../core/Widgets/LoadingButton.vala"
	return self;
#line 145 "LoadingButton.c"
}

WidgetsLoadingButton*
widgets_loading_button_new_with_icon (const gchar* icon_name,
                                      gint icon_size)
{
#line 63 "../core/Widgets/LoadingButton.vala"
	return widgets_loading_button_construct_with_icon (WIDGETS_TYPE_LOADING_BUTTON, icon_name, icon_size);
#line 154 "LoadingButton.c"
}

void
widgets_loading_button_update_icon (WidgetsLoadingButton* self,
                                    const gchar* icon_name)
{
	GtkImage* _tmp0_;
#line 95 "../core/Widgets/LoadingButton.vala"
	g_return_if_fail (self != NULL);
#line 95 "../core/Widgets/LoadingButton.vala"
	g_return_if_fail (icon_name != NULL);
#line 96 "../core/Widgets/LoadingButton.vala"
	_tmp0_ = self->priv->icon;
#line 96 "../core/Widgets/LoadingButton.vala"
	if (_tmp0_ != NULL) {
#line 170 "LoadingButton.c"
		GtkImage* _tmp1_;
#line 97 "../core/Widgets/LoadingButton.vala"
		_tmp1_ = self->priv->icon;
#line 97 "../core/Widgets/LoadingButton.vala"
		g_object_set (_tmp1_, "icon-name", icon_name, NULL);
#line 176 "LoadingButton.c"
	}
}

const gchar*
widgets_loading_button_get_text_icon (WidgetsLoadingButton* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 23 "../core/Widgets/LoadingButton.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 23 "../core/Widgets/LoadingButton.vala"
	_tmp0_ = self->priv->_text_icon;
#line 23 "../core/Widgets/LoadingButton.vala"
	result = _tmp0_;
#line 23 "../core/Widgets/LoadingButton.vala"
	return result;
#line 193 "LoadingButton.c"
}

static void
widgets_loading_button_set_text_icon (WidgetsLoadingButton* self,
                                      const gchar* value)
{
	gchar* old_value;
#line 23 "../core/Widgets/LoadingButton.vala"
	g_return_if_fail (self != NULL);
#line 23 "../core/Widgets/LoadingButton.vala"
	old_value = widgets_loading_button_get_text_icon (self);
#line 23 "../core/Widgets/LoadingButton.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 207 "LoadingButton.c"
		gchar* _tmp0_;
#line 23 "../core/Widgets/LoadingButton.vala"
		_tmp0_ = g_strdup (value);
#line 23 "../core/Widgets/LoadingButton.vala"
		_g_free0 (self->priv->_text_icon);
#line 23 "../core/Widgets/LoadingButton.vala"
		self->priv->_text_icon = _tmp0_;
#line 23 "../core/Widgets/LoadingButton.vala"
		g_object_notify_by_pspec ((GObject *) self, widgets_loading_button_properties[WIDGETS_LOADING_BUTTON_TEXT_ICON_PROPERTY]);
#line 217 "LoadingButton.c"
	}
}

LoadingButtonType
widgets_loading_button_get_loading_type (WidgetsLoadingButton* self)
{
	LoadingButtonType result;
#line 24 "../core/Widgets/LoadingButton.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 24 "../core/Widgets/LoadingButton.vala"
	result = self->priv->_loading_type;
#line 24 "../core/Widgets/LoadingButton.vala"
	return result;
#line 231 "LoadingButton.c"
}

static void
widgets_loading_button_set_loading_type (WidgetsLoadingButton* self,
                                         LoadingButtonType value)
{
	LoadingButtonType old_value;
#line 24 "../core/Widgets/LoadingButton.vala"
	g_return_if_fail (self != NULL);
#line 24 "../core/Widgets/LoadingButton.vala"
	old_value = widgets_loading_button_get_loading_type (self);
#line 24 "../core/Widgets/LoadingButton.vala"
	if (old_value != value) {
#line 24 "../core/Widgets/LoadingButton.vala"
		self->priv->_loading_type = value;
#line 24 "../core/Widgets/LoadingButton.vala"
		g_object_notify_by_pspec ((GObject *) self, widgets_loading_button_properties[WIDGETS_LOADING_BUTTON_LOADING_TYPE_PROPERTY]);
#line 249 "LoadingButton.c"
	}
}

gint
widgets_loading_button_get_icon_size (WidgetsLoadingButton* self)
{
	gint result;
#line 25 "../core/Widgets/LoadingButton.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 25 "../core/Widgets/LoadingButton.vala"
	result = self->priv->_icon_size;
#line 25 "../core/Widgets/LoadingButton.vala"
	return result;
#line 263 "LoadingButton.c"
}

static void
widgets_loading_button_set_icon_size (WidgetsLoadingButton* self,
                                      gint value)
{
	gint old_value;
#line 25 "../core/Widgets/LoadingButton.vala"
	g_return_if_fail (self != NULL);
#line 25 "../core/Widgets/LoadingButton.vala"
	old_value = widgets_loading_button_get_icon_size (self);
#line 25 "../core/Widgets/LoadingButton.vala"
	if (old_value != value) {
#line 25 "../core/Widgets/LoadingButton.vala"
		self->priv->_icon_size = value;
#line 25 "../core/Widgets/LoadingButton.vala"
		g_object_notify_by_pspec ((GObject *) self, widgets_loading_button_properties[WIDGETS_LOADING_BUTTON_ICON_SIZE_PROPERTY]);
#line 281 "LoadingButton.c"
	}
}

gboolean
widgets_loading_button_get_is_loading (WidgetsLoadingButton* self)
{
	gboolean result;
#line 33 "../core/Widgets/LoadingButton.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 34 "../core/Widgets/LoadingButton.vala"
	result = self->priv->_is_loading;
#line 34 "../core/Widgets/LoadingButton.vala"
	return result;
#line 295 "LoadingButton.c"
}

void
widgets_loading_button_set_is_loading (WidgetsLoadingButton* self,
                                       gboolean value)
{
#line 37 "../core/Widgets/LoadingButton.vala"
	g_return_if_fail (self != NULL);
#line 38 "../core/Widgets/LoadingButton.vala"
	if (value) {
#line 306 "LoadingButton.c"
		GtkStack* _tmp0_;
#line 39 "../core/Widgets/LoadingButton.vala"
		_tmp0_ = self->priv->submit_stack;
#line 39 "../core/Widgets/LoadingButton.vala"
		gtk_stack_set_visible_child_name (_tmp0_, "spinner");
#line 312 "LoadingButton.c"
	} else {
		GtkStack* _tmp1_;
#line 41 "../core/Widgets/LoadingButton.vala"
		_tmp1_ = self->priv->submit_stack;
#line 41 "../core/Widgets/LoadingButton.vala"
		gtk_stack_set_visible_child_name (_tmp1_, "button");
#line 319 "LoadingButton.c"
	}
#line 44 "../core/Widgets/LoadingButton.vala"
	self->priv->_is_loading = value;
#line 37 "../core/Widgets/LoadingButton.vala"
	g_object_notify_by_pspec ((GObject *) self, widgets_loading_button_properties[WIDGETS_LOADING_BUTTON_IS_LOADING_PROPERTY]);
#line 325 "LoadingButton.c"
}

static GObject *
widgets_loading_button_constructor (GType type,
                                    guint n_construct_properties,
                                    GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	WidgetsLoadingButton * self;
	AdwSpinner* submit_spinner = NULL;
	AdwSpinner* _tmp0_ = NULL;
	GtkStack* _tmp1_ = NULL;
	LoadingButtonType _tmp2_;
	GtkStack* _tmp14_;
	AdwSpinner* _tmp15_;
	GtkStack* _tmp16_;
#line 71 "../core/Widgets/LoadingButton.vala"
	parent_class = G_OBJECT_CLASS (widgets_loading_button_parent_class);
#line 71 "../core/Widgets/LoadingButton.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 71 "../core/Widgets/LoadingButton.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, WIDGETS_TYPE_LOADING_BUTTON, WidgetsLoadingButton);
#line 72 "../core/Widgets/LoadingButton.vala"
	_tmp0_ = (AdwSpinner*) adw_spinner_new ();
#line 72 "../core/Widgets/LoadingButton.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp0_, GTK_ALIGN_CENTER);
#line 72 "../core/Widgets/LoadingButton.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp0_, GTK_ALIGN_CENTER);
#line 72 "../core/Widgets/LoadingButton.vala"
	g_object_ref_sink (_tmp0_);
#line 72 "../core/Widgets/LoadingButton.vala"
	submit_spinner = _tmp0_;
#line 77 "../core/Widgets/LoadingButton.vala"
	_tmp1_ = (GtkStack*) gtk_stack_new ();
#line 77 "../core/Widgets/LoadingButton.vala"
	gtk_stack_set_transition_type (_tmp1_, GTK_STACK_TRANSITION_TYPE_CROSSFADE);
#line 77 "../core/Widgets/LoadingButton.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp1_, GTK_ALIGN_CENTER);
#line 77 "../core/Widgets/LoadingButton.vala"
	g_object_ref_sink (_tmp1_);
#line 77 "../core/Widgets/LoadingButton.vala"
	_g_object_unref0 (self->priv->submit_stack);
#line 77 "../core/Widgets/LoadingButton.vala"
	self->priv->submit_stack = _tmp1_;
#line 82 "../core/Widgets/LoadingButton.vala"
	_tmp2_ = self->priv->_loading_type;
#line 82 "../core/Widgets/LoadingButton.vala"
	if (_tmp2_ == LOADING_BUTTON_TYPE_LABEL) {
#line 375 "LoadingButton.c"
		GtkStack* _tmp3_;
		const gchar* _tmp4_;
		GtkLabel* _tmp5_;
		GtkLabel* _tmp6_;
#line 83 "../core/Widgets/LoadingButton.vala"
		_tmp3_ = self->priv->submit_stack;
#line 83 "../core/Widgets/LoadingButton.vala"
		_tmp4_ = self->priv->_text_icon;
#line 83 "../core/Widgets/LoadingButton.vala"
		_tmp5_ = (GtkLabel*) gtk_label_new (_tmp4_);
#line 83 "../core/Widgets/LoadingButton.vala"
		g_object_ref_sink (_tmp5_);
#line 83 "../core/Widgets/LoadingButton.vala"
		_tmp6_ = _tmp5_;
#line 83 "../core/Widgets/LoadingButton.vala"
		gtk_stack_add_named (_tmp3_, (GtkWidget*) _tmp6_, "button");
#line 83 "../core/Widgets/LoadingButton.vala"
		_g_object_unref0 (_tmp6_);
#line 394 "LoadingButton.c"
	} else {
		GtkImage* _tmp7_;
		GtkImage* _tmp8_;
		gint _tmp9_;
		GtkImage* _tmp10_;
		const gchar* _tmp11_;
		GtkStack* _tmp12_;
		GtkImage* _tmp13_;
#line 85 "../core/Widgets/LoadingButton.vala"
		_tmp7_ = (GtkImage*) gtk_image_new ();
#line 85 "../core/Widgets/LoadingButton.vala"
		g_object_ref_sink (_tmp7_);
#line 85 "../core/Widgets/LoadingButton.vala"
		_g_object_unref0 (self->priv->icon);
#line 85 "../core/Widgets/LoadingButton.vala"
		self->priv->icon = _tmp7_;
#line 86 "../core/Widgets/LoadingButton.vala"
		_tmp8_ = self->priv->icon;
#line 86 "../core/Widgets/LoadingButton.vala"
		_tmp9_ = self->priv->_icon_size;
#line 86 "../core/Widgets/LoadingButton.vala"
		gtk_image_set_pixel_size (_tmp8_, _tmp9_);
#line 87 "../core/Widgets/LoadingButton.vala"
		_tmp10_ = self->priv->icon;
#line 87 "../core/Widgets/LoadingButton.vala"
		_tmp11_ = self->priv->_text_icon;
#line 87 "../core/Widgets/LoadingButton.vala"
		g_object_set (_tmp10_, "icon-name", _tmp11_, NULL);
#line 88 "../core/Widgets/LoadingButton.vala"
		_tmp12_ = self->priv->submit_stack;
#line 88 "../core/Widgets/LoadingButton.vala"
		_tmp13_ = self->priv->icon;
#line 88 "../core/Widgets/LoadingButton.vala"
		gtk_stack_add_named (_tmp12_, (GtkWidget*) _tmp13_, "button");
#line 429 "LoadingButton.c"
	}
#line 91 "../core/Widgets/LoadingButton.vala"
	_tmp14_ = self->priv->submit_stack;
#line 91 "../core/Widgets/LoadingButton.vala"
	_tmp15_ = submit_spinner;
#line 91 "../core/Widgets/LoadingButton.vala"
	gtk_stack_add_named (_tmp14_, (GtkWidget*) _tmp15_, "spinner");
#line 92 "../core/Widgets/LoadingButton.vala"
	_tmp16_ = self->priv->submit_stack;
#line 92 "../core/Widgets/LoadingButton.vala"
	gtk_button_set_child ((GtkButton*) self, (GtkWidget*) _tmp16_);
#line 71 "../core/Widgets/LoadingButton.vala"
	_g_object_unref0 (submit_spinner);
#line 71 "../core/Widgets/LoadingButton.vala"
	return obj;
#line 445 "LoadingButton.c"
}

static void
widgets_loading_button_class_init (WidgetsLoadingButtonClass * klass,
                                   gpointer klass_data)
{
#line 22 "../core/Widgets/LoadingButton.vala"
	widgets_loading_button_parent_class = g_type_class_peek_parent (klass);
#line 22 "../core/Widgets/LoadingButton.vala"
	g_type_class_adjust_private_offset (klass, &WidgetsLoadingButton_private_offset);
#line 22 "../core/Widgets/LoadingButton.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_widgets_loading_button_get_property;
#line 22 "../core/Widgets/LoadingButton.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_widgets_loading_button_set_property;
#line 22 "../core/Widgets/LoadingButton.vala"
	G_OBJECT_CLASS (klass)->constructor = widgets_loading_button_constructor;
#line 22 "../core/Widgets/LoadingButton.vala"
	G_OBJECT_CLASS (klass)->finalize = widgets_loading_button_finalize;
#line 22 "../core/Widgets/LoadingButton.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), WIDGETS_LOADING_BUTTON_TEXT_ICON_PROPERTY, widgets_loading_button_properties[WIDGETS_LOADING_BUTTON_TEXT_ICON_PROPERTY] = g_param_spec_string ("text-icon", "text-icon", "text-icon", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 22 "../core/Widgets/LoadingButton.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), WIDGETS_LOADING_BUTTON_LOADING_TYPE_PROPERTY, widgets_loading_button_properties[WIDGETS_LOADING_BUTTON_LOADING_TYPE_PROPERTY] = g_param_spec_enum ("loading-type", "loading-type", "loading-type", TYPE_LOADING_BUTTON_TYPE, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 22 "../core/Widgets/LoadingButton.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), WIDGETS_LOADING_BUTTON_ICON_SIZE_PROPERTY, widgets_loading_button_properties[WIDGETS_LOADING_BUTTON_ICON_SIZE_PROPERTY] = g_param_spec_int ("icon-size", "icon-size", "icon-size", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 22 "../core/Widgets/LoadingButton.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), WIDGETS_LOADING_BUTTON_IS_LOADING_PROPERTY, widgets_loading_button_properties[WIDGETS_LOADING_BUTTON_IS_LOADING_PROPERTY] = g_param_spec_boolean ("is-loading", "Show loading", "Show loading", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 472 "LoadingButton.c"
}

static void
widgets_loading_button_instance_init (WidgetsLoadingButton * self,
                                      gpointer klass)
{
#line 22 "../core/Widgets/LoadingButton.vala"
	self->priv = widgets_loading_button_get_instance_private (self);
#line 481 "LoadingButton.c"
}

static void
widgets_loading_button_finalize (GObject * obj)
{
	WidgetsLoadingButton * self;
#line 22 "../core/Widgets/LoadingButton.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, WIDGETS_TYPE_LOADING_BUTTON, WidgetsLoadingButton);
#line 23 "../core/Widgets/LoadingButton.vala"
	_g_free0 (self->priv->_text_icon);
#line 28 "../core/Widgets/LoadingButton.vala"
	_g_object_unref0 (self->priv->submit_stack);
#line 29 "../core/Widgets/LoadingButton.vala"
	_g_object_unref0 (self->priv->icon);
#line 22 "../core/Widgets/LoadingButton.vala"
	G_OBJECT_CLASS (widgets_loading_button_parent_class)->finalize (obj);
#line 498 "LoadingButton.c"
}

static GType
widgets_loading_button_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (WidgetsLoadingButtonClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) widgets_loading_button_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (WidgetsLoadingButton), 0, (GInstanceInitFunc) widgets_loading_button_instance_init, NULL };
	GType widgets_loading_button_type_id;
	widgets_loading_button_type_id = g_type_register_static (gtk_button_get_type (), "WidgetsLoadingButton", &g_define_type_info, 0);
	WidgetsLoadingButton_private_offset = g_type_add_instance_private (widgets_loading_button_type_id, sizeof (WidgetsLoadingButtonPrivate));
	return widgets_loading_button_type_id;
}

GType
widgets_loading_button_get_type (void)
{
	static volatile gsize widgets_loading_button_type_id__once = 0;
	if (g_once_init_enter (&widgets_loading_button_type_id__once)) {
		GType widgets_loading_button_type_id;
		widgets_loading_button_type_id = widgets_loading_button_get_type_once ();
		g_once_init_leave (&widgets_loading_button_type_id__once, widgets_loading_button_type_id);
	}
	return widgets_loading_button_type_id__once;
}

static void
_vala_widgets_loading_button_get_property (GObject * object,
                                           guint property_id,
                                           GValue * value,
                                           GParamSpec * pspec)
{
	WidgetsLoadingButton * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, WIDGETS_TYPE_LOADING_BUTTON, WidgetsLoadingButton);
#line 22 "../core/Widgets/LoadingButton.vala"
	switch (property_id) {
#line 22 "../core/Widgets/LoadingButton.vala"
		case WIDGETS_LOADING_BUTTON_TEXT_ICON_PROPERTY:
#line 22 "../core/Widgets/LoadingButton.vala"
		g_value_set_string (value, widgets_loading_button_get_text_icon (self));
#line 22 "../core/Widgets/LoadingButton.vala"
		break;
#line 22 "../core/Widgets/LoadingButton.vala"
		case WIDGETS_LOADING_BUTTON_LOADING_TYPE_PROPERTY:
#line 22 "../core/Widgets/LoadingButton.vala"
		g_value_set_enum (value, widgets_loading_button_get_loading_type (self));
#line 22 "../core/Widgets/LoadingButton.vala"
		break;
#line 22 "../core/Widgets/LoadingButton.vala"
		case WIDGETS_LOADING_BUTTON_ICON_SIZE_PROPERTY:
#line 22 "../core/Widgets/LoadingButton.vala"
		g_value_set_int (value, widgets_loading_button_get_icon_size (self));
#line 22 "../core/Widgets/LoadingButton.vala"
		break;
#line 22 "../core/Widgets/LoadingButton.vala"
		case WIDGETS_LOADING_BUTTON_IS_LOADING_PROPERTY:
#line 22 "../core/Widgets/LoadingButton.vala"
		g_value_set_boolean (value, widgets_loading_button_get_is_loading (self));
#line 22 "../core/Widgets/LoadingButton.vala"
		break;
#line 557 "LoadingButton.c"
		default:
#line 22 "../core/Widgets/LoadingButton.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 22 "../core/Widgets/LoadingButton.vala"
		break;
#line 563 "LoadingButton.c"
	}
}

static void
_vala_widgets_loading_button_set_property (GObject * object,
                                           guint property_id,
                                           const GValue * value,
                                           GParamSpec * pspec)
{
	WidgetsLoadingButton * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, WIDGETS_TYPE_LOADING_BUTTON, WidgetsLoadingButton);
#line 22 "../core/Widgets/LoadingButton.vala"
	switch (property_id) {
#line 22 "../core/Widgets/LoadingButton.vala"
		case WIDGETS_LOADING_BUTTON_TEXT_ICON_PROPERTY:
#line 22 "../core/Widgets/LoadingButton.vala"
		widgets_loading_button_set_text_icon (self, g_value_get_string (value));
#line 22 "../core/Widgets/LoadingButton.vala"
		break;
#line 22 "../core/Widgets/LoadingButton.vala"
		case WIDGETS_LOADING_BUTTON_LOADING_TYPE_PROPERTY:
#line 22 "../core/Widgets/LoadingButton.vala"
		widgets_loading_button_set_loading_type (self, g_value_get_enum (value));
#line 22 "../core/Widgets/LoadingButton.vala"
		break;
#line 22 "../core/Widgets/LoadingButton.vala"
		case WIDGETS_LOADING_BUTTON_ICON_SIZE_PROPERTY:
#line 22 "../core/Widgets/LoadingButton.vala"
		widgets_loading_button_set_icon_size (self, g_value_get_int (value));
#line 22 "../core/Widgets/LoadingButton.vala"
		break;
#line 22 "../core/Widgets/LoadingButton.vala"
		case WIDGETS_LOADING_BUTTON_IS_LOADING_PROPERTY:
#line 22 "../core/Widgets/LoadingButton.vala"
		widgets_loading_button_set_is_loading (self, g_value_get_boolean (value));
#line 22 "../core/Widgets/LoadingButton.vala"
		break;
#line 601 "LoadingButton.c"
		default:
#line 22 "../core/Widgets/LoadingButton.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 22 "../core/Widgets/LoadingButton.vala"
		break;
#line 607 "LoadingButton.c"
	}
}

