/* Project.c generated by valac 0.56.18, the Vala compiler
 * generated from Project.vala, do not modify */

/*
* Copyright © 2023 Alain M. (https://github.com/alainm23/planify)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 3 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*
* Authored by: Alain M. <alainmh23@gmail.com>
*/

#include <adwaita.h>
#include <glib-object.h>
#include "planify.h"
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <gtk/gtk.h>
#include <gee.h>
#include <glib/gi18n-lib.h>
#include <gio/gio.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define DIALOGS_TYPE_PROJECT (dialogs_project_get_type ())
#define DIALOGS_PROJECT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DIALOGS_TYPE_PROJECT, DialogsProject))
#define DIALOGS_PROJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DIALOGS_TYPE_PROJECT, DialogsProjectClass))
#define DIALOGS_IS_PROJECT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DIALOGS_TYPE_PROJECT))
#define DIALOGS_IS_PROJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DIALOGS_TYPE_PROJECT))
#define DIALOGS_PROJECT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DIALOGS_TYPE_PROJECT, DialogsProjectClass))

typedef struct _DialogsProject DialogsProject;
typedef struct _DialogsProjectClass DialogsProjectClass;
typedef struct _DialogsProjectPrivate DialogsProjectPrivate;

#define WIDGETS_TYPE_COLOR_PICKER_ROW (widgets_color_picker_row_get_type ())
#define WIDGETS_COLOR_PICKER_ROW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), WIDGETS_TYPE_COLOR_PICKER_ROW, WidgetsColorPickerRow))
#define WIDGETS_COLOR_PICKER_ROW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), WIDGETS_TYPE_COLOR_PICKER_ROW, WidgetsColorPickerRowClass))
#define WIDGETS_IS_COLOR_PICKER_ROW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), WIDGETS_TYPE_COLOR_PICKER_ROW))
#define WIDGETS_IS_COLOR_PICKER_ROW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), WIDGETS_TYPE_COLOR_PICKER_ROW))
#define WIDGETS_COLOR_PICKER_ROW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), WIDGETS_TYPE_COLOR_PICKER_ROW, WidgetsColorPickerRowClass))

typedef struct _WidgetsColorPickerRow WidgetsColorPickerRow;
typedef struct _WidgetsColorPickerRowClass WidgetsColorPickerRowClass;
enum  {
	DIALOGS_PROJECT_0_PROPERTY,
	DIALOGS_PROJECT_PROJECT_PROPERTY,
	DIALOGS_PROJECT_BACKEND_PICKER_PROPERTY,
	DIALOGS_PROJECT_HEADER_TITLE_PROPERTY,
	DIALOGS_PROJECT_IS_CREATING_PROPERTY,
	DIALOGS_PROJECT_NUM_PROPERTIES
};
static GParamSpec* dialogs_project_properties[DIALOGS_PROJECT_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _Block61Data Block61Data;
typedef struct _Block62Data Block62Data;
#define _http_response_unref0(var) ((var == NULL) ? NULL : (var = (http_response_unref (var), NULL)))
typedef struct _DialogsProjectUpdateProjectData DialogsProjectUpdateProjectData;
typedef struct _Block63Data Block63Data;

struct _DialogsProject {
	AdwDialog parent_instance;
	DialogsProjectPrivate * priv;
};

struct _DialogsProjectClass {
	AdwDialogClass parent_class;
};

struct _DialogsProjectPrivate {
	ObjectsProject* _project;
	gboolean _backend_picker;
	gchar* _header_title;
	GtkStack* emoji_color_stack;
	WidgetsCircularProgressBar* progress_bar;
	AdwEntryRow* name_entry;
	WidgetsColorPickerRow* color_picker_row;
	WidgetsLoadingButton* submit_button;
	GtkSwitch* emoji_switch;
	GtkLabel* emoji_label;
	GtkLabel* source_selected_label;
	AdwNavigationView* navigation_view;
	AdwNavigationPage* sources_page;
	GeeHashMap* signal_map;
};

struct _Block61Data {
	int _ref_count_;
	DialogsProject* self;
	GtkEmojiChooser* emoji_chooser;
	GtkRevealer* color_box_revealer;
};

struct _Block62Data {
	int _ref_count_;
	DialogsProject* self;
	ObjectsSource* source;
};

struct _DialogsProjectUpdateProjectData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	DialogsProject* self;
	ObjectsProject* _tmp0_;
	SourceType _tmp1_;
	SourceType _tmp2_;
	ServicesStore* _tmp3_;
	ObjectsProject* _tmp4_;
	HttpResponse* response;
	ObjectsProject* _tmp5_;
	SourceType _tmp6_;
	SourceType _tmp7_;
	ServicesTodoist* _tmp8_;
	ServicesTodoist* _tmp9_;
	ObjectsProject* _tmp10_;
	HttpResponse* _tmp11_;
	ServicesCalDAVCore* _tmp12_;
	ServicesCalDAVCore* _tmp13_;
	ObjectsProject* _tmp14_;
	HttpResponse* _tmp15_;
	HttpResponse* _tmp16_;
	HttpResponse* _tmp17_;
	gboolean _tmp18_;
	gboolean _tmp19_;
	ServicesStore* _tmp20_;
	ObjectsProject* _tmp21_;
	ServicesEventBus* _tmp22_;
	ServicesEventBus* _tmp23_;
	HttpResponse* _tmp24_;
	gint _tmp25_;
	gint _tmp26_;
	HttpResponse* _tmp27_;
	const gchar* _tmp28_;
	const gchar* _tmp29_;
};

struct _Block63Data {
	int _ref_count_;
	DialogsProject* self;
	gchar* id;
};

static gint DialogsProject_private_offset;
static gpointer dialogs_project_parent_class = NULL;

VALA_EXTERN GType dialogs_project_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DialogsProject, g_object_unref)
VALA_EXTERN GType widgets_color_picker_row_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (WidgetsColorPickerRow, g_object_unref)
VALA_EXTERN DialogsProject* dialogs_project_new_new (const gchar* source_id,
                                         gboolean backend_picker,
                                         const gchar* parent_id);
VALA_EXTERN DialogsProject* dialogs_project_construct_new (GType object_type,
                                               const gchar* source_id,
                                               gboolean backend_picker,
                                               const gchar* parent_id);
VALA_EXTERN DialogsProject* dialogs_project_new (ObjectsProject* project);
VALA_EXTERN DialogsProject* dialogs_project_construct (GType object_type,
                                           ObjectsProject* project);
static AdwNavigationPage* dialogs_project_get_main_page (DialogsProject* self);
static Block61Data* block61_data_ref (Block61Data* _data61_);
static void block61_data_unref (void * _userdata_);
VALA_EXTERN ObjectsProject* dialogs_project_get_project (DialogsProject* self);
VALA_EXTERN gboolean dialogs_project_get_backend_picker (DialogsProject* self);
VALA_EXTERN WidgetsColorPickerRow* widgets_color_picker_row_new (void);
VALA_EXTERN WidgetsColorPickerRow* widgets_color_picker_row_construct (GType object_type);
VALA_EXTERN gboolean dialogs_project_get_is_creating (DialogsProject* self);
VALA_EXTERN const gchar* dialogs_project_get_header_title (DialogsProject* self);
static gboolean __lambda30_ (DialogsProject* self);
VALA_EXTERN void widgets_color_picker_row_set_color (WidgetsColorPickerRow* self,
                                         const gchar* value);
static gboolean ___lambda30__gsource_func (gpointer self);
static void dialogs_project_add_update_project (DialogsProject* self);
static void _dialogs_project_add_update_project_adw_entry_row_entry_activated (AdwEntryRow* _sender,
                                                                        gpointer self);
static void _dialogs_project_add_update_project_gtk_button_clicked (GtkButton* _sender,
                                                             gpointer self);
static void __lambda34_ (DialogsProject* self,
                  const gchar* emoji);
static void ___lambda34__gtk_emoji_chooser_emoji_picked (GtkEmojiChooser* _sender,
                                                  const gchar* text,
                                                  gpointer self);
static void __lambda35_ (Block61Data* _data61_);
static void ___lambda35__g_object_notify (GObject* _sender,
                                   GParamSpec* pspec,
                                   gpointer self);
static void __lambda36_ (DialogsProject* self);
VALA_EXTERN const gchar* widgets_color_picker_row_get_color (WidgetsColorPickerRow* self);
static void ___lambda36__widgets_color_picker_row_color_changed (WidgetsColorPickerRow* _sender,
                                                          const gchar* color,
                                                          gpointer self);
static void __lambda37_ (Block61Data* _data61_);
static void ___lambda37__gtk_button_clicked (GtkButton* _sender,
                                      gpointer self);
static void __lambda38_ (DialogsProject* self);
static void ___lambda38__adw_action_row_activated (AdwActionRow* _sender,
                                            gpointer self);
static AdwNavigationPage* dialogs_project_get_sources_page (DialogsProject* self);
static Block62Data* block62_data_ref (Block62Data* _data62_);
static void block62_data_unref (void * _userdata_);
static void ____lambda39_ (Block62Data* _data62_);
static void _____lambda39__adw_action_row_activated (AdwActionRow* _sender,
                                              gpointer self);
static void ____lambda40_ (Block62Data* _data62_);
static void _____lambda40__gtk_check_button_toggled (GtkCheckButton* _sender,
                                              gpointer self);
VALA_EXTERN void dialogs_project_hide_destroy (DialogsProject* self);
static void dialogs_project_update_project (DialogsProject* self,
                                     GAsyncReadyCallback _callback_,
                                     gpointer _user_data_);
static void dialogs_project_update_project_finish (DialogsProject* self,
                                            GAsyncResult* _res_);
static void dialogs_project_add_project (DialogsProject* self);
static void dialogs_project_update_project_data_free (gpointer _data);
static gboolean dialogs_project_update_project_co (DialogsProjectUpdateProjectData* _data_);
static void dialogs_project_update_project_ready (GObject* source_object,
                                           GAsyncResult* _res_,
                                           gpointer _user_data_);
VALA_EXTERN void dialogs_project_go_project (DialogsProject* self,
                                 const gchar* id);
static void ____lambda32_ (DialogsProject* self,
                    GObject* obj,
                    GAsyncResult* res);
static void _____lambda32__gasync_ready_callback (GObject* source_object,
                                           GAsyncResult* res,
                                           gpointer self);
static void _____lambda33_ (DialogsProject* self,
                     GObject* obj,
                     GAsyncResult* res);
static void ______lambda33__gasync_ready_callback (GObject* source_object,
                                            GAsyncResult* res,
                                            gpointer self);
static Block63Data* block63_data_ref (Block63Data* _data63_);
static void block63_data_unref (void * _userdata_);
static gboolean __lambda31_ (Block63Data* _data63_);
static gboolean ___lambda31__gsource_func (gpointer self);
static void dialogs_project_set_project (DialogsProject* self,
                                  ObjectsProject* value);
static void dialogs_project_set_backend_picker (DialogsProject* self,
                                         gboolean value);
static void dialogs_project_set_header_title (DialogsProject* self,
                                       const gchar* value);
static GObject * dialogs_project_constructor (GType type,
                                       guint n_construct_properties,
                                       GObjectConstructParam * construct_properties);
static void _dialogs_project___lambda41_ (DialogsProject* self);
static void __dialogs_project___lambda41__adw_dialog_closed (AdwDialog* _sender,
                                                      gpointer self);
static void dialogs_project_finalize (GObject * obj);
static GType dialogs_project_get_type_once (void);
static void _vala_dialogs_project_get_property (GObject * object,
                                         guint property_id,
                                         GValue * value,
                                         GParamSpec * pspec);
static void _vala_dialogs_project_set_property (GObject * object,
                                         guint property_id,
                                         const GValue * value,
                                         GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

static inline gpointer
dialogs_project_get_instance_private (DialogsProject* self)
{
	return G_STRUCT_MEMBER_P (self, DialogsProject_private_offset);
}

DialogsProject*
dialogs_project_construct_new (GType object_type,
                               const gchar* source_id,
                               gboolean backend_picker,
                               const gchar* parent_id)
{
	DialogsProject * self = NULL;
	ObjectsProject* project = NULL;
	ObjectsProject* _tmp0_;
	ObjectsProject* _tmp1_;
	ObjectsProject* _tmp2_;
	ObjectsProject* _tmp3_;
	ObjectsProject* _tmp4_;
	ObjectsProject* _tmp5_;
	gchar* _tmp6_ = NULL;
	ObjectsProject* _tmp7_;
	const gchar* _tmp8_;
	const gchar* _tmp9_;
	ObjectsProject* _tmp19_;
#line 47 "../src/Dialogs/Project.vala"
	g_return_val_if_fail (source_id != NULL, NULL);
#line 47 "../src/Dialogs/Project.vala"
	g_return_val_if_fail (parent_id != NULL, NULL);
#line 48 "../src/Dialogs/Project.vala"
	_tmp0_ = objects_project_new ();
#line 48 "../src/Dialogs/Project.vala"
	project = _tmp0_;
#line 49 "../src/Dialogs/Project.vala"
	_tmp1_ = project;
#line 49 "../src/Dialogs/Project.vala"
	objects_project_set_color (_tmp1_, "blue");
#line 50 "../src/Dialogs/Project.vala"
	_tmp2_ = project;
#line 50 "../src/Dialogs/Project.vala"
	objects_project_set_emoji (_tmp2_, "🚀️");
#line 51 "../src/Dialogs/Project.vala"
	_tmp3_ = project;
#line 51 "../src/Dialogs/Project.vala"
	objects_base_object_set_id ((ObjectsBaseObject*) _tmp3_, "");
#line 52 "../src/Dialogs/Project.vala"
	_tmp4_ = project;
#line 52 "../src/Dialogs/Project.vala"
	objects_project_set_parent_id (_tmp4_, parent_id);
#line 53 "../src/Dialogs/Project.vala"
	_tmp5_ = project;
#line 53 "../src/Dialogs/Project.vala"
	objects_project_set_source_id (_tmp5_, source_id);
#line 58 "../src/Dialogs/Project.vala"
	_tmp7_ = project;
#line 58 "../src/Dialogs/Project.vala"
	_tmp8_ = objects_project_get_parent_id (_tmp7_);
#line 58 "../src/Dialogs/Project.vala"
	_tmp9_ = _tmp8_;
#line 58 "../src/Dialogs/Project.vala"
	if (g_strcmp0 (_tmp9_, "") == 0) {
#line 360 "Project.c"
		gchar* _tmp10_;
#line 58 "../src/Dialogs/Project.vala"
		_tmp10_ = g_strdup (_ ("New Project"));
#line 58 "../src/Dialogs/Project.vala"
		_g_free0 (_tmp6_);
#line 58 "../src/Dialogs/Project.vala"
		_tmp6_ = _tmp10_;
#line 368 "Project.c"
	} else {
		ObjectsProject* _tmp11_;
		ObjectsProject* _tmp12_;
		ObjectsProject* _tmp13_;
		const gchar* _tmp14_;
		const gchar* _tmp15_;
		gchar* _tmp16_;
		gchar* _tmp17_;
		gchar* _tmp18_;
#line 58 "../src/Dialogs/Project.vala"
		_tmp11_ = project;
#line 58 "../src/Dialogs/Project.vala"
		_tmp12_ = objects_project_get_parent (_tmp11_);
#line 58 "../src/Dialogs/Project.vala"
		_tmp13_ = _tmp12_;
#line 58 "../src/Dialogs/Project.vala"
		_tmp14_ = objects_base_object_get_name ((ObjectsBaseObject*) _tmp13_);
#line 58 "../src/Dialogs/Project.vala"
		_tmp15_ = _tmp14_;
#line 58 "../src/Dialogs/Project.vala"
		_tmp16_ = g_strconcat (_tmp15_, " → ", NULL);
#line 58 "../src/Dialogs/Project.vala"
		_tmp17_ = _tmp16_;
#line 58 "../src/Dialogs/Project.vala"
		_tmp18_ = g_strconcat (_tmp17_, _ ("New Project"), NULL);
#line 58 "../src/Dialogs/Project.vala"
		_g_free0 (_tmp6_);
#line 58 "../src/Dialogs/Project.vala"
		_tmp6_ = _tmp18_;
#line 58 "../src/Dialogs/Project.vala"
		_g_free0 (_tmp17_);
#line 400 "Project.c"
	}
#line 55 "../src/Dialogs/Project.vala"
	_tmp19_ = project;
#line 55 "../src/Dialogs/Project.vala"
	self = (DialogsProject*) g_object_new (object_type, "project", _tmp19_, "backend-picker", backend_picker, "header-title", _tmp6_, NULL);
#line 47 "../src/Dialogs/Project.vala"
	_g_free0 (_tmp6_);
#line 47 "../src/Dialogs/Project.vala"
	_g_object_unref0 (project);
#line 47 "../src/Dialogs/Project.vala"
	return self;
#line 412 "Project.c"
}

DialogsProject*
dialogs_project_new_new (const gchar* source_id,
                         gboolean backend_picker,
                         const gchar* parent_id)
{
#line 47 "../src/Dialogs/Project.vala"
	return dialogs_project_construct_new (DIALOGS_TYPE_PROJECT, source_id, backend_picker, parent_id);
#line 422 "Project.c"
}

DialogsProject*
dialogs_project_construct (GType object_type,
                           ObjectsProject* project)
{
	DialogsProject * self = NULL;
#line 62 "../src/Dialogs/Project.vala"
	g_return_val_if_fail (project != NULL, NULL);
#line 63 "../src/Dialogs/Project.vala"
	self = (DialogsProject*) g_object_new (object_type, "project", project, "backend-picker", FALSE, "header-title", _ ("Edit Project"), NULL);
#line 62 "../src/Dialogs/Project.vala"
	return self;
#line 436 "Project.c"
}

DialogsProject*
dialogs_project_new (ObjectsProject* project)
{
#line 62 "../src/Dialogs/Project.vala"
	return dialogs_project_construct (DIALOGS_TYPE_PROJECT, project);
#line 444 "Project.c"
}

static Block61Data*
block61_data_ref (Block61Data* _data61_)
{
#line 95 "../src/Dialogs/Project.vala"
	g_atomic_int_inc (&_data61_->_ref_count_);
#line 95 "../src/Dialogs/Project.vala"
	return _data61_;
#line 454 "Project.c"
}

static void
block61_data_unref (void * _userdata_)
{
	Block61Data* _data61_;
	_data61_ = (Block61Data*) _userdata_;
#line 95 "../src/Dialogs/Project.vala"
	if (g_atomic_int_dec_and_test (&_data61_->_ref_count_)) {
#line 464 "Project.c"
		DialogsProject* self;
#line 95 "../src/Dialogs/Project.vala"
		self = _data61_->self;
#line 95 "../src/Dialogs/Project.vala"
		_g_object_unref0 (_data61_->color_box_revealer);
#line 95 "../src/Dialogs/Project.vala"
		_g_object_unref0 (_data61_->emoji_chooser);
#line 95 "../src/Dialogs/Project.vala"
		_g_object_unref0 (self);
#line 95 "../src/Dialogs/Project.vala"
		g_slice_free (Block61Data, _data61_);
#line 476 "Project.c"
	}
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 114 "../src/Dialogs/Project.vala"
	return self ? g_object_ref (self) : NULL;
#line 485 "Project.c"
}

static gboolean
__lambda30_ (DialogsProject* self)
{
	WidgetsCircularProgressBar* _tmp0_;
	ObjectsProject* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	WidgetsColorPickerRow* _tmp4_;
	ObjectsProject* _tmp5_;
	const gchar* _tmp6_;
	const gchar* _tmp7_;
	gboolean _tmp8_;
	gboolean _tmp9_;
	gboolean result;
#line 246 "../src/Dialogs/Project.vala"
	_tmp0_ = self->priv->progress_bar;
#line 246 "../src/Dialogs/Project.vala"
	_tmp1_ = self->priv->_project;
#line 246 "../src/Dialogs/Project.vala"
	_tmp2_ = objects_project_get_color (_tmp1_);
#line 246 "../src/Dialogs/Project.vala"
	_tmp3_ = _tmp2_;
#line 246 "../src/Dialogs/Project.vala"
	widgets_circular_progress_bar_set_color (_tmp0_, _tmp3_);
#line 247 "../src/Dialogs/Project.vala"
	_tmp4_ = self->priv->color_picker_row;
#line 247 "../src/Dialogs/Project.vala"
	_tmp5_ = self->priv->_project;
#line 247 "../src/Dialogs/Project.vala"
	_tmp6_ = objects_project_get_color (_tmp5_);
#line 247 "../src/Dialogs/Project.vala"
	_tmp7_ = _tmp6_;
#line 247 "../src/Dialogs/Project.vala"
	widgets_color_picker_row_set_color (_tmp4_, _tmp7_);
#line 249 "../src/Dialogs/Project.vala"
	_tmp8_ = dialogs_project_get_is_creating (self);
#line 249 "../src/Dialogs/Project.vala"
	_tmp9_ = _tmp8_;
#line 249 "../src/Dialogs/Project.vala"
	if (_tmp9_) {
#line 528 "Project.c"
		AdwEntryRow* _tmp10_;
#line 250 "../src/Dialogs/Project.vala"
		_tmp10_ = self->priv->name_entry;
#line 250 "../src/Dialogs/Project.vala"
		gtk_widget_grab_focus ((GtkWidget*) _tmp10_);
#line 534 "Project.c"
	}
#line 253 "../src/Dialogs/Project.vala"
	result = G_SOURCE_REMOVE;
#line 253 "../src/Dialogs/Project.vala"
	return result;
#line 540 "Project.c"
}

static gboolean
___lambda30__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda30_ ((DialogsProject*) self);
#line 245 "../src/Dialogs/Project.vala"
	return result;
#line 550 "Project.c"
}

static void
_dialogs_project_add_update_project_adw_entry_row_entry_activated (AdwEntryRow* _sender,
                                                                   gpointer self)
{
#line 256 "../src/Dialogs/Project.vala"
	dialogs_project_add_update_project ((DialogsProject*) self);
#line 559 "Project.c"
}

static void
_dialogs_project_add_update_project_gtk_button_clicked (GtkButton* _sender,
                                                        gpointer self)
{
#line 257 "../src/Dialogs/Project.vala"
	dialogs_project_add_update_project ((DialogsProject*) self);
#line 568 "Project.c"
}

static void
__lambda34_ (DialogsProject* self,
             const gchar* emoji)
{
	GtkLabel* _tmp0_;
#line 259 "../src/Dialogs/Project.vala"
	g_return_if_fail (emoji != NULL);
#line 260 "../src/Dialogs/Project.vala"
	_tmp0_ = self->priv->emoji_label;
#line 260 "../src/Dialogs/Project.vala"
	gtk_label_set_label (_tmp0_, emoji);
#line 582 "Project.c"
}

static void
___lambda34__gtk_emoji_chooser_emoji_picked (GtkEmojiChooser* _sender,
                                             const gchar* text,
                                             gpointer self)
{
#line 259 "../src/Dialogs/Project.vala"
	__lambda34_ ((DialogsProject*) self, text);
#line 592 "Project.c"
}

static gchar*
string_strip (const gchar* self)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* result;
#line 1413 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1414 "glib-2.0.vapi"
	_tmp0_ = g_strdup (self);
#line 1414 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1415 "glib-2.0.vapi"
	g_strstrip (_result_);
#line 1416 "glib-2.0.vapi"
	result = _result_;
#line 1416 "glib-2.0.vapi"
	return result;
#line 613 "Project.c"
}

static void
__lambda35_ (Block61Data* _data61_)
{
	DialogsProject* self;
	GtkSwitch* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 263 "../src/Dialogs/Project.vala"
	self = _data61_->self;
#line 264 "../src/Dialogs/Project.vala"
	_tmp0_ = self->priv->emoji_switch;
#line 264 "../src/Dialogs/Project.vala"
	_tmp1_ = gtk_switch_get_active (_tmp0_);
#line 264 "../src/Dialogs/Project.vala"
	_tmp2_ = _tmp1_;
#line 264 "../src/Dialogs/Project.vala"
	if (_tmp2_) {
#line 633 "Project.c"
		GtkRevealer* _tmp3_;
		GtkStack* _tmp4_;
		GtkLabel* _tmp5_;
		const gchar* _tmp6_;
		const gchar* _tmp7_;
		gchar* _tmp8_;
		gchar* _tmp9_;
		gboolean _tmp10_;
		GtkEmojiChooser* _tmp12_;
#line 265 "../src/Dialogs/Project.vala"
		_tmp3_ = _data61_->color_box_revealer;
#line 265 "../src/Dialogs/Project.vala"
		gtk_revealer_set_reveal_child (_tmp3_, FALSE);
#line 266 "../src/Dialogs/Project.vala"
		_tmp4_ = self->priv->emoji_color_stack;
#line 266 "../src/Dialogs/Project.vala"
		gtk_stack_set_visible_child_name (_tmp4_, "emoji");
#line 268 "../src/Dialogs/Project.vala"
		_tmp5_ = self->priv->emoji_label;
#line 268 "../src/Dialogs/Project.vala"
		_tmp6_ = gtk_label_get_label (_tmp5_);
#line 268 "../src/Dialogs/Project.vala"
		_tmp7_ = _tmp6_;
#line 268 "../src/Dialogs/Project.vala"
		_tmp8_ = string_strip (_tmp7_);
#line 268 "../src/Dialogs/Project.vala"
		_tmp9_ = _tmp8_;
#line 268 "../src/Dialogs/Project.vala"
		_tmp10_ = g_strcmp0 (_tmp9_, "") == 0;
#line 268 "../src/Dialogs/Project.vala"
		_g_free0 (_tmp9_);
#line 268 "../src/Dialogs/Project.vala"
		if (_tmp10_) {
#line 667 "Project.c"
			GtkLabel* _tmp11_;
#line 269 "../src/Dialogs/Project.vala"
			_tmp11_ = self->priv->emoji_label;
#line 269 "../src/Dialogs/Project.vala"
			gtk_label_set_label (_tmp11_, "🚀️");
#line 673 "Project.c"
		}
#line 272 "../src/Dialogs/Project.vala"
		_tmp12_ = _data61_->emoji_chooser;
#line 272 "../src/Dialogs/Project.vala"
		gtk_popover_popup ((GtkPopover*) _tmp12_);
#line 679 "Project.c"
	} else {
		GtkRevealer* _tmp13_;
		GtkStack* _tmp14_;
#line 274 "../src/Dialogs/Project.vala"
		_tmp13_ = _data61_->color_box_revealer;
#line 274 "../src/Dialogs/Project.vala"
		gtk_revealer_set_reveal_child (_tmp13_, TRUE);
#line 275 "../src/Dialogs/Project.vala"
		_tmp14_ = self->priv->emoji_color_stack;
#line 275 "../src/Dialogs/Project.vala"
		gtk_stack_set_visible_child_name (_tmp14_, "color");
#line 691 "Project.c"
	}
}

static void
___lambda35__g_object_notify (GObject* _sender,
                              GParamSpec* pspec,
                              gpointer self)
{
#line 263 "../src/Dialogs/Project.vala"
	__lambda35_ (self);
#line 702 "Project.c"
}

static void
__lambda36_ (DialogsProject* self)
{
	WidgetsCircularProgressBar* _tmp0_;
	WidgetsColorPickerRow* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
#line 280 "../src/Dialogs/Project.vala"
	_tmp0_ = self->priv->progress_bar;
#line 280 "../src/Dialogs/Project.vala"
	_tmp1_ = self->priv->color_picker_row;
#line 280 "../src/Dialogs/Project.vala"
	_tmp2_ = widgets_color_picker_row_get_color (_tmp1_);
#line 280 "../src/Dialogs/Project.vala"
	_tmp3_ = _tmp2_;
#line 280 "../src/Dialogs/Project.vala"
	widgets_circular_progress_bar_set_color (_tmp0_, _tmp3_);
#line 722 "Project.c"
}

static void
___lambda36__widgets_color_picker_row_color_changed (WidgetsColorPickerRow* _sender,
                                                     const gchar* color,
                                                     gpointer self)
{
#line 279 "../src/Dialogs/Project.vala"
	__lambda36_ ((DialogsProject*) self);
#line 732 "Project.c"
}

static void
__lambda37_ (Block61Data* _data61_)
{
	DialogsProject* self;
	GtkSwitch* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 283 "../src/Dialogs/Project.vala"
	self = _data61_->self;
#line 284 "../src/Dialogs/Project.vala"
	_tmp0_ = self->priv->emoji_switch;
#line 284 "../src/Dialogs/Project.vala"
	_tmp1_ = gtk_switch_get_active (_tmp0_);
#line 284 "../src/Dialogs/Project.vala"
	_tmp2_ = _tmp1_;
#line 284 "../src/Dialogs/Project.vala"
	if (_tmp2_) {
#line 752 "Project.c"
		GtkEmojiChooser* _tmp3_;
#line 285 "../src/Dialogs/Project.vala"
		_tmp3_ = _data61_->emoji_chooser;
#line 285 "../src/Dialogs/Project.vala"
		gtk_popover_popup ((GtkPopover*) _tmp3_);
#line 758 "Project.c"
	}
}

static void
___lambda37__gtk_button_clicked (GtkButton* _sender,
                                 gpointer self)
{
#line 283 "../src/Dialogs/Project.vala"
	__lambda37_ (self);
#line 768 "Project.c"
}

static void
__lambda38_ (DialogsProject* self)
{
	AdwNavigationView* _tmp0_;
	AdwNavigationPage* _tmp1_;
#line 290 "../src/Dialogs/Project.vala"
	_tmp0_ = self->priv->navigation_view;
#line 290 "../src/Dialogs/Project.vala"
	_tmp1_ = self->priv->sources_page;
#line 290 "../src/Dialogs/Project.vala"
	adw_navigation_view_push (_tmp0_, _tmp1_);
#line 782 "Project.c"
}

static void
___lambda38__adw_action_row_activated (AdwActionRow* _sender,
                                       gpointer self)
{
#line 289 "../src/Dialogs/Project.vala"
	__lambda38_ ((DialogsProject*) self);
#line 791 "Project.c"
}

static AdwNavigationPage*
dialogs_project_get_main_page (DialogsProject* self)
{
	Block61Data* _data61_;
	AdwHeaderBar* headerbar = NULL;
	AdwHeaderBar* _tmp0_;
	AdwHeaderBar* _tmp1_;
	ObjectsProject* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	GtkLabel* _tmp5_;
	WidgetsCircularProgressBar* _tmp6_;
	WidgetsCircularProgressBar* _tmp7_;
	GtkStack* _tmp8_ = NULL;
	GtkStack* _tmp9_;
	WidgetsCircularProgressBar* _tmp10_;
	GtkStack* _tmp11_;
	GtkLabel* _tmp12_;
	const gchar* _tmp13_ = NULL;
	ObjectsProject* _tmp14_;
	ProjectIconStyle _tmp15_;
	ProjectIconStyle _tmp16_;
	GtkStack* _tmp17_;
	GtkButton* emoji_picker_button = NULL;
	GtkStack* _tmp18_;
	GtkWidget* _tmp19_;
	gchar* _tmp20_;
	gchar* _tmp21_;
	gchar** _tmp22_;
	GtkButton* _tmp23_ = NULL;
	GtkEmojiChooser* _tmp24_ = NULL;
	GtkEmojiChooser* _tmp25_;
	GtkButton* _tmp26_;
	AdwEntryRow* _tmp27_;
	AdwEntryRow* _tmp28_;
	AdwEntryRow* _tmp29_;
	ObjectsProject* _tmp30_;
	const gchar* _tmp31_;
	const gchar* _tmp32_;
	GtkImage* emoji_icon = NULL;
	GtkImage* _tmp33_;
	ObjectsProject* _tmp34_;
	ProjectIconStyle _tmp35_;
	ProjectIconStyle _tmp36_;
	GtkSwitch* _tmp37_ = NULL;
	AdwActionRow* emoji_switch_row = NULL;
	AdwActionRow* _tmp38_;
	AdwActionRow* _tmp39_;
	AdwActionRow* _tmp40_;
	GtkSwitch* _tmp41_;
	AdwActionRow* _tmp42_;
	GtkImage* _tmp43_;
	AdwActionRow* _tmp44_;
	GtkSwitch* _tmp45_;
	AdwPreferencesGroup* name_group = NULL;
	AdwPreferencesGroup* _tmp46_ = NULL;
	AdwPreferencesGroup* _tmp47_;
	AdwEntryRow* _tmp48_;
	AdwPreferencesGroup* _tmp49_;
	AdwActionRow* _tmp50_;
	ObjectsProject* _tmp51_;
	ObjectsSource* _tmp52_;
	ObjectsSource* _tmp53_;
	const gchar* _tmp54_;
	const gchar* _tmp55_;
	gchar* _tmp56_;
	gchar** _tmp57_;
	ObjectsProject* _tmp58_;
	ObjectsSource* _tmp59_;
	ObjectsSource* _tmp60_;
	const gchar* _tmp61_;
	const gchar* _tmp62_;
	gchar* _tmp63_;
	GtkLabel* _tmp64_ = NULL;
	GtkImage* pan_icon = NULL;
	GtkImage* _tmp65_ = NULL;
	GtkBox* source_selected_box = NULL;
	GtkBox* _tmp66_;
	GtkBox* _tmp67_;
	GtkLabel* _tmp68_;
	GtkBox* _tmp69_;
	GtkImage* _tmp70_;
	AdwActionRow* source_row = NULL;
	gchar* _tmp71_;
	AdwActionRow* _tmp72_ = NULL;
	AdwActionRow* _tmp73_;
	GtkBox* _tmp74_;
	AdwPreferencesGroup* source_group = NULL;
	AdwPreferencesGroup* _tmp75_ = NULL;
	AdwPreferencesGroup* _tmp76_;
	AdwActionRow* _tmp77_;
	GtkRevealer* source_revealer = NULL;
	gboolean _tmp78_;
	AdwPreferencesGroup* _tmp79_;
	GtkWidget* _tmp80_;
	GtkRevealer* _tmp81_ = NULL;
	WidgetsColorPickerRow* _tmp82_;
	AdwBin* color_group = NULL;
	gchar* _tmp83_;
	gchar** _tmp84_;
	WidgetsColorPickerRow* _tmp85_;
	GtkWidget* _tmp86_;
	AdwBin* _tmp87_ = NULL;
	ObjectsProject* _tmp88_;
	ProjectIconStyle _tmp89_;
	ProjectIconStyle _tmp90_;
	GtkRevealer* _tmp91_ = NULL;
	GtkRevealer* _tmp92_;
	AdwBin* _tmp93_;
	const gchar* _tmp94_ = NULL;
	gboolean _tmp95_;
	gboolean _tmp96_;
	WidgetsLoadingButton* _tmp97_ = NULL;
	WidgetsLoadingButton* _tmp98_;
	GtkBox* content_box = NULL;
	GtkBox* _tmp99_;
	GtkButton* _tmp100_;
	AdwPreferencesGroup* _tmp101_;
	GtkRevealer* _tmp102_;
	GtkRevealer* _tmp103_;
	WidgetsLoadingButton* _tmp104_;
	AdwClamp* content_clamp = NULL;
	AdwClamp* _tmp105_ = NULL;
	AdwToolbarView* toolbar_view = NULL;
	AdwToolbarView* _tmp106_;
	AdwHeaderBar* _tmp107_;
	AdwNavigationPage* navigation_page = NULL;
	const gchar* _tmp108_;
	AdwNavigationPage* _tmp109_;
	GtkStack* _tmp110_;
	guint _tmp111_;
	guint _tmp112_;
	GeeHashMap* _tmp113_;
	AdwEntryRow* _tmp114_;
	gulong _tmp115_;
	AdwEntryRow* _tmp116_;
	GeeHashMap* _tmp117_;
	WidgetsLoadingButton* _tmp118_;
	gulong _tmp119_;
	WidgetsLoadingButton* _tmp120_;
	GeeHashMap* _tmp121_;
	GtkEmojiChooser* _tmp122_;
	gulong _tmp123_;
	GtkEmojiChooser* _tmp124_;
	GeeHashMap* _tmp125_;
	GtkSwitch* _tmp126_;
	gulong _tmp127_;
	GtkSwitch* _tmp128_;
	GeeHashMap* _tmp129_;
	WidgetsColorPickerRow* _tmp130_;
	gulong _tmp131_;
	WidgetsColorPickerRow* _tmp132_;
	GeeHashMap* _tmp133_;
	GtkButton* _tmp134_;
	gulong _tmp135_;
	GtkButton* _tmp136_;
	GeeHashMap* _tmp137_;
	AdwActionRow* _tmp138_;
	gulong _tmp139_;
	AdwActionRow* _tmp140_;
	AdwNavigationPage* result;
#line 95 "../src/Dialogs/Project.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 95 "../src/Dialogs/Project.vala"
	_data61_ = g_slice_new0 (Block61Data);
#line 95 "../src/Dialogs/Project.vala"
	_data61_->_ref_count_ = 1;
#line 95 "../src/Dialogs/Project.vala"
	_data61_->self = g_object_ref (self);
#line 96 "../src/Dialogs/Project.vala"
	_tmp0_ = (AdwHeaderBar*) adw_header_bar_new ();
#line 96 "../src/Dialogs/Project.vala"
	g_object_ref_sink (_tmp0_);
#line 96 "../src/Dialogs/Project.vala"
	headerbar = _tmp0_;
#line 97 "../src/Dialogs/Project.vala"
	_tmp1_ = headerbar;
#line 97 "../src/Dialogs/Project.vala"
	gtk_widget_add_css_class ((GtkWidget*) _tmp1_, "flat");
#line 99 "../src/Dialogs/Project.vala"
	_tmp2_ = self->priv->_project;
#line 99 "../src/Dialogs/Project.vala"
	_tmp3_ = objects_project_get_emoji (_tmp2_);
#line 99 "../src/Dialogs/Project.vala"
	_tmp4_ = _tmp3_;
#line 99 "../src/Dialogs/Project.vala"
	_tmp5_ = (GtkLabel*) gtk_label_new (_tmp4_);
#line 99 "../src/Dialogs/Project.vala"
	g_object_ref_sink (_tmp5_);
#line 99 "../src/Dialogs/Project.vala"
	_g_object_unref0 (self->priv->emoji_label);
#line 99 "../src/Dialogs/Project.vala"
	self->priv->emoji_label = _tmp5_;
#line 101 "../src/Dialogs/Project.vala"
	_tmp6_ = widgets_circular_progress_bar_new (32);
#line 101 "../src/Dialogs/Project.vala"
	g_object_ref_sink (_tmp6_);
#line 101 "../src/Dialogs/Project.vala"
	_g_object_unref0 (self->priv->progress_bar);
#line 101 "../src/Dialogs/Project.vala"
	self->priv->progress_bar = _tmp6_;
#line 102 "../src/Dialogs/Project.vala"
	_tmp7_ = self->priv->progress_bar;
#line 102 "../src/Dialogs/Project.vala"
	widgets_circular_progress_bar_set_percentage (_tmp7_, 0.64);
#line 104 "../src/Dialogs/Project.vala"
	_tmp8_ = (GtkStack*) gtk_stack_new ();
#line 104 "../src/Dialogs/Project.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp8_, GTK_ALIGN_CENTER);
#line 104 "../src/Dialogs/Project.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp8_, GTK_ALIGN_CENTER);
#line 104 "../src/Dialogs/Project.vala"
	gtk_stack_set_transition_type (_tmp8_, GTK_STACK_TRANSITION_TYPE_CROSSFADE);
#line 104 "../src/Dialogs/Project.vala"
	g_object_ref_sink (_tmp8_);
#line 104 "../src/Dialogs/Project.vala"
	_g_object_unref0 (self->priv->emoji_color_stack);
#line 104 "../src/Dialogs/Project.vala"
	self->priv->emoji_color_stack = _tmp8_;
#line 110 "../src/Dialogs/Project.vala"
	_tmp9_ = self->priv->emoji_color_stack;
#line 110 "../src/Dialogs/Project.vala"
	_tmp10_ = self->priv->progress_bar;
#line 110 "../src/Dialogs/Project.vala"
	gtk_stack_add_named (_tmp9_, (GtkWidget*) _tmp10_, "color");
#line 111 "../src/Dialogs/Project.vala"
	_tmp11_ = self->priv->emoji_color_stack;
#line 111 "../src/Dialogs/Project.vala"
	_tmp12_ = self->priv->emoji_label;
#line 111 "../src/Dialogs/Project.vala"
	gtk_stack_add_named (_tmp11_, (GtkWidget*) _tmp12_, "emoji");
#line 112 "../src/Dialogs/Project.vala"
	_tmp14_ = self->priv->_project;
#line 112 "../src/Dialogs/Project.vala"
	_tmp15_ = objects_project_get_icon_style (_tmp14_);
#line 112 "../src/Dialogs/Project.vala"
	_tmp16_ = _tmp15_;
#line 112 "../src/Dialogs/Project.vala"
	if (_tmp16_ == PROJECT_ICON_STYLE_PROGRESS) {
#line 112 "../src/Dialogs/Project.vala"
		_tmp13_ = "color";
#line 1035 "Project.c"
	} else {
#line 112 "../src/Dialogs/Project.vala"
		_tmp13_ = "emoji";
#line 1039 "Project.c"
	}
#line 112 "../src/Dialogs/Project.vala"
	_tmp17_ = self->priv->emoji_color_stack;
#line 112 "../src/Dialogs/Project.vala"
	gtk_stack_set_visible_child_name (_tmp17_, _tmp13_);
#line 114 "../src/Dialogs/Project.vala"
	_tmp18_ = self->priv->emoji_color_stack;
#line 114 "../src/Dialogs/Project.vala"
	_tmp19_ = _g_object_ref0 ((GtkWidget*) _tmp18_);
#line 114 "../src/Dialogs/Project.vala"
	_tmp20_ = g_strdup ("title-2");
#line 114 "../src/Dialogs/Project.vala"
	_tmp21_ = g_strdup ("button-emoji-picker");
#line 114 "../src/Dialogs/Project.vala"
	_tmp22_ = g_new0 (gchar*, 2 + 1);
#line 114 "../src/Dialogs/Project.vala"
	_tmp22_[0] = _tmp20_;
#line 114 "../src/Dialogs/Project.vala"
	_tmp22_[1] = _tmp21_;
#line 114 "../src/Dialogs/Project.vala"
	_tmp23_ = (GtkButton*) gtk_button_new ();
#line 114 "../src/Dialogs/Project.vala"
	gtk_widget_set_hexpand ((GtkWidget*) _tmp23_, TRUE);
#line 114 "../src/Dialogs/Project.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp23_, GTK_ALIGN_CENTER);
#line 114 "../src/Dialogs/Project.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp23_, GTK_ALIGN_CENTER);
#line 114 "../src/Dialogs/Project.vala"
	g_object_set ((GtkWidget*) _tmp23_, "height-request", 64, NULL);
#line 114 "../src/Dialogs/Project.vala"
	g_object_set ((GtkWidget*) _tmp23_, "width-request", 64, NULL);
#line 114 "../src/Dialogs/Project.vala"
	gtk_widget_set_margin_top ((GtkWidget*) _tmp23_, 6);
#line 114 "../src/Dialogs/Project.vala"
	gtk_button_set_child (_tmp23_, _tmp19_);
#line 114 "../src/Dialogs/Project.vala"
	_g_object_unref0 (_tmp19_);
#line 114 "../src/Dialogs/Project.vala"
	gtk_widget_set_css_classes ((GtkWidget*) _tmp23_, _tmp22_);
#line 114 "../src/Dialogs/Project.vala"
	_tmp22_ = (_vala_array_free (_tmp22_, 2, (GDestroyNotify) g_free), NULL);
#line 114 "../src/Dialogs/Project.vala"
	g_object_ref_sink (_tmp23_);
#line 114 "../src/Dialogs/Project.vala"
	emoji_picker_button = _tmp23_;
#line 125 "../src/Dialogs/Project.vala"
	_tmp24_ = (GtkEmojiChooser*) gtk_emoji_chooser_new ();
#line 125 "../src/Dialogs/Project.vala"
	gtk_popover_set_has_arrow ((GtkPopover*) _tmp24_, FALSE);
#line 125 "../src/Dialogs/Project.vala"
	g_object_ref_sink (_tmp24_);
#line 125 "../src/Dialogs/Project.vala"
	_data61_->emoji_chooser = _tmp24_;
#line 129 "../src/Dialogs/Project.vala"
	_tmp25_ = _data61_->emoji_chooser;
#line 129 "../src/Dialogs/Project.vala"
	_tmp26_ = emoji_picker_button;
#line 129 "../src/Dialogs/Project.vala"
	gtk_widget_set_parent ((GtkWidget*) _tmp25_, (GtkWidget*) _tmp26_);
#line 131 "../src/Dialogs/Project.vala"
	_tmp27_ = (AdwEntryRow*) adw_entry_row_new ();
#line 131 "../src/Dialogs/Project.vala"
	g_object_ref_sink (_tmp27_);
#line 131 "../src/Dialogs/Project.vala"
	_g_object_unref0 (self->priv->name_entry);
#line 131 "../src/Dialogs/Project.vala"
	self->priv->name_entry = _tmp27_;
#line 132 "../src/Dialogs/Project.vala"
	_tmp28_ = self->priv->name_entry;
#line 132 "../src/Dialogs/Project.vala"
	adw_preferences_row_set_title ((AdwPreferencesRow*) _tmp28_, _ ("Give your project a name"));
#line 133 "../src/Dialogs/Project.vala"
	_tmp29_ = self->priv->name_entry;
#line 133 "../src/Dialogs/Project.vala"
	_tmp30_ = self->priv->_project;
#line 133 "../src/Dialogs/Project.vala"
	_tmp31_ = objects_base_object_get_name ((ObjectsBaseObject*) _tmp30_);
#line 133 "../src/Dialogs/Project.vala"
	_tmp32_ = _tmp31_;
#line 133 "../src/Dialogs/Project.vala"
	gtk_editable_set_text ((GtkEditable*) _tmp29_, _tmp32_);
#line 135 "../src/Dialogs/Project.vala"
	_tmp33_ = (GtkImage*) gtk_image_new_from_icon_name ("reaction-add2-symbolic");
#line 135 "../src/Dialogs/Project.vala"
	g_object_ref_sink (_tmp33_);
#line 135 "../src/Dialogs/Project.vala"
	emoji_icon = _tmp33_;
#line 137 "../src/Dialogs/Project.vala"
	_tmp34_ = self->priv->_project;
#line 137 "../src/Dialogs/Project.vala"
	_tmp35_ = objects_project_get_icon_style (_tmp34_);
#line 137 "../src/Dialogs/Project.vala"
	_tmp36_ = _tmp35_;
#line 137 "../src/Dialogs/Project.vala"
	_tmp37_ = (GtkSwitch*) gtk_switch_new ();
#line 137 "../src/Dialogs/Project.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp37_, GTK_ALIGN_CENTER);
#line 137 "../src/Dialogs/Project.vala"
	gtk_switch_set_active (_tmp37_, _tmp36_ == PROJECT_ICON_STYLE_EMOJI);
#line 137 "../src/Dialogs/Project.vala"
	g_object_ref_sink (_tmp37_);
#line 137 "../src/Dialogs/Project.vala"
	_g_object_unref0 (self->priv->emoji_switch);
#line 137 "../src/Dialogs/Project.vala"
	self->priv->emoji_switch = _tmp37_;
#line 142 "../src/Dialogs/Project.vala"
	_tmp38_ = (AdwActionRow*) adw_action_row_new ();
#line 142 "../src/Dialogs/Project.vala"
	g_object_ref_sink (_tmp38_);
#line 142 "../src/Dialogs/Project.vala"
	emoji_switch_row = _tmp38_;
#line 143 "../src/Dialogs/Project.vala"
	_tmp39_ = emoji_switch_row;
#line 143 "../src/Dialogs/Project.vala"
	adw_preferences_row_set_title ((AdwPreferencesRow*) _tmp39_, _ ("Use Emoji"));
#line 144 "../src/Dialogs/Project.vala"
	_tmp40_ = emoji_switch_row;
#line 144 "../src/Dialogs/Project.vala"
	_tmp41_ = self->priv->emoji_switch;
#line 144 "../src/Dialogs/Project.vala"
	adw_action_row_set_activatable_widget (_tmp40_, (GtkWidget*) _tmp41_);
#line 145 "../src/Dialogs/Project.vala"
	_tmp42_ = emoji_switch_row;
#line 145 "../src/Dialogs/Project.vala"
	_tmp43_ = emoji_icon;
#line 145 "../src/Dialogs/Project.vala"
	adw_action_row_add_prefix (_tmp42_, (GtkWidget*) _tmp43_);
#line 146 "../src/Dialogs/Project.vala"
	_tmp44_ = emoji_switch_row;
#line 146 "../src/Dialogs/Project.vala"
	_tmp45_ = self->priv->emoji_switch;
#line 146 "../src/Dialogs/Project.vala"
	adw_action_row_add_suffix (_tmp44_, (GtkWidget*) _tmp45_);
#line 148 "../src/Dialogs/Project.vala"
	_tmp46_ = (AdwPreferencesGroup*) adw_preferences_group_new ();
#line 148 "../src/Dialogs/Project.vala"
	gtk_widget_set_margin_end ((GtkWidget*) _tmp46_, 12);
#line 148 "../src/Dialogs/Project.vala"
	gtk_widget_set_margin_start ((GtkWidget*) _tmp46_, 12);
#line 148 "../src/Dialogs/Project.vala"
	gtk_widget_set_margin_top ((GtkWidget*) _tmp46_, 24);
#line 148 "../src/Dialogs/Project.vala"
	g_object_ref_sink (_tmp46_);
#line 148 "../src/Dialogs/Project.vala"
	name_group = _tmp46_;
#line 154 "../src/Dialogs/Project.vala"
	_tmp47_ = name_group;
#line 154 "../src/Dialogs/Project.vala"
	_tmp48_ = self->priv->name_entry;
#line 154 "../src/Dialogs/Project.vala"
	adw_preferences_group_add (_tmp47_, (GtkWidget*) _tmp48_);
#line 155 "../src/Dialogs/Project.vala"
	_tmp49_ = name_group;
#line 155 "../src/Dialogs/Project.vala"
	_tmp50_ = emoji_switch_row;
#line 155 "../src/Dialogs/Project.vala"
	adw_preferences_group_add (_tmp49_, (GtkWidget*) _tmp50_);
#line 157 "../src/Dialogs/Project.vala"
	_tmp51_ = self->priv->_project;
#line 157 "../src/Dialogs/Project.vala"
	_tmp52_ = objects_project_get_source (_tmp51_);
#line 157 "../src/Dialogs/Project.vala"
	_tmp53_ = _tmp52_;
#line 157 "../src/Dialogs/Project.vala"
	_tmp54_ = objects_source_get_display_name (_tmp53_);
#line 157 "../src/Dialogs/Project.vala"
	_tmp55_ = _tmp54_;
#line 157 "../src/Dialogs/Project.vala"
	_tmp56_ = g_strdup ("dim-label");
#line 157 "../src/Dialogs/Project.vala"
	_tmp57_ = g_new0 (gchar*, 1 + 1);
#line 157 "../src/Dialogs/Project.vala"
	_tmp57_[0] = _tmp56_;
#line 157 "../src/Dialogs/Project.vala"
	_tmp58_ = self->priv->_project;
#line 157 "../src/Dialogs/Project.vala"
	_tmp59_ = objects_project_get_source (_tmp58_);
#line 157 "../src/Dialogs/Project.vala"
	_tmp60_ = _tmp59_;
#line 157 "../src/Dialogs/Project.vala"
	_tmp61_ = objects_source_get_subheader_text (_tmp60_);
#line 157 "../src/Dialogs/Project.vala"
	_tmp62_ = _tmp61_;
#line 157 "../src/Dialogs/Project.vala"
	_tmp63_ = g_strdup (_tmp62_);
#line 157 "../src/Dialogs/Project.vala"
	_tmp64_ = (GtkLabel*) gtk_label_new (_tmp55_);
#line 157 "../src/Dialogs/Project.vala"
	gtk_widget_set_css_classes ((GtkWidget*) _tmp64_, _tmp57_);
#line 157 "../src/Dialogs/Project.vala"
	_tmp57_ = (_vala_array_free (_tmp57_, 1, (GDestroyNotify) g_free), NULL);
#line 157 "../src/Dialogs/Project.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp64_, _tmp63_);
#line 157 "../src/Dialogs/Project.vala"
	_g_free0 (_tmp63_);
#line 157 "../src/Dialogs/Project.vala"
	g_object_ref_sink (_tmp64_);
#line 157 "../src/Dialogs/Project.vala"
	_g_object_unref0 (self->priv->source_selected_label);
#line 157 "../src/Dialogs/Project.vala"
	self->priv->source_selected_label = _tmp64_;
#line 161 "../src/Dialogs/Project.vala"
	_tmp65_ = (GtkImage*) gtk_image_new_from_icon_name ("go-next-symbolic");
#line 161 "../src/Dialogs/Project.vala"
	gtk_image_set_pixel_size (_tmp65_, 16);
#line 161 "../src/Dialogs/Project.vala"
	g_object_ref_sink (_tmp65_);
#line 161 "../src/Dialogs/Project.vala"
	pan_icon = _tmp65_;
#line 165 "../src/Dialogs/Project.vala"
	_tmp66_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 6);
#line 165 "../src/Dialogs/Project.vala"
	g_object_ref_sink (_tmp66_);
#line 165 "../src/Dialogs/Project.vala"
	source_selected_box = _tmp66_;
#line 166 "../src/Dialogs/Project.vala"
	_tmp67_ = source_selected_box;
#line 166 "../src/Dialogs/Project.vala"
	_tmp68_ = self->priv->source_selected_label;
#line 166 "../src/Dialogs/Project.vala"
	gtk_box_append (_tmp67_, (GtkWidget*) _tmp68_);
#line 167 "../src/Dialogs/Project.vala"
	_tmp69_ = source_selected_box;
#line 167 "../src/Dialogs/Project.vala"
	_tmp70_ = pan_icon;
#line 167 "../src/Dialogs/Project.vala"
	gtk_box_append (_tmp69_, (GtkWidget*) _tmp70_);
#line 169 "../src/Dialogs/Project.vala"
	_tmp71_ = g_strdup (_ ("Source"));
#line 169 "../src/Dialogs/Project.vala"
	_tmp72_ = (AdwActionRow*) adw_action_row_new ();
#line 169 "../src/Dialogs/Project.vala"
	gtk_list_box_row_set_activatable ((GtkListBoxRow*) _tmp72_, TRUE);
#line 169 "../src/Dialogs/Project.vala"
	adw_preferences_row_set_title ((AdwPreferencesRow*) _tmp72_, _tmp71_);
#line 169 "../src/Dialogs/Project.vala"
	_g_free0 (_tmp71_);
#line 169 "../src/Dialogs/Project.vala"
	g_object_ref_sink (_tmp72_);
#line 169 "../src/Dialogs/Project.vala"
	source_row = _tmp72_;
#line 174 "../src/Dialogs/Project.vala"
	_tmp73_ = source_row;
#line 174 "../src/Dialogs/Project.vala"
	_tmp74_ = source_selected_box;
#line 174 "../src/Dialogs/Project.vala"
	adw_action_row_add_suffix (_tmp73_, (GtkWidget*) _tmp74_);
#line 176 "../src/Dialogs/Project.vala"
	_tmp75_ = (AdwPreferencesGroup*) adw_preferences_group_new ();
#line 176 "../src/Dialogs/Project.vala"
	gtk_widget_set_margin_end ((GtkWidget*) _tmp75_, 12);
#line 176 "../src/Dialogs/Project.vala"
	gtk_widget_set_margin_start ((GtkWidget*) _tmp75_, 12);
#line 176 "../src/Dialogs/Project.vala"
	gtk_widget_set_margin_top ((GtkWidget*) _tmp75_, 24);
#line 176 "../src/Dialogs/Project.vala"
	gtk_widget_set_margin_bottom ((GtkWidget*) _tmp75_, 1);
#line 176 "../src/Dialogs/Project.vala"
	g_object_ref_sink (_tmp75_);
#line 176 "../src/Dialogs/Project.vala"
	source_group = _tmp75_;
#line 183 "../src/Dialogs/Project.vala"
	_tmp76_ = source_group;
#line 183 "../src/Dialogs/Project.vala"
	_tmp77_ = source_row;
#line 183 "../src/Dialogs/Project.vala"
	adw_preferences_group_add (_tmp76_, (GtkWidget*) _tmp77_);
#line 185 "../src/Dialogs/Project.vala"
	_tmp78_ = self->priv->_backend_picker;
#line 185 "../src/Dialogs/Project.vala"
	_tmp79_ = source_group;
#line 185 "../src/Dialogs/Project.vala"
	_tmp80_ = _g_object_ref0 ((GtkWidget*) _tmp79_);
#line 185 "../src/Dialogs/Project.vala"
	_tmp81_ = (GtkRevealer*) gtk_revealer_new ();
#line 185 "../src/Dialogs/Project.vala"
	gtk_revealer_set_transition_type (_tmp81_, GTK_REVEALER_TRANSITION_TYPE_SLIDE_DOWN);
#line 185 "../src/Dialogs/Project.vala"
	gtk_revealer_set_reveal_child (_tmp81_, _tmp78_);
#line 185 "../src/Dialogs/Project.vala"
	gtk_revealer_set_child (_tmp81_, _tmp80_);
#line 185 "../src/Dialogs/Project.vala"
	_g_object_unref0 (_tmp80_);
#line 185 "../src/Dialogs/Project.vala"
	g_object_ref_sink (_tmp81_);
#line 185 "../src/Dialogs/Project.vala"
	source_revealer = _tmp81_;
#line 191 "../src/Dialogs/Project.vala"
	_tmp82_ = widgets_color_picker_row_new ();
#line 191 "../src/Dialogs/Project.vala"
	g_object_ref_sink (_tmp82_);
#line 191 "../src/Dialogs/Project.vala"
	_g_object_unref0 (self->priv->color_picker_row);
#line 191 "../src/Dialogs/Project.vala"
	self->priv->color_picker_row = _tmp82_;
#line 193 "../src/Dialogs/Project.vala"
	_tmp83_ = g_strdup ("card");
#line 193 "../src/Dialogs/Project.vala"
	_tmp84_ = g_new0 (gchar*, 1 + 1);
#line 193 "../src/Dialogs/Project.vala"
	_tmp84_[0] = _tmp83_;
#line 193 "../src/Dialogs/Project.vala"
	_tmp85_ = self->priv->color_picker_row;
#line 193 "../src/Dialogs/Project.vala"
	_tmp86_ = _g_object_ref0 ((GtkWidget*) _tmp85_);
#line 193 "../src/Dialogs/Project.vala"
	_tmp87_ = (AdwBin*) adw_bin_new ();
#line 193 "../src/Dialogs/Project.vala"
	gtk_widget_set_margin_end ((GtkWidget*) _tmp87_, 12);
#line 193 "../src/Dialogs/Project.vala"
	gtk_widget_set_margin_start ((GtkWidget*) _tmp87_, 12);
#line 193 "../src/Dialogs/Project.vala"
	gtk_widget_set_margin_top ((GtkWidget*) _tmp87_, 24);
#line 193 "../src/Dialogs/Project.vala"
	gtk_widget_set_margin_bottom ((GtkWidget*) _tmp87_, 1);
#line 193 "../src/Dialogs/Project.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp87_, GTK_ALIGN_START);
#line 193 "../src/Dialogs/Project.vala"
	gtk_widget_set_css_classes ((GtkWidget*) _tmp87_, _tmp84_);
#line 193 "../src/Dialogs/Project.vala"
	_tmp84_ = (_vala_array_free (_tmp84_, 1, (GDestroyNotify) g_free), NULL);
#line 193 "../src/Dialogs/Project.vala"
	adw_bin_set_child (_tmp87_, _tmp86_);
#line 193 "../src/Dialogs/Project.vala"
	_g_object_unref0 (_tmp86_);
#line 193 "../src/Dialogs/Project.vala"
	g_object_ref_sink (_tmp87_);
#line 193 "../src/Dialogs/Project.vala"
	color_group = _tmp87_;
#line 203 "../src/Dialogs/Project.vala"
	_tmp88_ = self->priv->_project;
#line 203 "../src/Dialogs/Project.vala"
	_tmp89_ = objects_project_get_icon_style (_tmp88_);
#line 203 "../src/Dialogs/Project.vala"
	_tmp90_ = _tmp89_;
#line 203 "../src/Dialogs/Project.vala"
	_tmp91_ = (GtkRevealer*) gtk_revealer_new ();
#line 203 "../src/Dialogs/Project.vala"
	gtk_revealer_set_transition_type (_tmp91_, GTK_REVEALER_TRANSITION_TYPE_SLIDE_DOWN);
#line 203 "../src/Dialogs/Project.vala"
	gtk_revealer_set_reveal_child (_tmp91_, _tmp90_ == PROJECT_ICON_STYLE_PROGRESS);
#line 203 "../src/Dialogs/Project.vala"
	g_object_ref_sink (_tmp91_);
#line 203 "../src/Dialogs/Project.vala"
	_data61_->color_box_revealer = _tmp91_;
#line 208 "../src/Dialogs/Project.vala"
	_tmp92_ = _data61_->color_box_revealer;
#line 208 "../src/Dialogs/Project.vala"
	_tmp93_ = color_group;
#line 208 "../src/Dialogs/Project.vala"
	gtk_revealer_set_child (_tmp92_, (GtkWidget*) _tmp93_);
#line 210 "../src/Dialogs/Project.vala"
	_tmp95_ = dialogs_project_get_is_creating (self);
#line 210 "../src/Dialogs/Project.vala"
	_tmp96_ = _tmp95_;
#line 210 "../src/Dialogs/Project.vala"
	if (_tmp96_) {
#line 210 "../src/Dialogs/Project.vala"
		_tmp94_ = _ ("Add Project");
#line 1399 "Project.c"
	} else {
#line 210 "../src/Dialogs/Project.vala"
		_tmp94_ = _ ("Update Project");
#line 1403 "Project.c"
	}
#line 210 "../src/Dialogs/Project.vala"
	_tmp97_ = widgets_loading_button_new_with_label (_tmp94_);
#line 210 "../src/Dialogs/Project.vala"
	gtk_widget_set_vexpand ((GtkWidget*) _tmp97_, TRUE);
#line 210 "../src/Dialogs/Project.vala"
	gtk_widget_set_hexpand ((GtkWidget*) _tmp97_, TRUE);
#line 210 "../src/Dialogs/Project.vala"
	gtk_widget_set_margin_bottom ((GtkWidget*) _tmp97_, 12);
#line 210 "../src/Dialogs/Project.vala"
	gtk_widget_set_margin_end ((GtkWidget*) _tmp97_, 12);
#line 210 "../src/Dialogs/Project.vala"
	gtk_widget_set_margin_start ((GtkWidget*) _tmp97_, 12);
#line 210 "../src/Dialogs/Project.vala"
	gtk_widget_set_margin_top ((GtkWidget*) _tmp97_, 24);
#line 210 "../src/Dialogs/Project.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp97_, GTK_ALIGN_END);
#line 210 "../src/Dialogs/Project.vala"
	g_object_ref_sink (_tmp97_);
#line 210 "../src/Dialogs/Project.vala"
	_g_object_unref0 (self->priv->submit_button);
#line 210 "../src/Dialogs/Project.vala"
	self->priv->submit_button = _tmp97_;
#line 220 "../src/Dialogs/Project.vala"
	_tmp98_ = self->priv->submit_button;
#line 220 "../src/Dialogs/Project.vala"
	gtk_widget_add_css_class ((GtkWidget*) _tmp98_, "suggested-action");
#line 222 "../src/Dialogs/Project.vala"
	_tmp99_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 0);
#line 222 "../src/Dialogs/Project.vala"
	g_object_ref_sink (_tmp99_);
#line 222 "../src/Dialogs/Project.vala"
	content_box = _tmp99_;
#line 223 "../src/Dialogs/Project.vala"
	_tmp100_ = emoji_picker_button;
#line 223 "../src/Dialogs/Project.vala"
	gtk_box_append (content_box, (GtkWidget*) _tmp100_);
#line 224 "../src/Dialogs/Project.vala"
	_tmp101_ = name_group;
#line 224 "../src/Dialogs/Project.vala"
	gtk_box_append (content_box, (GtkWidget*) _tmp101_);
#line 225 "../src/Dialogs/Project.vala"
	_tmp102_ = source_revealer;
#line 225 "../src/Dialogs/Project.vala"
	gtk_box_append (content_box, (GtkWidget*) _tmp102_);
#line 226 "../src/Dialogs/Project.vala"
	_tmp103_ = _data61_->color_box_revealer;
#line 226 "../src/Dialogs/Project.vala"
	gtk_box_append (content_box, (GtkWidget*) _tmp103_);
#line 227 "../src/Dialogs/Project.vala"
	_tmp104_ = self->priv->submit_button;
#line 227 "../src/Dialogs/Project.vala"
	gtk_box_append (content_box, (GtkWidget*) _tmp104_);
#line 229 "../src/Dialogs/Project.vala"
	_tmp105_ = (AdwClamp*) adw_clamp_new ();
#line 229 "../src/Dialogs/Project.vala"
	adw_clamp_set_maximum_size (_tmp105_, 600);
#line 229 "../src/Dialogs/Project.vala"
	gtk_widget_set_margin_start ((GtkWidget*) _tmp105_, 12);
#line 229 "../src/Dialogs/Project.vala"
	gtk_widget_set_margin_end ((GtkWidget*) _tmp105_, 12);
#line 229 "../src/Dialogs/Project.vala"
	gtk_widget_set_margin_bottom ((GtkWidget*) _tmp105_, 12);
#line 229 "../src/Dialogs/Project.vala"
	gtk_widget_set_margin_top ((GtkWidget*) _tmp105_, 6);
#line 229 "../src/Dialogs/Project.vala"
	g_object_ref_sink (_tmp105_);
#line 229 "../src/Dialogs/Project.vala"
	content_clamp = _tmp105_;
#line 237 "../src/Dialogs/Project.vala"
	adw_clamp_set_child (content_clamp, (GtkWidget*) content_box);
#line 239 "../src/Dialogs/Project.vala"
	_tmp106_ = (AdwToolbarView*) adw_toolbar_view_new ();
#line 239 "../src/Dialogs/Project.vala"
	g_object_ref_sink (_tmp106_);
#line 239 "../src/Dialogs/Project.vala"
	toolbar_view = _tmp106_;
#line 240 "../src/Dialogs/Project.vala"
	_tmp107_ = headerbar;
#line 240 "../src/Dialogs/Project.vala"
	adw_toolbar_view_add_top_bar (toolbar_view, (GtkWidget*) _tmp107_);
#line 241 "../src/Dialogs/Project.vala"
	adw_toolbar_view_set_content (toolbar_view, (GtkWidget*) content_clamp);
#line 243 "../src/Dialogs/Project.vala"
	_tmp108_ = self->priv->_header_title;
#line 243 "../src/Dialogs/Project.vala"
	_tmp109_ = adw_navigation_page_new ((GtkWidget*) toolbar_view, _tmp108_);
#line 243 "../src/Dialogs/Project.vala"
	g_object_ref_sink (_tmp109_);
#line 243 "../src/Dialogs/Project.vala"
	navigation_page = _tmp109_;
#line 245 "../src/Dialogs/Project.vala"
	_tmp110_ = self->priv->emoji_color_stack;
#line 245 "../src/Dialogs/Project.vala"
	_tmp111_ = gtk_stack_get_transition_duration (_tmp110_);
#line 245 "../src/Dialogs/Project.vala"
	_tmp112_ = _tmp111_;
#line 245 "../src/Dialogs/Project.vala"
	g_timeout_add_full (G_PRIORITY_DEFAULT, _tmp112_, ___lambda30__gsource_func, g_object_ref (self), g_object_unref);
#line 256 "../src/Dialogs/Project.vala"
	_tmp113_ = self->priv->signal_map;
#line 256 "../src/Dialogs/Project.vala"
	_tmp114_ = self->priv->name_entry;
#line 256 "../src/Dialogs/Project.vala"
	_tmp115_ = g_signal_connect_object (_tmp114_, "entry-activated", (GCallback) _dialogs_project_add_update_project_adw_entry_row_entry_activated, self, 0);
#line 256 "../src/Dialogs/Project.vala"
	_tmp116_ = self->priv->name_entry;
#line 256 "../src/Dialogs/Project.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _tmp113_, (gpointer) ((guintptr) _tmp115_), (GObject*) _tmp116_);
#line 257 "../src/Dialogs/Project.vala"
	_tmp117_ = self->priv->signal_map;
#line 257 "../src/Dialogs/Project.vala"
	_tmp118_ = self->priv->submit_button;
#line 257 "../src/Dialogs/Project.vala"
	_tmp119_ = g_signal_connect_object ((GtkButton*) _tmp118_, "clicked", (GCallback) _dialogs_project_add_update_project_gtk_button_clicked, self, 0);
#line 257 "../src/Dialogs/Project.vala"
	_tmp120_ = self->priv->submit_button;
#line 257 "../src/Dialogs/Project.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _tmp117_, (gpointer) ((guintptr) _tmp119_), (GObject*) _tmp120_);
#line 259 "../src/Dialogs/Project.vala"
	_tmp121_ = self->priv->signal_map;
#line 259 "../src/Dialogs/Project.vala"
	_tmp122_ = _data61_->emoji_chooser;
#line 259 "../src/Dialogs/Project.vala"
	_tmp123_ = g_signal_connect_object (_tmp122_, "emoji-picked", (GCallback) ___lambda34__gtk_emoji_chooser_emoji_picked, self, 0);
#line 259 "../src/Dialogs/Project.vala"
	_tmp124_ = _data61_->emoji_chooser;
#line 259 "../src/Dialogs/Project.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _tmp121_, (gpointer) ((guintptr) _tmp123_), (GObject*) _tmp124_);
#line 263 "../src/Dialogs/Project.vala"
	_tmp125_ = self->priv->signal_map;
#line 263 "../src/Dialogs/Project.vala"
	_tmp126_ = self->priv->emoji_switch;
#line 263 "../src/Dialogs/Project.vala"
	_tmp127_ = g_signal_connect_data ((GObject*) _tmp126_, "notify::active", (GCallback) ___lambda35__g_object_notify, block61_data_ref (_data61_), (GClosureNotify) block61_data_unref, 0);
#line 263 "../src/Dialogs/Project.vala"
	_tmp128_ = self->priv->emoji_switch;
#line 263 "../src/Dialogs/Project.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _tmp125_, (gpointer) ((guintptr) _tmp127_), (GObject*) _tmp128_);
#line 279 "../src/Dialogs/Project.vala"
	_tmp129_ = self->priv->signal_map;
#line 279 "../src/Dialogs/Project.vala"
	_tmp130_ = self->priv->color_picker_row;
#line 279 "../src/Dialogs/Project.vala"
	_tmp131_ = g_signal_connect_object (_tmp130_, "color-changed", (GCallback) ___lambda36__widgets_color_picker_row_color_changed, self, 0);
#line 279 "../src/Dialogs/Project.vala"
	_tmp132_ = self->priv->color_picker_row;
#line 279 "../src/Dialogs/Project.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _tmp129_, (gpointer) ((guintptr) _tmp131_), (GObject*) _tmp132_);
#line 283 "../src/Dialogs/Project.vala"
	_tmp133_ = self->priv->signal_map;
#line 283 "../src/Dialogs/Project.vala"
	_tmp134_ = emoji_picker_button;
#line 283 "../src/Dialogs/Project.vala"
	_tmp135_ = g_signal_connect_data (_tmp134_, "clicked", (GCallback) ___lambda37__gtk_button_clicked, block61_data_ref (_data61_), (GClosureNotify) block61_data_unref, 0);
#line 283 "../src/Dialogs/Project.vala"
	_tmp136_ = emoji_picker_button;
#line 283 "../src/Dialogs/Project.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _tmp133_, (gpointer) ((guintptr) _tmp135_), (GObject*) _tmp136_);
#line 289 "../src/Dialogs/Project.vala"
	_tmp137_ = self->priv->signal_map;
#line 289 "../src/Dialogs/Project.vala"
	_tmp138_ = source_row;
#line 289 "../src/Dialogs/Project.vala"
	_tmp139_ = g_signal_connect_object (_tmp138_, "activated", (GCallback) ___lambda38__adw_action_row_activated, self, 0);
#line 289 "../src/Dialogs/Project.vala"
	_tmp140_ = source_row;
#line 289 "../src/Dialogs/Project.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _tmp137_, (gpointer) ((guintptr) _tmp139_), (GObject*) _tmp140_);
#line 293 "../src/Dialogs/Project.vala"
	result = navigation_page;
#line 293 "../src/Dialogs/Project.vala"
	_g_object_unref0 (toolbar_view);
#line 293 "../src/Dialogs/Project.vala"
	_g_object_unref0 (content_clamp);
#line 293 "../src/Dialogs/Project.vala"
	_g_object_unref0 (content_box);
#line 293 "../src/Dialogs/Project.vala"
	_g_object_unref0 (color_group);
#line 293 "../src/Dialogs/Project.vala"
	_g_object_unref0 (source_revealer);
#line 293 "../src/Dialogs/Project.vala"
	_g_object_unref0 (source_group);
#line 293 "../src/Dialogs/Project.vala"
	_g_object_unref0 (source_row);
#line 293 "../src/Dialogs/Project.vala"
	_g_object_unref0 (source_selected_box);
#line 293 "../src/Dialogs/Project.vala"
	_g_object_unref0 (pan_icon);
#line 293 "../src/Dialogs/Project.vala"
	_g_object_unref0 (name_group);
#line 293 "../src/Dialogs/Project.vala"
	_g_object_unref0 (emoji_switch_row);
#line 293 "../src/Dialogs/Project.vala"
	_g_object_unref0 (emoji_icon);
#line 293 "../src/Dialogs/Project.vala"
	_g_object_unref0 (emoji_picker_button);
#line 293 "../src/Dialogs/Project.vala"
	_g_object_unref0 (headerbar);
#line 293 "../src/Dialogs/Project.vala"
	block61_data_unref (_data61_);
#line 293 "../src/Dialogs/Project.vala"
	_data61_ = NULL;
#line 293 "../src/Dialogs/Project.vala"
	return result;
#line 1609 "Project.c"
}

static Block62Data*
block62_data_ref (Block62Data* _data62_)
{
#line 308 "../src/Dialogs/Project.vala"
	g_atomic_int_inc (&_data62_->_ref_count_);
#line 308 "../src/Dialogs/Project.vala"
	return _data62_;
#line 1619 "Project.c"
}

static void
block62_data_unref (void * _userdata_)
{
	Block62Data* _data62_;
	_data62_ = (Block62Data*) _userdata_;
#line 308 "../src/Dialogs/Project.vala"
	if (g_atomic_int_dec_and_test (&_data62_->_ref_count_)) {
#line 1629 "Project.c"
		DialogsProject* self;
#line 308 "../src/Dialogs/Project.vala"
		self = _data62_->self;
#line 308 "../src/Dialogs/Project.vala"
		_g_object_unref0 (_data62_->source);
#line 308 "../src/Dialogs/Project.vala"
		_g_object_unref0 (self);
#line 308 "../src/Dialogs/Project.vala"
		g_slice_free (Block62Data, _data62_);
#line 1639 "Project.c"
	}
}

static void
____lambda39_ (Block62Data* _data62_)
{
	DialogsProject* self;
	ObjectsProject* _tmp0_;
	ObjectsSource* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	GtkLabel* _tmp4_;
	ObjectsSource* _tmp5_;
	const gchar* _tmp6_;
	const gchar* _tmp7_;
	GtkLabel* _tmp8_;
	ObjectsSource* _tmp9_;
	const gchar* _tmp10_;
	const gchar* _tmp11_;
	AdwNavigationView* _tmp12_;
#line 323 "../src/Dialogs/Project.vala"
	self = _data62_->self;
#line 324 "../src/Dialogs/Project.vala"
	_tmp0_ = self->priv->_project;
#line 324 "../src/Dialogs/Project.vala"
	_tmp1_ = _data62_->source;
#line 324 "../src/Dialogs/Project.vala"
	_tmp2_ = objects_base_object_get_id ((ObjectsBaseObject*) _tmp1_);
#line 324 "../src/Dialogs/Project.vala"
	_tmp3_ = _tmp2_;
#line 324 "../src/Dialogs/Project.vala"
	objects_project_set_source_id (_tmp0_, _tmp3_);
#line 326 "../src/Dialogs/Project.vala"
	_tmp4_ = self->priv->source_selected_label;
#line 326 "../src/Dialogs/Project.vala"
	_tmp5_ = _data62_->source;
#line 326 "../src/Dialogs/Project.vala"
	_tmp6_ = objects_source_get_display_name (_tmp5_);
#line 326 "../src/Dialogs/Project.vala"
	_tmp7_ = _tmp6_;
#line 326 "../src/Dialogs/Project.vala"
	gtk_label_set_label (_tmp4_, _tmp7_);
#line 327 "../src/Dialogs/Project.vala"
	_tmp8_ = self->priv->source_selected_label;
#line 327 "../src/Dialogs/Project.vala"
	_tmp9_ = _data62_->source;
#line 327 "../src/Dialogs/Project.vala"
	_tmp10_ = objects_source_get_subheader_text (_tmp9_);
#line 327 "../src/Dialogs/Project.vala"
	_tmp11_ = _tmp10_;
#line 327 "../src/Dialogs/Project.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp8_, _tmp11_);
#line 329 "../src/Dialogs/Project.vala"
	_tmp12_ = self->priv->navigation_view;
#line 329 "../src/Dialogs/Project.vala"
	adw_navigation_view_pop (_tmp12_);
#line 1696 "Project.c"
}

static void
_____lambda39__adw_action_row_activated (AdwActionRow* _sender,
                                         gpointer self)
{
#line 323 "../src/Dialogs/Project.vala"
	____lambda39_ (self);
#line 1705 "Project.c"
}

static void
____lambda40_ (Block62Data* _data62_)
{
	DialogsProject* self;
	ObjectsProject* _tmp0_;
	ObjectsSource* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	GtkLabel* _tmp4_;
	ObjectsSource* _tmp5_;
	const gchar* _tmp6_;
	const gchar* _tmp7_;
	GtkLabel* _tmp8_;
	ObjectsSource* _tmp9_;
	const gchar* _tmp10_;
	const gchar* _tmp11_;
	AdwNavigationView* _tmp12_;
#line 332 "../src/Dialogs/Project.vala"
	self = _data62_->self;
#line 333 "../src/Dialogs/Project.vala"
	_tmp0_ = self->priv->_project;
#line 333 "../src/Dialogs/Project.vala"
	_tmp1_ = _data62_->source;
#line 333 "../src/Dialogs/Project.vala"
	_tmp2_ = objects_base_object_get_id ((ObjectsBaseObject*) _tmp1_);
#line 333 "../src/Dialogs/Project.vala"
	_tmp3_ = _tmp2_;
#line 333 "../src/Dialogs/Project.vala"
	objects_project_set_source_id (_tmp0_, _tmp3_);
#line 335 "../src/Dialogs/Project.vala"
	_tmp4_ = self->priv->source_selected_label;
#line 335 "../src/Dialogs/Project.vala"
	_tmp5_ = _data62_->source;
#line 335 "../src/Dialogs/Project.vala"
	_tmp6_ = objects_source_get_display_name (_tmp5_);
#line 335 "../src/Dialogs/Project.vala"
	_tmp7_ = _tmp6_;
#line 335 "../src/Dialogs/Project.vala"
	gtk_label_set_label (_tmp4_, _tmp7_);
#line 336 "../src/Dialogs/Project.vala"
	_tmp8_ = self->priv->source_selected_label;
#line 336 "../src/Dialogs/Project.vala"
	_tmp9_ = _data62_->source;
#line 336 "../src/Dialogs/Project.vala"
	_tmp10_ = objects_source_get_subheader_text (_tmp9_);
#line 336 "../src/Dialogs/Project.vala"
	_tmp11_ = _tmp10_;
#line 336 "../src/Dialogs/Project.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp8_, _tmp11_);
#line 338 "../src/Dialogs/Project.vala"
	_tmp12_ = self->priv->navigation_view;
#line 338 "../src/Dialogs/Project.vala"
	adw_navigation_view_pop (_tmp12_);
#line 1761 "Project.c"
}

static void
_____lambda40__gtk_check_button_toggled (GtkCheckButton* _sender,
                                         gpointer self)
{
#line 332 "../src/Dialogs/Project.vala"
	____lambda40_ (self);
#line 1770 "Project.c"
}

static AdwNavigationPage*
dialogs_project_get_sources_page (DialogsProject* self)
{
	AdwHeaderBar* headerbar = NULL;
	AdwHeaderBar* _tmp0_;
	AdwHeaderBar* _tmp1_;
	AdwPreferencesGroup* sources_group = NULL;
	AdwPreferencesGroup* _tmp2_ = NULL;
	GtkCheckButton* none_radio = NULL;
	GtkCheckButton* _tmp3_;
	AdwClamp* content_clamp = NULL;
	AdwPreferencesGroup* _tmp46_;
	GtkWidget* _tmp47_;
	AdwClamp* _tmp48_ = NULL;
	AdwToolbarView* toolbar_view = NULL;
	AdwToolbarView* _tmp49_;
	AdwHeaderBar* _tmp50_;
	AdwNavigationPage* navigation_page = NULL;
	AdwNavigationPage* _tmp51_;
	AdwNavigationPage* result;
#line 296 "../src/Dialogs/Project.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 297 "../src/Dialogs/Project.vala"
	_tmp0_ = (AdwHeaderBar*) adw_header_bar_new ();
#line 297 "../src/Dialogs/Project.vala"
	g_object_ref_sink (_tmp0_);
#line 297 "../src/Dialogs/Project.vala"
	headerbar = _tmp0_;
#line 298 "../src/Dialogs/Project.vala"
	_tmp1_ = headerbar;
#line 298 "../src/Dialogs/Project.vala"
	gtk_widget_add_css_class ((GtkWidget*) _tmp1_, "flat");
#line 300 "../src/Dialogs/Project.vala"
	_tmp2_ = (AdwPreferencesGroup*) adw_preferences_group_new ();
#line 300 "../src/Dialogs/Project.vala"
	gtk_widget_set_margin_end ((GtkWidget*) _tmp2_, 12);
#line 300 "../src/Dialogs/Project.vala"
	gtk_widget_set_margin_start ((GtkWidget*) _tmp2_, 12);
#line 300 "../src/Dialogs/Project.vala"
	gtk_widget_set_margin_top ((GtkWidget*) _tmp2_, 6);
#line 300 "../src/Dialogs/Project.vala"
	g_object_ref_sink (_tmp2_);
#line 300 "../src/Dialogs/Project.vala"
	sources_group = _tmp2_;
#line 306 "../src/Dialogs/Project.vala"
	_tmp3_ = (GtkCheckButton*) gtk_check_button_new ();
#line 306 "../src/Dialogs/Project.vala"
	g_object_ref_sink (_tmp3_);
#line 306 "../src/Dialogs/Project.vala"
	none_radio = _tmp3_;
#line 1823 "Project.c"
	{
		GeeArrayList* _source_list = NULL;
		ServicesStore* _tmp4_;
		GeeArrayList* _tmp5_;
		GeeArrayList* _tmp6_;
		gint _source_size = 0;
		GeeArrayList* _tmp7_;
		gint _tmp8_;
		gint _tmp9_;
		gint _source_index = 0;
#line 308 "../src/Dialogs/Project.vala"
		_tmp4_ = services_store_instance ();
#line 308 "../src/Dialogs/Project.vala"
		_tmp5_ = services_store_get_sources (_tmp4_);
#line 308 "../src/Dialogs/Project.vala"
		_tmp6_ = _tmp5_;
#line 308 "../src/Dialogs/Project.vala"
		_source_list = _tmp6_;
#line 308 "../src/Dialogs/Project.vala"
		_tmp7_ = _source_list;
#line 308 "../src/Dialogs/Project.vala"
		_tmp8_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp7_);
#line 308 "../src/Dialogs/Project.vala"
		_tmp9_ = _tmp8_;
#line 308 "../src/Dialogs/Project.vala"
		_source_size = _tmp9_;
#line 308 "../src/Dialogs/Project.vala"
		_source_index = -1;
#line 308 "../src/Dialogs/Project.vala"
		while (TRUE) {
#line 1854 "Project.c"
			Block62Data* _data62_;
			gint _tmp10_;
			gint _tmp11_;
			GeeArrayList* _tmp12_;
			gpointer _tmp13_;
			GtkCheckButton* radio_button = NULL;
			GtkCheckButton* _tmp14_;
			GtkCheckButton* _tmp15_;
			ObjectsProject* _tmp16_;
			const gchar* _tmp17_;
			const gchar* _tmp18_;
			ObjectsSource* _tmp19_;
			const gchar* _tmp20_;
			const gchar* _tmp21_;
			GtkCheckButton* _tmp22_ = NULL;
			AdwActionRow* source_row = NULL;
			ObjectsSource* _tmp23_;
			const gchar* _tmp24_;
			const gchar* _tmp25_;
			gchar* _tmp26_;
			ObjectsSource* _tmp27_;
			const gchar* _tmp28_;
			const gchar* _tmp29_;
			gchar* _tmp30_;
			AdwActionRow* _tmp31_ = NULL;
			AdwActionRow* _tmp32_;
			GtkCheckButton* _tmp33_;
			AdwActionRow* _tmp34_;
			GtkCheckButton* _tmp35_;
			GeeHashMap* _tmp36_;
			AdwActionRow* _tmp37_;
			gulong _tmp38_;
			AdwActionRow* _tmp39_;
			GeeHashMap* _tmp40_;
			GtkCheckButton* _tmp41_;
			gulong _tmp42_;
			GtkCheckButton* _tmp43_;
			AdwPreferencesGroup* _tmp44_;
			AdwActionRow* _tmp45_;
#line 308 "../src/Dialogs/Project.vala"
			_data62_ = g_slice_new0 (Block62Data);
#line 308 "../src/Dialogs/Project.vala"
			_data62_->_ref_count_ = 1;
#line 308 "../src/Dialogs/Project.vala"
			_data62_->self = g_object_ref (self);
#line 308 "../src/Dialogs/Project.vala"
			_source_index = _source_index + 1;
#line 308 "../src/Dialogs/Project.vala"
			_tmp10_ = _source_index;
#line 308 "../src/Dialogs/Project.vala"
			_tmp11_ = _source_size;
#line 308 "../src/Dialogs/Project.vala"
			if (!(_tmp10_ < _tmp11_)) {
#line 308 "../src/Dialogs/Project.vala"
				block62_data_unref (_data62_);
#line 308 "../src/Dialogs/Project.vala"
				_data62_ = NULL;
#line 308 "../src/Dialogs/Project.vala"
				break;
#line 1914 "Project.c"
			}
#line 308 "../src/Dialogs/Project.vala"
			_tmp12_ = _source_list;
#line 308 "../src/Dialogs/Project.vala"
			_tmp13_ = gee_abstract_list_get ((GeeAbstractList*) _tmp12_, _source_index);
#line 308 "../src/Dialogs/Project.vala"
			_data62_->source = (ObjectsSource*) _tmp13_;
#line 309 "../src/Dialogs/Project.vala"
			_tmp14_ = none_radio;
#line 309 "../src/Dialogs/Project.vala"
			_tmp15_ = _g_object_ref0 (_tmp14_);
#line 309 "../src/Dialogs/Project.vala"
			_tmp16_ = self->priv->_project;
#line 309 "../src/Dialogs/Project.vala"
			_tmp17_ = objects_project_get_source_id (_tmp16_);
#line 309 "../src/Dialogs/Project.vala"
			_tmp18_ = _tmp17_;
#line 309 "../src/Dialogs/Project.vala"
			_tmp19_ = _data62_->source;
#line 309 "../src/Dialogs/Project.vala"
			_tmp20_ = objects_base_object_get_id ((ObjectsBaseObject*) _tmp19_);
#line 309 "../src/Dialogs/Project.vala"
			_tmp21_ = _tmp20_;
#line 309 "../src/Dialogs/Project.vala"
			_tmp22_ = (GtkCheckButton*) gtk_check_button_new ();
#line 309 "../src/Dialogs/Project.vala"
			gtk_check_button_set_group (_tmp22_, _tmp15_);
#line 309 "../src/Dialogs/Project.vala"
			_g_object_unref0 (_tmp15_);
#line 309 "../src/Dialogs/Project.vala"
			gtk_check_button_set_active (_tmp22_, g_strcmp0 (_tmp18_, _tmp21_) == 0);
#line 309 "../src/Dialogs/Project.vala"
			g_object_ref_sink (_tmp22_);
#line 309 "../src/Dialogs/Project.vala"
			radio_button = _tmp22_;
#line 314 "../src/Dialogs/Project.vala"
			_tmp23_ = _data62_->source;
#line 314 "../src/Dialogs/Project.vala"
			_tmp24_ = objects_source_get_display_name (_tmp23_);
#line 314 "../src/Dialogs/Project.vala"
			_tmp25_ = _tmp24_;
#line 314 "../src/Dialogs/Project.vala"
			_tmp26_ = g_strdup (_tmp25_);
#line 314 "../src/Dialogs/Project.vala"
			_tmp27_ = _data62_->source;
#line 314 "../src/Dialogs/Project.vala"
			_tmp28_ = objects_source_get_subheader_text (_tmp27_);
#line 314 "../src/Dialogs/Project.vala"
			_tmp29_ = _tmp28_;
#line 314 "../src/Dialogs/Project.vala"
			_tmp30_ = g_strdup (_tmp29_);
#line 314 "../src/Dialogs/Project.vala"
			_tmp31_ = (AdwActionRow*) adw_action_row_new ();
#line 314 "../src/Dialogs/Project.vala"
			gtk_list_box_row_set_activatable ((GtkListBoxRow*) _tmp31_, TRUE);
#line 314 "../src/Dialogs/Project.vala"
			adw_preferences_row_set_title ((AdwPreferencesRow*) _tmp31_, _tmp26_);
#line 314 "../src/Dialogs/Project.vala"
			_g_free0 (_tmp26_);
#line 314 "../src/Dialogs/Project.vala"
			adw_action_row_set_subtitle (_tmp31_, _tmp30_);
#line 314 "../src/Dialogs/Project.vala"
			_g_free0 (_tmp30_);
#line 314 "../src/Dialogs/Project.vala"
			g_object_ref_sink (_tmp31_);
#line 314 "../src/Dialogs/Project.vala"
			source_row = _tmp31_;
#line 320 "../src/Dialogs/Project.vala"
			_tmp32_ = source_row;
#line 320 "../src/Dialogs/Project.vala"
			_tmp33_ = radio_button;
#line 320 "../src/Dialogs/Project.vala"
			adw_action_row_add_suffix (_tmp32_, (GtkWidget*) _tmp33_);
#line 321 "../src/Dialogs/Project.vala"
			_tmp34_ = source_row;
#line 321 "../src/Dialogs/Project.vala"
			_tmp35_ = radio_button;
#line 321 "../src/Dialogs/Project.vala"
			adw_action_row_set_activatable_widget (_tmp34_, (GtkWidget*) _tmp35_);
#line 323 "../src/Dialogs/Project.vala"
			_tmp36_ = self->priv->signal_map;
#line 323 "../src/Dialogs/Project.vala"
			_tmp37_ = source_row;
#line 323 "../src/Dialogs/Project.vala"
			_tmp38_ = g_signal_connect_data (_tmp37_, "activated", (GCallback) _____lambda39__adw_action_row_activated, block62_data_ref (_data62_), (GClosureNotify) block62_data_unref, 0);
#line 323 "../src/Dialogs/Project.vala"
			_tmp39_ = source_row;
#line 323 "../src/Dialogs/Project.vala"
			gee_abstract_map_set ((GeeAbstractMap*) _tmp36_, (gpointer) ((guintptr) _tmp38_), (GObject*) _tmp39_);
#line 332 "../src/Dialogs/Project.vala"
			_tmp40_ = self->priv->signal_map;
#line 332 "../src/Dialogs/Project.vala"
			_tmp41_ = radio_button;
#line 332 "../src/Dialogs/Project.vala"
			_tmp42_ = g_signal_connect_data (_tmp41_, "toggled", (GCallback) _____lambda40__gtk_check_button_toggled, block62_data_ref (_data62_), (GClosureNotify) block62_data_unref, 0);
#line 332 "../src/Dialogs/Project.vala"
			_tmp43_ = radio_button;
#line 332 "../src/Dialogs/Project.vala"
			gee_abstract_map_set ((GeeAbstractMap*) _tmp40_, (gpointer) ((guintptr) _tmp42_), (GObject*) _tmp43_);
#line 341 "../src/Dialogs/Project.vala"
			_tmp44_ = sources_group;
#line 341 "../src/Dialogs/Project.vala"
			_tmp45_ = source_row;
#line 341 "../src/Dialogs/Project.vala"
			adw_preferences_group_add (_tmp44_, (GtkWidget*) _tmp45_);
#line 308 "../src/Dialogs/Project.vala"
			_g_object_unref0 (source_row);
#line 308 "../src/Dialogs/Project.vala"
			_g_object_unref0 (radio_button);
#line 308 "../src/Dialogs/Project.vala"
			block62_data_unref (_data62_);
#line 308 "../src/Dialogs/Project.vala"
			_data62_ = NULL;
#line 2028 "Project.c"
		}
	}
#line 344 "../src/Dialogs/Project.vala"
	_tmp46_ = sources_group;
#line 344 "../src/Dialogs/Project.vala"
	_tmp47_ = _g_object_ref0 ((GtkWidget*) _tmp46_);
#line 344 "../src/Dialogs/Project.vala"
	_tmp48_ = (AdwClamp*) adw_clamp_new ();
#line 344 "../src/Dialogs/Project.vala"
	adw_clamp_set_maximum_size (_tmp48_, 600);
#line 344 "../src/Dialogs/Project.vala"
	gtk_widget_set_margin_start ((GtkWidget*) _tmp48_, 12);
#line 344 "../src/Dialogs/Project.vala"
	gtk_widget_set_margin_end ((GtkWidget*) _tmp48_, 12);
#line 344 "../src/Dialogs/Project.vala"
	gtk_widget_set_margin_bottom ((GtkWidget*) _tmp48_, 12);
#line 344 "../src/Dialogs/Project.vala"
	gtk_widget_set_margin_top ((GtkWidget*) _tmp48_, 6);
#line 344 "../src/Dialogs/Project.vala"
	adw_clamp_set_child (_tmp48_, _tmp47_);
#line 344 "../src/Dialogs/Project.vala"
	_g_object_unref0 (_tmp47_);
#line 344 "../src/Dialogs/Project.vala"
	g_object_ref_sink (_tmp48_);
#line 344 "../src/Dialogs/Project.vala"
	content_clamp = _tmp48_;
#line 353 "../src/Dialogs/Project.vala"
	_tmp49_ = (AdwToolbarView*) adw_toolbar_view_new ();
#line 353 "../src/Dialogs/Project.vala"
	g_object_ref_sink (_tmp49_);
#line 353 "../src/Dialogs/Project.vala"
	toolbar_view = _tmp49_;
#line 354 "../src/Dialogs/Project.vala"
	_tmp50_ = headerbar;
#line 354 "../src/Dialogs/Project.vala"
	adw_toolbar_view_add_top_bar (toolbar_view, (GtkWidget*) _tmp50_);
#line 355 "../src/Dialogs/Project.vala"
	adw_toolbar_view_set_content (toolbar_view, (GtkWidget*) content_clamp);
#line 357 "../src/Dialogs/Project.vala"
	_tmp51_ = adw_navigation_page_new ((GtkWidget*) toolbar_view, _ ("Sources"));
#line 357 "../src/Dialogs/Project.vala"
	g_object_ref_sink (_tmp51_);
#line 357 "../src/Dialogs/Project.vala"
	navigation_page = _tmp51_;
#line 359 "../src/Dialogs/Project.vala"
	result = navigation_page;
#line 359 "../src/Dialogs/Project.vala"
	_g_object_unref0 (toolbar_view);
#line 359 "../src/Dialogs/Project.vala"
	_g_object_unref0 (content_clamp);
#line 359 "../src/Dialogs/Project.vala"
	_g_object_unref0 (none_radio);
#line 359 "../src/Dialogs/Project.vala"
	_g_object_unref0 (sources_group);
#line 359 "../src/Dialogs/Project.vala"
	_g_object_unref0 (headerbar);
#line 359 "../src/Dialogs/Project.vala"
	return result;
#line 2087 "Project.c"
}

static void
dialogs_project_add_update_project (DialogsProject* self)
{
	AdwEntryRow* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	ObjectsProject* _tmp5_;
	AdwEntryRow* _tmp6_;
	const gchar* _tmp7_;
	const gchar* _tmp8_;
	ObjectsProject* _tmp9_;
	WidgetsColorPickerRow* _tmp10_;
	const gchar* _tmp11_;
	const gchar* _tmp12_;
	ProjectIconStyle _tmp13_ = 0;
	GtkSwitch* _tmp14_;
	gboolean _tmp15_;
	gboolean _tmp16_;
	ObjectsProject* _tmp17_;
	ObjectsProject* _tmp18_;
	GtkLabel* _tmp19_;
	const gchar* _tmp20_;
	const gchar* _tmp21_;
	WidgetsLoadingButton* _tmp22_;
	gboolean _tmp23_;
	gboolean _tmp24_;
#line 362 "../src/Dialogs/Project.vala"
	g_return_if_fail (self != NULL);
#line 363 "../src/Dialogs/Project.vala"
	_tmp0_ = self->priv->name_entry;
#line 363 "../src/Dialogs/Project.vala"
	_tmp1_ = gtk_editable_get_text ((GtkEditable*) _tmp0_);
#line 363 "../src/Dialogs/Project.vala"
	_tmp2_ = _tmp1_;
#line 363 "../src/Dialogs/Project.vala"
	_tmp3_ = strlen (_tmp2_);
#line 363 "../src/Dialogs/Project.vala"
	_tmp4_ = _tmp3_;
#line 363 "../src/Dialogs/Project.vala"
	if (_tmp4_ <= 0) {
#line 364 "../src/Dialogs/Project.vala"
		dialogs_project_hide_destroy (self);
#line 365 "../src/Dialogs/Project.vala"
		return;
#line 2136 "Project.c"
	}
#line 368 "../src/Dialogs/Project.vala"
	_tmp5_ = self->priv->_project;
#line 368 "../src/Dialogs/Project.vala"
	_tmp6_ = self->priv->name_entry;
#line 368 "../src/Dialogs/Project.vala"
	_tmp7_ = gtk_editable_get_text ((GtkEditable*) _tmp6_);
#line 368 "../src/Dialogs/Project.vala"
	_tmp8_ = _tmp7_;
#line 368 "../src/Dialogs/Project.vala"
	objects_base_object_set_name ((ObjectsBaseObject*) _tmp5_, _tmp8_);
#line 369 "../src/Dialogs/Project.vala"
	_tmp9_ = self->priv->_project;
#line 369 "../src/Dialogs/Project.vala"
	_tmp10_ = self->priv->color_picker_row;
#line 369 "../src/Dialogs/Project.vala"
	_tmp11_ = widgets_color_picker_row_get_color (_tmp10_);
#line 369 "../src/Dialogs/Project.vala"
	_tmp12_ = _tmp11_;
#line 369 "../src/Dialogs/Project.vala"
	objects_project_set_color (_tmp9_, _tmp12_);
#line 370 "../src/Dialogs/Project.vala"
	_tmp14_ = self->priv->emoji_switch;
#line 370 "../src/Dialogs/Project.vala"
	_tmp15_ = gtk_switch_get_active (_tmp14_);
#line 370 "../src/Dialogs/Project.vala"
	_tmp16_ = _tmp15_;
#line 370 "../src/Dialogs/Project.vala"
	if (_tmp16_) {
#line 370 "../src/Dialogs/Project.vala"
		_tmp13_ = PROJECT_ICON_STYLE_EMOJI;
#line 2168 "Project.c"
	} else {
#line 370 "../src/Dialogs/Project.vala"
		_tmp13_ = PROJECT_ICON_STYLE_PROGRESS;
#line 2172 "Project.c"
	}
#line 370 "../src/Dialogs/Project.vala"
	_tmp17_ = self->priv->_project;
#line 370 "../src/Dialogs/Project.vala"
	objects_project_set_icon_style (_tmp17_, _tmp13_);
#line 371 "../src/Dialogs/Project.vala"
	_tmp18_ = self->priv->_project;
#line 371 "../src/Dialogs/Project.vala"
	_tmp19_ = self->priv->emoji_label;
#line 371 "../src/Dialogs/Project.vala"
	_tmp20_ = gtk_label_get_label (_tmp19_);
#line 371 "../src/Dialogs/Project.vala"
	_tmp21_ = _tmp20_;
#line 371 "../src/Dialogs/Project.vala"
	objects_project_set_emoji (_tmp18_, _tmp21_);
#line 373 "../src/Dialogs/Project.vala"
	_tmp22_ = self->priv->submit_button;
#line 373 "../src/Dialogs/Project.vala"
	widgets_loading_button_set_is_loading (_tmp22_, TRUE);
#line 375 "../src/Dialogs/Project.vala"
	_tmp23_ = dialogs_project_get_is_creating (self);
#line 375 "../src/Dialogs/Project.vala"
	_tmp24_ = _tmp23_;
#line 375 "../src/Dialogs/Project.vala"
	if (!_tmp24_) {
#line 376 "../src/Dialogs/Project.vala"
		dialogs_project_update_project (self, NULL, NULL);
#line 2200 "Project.c"
	} else {
#line 378 "../src/Dialogs/Project.vala"
		dialogs_project_add_project (self);
#line 2204 "Project.c"
	}
}

static void
dialogs_project_update_project_data_free (gpointer _data)
{
	DialogsProjectUpdateProjectData* _data_;
	_data_ = _data;
#line 22 "../src/Dialogs/Project.vala"
	_g_object_unref0 (_data_->self);
#line 22 "../src/Dialogs/Project.vala"
	g_slice_free (DialogsProjectUpdateProjectData, _data_);
#line 2217 "Project.c"
}

static void
dialogs_project_update_project (DialogsProject* self,
                                GAsyncReadyCallback _callback_,
                                gpointer _user_data_)
{
	DialogsProjectUpdateProjectData* _data_;
	DialogsProject* _tmp0_;
#line 22 "../src/Dialogs/Project.vala"
	g_return_if_fail (self != NULL);
#line 22 "../src/Dialogs/Project.vala"
	_data_ = g_slice_new0 (DialogsProjectUpdateProjectData);
#line 22 "../src/Dialogs/Project.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 22 "../src/Dialogs/Project.vala"
	g_task_set_task_data (_data_->_async_result, _data_, dialogs_project_update_project_data_free);
#line 22 "../src/Dialogs/Project.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 22 "../src/Dialogs/Project.vala"
	_data_->self = _tmp0_;
#line 22 "../src/Dialogs/Project.vala"
	dialogs_project_update_project_co (_data_);
#line 2241 "Project.c"
}

static void
dialogs_project_update_project_finish (DialogsProject* self,
                                       GAsyncResult* _res_)
{
	DialogsProjectUpdateProjectData* _data_;
#line 22 "../src/Dialogs/Project.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 2251 "Project.c"
}

static void
dialogs_project_update_project_ready (GObject* source_object,
                                      GAsyncResult* _res_,
                                      gpointer _user_data_)
{
	DialogsProjectUpdateProjectData* _data_;
#line 393 "../src/Dialogs/Project.vala"
	_data_ = _user_data_;
#line 393 "../src/Dialogs/Project.vala"
	_data_->_source_object_ = source_object;
#line 393 "../src/Dialogs/Project.vala"
	_data_->_res_ = _res_;
#line 393 "../src/Dialogs/Project.vala"
	dialogs_project_update_project_co (_data_);
#line 2268 "Project.c"
}

static gboolean
dialogs_project_update_project_co (DialogsProjectUpdateProjectData* _data_)
{
#line 383 "../src/Dialogs/Project.vala"
	switch (_data_->_state_) {
#line 383 "../src/Dialogs/Project.vala"
		case 0:
#line 2278 "Project.c"
		goto _state_0;
#line 383 "../src/Dialogs/Project.vala"
		case 1:
#line 2282 "Project.c"
		goto _state_1;
#line 383 "../src/Dialogs/Project.vala"
		case 2:
#line 2286 "Project.c"
		goto _state_2;
		default:
#line 383 "../src/Dialogs/Project.vala"
		g_assert_not_reached ();
#line 2291 "Project.c"
	}
	_state_0:
#line 384 "../src/Dialogs/Project.vala"
	_data_->_tmp0_ = _data_->self->priv->_project;
#line 384 "../src/Dialogs/Project.vala"
	_data_->_tmp1_ = objects_project_get_source_type (_data_->_tmp0_);
#line 384 "../src/Dialogs/Project.vala"
	_data_->_tmp2_ = _data_->_tmp1_;
#line 384 "../src/Dialogs/Project.vala"
	if (_data_->_tmp2_ == SOURCE_TYPE_LOCAL) {
#line 385 "../src/Dialogs/Project.vala"
		_data_->_tmp3_ = services_store_instance ();
#line 385 "../src/Dialogs/Project.vala"
		_data_->_tmp4_ = _data_->self->priv->_project;
#line 385 "../src/Dialogs/Project.vala"
		services_store_update_project (_data_->_tmp3_, _data_->_tmp4_);
#line 386 "../src/Dialogs/Project.vala"
		dialogs_project_hide_destroy (_data_->self);
#line 387 "../src/Dialogs/Project.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 387 "../src/Dialogs/Project.vala"
		if (_data_->_state_ != 0) {
#line 387 "../src/Dialogs/Project.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 387 "../src/Dialogs/Project.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 2318 "Project.c"
			}
		}
#line 387 "../src/Dialogs/Project.vala"
		g_object_unref (_data_->_async_result);
#line 387 "../src/Dialogs/Project.vala"
		return FALSE;
#line 2325 "Project.c"
	}
#line 392 "../src/Dialogs/Project.vala"
	_data_->_tmp5_ = _data_->self->priv->_project;
#line 392 "../src/Dialogs/Project.vala"
	_data_->_tmp6_ = objects_project_get_source_type (_data_->_tmp5_);
#line 392 "../src/Dialogs/Project.vala"
	_data_->_tmp7_ = _data_->_tmp6_;
#line 392 "../src/Dialogs/Project.vala"
	if (_data_->_tmp7_ == SOURCE_TYPE_TODOIST) {
#line 393 "../src/Dialogs/Project.vala"
		_data_->_tmp8_ = services_todoist_get_default ();
#line 393 "../src/Dialogs/Project.vala"
		_data_->_tmp9_ = _data_->_tmp8_;
#line 393 "../src/Dialogs/Project.vala"
		_data_->_tmp10_ = _data_->self->priv->_project;
#line 393 "../src/Dialogs/Project.vala"
		_data_->_state_ = 1;
#line 393 "../src/Dialogs/Project.vala"
		services_todoist_update (_data_->_tmp9_, (ObjectsBaseObject*) _data_->_tmp10_, dialogs_project_update_project_ready, _data_);
#line 393 "../src/Dialogs/Project.vala"
		return FALSE;
#line 2347 "Project.c"
		_state_1:
#line 393 "../src/Dialogs/Project.vala"
		_data_->_tmp11_ = services_todoist_update_finish (_data_->_tmp9_, _data_->_res_);
#line 393 "../src/Dialogs/Project.vala"
		_http_response_unref0 (_data_->response);
#line 393 "../src/Dialogs/Project.vala"
		_data_->response = _data_->_tmp11_;
#line 393 "../src/Dialogs/Project.vala"
		_g_object_unref0 (_data_->_tmp9_);
#line 2357 "Project.c"
	} else {
#line 395 "../src/Dialogs/Project.vala"
		_data_->_tmp12_ = services_cal_dav_core_get_default ();
#line 395 "../src/Dialogs/Project.vala"
		_data_->_tmp13_ = _data_->_tmp12_;
#line 395 "../src/Dialogs/Project.vala"
		_data_->_tmp14_ = _data_->self->priv->_project;
#line 395 "../src/Dialogs/Project.vala"
		_data_->_state_ = 2;
#line 395 "../src/Dialogs/Project.vala"
		services_cal_dav_core_update_tasklist (_data_->_tmp13_, _data_->_tmp14_, dialogs_project_update_project_ready, _data_);
#line 395 "../src/Dialogs/Project.vala"
		return FALSE;
#line 2371 "Project.c"
		_state_2:
#line 395 "../src/Dialogs/Project.vala"
		_data_->_tmp15_ = services_cal_dav_core_update_tasklist_finish (_data_->_tmp13_, _data_->_res_);
#line 395 "../src/Dialogs/Project.vala"
		_http_response_unref0 (_data_->response);
#line 395 "../src/Dialogs/Project.vala"
		_data_->response = _data_->_tmp15_;
#line 395 "../src/Dialogs/Project.vala"
		_g_object_unref0 (_data_->_tmp13_);
#line 2381 "Project.c"
	}
#line 398 "../src/Dialogs/Project.vala"
	_data_->_tmp16_ = _data_->response;
#line 398 "../src/Dialogs/Project.vala"
	if (_data_->_tmp16_ == NULL) {
#line 399 "../src/Dialogs/Project.vala"
		dialogs_project_hide_destroy (_data_->self);
#line 400 "../src/Dialogs/Project.vala"
		_http_response_unref0 (_data_->response);
#line 400 "../src/Dialogs/Project.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 400 "../src/Dialogs/Project.vala"
		if (_data_->_state_ != 0) {
#line 400 "../src/Dialogs/Project.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 400 "../src/Dialogs/Project.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 2399 "Project.c"
			}
		}
#line 400 "../src/Dialogs/Project.vala"
		g_object_unref (_data_->_async_result);
#line 400 "../src/Dialogs/Project.vala"
		return FALSE;
#line 2406 "Project.c"
	}
#line 403 "../src/Dialogs/Project.vala"
	_data_->_tmp17_ = _data_->response;
#line 403 "../src/Dialogs/Project.vala"
	_data_->_tmp18_ = http_response_get_status (_data_->_tmp17_);
#line 403 "../src/Dialogs/Project.vala"
	_data_->_tmp19_ = _data_->_tmp18_;
#line 403 "../src/Dialogs/Project.vala"
	if (_data_->_tmp19_) {
#line 404 "../src/Dialogs/Project.vala"
		_data_->_tmp20_ = services_store_instance ();
#line 404 "../src/Dialogs/Project.vala"
		_data_->_tmp21_ = _data_->self->priv->_project;
#line 404 "../src/Dialogs/Project.vala"
		services_store_update_project (_data_->_tmp20_, _data_->_tmp21_);
#line 405 "../src/Dialogs/Project.vala"
		dialogs_project_hide_destroy (_data_->self);
#line 2424 "Project.c"
	} else {
#line 407 "../src/Dialogs/Project.vala"
		_data_->_tmp22_ = services_event_bus_get_default ();
#line 407 "../src/Dialogs/Project.vala"
		_data_->_tmp23_ = _data_->_tmp22_;
#line 407 "../src/Dialogs/Project.vala"
		_data_->_tmp24_ = _data_->response;
#line 407 "../src/Dialogs/Project.vala"
		_data_->_tmp25_ = http_response_get_error_code (_data_->_tmp24_);
#line 407 "../src/Dialogs/Project.vala"
		_data_->_tmp26_ = _data_->_tmp25_;
#line 407 "../src/Dialogs/Project.vala"
		_data_->_tmp27_ = _data_->response;
#line 407 "../src/Dialogs/Project.vala"
		_data_->_tmp28_ = http_response_get_error (_data_->_tmp27_);
#line 407 "../src/Dialogs/Project.vala"
		_data_->_tmp29_ = _data_->_tmp28_;
#line 407 "../src/Dialogs/Project.vala"
		g_signal_emit_by_name (_data_->_tmp23_, "send-error-toast", _data_->_tmp26_, _data_->_tmp29_);
#line 407 "../src/Dialogs/Project.vala"
		_g_object_unref0 (_data_->_tmp23_);
#line 408 "../src/Dialogs/Project.vala"
		dialogs_project_hide_destroy (_data_->self);
#line 2448 "Project.c"
	}
#line 383 "../src/Dialogs/Project.vala"
	_http_response_unref0 (_data_->response);
#line 383 "../src/Dialogs/Project.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 383 "../src/Dialogs/Project.vala"
	if (_data_->_state_ != 0) {
#line 383 "../src/Dialogs/Project.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 383 "../src/Dialogs/Project.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 2460 "Project.c"
		}
	}
#line 383 "../src/Dialogs/Project.vala"
	g_object_unref (_data_->_async_result);
#line 383 "../src/Dialogs/Project.vala"
	return FALSE;
#line 2467 "Project.c"
}

static void
____lambda32_ (DialogsProject* self,
               GObject* obj,
               GAsyncResult* res)
{
	HttpResponse* response = NULL;
	ServicesTodoist* _tmp0_;
	ServicesTodoist* _tmp1_;
	HttpResponse* _tmp2_;
	HttpResponse* _tmp3_;
	HttpResponse* _tmp4_;
	gboolean _tmp5_;
	gboolean _tmp6_;
#line 420 "../src/Dialogs/Project.vala"
	g_return_if_fail (res != NULL);
#line 421 "../src/Dialogs/Project.vala"
	_tmp0_ = services_todoist_get_default ();
#line 421 "../src/Dialogs/Project.vala"
	_tmp1_ = _tmp0_;
#line 421 "../src/Dialogs/Project.vala"
	_tmp2_ = services_todoist_add_finish (_tmp1_, res);
#line 421 "../src/Dialogs/Project.vala"
	_tmp3_ = _tmp2_;
#line 421 "../src/Dialogs/Project.vala"
	_g_object_unref0 (_tmp1_);
#line 421 "../src/Dialogs/Project.vala"
	response = _tmp3_;
#line 423 "../src/Dialogs/Project.vala"
	_tmp4_ = response;
#line 423 "../src/Dialogs/Project.vala"
	_tmp5_ = http_response_get_status (_tmp4_);
#line 423 "../src/Dialogs/Project.vala"
	_tmp6_ = _tmp5_;
#line 423 "../src/Dialogs/Project.vala"
	if (_tmp6_) {
#line 2505 "Project.c"
		ObjectsProject* _tmp7_;
		HttpResponse* _tmp8_;
		const gchar* _tmp9_;
		const gchar* _tmp10_;
		ServicesStore* _tmp11_;
		ObjectsProject* _tmp12_;
		ObjectsProject* _tmp13_;
		const gchar* _tmp14_;
		const gchar* _tmp15_;
#line 424 "../src/Dialogs/Project.vala"
		_tmp7_ = self->priv->_project;
#line 424 "../src/Dialogs/Project.vala"
		_tmp8_ = response;
#line 424 "../src/Dialogs/Project.vala"
		_tmp9_ = http_response_get_data (_tmp8_);
#line 424 "../src/Dialogs/Project.vala"
		_tmp10_ = _tmp9_;
#line 424 "../src/Dialogs/Project.vala"
		objects_base_object_set_id ((ObjectsBaseObject*) _tmp7_, _tmp10_);
#line 425 "../src/Dialogs/Project.vala"
		_tmp11_ = services_store_instance ();
#line 425 "../src/Dialogs/Project.vala"
		_tmp12_ = self->priv->_project;
#line 425 "../src/Dialogs/Project.vala"
		services_store_insert_project (_tmp11_, _tmp12_);
#line 426 "../src/Dialogs/Project.vala"
		_tmp13_ = self->priv->_project;
#line 426 "../src/Dialogs/Project.vala"
		_tmp14_ = objects_base_object_get_id ((ObjectsBaseObject*) _tmp13_);
#line 426 "../src/Dialogs/Project.vala"
		_tmp15_ = _tmp14_;
#line 426 "../src/Dialogs/Project.vala"
		dialogs_project_go_project (self, _tmp15_);
#line 2539 "Project.c"
	} else {
		ServicesEventBus* _tmp16_;
		ServicesEventBus* _tmp17_;
		HttpResponse* _tmp18_;
		gint _tmp19_;
		gint _tmp20_;
		HttpResponse* _tmp21_;
		const gchar* _tmp22_;
		const gchar* _tmp23_;
#line 428 "../src/Dialogs/Project.vala"
		_tmp16_ = services_event_bus_get_default ();
#line 428 "../src/Dialogs/Project.vala"
		_tmp17_ = _tmp16_;
#line 428 "../src/Dialogs/Project.vala"
		_tmp18_ = response;
#line 428 "../src/Dialogs/Project.vala"
		_tmp19_ = http_response_get_error_code (_tmp18_);
#line 428 "../src/Dialogs/Project.vala"
		_tmp20_ = _tmp19_;
#line 428 "../src/Dialogs/Project.vala"
		_tmp21_ = response;
#line 428 "../src/Dialogs/Project.vala"
		_tmp22_ = http_response_get_error (_tmp21_);
#line 428 "../src/Dialogs/Project.vala"
		_tmp23_ = _tmp22_;
#line 428 "../src/Dialogs/Project.vala"
		g_signal_emit_by_name (_tmp17_, "send-error-toast", _tmp20_, _tmp23_);
#line 428 "../src/Dialogs/Project.vala"
		_g_object_unref0 (_tmp17_);
#line 429 "../src/Dialogs/Project.vala"
		dialogs_project_hide_destroy (self);
#line 2571 "Project.c"
	}
#line 420 "../src/Dialogs/Project.vala"
	_http_response_unref0 (response);
#line 2575 "Project.c"
}

static void
_____lambda32__gasync_ready_callback (GObject* source_object,
                                      GAsyncResult* res,
                                      gpointer self)
{
#line 420 "../src/Dialogs/Project.vala"
	____lambda32_ ((DialogsProject*) self, source_object, res);
#line 420 "../src/Dialogs/Project.vala"
	g_object_unref (self);
#line 2587 "Project.c"
}

static void
_____lambda33_ (DialogsProject* self,
                GObject* obj,
                GAsyncResult* res)
{
	HttpResponse* response = NULL;
	ServicesCalDAVCore* _tmp0_;
	ServicesCalDAVCore* _tmp1_;
	HttpResponse* _tmp2_;
	HttpResponse* _tmp3_;
	HttpResponse* _tmp4_;
	gboolean _tmp5_;
	gboolean _tmp6_;
#line 434 "../src/Dialogs/Project.vala"
	g_return_if_fail (res != NULL);
#line 435 "../src/Dialogs/Project.vala"
	_tmp0_ = services_cal_dav_core_get_default ();
#line 435 "../src/Dialogs/Project.vala"
	_tmp1_ = _tmp0_;
#line 435 "../src/Dialogs/Project.vala"
	_tmp2_ = services_cal_dav_core_add_tasklist_finish (_tmp1_, res);
#line 435 "../src/Dialogs/Project.vala"
	_tmp3_ = _tmp2_;
#line 435 "../src/Dialogs/Project.vala"
	_g_object_unref0 (_tmp1_);
#line 435 "../src/Dialogs/Project.vala"
	response = _tmp3_;
#line 437 "../src/Dialogs/Project.vala"
	_tmp4_ = response;
#line 437 "../src/Dialogs/Project.vala"
	_tmp5_ = http_response_get_status (_tmp4_);
#line 437 "../src/Dialogs/Project.vala"
	_tmp6_ = _tmp5_;
#line 437 "../src/Dialogs/Project.vala"
	if (_tmp6_) {
#line 2625 "Project.c"
		ServicesStore* _tmp7_;
		ObjectsProject* _tmp8_;
		ServicesCalDAVCore* _tmp9_;
		ServicesCalDAVCore* _tmp10_;
		ObjectsProject* _tmp11_;
		ObjectsProject* _tmp12_;
		const gchar* _tmp13_;
		const gchar* _tmp14_;
#line 438 "../src/Dialogs/Project.vala"
		_tmp7_ = services_store_instance ();
#line 438 "../src/Dialogs/Project.vala"
		_tmp8_ = self->priv->_project;
#line 438 "../src/Dialogs/Project.vala"
		services_store_insert_project (_tmp7_, _tmp8_);
#line 439 "../src/Dialogs/Project.vala"
		_tmp9_ = services_cal_dav_core_get_default ();
#line 439 "../src/Dialogs/Project.vala"
		_tmp10_ = _tmp9_;
#line 439 "../src/Dialogs/Project.vala"
		_tmp11_ = self->priv->_project;
#line 439 "../src/Dialogs/Project.vala"
		services_cal_dav_core_update_sync_token (_tmp10_, _tmp11_, NULL, NULL);
#line 439 "../src/Dialogs/Project.vala"
		_g_object_unref0 (_tmp10_);
#line 440 "../src/Dialogs/Project.vala"
		_tmp12_ = self->priv->_project;
#line 440 "../src/Dialogs/Project.vala"
		_tmp13_ = objects_base_object_get_id ((ObjectsBaseObject*) _tmp12_);
#line 440 "../src/Dialogs/Project.vala"
		_tmp14_ = _tmp13_;
#line 440 "../src/Dialogs/Project.vala"
		dialogs_project_go_project (self, _tmp14_);
#line 2658 "Project.c"
	} else {
		ServicesEventBus* _tmp15_;
		ServicesEventBus* _tmp16_;
		HttpResponse* _tmp17_;
		gint _tmp18_;
		gint _tmp19_;
		HttpResponse* _tmp20_;
		const gchar* _tmp21_;
		const gchar* _tmp22_;
#line 442 "../src/Dialogs/Project.vala"
		_tmp15_ = services_event_bus_get_default ();
#line 442 "../src/Dialogs/Project.vala"
		_tmp16_ = _tmp15_;
#line 442 "../src/Dialogs/Project.vala"
		_tmp17_ = response;
#line 442 "../src/Dialogs/Project.vala"
		_tmp18_ = http_response_get_error_code (_tmp17_);
#line 442 "../src/Dialogs/Project.vala"
		_tmp19_ = _tmp18_;
#line 442 "../src/Dialogs/Project.vala"
		_tmp20_ = response;
#line 442 "../src/Dialogs/Project.vala"
		_tmp21_ = http_response_get_error (_tmp20_);
#line 442 "../src/Dialogs/Project.vala"
		_tmp22_ = _tmp21_;
#line 442 "../src/Dialogs/Project.vala"
		g_signal_emit_by_name (_tmp16_, "send-error-toast", _tmp19_, _tmp22_);
#line 442 "../src/Dialogs/Project.vala"
		_g_object_unref0 (_tmp16_);
#line 443 "../src/Dialogs/Project.vala"
		dialogs_project_hide_destroy (self);
#line 2690 "Project.c"
	}
#line 434 "../src/Dialogs/Project.vala"
	_http_response_unref0 (response);
#line 2694 "Project.c"
}

static void
______lambda33__gasync_ready_callback (GObject* source_object,
                                       GAsyncResult* res,
                                       gpointer self)
{
#line 434 "../src/Dialogs/Project.vala"
	_____lambda33_ ((DialogsProject*) self, source_object, res);
#line 434 "../src/Dialogs/Project.vala"
	g_object_unref (self);
#line 2706 "Project.c"
}

static void
dialogs_project_add_project (DialogsProject* self)
{
	ObjectsProject* _tmp0_;
	ServicesStore* _tmp1_;
	ObjectsProject* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	GeeArrayList* _tmp5_;
	GeeArrayList* _tmp6_;
	gint _tmp7_;
	gint _tmp8_;
	gboolean _tmp9_ = FALSE;
	ObjectsProject* _tmp10_;
	SourceType _tmp11_;
	SourceType _tmp12_;
#line 412 "../src/Dialogs/Project.vala"
	g_return_if_fail (self != NULL);
#line 413 "../src/Dialogs/Project.vala"
	_tmp0_ = self->priv->_project;
#line 413 "../src/Dialogs/Project.vala"
	_tmp1_ = services_store_instance ();
#line 413 "../src/Dialogs/Project.vala"
	_tmp2_ = self->priv->_project;
#line 413 "../src/Dialogs/Project.vala"
	_tmp3_ = objects_project_get_source_id (_tmp2_);
#line 413 "../src/Dialogs/Project.vala"
	_tmp4_ = _tmp3_;
#line 413 "../src/Dialogs/Project.vala"
	_tmp5_ = services_store_get_projects_by_source (_tmp1_, _tmp4_);
#line 413 "../src/Dialogs/Project.vala"
	_tmp6_ = _tmp5_;
#line 413 "../src/Dialogs/Project.vala"
	_tmp7_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp6_);
#line 413 "../src/Dialogs/Project.vala"
	_tmp8_ = _tmp7_;
#line 413 "../src/Dialogs/Project.vala"
	objects_project_set_child_order (_tmp0_, _tmp8_);
#line 413 "../src/Dialogs/Project.vala"
	_g_object_unref0 (_tmp6_);
#line 415 "../src/Dialogs/Project.vala"
	_tmp10_ = self->priv->_project;
#line 415 "../src/Dialogs/Project.vala"
	_tmp11_ = objects_project_get_source_type (_tmp10_);
#line 415 "../src/Dialogs/Project.vala"
	_tmp12_ = _tmp11_;
#line 415 "../src/Dialogs/Project.vala"
	if (_tmp12_ == SOURCE_TYPE_LOCAL) {
#line 415 "../src/Dialogs/Project.vala"
		_tmp9_ = TRUE;
#line 2759 "Project.c"
	} else {
		ObjectsProject* _tmp13_;
		SourceType _tmp14_;
		SourceType _tmp15_;
#line 415 "../src/Dialogs/Project.vala"
		_tmp13_ = self->priv->_project;
#line 415 "../src/Dialogs/Project.vala"
		_tmp14_ = objects_project_get_source_type (_tmp13_);
#line 415 "../src/Dialogs/Project.vala"
		_tmp15_ = _tmp14_;
#line 415 "../src/Dialogs/Project.vala"
		_tmp9_ = _tmp15_ == SOURCE_TYPE_NONE;
#line 2772 "Project.c"
	}
#line 415 "../src/Dialogs/Project.vala"
	if (_tmp9_) {
#line 2776 "Project.c"
		ObjectsProject* _tmp16_;
		Util* _tmp17_;
		Util* _tmp18_;
		ObjectsProject* _tmp19_;
		gchar* _tmp20_;
		gchar* _tmp21_;
		ServicesStore* _tmp22_;
		ObjectsProject* _tmp23_;
		ObjectsProject* _tmp24_;
		const gchar* _tmp25_;
		const gchar* _tmp26_;
#line 416 "../src/Dialogs/Project.vala"
		_tmp16_ = self->priv->_project;
#line 416 "../src/Dialogs/Project.vala"
		_tmp17_ = util_get_default ();
#line 416 "../src/Dialogs/Project.vala"
		_tmp18_ = _tmp17_;
#line 416 "../src/Dialogs/Project.vala"
		_tmp19_ = self->priv->_project;
#line 416 "../src/Dialogs/Project.vala"
		_tmp20_ = util_generate_id (_tmp18_, (ObjectsBaseObject*) _tmp19_);
#line 416 "../src/Dialogs/Project.vala"
		_tmp21_ = _tmp20_;
#line 416 "../src/Dialogs/Project.vala"
		objects_base_object_set_id ((ObjectsBaseObject*) _tmp16_, _tmp21_);
#line 416 "../src/Dialogs/Project.vala"
		_g_free0 (_tmp21_);
#line 416 "../src/Dialogs/Project.vala"
		_g_object_unref0 (_tmp18_);
#line 417 "../src/Dialogs/Project.vala"
		_tmp22_ = services_store_instance ();
#line 417 "../src/Dialogs/Project.vala"
		_tmp23_ = self->priv->_project;
#line 417 "../src/Dialogs/Project.vala"
		services_store_insert_project (_tmp22_, _tmp23_);
#line 418 "../src/Dialogs/Project.vala"
		_tmp24_ = self->priv->_project;
#line 418 "../src/Dialogs/Project.vala"
		_tmp25_ = objects_base_object_get_id ((ObjectsBaseObject*) _tmp24_);
#line 418 "../src/Dialogs/Project.vala"
		_tmp26_ = _tmp25_;
#line 418 "../src/Dialogs/Project.vala"
		dialogs_project_go_project (self, _tmp26_);
#line 2820 "Project.c"
	} else {
		ObjectsProject* _tmp27_;
		SourceType _tmp28_;
		SourceType _tmp29_;
#line 419 "../src/Dialogs/Project.vala"
		_tmp27_ = self->priv->_project;
#line 419 "../src/Dialogs/Project.vala"
		_tmp28_ = objects_project_get_source_type (_tmp27_);
#line 419 "../src/Dialogs/Project.vala"
		_tmp29_ = _tmp28_;
#line 419 "../src/Dialogs/Project.vala"
		if (_tmp29_ == SOURCE_TYPE_TODOIST) {
#line 2833 "Project.c"
			ServicesTodoist* _tmp30_;
			ServicesTodoist* _tmp31_;
			ObjectsProject* _tmp32_;
#line 420 "../src/Dialogs/Project.vala"
			_tmp30_ = services_todoist_get_default ();
#line 420 "../src/Dialogs/Project.vala"
			_tmp31_ = _tmp30_;
#line 420 "../src/Dialogs/Project.vala"
			_tmp32_ = self->priv->_project;
#line 420 "../src/Dialogs/Project.vala"
			services_todoist_add (_tmp31_, (ObjectsBaseObject*) _tmp32_, _____lambda32__gasync_ready_callback, g_object_ref (self));
#line 420 "../src/Dialogs/Project.vala"
			_g_object_unref0 (_tmp31_);
#line 2847 "Project.c"
		} else {
			ObjectsProject* _tmp33_;
			SourceType _tmp34_;
			SourceType _tmp35_;
#line 432 "../src/Dialogs/Project.vala"
			_tmp33_ = self->priv->_project;
#line 432 "../src/Dialogs/Project.vala"
			_tmp34_ = objects_project_get_source_type (_tmp33_);
#line 432 "../src/Dialogs/Project.vala"
			_tmp35_ = _tmp34_;
#line 432 "../src/Dialogs/Project.vala"
			if (_tmp35_ == SOURCE_TYPE_CALDAV) {
#line 2860 "Project.c"
				ObjectsProject* _tmp36_;
				Util* _tmp37_;
				Util* _tmp38_;
				ObjectsProject* _tmp39_;
				gchar* _tmp40_;
				gchar* _tmp41_;
				ServicesCalDAVCore* _tmp42_;
				ServicesCalDAVCore* _tmp43_;
				ObjectsProject* _tmp44_;
#line 433 "../src/Dialogs/Project.vala"
				_tmp36_ = self->priv->_project;
#line 433 "../src/Dialogs/Project.vala"
				_tmp37_ = util_get_default ();
#line 433 "../src/Dialogs/Project.vala"
				_tmp38_ = _tmp37_;
#line 433 "../src/Dialogs/Project.vala"
				_tmp39_ = self->priv->_project;
#line 433 "../src/Dialogs/Project.vala"
				_tmp40_ = util_generate_id (_tmp38_, (ObjectsBaseObject*) _tmp39_);
#line 433 "../src/Dialogs/Project.vala"
				_tmp41_ = _tmp40_;
#line 433 "../src/Dialogs/Project.vala"
				objects_base_object_set_id ((ObjectsBaseObject*) _tmp36_, _tmp41_);
#line 433 "../src/Dialogs/Project.vala"
				_g_free0 (_tmp41_);
#line 433 "../src/Dialogs/Project.vala"
				_g_object_unref0 (_tmp38_);
#line 434 "../src/Dialogs/Project.vala"
				_tmp42_ = services_cal_dav_core_get_default ();
#line 434 "../src/Dialogs/Project.vala"
				_tmp43_ = _tmp42_;
#line 434 "../src/Dialogs/Project.vala"
				_tmp44_ = self->priv->_project;
#line 434 "../src/Dialogs/Project.vala"
				services_cal_dav_core_add_tasklist (_tmp43_, _tmp44_, ______lambda33__gasync_ready_callback, g_object_ref (self));
#line 434 "../src/Dialogs/Project.vala"
				_g_object_unref0 (_tmp43_);
#line 2898 "Project.c"
			}
		}
	}
}

static Block63Data*
block63_data_ref (Block63Data* _data63_)
{
#line 449 "../src/Dialogs/Project.vala"
	g_atomic_int_inc (&_data63_->_ref_count_);
#line 449 "../src/Dialogs/Project.vala"
	return _data63_;
#line 2911 "Project.c"
}

static void
block63_data_unref (void * _userdata_)
{
	Block63Data* _data63_;
	_data63_ = (Block63Data*) _userdata_;
#line 449 "../src/Dialogs/Project.vala"
	if (g_atomic_int_dec_and_test (&_data63_->_ref_count_)) {
#line 2921 "Project.c"
		DialogsProject* self;
#line 449 "../src/Dialogs/Project.vala"
		self = _data63_->self;
#line 449 "../src/Dialogs/Project.vala"
		_g_free0 (_data63_->id);
#line 449 "../src/Dialogs/Project.vala"
		_g_object_unref0 (self);
#line 449 "../src/Dialogs/Project.vala"
		g_slice_free (Block63Data, _data63_);
#line 2931 "Project.c"
	}
}

static gboolean
__lambda31_ (Block63Data* _data63_)
{
	DialogsProject* self;
	ServicesEventBus* _tmp0_;
	ServicesEventBus* _tmp1_;
	Util* _tmp2_;
	Util* _tmp3_;
	AdwToast* _tmp4_;
	AdwToast* _tmp5_;
	ServicesEventBus* _tmp6_;
	ServicesEventBus* _tmp7_;
	gboolean result;
#line 450 "../src/Dialogs/Project.vala"
	self = _data63_->self;
#line 451 "../src/Dialogs/Project.vala"
	_tmp0_ = services_event_bus_get_default ();
#line 451 "../src/Dialogs/Project.vala"
	_tmp1_ = _tmp0_;
#line 451 "../src/Dialogs/Project.vala"
	_tmp2_ = util_get_default ();
#line 451 "../src/Dialogs/Project.vala"
	_tmp3_ = _tmp2_;
#line 451 "../src/Dialogs/Project.vala"
	_tmp4_ = util_create_toast (_tmp3_, _ ("Project added successfully!"), (guint) 2, ADW_TOAST_PRIORITY_NORMAL);
#line 451 "../src/Dialogs/Project.vala"
	_tmp5_ = _tmp4_;
#line 451 "../src/Dialogs/Project.vala"
	g_signal_emit_by_name (_tmp1_, "send-toast", _tmp5_);
#line 451 "../src/Dialogs/Project.vala"
	_g_object_unref0 (_tmp5_);
#line 451 "../src/Dialogs/Project.vala"
	_g_object_unref0 (_tmp3_);
#line 451 "../src/Dialogs/Project.vala"
	_g_object_unref0 (_tmp1_);
#line 454 "../src/Dialogs/Project.vala"
	_tmp6_ = services_event_bus_get_default ();
#line 454 "../src/Dialogs/Project.vala"
	_tmp7_ = _tmp6_;
#line 454 "../src/Dialogs/Project.vala"
	g_signal_emit_by_name (_tmp7_, "pane-selected", PANE_TYPE_PROJECT, _data63_->id);
#line 454 "../src/Dialogs/Project.vala"
	_g_object_unref0 (_tmp7_);
#line 455 "../src/Dialogs/Project.vala"
	dialogs_project_hide_destroy (self);
#line 456 "../src/Dialogs/Project.vala"
	result = G_SOURCE_REMOVE;
#line 456 "../src/Dialogs/Project.vala"
	return result;
#line 2984 "Project.c"
}

static gboolean
___lambda31__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda31_ (self);
#line 450 "../src/Dialogs/Project.vala"
	return result;
#line 2994 "Project.c"
}

void
dialogs_project_go_project (DialogsProject* self,
                            const gchar* id)
{
	Block63Data* _data63_;
	gchar* _tmp0_;
#line 449 "../src/Dialogs/Project.vala"
	g_return_if_fail (self != NULL);
#line 449 "../src/Dialogs/Project.vala"
	g_return_if_fail (id != NULL);
#line 449 "../src/Dialogs/Project.vala"
	_data63_ = g_slice_new0 (Block63Data);
#line 449 "../src/Dialogs/Project.vala"
	_data63_->_ref_count_ = 1;
#line 449 "../src/Dialogs/Project.vala"
	_data63_->self = g_object_ref (self);
#line 449 "../src/Dialogs/Project.vala"
	_tmp0_ = g_strdup (id);
#line 449 "../src/Dialogs/Project.vala"
	_g_free0 (_data63_->id);
#line 449 "../src/Dialogs/Project.vala"
	_data63_->id = _tmp0_;
#line 450 "../src/Dialogs/Project.vala"
	g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 250, ___lambda31__gsource_func, block63_data_ref (_data63_), block63_data_unref);
#line 449 "../src/Dialogs/Project.vala"
	block63_data_unref (_data63_);
#line 449 "../src/Dialogs/Project.vala"
	_data63_ = NULL;
#line 3025 "Project.c"
}

void
dialogs_project_hide_destroy (DialogsProject* self)
{
#line 460 "../src/Dialogs/Project.vala"
	g_return_if_fail (self != NULL);
#line 461 "../src/Dialogs/Project.vala"
	adw_dialog_close ((AdwDialog*) self);
#line 3035 "Project.c"
}

ObjectsProject*
dialogs_project_get_project (DialogsProject* self)
{
	ObjectsProject* result;
	ObjectsProject* _tmp0_;
#line 23 "../src/Dialogs/Project.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 23 "../src/Dialogs/Project.vala"
	_tmp0_ = self->priv->_project;
#line 23 "../src/Dialogs/Project.vala"
	result = _tmp0_;
#line 23 "../src/Dialogs/Project.vala"
	return result;
#line 3051 "Project.c"
}

static void
dialogs_project_set_project (DialogsProject* self,
                             ObjectsProject* value)
{
	ObjectsProject* old_value;
#line 23 "../src/Dialogs/Project.vala"
	g_return_if_fail (self != NULL);
#line 23 "../src/Dialogs/Project.vala"
	old_value = dialogs_project_get_project (self);
#line 23 "../src/Dialogs/Project.vala"
	if (old_value != value) {
#line 3065 "Project.c"
		ObjectsProject* _tmp0_;
#line 23 "../src/Dialogs/Project.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 23 "../src/Dialogs/Project.vala"
		_g_object_unref0 (self->priv->_project);
#line 23 "../src/Dialogs/Project.vala"
		self->priv->_project = _tmp0_;
#line 23 "../src/Dialogs/Project.vala"
		g_object_notify_by_pspec ((GObject *) self, dialogs_project_properties[DIALOGS_PROJECT_PROJECT_PROPERTY]);
#line 3075 "Project.c"
	}
}

gboolean
dialogs_project_get_backend_picker (DialogsProject* self)
{
	gboolean result;
#line 24 "../src/Dialogs/Project.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 24 "../src/Dialogs/Project.vala"
	result = self->priv->_backend_picker;
#line 24 "../src/Dialogs/Project.vala"
	return result;
#line 3089 "Project.c"
}

static void
dialogs_project_set_backend_picker (DialogsProject* self,
                                    gboolean value)
{
	gboolean old_value;
#line 24 "../src/Dialogs/Project.vala"
	g_return_if_fail (self != NULL);
#line 24 "../src/Dialogs/Project.vala"
	old_value = dialogs_project_get_backend_picker (self);
#line 24 "../src/Dialogs/Project.vala"
	if (old_value != value) {
#line 24 "../src/Dialogs/Project.vala"
		self->priv->_backend_picker = value;
#line 24 "../src/Dialogs/Project.vala"
		g_object_notify_by_pspec ((GObject *) self, dialogs_project_properties[DIALOGS_PROJECT_BACKEND_PICKER_PROPERTY]);
#line 3107 "Project.c"
	}
}

const gchar*
dialogs_project_get_header_title (DialogsProject* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 25 "../src/Dialogs/Project.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 25 "../src/Dialogs/Project.vala"
	_tmp0_ = self->priv->_header_title;
#line 25 "../src/Dialogs/Project.vala"
	result = _tmp0_;
#line 25 "../src/Dialogs/Project.vala"
	return result;
#line 3124 "Project.c"
}

static void
dialogs_project_set_header_title (DialogsProject* self,
                                  const gchar* value)
{
	gchar* old_value;
#line 25 "../src/Dialogs/Project.vala"
	g_return_if_fail (self != NULL);
#line 25 "../src/Dialogs/Project.vala"
	old_value = dialogs_project_get_header_title (self);
#line 25 "../src/Dialogs/Project.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 3138 "Project.c"
		gchar* _tmp0_;
#line 25 "../src/Dialogs/Project.vala"
		_tmp0_ = g_strdup (value);
#line 25 "../src/Dialogs/Project.vala"
		_g_free0 (self->priv->_header_title);
#line 25 "../src/Dialogs/Project.vala"
		self->priv->_header_title = _tmp0_;
#line 25 "../src/Dialogs/Project.vala"
		g_object_notify_by_pspec ((GObject *) self, dialogs_project_properties[DIALOGS_PROJECT_HEADER_TITLE_PROPERTY]);
#line 3148 "Project.c"
	}
}

gboolean
dialogs_project_get_is_creating (DialogsProject* self)
{
	gboolean result;
	ObjectsProject* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
#line 40 "../src/Dialogs/Project.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 41 "../src/Dialogs/Project.vala"
	_tmp0_ = self->priv->_project;
#line 41 "../src/Dialogs/Project.vala"
	_tmp1_ = objects_base_object_get_id ((ObjectsBaseObject*) _tmp0_);
#line 41 "../src/Dialogs/Project.vala"
	_tmp2_ = _tmp1_;
#line 41 "../src/Dialogs/Project.vala"
	result = g_strcmp0 (_tmp2_, "") == 0;
#line 41 "../src/Dialogs/Project.vala"
	return result;
#line 3171 "Project.c"
}

static void
_dialogs_project___lambda41_ (DialogsProject* self)
{
	GeeHashMap* _tmp15_;
	ServicesEventBus* _tmp16_;
	ServicesEventBus* _tmp17_;
	{
		GeeIterator* _entry_it = NULL;
		GeeHashMap* _tmp0_;
		GeeSet* _tmp1_;
		GeeSet* _tmp2_;
		GeeSet* _tmp3_;
		GeeIterator* _tmp4_;
		GeeIterator* _tmp5_;
#line 85 "../src/Dialogs/Project.vala"
		_tmp0_ = self->priv->signal_map;
#line 85 "../src/Dialogs/Project.vala"
		_tmp1_ = gee_abstract_map_get_entries ((GeeAbstractMap*) _tmp0_);
#line 85 "../src/Dialogs/Project.vala"
		_tmp2_ = _tmp1_;
#line 85 "../src/Dialogs/Project.vala"
		_tmp3_ = _tmp2_;
#line 85 "../src/Dialogs/Project.vala"
		_tmp4_ = gee_iterable_iterator ((GeeIterable*) _tmp3_);
#line 85 "../src/Dialogs/Project.vala"
		_tmp5_ = _tmp4_;
#line 85 "../src/Dialogs/Project.vala"
		_g_object_unref0 (_tmp3_);
#line 85 "../src/Dialogs/Project.vala"
		_entry_it = _tmp5_;
#line 85 "../src/Dialogs/Project.vala"
		while (TRUE) {
#line 3206 "Project.c"
			GeeIterator* _tmp6_;
			GeeMapEntry* entry = NULL;
			GeeIterator* _tmp7_;
			gpointer _tmp8_;
			GeeMapEntry* _tmp9_;
			gconstpointer _tmp10_;
			gconstpointer _tmp11_;
			GeeMapEntry* _tmp12_;
			gconstpointer _tmp13_;
			gconstpointer _tmp14_;
#line 85 "../src/Dialogs/Project.vala"
			_tmp6_ = _entry_it;
#line 85 "../src/Dialogs/Project.vala"
			if (!gee_iterator_next (_tmp6_)) {
#line 85 "../src/Dialogs/Project.vala"
				break;
#line 3223 "Project.c"
			}
#line 85 "../src/Dialogs/Project.vala"
			_tmp7_ = _entry_it;
#line 85 "../src/Dialogs/Project.vala"
			_tmp8_ = gee_iterator_get (_tmp7_);
#line 85 "../src/Dialogs/Project.vala"
			entry = (GeeMapEntry*) _tmp8_;
#line 86 "../src/Dialogs/Project.vala"
			_tmp9_ = entry;
#line 86 "../src/Dialogs/Project.vala"
			_tmp10_ = gee_map_entry_get_value (_tmp9_);
#line 86 "../src/Dialogs/Project.vala"
			_tmp11_ = _tmp10_;
#line 86 "../src/Dialogs/Project.vala"
			_tmp12_ = entry;
#line 86 "../src/Dialogs/Project.vala"
			_tmp13_ = gee_map_entry_get_key (_tmp12_);
#line 86 "../src/Dialogs/Project.vala"
			_tmp14_ = _tmp13_;
#line 86 "../src/Dialogs/Project.vala"
			g_signal_handler_disconnect ((GObject*) _tmp11_, (gulong) ((guintptr) _tmp14_));
#line 85 "../src/Dialogs/Project.vala"
			_g_object_unref0 (entry);
#line 3247 "Project.c"
		}
#line 85 "../src/Dialogs/Project.vala"
		_g_object_unref0 (_entry_it);
#line 3251 "Project.c"
	}
#line 89 "../src/Dialogs/Project.vala"
	_tmp15_ = self->priv->signal_map;
#line 89 "../src/Dialogs/Project.vala"
	gee_abstract_map_clear ((GeeAbstractMap*) _tmp15_);
#line 91 "../src/Dialogs/Project.vala"
	_tmp16_ = services_event_bus_get_default ();
#line 91 "../src/Dialogs/Project.vala"
	_tmp17_ = _tmp16_;
#line 91 "../src/Dialogs/Project.vala"
	g_signal_emit_by_name (_tmp17_, "connect-typing-accel");
#line 91 "../src/Dialogs/Project.vala"
	_g_object_unref0 (_tmp17_);
#line 3265 "Project.c"
}

static void
__dialogs_project___lambda41__adw_dialog_closed (AdwDialog* _sender,
                                                 gpointer self)
{
#line 84 "../src/Dialogs/Project.vala"
	_dialogs_project___lambda41_ ((DialogsProject*) self);
#line 3274 "Project.c"
}

static GObject *
dialogs_project_constructor (GType type,
                             guint n_construct_properties,
                             GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	DialogsProject * self;
	AdwNavigationPage* main_page = NULL;
	AdwNavigationPage* _tmp0_;
	AdwNavigationPage* _tmp1_;
	AdwNavigationView* _tmp2_;
	AdwNavigationView* _tmp3_;
	AdwNavigationPage* _tmp4_;
	AdwNavigationView* _tmp5_;
	ServicesEventBus* _tmp6_;
	ServicesEventBus* _tmp7_;
#line 74 "../src/Dialogs/Project.vala"
	parent_class = G_OBJECT_CLASS (dialogs_project_parent_class);
#line 74 "../src/Dialogs/Project.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 74 "../src/Dialogs/Project.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, DIALOGS_TYPE_PROJECT, DialogsProject);
#line 75 "../src/Dialogs/Project.vala"
	_tmp0_ = dialogs_project_get_main_page (self);
#line 75 "../src/Dialogs/Project.vala"
	main_page = _tmp0_;
#line 76 "../src/Dialogs/Project.vala"
	_tmp1_ = dialogs_project_get_sources_page (self);
#line 76 "../src/Dialogs/Project.vala"
	_g_object_unref0 (self->priv->sources_page);
#line 76 "../src/Dialogs/Project.vala"
	self->priv->sources_page = _tmp1_;
#line 78 "../src/Dialogs/Project.vala"
	_tmp2_ = (AdwNavigationView*) adw_navigation_view_new ();
#line 78 "../src/Dialogs/Project.vala"
	g_object_ref_sink (_tmp2_);
#line 78 "../src/Dialogs/Project.vala"
	_g_object_unref0 (self->priv->navigation_view);
#line 78 "../src/Dialogs/Project.vala"
	self->priv->navigation_view = _tmp2_;
#line 79 "../src/Dialogs/Project.vala"
	_tmp3_ = self->priv->navigation_view;
#line 79 "../src/Dialogs/Project.vala"
	_tmp4_ = main_page;
#line 79 "../src/Dialogs/Project.vala"
	adw_navigation_view_add (_tmp3_, _tmp4_);
#line 81 "../src/Dialogs/Project.vala"
	_tmp5_ = self->priv->navigation_view;
#line 81 "../src/Dialogs/Project.vala"
	adw_dialog_set_child ((AdwDialog*) self, (GtkWidget*) _tmp5_);
#line 82 "../src/Dialogs/Project.vala"
	_tmp6_ = services_event_bus_get_default ();
#line 82 "../src/Dialogs/Project.vala"
	_tmp7_ = _tmp6_;
#line 82 "../src/Dialogs/Project.vala"
	g_signal_emit_by_name (_tmp7_, "disconnect-typing-accel");
#line 82 "../src/Dialogs/Project.vala"
	_g_object_unref0 (_tmp7_);
#line 84 "../src/Dialogs/Project.vala"
	g_signal_connect_object ((AdwDialog*) self, "closed", (GCallback) __dialogs_project___lambda41__adw_dialog_closed, self, 0);
#line 74 "../src/Dialogs/Project.vala"
	_g_object_unref0 (main_page);
#line 74 "../src/Dialogs/Project.vala"
	return obj;
#line 3342 "Project.c"
}

static void
dialogs_project_class_init (DialogsProjectClass * klass,
                            gpointer klass_data)
{
#line 22 "../src/Dialogs/Project.vala"
	dialogs_project_parent_class = g_type_class_peek_parent (klass);
#line 22 "../src/Dialogs/Project.vala"
	g_type_class_adjust_private_offset (klass, &DialogsProject_private_offset);
#line 22 "../src/Dialogs/Project.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_dialogs_project_get_property;
#line 22 "../src/Dialogs/Project.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_dialogs_project_set_property;
#line 22 "../src/Dialogs/Project.vala"
	G_OBJECT_CLASS (klass)->constructor = dialogs_project_constructor;
#line 22 "../src/Dialogs/Project.vala"
	G_OBJECT_CLASS (klass)->finalize = dialogs_project_finalize;
#line 22 "../src/Dialogs/Project.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DIALOGS_PROJECT_PROJECT_PROPERTY, dialogs_project_properties[DIALOGS_PROJECT_PROJECT_PROPERTY] = g_param_spec_object ("project", "project", "project", OBJECTS_TYPE_PROJECT, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 22 "../src/Dialogs/Project.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DIALOGS_PROJECT_BACKEND_PICKER_PROPERTY, dialogs_project_properties[DIALOGS_PROJECT_BACKEND_PICKER_PROPERTY] = g_param_spec_boolean ("backend-picker", "backend-picker", "backend-picker", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 22 "../src/Dialogs/Project.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DIALOGS_PROJECT_HEADER_TITLE_PROPERTY, dialogs_project_properties[DIALOGS_PROJECT_HEADER_TITLE_PROPERTY] = g_param_spec_string ("header-title", "header-title", "header-title", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 22 "../src/Dialogs/Project.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DIALOGS_PROJECT_IS_CREATING_PROPERTY, dialogs_project_properties[DIALOGS_PROJECT_IS_CREATING_PROPERTY] = g_param_spec_boolean ("is-creating", "is-creating", "is-creating", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 3369 "Project.c"
}

static void
dialogs_project_instance_init (DialogsProject * self,
                               gpointer klass)
{
	GeeHashMap* _tmp0_;
#line 22 "../src/Dialogs/Project.vala"
	self->priv = dialogs_project_get_instance_private (self);
#line 45 "../src/Dialogs/Project.vala"
	_tmp0_ = gee_hash_map_new (G_TYPE_ULONG, NULL, NULL, G_TYPE_OBJECT, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 45 "../src/Dialogs/Project.vala"
	self->priv->signal_map = _tmp0_;
#line 3383 "Project.c"
}

static void
dialogs_project_finalize (GObject * obj)
{
	DialogsProject * self;
#line 22 "../src/Dialogs/Project.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, DIALOGS_TYPE_PROJECT, DialogsProject);
#line 71 "../src/Dialogs/Project.vala"
	g_print ("Destroying Dialogs.Project\n");
#line 23 "../src/Dialogs/Project.vala"
	_g_object_unref0 (self->priv->_project);
#line 25 "../src/Dialogs/Project.vala"
	_g_free0 (self->priv->_header_title);
#line 27 "../src/Dialogs/Project.vala"
	_g_object_unref0 (self->priv->emoji_color_stack);
#line 28 "../src/Dialogs/Project.vala"
	_g_object_unref0 (self->priv->progress_bar);
#line 29 "../src/Dialogs/Project.vala"
	_g_object_unref0 (self->priv->name_entry);
#line 30 "../src/Dialogs/Project.vala"
	_g_object_unref0 (self->priv->color_picker_row);
#line 31 "../src/Dialogs/Project.vala"
	_g_object_unref0 (self->priv->submit_button);
#line 32 "../src/Dialogs/Project.vala"
	_g_object_unref0 (self->priv->emoji_switch);
#line 33 "../src/Dialogs/Project.vala"
	_g_object_unref0 (self->priv->emoji_label);
#line 34 "../src/Dialogs/Project.vala"
	_g_object_unref0 (self->priv->source_selected_label);
#line 36 "../src/Dialogs/Project.vala"
	_g_object_unref0 (self->priv->navigation_view);
#line 37 "../src/Dialogs/Project.vala"
	_g_object_unref0 (self->priv->sources_page);
#line 45 "../src/Dialogs/Project.vala"
	_g_object_unref0 (self->priv->signal_map);
#line 22 "../src/Dialogs/Project.vala"
	G_OBJECT_CLASS (dialogs_project_parent_class)->finalize (obj);
#line 3422 "Project.c"
}

static GType
dialogs_project_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (DialogsProjectClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) dialogs_project_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DialogsProject), 0, (GInstanceInitFunc) dialogs_project_instance_init, NULL };
	GType dialogs_project_type_id;
	dialogs_project_type_id = g_type_register_static (adw_dialog_get_type (), "DialogsProject", &g_define_type_info, 0);
	DialogsProject_private_offset = g_type_add_instance_private (dialogs_project_type_id, sizeof (DialogsProjectPrivate));
	return dialogs_project_type_id;
}

GType
dialogs_project_get_type (void)
{
	static volatile gsize dialogs_project_type_id__once = 0;
	if (g_once_init_enter (&dialogs_project_type_id__once)) {
		GType dialogs_project_type_id;
		dialogs_project_type_id = dialogs_project_get_type_once ();
		g_once_init_leave (&dialogs_project_type_id__once, dialogs_project_type_id);
	}
	return dialogs_project_type_id__once;
}

static void
_vala_dialogs_project_get_property (GObject * object,
                                    guint property_id,
                                    GValue * value,
                                    GParamSpec * pspec)
{
	DialogsProject * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, DIALOGS_TYPE_PROJECT, DialogsProject);
#line 22 "../src/Dialogs/Project.vala"
	switch (property_id) {
#line 22 "../src/Dialogs/Project.vala"
		case DIALOGS_PROJECT_PROJECT_PROPERTY:
#line 22 "../src/Dialogs/Project.vala"
		g_value_set_object (value, dialogs_project_get_project (self));
#line 22 "../src/Dialogs/Project.vala"
		break;
#line 22 "../src/Dialogs/Project.vala"
		case DIALOGS_PROJECT_BACKEND_PICKER_PROPERTY:
#line 22 "../src/Dialogs/Project.vala"
		g_value_set_boolean (value, dialogs_project_get_backend_picker (self));
#line 22 "../src/Dialogs/Project.vala"
		break;
#line 22 "../src/Dialogs/Project.vala"
		case DIALOGS_PROJECT_HEADER_TITLE_PROPERTY:
#line 22 "../src/Dialogs/Project.vala"
		g_value_set_string (value, dialogs_project_get_header_title (self));
#line 22 "../src/Dialogs/Project.vala"
		break;
#line 22 "../src/Dialogs/Project.vala"
		case DIALOGS_PROJECT_IS_CREATING_PROPERTY:
#line 22 "../src/Dialogs/Project.vala"
		g_value_set_boolean (value, dialogs_project_get_is_creating (self));
#line 22 "../src/Dialogs/Project.vala"
		break;
#line 3481 "Project.c"
		default:
#line 22 "../src/Dialogs/Project.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 22 "../src/Dialogs/Project.vala"
		break;
#line 3487 "Project.c"
	}
}

static void
_vala_dialogs_project_set_property (GObject * object,
                                    guint property_id,
                                    const GValue * value,
                                    GParamSpec * pspec)
{
	DialogsProject * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, DIALOGS_TYPE_PROJECT, DialogsProject);
#line 22 "../src/Dialogs/Project.vala"
	switch (property_id) {
#line 22 "../src/Dialogs/Project.vala"
		case DIALOGS_PROJECT_PROJECT_PROPERTY:
#line 22 "../src/Dialogs/Project.vala"
		dialogs_project_set_project (self, g_value_get_object (value));
#line 22 "../src/Dialogs/Project.vala"
		break;
#line 22 "../src/Dialogs/Project.vala"
		case DIALOGS_PROJECT_BACKEND_PICKER_PROPERTY:
#line 22 "../src/Dialogs/Project.vala"
		dialogs_project_set_backend_picker (self, g_value_get_boolean (value));
#line 22 "../src/Dialogs/Project.vala"
		break;
#line 22 "../src/Dialogs/Project.vala"
		case DIALOGS_PROJECT_HEADER_TITLE_PROPERTY:
#line 22 "../src/Dialogs/Project.vala"
		dialogs_project_set_header_title (self, g_value_get_string (value));
#line 22 "../src/Dialogs/Project.vala"
		break;
#line 3519 "Project.c"
		default:
#line 22 "../src/Dialogs/Project.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 22 "../src/Dialogs/Project.vala"
		break;
#line 3525 "Project.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

