/* Backup.c generated by valac 0.56.18, the Vala compiler
 * generated from Backup.vala, do not modify */

/*
* Copyright © 2023 Alain M. (https://github.com/alainm23/planify)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 3 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*
* Authored by: Alain M. <alainmh23@gmail.com>
*/

#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gee.h>
#include "planify.h"
#include <gio/gio.h>
#include <json-glib/json-glib.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define OBJECTS_TYPE_BACKUP (objects_backup_get_type ())
#define OBJECTS_BACKUP(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), OBJECTS_TYPE_BACKUP, ObjectsBackup))
#define OBJECTS_BACKUP_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), OBJECTS_TYPE_BACKUP, ObjectsBackupClass))
#define OBJECTS_IS_BACKUP(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), OBJECTS_TYPE_BACKUP))
#define OBJECTS_IS_BACKUP_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), OBJECTS_TYPE_BACKUP))
#define OBJECTS_BACKUP_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), OBJECTS_TYPE_BACKUP, ObjectsBackupClass))

typedef struct _ObjectsBackup ObjectsBackup;
typedef struct _ObjectsBackupClass ObjectsBackupClass;
typedef struct _ObjectsBackupPrivate ObjectsBackupPrivate;
enum  {
	OBJECTS_BACKUP_0_PROPERTY,
	OBJECTS_BACKUP_VERSION_PROPERTY,
	OBJECTS_BACKUP_DATE_PROPERTY,
	OBJECTS_BACKUP_DEFAULT_INBOX_PROPERTY,
	OBJECTS_BACKUP_LOCAL_INBOX_PROJECT_ID_PROPERTY,
	OBJECTS_BACKUP_TODOIST_ACCESS_TOKEN_PROPERTY,
	OBJECTS_BACKUP_TODOIST_SYNC_TOKEN_PROPERTY,
	OBJECTS_BACKUP_TODOIST_USER_NAME_PROPERTY,
	OBJECTS_BACKUP_TODOIST_USER_EMAIL_PROPERTY,
	OBJECTS_BACKUP_TODOIST_USER_IMAGE_ID_PROPERTY,
	OBJECTS_BACKUP_TODOIST_USER_AVATAR_PROPERTY,
	OBJECTS_BACKUP_TODOIST_USER_IS_PREMIUM_PROPERTY,
	OBJECTS_BACKUP_PROJECTS_PROPERTY,
	OBJECTS_BACKUP_SECTIONS_PROPERTY,
	OBJECTS_BACKUP_ITEMS_PROPERTY,
	OBJECTS_BACKUP_LABELS_PROPERTY,
	OBJECTS_BACKUP_SOURCES_PROPERTY,
	OBJECTS_BACKUP_PATH_PROPERTY,
	OBJECTS_BACKUP_ERROR_PROPERTY,
	OBJECTS_BACKUP_DATETIME_PROPERTY,
	OBJECTS_BACKUP_TITLE_PROPERTY,
	OBJECTS_BACKUP_TODOIST_BACKEND_PROPERTY,
	OBJECTS_BACKUP_NUM_PROPERTIES
};
static GParamSpec* objects_backup_properties[OBJECTS_BACKUP_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _json_object_unref0(var) ((var == NULL) ? NULL : (var = (json_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_time_zone_unref0(var) ((var == NULL) ? NULL : (var = (g_time_zone_unref (var), NULL)))
enum  {
	OBJECTS_BACKUP_DELETED_SIGNAL,
	OBJECTS_BACKUP_NUM_SIGNALS
};
static guint objects_backup_signals[OBJECTS_BACKUP_NUM_SIGNALS] = {0};

struct _ObjectsBackup {
	GObject parent_instance;
	ObjectsBackupPrivate * priv;
};

struct _ObjectsBackupClass {
	GObjectClass parent_class;
};

struct _ObjectsBackupPrivate {
	gchar* _version;
	gchar* _date;
	gint _default_inbox;
	gchar* _local_inbox_project_id;
	gchar* _todoist_access_token;
	gchar* _todoist_sync_token;
	gchar* _todoist_user_name;
	gchar* _todoist_user_email;
	gchar* _todoist_user_image_id;
	gchar* _todoist_user_avatar;
	gboolean _todoist_user_is_premium;
	GeeArrayList* _projects;
	GeeArrayList* _sections;
	GeeArrayList* _items;
	GeeArrayList* _labels;
	GeeArrayList* _sources;
	gchar* _path;
	gchar* _error;
	GDateTime* _datetime;
	gchar* _title;
	gboolean _todoist_backend;
};

static gint ObjectsBackup_private_offset;
static gpointer objects_backup_parent_class = NULL;

VALA_EXTERN GType objects_backup_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ObjectsBackup, g_object_unref)
VALA_EXTERN ObjectsBackup* objects_backup_new_from_file (GFile* file);
VALA_EXTERN ObjectsBackup* objects_backup_construct_from_file (GType object_type,
                                                   GFile* file);
VALA_EXTERN void objects_backup_set_path (ObjectsBackup* self,
                              const gchar* value);
VALA_EXTERN void objects_backup_set_version (ObjectsBackup* self,
                                 const gchar* value);
VALA_EXTERN void objects_backup_set_date (ObjectsBackup* self,
                              const gchar* value);
VALA_EXTERN void objects_backup_set_local_inbox_project_id (ObjectsBackup* self,
                                                const gchar* value);
VALA_EXTERN void objects_backup_set_todoist_access_token (ObjectsBackup* self,
                                              const gchar* value);
VALA_EXTERN void objects_backup_set_todoist_sync_token (ObjectsBackup* self,
                                            const gchar* value);
VALA_EXTERN void objects_backup_set_todoist_user_name (ObjectsBackup* self,
                                           const gchar* value);
VALA_EXTERN void objects_backup_set_todoist_user_email (ObjectsBackup* self,
                                            const gchar* value);
VALA_EXTERN void objects_backup_set_todoist_user_image_id (ObjectsBackup* self,
                                               const gchar* value);
VALA_EXTERN void objects_backup_set_todoist_user_avatar (ObjectsBackup* self,
                                             const gchar* value);
VALA_EXTERN void objects_backup_set_todoist_user_is_premium (ObjectsBackup* self,
                                                 gboolean value);
VALA_EXTERN GeeArrayList* objects_backup_get_sources (ObjectsBackup* self);
VALA_EXTERN const gchar* objects_backup_get_version (ObjectsBackup* self);
VALA_EXTERN const gchar* objects_backup_get_todoist_access_token (ObjectsBackup* self);
VALA_EXTERN const gchar* objects_backup_get_todoist_user_email (ObjectsBackup* self);
VALA_EXTERN const gchar* objects_backup_get_todoist_sync_token (ObjectsBackup* self);
VALA_EXTERN const gchar* objects_backup_get_todoist_user_avatar (ObjectsBackup* self);
VALA_EXTERN const gchar* objects_backup_get_todoist_user_image_id (ObjectsBackup* self);
VALA_EXTERN gboolean objects_backup_get_todoist_user_is_premium (ObjectsBackup* self);
VALA_EXTERN GeeArrayList* objects_backup_get_labels (ObjectsBackup* self);
VALA_EXTERN GeeArrayList* objects_backup_get_projects (ObjectsBackup* self);
VALA_EXTERN GeeArrayList* objects_backup_get_sections (ObjectsBackup* self);
VALA_EXTERN GeeArrayList* objects_backup_get_items (ObjectsBackup* self);
VALA_EXTERN void objects_backup_set_error (ObjectsBackup* self,
                               const gchar* value);
VALA_EXTERN gboolean objects_backup_valid (ObjectsBackup* self);
VALA_EXTERN const gchar* objects_backup_get_error (ObjectsBackup* self);
VALA_EXTERN const gchar* objects_backup_get_date (ObjectsBackup* self);
VALA_EXTERN ObjectsBackup* objects_backup_new (void);
VALA_EXTERN ObjectsBackup* objects_backup_construct (GType object_type);
VALA_EXTERN gint objects_backup_get_default_inbox (ObjectsBackup* self);
VALA_EXTERN void objects_backup_set_default_inbox (ObjectsBackup* self,
                                       gint value);
VALA_EXTERN const gchar* objects_backup_get_local_inbox_project_id (ObjectsBackup* self);
VALA_EXTERN const gchar* objects_backup_get_todoist_user_name (ObjectsBackup* self);
VALA_EXTERN void objects_backup_set_projects (ObjectsBackup* self,
                                  GeeArrayList* value);
VALA_EXTERN void objects_backup_set_sections (ObjectsBackup* self,
                                  GeeArrayList* value);
VALA_EXTERN void objects_backup_set_items (ObjectsBackup* self,
                               GeeArrayList* value);
VALA_EXTERN void objects_backup_set_labels (ObjectsBackup* self,
                                GeeArrayList* value);
VALA_EXTERN void objects_backup_set_sources (ObjectsBackup* self,
                                 GeeArrayList* value);
VALA_EXTERN const gchar* objects_backup_get_path (ObjectsBackup* self);
VALA_EXTERN GDateTime* objects_backup_get_datetime (ObjectsBackup* self);
VALA_EXTERN const gchar* objects_backup_get_title (ObjectsBackup* self);
VALA_EXTERN gboolean objects_backup_get_todoist_backend (ObjectsBackup* self);
static void objects_backup_finalize (GObject * obj);
static GType objects_backup_get_type_once (void);
static void _vala_objects_backup_get_property (GObject * object,
                                        guint property_id,
                                        GValue * value,
                                        GParamSpec * pspec);
static void _vala_objects_backup_set_property (GObject * object,
                                        guint property_id,
                                        const GValue * value,
                                        GParamSpec * pspec);

static inline gpointer
objects_backup_get_instance_private (ObjectsBackup* self)
{
	return G_STRUCT_MEMBER_P (self, ObjectsBackup_private_offset);
}

static gchar*
g_date_time_to_string (GDateTime* self)
{
	gchar* _tmp0_;
	gchar* result;
#line 3410 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 3411 "glib-2.0.vapi"
	_tmp0_ = g_date_time_format (self, "%FT%H:%M:%S%z");
#line 3411 "glib-2.0.vapi"
	result = _tmp0_;
#line 3411 "glib-2.0.vapi"
	return result;
#line 232 "Backup.c"
}

static gpointer
_json_object_ref0 (gpointer self)
{
#line 78 "../src/Objects/Backup.vala"
	return self ? json_object_ref (self) : NULL;
#line 240 "Backup.c"
}

static gchar*
string_strip (const gchar* self)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* result;
#line 1413 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1414 "glib-2.0.vapi"
	_tmp0_ = g_strdup (self);
#line 1414 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1415 "glib-2.0.vapi"
	g_strstrip (_result_);
#line 1416 "glib-2.0.vapi"
	result = _result_;
#line 1416 "glib-2.0.vapi"
	return result;
#line 261 "Backup.c"
}

ObjectsBackup*
objects_backup_construct_from_file (GType object_type,
                                    GFile* file)
{
	ObjectsBackup * self = NULL;
	JsonParser* parser = NULL;
	JsonParser* _tmp0_;
	GError* _inner_error0_ = NULL;
#line 71 "../src/Objects/Backup.vala"
	g_return_val_if_fail (file != NULL, NULL);
#line 71 "../src/Objects/Backup.vala"
	self = (ObjectsBackup*) g_object_new (object_type, NULL);
#line 72 "../src/Objects/Backup.vala"
	_tmp0_ = json_parser_new ();
#line 72 "../src/Objects/Backup.vala"
	parser = _tmp0_;
#line 280 "Backup.c"
	{
		gchar* _tmp1_;
		gchar* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
		JsonObject* node = NULL;
		JsonNode* _tmp5_;
		JsonObject* _tmp6_;
		JsonObject* _tmp7_;
		JsonObject* _tmp8_;
		const gchar* _tmp9_;
		JsonObject* _tmp10_;
		const gchar* _tmp11_;
		JsonObject* settings = NULL;
		JsonObject* _tmp12_;
		JsonObject* _tmp13_;
		JsonObject* _tmp14_;
		JsonObject* _tmp15_;
		const gchar* _tmp16_;
		JsonObject* _tmp17_;
		JsonObject* _tmp20_;
		JsonObject* _tmp23_;
		JsonObject* _tmp26_;
		JsonObject* _tmp29_;
		JsonObject* _tmp32_;
		JsonObject* _tmp35_;
		GeeArrayList* _tmp37_;
		JsonArray* _sources = NULL;
		JsonObject* _tmp38_;
		JsonArray* _tmp39_;
		JsonArray* _tmp40_;
		GList* _tmp41_;
		gboolean _tmp46_ = FALSE;
		const gchar* _tmp47_;
		GeeArrayList* _tmp77_;
		JsonArray* _labels = NULL;
		JsonObject* _tmp78_;
		JsonArray* _tmp79_;
		JsonArray* _tmp80_;
		GList* _tmp81_;
		GeeArrayList* _tmp86_;
		JsonArray* _projects = NULL;
		JsonObject* _tmp87_;
		JsonArray* _tmp88_;
		JsonArray* _tmp89_;
		GList* _tmp90_;
		GeeArrayList* _tmp104_;
		JsonArray* _sections = NULL;
		JsonObject* _tmp105_;
		JsonArray* _tmp106_;
		JsonArray* _tmp107_;
		GList* _tmp108_;
		GeeArrayList* _tmp113_;
		JsonArray* _items = NULL;
		JsonObject* _tmp114_;
		JsonArray* _tmp115_;
		JsonArray* _tmp116_;
		GList* _tmp117_;
#line 75 "../src/Objects/Backup.vala"
		_tmp1_ = g_file_get_path (file);
#line 75 "../src/Objects/Backup.vala"
		_tmp2_ = _tmp1_;
#line 75 "../src/Objects/Backup.vala"
		json_parser_load_from_file (parser, _tmp2_, &_inner_error0_);
#line 75 "../src/Objects/Backup.vala"
		_g_free0 (_tmp2_);
#line 75 "../src/Objects/Backup.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 349 "Backup.c"
			goto __catch0_g_error;
		}
#line 76 "../src/Objects/Backup.vala"
		_tmp3_ = g_file_get_path (file);
#line 76 "../src/Objects/Backup.vala"
		_tmp4_ = _tmp3_;
#line 76 "../src/Objects/Backup.vala"
		objects_backup_set_path (self, _tmp4_);
#line 76 "../src/Objects/Backup.vala"
		_g_free0 (_tmp4_);
#line 78 "../src/Objects/Backup.vala"
		_tmp5_ = json_parser_get_root (parser);
#line 78 "../src/Objects/Backup.vala"
		_tmp6_ = json_node_get_object (_tmp5_);
#line 78 "../src/Objects/Backup.vala"
		_tmp7_ = _json_object_ref0 (_tmp6_);
#line 78 "../src/Objects/Backup.vala"
		node = _tmp7_;
#line 80 "../src/Objects/Backup.vala"
		_tmp8_ = node;
#line 80 "../src/Objects/Backup.vala"
		_tmp9_ = json_object_get_string_member (_tmp8_, "version");
#line 80 "../src/Objects/Backup.vala"
		objects_backup_set_version (self, _tmp9_);
#line 81 "../src/Objects/Backup.vala"
		_tmp10_ = node;
#line 81 "../src/Objects/Backup.vala"
		_tmp11_ = json_object_get_string_member (_tmp10_, "date");
#line 81 "../src/Objects/Backup.vala"
		objects_backup_set_date (self, _tmp11_);
#line 84 "../src/Objects/Backup.vala"
		_tmp12_ = node;
#line 84 "../src/Objects/Backup.vala"
		_tmp13_ = json_object_get_object_member (_tmp12_, "settings");
#line 84 "../src/Objects/Backup.vala"
		_tmp14_ = _json_object_ref0 (_tmp13_);
#line 84 "../src/Objects/Backup.vala"
		settings = _tmp14_;
#line 85 "../src/Objects/Backup.vala"
		_tmp15_ = settings;
#line 85 "../src/Objects/Backup.vala"
		_tmp16_ = json_object_get_string_member (_tmp15_, "local-inbox-project-id");
#line 85 "../src/Objects/Backup.vala"
		objects_backup_set_local_inbox_project_id (self, _tmp16_);
#line 87 "../src/Objects/Backup.vala"
		_tmp17_ = settings;
#line 87 "../src/Objects/Backup.vala"
		if (json_object_has_member (_tmp17_, "todoist-access-token")) {
#line 398 "Backup.c"
			JsonObject* _tmp18_;
			const gchar* _tmp19_;
#line 88 "../src/Objects/Backup.vala"
			_tmp18_ = settings;
#line 88 "../src/Objects/Backup.vala"
			_tmp19_ = json_object_get_string_member (_tmp18_, "todoist-access-token");
#line 88 "../src/Objects/Backup.vala"
			objects_backup_set_todoist_access_token (self, _tmp19_);
#line 407 "Backup.c"
		}
#line 91 "../src/Objects/Backup.vala"
		_tmp20_ = settings;
#line 91 "../src/Objects/Backup.vala"
		if (json_object_has_member (_tmp20_, "todoist-sync-token")) {
#line 413 "Backup.c"
			JsonObject* _tmp21_;
			const gchar* _tmp22_;
#line 92 "../src/Objects/Backup.vala"
			_tmp21_ = settings;
#line 92 "../src/Objects/Backup.vala"
			_tmp22_ = json_object_get_string_member (_tmp21_, "todoist-sync-token");
#line 92 "../src/Objects/Backup.vala"
			objects_backup_set_todoist_sync_token (self, _tmp22_);
#line 422 "Backup.c"
		}
#line 95 "../src/Objects/Backup.vala"
		_tmp23_ = settings;
#line 95 "../src/Objects/Backup.vala"
		if (json_object_has_member (_tmp23_, "todoist-user-name")) {
#line 428 "Backup.c"
			JsonObject* _tmp24_;
			const gchar* _tmp25_;
#line 96 "../src/Objects/Backup.vala"
			_tmp24_ = settings;
#line 96 "../src/Objects/Backup.vala"
			_tmp25_ = json_object_get_string_member (_tmp24_, "todoist-user-name");
#line 96 "../src/Objects/Backup.vala"
			objects_backup_set_todoist_user_name (self, _tmp25_);
#line 437 "Backup.c"
		}
#line 99 "../src/Objects/Backup.vala"
		_tmp26_ = settings;
#line 99 "../src/Objects/Backup.vala"
		if (json_object_has_member (_tmp26_, "todoist-user-email")) {
#line 443 "Backup.c"
			JsonObject* _tmp27_;
			const gchar* _tmp28_;
#line 100 "../src/Objects/Backup.vala"
			_tmp27_ = settings;
#line 100 "../src/Objects/Backup.vala"
			_tmp28_ = json_object_get_string_member (_tmp27_, "todoist-user-name");
#line 100 "../src/Objects/Backup.vala"
			objects_backup_set_todoist_user_email (self, _tmp28_);
#line 452 "Backup.c"
		}
#line 103 "../src/Objects/Backup.vala"
		_tmp29_ = settings;
#line 103 "../src/Objects/Backup.vala"
		if (json_object_has_member (_tmp29_, "todoist-user-image-id")) {
#line 458 "Backup.c"
			JsonObject* _tmp30_;
			const gchar* _tmp31_;
#line 104 "../src/Objects/Backup.vala"
			_tmp30_ = settings;
#line 104 "../src/Objects/Backup.vala"
			_tmp31_ = json_object_get_string_member (_tmp30_, "todoist-user-image-id");
#line 104 "../src/Objects/Backup.vala"
			objects_backup_set_todoist_user_image_id (self, _tmp31_);
#line 467 "Backup.c"
		}
#line 107 "../src/Objects/Backup.vala"
		_tmp32_ = settings;
#line 107 "../src/Objects/Backup.vala"
		if (json_object_has_member (_tmp32_, "todoist-user-avatar")) {
#line 473 "Backup.c"
			JsonObject* _tmp33_;
			const gchar* _tmp34_;
#line 108 "../src/Objects/Backup.vala"
			_tmp33_ = settings;
#line 108 "../src/Objects/Backup.vala"
			_tmp34_ = json_object_get_string_member (_tmp33_, "todoist-user-avatar");
#line 108 "../src/Objects/Backup.vala"
			objects_backup_set_todoist_user_avatar (self, _tmp34_);
#line 482 "Backup.c"
		}
#line 111 "../src/Objects/Backup.vala"
		_tmp35_ = settings;
#line 111 "../src/Objects/Backup.vala"
		if (json_object_has_member (_tmp35_, "todoist-user-is-premium")) {
#line 488 "Backup.c"
			JsonObject* _tmp36_;
#line 112 "../src/Objects/Backup.vala"
			_tmp36_ = settings;
#line 112 "../src/Objects/Backup.vala"
			objects_backup_set_todoist_user_is_premium (self, json_object_get_boolean_member (_tmp36_, "todoist-user-is-premium"));
#line 494 "Backup.c"
		}
#line 116 "../src/Objects/Backup.vala"
		_tmp37_ = self->priv->_sources;
#line 116 "../src/Objects/Backup.vala"
		gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp37_);
#line 117 "../src/Objects/Backup.vala"
		_tmp38_ = node;
#line 117 "../src/Objects/Backup.vala"
		_tmp39_ = json_object_get_array_member (_tmp38_, "sources");
#line 117 "../src/Objects/Backup.vala"
		_sources = _tmp39_;
#line 118 "../src/Objects/Backup.vala"
		_tmp40_ = _sources;
#line 118 "../src/Objects/Backup.vala"
		_tmp41_ = json_array_get_elements (_tmp40_);
#line 510 "Backup.c"
		{
			GList* item_collection = NULL;
			GList* item_it = NULL;
#line 118 "../src/Objects/Backup.vala"
			item_collection = _tmp41_;
#line 118 "../src/Objects/Backup.vala"
			for (item_it = item_collection; item_it != NULL; item_it = item_it->next) {
#line 518 "Backup.c"
				JsonNode* item = NULL;
#line 118 "../src/Objects/Backup.vala"
				item = (JsonNode*) item_it->data;
#line 522 "Backup.c"
				{
					GeeArrayList* _tmp42_;
					JsonNode* _tmp43_;
					ObjectsSource* _tmp44_;
					ObjectsSource* _tmp45_;
#line 119 "../src/Objects/Backup.vala"
					_tmp42_ = self->priv->_sources;
#line 119 "../src/Objects/Backup.vala"
					_tmp43_ = item;
#line 119 "../src/Objects/Backup.vala"
					_tmp44_ = objects_source_new_from_import_json (_tmp43_);
#line 119 "../src/Objects/Backup.vala"
					_tmp45_ = _tmp44_;
#line 119 "../src/Objects/Backup.vala"
					gee_abstract_collection_add ((GeeAbstractCollection*) _tmp42_, _tmp45_);
#line 119 "../src/Objects/Backup.vala"
					_g_object_unref0 (_tmp45_);
#line 540 "Backup.c"
				}
			}
#line 118 "../src/Objects/Backup.vala"
			(item_collection == NULL) ? NULL : (item_collection = (g_list_free (item_collection), NULL));
#line 545 "Backup.c"
		}
#line 122 "../src/Objects/Backup.vala"
		_tmp47_ = self->priv->_version;
#line 122 "../src/Objects/Backup.vala"
		if (g_strcmp0 (_tmp47_, "1.0") == 0) {
#line 551 "Backup.c"
			const gchar* _tmp48_;
			gchar* _tmp49_;
			gchar* _tmp50_;
#line 122 "../src/Objects/Backup.vala"
			_tmp48_ = self->priv->_todoist_access_token;
#line 122 "../src/Objects/Backup.vala"
			_tmp49_ = string_strip (_tmp48_);
#line 122 "../src/Objects/Backup.vala"
			_tmp50_ = _tmp49_;
#line 122 "../src/Objects/Backup.vala"
			_tmp46_ = g_strcmp0 (_tmp50_, "") != 0;
#line 122 "../src/Objects/Backup.vala"
			_g_free0 (_tmp50_);
#line 565 "Backup.c"
		} else {
#line 122 "../src/Objects/Backup.vala"
			_tmp46_ = FALSE;
#line 569 "Backup.c"
		}
#line 122 "../src/Objects/Backup.vala"
		if (_tmp46_) {
#line 573 "Backup.c"
			ObjectsSource* todoist_source = NULL;
			ObjectsSource* _tmp51_;
			ObjectsSource* _tmp52_;
			gchar* _tmp53_;
			gchar* _tmp54_;
			ObjectsSource* _tmp55_;
			ObjectsSource* _tmp56_;
			const gchar* _tmp57_;
			ObjectsSourceTodoistData* todoist_data = NULL;
			ObjectsSourceTodoistData* _tmp58_;
			ObjectsSourceTodoistData* _tmp59_;
			const gchar* _tmp60_;
			ObjectsSourceTodoistData* _tmp61_;
			const gchar* _tmp62_;
			ObjectsSourceTodoistData* _tmp63_;
			const gchar* _tmp64_;
			ObjectsSourceTodoistData* _tmp65_;
			const gchar* _tmp66_;
			ObjectsSourceTodoistData* _tmp67_;
			const gchar* _tmp68_;
			ObjectsSourceTodoistData* _tmp69_;
			const gchar* _tmp70_;
			ObjectsSourceTodoistData* _tmp71_;
			gboolean _tmp72_;
			ObjectsSource* _tmp73_;
			ObjectsSourceTodoistData* _tmp74_;
			GeeArrayList* _tmp75_;
			ObjectsSource* _tmp76_;
#line 123 "../src/Objects/Backup.vala"
			_tmp51_ = objects_source_new ();
#line 123 "../src/Objects/Backup.vala"
			todoist_source = _tmp51_;
#line 124 "../src/Objects/Backup.vala"
			_tmp52_ = todoist_source;
#line 124 "../src/Objects/Backup.vala"
			_tmp53_ = source_type_to_string (SOURCE_TYPE_TODOIST);
#line 124 "../src/Objects/Backup.vala"
			_tmp54_ = _tmp53_;
#line 124 "../src/Objects/Backup.vala"
			objects_base_object_set_id ((ObjectsBaseObject*) _tmp52_, _tmp54_);
#line 124 "../src/Objects/Backup.vala"
			_g_free0 (_tmp54_);
#line 125 "../src/Objects/Backup.vala"
			_tmp55_ = todoist_source;
#line 125 "../src/Objects/Backup.vala"
			objects_source_set_source_type (_tmp55_, SOURCE_TYPE_TODOIST);
#line 126 "../src/Objects/Backup.vala"
			_tmp56_ = todoist_source;
#line 126 "../src/Objects/Backup.vala"
			_tmp57_ = self->priv->_todoist_user_email;
#line 126 "../src/Objects/Backup.vala"
			objects_source_set_display_name (_tmp56_, _tmp57_);
#line 128 "../src/Objects/Backup.vala"
			_tmp58_ = objects_source_todoist_data_new ();
#line 128 "../src/Objects/Backup.vala"
			todoist_data = _tmp58_;
#line 129 "../src/Objects/Backup.vala"
			_tmp59_ = todoist_data;
#line 129 "../src/Objects/Backup.vala"
			_tmp60_ = self->priv->_todoist_sync_token;
#line 129 "../src/Objects/Backup.vala"
			objects_source_todoist_data_set_sync_token (_tmp59_, _tmp60_);
#line 130 "../src/Objects/Backup.vala"
			_tmp61_ = todoist_data;
#line 130 "../src/Objects/Backup.vala"
			_tmp62_ = self->priv->_todoist_access_token;
#line 130 "../src/Objects/Backup.vala"
			objects_source_todoist_data_set_access_token (_tmp61_, _tmp62_);
#line 131 "../src/Objects/Backup.vala"
			_tmp63_ = todoist_data;
#line 131 "../src/Objects/Backup.vala"
			_tmp64_ = self->priv->_todoist_user_email;
#line 131 "../src/Objects/Backup.vala"
			objects_source_todoist_data_set_user_email (_tmp63_, _tmp64_);
#line 132 "../src/Objects/Backup.vala"
			_tmp65_ = todoist_data;
#line 132 "../src/Objects/Backup.vala"
			_tmp66_ = self->priv->_todoist_user_email;
#line 132 "../src/Objects/Backup.vala"
			objects_source_todoist_data_set_user_name (_tmp65_, _tmp66_);
#line 133 "../src/Objects/Backup.vala"
			_tmp67_ = todoist_data;
#line 133 "../src/Objects/Backup.vala"
			_tmp68_ = self->priv->_todoist_user_avatar;
#line 133 "../src/Objects/Backup.vala"
			objects_source_todoist_data_set_user_avatar (_tmp67_, _tmp68_);
#line 134 "../src/Objects/Backup.vala"
			_tmp69_ = todoist_data;
#line 134 "../src/Objects/Backup.vala"
			_tmp70_ = self->priv->_todoist_user_image_id;
#line 134 "../src/Objects/Backup.vala"
			objects_source_todoist_data_set_user_image_id (_tmp69_, _tmp70_);
#line 135 "../src/Objects/Backup.vala"
			_tmp71_ = todoist_data;
#line 135 "../src/Objects/Backup.vala"
			_tmp72_ = self->priv->_todoist_user_is_premium;
#line 135 "../src/Objects/Backup.vala"
			objects_source_todoist_data_set_user_is_premium (_tmp71_, _tmp72_);
#line 136 "../src/Objects/Backup.vala"
			_tmp73_ = todoist_source;
#line 136 "../src/Objects/Backup.vala"
			_tmp74_ = todoist_data;
#line 136 "../src/Objects/Backup.vala"
			objects_source_set_data (_tmp73_, (ObjectsSourceData*) _tmp74_);
#line 138 "../src/Objects/Backup.vala"
			_tmp75_ = self->priv->_sources;
#line 138 "../src/Objects/Backup.vala"
			_tmp76_ = todoist_source;
#line 138 "../src/Objects/Backup.vala"
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp75_, _tmp76_);
#line 122 "../src/Objects/Backup.vala"
			_g_object_unref0 (todoist_data);
#line 122 "../src/Objects/Backup.vala"
			_g_object_unref0 (todoist_source);
#line 688 "Backup.c"
		}
#line 142 "../src/Objects/Backup.vala"
		_tmp77_ = self->priv->_labels;
#line 142 "../src/Objects/Backup.vala"
		gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp77_);
#line 143 "../src/Objects/Backup.vala"
		_tmp78_ = node;
#line 143 "../src/Objects/Backup.vala"
		_tmp79_ = json_object_get_array_member (_tmp78_, "labels");
#line 143 "../src/Objects/Backup.vala"
		_labels = _tmp79_;
#line 144 "../src/Objects/Backup.vala"
		_tmp80_ = _labels;
#line 144 "../src/Objects/Backup.vala"
		_tmp81_ = json_array_get_elements (_tmp80_);
#line 704 "Backup.c"
		{
			GList* item_collection = NULL;
			GList* item_it = NULL;
#line 144 "../src/Objects/Backup.vala"
			item_collection = _tmp81_;
#line 144 "../src/Objects/Backup.vala"
			for (item_it = item_collection; item_it != NULL; item_it = item_it->next) {
#line 712 "Backup.c"
				JsonNode* item = NULL;
#line 144 "../src/Objects/Backup.vala"
				item = (JsonNode*) item_it->data;
#line 716 "Backup.c"
				{
					GeeArrayList* _tmp82_;
					JsonNode* _tmp83_;
					ObjectsLabel* _tmp84_;
					ObjectsLabel* _tmp85_;
#line 145 "../src/Objects/Backup.vala"
					_tmp82_ = self->priv->_labels;
#line 145 "../src/Objects/Backup.vala"
					_tmp83_ = item;
#line 145 "../src/Objects/Backup.vala"
					_tmp84_ = objects_label_new_from_import_json (_tmp83_);
#line 145 "../src/Objects/Backup.vala"
					_tmp85_ = _tmp84_;
#line 145 "../src/Objects/Backup.vala"
					gee_abstract_collection_add ((GeeAbstractCollection*) _tmp82_, _tmp85_);
#line 145 "../src/Objects/Backup.vala"
					_g_object_unref0 (_tmp85_);
#line 734 "Backup.c"
				}
			}
#line 144 "../src/Objects/Backup.vala"
			(item_collection == NULL) ? NULL : (item_collection = (g_list_free (item_collection), NULL));
#line 739 "Backup.c"
		}
#line 149 "../src/Objects/Backup.vala"
		_tmp86_ = self->priv->_projects;
#line 149 "../src/Objects/Backup.vala"
		gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp86_);
#line 150 "../src/Objects/Backup.vala"
		_tmp87_ = node;
#line 150 "../src/Objects/Backup.vala"
		_tmp88_ = json_object_get_array_member (_tmp87_, "projects");
#line 150 "../src/Objects/Backup.vala"
		_projects = _tmp88_;
#line 151 "../src/Objects/Backup.vala"
		_tmp89_ = _projects;
#line 151 "../src/Objects/Backup.vala"
		_tmp90_ = json_array_get_elements (_tmp89_);
#line 755 "Backup.c"
		{
			GList* item_collection = NULL;
			GList* item_it = NULL;
#line 151 "../src/Objects/Backup.vala"
			item_collection = _tmp90_;
#line 151 "../src/Objects/Backup.vala"
			for (item_it = item_collection; item_it != NULL; item_it = item_it->next) {
#line 763 "Backup.c"
				JsonNode* item = NULL;
#line 151 "../src/Objects/Backup.vala"
				item = (JsonNode*) item_it->data;
#line 767 "Backup.c"
				{
					ObjectsProject* _project = NULL;
					JsonNode* _tmp91_;
					ObjectsProject* _tmp92_;
					const gchar* _tmp93_;
#line 152 "../src/Objects/Backup.vala"
					_tmp91_ = item;
#line 152 "../src/Objects/Backup.vala"
					_tmp92_ = objects_project_new_from_import_json (_tmp91_);
#line 152 "../src/Objects/Backup.vala"
					_project = _tmp92_;
#line 154 "../src/Objects/Backup.vala"
					_tmp93_ = self->priv->_version;
#line 154 "../src/Objects/Backup.vala"
					if (g_strcmp0 (_tmp93_, "1.0") == 0) {
#line 783 "Backup.c"
						ObjectsProject* _tmp94_;
						const gchar* _tmp95_;
						const gchar* _tmp96_;
						gchar* _tmp97_;
						gchar* _tmp98_;
						gboolean _tmp99_;
#line 155 "../src/Objects/Backup.vala"
						_tmp94_ = _project;
#line 155 "../src/Objects/Backup.vala"
						_tmp95_ = objects_project_get_source_id (_tmp94_);
#line 155 "../src/Objects/Backup.vala"
						_tmp96_ = _tmp95_;
#line 155 "../src/Objects/Backup.vala"
						_tmp97_ = source_type_to_string (SOURCE_TYPE_CALDAV);
#line 155 "../src/Objects/Backup.vala"
						_tmp98_ = _tmp97_;
#line 155 "../src/Objects/Backup.vala"
						_tmp99_ = g_strcmp0 (_tmp96_, _tmp98_) != 0;
#line 155 "../src/Objects/Backup.vala"
						_g_free0 (_tmp98_);
#line 155 "../src/Objects/Backup.vala"
						if (_tmp99_) {
#line 806 "Backup.c"
							GeeArrayList* _tmp100_;
							ObjectsProject* _tmp101_;
#line 156 "../src/Objects/Backup.vala"
							_tmp100_ = self->priv->_projects;
#line 156 "../src/Objects/Backup.vala"
							_tmp101_ = _project;
#line 156 "../src/Objects/Backup.vala"
							gee_abstract_collection_add ((GeeAbstractCollection*) _tmp100_, _tmp101_);
#line 815 "Backup.c"
						}
					} else {
						GeeArrayList* _tmp102_;
						ObjectsProject* _tmp103_;
#line 159 "../src/Objects/Backup.vala"
						_tmp102_ = self->priv->_projects;
#line 159 "../src/Objects/Backup.vala"
						_tmp103_ = _project;
#line 159 "../src/Objects/Backup.vala"
						gee_abstract_collection_add ((GeeAbstractCollection*) _tmp102_, _tmp103_);
#line 826 "Backup.c"
					}
#line 151 "../src/Objects/Backup.vala"
					_g_object_unref0 (_project);
#line 830 "Backup.c"
				}
			}
#line 151 "../src/Objects/Backup.vala"
			(item_collection == NULL) ? NULL : (item_collection = (g_list_free (item_collection), NULL));
#line 835 "Backup.c"
		}
#line 164 "../src/Objects/Backup.vala"
		_tmp104_ = self->priv->_sections;
#line 164 "../src/Objects/Backup.vala"
		gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp104_);
#line 165 "../src/Objects/Backup.vala"
		_tmp105_ = node;
#line 165 "../src/Objects/Backup.vala"
		_tmp106_ = json_object_get_array_member (_tmp105_, "sections");
#line 165 "../src/Objects/Backup.vala"
		_sections = _tmp106_;
#line 166 "../src/Objects/Backup.vala"
		_tmp107_ = _sections;
#line 166 "../src/Objects/Backup.vala"
		_tmp108_ = json_array_get_elements (_tmp107_);
#line 851 "Backup.c"
		{
			GList* item_collection = NULL;
			GList* item_it = NULL;
#line 166 "../src/Objects/Backup.vala"
			item_collection = _tmp108_;
#line 166 "../src/Objects/Backup.vala"
			for (item_it = item_collection; item_it != NULL; item_it = item_it->next) {
#line 859 "Backup.c"
				JsonNode* item = NULL;
#line 166 "../src/Objects/Backup.vala"
				item = (JsonNode*) item_it->data;
#line 863 "Backup.c"
				{
					GeeArrayList* _tmp109_;
					JsonNode* _tmp110_;
					ObjectsSection* _tmp111_;
					ObjectsSection* _tmp112_;
#line 167 "../src/Objects/Backup.vala"
					_tmp109_ = self->priv->_sections;
#line 167 "../src/Objects/Backup.vala"
					_tmp110_ = item;
#line 167 "../src/Objects/Backup.vala"
					_tmp111_ = objects_section_new_from_import_json (_tmp110_);
#line 167 "../src/Objects/Backup.vala"
					_tmp112_ = _tmp111_;
#line 167 "../src/Objects/Backup.vala"
					gee_abstract_collection_add ((GeeAbstractCollection*) _tmp109_, _tmp112_);
#line 167 "../src/Objects/Backup.vala"
					_g_object_unref0 (_tmp112_);
#line 881 "Backup.c"
				}
			}
#line 166 "../src/Objects/Backup.vala"
			(item_collection == NULL) ? NULL : (item_collection = (g_list_free (item_collection), NULL));
#line 886 "Backup.c"
		}
#line 171 "../src/Objects/Backup.vala"
		_tmp113_ = self->priv->_items;
#line 171 "../src/Objects/Backup.vala"
		gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp113_);
#line 172 "../src/Objects/Backup.vala"
		_tmp114_ = node;
#line 172 "../src/Objects/Backup.vala"
		_tmp115_ = json_object_get_array_member (_tmp114_, "items");
#line 172 "../src/Objects/Backup.vala"
		_items = _tmp115_;
#line 173 "../src/Objects/Backup.vala"
		_tmp116_ = _items;
#line 173 "../src/Objects/Backup.vala"
		_tmp117_ = json_array_get_elements (_tmp116_);
#line 902 "Backup.c"
		{
			GList* item_collection = NULL;
			GList* item_it = NULL;
#line 173 "../src/Objects/Backup.vala"
			item_collection = _tmp117_;
#line 173 "../src/Objects/Backup.vala"
			for (item_it = item_collection; item_it != NULL; item_it = item_it->next) {
#line 910 "Backup.c"
				JsonNode* item = NULL;
#line 173 "../src/Objects/Backup.vala"
				item = (JsonNode*) item_it->data;
#line 914 "Backup.c"
				{
					GeeArrayList* _tmp118_;
					JsonNode* _tmp119_;
					GeeArrayList* _tmp120_;
					ObjectsItem* _tmp121_;
					ObjectsItem* _tmp122_;
#line 174 "../src/Objects/Backup.vala"
					_tmp118_ = self->priv->_items;
#line 174 "../src/Objects/Backup.vala"
					_tmp119_ = item;
#line 174 "../src/Objects/Backup.vala"
					_tmp120_ = self->priv->_labels;
#line 174 "../src/Objects/Backup.vala"
					_tmp121_ = objects_item_new_from_import_json (_tmp119_, _tmp120_);
#line 174 "../src/Objects/Backup.vala"
					_tmp122_ = _tmp121_;
#line 174 "../src/Objects/Backup.vala"
					gee_abstract_collection_add ((GeeAbstractCollection*) _tmp118_, _tmp122_);
#line 174 "../src/Objects/Backup.vala"
					_g_object_unref0 (_tmp122_);
#line 935 "Backup.c"
				}
			}
#line 173 "../src/Objects/Backup.vala"
			(item_collection == NULL) ? NULL : (item_collection = (g_list_free (item_collection), NULL));
#line 940 "Backup.c"
		}
#line 74 "../src/Objects/Backup.vala"
		_json_object_unref0 (settings);
#line 74 "../src/Objects/Backup.vala"
		_json_object_unref0 (node);
#line 946 "Backup.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp123_;
		const gchar* _tmp124_;
#line 74 "../src/Objects/Backup.vala"
		e = _inner_error0_;
#line 74 "../src/Objects/Backup.vala"
		_inner_error0_ = NULL;
#line 177 "../src/Objects/Backup.vala"
		_tmp123_ = e;
#line 177 "../src/Objects/Backup.vala"
		_tmp124_ = _tmp123_->message;
#line 177 "../src/Objects/Backup.vala"
		objects_backup_set_error (self, _tmp124_);
#line 74 "../src/Objects/Backup.vala"
		_g_error_free0 (e);
#line 966 "Backup.c"
	}
	__finally0:
#line 74 "../src/Objects/Backup.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 74 "../src/Objects/Backup.vala"
		_g_object_unref0 (parser);
#line 74 "../src/Objects/Backup.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 74 "../src/Objects/Backup.vala"
		g_clear_error (&_inner_error0_);
#line 74 "../src/Objects/Backup.vala"
		return NULL;
#line 979 "Backup.c"
	}
#line 71 "../src/Objects/Backup.vala"
	_g_object_unref0 (parser);
#line 71 "../src/Objects/Backup.vala"
	return self;
#line 985 "Backup.c"
}

ObjectsBackup*
objects_backup_new_from_file (GFile* file)
{
#line 71 "../src/Objects/Backup.vala"
	return objects_backup_construct_from_file (OBJECTS_TYPE_BACKUP, file);
#line 993 "Backup.c"
}

gboolean
objects_backup_valid (ObjectsBackup* self)
{
	const gchar* _tmp0_;
	gboolean _tmp1_ = FALSE;
	const gchar* _tmp2_;
	gboolean _tmp4_ = FALSE;
	const gchar* _tmp5_;
	GeeArrayList* _tmp7_;
	gboolean _tmp8_;
	gboolean _tmp9_;
	gboolean result;
#line 181 "../src/Objects/Backup.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 182 "../src/Objects/Backup.vala"
	_tmp0_ = self->priv->_error;
#line 182 "../src/Objects/Backup.vala"
	if (g_strcmp0 (_tmp0_, "") != 0) {
#line 183 "../src/Objects/Backup.vala"
		result = FALSE;
#line 183 "../src/Objects/Backup.vala"
		return result;
#line 1018 "Backup.c"
	}
#line 186 "../src/Objects/Backup.vala"
	_tmp2_ = self->priv->_version;
#line 186 "../src/Objects/Backup.vala"
	if (_tmp2_ == NULL) {
#line 186 "../src/Objects/Backup.vala"
		_tmp1_ = TRUE;
#line 1026 "Backup.c"
	} else {
		const gchar* _tmp3_;
#line 186 "../src/Objects/Backup.vala"
		_tmp3_ = self->priv->_version;
#line 186 "../src/Objects/Backup.vala"
		_tmp1_ = g_strcmp0 (_tmp3_, "") == 0;
#line 1033 "Backup.c"
	}
#line 186 "../src/Objects/Backup.vala"
	if (_tmp1_) {
#line 187 "../src/Objects/Backup.vala"
		result = FALSE;
#line 187 "../src/Objects/Backup.vala"
		return result;
#line 1041 "Backup.c"
	}
#line 190 "../src/Objects/Backup.vala"
	_tmp5_ = self->priv->_date;
#line 190 "../src/Objects/Backup.vala"
	if (_tmp5_ == NULL) {
#line 190 "../src/Objects/Backup.vala"
		_tmp4_ = TRUE;
#line 1049 "Backup.c"
	} else {
		const gchar* _tmp6_;
#line 190 "../src/Objects/Backup.vala"
		_tmp6_ = self->priv->_date;
#line 190 "../src/Objects/Backup.vala"
		_tmp4_ = g_strcmp0 (_tmp6_, "") == 0;
#line 1056 "Backup.c"
	}
#line 190 "../src/Objects/Backup.vala"
	if (_tmp4_) {
#line 191 "../src/Objects/Backup.vala"
		result = FALSE;
#line 191 "../src/Objects/Backup.vala"
		return result;
#line 1064 "Backup.c"
	}
#line 194 "../src/Objects/Backup.vala"
	_tmp7_ = self->priv->_projects;
#line 194 "../src/Objects/Backup.vala"
	_tmp8_ = gee_collection_get_is_empty ((GeeCollection*) _tmp7_);
#line 194 "../src/Objects/Backup.vala"
	_tmp9_ = _tmp8_;
#line 194 "../src/Objects/Backup.vala"
	if (_tmp9_) {
#line 195 "../src/Objects/Backup.vala"
		result = FALSE;
#line 195 "../src/Objects/Backup.vala"
		return result;
#line 1078 "Backup.c"
	}
#line 198 "../src/Objects/Backup.vala"
	result = TRUE;
#line 198 "../src/Objects/Backup.vala"
	return result;
#line 1084 "Backup.c"
}

ObjectsBackup*
objects_backup_construct (GType object_type)
{
	ObjectsBackup * self = NULL;
#line 22 "../src/Objects/Backup.vala"
	self = (ObjectsBackup*) g_object_new (object_type, NULL);
#line 22 "../src/Objects/Backup.vala"
	return self;
#line 1095 "Backup.c"
}

ObjectsBackup*
objects_backup_new (void)
{
#line 22 "../src/Objects/Backup.vala"
	return objects_backup_construct (OBJECTS_TYPE_BACKUP);
#line 1103 "Backup.c"
}

const gchar*
objects_backup_get_version (ObjectsBackup* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 23 "../src/Objects/Backup.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 23 "../src/Objects/Backup.vala"
	_tmp0_ = self->priv->_version;
#line 23 "../src/Objects/Backup.vala"
	result = _tmp0_;
#line 23 "../src/Objects/Backup.vala"
	return result;
#line 1119 "Backup.c"
}

void
objects_backup_set_version (ObjectsBackup* self,
                            const gchar* value)
{
	gchar* old_value;
#line 23 "../src/Objects/Backup.vala"
	g_return_if_fail (self != NULL);
#line 23 "../src/Objects/Backup.vala"
	old_value = objects_backup_get_version (self);
#line 23 "../src/Objects/Backup.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 1133 "Backup.c"
		gchar* _tmp0_;
#line 23 "../src/Objects/Backup.vala"
		_tmp0_ = g_strdup (value);
#line 23 "../src/Objects/Backup.vala"
		_g_free0 (self->priv->_version);
#line 23 "../src/Objects/Backup.vala"
		self->priv->_version = _tmp0_;
#line 23 "../src/Objects/Backup.vala"
		g_object_notify_by_pspec ((GObject *) self, objects_backup_properties[OBJECTS_BACKUP_VERSION_PROPERTY]);
#line 1143 "Backup.c"
	}
}

const gchar*
objects_backup_get_date (ObjectsBackup* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 24 "../src/Objects/Backup.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 24 "../src/Objects/Backup.vala"
	_tmp0_ = self->priv->_date;
#line 24 "../src/Objects/Backup.vala"
	result = _tmp0_;
#line 24 "../src/Objects/Backup.vala"
	return result;
#line 1160 "Backup.c"
}

void
objects_backup_set_date (ObjectsBackup* self,
                         const gchar* value)
{
	gchar* old_value;
#line 24 "../src/Objects/Backup.vala"
	g_return_if_fail (self != NULL);
#line 24 "../src/Objects/Backup.vala"
	old_value = objects_backup_get_date (self);
#line 24 "../src/Objects/Backup.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 1174 "Backup.c"
		gchar* _tmp0_;
#line 24 "../src/Objects/Backup.vala"
		_tmp0_ = g_strdup (value);
#line 24 "../src/Objects/Backup.vala"
		_g_free0 (self->priv->_date);
#line 24 "../src/Objects/Backup.vala"
		self->priv->_date = _tmp0_;
#line 24 "../src/Objects/Backup.vala"
		g_object_notify_by_pspec ((GObject *) self, objects_backup_properties[OBJECTS_BACKUP_DATE_PROPERTY]);
#line 1184 "Backup.c"
	}
}

gint
objects_backup_get_default_inbox (ObjectsBackup* self)
{
	gint result;
#line 26 "../src/Objects/Backup.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 26 "../src/Objects/Backup.vala"
	result = self->priv->_default_inbox;
#line 26 "../src/Objects/Backup.vala"
	return result;
#line 1198 "Backup.c"
}

void
objects_backup_set_default_inbox (ObjectsBackup* self,
                                  gint value)
{
	gint old_value;
#line 26 "../src/Objects/Backup.vala"
	g_return_if_fail (self != NULL);
#line 26 "../src/Objects/Backup.vala"
	old_value = objects_backup_get_default_inbox (self);
#line 26 "../src/Objects/Backup.vala"
	if (old_value != value) {
#line 26 "../src/Objects/Backup.vala"
		self->priv->_default_inbox = value;
#line 26 "../src/Objects/Backup.vala"
		g_object_notify_by_pspec ((GObject *) self, objects_backup_properties[OBJECTS_BACKUP_DEFAULT_INBOX_PROPERTY]);
#line 1216 "Backup.c"
	}
}

const gchar*
objects_backup_get_local_inbox_project_id (ObjectsBackup* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 27 "../src/Objects/Backup.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 27 "../src/Objects/Backup.vala"
	_tmp0_ = self->priv->_local_inbox_project_id;
#line 27 "../src/Objects/Backup.vala"
	result = _tmp0_;
#line 27 "../src/Objects/Backup.vala"
	return result;
#line 1233 "Backup.c"
}

void
objects_backup_set_local_inbox_project_id (ObjectsBackup* self,
                                           const gchar* value)
{
	gchar* old_value;
#line 27 "../src/Objects/Backup.vala"
	g_return_if_fail (self != NULL);
#line 27 "../src/Objects/Backup.vala"
	old_value = objects_backup_get_local_inbox_project_id (self);
#line 27 "../src/Objects/Backup.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 1247 "Backup.c"
		gchar* _tmp0_;
#line 27 "../src/Objects/Backup.vala"
		_tmp0_ = g_strdup (value);
#line 27 "../src/Objects/Backup.vala"
		_g_free0 (self->priv->_local_inbox_project_id);
#line 27 "../src/Objects/Backup.vala"
		self->priv->_local_inbox_project_id = _tmp0_;
#line 27 "../src/Objects/Backup.vala"
		g_object_notify_by_pspec ((GObject *) self, objects_backup_properties[OBJECTS_BACKUP_LOCAL_INBOX_PROJECT_ID_PROPERTY]);
#line 1257 "Backup.c"
	}
}

const gchar*
objects_backup_get_todoist_access_token (ObjectsBackup* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 28 "../src/Objects/Backup.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 28 "../src/Objects/Backup.vala"
	_tmp0_ = self->priv->_todoist_access_token;
#line 28 "../src/Objects/Backup.vala"
	result = _tmp0_;
#line 28 "../src/Objects/Backup.vala"
	return result;
#line 1274 "Backup.c"
}

void
objects_backup_set_todoist_access_token (ObjectsBackup* self,
                                         const gchar* value)
{
	gchar* old_value;
#line 28 "../src/Objects/Backup.vala"
	g_return_if_fail (self != NULL);
#line 28 "../src/Objects/Backup.vala"
	old_value = objects_backup_get_todoist_access_token (self);
#line 28 "../src/Objects/Backup.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 1288 "Backup.c"
		gchar* _tmp0_;
#line 28 "../src/Objects/Backup.vala"
		_tmp0_ = g_strdup (value);
#line 28 "../src/Objects/Backup.vala"
		_g_free0 (self->priv->_todoist_access_token);
#line 28 "../src/Objects/Backup.vala"
		self->priv->_todoist_access_token = _tmp0_;
#line 28 "../src/Objects/Backup.vala"
		g_object_notify_by_pspec ((GObject *) self, objects_backup_properties[OBJECTS_BACKUP_TODOIST_ACCESS_TOKEN_PROPERTY]);
#line 1298 "Backup.c"
	}
}

const gchar*
objects_backup_get_todoist_sync_token (ObjectsBackup* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 29 "../src/Objects/Backup.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 29 "../src/Objects/Backup.vala"
	_tmp0_ = self->priv->_todoist_sync_token;
#line 29 "../src/Objects/Backup.vala"
	result = _tmp0_;
#line 29 "../src/Objects/Backup.vala"
	return result;
#line 1315 "Backup.c"
}

void
objects_backup_set_todoist_sync_token (ObjectsBackup* self,
                                       const gchar* value)
{
	gchar* old_value;
#line 29 "../src/Objects/Backup.vala"
	g_return_if_fail (self != NULL);
#line 29 "../src/Objects/Backup.vala"
	old_value = objects_backup_get_todoist_sync_token (self);
#line 29 "../src/Objects/Backup.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 1329 "Backup.c"
		gchar* _tmp0_;
#line 29 "../src/Objects/Backup.vala"
		_tmp0_ = g_strdup (value);
#line 29 "../src/Objects/Backup.vala"
		_g_free0 (self->priv->_todoist_sync_token);
#line 29 "../src/Objects/Backup.vala"
		self->priv->_todoist_sync_token = _tmp0_;
#line 29 "../src/Objects/Backup.vala"
		g_object_notify_by_pspec ((GObject *) self, objects_backup_properties[OBJECTS_BACKUP_TODOIST_SYNC_TOKEN_PROPERTY]);
#line 1339 "Backup.c"
	}
}

const gchar*
objects_backup_get_todoist_user_name (ObjectsBackup* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 30 "../src/Objects/Backup.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 30 "../src/Objects/Backup.vala"
	_tmp0_ = self->priv->_todoist_user_name;
#line 30 "../src/Objects/Backup.vala"
	result = _tmp0_;
#line 30 "../src/Objects/Backup.vala"
	return result;
#line 1356 "Backup.c"
}

void
objects_backup_set_todoist_user_name (ObjectsBackup* self,
                                      const gchar* value)
{
	gchar* old_value;
#line 30 "../src/Objects/Backup.vala"
	g_return_if_fail (self != NULL);
#line 30 "../src/Objects/Backup.vala"
	old_value = objects_backup_get_todoist_user_name (self);
#line 30 "../src/Objects/Backup.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 1370 "Backup.c"
		gchar* _tmp0_;
#line 30 "../src/Objects/Backup.vala"
		_tmp0_ = g_strdup (value);
#line 30 "../src/Objects/Backup.vala"
		_g_free0 (self->priv->_todoist_user_name);
#line 30 "../src/Objects/Backup.vala"
		self->priv->_todoist_user_name = _tmp0_;
#line 30 "../src/Objects/Backup.vala"
		g_object_notify_by_pspec ((GObject *) self, objects_backup_properties[OBJECTS_BACKUP_TODOIST_USER_NAME_PROPERTY]);
#line 1380 "Backup.c"
	}
}

const gchar*
objects_backup_get_todoist_user_email (ObjectsBackup* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 31 "../src/Objects/Backup.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 31 "../src/Objects/Backup.vala"
	_tmp0_ = self->priv->_todoist_user_email;
#line 31 "../src/Objects/Backup.vala"
	result = _tmp0_;
#line 31 "../src/Objects/Backup.vala"
	return result;
#line 1397 "Backup.c"
}

void
objects_backup_set_todoist_user_email (ObjectsBackup* self,
                                       const gchar* value)
{
	gchar* old_value;
#line 31 "../src/Objects/Backup.vala"
	g_return_if_fail (self != NULL);
#line 31 "../src/Objects/Backup.vala"
	old_value = objects_backup_get_todoist_user_email (self);
#line 31 "../src/Objects/Backup.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 1411 "Backup.c"
		gchar* _tmp0_;
#line 31 "../src/Objects/Backup.vala"
		_tmp0_ = g_strdup (value);
#line 31 "../src/Objects/Backup.vala"
		_g_free0 (self->priv->_todoist_user_email);
#line 31 "../src/Objects/Backup.vala"
		self->priv->_todoist_user_email = _tmp0_;
#line 31 "../src/Objects/Backup.vala"
		g_object_notify_by_pspec ((GObject *) self, objects_backup_properties[OBJECTS_BACKUP_TODOIST_USER_EMAIL_PROPERTY]);
#line 1421 "Backup.c"
	}
}

const gchar*
objects_backup_get_todoist_user_image_id (ObjectsBackup* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 32 "../src/Objects/Backup.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 32 "../src/Objects/Backup.vala"
	_tmp0_ = self->priv->_todoist_user_image_id;
#line 32 "../src/Objects/Backup.vala"
	result = _tmp0_;
#line 32 "../src/Objects/Backup.vala"
	return result;
#line 1438 "Backup.c"
}

void
objects_backup_set_todoist_user_image_id (ObjectsBackup* self,
                                          const gchar* value)
{
	gchar* old_value;
#line 32 "../src/Objects/Backup.vala"
	g_return_if_fail (self != NULL);
#line 32 "../src/Objects/Backup.vala"
	old_value = objects_backup_get_todoist_user_image_id (self);
#line 32 "../src/Objects/Backup.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 1452 "Backup.c"
		gchar* _tmp0_;
#line 32 "../src/Objects/Backup.vala"
		_tmp0_ = g_strdup (value);
#line 32 "../src/Objects/Backup.vala"
		_g_free0 (self->priv->_todoist_user_image_id);
#line 32 "../src/Objects/Backup.vala"
		self->priv->_todoist_user_image_id = _tmp0_;
#line 32 "../src/Objects/Backup.vala"
		g_object_notify_by_pspec ((GObject *) self, objects_backup_properties[OBJECTS_BACKUP_TODOIST_USER_IMAGE_ID_PROPERTY]);
#line 1462 "Backup.c"
	}
}

const gchar*
objects_backup_get_todoist_user_avatar (ObjectsBackup* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 33 "../src/Objects/Backup.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 33 "../src/Objects/Backup.vala"
	_tmp0_ = self->priv->_todoist_user_avatar;
#line 33 "../src/Objects/Backup.vala"
	result = _tmp0_;
#line 33 "../src/Objects/Backup.vala"
	return result;
#line 1479 "Backup.c"
}

void
objects_backup_set_todoist_user_avatar (ObjectsBackup* self,
                                        const gchar* value)
{
	gchar* old_value;
#line 33 "../src/Objects/Backup.vala"
	g_return_if_fail (self != NULL);
#line 33 "../src/Objects/Backup.vala"
	old_value = objects_backup_get_todoist_user_avatar (self);
#line 33 "../src/Objects/Backup.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 1493 "Backup.c"
		gchar* _tmp0_;
#line 33 "../src/Objects/Backup.vala"
		_tmp0_ = g_strdup (value);
#line 33 "../src/Objects/Backup.vala"
		_g_free0 (self->priv->_todoist_user_avatar);
#line 33 "../src/Objects/Backup.vala"
		self->priv->_todoist_user_avatar = _tmp0_;
#line 33 "../src/Objects/Backup.vala"
		g_object_notify_by_pspec ((GObject *) self, objects_backup_properties[OBJECTS_BACKUP_TODOIST_USER_AVATAR_PROPERTY]);
#line 1503 "Backup.c"
	}
}

gboolean
objects_backup_get_todoist_user_is_premium (ObjectsBackup* self)
{
	gboolean result;
#line 34 "../src/Objects/Backup.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 34 "../src/Objects/Backup.vala"
	result = self->priv->_todoist_user_is_premium;
#line 34 "../src/Objects/Backup.vala"
	return result;
#line 1517 "Backup.c"
}

void
objects_backup_set_todoist_user_is_premium (ObjectsBackup* self,
                                            gboolean value)
{
	gboolean old_value;
#line 34 "../src/Objects/Backup.vala"
	g_return_if_fail (self != NULL);
#line 34 "../src/Objects/Backup.vala"
	old_value = objects_backup_get_todoist_user_is_premium (self);
#line 34 "../src/Objects/Backup.vala"
	if (old_value != value) {
#line 34 "../src/Objects/Backup.vala"
		self->priv->_todoist_user_is_premium = value;
#line 34 "../src/Objects/Backup.vala"
		g_object_notify_by_pspec ((GObject *) self, objects_backup_properties[OBJECTS_BACKUP_TODOIST_USER_IS_PREMIUM_PROPERTY]);
#line 1535 "Backup.c"
	}
}

GeeArrayList*
objects_backup_get_projects (ObjectsBackup* self)
{
	GeeArrayList* result;
	GeeArrayList* _tmp0_;
#line 36 "../src/Objects/Backup.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 36 "../src/Objects/Backup.vala"
	_tmp0_ = self->priv->_projects;
#line 36 "../src/Objects/Backup.vala"
	result = _tmp0_;
#line 36 "../src/Objects/Backup.vala"
	return result;
#line 1552 "Backup.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 36 "../src/Objects/Backup.vala"
	return self ? g_object_ref (self) : NULL;
#line 1560 "Backup.c"
}

void
objects_backup_set_projects (ObjectsBackup* self,
                             GeeArrayList* value)
{
	GeeArrayList* old_value;
#line 36 "../src/Objects/Backup.vala"
	g_return_if_fail (self != NULL);
#line 36 "../src/Objects/Backup.vala"
	old_value = objects_backup_get_projects (self);
#line 36 "../src/Objects/Backup.vala"
	if (old_value != value) {
#line 1574 "Backup.c"
		GeeArrayList* _tmp0_;
#line 36 "../src/Objects/Backup.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 36 "../src/Objects/Backup.vala"
		_g_object_unref0 (self->priv->_projects);
#line 36 "../src/Objects/Backup.vala"
		self->priv->_projects = _tmp0_;
#line 36 "../src/Objects/Backup.vala"
		g_object_notify_by_pspec ((GObject *) self, objects_backup_properties[OBJECTS_BACKUP_PROJECTS_PROPERTY]);
#line 1584 "Backup.c"
	}
}

GeeArrayList*
objects_backup_get_sections (ObjectsBackup* self)
{
	GeeArrayList* result;
	GeeArrayList* _tmp0_;
#line 37 "../src/Objects/Backup.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 37 "../src/Objects/Backup.vala"
	_tmp0_ = self->priv->_sections;
#line 37 "../src/Objects/Backup.vala"
	result = _tmp0_;
#line 37 "../src/Objects/Backup.vala"
	return result;
#line 1601 "Backup.c"
}

void
objects_backup_set_sections (ObjectsBackup* self,
                             GeeArrayList* value)
{
	GeeArrayList* old_value;
#line 37 "../src/Objects/Backup.vala"
	g_return_if_fail (self != NULL);
#line 37 "../src/Objects/Backup.vala"
	old_value = objects_backup_get_sections (self);
#line 37 "../src/Objects/Backup.vala"
	if (old_value != value) {
#line 1615 "Backup.c"
		GeeArrayList* _tmp0_;
#line 37 "../src/Objects/Backup.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 37 "../src/Objects/Backup.vala"
		_g_object_unref0 (self->priv->_sections);
#line 37 "../src/Objects/Backup.vala"
		self->priv->_sections = _tmp0_;
#line 37 "../src/Objects/Backup.vala"
		g_object_notify_by_pspec ((GObject *) self, objects_backup_properties[OBJECTS_BACKUP_SECTIONS_PROPERTY]);
#line 1625 "Backup.c"
	}
}

GeeArrayList*
objects_backup_get_items (ObjectsBackup* self)
{
	GeeArrayList* result;
	GeeArrayList* _tmp0_;
#line 38 "../src/Objects/Backup.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 38 "../src/Objects/Backup.vala"
	_tmp0_ = self->priv->_items;
#line 38 "../src/Objects/Backup.vala"
	result = _tmp0_;
#line 38 "../src/Objects/Backup.vala"
	return result;
#line 1642 "Backup.c"
}

void
objects_backup_set_items (ObjectsBackup* self,
                          GeeArrayList* value)
{
	GeeArrayList* old_value;
#line 38 "../src/Objects/Backup.vala"
	g_return_if_fail (self != NULL);
#line 38 "../src/Objects/Backup.vala"
	old_value = objects_backup_get_items (self);
#line 38 "../src/Objects/Backup.vala"
	if (old_value != value) {
#line 1656 "Backup.c"
		GeeArrayList* _tmp0_;
#line 38 "../src/Objects/Backup.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 38 "../src/Objects/Backup.vala"
		_g_object_unref0 (self->priv->_items);
#line 38 "../src/Objects/Backup.vala"
		self->priv->_items = _tmp0_;
#line 38 "../src/Objects/Backup.vala"
		g_object_notify_by_pspec ((GObject *) self, objects_backup_properties[OBJECTS_BACKUP_ITEMS_PROPERTY]);
#line 1666 "Backup.c"
	}
}

GeeArrayList*
objects_backup_get_labels (ObjectsBackup* self)
{
	GeeArrayList* result;
	GeeArrayList* _tmp0_;
#line 39 "../src/Objects/Backup.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 39 "../src/Objects/Backup.vala"
	_tmp0_ = self->priv->_labels;
#line 39 "../src/Objects/Backup.vala"
	result = _tmp0_;
#line 39 "../src/Objects/Backup.vala"
	return result;
#line 1683 "Backup.c"
}

void
objects_backup_set_labels (ObjectsBackup* self,
                           GeeArrayList* value)
{
	GeeArrayList* old_value;
#line 39 "../src/Objects/Backup.vala"
	g_return_if_fail (self != NULL);
#line 39 "../src/Objects/Backup.vala"
	old_value = objects_backup_get_labels (self);
#line 39 "../src/Objects/Backup.vala"
	if (old_value != value) {
#line 1697 "Backup.c"
		GeeArrayList* _tmp0_;
#line 39 "../src/Objects/Backup.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 39 "../src/Objects/Backup.vala"
		_g_object_unref0 (self->priv->_labels);
#line 39 "../src/Objects/Backup.vala"
		self->priv->_labels = _tmp0_;
#line 39 "../src/Objects/Backup.vala"
		g_object_notify_by_pspec ((GObject *) self, objects_backup_properties[OBJECTS_BACKUP_LABELS_PROPERTY]);
#line 1707 "Backup.c"
	}
}

GeeArrayList*
objects_backup_get_sources (ObjectsBackup* self)
{
	GeeArrayList* result;
	GeeArrayList* _tmp0_;
#line 40 "../src/Objects/Backup.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 40 "../src/Objects/Backup.vala"
	_tmp0_ = self->priv->_sources;
#line 40 "../src/Objects/Backup.vala"
	result = _tmp0_;
#line 40 "../src/Objects/Backup.vala"
	return result;
#line 1724 "Backup.c"
}

void
objects_backup_set_sources (ObjectsBackup* self,
                            GeeArrayList* value)
{
	GeeArrayList* old_value;
#line 40 "../src/Objects/Backup.vala"
	g_return_if_fail (self != NULL);
#line 40 "../src/Objects/Backup.vala"
	old_value = objects_backup_get_sources (self);
#line 40 "../src/Objects/Backup.vala"
	if (old_value != value) {
#line 1738 "Backup.c"
		GeeArrayList* _tmp0_;
#line 40 "../src/Objects/Backup.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 40 "../src/Objects/Backup.vala"
		_g_object_unref0 (self->priv->_sources);
#line 40 "../src/Objects/Backup.vala"
		self->priv->_sources = _tmp0_;
#line 40 "../src/Objects/Backup.vala"
		g_object_notify_by_pspec ((GObject *) self, objects_backup_properties[OBJECTS_BACKUP_SOURCES_PROPERTY]);
#line 1748 "Backup.c"
	}
}

const gchar*
objects_backup_get_path (ObjectsBackup* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 42 "../src/Objects/Backup.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 42 "../src/Objects/Backup.vala"
	_tmp0_ = self->priv->_path;
#line 42 "../src/Objects/Backup.vala"
	result = _tmp0_;
#line 42 "../src/Objects/Backup.vala"
	return result;
#line 1765 "Backup.c"
}

void
objects_backup_set_path (ObjectsBackup* self,
                         const gchar* value)
{
	gchar* old_value;
#line 42 "../src/Objects/Backup.vala"
	g_return_if_fail (self != NULL);
#line 42 "../src/Objects/Backup.vala"
	old_value = objects_backup_get_path (self);
#line 42 "../src/Objects/Backup.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 1779 "Backup.c"
		gchar* _tmp0_;
#line 42 "../src/Objects/Backup.vala"
		_tmp0_ = g_strdup (value);
#line 42 "../src/Objects/Backup.vala"
		_g_free0 (self->priv->_path);
#line 42 "../src/Objects/Backup.vala"
		self->priv->_path = _tmp0_;
#line 42 "../src/Objects/Backup.vala"
		g_object_notify_by_pspec ((GObject *) self, objects_backup_properties[OBJECTS_BACKUP_PATH_PROPERTY]);
#line 1789 "Backup.c"
	}
}

const gchar*
objects_backup_get_error (ObjectsBackup* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 43 "../src/Objects/Backup.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 43 "../src/Objects/Backup.vala"
	_tmp0_ = self->priv->_error;
#line 43 "../src/Objects/Backup.vala"
	result = _tmp0_;
#line 43 "../src/Objects/Backup.vala"
	return result;
#line 1806 "Backup.c"
}

void
objects_backup_set_error (ObjectsBackup* self,
                          const gchar* value)
{
	gchar* old_value;
#line 43 "../src/Objects/Backup.vala"
	g_return_if_fail (self != NULL);
#line 43 "../src/Objects/Backup.vala"
	old_value = objects_backup_get_error (self);
#line 43 "../src/Objects/Backup.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 1820 "Backup.c"
		gchar* _tmp0_;
#line 43 "../src/Objects/Backup.vala"
		_tmp0_ = g_strdup (value);
#line 43 "../src/Objects/Backup.vala"
		_g_free0 (self->priv->_error);
#line 43 "../src/Objects/Backup.vala"
		self->priv->_error = _tmp0_;
#line 43 "../src/Objects/Backup.vala"
		g_object_notify_by_pspec ((GObject *) self, objects_backup_properties[OBJECTS_BACKUP_ERROR_PROPERTY]);
#line 1830 "Backup.c"
	}
}

GDateTime*
objects_backup_get_datetime (ObjectsBackup* self)
{
	GDateTime* result;
	const gchar* _tmp0_;
	GTimeZone* _tmp1_;
	GTimeZone* _tmp2_;
	GDateTime* _tmp3_;
	GDateTime* _tmp4_;
#line 47 "../src/Objects/Backup.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 48 "../src/Objects/Backup.vala"
	_tmp0_ = self->priv->_date;
#line 48 "../src/Objects/Backup.vala"
	_tmp1_ = g_time_zone_new_local ();
#line 48 "../src/Objects/Backup.vala"
	_tmp2_ = _tmp1_;
#line 48 "../src/Objects/Backup.vala"
	_tmp3_ = g_date_time_new_from_iso8601 (_tmp0_, _tmp2_);
#line 48 "../src/Objects/Backup.vala"
	_g_date_time_unref0 (self->priv->_datetime);
#line 48 "../src/Objects/Backup.vala"
	self->priv->_datetime = _tmp3_;
#line 48 "../src/Objects/Backup.vala"
	_g_time_zone_unref0 (_tmp2_);
#line 49 "../src/Objects/Backup.vala"
	_tmp4_ = self->priv->_datetime;
#line 49 "../src/Objects/Backup.vala"
	result = _tmp4_;
#line 49 "../src/Objects/Backup.vala"
	return result;
#line 1865 "Backup.c"
}

const gchar*
objects_backup_get_title (ObjectsBackup* self)
{
	const gchar* result;
	GDateTime* _tmp0_;
	GDateTime* _tmp1_;
	gchar* _tmp2_;
	const gchar* _tmp3_;
#line 55 "../src/Objects/Backup.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 56 "../src/Objects/Backup.vala"
	_tmp0_ = objects_backup_get_datetime (self);
#line 56 "../src/Objects/Backup.vala"
	_tmp1_ = _tmp0_;
#line 56 "../src/Objects/Backup.vala"
	_tmp2_ = g_date_time_format (_tmp1_, "%c");
#line 56 "../src/Objects/Backup.vala"
	_g_free0 (self->priv->_title);
#line 56 "../src/Objects/Backup.vala"
	self->priv->_title = _tmp2_;
#line 57 "../src/Objects/Backup.vala"
	_tmp3_ = self->priv->_title;
#line 57 "../src/Objects/Backup.vala"
	result = _tmp3_;
#line 57 "../src/Objects/Backup.vala"
	return result;
#line 1894 "Backup.c"
}

gboolean
objects_backup_get_todoist_backend (ObjectsBackup* self)
{
	gboolean result;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
#line 63 "../src/Objects/Backup.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 64 "../src/Objects/Backup.vala"
	_tmp0_ = self->priv->_todoist_access_token;
#line 64 "../src/Objects/Backup.vala"
	_tmp1_ = string_strip (_tmp0_);
#line 64 "../src/Objects/Backup.vala"
	_tmp2_ = _tmp1_;
#line 64 "../src/Objects/Backup.vala"
	self->priv->_todoist_backend = g_strcmp0 (_tmp2_, "") != 0;
#line 64 "../src/Objects/Backup.vala"
	_g_free0 (_tmp2_);
#line 65 "../src/Objects/Backup.vala"
	result = self->priv->_todoist_backend;
#line 65 "../src/Objects/Backup.vala"
	return result;
#line 1920 "Backup.c"
}

static void
objects_backup_class_init (ObjectsBackupClass * klass,
                           gpointer klass_data)
{
#line 22 "../src/Objects/Backup.vala"
	objects_backup_parent_class = g_type_class_peek_parent (klass);
#line 22 "../src/Objects/Backup.vala"
	g_type_class_adjust_private_offset (klass, &ObjectsBackup_private_offset);
#line 22 "../src/Objects/Backup.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_objects_backup_get_property;
#line 22 "../src/Objects/Backup.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_objects_backup_set_property;
#line 22 "../src/Objects/Backup.vala"
	G_OBJECT_CLASS (klass)->finalize = objects_backup_finalize;
#line 22 "../src/Objects/Backup.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), OBJECTS_BACKUP_VERSION_PROPERTY, objects_backup_properties[OBJECTS_BACKUP_VERSION_PROPERTY] = g_param_spec_string ("version", "version", "version", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 22 "../src/Objects/Backup.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), OBJECTS_BACKUP_DATE_PROPERTY, objects_backup_properties[OBJECTS_BACKUP_DATE_PROPERTY] = g_param_spec_string ("date", "date", "date", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 22 "../src/Objects/Backup.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), OBJECTS_BACKUP_DEFAULT_INBOX_PROPERTY, objects_backup_properties[OBJECTS_BACKUP_DEFAULT_INBOX_PROPERTY] = g_param_spec_int ("default-inbox", "default-inbox", "default-inbox", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 22 "../src/Objects/Backup.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), OBJECTS_BACKUP_LOCAL_INBOX_PROJECT_ID_PROPERTY, objects_backup_properties[OBJECTS_BACKUP_LOCAL_INBOX_PROJECT_ID_PROPERTY] = g_param_spec_string ("local-inbox-project-id", "local-inbox-project-id", "local-inbox-project-id", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 22 "../src/Objects/Backup.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), OBJECTS_BACKUP_TODOIST_ACCESS_TOKEN_PROPERTY, objects_backup_properties[OBJECTS_BACKUP_TODOIST_ACCESS_TOKEN_PROPERTY] = g_param_spec_string ("todoist-access-token", "todoist-access-token", "todoist-access-token", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 22 "../src/Objects/Backup.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), OBJECTS_BACKUP_TODOIST_SYNC_TOKEN_PROPERTY, objects_backup_properties[OBJECTS_BACKUP_TODOIST_SYNC_TOKEN_PROPERTY] = g_param_spec_string ("todoist-sync-token", "todoist-sync-token", "todoist-sync-token", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 22 "../src/Objects/Backup.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), OBJECTS_BACKUP_TODOIST_USER_NAME_PROPERTY, objects_backup_properties[OBJECTS_BACKUP_TODOIST_USER_NAME_PROPERTY] = g_param_spec_string ("todoist-user-name", "todoist-user-name", "todoist-user-name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 22 "../src/Objects/Backup.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), OBJECTS_BACKUP_TODOIST_USER_EMAIL_PROPERTY, objects_backup_properties[OBJECTS_BACKUP_TODOIST_USER_EMAIL_PROPERTY] = g_param_spec_string ("todoist-user-email", "todoist-user-email", "todoist-user-email", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 22 "../src/Objects/Backup.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), OBJECTS_BACKUP_TODOIST_USER_IMAGE_ID_PROPERTY, objects_backup_properties[OBJECTS_BACKUP_TODOIST_USER_IMAGE_ID_PROPERTY] = g_param_spec_string ("todoist-user-image-id", "todoist-user-image-id", "todoist-user-image-id", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 22 "../src/Objects/Backup.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), OBJECTS_BACKUP_TODOIST_USER_AVATAR_PROPERTY, objects_backup_properties[OBJECTS_BACKUP_TODOIST_USER_AVATAR_PROPERTY] = g_param_spec_string ("todoist-user-avatar", "todoist-user-avatar", "todoist-user-avatar", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 22 "../src/Objects/Backup.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), OBJECTS_BACKUP_TODOIST_USER_IS_PREMIUM_PROPERTY, objects_backup_properties[OBJECTS_BACKUP_TODOIST_USER_IS_PREMIUM_PROPERTY] = g_param_spec_boolean ("todoist-user-is-premium", "todoist-user-is-premium", "todoist-user-is-premium", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 22 "../src/Objects/Backup.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), OBJECTS_BACKUP_PROJECTS_PROPERTY, objects_backup_properties[OBJECTS_BACKUP_PROJECTS_PROPERTY] = g_param_spec_object ("projects", "projects", "projects", GEE_TYPE_ARRAY_LIST, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 22 "../src/Objects/Backup.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), OBJECTS_BACKUP_SECTIONS_PROPERTY, objects_backup_properties[OBJECTS_BACKUP_SECTIONS_PROPERTY] = g_param_spec_object ("sections", "sections", "sections", GEE_TYPE_ARRAY_LIST, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 22 "../src/Objects/Backup.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), OBJECTS_BACKUP_ITEMS_PROPERTY, objects_backup_properties[OBJECTS_BACKUP_ITEMS_PROPERTY] = g_param_spec_object ("items", "items", "items", GEE_TYPE_ARRAY_LIST, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 22 "../src/Objects/Backup.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), OBJECTS_BACKUP_LABELS_PROPERTY, objects_backup_properties[OBJECTS_BACKUP_LABELS_PROPERTY] = g_param_spec_object ("labels", "labels", "labels", GEE_TYPE_ARRAY_LIST, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 22 "../src/Objects/Backup.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), OBJECTS_BACKUP_SOURCES_PROPERTY, objects_backup_properties[OBJECTS_BACKUP_SOURCES_PROPERTY] = g_param_spec_object ("sources", "sources", "sources", GEE_TYPE_ARRAY_LIST, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 22 "../src/Objects/Backup.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), OBJECTS_BACKUP_PATH_PROPERTY, objects_backup_properties[OBJECTS_BACKUP_PATH_PROPERTY] = g_param_spec_string ("path", "path", "path", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 22 "../src/Objects/Backup.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), OBJECTS_BACKUP_ERROR_PROPERTY, objects_backup_properties[OBJECTS_BACKUP_ERROR_PROPERTY] = g_param_spec_string ("error", "error", "error", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 22 "../src/Objects/Backup.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), OBJECTS_BACKUP_DATETIME_PROPERTY, objects_backup_properties[OBJECTS_BACKUP_DATETIME_PROPERTY] = g_param_spec_boxed ("datetime", "datetime", "datetime", G_TYPE_DATE_TIME, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 22 "../src/Objects/Backup.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), OBJECTS_BACKUP_TITLE_PROPERTY, objects_backup_properties[OBJECTS_BACKUP_TITLE_PROPERTY] = g_param_spec_string ("title", "title", "title", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 22 "../src/Objects/Backup.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), OBJECTS_BACKUP_TODOIST_BACKEND_PROPERTY, objects_backup_properties[OBJECTS_BACKUP_TODOIST_BACKEND_PROPERTY] = g_param_spec_boolean ("todoist-backend", "todoist-backend", "todoist-backend", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 22 "../src/Objects/Backup.vala"
	objects_backup_signals[OBJECTS_BACKUP_DELETED_SIGNAL] = g_signal_new ("deleted", OBJECTS_TYPE_BACKUP, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 1981 "Backup.c"
}

static void
objects_backup_instance_init (ObjectsBackup * self,
                              gpointer klass)
{
	gchar* _tmp0_;
	GDateTime* _tmp1_;
	GDateTime* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	GeeArrayList* _tmp11_;
	GeeArrayList* _tmp12_;
	GeeArrayList* _tmp13_;
	GeeArrayList* _tmp14_;
	GeeArrayList* _tmp15_;
	gchar* _tmp16_;
#line 22 "../src/Objects/Backup.vala"
	self->priv = objects_backup_get_instance_private (self);
#line 23 "../src/Objects/Backup.vala"
	_tmp0_ = g_strdup ("");
#line 23 "../src/Objects/Backup.vala"
	self->priv->_version = _tmp0_;
#line 24 "../src/Objects/Backup.vala"
	_tmp1_ = g_date_time_new_now_local ();
#line 24 "../src/Objects/Backup.vala"
	_tmp2_ = _tmp1_;
#line 24 "../src/Objects/Backup.vala"
	_tmp3_ = g_date_time_to_string (_tmp2_);
#line 24 "../src/Objects/Backup.vala"
	self->priv->_date = _tmp3_;
#line 24 "../src/Objects/Backup.vala"
	_g_date_time_unref0 (_tmp2_);
#line 26 "../src/Objects/Backup.vala"
	self->priv->_default_inbox = 0;
#line 27 "../src/Objects/Backup.vala"
	_tmp4_ = g_strdup ("");
#line 27 "../src/Objects/Backup.vala"
	self->priv->_local_inbox_project_id = _tmp4_;
#line 28 "../src/Objects/Backup.vala"
	_tmp5_ = g_strdup ("");
#line 28 "../src/Objects/Backup.vala"
	self->priv->_todoist_access_token = _tmp5_;
#line 29 "../src/Objects/Backup.vala"
	_tmp6_ = g_strdup ("");
#line 29 "../src/Objects/Backup.vala"
	self->priv->_todoist_sync_token = _tmp6_;
#line 30 "../src/Objects/Backup.vala"
	_tmp7_ = g_strdup ("");
#line 30 "../src/Objects/Backup.vala"
	self->priv->_todoist_user_name = _tmp7_;
#line 31 "../src/Objects/Backup.vala"
	_tmp8_ = g_strdup ("");
#line 31 "../src/Objects/Backup.vala"
	self->priv->_todoist_user_email = _tmp8_;
#line 32 "../src/Objects/Backup.vala"
	_tmp9_ = g_strdup ("");
#line 32 "../src/Objects/Backup.vala"
	self->priv->_todoist_user_image_id = _tmp9_;
#line 33 "../src/Objects/Backup.vala"
	_tmp10_ = g_strdup ("");
#line 33 "../src/Objects/Backup.vala"
	self->priv->_todoist_user_avatar = _tmp10_;
#line 34 "../src/Objects/Backup.vala"
	self->priv->_todoist_user_is_premium = FALSE;
#line 36 "../src/Objects/Backup.vala"
	_tmp11_ = gee_array_list_new (OBJECTS_TYPE_PROJECT, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 36 "../src/Objects/Backup.vala"
	self->priv->_projects = _tmp11_;
#line 37 "../src/Objects/Backup.vala"
	_tmp12_ = gee_array_list_new (OBJECTS_TYPE_SECTION, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 37 "../src/Objects/Backup.vala"
	self->priv->_sections = _tmp12_;
#line 38 "../src/Objects/Backup.vala"
	_tmp13_ = gee_array_list_new (OBJECTS_TYPE_ITEM, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 38 "../src/Objects/Backup.vala"
	self->priv->_items = _tmp13_;
#line 39 "../src/Objects/Backup.vala"
	_tmp14_ = gee_array_list_new (OBJECTS_TYPE_LABEL, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 39 "../src/Objects/Backup.vala"
	self->priv->_labels = _tmp14_;
#line 40 "../src/Objects/Backup.vala"
	_tmp15_ = gee_array_list_new (OBJECTS_TYPE_SOURCE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 40 "../src/Objects/Backup.vala"
	self->priv->_sources = _tmp15_;
#line 43 "../src/Objects/Backup.vala"
	_tmp16_ = g_strdup ("");
#line 43 "../src/Objects/Backup.vala"
	self->priv->_error = _tmp16_;
#line 2077 "Backup.c"
}

static void
objects_backup_finalize (GObject * obj)
{
	ObjectsBackup * self;
#line 22 "../src/Objects/Backup.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, OBJECTS_TYPE_BACKUP, ObjectsBackup);
#line 23 "../src/Objects/Backup.vala"
	_g_free0 (self->priv->_version);
#line 24 "../src/Objects/Backup.vala"
	_g_free0 (self->priv->_date);
#line 27 "../src/Objects/Backup.vala"
	_g_free0 (self->priv->_local_inbox_project_id);
#line 28 "../src/Objects/Backup.vala"
	_g_free0 (self->priv->_todoist_access_token);
#line 29 "../src/Objects/Backup.vala"
	_g_free0 (self->priv->_todoist_sync_token);
#line 30 "../src/Objects/Backup.vala"
	_g_free0 (self->priv->_todoist_user_name);
#line 31 "../src/Objects/Backup.vala"
	_g_free0 (self->priv->_todoist_user_email);
#line 32 "../src/Objects/Backup.vala"
	_g_free0 (self->priv->_todoist_user_image_id);
#line 33 "../src/Objects/Backup.vala"
	_g_free0 (self->priv->_todoist_user_avatar);
#line 36 "../src/Objects/Backup.vala"
	_g_object_unref0 (self->priv->_projects);
#line 37 "../src/Objects/Backup.vala"
	_g_object_unref0 (self->priv->_sections);
#line 38 "../src/Objects/Backup.vala"
	_g_object_unref0 (self->priv->_items);
#line 39 "../src/Objects/Backup.vala"
	_g_object_unref0 (self->priv->_labels);
#line 40 "../src/Objects/Backup.vala"
	_g_object_unref0 (self->priv->_sources);
#line 42 "../src/Objects/Backup.vala"
	_g_free0 (self->priv->_path);
#line 43 "../src/Objects/Backup.vala"
	_g_free0 (self->priv->_error);
#line 45 "../src/Objects/Backup.vala"
	_g_date_time_unref0 (self->priv->_datetime);
#line 53 "../src/Objects/Backup.vala"
	_g_free0 (self->priv->_title);
#line 22 "../src/Objects/Backup.vala"
	G_OBJECT_CLASS (objects_backup_parent_class)->finalize (obj);
#line 2124 "Backup.c"
}

static GType
objects_backup_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ObjectsBackupClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) objects_backup_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ObjectsBackup), 0, (GInstanceInitFunc) objects_backup_instance_init, NULL };
	GType objects_backup_type_id;
	objects_backup_type_id = g_type_register_static (G_TYPE_OBJECT, "ObjectsBackup", &g_define_type_info, 0);
	ObjectsBackup_private_offset = g_type_add_instance_private (objects_backup_type_id, sizeof (ObjectsBackupPrivate));
	return objects_backup_type_id;
}

GType
objects_backup_get_type (void)
{
	static volatile gsize objects_backup_type_id__once = 0;
	if (g_once_init_enter (&objects_backup_type_id__once)) {
		GType objects_backup_type_id;
		objects_backup_type_id = objects_backup_get_type_once ();
		g_once_init_leave (&objects_backup_type_id__once, objects_backup_type_id);
	}
	return objects_backup_type_id__once;
}

static void
_vala_objects_backup_get_property (GObject * object,
                                   guint property_id,
                                   GValue * value,
                                   GParamSpec * pspec)
{
	ObjectsBackup * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, OBJECTS_TYPE_BACKUP, ObjectsBackup);
#line 22 "../src/Objects/Backup.vala"
	switch (property_id) {
#line 22 "../src/Objects/Backup.vala"
		case OBJECTS_BACKUP_VERSION_PROPERTY:
#line 22 "../src/Objects/Backup.vala"
		g_value_set_string (value, objects_backup_get_version (self));
#line 22 "../src/Objects/Backup.vala"
		break;
#line 22 "../src/Objects/Backup.vala"
		case OBJECTS_BACKUP_DATE_PROPERTY:
#line 22 "../src/Objects/Backup.vala"
		g_value_set_string (value, objects_backup_get_date (self));
#line 22 "../src/Objects/Backup.vala"
		break;
#line 22 "../src/Objects/Backup.vala"
		case OBJECTS_BACKUP_DEFAULT_INBOX_PROPERTY:
#line 22 "../src/Objects/Backup.vala"
		g_value_set_int (value, objects_backup_get_default_inbox (self));
#line 22 "../src/Objects/Backup.vala"
		break;
#line 22 "../src/Objects/Backup.vala"
		case OBJECTS_BACKUP_LOCAL_INBOX_PROJECT_ID_PROPERTY:
#line 22 "../src/Objects/Backup.vala"
		g_value_set_string (value, objects_backup_get_local_inbox_project_id (self));
#line 22 "../src/Objects/Backup.vala"
		break;
#line 22 "../src/Objects/Backup.vala"
		case OBJECTS_BACKUP_TODOIST_ACCESS_TOKEN_PROPERTY:
#line 22 "../src/Objects/Backup.vala"
		g_value_set_string (value, objects_backup_get_todoist_access_token (self));
#line 22 "../src/Objects/Backup.vala"
		break;
#line 22 "../src/Objects/Backup.vala"
		case OBJECTS_BACKUP_TODOIST_SYNC_TOKEN_PROPERTY:
#line 22 "../src/Objects/Backup.vala"
		g_value_set_string (value, objects_backup_get_todoist_sync_token (self));
#line 22 "../src/Objects/Backup.vala"
		break;
#line 22 "../src/Objects/Backup.vala"
		case OBJECTS_BACKUP_TODOIST_USER_NAME_PROPERTY:
#line 22 "../src/Objects/Backup.vala"
		g_value_set_string (value, objects_backup_get_todoist_user_name (self));
#line 22 "../src/Objects/Backup.vala"
		break;
#line 22 "../src/Objects/Backup.vala"
		case OBJECTS_BACKUP_TODOIST_USER_EMAIL_PROPERTY:
#line 22 "../src/Objects/Backup.vala"
		g_value_set_string (value, objects_backup_get_todoist_user_email (self));
#line 22 "../src/Objects/Backup.vala"
		break;
#line 22 "../src/Objects/Backup.vala"
		case OBJECTS_BACKUP_TODOIST_USER_IMAGE_ID_PROPERTY:
#line 22 "../src/Objects/Backup.vala"
		g_value_set_string (value, objects_backup_get_todoist_user_image_id (self));
#line 22 "../src/Objects/Backup.vala"
		break;
#line 22 "../src/Objects/Backup.vala"
		case OBJECTS_BACKUP_TODOIST_USER_AVATAR_PROPERTY:
#line 22 "../src/Objects/Backup.vala"
		g_value_set_string (value, objects_backup_get_todoist_user_avatar (self));
#line 22 "../src/Objects/Backup.vala"
		break;
#line 22 "../src/Objects/Backup.vala"
		case OBJECTS_BACKUP_TODOIST_USER_IS_PREMIUM_PROPERTY:
#line 22 "../src/Objects/Backup.vala"
		g_value_set_boolean (value, objects_backup_get_todoist_user_is_premium (self));
#line 22 "../src/Objects/Backup.vala"
		break;
#line 22 "../src/Objects/Backup.vala"
		case OBJECTS_BACKUP_PROJECTS_PROPERTY:
#line 22 "../src/Objects/Backup.vala"
		g_value_set_object (value, objects_backup_get_projects (self));
#line 22 "../src/Objects/Backup.vala"
		break;
#line 22 "../src/Objects/Backup.vala"
		case OBJECTS_BACKUP_SECTIONS_PROPERTY:
#line 22 "../src/Objects/Backup.vala"
		g_value_set_object (value, objects_backup_get_sections (self));
#line 22 "../src/Objects/Backup.vala"
		break;
#line 22 "../src/Objects/Backup.vala"
		case OBJECTS_BACKUP_ITEMS_PROPERTY:
#line 22 "../src/Objects/Backup.vala"
		g_value_set_object (value, objects_backup_get_items (self));
#line 22 "../src/Objects/Backup.vala"
		break;
#line 22 "../src/Objects/Backup.vala"
		case OBJECTS_BACKUP_LABELS_PROPERTY:
#line 22 "../src/Objects/Backup.vala"
		g_value_set_object (value, objects_backup_get_labels (self));
#line 22 "../src/Objects/Backup.vala"
		break;
#line 22 "../src/Objects/Backup.vala"
		case OBJECTS_BACKUP_SOURCES_PROPERTY:
#line 22 "../src/Objects/Backup.vala"
		g_value_set_object (value, objects_backup_get_sources (self));
#line 22 "../src/Objects/Backup.vala"
		break;
#line 22 "../src/Objects/Backup.vala"
		case OBJECTS_BACKUP_PATH_PROPERTY:
#line 22 "../src/Objects/Backup.vala"
		g_value_set_string (value, objects_backup_get_path (self));
#line 22 "../src/Objects/Backup.vala"
		break;
#line 22 "../src/Objects/Backup.vala"
		case OBJECTS_BACKUP_ERROR_PROPERTY:
#line 22 "../src/Objects/Backup.vala"
		g_value_set_string (value, objects_backup_get_error (self));
#line 22 "../src/Objects/Backup.vala"
		break;
#line 22 "../src/Objects/Backup.vala"
		case OBJECTS_BACKUP_DATETIME_PROPERTY:
#line 22 "../src/Objects/Backup.vala"
		g_value_set_boxed (value, objects_backup_get_datetime (self));
#line 22 "../src/Objects/Backup.vala"
		break;
#line 22 "../src/Objects/Backup.vala"
		case OBJECTS_BACKUP_TITLE_PROPERTY:
#line 22 "../src/Objects/Backup.vala"
		g_value_set_string (value, objects_backup_get_title (self));
#line 22 "../src/Objects/Backup.vala"
		break;
#line 22 "../src/Objects/Backup.vala"
		case OBJECTS_BACKUP_TODOIST_BACKEND_PROPERTY:
#line 22 "../src/Objects/Backup.vala"
		g_value_set_boolean (value, objects_backup_get_todoist_backend (self));
#line 22 "../src/Objects/Backup.vala"
		break;
#line 2285 "Backup.c"
		default:
#line 22 "../src/Objects/Backup.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 22 "../src/Objects/Backup.vala"
		break;
#line 2291 "Backup.c"
	}
}

static void
_vala_objects_backup_set_property (GObject * object,
                                   guint property_id,
                                   const GValue * value,
                                   GParamSpec * pspec)
{
	ObjectsBackup * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, OBJECTS_TYPE_BACKUP, ObjectsBackup);
#line 22 "../src/Objects/Backup.vala"
	switch (property_id) {
#line 22 "../src/Objects/Backup.vala"
		case OBJECTS_BACKUP_VERSION_PROPERTY:
#line 22 "../src/Objects/Backup.vala"
		objects_backup_set_version (self, g_value_get_string (value));
#line 22 "../src/Objects/Backup.vala"
		break;
#line 22 "../src/Objects/Backup.vala"
		case OBJECTS_BACKUP_DATE_PROPERTY:
#line 22 "../src/Objects/Backup.vala"
		objects_backup_set_date (self, g_value_get_string (value));
#line 22 "../src/Objects/Backup.vala"
		break;
#line 22 "../src/Objects/Backup.vala"
		case OBJECTS_BACKUP_DEFAULT_INBOX_PROPERTY:
#line 22 "../src/Objects/Backup.vala"
		objects_backup_set_default_inbox (self, g_value_get_int (value));
#line 22 "../src/Objects/Backup.vala"
		break;
#line 22 "../src/Objects/Backup.vala"
		case OBJECTS_BACKUP_LOCAL_INBOX_PROJECT_ID_PROPERTY:
#line 22 "../src/Objects/Backup.vala"
		objects_backup_set_local_inbox_project_id (self, g_value_get_string (value));
#line 22 "../src/Objects/Backup.vala"
		break;
#line 22 "../src/Objects/Backup.vala"
		case OBJECTS_BACKUP_TODOIST_ACCESS_TOKEN_PROPERTY:
#line 22 "../src/Objects/Backup.vala"
		objects_backup_set_todoist_access_token (self, g_value_get_string (value));
#line 22 "../src/Objects/Backup.vala"
		break;
#line 22 "../src/Objects/Backup.vala"
		case OBJECTS_BACKUP_TODOIST_SYNC_TOKEN_PROPERTY:
#line 22 "../src/Objects/Backup.vala"
		objects_backup_set_todoist_sync_token (self, g_value_get_string (value));
#line 22 "../src/Objects/Backup.vala"
		break;
#line 22 "../src/Objects/Backup.vala"
		case OBJECTS_BACKUP_TODOIST_USER_NAME_PROPERTY:
#line 22 "../src/Objects/Backup.vala"
		objects_backup_set_todoist_user_name (self, g_value_get_string (value));
#line 22 "../src/Objects/Backup.vala"
		break;
#line 22 "../src/Objects/Backup.vala"
		case OBJECTS_BACKUP_TODOIST_USER_EMAIL_PROPERTY:
#line 22 "../src/Objects/Backup.vala"
		objects_backup_set_todoist_user_email (self, g_value_get_string (value));
#line 22 "../src/Objects/Backup.vala"
		break;
#line 22 "../src/Objects/Backup.vala"
		case OBJECTS_BACKUP_TODOIST_USER_IMAGE_ID_PROPERTY:
#line 22 "../src/Objects/Backup.vala"
		objects_backup_set_todoist_user_image_id (self, g_value_get_string (value));
#line 22 "../src/Objects/Backup.vala"
		break;
#line 22 "../src/Objects/Backup.vala"
		case OBJECTS_BACKUP_TODOIST_USER_AVATAR_PROPERTY:
#line 22 "../src/Objects/Backup.vala"
		objects_backup_set_todoist_user_avatar (self, g_value_get_string (value));
#line 22 "../src/Objects/Backup.vala"
		break;
#line 22 "../src/Objects/Backup.vala"
		case OBJECTS_BACKUP_TODOIST_USER_IS_PREMIUM_PROPERTY:
#line 22 "../src/Objects/Backup.vala"
		objects_backup_set_todoist_user_is_premium (self, g_value_get_boolean (value));
#line 22 "../src/Objects/Backup.vala"
		break;
#line 22 "../src/Objects/Backup.vala"
		case OBJECTS_BACKUP_PROJECTS_PROPERTY:
#line 22 "../src/Objects/Backup.vala"
		objects_backup_set_projects (self, g_value_get_object (value));
#line 22 "../src/Objects/Backup.vala"
		break;
#line 22 "../src/Objects/Backup.vala"
		case OBJECTS_BACKUP_SECTIONS_PROPERTY:
#line 22 "../src/Objects/Backup.vala"
		objects_backup_set_sections (self, g_value_get_object (value));
#line 22 "../src/Objects/Backup.vala"
		break;
#line 22 "../src/Objects/Backup.vala"
		case OBJECTS_BACKUP_ITEMS_PROPERTY:
#line 22 "../src/Objects/Backup.vala"
		objects_backup_set_items (self, g_value_get_object (value));
#line 22 "../src/Objects/Backup.vala"
		break;
#line 22 "../src/Objects/Backup.vala"
		case OBJECTS_BACKUP_LABELS_PROPERTY:
#line 22 "../src/Objects/Backup.vala"
		objects_backup_set_labels (self, g_value_get_object (value));
#line 22 "../src/Objects/Backup.vala"
		break;
#line 22 "../src/Objects/Backup.vala"
		case OBJECTS_BACKUP_SOURCES_PROPERTY:
#line 22 "../src/Objects/Backup.vala"
		objects_backup_set_sources (self, g_value_get_object (value));
#line 22 "../src/Objects/Backup.vala"
		break;
#line 22 "../src/Objects/Backup.vala"
		case OBJECTS_BACKUP_PATH_PROPERTY:
#line 22 "../src/Objects/Backup.vala"
		objects_backup_set_path (self, g_value_get_string (value));
#line 22 "../src/Objects/Backup.vala"
		break;
#line 22 "../src/Objects/Backup.vala"
		case OBJECTS_BACKUP_ERROR_PROPERTY:
#line 22 "../src/Objects/Backup.vala"
		objects_backup_set_error (self, g_value_get_string (value));
#line 22 "../src/Objects/Backup.vala"
		break;
#line 2413 "Backup.c"
		default:
#line 22 "../src/Objects/Backup.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 22 "../src/Objects/Backup.vala"
		break;
#line 2419 "Backup.c"
	}
}

