/* ActionManager.c generated by valac 0.56.18, the Vala compiler
 * generated from ActionManager.vala, do not modify */

/*
* Copyright © 2023 Alain M. (https://github.com/alainm23/planify)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 3 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*
* Authored by: Alain M. <alainmh23@gmail.com>
*/

#include <glib-object.h>
#include <adwaita.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gee.h>
#include <gtk/gtk.h>
#include "planify.h"
#include <gdk/gdk.h>

#define SERVICES_ACTION_MANAGER_ACTION_PREFIX "win."
#define SERVICES_ACTION_MANAGER_ACTION_QUIT_Q "action_quit_q"
#define SERVICES_ACTION_MANAGER_ACTION_QUIT_W "action_quit_w"
#define SERVICES_ACTION_MANAGER_ACTION_PREFERENCES "action_preferences"
#define SERVICES_ACTION_MANAGER_ACTION_SHORTCUTS "action_shortcuts"
#define SERVICES_ACTION_MANAGER_ACTION_ADD_TASK "action_add_task"
#define SERVICES_ACTION_MANAGER_ACTION_ADD_TASK_PASTE "action_add_task_paste"
#define SERVICES_ACTION_MANAGER_ACTION_OPEN_SEARCH "action_open_search"
#define SERVICES_ACTION_MANAGER_ACTION_SYNC_MANUALLY "action_sync_manually"
#define SERVICES_ACTION_MANAGER_ACTION_NEW_PROJECT "action_new_project"
#define SERVICES_ACTION_MANAGER_ACTION_NEW_SECTION "action_new_section"
#define SERVICES_ACTION_MANAGER_ACTION_VIEW_HOMEPAGE "action_view_homepage"
#define SERVICES_ACTION_MANAGER_ACTION_VIEW_INBOX "action_view_inbox"
#define SERVICES_ACTION_MANAGER_ACTION_VIEW_TODAY "action_view_today"
#define SERVICES_ACTION_MANAGER_ACTION_VIEW_SCHEDULED "action_view_scheduled"
#define SERVICES_ACTION_MANAGER_ACTION_VIEW_PINBOARD "action_view_pinboard"
#define SERVICES_ACTION_MANAGER_ACTION_VIEW_LABELS "action_view_labels"
#define SERVICES_ACTION_MANAGER_ACTION_VIEW_HOME "action_view_home"
#define SERVICES_ACTION_MANAGER_ACTION_SHOW_HIDE_SIDEBAR "action_show_hide_sidebar"
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define SERVICES_TYPE_ACTION_MANAGER (services_action_manager_get_type ())
#define SERVICES_ACTION_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), SERVICES_TYPE_ACTION_MANAGER, ServicesActionManager))
#define SERVICES_ACTION_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), SERVICES_TYPE_ACTION_MANAGER, ServicesActionManagerClass))
#define SERVICES_IS_ACTION_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), SERVICES_TYPE_ACTION_MANAGER))
#define SERVICES_IS_ACTION_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), SERVICES_TYPE_ACTION_MANAGER))
#define SERVICES_ACTION_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), SERVICES_TYPE_ACTION_MANAGER, ServicesActionManagerClass))

typedef struct _ServicesActionManager ServicesActionManager;
typedef struct _ServicesActionManagerClass ServicesActionManagerClass;
typedef struct _ServicesActionManagerPrivate ServicesActionManagerPrivate;

#define TYPE_PLANIFY (planify_get_type ())
#define PLANIFY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PLANIFY, Planify))
#define PLANIFY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PLANIFY, PlanifyClass))
#define IS_PLANIFY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PLANIFY))
#define IS_PLANIFY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PLANIFY))
#define PLANIFY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PLANIFY, PlanifyClass))

typedef struct _Planify Planify;
typedef struct _PlanifyClass PlanifyClass;

#define TYPE_MAIN_WINDOW (main_window_get_type ())
#define MAIN_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MAIN_WINDOW, MainWindow))
#define MAIN_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MAIN_WINDOW, MainWindowClass))
#define IS_MAIN_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MAIN_WINDOW))
#define IS_MAIN_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MAIN_WINDOW))
#define MAIN_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MAIN_WINDOW, MainWindowClass))

typedef struct _MainWindow MainWindow;
typedef struct _MainWindowClass MainWindowClass;
enum  {
	SERVICES_ACTION_MANAGER_0_PROPERTY,
	SERVICES_ACTION_MANAGER_APP_PROPERTY,
	SERVICES_ACTION_MANAGER_WINDOW_PROPERTY,
	SERVICES_ACTION_MANAGER_ACTIONS_PROPERTY,
	SERVICES_ACTION_MANAGER_NUM_PROPERTIES
};
static GParamSpec* services_action_manager_properties[SERVICES_ACTION_MANAGER_NUM_PROPERTIES];
typedef void (*GSimpleActionActivateCallback) (GSimpleAction* action, GVariant* parameter, gpointer user_data);
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

#define DIALOGS_PREFERENCES_TYPE_PREFERENCES_WINDOW (dialogs_preferences_preferences_window_get_type ())
#define DIALOGS_PREFERENCES_PREFERENCES_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DIALOGS_PREFERENCES_TYPE_PREFERENCES_WINDOW, DialogsPreferencesPreferencesWindow))
#define DIALOGS_PREFERENCES_PREFERENCES_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DIALOGS_PREFERENCES_TYPE_PREFERENCES_WINDOW, DialogsPreferencesPreferencesWindowClass))
#define DIALOGS_PREFERENCES_IS_PREFERENCES_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DIALOGS_PREFERENCES_TYPE_PREFERENCES_WINDOW))
#define DIALOGS_PREFERENCES_IS_PREFERENCES_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DIALOGS_PREFERENCES_TYPE_PREFERENCES_WINDOW))
#define DIALOGS_PREFERENCES_PREFERENCES_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DIALOGS_PREFERENCES_TYPE_PREFERENCES_WINDOW, DialogsPreferencesPreferencesWindowClass))

typedef struct _DialogsPreferencesPreferencesWindow DialogsPreferencesPreferencesWindow;
typedef struct _DialogsPreferencesPreferencesWindowClass DialogsPreferencesPreferencesWindowClass;
typedef struct _PlanifyPrivate PlanifyPrivate;

#define DIALOGS_QUICK_FIND_TYPE_QUICK_FIND (dialogs_quick_find_quick_find_get_type ())
#define DIALOGS_QUICK_FIND_QUICK_FIND(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DIALOGS_QUICK_FIND_TYPE_QUICK_FIND, DialogsQuickFindQuickFind))
#define DIALOGS_QUICK_FIND_QUICK_FIND_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DIALOGS_QUICK_FIND_TYPE_QUICK_FIND, DialogsQuickFindQuickFindClass))
#define DIALOGS_QUICK_FIND_IS_QUICK_FIND(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DIALOGS_QUICK_FIND_TYPE_QUICK_FIND))
#define DIALOGS_QUICK_FIND_IS_QUICK_FIND_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DIALOGS_QUICK_FIND_TYPE_QUICK_FIND))
#define DIALOGS_QUICK_FIND_QUICK_FIND_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DIALOGS_QUICK_FIND_TYPE_QUICK_FIND, DialogsQuickFindQuickFindClass))

typedef struct _DialogsQuickFindQuickFind DialogsQuickFindQuickFind;
typedef struct _DialogsQuickFindQuickFindClass DialogsQuickFindQuickFindClass;

#define DIALOGS_TYPE_PROJECT (dialogs_project_get_type ())
#define DIALOGS_PROJECT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DIALOGS_TYPE_PROJECT, DialogsProject))
#define DIALOGS_PROJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DIALOGS_TYPE_PROJECT, DialogsProjectClass))
#define DIALOGS_IS_PROJECT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DIALOGS_TYPE_PROJECT))
#define DIALOGS_IS_PROJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DIALOGS_TYPE_PROJECT))
#define DIALOGS_PROJECT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DIALOGS_TYPE_PROJECT, DialogsProjectClass))

typedef struct _DialogsProject DialogsProject;
typedef struct _DialogsProjectClass DialogsProjectClass;
typedef struct _Block4Data Block4Data;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

struct _ServicesActionManager {
	GObject parent_instance;
	ServicesActionManagerPrivate * priv;
};

struct _ServicesActionManagerClass {
	GObjectClass parent_class;
};

struct _ServicesActionManagerPrivate {
	Planify* _app;
	MainWindow* _window;
	GSimpleActionGroup* _actions;
};

struct _Planify {
	AdwApplication parent_instance;
	PlanifyPrivate * priv;
	MainWindow* main_window;
};

struct _PlanifyClass {
	AdwApplicationClass parent_class;
};

struct _Block4Data {
	int _ref_count_;
	ServicesActionManager* self;
	GdkClipboard* clipboard;
};

static gint ServicesActionManager_private_offset;
static gpointer services_action_manager_parent_class = NULL;
VALA_EXTERN GeeMultiMap* services_action_manager_action_accelerators;
GeeMultiMap* services_action_manager_action_accelerators = NULL;
VALA_EXTERN GeeMultiMap* services_action_manager_typing_accelerators;
GeeMultiMap* services_action_manager_typing_accelerators = NULL;
VALA_EXTERN Planify* planify__instance;

VALA_EXTERN GType services_action_manager_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ServicesActionManager, g_object_unref)
VALA_EXTERN GType planify_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Planify, g_object_unref)
VALA_EXTERN GType main_window_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MainWindow, g_object_unref)
static void services_action_manager_action_quit (ServicesActionManager* self);
static void _services_action_manager_action_quit_gsimple_action_activate_callback (GSimpleAction* action,
                                                                            GVariant* parameter,
                                                                            gpointer self);
static void services_action_manager_action_preferences (ServicesActionManager* self);
static void _services_action_manager_action_preferences_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                   GVariant* parameter,
                                                                                   gpointer self);
static void services_action_manager_action_shortcuts (ServicesActionManager* self);
static void _services_action_manager_action_shortcuts_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                 GVariant* parameter,
                                                                                 gpointer self);
static void services_action_manager_action_add_task (ServicesActionManager* self);
static void _services_action_manager_action_add_task_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                GVariant* parameter,
                                                                                gpointer self);
static void services_action_manager_action_add_task_paste (ServicesActionManager* self);
static void _services_action_manager_action_add_task_paste_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                      GVariant* parameter,
                                                                                      gpointer self);
static void services_action_manager_action_open_search (ServicesActionManager* self);
static void _services_action_manager_action_open_search_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                   GVariant* parameter,
                                                                                   gpointer self);
static void services_action_manager_action_sync_manually (ServicesActionManager* self);
static void _services_action_manager_action_sync_manually_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                     GVariant* parameter,
                                                                                     gpointer self);
static void services_action_manager_action_new_project (ServicesActionManager* self);
static void _services_action_manager_action_new_project_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                   GVariant* parameter,
                                                                                   gpointer self);
static void services_action_manager_action_new_section (ServicesActionManager* self);
static void _services_action_manager_action_new_section_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                   GVariant* parameter,
                                                                                   gpointer self);
static void services_action_manager_action_view_homepage (ServicesActionManager* self);
static void _services_action_manager_action_view_homepage_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                     GVariant* parameter,
                                                                                     gpointer self);
static void services_action_manager_action_view_inbox (ServicesActionManager* self);
static void _services_action_manager_action_view_inbox_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                  GVariant* parameter,
                                                                                  gpointer self);
static void services_action_manager_action_view_today (ServicesActionManager* self);
static void _services_action_manager_action_view_today_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                  GVariant* parameter,
                                                                                  gpointer self);
static void services_action_manager_action_view_scheduled (ServicesActionManager* self);
static void _services_action_manager_action_view_scheduled_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                      GVariant* parameter,
                                                                                      gpointer self);
static void services_action_manager_action_view_pinboard (ServicesActionManager* self);
static void _services_action_manager_action_view_pinboard_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                     GVariant* parameter,
                                                                                     gpointer self);
static void services_action_manager_action_view_labels (ServicesActionManager* self);
static void _services_action_manager_action_view_labels_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                   GVariant* parameter,
                                                                                   gpointer self);
static void services_action_manager_action_view_home (ServicesActionManager* self);
static void _services_action_manager_action_view_home_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                 GVariant* parameter,
                                                                                 gpointer self);
static void services_action_manager_action_show_hide_sidebar (ServicesActionManager* self);
static void _services_action_manager_action_show_hide_sidebar_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                         GVariant* parameter,
                                                                                         gpointer self);
VALA_EXTERN ServicesActionManager* services_action_manager_new (Planify* app,
                                                    MainWindow* window);
VALA_EXTERN ServicesActionManager* services_action_manager_construct (GType object_type,
                                                          Planify* app,
                                                          MainWindow* window);
static void services_action_manager_disable_typing_accels (ServicesActionManager* self);
VALA_EXTERN Planify* services_action_manager_get_app (ServicesActionManager* self);
static void services_action_manager_disable_action_accels (ServicesActionManager* self);
static void services_action_manager_enable_typing_accels (ServicesActionManager* self);
static void _vala_array_add1 (gchar** * array,
                       gint* length,
                       gint* size,
                       gchar* value);
static void services_action_manager_enable_action_accels (ServicesActionManager* self);
static void _vala_array_add2 (gchar** * array,
                       gint* length,
                       gint* size,
                       gchar* value);
static void services_action_manager_disable_all_accel (ServicesActionManager* self);
static void services_action_manager_enable_all_accel (ServicesActionManager* self);
VALA_EXTERN MainWindow* services_action_manager_get_window (ServicesActionManager* self);
VALA_EXTERN GType dialogs_preferences_preferences_window_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DialogsPreferencesPreferencesWindow, g_object_unref)
VALA_EXTERN DialogsPreferencesPreferencesWindow* dialogs_preferences_preferences_window_new (void);
VALA_EXTERN DialogsPreferencesPreferencesWindow* dialogs_preferences_preferences_window_construct (GType object_type);
VALA_EXTERN GType dialogs_quick_find_quick_find_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DialogsQuickFindQuickFind, g_object_unref)
VALA_EXTERN DialogsQuickFindQuickFind* dialogs_quick_find_quick_find_new (void);
VALA_EXTERN DialogsQuickFindQuickFind* dialogs_quick_find_quick_find_construct (GType object_type);
VALA_EXTERN GType dialogs_project_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DialogsProject, g_object_unref)
VALA_EXTERN DialogsProject* dialogs_project_new_new (const gchar* source_id,
                                         gboolean backend_picker,
                                         const gchar* parent_id);
VALA_EXTERN DialogsProject* dialogs_project_construct_new (GType object_type,
                                               const gchar* source_id,
                                               gboolean backend_picker,
                                               const gchar* parent_id);
VALA_EXTERN void main_window_go_homepage (MainWindow* self);
VALA_EXTERN void main_window_show_hide_sidebar (MainWindow* self);
VALA_EXTERN void main_window_new_section_action (MainWindow* self);
VALA_EXTERN void main_window_add_task_action (MainWindow* self,
                                  const gchar* content);
static Block4Data* block4_data_ref (Block4Data* _data4_);
static void block4_data_unref (void * _userdata_);
static void __lambda710_ (Block4Data* _data4_,
                   GObject* obj,
                   GAsyncResult* res);
static void ___lambda710__gasync_ready_callback (GObject* source_object,
                                          GAsyncResult* res,
                                          gpointer self);
VALA_EXTERN void main_window_open_shortcuts_window (MainWindow* self);
static void services_action_manager_set_app (ServicesActionManager* self,
                                      Planify* value);
static void services_action_manager_set_window (ServicesActionManager* self,
                                         MainWindow* value);
VALA_EXTERN GSimpleActionGroup* services_action_manager_get_actions (ServicesActionManager* self);
static void services_action_manager_set_actions (ServicesActionManager* self,
                                          GSimpleActionGroup* value);
static GObject * services_action_manager_constructor (GType type,
                                               guint n_construct_properties,
                                               GObjectConstructParam * construct_properties);
static void _vala_array_add3 (gchar** * array,
                       gint* length,
                       gint* size,
                       gchar* value);
static void _services_action_manager_disable_typing_accels_services_event_bus_disconnect_typing_accel (ServicesEventBus* _sender,
                                                                                                gpointer self);
static void _services_action_manager_enable_typing_accels_services_event_bus_connect_typing_accel (ServicesEventBus* _sender,
                                                                                            gpointer self);
static void _services_action_manager_disable_all_accel_services_event_bus_disconnect_all_accels (ServicesEventBus* _sender,
                                                                                          gpointer self);
static void _services_action_manager_enable_all_accel_services_event_bus_connect_all_accels (ServicesEventBus* _sender,
                                                                                      gpointer self);
static void services_action_manager_finalize (GObject * obj);
static GType services_action_manager_get_type_once (void);
static void _vala_services_action_manager_get_property (GObject * object,
                                                 guint property_id,
                                                 GValue * value,
                                                 GParamSpec * pspec);
static void _vala_services_action_manager_set_property (GObject * object,
                                                 guint property_id,
                                                 const GValue * value,
                                                 GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

static const GActionEntry SERVICES_ACTION_MANAGER_ACTION_ENTRIES[18] = {{SERVICES_ACTION_MANAGER_ACTION_QUIT_Q, _services_action_manager_action_quit_gsimple_action_activate_callback}, {SERVICES_ACTION_MANAGER_ACTION_QUIT_W, _services_action_manager_action_quit_gsimple_action_activate_callback}, {SERVICES_ACTION_MANAGER_ACTION_PREFERENCES, _services_action_manager_action_preferences_gsimple_action_activate_callback}, {SERVICES_ACTION_MANAGER_ACTION_SHORTCUTS, _services_action_manager_action_shortcuts_gsimple_action_activate_callback}, {SERVICES_ACTION_MANAGER_ACTION_ADD_TASK, _services_action_manager_action_add_task_gsimple_action_activate_callback}, {SERVICES_ACTION_MANAGER_ACTION_ADD_TASK_PASTE, _services_action_manager_action_add_task_paste_gsimple_action_activate_callback}, {SERVICES_ACTION_MANAGER_ACTION_OPEN_SEARCH, _services_action_manager_action_open_search_gsimple_action_activate_callback}, {SERVICES_ACTION_MANAGER_ACTION_SYNC_MANUALLY, _services_action_manager_action_sync_manually_gsimple_action_activate_callback}, {SERVICES_ACTION_MANAGER_ACTION_NEW_PROJECT, _services_action_manager_action_new_project_gsimple_action_activate_callback}, {SERVICES_ACTION_MANAGER_ACTION_NEW_SECTION, _services_action_manager_action_new_section_gsimple_action_activate_callback}, {SERVICES_ACTION_MANAGER_ACTION_VIEW_HOMEPAGE, _services_action_manager_action_view_homepage_gsimple_action_activate_callback}, {SERVICES_ACTION_MANAGER_ACTION_VIEW_INBOX, _services_action_manager_action_view_inbox_gsimple_action_activate_callback}, {SERVICES_ACTION_MANAGER_ACTION_VIEW_TODAY, _services_action_manager_action_view_today_gsimple_action_activate_callback}, {SERVICES_ACTION_MANAGER_ACTION_VIEW_SCHEDULED, _services_action_manager_action_view_scheduled_gsimple_action_activate_callback}, {SERVICES_ACTION_MANAGER_ACTION_VIEW_PINBOARD, _services_action_manager_action_view_pinboard_gsimple_action_activate_callback}, {SERVICES_ACTION_MANAGER_ACTION_VIEW_LABELS, _services_action_manager_action_view_labels_gsimple_action_activate_callback}, {SERVICES_ACTION_MANAGER_ACTION_VIEW_HOME, _services_action_manager_action_view_home_gsimple_action_activate_callback}, {SERVICES_ACTION_MANAGER_ACTION_SHOW_HIDE_SIDEBAR, _services_action_manager_action_show_hide_sidebar_gsimple_action_activate_callback}};

static inline gpointer
services_action_manager_get_instance_private (ServicesActionManager* self)
{
	return G_STRUCT_MEMBER_P (self, ServicesActionManager_private_offset);
}

static void
_services_action_manager_action_quit_gsimple_action_activate_callback (GSimpleAction* action,
                                                                       GVariant* parameter,
                                                                       gpointer self)
{
#line 51 "../src/Services/ActionManager.vala"
	services_action_manager_action_quit ((ServicesActionManager*) self);
#line 368 "ActionManager.c"
}

static void
_services_action_manager_action_preferences_gsimple_action_activate_callback (GSimpleAction* action,
                                                                              GVariant* parameter,
                                                                              gpointer self)
{
#line 51 "../src/Services/ActionManager.vala"
	services_action_manager_action_preferences ((ServicesActionManager*) self);
#line 378 "ActionManager.c"
}

static void
_services_action_manager_action_shortcuts_gsimple_action_activate_callback (GSimpleAction* action,
                                                                            GVariant* parameter,
                                                                            gpointer self)
{
#line 51 "../src/Services/ActionManager.vala"
	services_action_manager_action_shortcuts ((ServicesActionManager*) self);
#line 388 "ActionManager.c"
}

static void
_services_action_manager_action_add_task_gsimple_action_activate_callback (GSimpleAction* action,
                                                                           GVariant* parameter,
                                                                           gpointer self)
{
#line 51 "../src/Services/ActionManager.vala"
	services_action_manager_action_add_task ((ServicesActionManager*) self);
#line 398 "ActionManager.c"
}

static void
_services_action_manager_action_add_task_paste_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                 GVariant* parameter,
                                                                                 gpointer self)
{
#line 51 "../src/Services/ActionManager.vala"
	services_action_manager_action_add_task_paste ((ServicesActionManager*) self);
#line 408 "ActionManager.c"
}

static void
_services_action_manager_action_open_search_gsimple_action_activate_callback (GSimpleAction* action,
                                                                              GVariant* parameter,
                                                                              gpointer self)
{
#line 51 "../src/Services/ActionManager.vala"
	services_action_manager_action_open_search ((ServicesActionManager*) self);
#line 418 "ActionManager.c"
}

static void
_services_action_manager_action_sync_manually_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                GVariant* parameter,
                                                                                gpointer self)
{
#line 51 "../src/Services/ActionManager.vala"
	services_action_manager_action_sync_manually ((ServicesActionManager*) self);
#line 428 "ActionManager.c"
}

static void
_services_action_manager_action_new_project_gsimple_action_activate_callback (GSimpleAction* action,
                                                                              GVariant* parameter,
                                                                              gpointer self)
{
#line 51 "../src/Services/ActionManager.vala"
	services_action_manager_action_new_project ((ServicesActionManager*) self);
#line 438 "ActionManager.c"
}

static void
_services_action_manager_action_new_section_gsimple_action_activate_callback (GSimpleAction* action,
                                                                              GVariant* parameter,
                                                                              gpointer self)
{
#line 51 "../src/Services/ActionManager.vala"
	services_action_manager_action_new_section ((ServicesActionManager*) self);
#line 448 "ActionManager.c"
}

static void
_services_action_manager_action_view_homepage_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                GVariant* parameter,
                                                                                gpointer self)
{
#line 51 "../src/Services/ActionManager.vala"
	services_action_manager_action_view_homepage ((ServicesActionManager*) self);
#line 458 "ActionManager.c"
}

static void
_services_action_manager_action_view_inbox_gsimple_action_activate_callback (GSimpleAction* action,
                                                                             GVariant* parameter,
                                                                             gpointer self)
{
#line 51 "../src/Services/ActionManager.vala"
	services_action_manager_action_view_inbox ((ServicesActionManager*) self);
#line 468 "ActionManager.c"
}

static void
_services_action_manager_action_view_today_gsimple_action_activate_callback (GSimpleAction* action,
                                                                             GVariant* parameter,
                                                                             gpointer self)
{
#line 51 "../src/Services/ActionManager.vala"
	services_action_manager_action_view_today ((ServicesActionManager*) self);
#line 478 "ActionManager.c"
}

static void
_services_action_manager_action_view_scheduled_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                 GVariant* parameter,
                                                                                 gpointer self)
{
#line 51 "../src/Services/ActionManager.vala"
	services_action_manager_action_view_scheduled ((ServicesActionManager*) self);
#line 488 "ActionManager.c"
}

static void
_services_action_manager_action_view_pinboard_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                GVariant* parameter,
                                                                                gpointer self)
{
#line 51 "../src/Services/ActionManager.vala"
	services_action_manager_action_view_pinboard ((ServicesActionManager*) self);
#line 498 "ActionManager.c"
}

static void
_services_action_manager_action_view_labels_gsimple_action_activate_callback (GSimpleAction* action,
                                                                              GVariant* parameter,
                                                                              gpointer self)
{
#line 51 "../src/Services/ActionManager.vala"
	services_action_manager_action_view_labels ((ServicesActionManager*) self);
#line 508 "ActionManager.c"
}

static void
_services_action_manager_action_view_home_gsimple_action_activate_callback (GSimpleAction* action,
                                                                            GVariant* parameter,
                                                                            gpointer self)
{
#line 51 "../src/Services/ActionManager.vala"
	services_action_manager_action_view_home ((ServicesActionManager*) self);
#line 518 "ActionManager.c"
}

static void
_services_action_manager_action_show_hide_sidebar_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                    GVariant* parameter,
                                                                                    gpointer self)
{
#line 51 "../src/Services/ActionManager.vala"
	services_action_manager_action_show_hide_sidebar ((ServicesActionManager*) self);
#line 528 "ActionManager.c"
}

ServicesActionManager*
services_action_manager_construct (GType object_type,
                                   Planify* app,
                                   MainWindow* window)
{
	ServicesActionManager * self = NULL;
#line 72 "../src/Services/ActionManager.vala"
	g_return_val_if_fail (app != NULL, NULL);
#line 72 "../src/Services/ActionManager.vala"
	g_return_val_if_fail (window != NULL, NULL);
#line 73 "../src/Services/ActionManager.vala"
	self = (ServicesActionManager*) g_object_new (object_type, "app", app, "window", window, NULL);
#line 72 "../src/Services/ActionManager.vala"
	return self;
#line 545 "ActionManager.c"
}

ServicesActionManager*
services_action_manager_new (Planify* app,
                             MainWindow* window)
{
#line 72 "../src/Services/ActionManager.vala"
	return services_action_manager_construct (SERVICES_TYPE_ACTION_MANAGER, app, window);
#line 554 "ActionManager.c"
}

static void
services_action_manager_disable_typing_accels (ServicesActionManager* self)
{
#line 122 "../src/Services/ActionManager.vala"
	g_return_if_fail (self != NULL);
#line 562 "ActionManager.c"
	{
		GeeIterator* _action_it = NULL;
		GeeMultiMap* _tmp0_;
		GeeSet* _tmp1_;
		GeeSet* _tmp2_;
		GeeIterator* _tmp3_;
		GeeIterator* _tmp4_;
#line 123 "../src/Services/ActionManager.vala"
		_tmp0_ = services_action_manager_typing_accelerators;
#line 123 "../src/Services/ActionManager.vala"
		_tmp1_ = gee_multi_map_get_keys (_tmp0_);
#line 123 "../src/Services/ActionManager.vala"
		_tmp2_ = _tmp1_;
#line 123 "../src/Services/ActionManager.vala"
		_tmp3_ = gee_iterable_iterator ((GeeIterable*) _tmp2_);
#line 123 "../src/Services/ActionManager.vala"
		_tmp4_ = _tmp3_;
#line 123 "../src/Services/ActionManager.vala"
		_g_object_unref0 (_tmp2_);
#line 123 "../src/Services/ActionManager.vala"
		_action_it = _tmp4_;
#line 123 "../src/Services/ActionManager.vala"
		while (TRUE) {
#line 586 "ActionManager.c"
			GeeIterator* _tmp5_;
			gchar* action = NULL;
			GeeIterator* _tmp6_;
			gpointer _tmp7_;
			Planify* _tmp8_;
			const gchar* _tmp9_;
			gchar* _tmp10_;
			gchar* _tmp11_;
			gchar** _tmp12_;
			gchar** _tmp13_;
			gint _tmp13__length1;
#line 123 "../src/Services/ActionManager.vala"
			_tmp5_ = _action_it;
#line 123 "../src/Services/ActionManager.vala"
			if (!gee_iterator_next (_tmp5_)) {
#line 123 "../src/Services/ActionManager.vala"
				break;
#line 604 "ActionManager.c"
			}
#line 123 "../src/Services/ActionManager.vala"
			_tmp6_ = _action_it;
#line 123 "../src/Services/ActionManager.vala"
			_tmp7_ = gee_iterator_get (_tmp6_);
#line 123 "../src/Services/ActionManager.vala"
			action = (gchar*) _tmp7_;
#line 124 "../src/Services/ActionManager.vala"
			_tmp8_ = self->priv->_app;
#line 124 "../src/Services/ActionManager.vala"
			_tmp9_ = action;
#line 124 "../src/Services/ActionManager.vala"
			_tmp10_ = g_strconcat (SERVICES_ACTION_MANAGER_ACTION_PREFIX, _tmp9_, NULL);
#line 124 "../src/Services/ActionManager.vala"
			_tmp11_ = _tmp10_;
#line 124 "../src/Services/ActionManager.vala"
			_tmp12_ = g_new0 (gchar*, 0 + 1);
#line 124 "../src/Services/ActionManager.vala"
			_tmp13_ = _tmp12_;
#line 124 "../src/Services/ActionManager.vala"
			_tmp13__length1 = 0;
#line 124 "../src/Services/ActionManager.vala"
			gtk_application_set_accels_for_action ((GtkApplication*) _tmp8_, _tmp11_, _tmp13_);
#line 124 "../src/Services/ActionManager.vala"
			_tmp13_ = (_vala_array_free (_tmp13_, _tmp13__length1, (GDestroyNotify) g_free), NULL);
#line 124 "../src/Services/ActionManager.vala"
			_g_free0 (_tmp11_);
#line 123 "../src/Services/ActionManager.vala"
			_g_free0 (action);
#line 634 "ActionManager.c"
		}
#line 123 "../src/Services/ActionManager.vala"
		_g_object_unref0 (_action_it);
#line 638 "ActionManager.c"
	}
}

static void
services_action_manager_disable_action_accels (ServicesActionManager* self)
{
#line 128 "../src/Services/ActionManager.vala"
	g_return_if_fail (self != NULL);
#line 647 "ActionManager.c"
	{
		GeeIterator* _action_it = NULL;
		GeeMultiMap* _tmp0_;
		GeeSet* _tmp1_;
		GeeSet* _tmp2_;
		GeeIterator* _tmp3_;
		GeeIterator* _tmp4_;
#line 129 "../src/Services/ActionManager.vala"
		_tmp0_ = services_action_manager_action_accelerators;
#line 129 "../src/Services/ActionManager.vala"
		_tmp1_ = gee_multi_map_get_keys (_tmp0_);
#line 129 "../src/Services/ActionManager.vala"
		_tmp2_ = _tmp1_;
#line 129 "../src/Services/ActionManager.vala"
		_tmp3_ = gee_iterable_iterator ((GeeIterable*) _tmp2_);
#line 129 "../src/Services/ActionManager.vala"
		_tmp4_ = _tmp3_;
#line 129 "../src/Services/ActionManager.vala"
		_g_object_unref0 (_tmp2_);
#line 129 "../src/Services/ActionManager.vala"
		_action_it = _tmp4_;
#line 129 "../src/Services/ActionManager.vala"
		while (TRUE) {
#line 671 "ActionManager.c"
			GeeIterator* _tmp5_;
			gchar* action = NULL;
			GeeIterator* _tmp6_;
			gpointer _tmp7_;
			Planify* _tmp8_;
			const gchar* _tmp9_;
			gchar* _tmp10_;
			gchar* _tmp11_;
			gchar** _tmp12_;
			gchar** _tmp13_;
			gint _tmp13__length1;
#line 129 "../src/Services/ActionManager.vala"
			_tmp5_ = _action_it;
#line 129 "../src/Services/ActionManager.vala"
			if (!gee_iterator_next (_tmp5_)) {
#line 129 "../src/Services/ActionManager.vala"
				break;
#line 689 "ActionManager.c"
			}
#line 129 "../src/Services/ActionManager.vala"
			_tmp6_ = _action_it;
#line 129 "../src/Services/ActionManager.vala"
			_tmp7_ = gee_iterator_get (_tmp6_);
#line 129 "../src/Services/ActionManager.vala"
			action = (gchar*) _tmp7_;
#line 130 "../src/Services/ActionManager.vala"
			_tmp8_ = self->priv->_app;
#line 130 "../src/Services/ActionManager.vala"
			_tmp9_ = action;
#line 130 "../src/Services/ActionManager.vala"
			_tmp10_ = g_strconcat (SERVICES_ACTION_MANAGER_ACTION_PREFIX, _tmp9_, NULL);
#line 130 "../src/Services/ActionManager.vala"
			_tmp11_ = _tmp10_;
#line 130 "../src/Services/ActionManager.vala"
			_tmp12_ = g_new0 (gchar*, 0 + 1);
#line 130 "../src/Services/ActionManager.vala"
			_tmp13_ = _tmp12_;
#line 130 "../src/Services/ActionManager.vala"
			_tmp13__length1 = 0;
#line 130 "../src/Services/ActionManager.vala"
			gtk_application_set_accels_for_action ((GtkApplication*) _tmp8_, _tmp11_, _tmp13_);
#line 130 "../src/Services/ActionManager.vala"
			_tmp13_ = (_vala_array_free (_tmp13_, _tmp13__length1, (GDestroyNotify) g_free), NULL);
#line 130 "../src/Services/ActionManager.vala"
			_g_free0 (_tmp11_);
#line 129 "../src/Services/ActionManager.vala"
			_g_free0 (action);
#line 719 "ActionManager.c"
		}
#line 129 "../src/Services/ActionManager.vala"
		_g_object_unref0 (_action_it);
#line 723 "ActionManager.c"
	}
}

static void
_vala_array_add1 (gchar** * array,
                  gint* length,
                  gint* size,
                  gchar* value)
{
#line 138 "../src/Services/ActionManager.vala"
	if ((*length) == (*size)) {
#line 138 "../src/Services/ActionManager.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 138 "../src/Services/ActionManager.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 739 "ActionManager.c"
	}
#line 138 "../src/Services/ActionManager.vala"
	(*array)[(*length)++] = value;
#line 138 "../src/Services/ActionManager.vala"
	(*array)[*length] = NULL;
#line 745 "ActionManager.c"
}

static void
services_action_manager_enable_typing_accels (ServicesActionManager* self)
{
#line 135 "../src/Services/ActionManager.vala"
	g_return_if_fail (self != NULL);
#line 753 "ActionManager.c"
	{
		GeeIterator* _action_it = NULL;
		GeeMultiMap* _tmp0_;
		GeeSet* _tmp1_;
		GeeSet* _tmp2_;
		GeeIterator* _tmp3_;
		GeeIterator* _tmp4_;
#line 136 "../src/Services/ActionManager.vala"
		_tmp0_ = services_action_manager_typing_accelerators;
#line 136 "../src/Services/ActionManager.vala"
		_tmp1_ = gee_multi_map_get_keys (_tmp0_);
#line 136 "../src/Services/ActionManager.vala"
		_tmp2_ = _tmp1_;
#line 136 "../src/Services/ActionManager.vala"
		_tmp3_ = gee_iterable_iterator ((GeeIterable*) _tmp2_);
#line 136 "../src/Services/ActionManager.vala"
		_tmp4_ = _tmp3_;
#line 136 "../src/Services/ActionManager.vala"
		_g_object_unref0 (_tmp2_);
#line 136 "../src/Services/ActionManager.vala"
		_action_it = _tmp4_;
#line 136 "../src/Services/ActionManager.vala"
		while (TRUE) {
#line 777 "ActionManager.c"
			GeeIterator* _tmp5_;
			gchar* action = NULL;
			GeeIterator* _tmp6_;
			gpointer _tmp7_;
			gchar** accels_array = NULL;
			GeeMultiMap* _tmp8_;
			const gchar* _tmp9_;
			GeeCollection* _tmp10_;
			GeeCollection* _tmp11_;
			gint _tmp12_ = 0;
			gpointer* _tmp13_;
			gchar** _tmp14_;
			gint _tmp14__length1;
			gint accels_array_length1;
			gint _accels_array_size_;
			Planify* _tmp15_;
			const gchar* _tmp16_;
			gchar* _tmp17_;
			gchar* _tmp18_;
			gchar** _tmp19_;
			gint _tmp19__length1;
#line 136 "../src/Services/ActionManager.vala"
			_tmp5_ = _action_it;
#line 136 "../src/Services/ActionManager.vala"
			if (!gee_iterator_next (_tmp5_)) {
#line 136 "../src/Services/ActionManager.vala"
				break;
#line 805 "ActionManager.c"
			}
#line 136 "../src/Services/ActionManager.vala"
			_tmp6_ = _action_it;
#line 136 "../src/Services/ActionManager.vala"
			_tmp7_ = gee_iterator_get (_tmp6_);
#line 136 "../src/Services/ActionManager.vala"
			action = (gchar*) _tmp7_;
#line 137 "../src/Services/ActionManager.vala"
			_tmp8_ = services_action_manager_typing_accelerators;
#line 137 "../src/Services/ActionManager.vala"
			_tmp9_ = action;
#line 137 "../src/Services/ActionManager.vala"
			_tmp10_ = gee_multi_map_get (_tmp8_, _tmp9_);
#line 137 "../src/Services/ActionManager.vala"
			_tmp11_ = _tmp10_;
#line 137 "../src/Services/ActionManager.vala"
			_tmp13_ = gee_collection_to_array (_tmp11_, &_tmp12_);
#line 137 "../src/Services/ActionManager.vala"
			_tmp14_ = _tmp13_;
#line 137 "../src/Services/ActionManager.vala"
			_tmp14__length1 = _tmp12_;
#line 137 "../src/Services/ActionManager.vala"
			_g_object_unref0 (_tmp11_);
#line 137 "../src/Services/ActionManager.vala"
			accels_array = _tmp14_;
#line 137 "../src/Services/ActionManager.vala"
			accels_array_length1 = _tmp14__length1;
#line 137 "../src/Services/ActionManager.vala"
			_accels_array_size_ = accels_array_length1;
#line 138 "../src/Services/ActionManager.vala"
			_vala_array_add1 (&accels_array, &accels_array_length1, &_accels_array_size_, NULL);
#line 139 "../src/Services/ActionManager.vala"
			_tmp15_ = self->priv->_app;
#line 139 "../src/Services/ActionManager.vala"
			_tmp16_ = action;
#line 139 "../src/Services/ActionManager.vala"
			_tmp17_ = g_strconcat (SERVICES_ACTION_MANAGER_ACTION_PREFIX, _tmp16_, NULL);
#line 139 "../src/Services/ActionManager.vala"
			_tmp18_ = _tmp17_;
#line 139 "../src/Services/ActionManager.vala"
			_tmp19_ = accels_array;
#line 139 "../src/Services/ActionManager.vala"
			_tmp19__length1 = accels_array_length1;
#line 139 "../src/Services/ActionManager.vala"
			gtk_application_set_accels_for_action ((GtkApplication*) _tmp15_, _tmp18_, _tmp19_);
#line 139 "../src/Services/ActionManager.vala"
			_g_free0 (_tmp18_);
#line 136 "../src/Services/ActionManager.vala"
			accels_array = (_vala_array_free (accels_array, accels_array_length1, (GDestroyNotify) g_free), NULL);
#line 136 "../src/Services/ActionManager.vala"
			_g_free0 (action);
#line 857 "ActionManager.c"
		}
#line 136 "../src/Services/ActionManager.vala"
		_g_object_unref0 (_action_it);
#line 861 "ActionManager.c"
	}
}

static void
_vala_array_add2 (gchar** * array,
                  gint* length,
                  gint* size,
                  gchar* value)
{
#line 146 "../src/Services/ActionManager.vala"
	if ((*length) == (*size)) {
#line 146 "../src/Services/ActionManager.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 146 "../src/Services/ActionManager.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 877 "ActionManager.c"
	}
#line 146 "../src/Services/ActionManager.vala"
	(*array)[(*length)++] = value;
#line 146 "../src/Services/ActionManager.vala"
	(*array)[*length] = NULL;
#line 883 "ActionManager.c"
}

static void
services_action_manager_enable_action_accels (ServicesActionManager* self)
{
#line 143 "../src/Services/ActionManager.vala"
	g_return_if_fail (self != NULL);
#line 891 "ActionManager.c"
	{
		GeeIterator* _action_it = NULL;
		GeeMultiMap* _tmp0_;
		GeeSet* _tmp1_;
		GeeSet* _tmp2_;
		GeeIterator* _tmp3_;
		GeeIterator* _tmp4_;
#line 144 "../src/Services/ActionManager.vala"
		_tmp0_ = services_action_manager_action_accelerators;
#line 144 "../src/Services/ActionManager.vala"
		_tmp1_ = gee_multi_map_get_keys (_tmp0_);
#line 144 "../src/Services/ActionManager.vala"
		_tmp2_ = _tmp1_;
#line 144 "../src/Services/ActionManager.vala"
		_tmp3_ = gee_iterable_iterator ((GeeIterable*) _tmp2_);
#line 144 "../src/Services/ActionManager.vala"
		_tmp4_ = _tmp3_;
#line 144 "../src/Services/ActionManager.vala"
		_g_object_unref0 (_tmp2_);
#line 144 "../src/Services/ActionManager.vala"
		_action_it = _tmp4_;
#line 144 "../src/Services/ActionManager.vala"
		while (TRUE) {
#line 915 "ActionManager.c"
			GeeIterator* _tmp5_;
			gchar* action = NULL;
			GeeIterator* _tmp6_;
			gpointer _tmp7_;
			gchar** accels_array = NULL;
			GeeMultiMap* _tmp8_;
			const gchar* _tmp9_;
			GeeCollection* _tmp10_;
			GeeCollection* _tmp11_;
			gint _tmp12_ = 0;
			gpointer* _tmp13_;
			gchar** _tmp14_;
			gint _tmp14__length1;
			gint accels_array_length1;
			gint _accels_array_size_;
			Planify* _tmp15_;
			const gchar* _tmp16_;
			gchar* _tmp17_;
			gchar* _tmp18_;
			gchar** _tmp19_;
			gint _tmp19__length1;
#line 144 "../src/Services/ActionManager.vala"
			_tmp5_ = _action_it;
#line 144 "../src/Services/ActionManager.vala"
			if (!gee_iterator_next (_tmp5_)) {
#line 144 "../src/Services/ActionManager.vala"
				break;
#line 943 "ActionManager.c"
			}
#line 144 "../src/Services/ActionManager.vala"
			_tmp6_ = _action_it;
#line 144 "../src/Services/ActionManager.vala"
			_tmp7_ = gee_iterator_get (_tmp6_);
#line 144 "../src/Services/ActionManager.vala"
			action = (gchar*) _tmp7_;
#line 145 "../src/Services/ActionManager.vala"
			_tmp8_ = services_action_manager_action_accelerators;
#line 145 "../src/Services/ActionManager.vala"
			_tmp9_ = action;
#line 145 "../src/Services/ActionManager.vala"
			_tmp10_ = gee_multi_map_get (_tmp8_, _tmp9_);
#line 145 "../src/Services/ActionManager.vala"
			_tmp11_ = _tmp10_;
#line 145 "../src/Services/ActionManager.vala"
			_tmp13_ = gee_collection_to_array (_tmp11_, &_tmp12_);
#line 145 "../src/Services/ActionManager.vala"
			_tmp14_ = _tmp13_;
#line 145 "../src/Services/ActionManager.vala"
			_tmp14__length1 = _tmp12_;
#line 145 "../src/Services/ActionManager.vala"
			_g_object_unref0 (_tmp11_);
#line 145 "../src/Services/ActionManager.vala"
			accels_array = _tmp14_;
#line 145 "../src/Services/ActionManager.vala"
			accels_array_length1 = _tmp14__length1;
#line 145 "../src/Services/ActionManager.vala"
			_accels_array_size_ = accels_array_length1;
#line 146 "../src/Services/ActionManager.vala"
			_vala_array_add2 (&accels_array, &accels_array_length1, &_accels_array_size_, NULL);
#line 147 "../src/Services/ActionManager.vala"
			_tmp15_ = self->priv->_app;
#line 147 "../src/Services/ActionManager.vala"
			_tmp16_ = action;
#line 147 "../src/Services/ActionManager.vala"
			_tmp17_ = g_strconcat (SERVICES_ACTION_MANAGER_ACTION_PREFIX, _tmp16_, NULL);
#line 147 "../src/Services/ActionManager.vala"
			_tmp18_ = _tmp17_;
#line 147 "../src/Services/ActionManager.vala"
			_tmp19_ = accels_array;
#line 147 "../src/Services/ActionManager.vala"
			_tmp19__length1 = accels_array_length1;
#line 147 "../src/Services/ActionManager.vala"
			gtk_application_set_accels_for_action ((GtkApplication*) _tmp15_, _tmp18_, _tmp19_);
#line 147 "../src/Services/ActionManager.vala"
			_g_free0 (_tmp18_);
#line 144 "../src/Services/ActionManager.vala"
			accels_array = (_vala_array_free (accels_array, accels_array_length1, (GDestroyNotify) g_free), NULL);
#line 144 "../src/Services/ActionManager.vala"
			_g_free0 (action);
#line 995 "ActionManager.c"
		}
#line 144 "../src/Services/ActionManager.vala"
		_g_object_unref0 (_action_it);
#line 999 "ActionManager.c"
	}
}

static void
services_action_manager_disable_all_accel (ServicesActionManager* self)
{
#line 151 "../src/Services/ActionManager.vala"
	g_return_if_fail (self != NULL);
#line 152 "../src/Services/ActionManager.vala"
	services_action_manager_disable_typing_accels (self);
#line 153 "../src/Services/ActionManager.vala"
	services_action_manager_disable_action_accels (self);
#line 1012 "ActionManager.c"
}

static void
services_action_manager_enable_all_accel (ServicesActionManager* self)
{
#line 156 "../src/Services/ActionManager.vala"
	g_return_if_fail (self != NULL);
#line 157 "../src/Services/ActionManager.vala"
	services_action_manager_enable_typing_accels (self);
#line 158 "../src/Services/ActionManager.vala"
	services_action_manager_enable_action_accels (self);
#line 1024 "ActionManager.c"
}

static void
services_action_manager_action_quit (ServicesActionManager* self)
{
	MainWindow* _tmp0_;
#line 161 "../src/Services/ActionManager.vala"
	g_return_if_fail (self != NULL);
#line 162 "../src/Services/ActionManager.vala"
	_tmp0_ = self->priv->_window;
#line 162 "../src/Services/ActionManager.vala"
	gtk_window_destroy ((GtkWindow*) _tmp0_);
#line 1037 "ActionManager.c"
}

static void
services_action_manager_action_preferences (ServicesActionManager* self)
{
	DialogsPreferencesPreferencesWindow* dialog = NULL;
	DialogsPreferencesPreferencesWindow* _tmp0_;
	Planify* _tmp1_;
	MainWindow* _tmp2_;
#line 165 "../src/Services/ActionManager.vala"
	g_return_if_fail (self != NULL);
#line 166 "../src/Services/ActionManager.vala"
	_tmp0_ = dialogs_preferences_preferences_window_new ();
#line 166 "../src/Services/ActionManager.vala"
	g_object_ref_sink (_tmp0_);
#line 166 "../src/Services/ActionManager.vala"
	dialog = _tmp0_;
#line 167 "../src/Services/ActionManager.vala"
	_tmp1_ = planify__instance;
#line 167 "../src/Services/ActionManager.vala"
	_tmp2_ = _tmp1_->main_window;
#line 167 "../src/Services/ActionManager.vala"
	adw_dialog_present ((AdwDialog*) dialog, (GtkWidget*) _tmp2_);
#line 165 "../src/Services/ActionManager.vala"
	_g_object_unref0 (dialog);
#line 1063 "ActionManager.c"
}

static void
services_action_manager_action_open_search (ServicesActionManager* self)
{
	DialogsQuickFindQuickFind* dialog = NULL;
	DialogsQuickFindQuickFind* _tmp0_;
	Planify* _tmp1_;
	MainWindow* _tmp2_;
#line 170 "../src/Services/ActionManager.vala"
	g_return_if_fail (self != NULL);
#line 171 "../src/Services/ActionManager.vala"
	_tmp0_ = dialogs_quick_find_quick_find_new ();
#line 171 "../src/Services/ActionManager.vala"
	g_object_ref_sink (_tmp0_);
#line 171 "../src/Services/ActionManager.vala"
	dialog = _tmp0_;
#line 172 "../src/Services/ActionManager.vala"
	_tmp1_ = planify__instance;
#line 172 "../src/Services/ActionManager.vala"
	_tmp2_ = _tmp1_->main_window;
#line 172 "../src/Services/ActionManager.vala"
	adw_dialog_present ((AdwDialog*) dialog, (GtkWidget*) _tmp2_);
#line 170 "../src/Services/ActionManager.vala"
	_g_object_unref0 (dialog);
#line 1089 "ActionManager.c"
}

static void
services_action_manager_action_sync_manually (ServicesActionManager* self)
{
#line 175 "../src/Services/ActionManager.vala"
	g_return_if_fail (self != NULL);
#line 1097 "ActionManager.c"
	{
		GeeArrayList* _source_list = NULL;
		ServicesStore* _tmp0_;
		GeeArrayList* _tmp1_;
		GeeArrayList* _tmp2_;
		gint _source_size = 0;
		GeeArrayList* _tmp3_;
		gint _tmp4_;
		gint _tmp5_;
		gint _source_index = 0;
#line 176 "../src/Services/ActionManager.vala"
		_tmp0_ = services_store_instance ();
#line 176 "../src/Services/ActionManager.vala"
		_tmp1_ = services_store_get_sources (_tmp0_);
#line 176 "../src/Services/ActionManager.vala"
		_tmp2_ = _tmp1_;
#line 176 "../src/Services/ActionManager.vala"
		_source_list = _tmp2_;
#line 176 "../src/Services/ActionManager.vala"
		_tmp3_ = _source_list;
#line 176 "../src/Services/ActionManager.vala"
		_tmp4_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp3_);
#line 176 "../src/Services/ActionManager.vala"
		_tmp5_ = _tmp4_;
#line 176 "../src/Services/ActionManager.vala"
		_source_size = _tmp5_;
#line 176 "../src/Services/ActionManager.vala"
		_source_index = -1;
#line 176 "../src/Services/ActionManager.vala"
		while (TRUE) {
#line 1128 "ActionManager.c"
			gint _tmp6_;
			gint _tmp7_;
			ObjectsSource* source = NULL;
			GeeArrayList* _tmp8_;
			gpointer _tmp9_;
			ObjectsSource* _tmp10_;
#line 176 "../src/Services/ActionManager.vala"
			_source_index = _source_index + 1;
#line 176 "../src/Services/ActionManager.vala"
			_tmp6_ = _source_index;
#line 176 "../src/Services/ActionManager.vala"
			_tmp7_ = _source_size;
#line 176 "../src/Services/ActionManager.vala"
			if (!(_tmp6_ < _tmp7_)) {
#line 176 "../src/Services/ActionManager.vala"
				break;
#line 1145 "ActionManager.c"
			}
#line 176 "../src/Services/ActionManager.vala"
			_tmp8_ = _source_list;
#line 176 "../src/Services/ActionManager.vala"
			_tmp9_ = gee_abstract_list_get ((GeeAbstractList*) _tmp8_, _source_index);
#line 176 "../src/Services/ActionManager.vala"
			source = (ObjectsSource*) _tmp9_;
#line 177 "../src/Services/ActionManager.vala"
			_tmp10_ = source;
#line 177 "../src/Services/ActionManager.vala"
			objects_source_run_server (_tmp10_);
#line 176 "../src/Services/ActionManager.vala"
			_g_object_unref0 (source);
#line 1159 "ActionManager.c"
		}
	}
}

static void
services_action_manager_action_new_project (ServicesActionManager* self)
{
	DialogsProject* dialog = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	DialogsProject* _tmp2_;
	DialogsProject* _tmp3_;
	Planify* _tmp4_;
	MainWindow* _tmp5_;
#line 181 "../src/Services/ActionManager.vala"
	g_return_if_fail (self != NULL);
#line 182 "../src/Services/ActionManager.vala"
	_tmp0_ = source_type_to_string (SOURCE_TYPE_LOCAL);
#line 182 "../src/Services/ActionManager.vala"
	_tmp1_ = _tmp0_;
#line 182 "../src/Services/ActionManager.vala"
	_tmp2_ = dialogs_project_new_new (_tmp1_, TRUE, "");
#line 182 "../src/Services/ActionManager.vala"
	g_object_ref_sink (_tmp2_);
#line 182 "../src/Services/ActionManager.vala"
	_tmp3_ = _tmp2_;
#line 182 "../src/Services/ActionManager.vala"
	_g_free0 (_tmp1_);
#line 182 "../src/Services/ActionManager.vala"
	dialog = _tmp3_;
#line 183 "../src/Services/ActionManager.vala"
	_tmp4_ = planify__instance;
#line 183 "../src/Services/ActionManager.vala"
	_tmp5_ = _tmp4_->main_window;
#line 183 "../src/Services/ActionManager.vala"
	adw_dialog_present ((AdwDialog*) dialog, (GtkWidget*) _tmp5_);
#line 181 "../src/Services/ActionManager.vala"
	_g_object_unref0 (dialog);
#line 1198 "ActionManager.c"
}

static void
services_action_manager_action_view_homepage (ServicesActionManager* self)
{
	MainWindow* _tmp0_;
#line 186 "../src/Services/ActionManager.vala"
	g_return_if_fail (self != NULL);
#line 187 "../src/Services/ActionManager.vala"
	_tmp0_ = self->priv->_window;
#line 187 "../src/Services/ActionManager.vala"
	main_window_go_homepage (_tmp0_);
#line 1211 "ActionManager.c"
}

static void
services_action_manager_action_view_inbox (ServicesActionManager* self)
{
	ServicesEventBus* _tmp0_;
	ServicesEventBus* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
#line 190 "../src/Services/ActionManager.vala"
	g_return_if_fail (self != NULL);
#line 191 "../src/Services/ActionManager.vala"
	_tmp0_ = services_event_bus_get_default ();
#line 191 "../src/Services/ActionManager.vala"
	_tmp1_ = _tmp0_;
#line 191 "../src/Services/ActionManager.vala"
	_tmp2_ = filter_type_to_string (FILTER_TYPE_INBOX);
#line 191 "../src/Services/ActionManager.vala"
	_tmp3_ = _tmp2_;
#line 191 "../src/Services/ActionManager.vala"
	g_signal_emit_by_name (_tmp1_, "pane-selected", PANE_TYPE_FILTER, _tmp3_);
#line 191 "../src/Services/ActionManager.vala"
	_g_free0 (_tmp3_);
#line 191 "../src/Services/ActionManager.vala"
	_g_object_unref0 (_tmp1_);
#line 1237 "ActionManager.c"
}

static void
services_action_manager_action_view_today (ServicesActionManager* self)
{
	ServicesEventBus* _tmp0_;
	ServicesEventBus* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
#line 194 "../src/Services/ActionManager.vala"
	g_return_if_fail (self != NULL);
#line 195 "../src/Services/ActionManager.vala"
	_tmp0_ = services_event_bus_get_default ();
#line 195 "../src/Services/ActionManager.vala"
	_tmp1_ = _tmp0_;
#line 195 "../src/Services/ActionManager.vala"
	_tmp2_ = filter_type_to_string (FILTER_TYPE_TODAY);
#line 195 "../src/Services/ActionManager.vala"
	_tmp3_ = _tmp2_;
#line 195 "../src/Services/ActionManager.vala"
	g_signal_emit_by_name (_tmp1_, "pane-selected", PANE_TYPE_FILTER, _tmp3_);
#line 195 "../src/Services/ActionManager.vala"
	_g_free0 (_tmp3_);
#line 195 "../src/Services/ActionManager.vala"
	_g_object_unref0 (_tmp1_);
#line 1263 "ActionManager.c"
}

static void
services_action_manager_action_view_scheduled (ServicesActionManager* self)
{
	ServicesEventBus* _tmp0_;
	ServicesEventBus* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
#line 198 "../src/Services/ActionManager.vala"
	g_return_if_fail (self != NULL);
#line 199 "../src/Services/ActionManager.vala"
	_tmp0_ = services_event_bus_get_default ();
#line 199 "../src/Services/ActionManager.vala"
	_tmp1_ = _tmp0_;
#line 199 "../src/Services/ActionManager.vala"
	_tmp2_ = filter_type_to_string (FILTER_TYPE_SCHEDULED);
#line 199 "../src/Services/ActionManager.vala"
	_tmp3_ = _tmp2_;
#line 199 "../src/Services/ActionManager.vala"
	g_signal_emit_by_name (_tmp1_, "pane-selected", PANE_TYPE_FILTER, _tmp3_);
#line 199 "../src/Services/ActionManager.vala"
	_g_free0 (_tmp3_);
#line 199 "../src/Services/ActionManager.vala"
	_g_object_unref0 (_tmp1_);
#line 1289 "ActionManager.c"
}

static void
services_action_manager_action_view_labels (ServicesActionManager* self)
{
	ServicesEventBus* _tmp0_;
	ServicesEventBus* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
#line 202 "../src/Services/ActionManager.vala"
	g_return_if_fail (self != NULL);
#line 203 "../src/Services/ActionManager.vala"
	_tmp0_ = services_event_bus_get_default ();
#line 203 "../src/Services/ActionManager.vala"
	_tmp1_ = _tmp0_;
#line 203 "../src/Services/ActionManager.vala"
	_tmp2_ = filter_type_to_string (FILTER_TYPE_LABELS);
#line 203 "../src/Services/ActionManager.vala"
	_tmp3_ = _tmp2_;
#line 203 "../src/Services/ActionManager.vala"
	g_signal_emit_by_name (_tmp1_, "pane-selected", PANE_TYPE_FILTER, _tmp3_);
#line 203 "../src/Services/ActionManager.vala"
	_g_free0 (_tmp3_);
#line 203 "../src/Services/ActionManager.vala"
	_g_object_unref0 (_tmp1_);
#line 1315 "ActionManager.c"
}

static void
services_action_manager_action_view_pinboard (ServicesActionManager* self)
{
	ServicesEventBus* _tmp0_;
	ServicesEventBus* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
#line 206 "../src/Services/ActionManager.vala"
	g_return_if_fail (self != NULL);
#line 207 "../src/Services/ActionManager.vala"
	_tmp0_ = services_event_bus_get_default ();
#line 207 "../src/Services/ActionManager.vala"
	_tmp1_ = _tmp0_;
#line 207 "../src/Services/ActionManager.vala"
	_tmp2_ = filter_type_to_string (FILTER_TYPE_PINBOARD);
#line 207 "../src/Services/ActionManager.vala"
	_tmp3_ = _tmp2_;
#line 207 "../src/Services/ActionManager.vala"
	g_signal_emit_by_name (_tmp1_, "pane-selected", PANE_TYPE_FILTER, _tmp3_);
#line 207 "../src/Services/ActionManager.vala"
	_g_free0 (_tmp3_);
#line 207 "../src/Services/ActionManager.vala"
	_g_object_unref0 (_tmp1_);
#line 1341 "ActionManager.c"
}

static void
services_action_manager_action_show_hide_sidebar (ServicesActionManager* self)
{
	MainWindow* _tmp0_;
#line 210 "../src/Services/ActionManager.vala"
	g_return_if_fail (self != NULL);
#line 211 "../src/Services/ActionManager.vala"
	_tmp0_ = self->priv->_window;
#line 211 "../src/Services/ActionManager.vala"
	main_window_show_hide_sidebar (_tmp0_);
#line 1354 "ActionManager.c"
}

static void
services_action_manager_action_new_section (ServicesActionManager* self)
{
	MainWindow* _tmp0_;
#line 214 "../src/Services/ActionManager.vala"
	g_return_if_fail (self != NULL);
#line 215 "../src/Services/ActionManager.vala"
	_tmp0_ = self->priv->_window;
#line 215 "../src/Services/ActionManager.vala"
	main_window_new_section_action (_tmp0_);
#line 1367 "ActionManager.c"
}

static void
services_action_manager_action_add_task (ServicesActionManager* self)
{
	MainWindow* _tmp0_;
#line 218 "../src/Services/ActionManager.vala"
	g_return_if_fail (self != NULL);
#line 219 "../src/Services/ActionManager.vala"
	_tmp0_ = self->priv->_window;
#line 219 "../src/Services/ActionManager.vala"
	main_window_add_task_action (_tmp0_, "");
#line 1380 "ActionManager.c"
}

static Block4Data*
block4_data_ref (Block4Data* _data4_)
{
#line 222 "../src/Services/ActionManager.vala"
	g_atomic_int_inc (&_data4_->_ref_count_);
#line 222 "../src/Services/ActionManager.vala"
	return _data4_;
#line 1390 "ActionManager.c"
}

static void
block4_data_unref (void * _userdata_)
{
	Block4Data* _data4_;
	_data4_ = (Block4Data*) _userdata_;
#line 222 "../src/Services/ActionManager.vala"
	if (g_atomic_int_dec_and_test (&_data4_->_ref_count_)) {
#line 1400 "ActionManager.c"
		ServicesActionManager* self;
#line 222 "../src/Services/ActionManager.vala"
		self = _data4_->self;
#line 222 "../src/Services/ActionManager.vala"
		_g_object_unref0 (_data4_->clipboard);
#line 222 "../src/Services/ActionManager.vala"
		_g_object_unref0 (self);
#line 222 "../src/Services/ActionManager.vala"
		g_slice_free (Block4Data, _data4_);
#line 1410 "ActionManager.c"
	}
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 223 "../src/Services/ActionManager.vala"
	return self ? g_object_ref (self) : NULL;
#line 1419 "ActionManager.c"
}

static void
__lambda710_ (Block4Data* _data4_,
              GObject* obj,
              GAsyncResult* res)
{
	ServicesActionManager* self;
	GError* _inner_error0_ = NULL;
#line 225 "../src/Services/ActionManager.vala"
	self = _data4_->self;
#line 225 "../src/Services/ActionManager.vala"
	g_return_if_fail (res != NULL);
#line 1433 "ActionManager.c"
	{
		gchar* content = NULL;
		gchar* _tmp0_;
		MainWindow* _tmp1_;
#line 227 "../src/Services/ActionManager.vala"
		_tmp0_ = gdk_clipboard_read_text_finish (_data4_->clipboard, res, &_inner_error0_);
#line 227 "../src/Services/ActionManager.vala"
		content = _tmp0_;
#line 227 "../src/Services/ActionManager.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1444 "ActionManager.c"
			goto __catch0_g_error;
		}
#line 228 "../src/Services/ActionManager.vala"
		_tmp1_ = self->priv->_window;
#line 228 "../src/Services/ActionManager.vala"
		main_window_add_task_action (_tmp1_, content);
#line 226 "../src/Services/ActionManager.vala"
		_g_free0 (content);
#line 1453 "ActionManager.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* _error_ = NULL;
		GError* _tmp2_;
		const gchar* _tmp3_;
#line 226 "../src/Services/ActionManager.vala"
		_error_ = _inner_error0_;
#line 226 "../src/Services/ActionManager.vala"
		_inner_error0_ = NULL;
#line 230 "../src/Services/ActionManager.vala"
		_tmp2_ = _error_;
#line 230 "../src/Services/ActionManager.vala"
		_tmp3_ = _tmp2_->message;
#line 230 "../src/Services/ActionManager.vala"
		g_debug ("ActionManager.vala:230: %s", _tmp3_);
#line 226 "../src/Services/ActionManager.vala"
		_g_error_free0 (_error_);
#line 1473 "ActionManager.c"
	}
	__finally0:
#line 226 "../src/Services/ActionManager.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 226 "../src/Services/ActionManager.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 226 "../src/Services/ActionManager.vala"
		g_clear_error (&_inner_error0_);
#line 226 "../src/Services/ActionManager.vala"
		return;
#line 1484 "ActionManager.c"
	}
}

static void
___lambda710__gasync_ready_callback (GObject* source_object,
                                     GAsyncResult* res,
                                     gpointer self)
{
#line 225 "../src/Services/ActionManager.vala"
	__lambda710_ (self, source_object, res);
#line 225 "../src/Services/ActionManager.vala"
	block4_data_unref (self);
#line 1497 "ActionManager.c"
}

static void
services_action_manager_action_add_task_paste (ServicesActionManager* self)
{
	Block4Data* _data4_;
	GdkDisplay* _tmp0_;
	GdkClipboard* _tmp1_;
	GdkClipboard* _tmp2_;
#line 222 "../src/Services/ActionManager.vala"
	g_return_if_fail (self != NULL);
#line 222 "../src/Services/ActionManager.vala"
	_data4_ = g_slice_new0 (Block4Data);
#line 222 "../src/Services/ActionManager.vala"
	_data4_->_ref_count_ = 1;
#line 222 "../src/Services/ActionManager.vala"
	_data4_->self = g_object_ref (self);
#line 223 "../src/Services/ActionManager.vala"
	_tmp0_ = gdk_display_get_default ();
#line 223 "../src/Services/ActionManager.vala"
	_tmp1_ = gdk_display_get_clipboard (_tmp0_);
#line 223 "../src/Services/ActionManager.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 223 "../src/Services/ActionManager.vala"
	_data4_->clipboard = _tmp2_;
#line 225 "../src/Services/ActionManager.vala"
	gdk_clipboard_read_text_async (_data4_->clipboard, NULL, ___lambda710__gasync_ready_callback, block4_data_ref (_data4_));
#line 222 "../src/Services/ActionManager.vala"
	block4_data_unref (_data4_);
#line 222 "../src/Services/ActionManager.vala"
	_data4_ = NULL;
#line 1529 "ActionManager.c"
}

static void
services_action_manager_action_shortcuts (ServicesActionManager* self)
{
	MainWindow* _tmp0_;
#line 235 "../src/Services/ActionManager.vala"
	g_return_if_fail (self != NULL);
#line 236 "../src/Services/ActionManager.vala"
	_tmp0_ = self->priv->_window;
#line 236 "../src/Services/ActionManager.vala"
	main_window_open_shortcuts_window (_tmp0_);
#line 1542 "ActionManager.c"
}

static void
services_action_manager_action_view_home (ServicesActionManager* self)
{
	MainWindow* _tmp0_;
#line 239 "../src/Services/ActionManager.vala"
	g_return_if_fail (self != NULL);
#line 240 "../src/Services/ActionManager.vala"
	_tmp0_ = self->priv->_window;
#line 240 "../src/Services/ActionManager.vala"
	main_window_go_homepage (_tmp0_);
#line 1555 "ActionManager.c"
}

Planify*
services_action_manager_get_app (ServicesActionManager* self)
{
	Planify* result;
	Planify* _tmp0_;
#line 23 "../src/Services/ActionManager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 23 "../src/Services/ActionManager.vala"
	_tmp0_ = self->priv->_app;
#line 23 "../src/Services/ActionManager.vala"
	result = _tmp0_;
#line 23 "../src/Services/ActionManager.vala"
	return result;
#line 1571 "ActionManager.c"
}

static void
services_action_manager_set_app (ServicesActionManager* self,
                                 Planify* value)
{
	Planify* old_value;
#line 23 "../src/Services/ActionManager.vala"
	g_return_if_fail (self != NULL);
#line 23 "../src/Services/ActionManager.vala"
	old_value = services_action_manager_get_app (self);
#line 23 "../src/Services/ActionManager.vala"
	if (old_value != value) {
#line 1585 "ActionManager.c"
		Planify* _tmp0_;
#line 23 "../src/Services/ActionManager.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 23 "../src/Services/ActionManager.vala"
		_g_object_unref0 (self->priv->_app);
#line 23 "../src/Services/ActionManager.vala"
		self->priv->_app = _tmp0_;
#line 23 "../src/Services/ActionManager.vala"
		g_object_notify_by_pspec ((GObject *) self, services_action_manager_properties[SERVICES_ACTION_MANAGER_APP_PROPERTY]);
#line 1595 "ActionManager.c"
	}
}

MainWindow*
services_action_manager_get_window (ServicesActionManager* self)
{
	MainWindow* result;
	MainWindow* _tmp0_;
#line 24 "../src/Services/ActionManager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 24 "../src/Services/ActionManager.vala"
	_tmp0_ = self->priv->_window;
#line 24 "../src/Services/ActionManager.vala"
	result = _tmp0_;
#line 24 "../src/Services/ActionManager.vala"
	return result;
#line 1612 "ActionManager.c"
}

static void
services_action_manager_set_window (ServicesActionManager* self,
                                    MainWindow* value)
{
	MainWindow* old_value;
#line 24 "../src/Services/ActionManager.vala"
	g_return_if_fail (self != NULL);
#line 24 "../src/Services/ActionManager.vala"
	old_value = services_action_manager_get_window (self);
#line 24 "../src/Services/ActionManager.vala"
	if (old_value != value) {
#line 1626 "ActionManager.c"
		MainWindow* _tmp0_;
#line 24 "../src/Services/ActionManager.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 24 "../src/Services/ActionManager.vala"
		_g_object_unref0 (self->priv->_window);
#line 24 "../src/Services/ActionManager.vala"
		self->priv->_window = _tmp0_;
#line 24 "../src/Services/ActionManager.vala"
		g_object_notify_by_pspec ((GObject *) self, services_action_manager_properties[SERVICES_ACTION_MANAGER_WINDOW_PROPERTY]);
#line 1636 "ActionManager.c"
	}
}

GSimpleActionGroup*
services_action_manager_get_actions (ServicesActionManager* self)
{
	GSimpleActionGroup* result;
	GSimpleActionGroup* _tmp0_;
#line 26 "../src/Services/ActionManager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 26 "../src/Services/ActionManager.vala"
	_tmp0_ = self->priv->_actions;
#line 26 "../src/Services/ActionManager.vala"
	result = _tmp0_;
#line 26 "../src/Services/ActionManager.vala"
	return result;
#line 1653 "ActionManager.c"
}

static void
services_action_manager_set_actions (ServicesActionManager* self,
                                     GSimpleActionGroup* value)
{
	GSimpleActionGroup* old_value;
#line 26 "../src/Services/ActionManager.vala"
	g_return_if_fail (self != NULL);
#line 26 "../src/Services/ActionManager.vala"
	old_value = services_action_manager_get_actions (self);
#line 26 "../src/Services/ActionManager.vala"
	if (old_value != value) {
#line 1667 "ActionManager.c"
		GSimpleActionGroup* _tmp0_;
#line 26 "../src/Services/ActionManager.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 26 "../src/Services/ActionManager.vala"
		_g_object_unref0 (self->priv->_actions);
#line 26 "../src/Services/ActionManager.vala"
		self->priv->_actions = _tmp0_;
#line 26 "../src/Services/ActionManager.vala"
		g_object_notify_by_pspec ((GObject *) self, services_action_manager_properties[SERVICES_ACTION_MANAGER_ACTIONS_PROPERTY]);
#line 1677 "ActionManager.c"
	}
}

static void
_vala_array_add3 (gchar** * array,
                  gint* length,
                  gint* size,
                  gchar* value)
{
#line 108 "../src/Services/ActionManager.vala"
	if ((*length) == (*size)) {
#line 108 "../src/Services/ActionManager.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 108 "../src/Services/ActionManager.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 1693 "ActionManager.c"
	}
#line 108 "../src/Services/ActionManager.vala"
	(*array)[(*length)++] = value;
#line 108 "../src/Services/ActionManager.vala"
	(*array)[*length] = NULL;
#line 1699 "ActionManager.c"
}

static void
_services_action_manager_disable_typing_accels_services_event_bus_disconnect_typing_accel (ServicesEventBus* _sender,
                                                                                           gpointer self)
{
#line 114 "../src/Services/ActionManager.vala"
	services_action_manager_disable_typing_accels ((ServicesActionManager*) self);
#line 1708 "ActionManager.c"
}

static void
_services_action_manager_enable_typing_accels_services_event_bus_connect_typing_accel (ServicesEventBus* _sender,
                                                                                       gpointer self)
{
#line 115 "../src/Services/ActionManager.vala"
	services_action_manager_enable_typing_accels ((ServicesActionManager*) self);
#line 1717 "ActionManager.c"
}

static void
_services_action_manager_disable_all_accel_services_event_bus_disconnect_all_accels (ServicesEventBus* _sender,
                                                                                     gpointer self)
{
#line 117 "../src/Services/ActionManager.vala"
	services_action_manager_disable_all_accel ((ServicesActionManager*) self);
#line 1726 "ActionManager.c"
}

static void
_services_action_manager_enable_all_accel_services_event_bus_connect_all_accels (ServicesEventBus* _sender,
                                                                                 gpointer self)
{
#line 118 "../src/Services/ActionManager.vala"
	services_action_manager_enable_all_accel ((ServicesActionManager*) self);
#line 1735 "ActionManager.c"
}

static GObject *
services_action_manager_constructor (GType type,
                                     guint n_construct_properties,
                                     GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	ServicesActionManager * self;
	GSimpleActionGroup* _tmp0_;
	GSimpleActionGroup* _tmp1_;
	GSimpleActionGroup* _tmp2_;
	MainWindow* _tmp3_;
	GSimpleActionGroup* _tmp4_;
	ServicesEventBus* _tmp25_;
	ServicesEventBus* _tmp26_;
	ServicesEventBus* _tmp27_;
	ServicesEventBus* _tmp28_;
	ServicesEventBus* _tmp29_;
	ServicesEventBus* _tmp30_;
	ServicesEventBus* _tmp31_;
	ServicesEventBus* _tmp32_;
#line 101 "../src/Services/ActionManager.vala"
	parent_class = G_OBJECT_CLASS (services_action_manager_parent_class);
#line 101 "../src/Services/ActionManager.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 101 "../src/Services/ActionManager.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SERVICES_TYPE_ACTION_MANAGER, ServicesActionManager);
#line 102 "../src/Services/ActionManager.vala"
	_tmp0_ = g_simple_action_group_new ();
#line 102 "../src/Services/ActionManager.vala"
	_tmp1_ = _tmp0_;
#line 102 "../src/Services/ActionManager.vala"
	services_action_manager_set_actions (self, _tmp1_);
#line 102 "../src/Services/ActionManager.vala"
	_g_object_unref0 (_tmp1_);
#line 103 "../src/Services/ActionManager.vala"
	_tmp2_ = self->priv->_actions;
#line 103 "../src/Services/ActionManager.vala"
	g_action_map_add_action_entries ((GActionMap*) _tmp2_, SERVICES_ACTION_MANAGER_ACTION_ENTRIES, (gint) G_N_ELEMENTS (SERVICES_ACTION_MANAGER_ACTION_ENTRIES), self);
#line 104 "../src/Services/ActionManager.vala"
	_tmp3_ = self->priv->_window;
#line 104 "../src/Services/ActionManager.vala"
	_tmp4_ = self->priv->_actions;
#line 104 "../src/Services/ActionManager.vala"
	gtk_widget_insert_action_group ((GtkWidget*) _tmp3_, "win", (GActionGroup*) _tmp4_);
#line 1783 "ActionManager.c"
	{
		GeeIterator* _action_it = NULL;
		GeeMultiMap* _tmp5_;
		GeeSet* _tmp6_;
		GeeSet* _tmp7_;
		GeeIterator* _tmp8_;
		GeeIterator* _tmp9_;
#line 106 "../src/Services/ActionManager.vala"
		_tmp5_ = services_action_manager_action_accelerators;
#line 106 "../src/Services/ActionManager.vala"
		_tmp6_ = gee_multi_map_get_keys (_tmp5_);
#line 106 "../src/Services/ActionManager.vala"
		_tmp7_ = _tmp6_;
#line 106 "../src/Services/ActionManager.vala"
		_tmp8_ = gee_iterable_iterator ((GeeIterable*) _tmp7_);
#line 106 "../src/Services/ActionManager.vala"
		_tmp9_ = _tmp8_;
#line 106 "../src/Services/ActionManager.vala"
		_g_object_unref0 (_tmp7_);
#line 106 "../src/Services/ActionManager.vala"
		_action_it = _tmp9_;
#line 106 "../src/Services/ActionManager.vala"
		while (TRUE) {
#line 1807 "ActionManager.c"
			GeeIterator* _tmp10_;
			gchar* action = NULL;
			GeeIterator* _tmp11_;
			gpointer _tmp12_;
			gchar** accels_array = NULL;
			GeeMultiMap* _tmp13_;
			const gchar* _tmp14_;
			GeeCollection* _tmp15_;
			GeeCollection* _tmp16_;
			gint _tmp17_ = 0;
			gpointer* _tmp18_;
			gchar** _tmp19_;
			gint _tmp19__length1;
			gint accels_array_length1;
			gint _accels_array_size_;
			Planify* _tmp20_;
			const gchar* _tmp21_;
			gchar* _tmp22_;
			gchar* _tmp23_;
			gchar** _tmp24_;
			gint _tmp24__length1;
#line 106 "../src/Services/ActionManager.vala"
			_tmp10_ = _action_it;
#line 106 "../src/Services/ActionManager.vala"
			if (!gee_iterator_next (_tmp10_)) {
#line 106 "../src/Services/ActionManager.vala"
				break;
#line 1835 "ActionManager.c"
			}
#line 106 "../src/Services/ActionManager.vala"
			_tmp11_ = _action_it;
#line 106 "../src/Services/ActionManager.vala"
			_tmp12_ = gee_iterator_get (_tmp11_);
#line 106 "../src/Services/ActionManager.vala"
			action = (gchar*) _tmp12_;
#line 107 "../src/Services/ActionManager.vala"
			_tmp13_ = services_action_manager_action_accelerators;
#line 107 "../src/Services/ActionManager.vala"
			_tmp14_ = action;
#line 107 "../src/Services/ActionManager.vala"
			_tmp15_ = gee_multi_map_get (_tmp13_, _tmp14_);
#line 107 "../src/Services/ActionManager.vala"
			_tmp16_ = _tmp15_;
#line 107 "../src/Services/ActionManager.vala"
			_tmp18_ = gee_collection_to_array (_tmp16_, &_tmp17_);
#line 107 "../src/Services/ActionManager.vala"
			_tmp19_ = _tmp18_;
#line 107 "../src/Services/ActionManager.vala"
			_tmp19__length1 = _tmp17_;
#line 107 "../src/Services/ActionManager.vala"
			_g_object_unref0 (_tmp16_);
#line 107 "../src/Services/ActionManager.vala"
			accels_array = _tmp19_;
#line 107 "../src/Services/ActionManager.vala"
			accels_array_length1 = _tmp19__length1;
#line 107 "../src/Services/ActionManager.vala"
			_accels_array_size_ = accels_array_length1;
#line 108 "../src/Services/ActionManager.vala"
			_vala_array_add3 (&accels_array, &accels_array_length1, &_accels_array_size_, NULL);
#line 109 "../src/Services/ActionManager.vala"
			_tmp20_ = self->priv->_app;
#line 109 "../src/Services/ActionManager.vala"
			_tmp21_ = action;
#line 109 "../src/Services/ActionManager.vala"
			_tmp22_ = g_strconcat (SERVICES_ACTION_MANAGER_ACTION_PREFIX, _tmp21_, NULL);
#line 109 "../src/Services/ActionManager.vala"
			_tmp23_ = _tmp22_;
#line 109 "../src/Services/ActionManager.vala"
			_tmp24_ = accels_array;
#line 109 "../src/Services/ActionManager.vala"
			_tmp24__length1 = accels_array_length1;
#line 109 "../src/Services/ActionManager.vala"
			gtk_application_set_accels_for_action ((GtkApplication*) _tmp20_, _tmp23_, _tmp24_);
#line 109 "../src/Services/ActionManager.vala"
			_g_free0 (_tmp23_);
#line 106 "../src/Services/ActionManager.vala"
			accels_array = (_vala_array_free (accels_array, accels_array_length1, (GDestroyNotify) g_free), NULL);
#line 106 "../src/Services/ActionManager.vala"
			_g_free0 (action);
#line 1887 "ActionManager.c"
		}
#line 106 "../src/Services/ActionManager.vala"
		_g_object_unref0 (_action_it);
#line 1891 "ActionManager.c"
	}
#line 112 "../src/Services/ActionManager.vala"
	services_action_manager_enable_typing_accels (self);
#line 114 "../src/Services/ActionManager.vala"
	_tmp25_ = services_event_bus_get_default ();
#line 114 "../src/Services/ActionManager.vala"
	_tmp26_ = _tmp25_;
#line 114 "../src/Services/ActionManager.vala"
	g_signal_connect_object (_tmp26_, "disconnect-typing-accel", (GCallback) _services_action_manager_disable_typing_accels_services_event_bus_disconnect_typing_accel, self, 0);
#line 114 "../src/Services/ActionManager.vala"
	_g_object_unref0 (_tmp26_);
#line 115 "../src/Services/ActionManager.vala"
	_tmp27_ = services_event_bus_get_default ();
#line 115 "../src/Services/ActionManager.vala"
	_tmp28_ = _tmp27_;
#line 115 "../src/Services/ActionManager.vala"
	g_signal_connect_object (_tmp28_, "connect-typing-accel", (GCallback) _services_action_manager_enable_typing_accels_services_event_bus_connect_typing_accel, self, 0);
#line 115 "../src/Services/ActionManager.vala"
	_g_object_unref0 (_tmp28_);
#line 117 "../src/Services/ActionManager.vala"
	_tmp29_ = services_event_bus_get_default ();
#line 117 "../src/Services/ActionManager.vala"
	_tmp30_ = _tmp29_;
#line 117 "../src/Services/ActionManager.vala"
	g_signal_connect_object (_tmp30_, "disconnect-all-accels", (GCallback) _services_action_manager_disable_all_accel_services_event_bus_disconnect_all_accels, self, 0);
#line 117 "../src/Services/ActionManager.vala"
	_g_object_unref0 (_tmp30_);
#line 118 "../src/Services/ActionManager.vala"
	_tmp31_ = services_event_bus_get_default ();
#line 118 "../src/Services/ActionManager.vala"
	_tmp32_ = _tmp31_;
#line 118 "../src/Services/ActionManager.vala"
	g_signal_connect_object (_tmp32_, "connect-all-accels", (GCallback) _services_action_manager_enable_all_accel_services_event_bus_connect_all_accels, self, 0);
#line 118 "../src/Services/ActionManager.vala"
	_g_object_unref0 (_tmp32_);
#line 101 "../src/Services/ActionManager.vala"
	return obj;
#line 1929 "ActionManager.c"
}

static void
services_action_manager_class_init (ServicesActionManagerClass * klass,
                                    gpointer klass_data)
{
	GeeHashMultiMap* _tmp0_;
	GeeHashMultiMap* _tmp1_;
	GeeMultiMap* _tmp2_;
	GeeMultiMap* _tmp3_;
	GeeMultiMap* _tmp4_;
	GeeMultiMap* _tmp5_;
	GeeMultiMap* _tmp6_;
	GeeMultiMap* _tmp7_;
	GeeMultiMap* _tmp8_;
	GeeMultiMap* _tmp9_;
	GeeMultiMap* _tmp10_;
	GeeMultiMap* _tmp11_;
	GeeMultiMap* _tmp12_;
	GeeMultiMap* _tmp13_;
	GeeMultiMap* _tmp14_;
	GeeMultiMap* _tmp15_;
	GeeMultiMap* _tmp16_;
	GeeMultiMap* _tmp17_;
	GeeMultiMap* _tmp18_;
	GeeMultiMap* _tmp19_;
#line 22 "../src/Services/ActionManager.vala"
	services_action_manager_parent_class = g_type_class_peek_parent (klass);
#line 22 "../src/Services/ActionManager.vala"
	g_type_class_adjust_private_offset (klass, &ServicesActionManager_private_offset);
#line 22 "../src/Services/ActionManager.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_services_action_manager_get_property;
#line 22 "../src/Services/ActionManager.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_services_action_manager_set_property;
#line 22 "../src/Services/ActionManager.vala"
	G_OBJECT_CLASS (klass)->constructor = services_action_manager_constructor;
#line 22 "../src/Services/ActionManager.vala"
	G_OBJECT_CLASS (klass)->finalize = services_action_manager_finalize;
#line 22 "../src/Services/ActionManager.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SERVICES_ACTION_MANAGER_APP_PROPERTY, services_action_manager_properties[SERVICES_ACTION_MANAGER_APP_PROPERTY] = g_param_spec_object ("app", "app", "app", TYPE_PLANIFY, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 22 "../src/Services/ActionManager.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SERVICES_ACTION_MANAGER_WINDOW_PROPERTY, services_action_manager_properties[SERVICES_ACTION_MANAGER_WINDOW_PROPERTY] = g_param_spec_object ("window", "window", "window", TYPE_MAIN_WINDOW, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 22 "../src/Services/ActionManager.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SERVICES_ACTION_MANAGER_ACTIONS_PROPERTY, services_action_manager_properties[SERVICES_ACTION_MANAGER_ACTIONS_PROPERTY] = g_param_spec_object ("actions", "actions", "actions", g_simple_action_group_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 48 "../src/Services/ActionManager.vala"
	_tmp0_ = gee_hash_multi_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 48 "../src/Services/ActionManager.vala"
	services_action_manager_action_accelerators = (GeeMultiMap*) _tmp0_;
#line 49 "../src/Services/ActionManager.vala"
	_tmp1_ = gee_hash_multi_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 49 "../src/Services/ActionManager.vala"
	services_action_manager_typing_accelerators = (GeeMultiMap*) _tmp1_;
#line 80 "../src/Services/ActionManager.vala"
	_tmp2_ = services_action_manager_action_accelerators;
#line 80 "../src/Services/ActionManager.vala"
	gee_multi_map_set (_tmp2_, SERVICES_ACTION_MANAGER_ACTION_QUIT_Q, "<Control>q");
#line 81 "../src/Services/ActionManager.vala"
	_tmp3_ = services_action_manager_action_accelerators;
#line 81 "../src/Services/ActionManager.vala"
	gee_multi_map_set (_tmp3_, SERVICES_ACTION_MANAGER_ACTION_QUIT_W, "<Control>w");
#line 82 "../src/Services/ActionManager.vala"
	_tmp4_ = services_action_manager_action_accelerators;
#line 82 "../src/Services/ActionManager.vala"
	gee_multi_map_set (_tmp4_, SERVICES_ACTION_MANAGER_ACTION_PREFERENCES, "<Control>comma");
#line 83 "../src/Services/ActionManager.vala"
	_tmp5_ = services_action_manager_action_accelerators;
#line 83 "../src/Services/ActionManager.vala"
	gee_multi_map_set (_tmp5_, SERVICES_ACTION_MANAGER_ACTION_SHORTCUTS, "F1");
#line 84 "../src/Services/ActionManager.vala"
	_tmp6_ = services_action_manager_action_accelerators;
#line 84 "../src/Services/ActionManager.vala"
	gee_multi_map_set (_tmp6_, SERVICES_ACTION_MANAGER_ACTION_OPEN_SEARCH, "<Control>f");
#line 85 "../src/Services/ActionManager.vala"
	_tmp7_ = services_action_manager_action_accelerators;
#line 85 "../src/Services/ActionManager.vala"
	gee_multi_map_set (_tmp7_, SERVICES_ACTION_MANAGER_ACTION_SYNC_MANUALLY, "<Control>s");
#line 86 "../src/Services/ActionManager.vala"
	_tmp8_ = services_action_manager_action_accelerators;
#line 86 "../src/Services/ActionManager.vala"
	gee_multi_map_set (_tmp8_, SERVICES_ACTION_MANAGER_ACTION_VIEW_HOMEPAGE, "<Control>h");
#line 87 "../src/Services/ActionManager.vala"
	_tmp9_ = services_action_manager_action_accelerators;
#line 87 "../src/Services/ActionManager.vala"
	gee_multi_map_set (_tmp9_, SERVICES_ACTION_MANAGER_ACTION_VIEW_INBOX, "<Control>i");
#line 88 "../src/Services/ActionManager.vala"
	_tmp10_ = services_action_manager_action_accelerators;
#line 88 "../src/Services/ActionManager.vala"
	gee_multi_map_set (_tmp10_, SERVICES_ACTION_MANAGER_ACTION_VIEW_TODAY, "<Control>t");
#line 89 "../src/Services/ActionManager.vala"
	_tmp11_ = services_action_manager_action_accelerators;
#line 89 "../src/Services/ActionManager.vala"
	gee_multi_map_set (_tmp11_, SERVICES_ACTION_MANAGER_ACTION_VIEW_SCHEDULED, "<Control>u");
#line 90 "../src/Services/ActionManager.vala"
	_tmp12_ = services_action_manager_action_accelerators;
#line 90 "../src/Services/ActionManager.vala"
	gee_multi_map_set (_tmp12_, SERVICES_ACTION_MANAGER_ACTION_VIEW_LABELS, "<Control>l");
#line 91 "../src/Services/ActionManager.vala"
	_tmp13_ = services_action_manager_action_accelerators;
#line 91 "../src/Services/ActionManager.vala"
	gee_multi_map_set (_tmp13_, SERVICES_ACTION_MANAGER_ACTION_VIEW_PINBOARD, "<Control>p");
#line 93 "../src/Services/ActionManager.vala"
	_tmp14_ = services_action_manager_typing_accelerators;
#line 93 "../src/Services/ActionManager.vala"
	gee_multi_map_set (_tmp14_, SERVICES_ACTION_MANAGER_ACTION_ADD_TASK, "a");
#line 94 "../src/Services/ActionManager.vala"
	_tmp15_ = services_action_manager_typing_accelerators;
#line 94 "../src/Services/ActionManager.vala"
	gee_multi_map_set (_tmp15_, SERVICES_ACTION_MANAGER_ACTION_ADD_TASK_PASTE, "<Control>v");
#line 95 "../src/Services/ActionManager.vala"
	_tmp16_ = services_action_manager_typing_accelerators;
#line 95 "../src/Services/ActionManager.vala"
	gee_multi_map_set (_tmp16_, SERVICES_ACTION_MANAGER_ACTION_NEW_PROJECT, "p");
#line 96 "../src/Services/ActionManager.vala"
	_tmp17_ = services_action_manager_typing_accelerators;
#line 96 "../src/Services/ActionManager.vala"
	gee_multi_map_set (_tmp17_, SERVICES_ACTION_MANAGER_ACTION_NEW_SECTION, "s");
#line 97 "../src/Services/ActionManager.vala"
	_tmp18_ = services_action_manager_typing_accelerators;
#line 97 "../src/Services/ActionManager.vala"
	gee_multi_map_set (_tmp18_, SERVICES_ACTION_MANAGER_ACTION_VIEW_HOME, "h");
#line 98 "../src/Services/ActionManager.vala"
	_tmp19_ = services_action_manager_typing_accelerators;
#line 98 "../src/Services/ActionManager.vala"
	gee_multi_map_set (_tmp19_, SERVICES_ACTION_MANAGER_ACTION_SHOW_HIDE_SIDEBAR, "m");
#line 2054 "ActionManager.c"
}

static void
services_action_manager_instance_init (ServicesActionManager * self,
                                       gpointer klass)
{
#line 22 "../src/Services/ActionManager.vala"
	self->priv = services_action_manager_get_instance_private (self);
#line 2063 "ActionManager.c"
}

static void
services_action_manager_finalize (GObject * obj)
{
	ServicesActionManager * self;
#line 22 "../src/Services/ActionManager.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SERVICES_TYPE_ACTION_MANAGER, ServicesActionManager);
#line 23 "../src/Services/ActionManager.vala"
	_g_object_unref0 (self->priv->_app);
#line 24 "../src/Services/ActionManager.vala"
	_g_object_unref0 (self->priv->_window);
#line 26 "../src/Services/ActionManager.vala"
	_g_object_unref0 (self->priv->_actions);
#line 22 "../src/Services/ActionManager.vala"
	G_OBJECT_CLASS (services_action_manager_parent_class)->finalize (obj);
#line 2080 "ActionManager.c"
}

static GType
services_action_manager_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ServicesActionManagerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) services_action_manager_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ServicesActionManager), 0, (GInstanceInitFunc) services_action_manager_instance_init, NULL };
	GType services_action_manager_type_id;
	services_action_manager_type_id = g_type_register_static (G_TYPE_OBJECT, "ServicesActionManager", &g_define_type_info, 0);
	ServicesActionManager_private_offset = g_type_add_instance_private (services_action_manager_type_id, sizeof (ServicesActionManagerPrivate));
	return services_action_manager_type_id;
}

GType
services_action_manager_get_type (void)
{
	static volatile gsize services_action_manager_type_id__once = 0;
	if (g_once_init_enter (&services_action_manager_type_id__once)) {
		GType services_action_manager_type_id;
		services_action_manager_type_id = services_action_manager_get_type_once ();
		g_once_init_leave (&services_action_manager_type_id__once, services_action_manager_type_id);
	}
	return services_action_manager_type_id__once;
}

static void
_vala_services_action_manager_get_property (GObject * object,
                                            guint property_id,
                                            GValue * value,
                                            GParamSpec * pspec)
{
	ServicesActionManager * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, SERVICES_TYPE_ACTION_MANAGER, ServicesActionManager);
#line 22 "../src/Services/ActionManager.vala"
	switch (property_id) {
#line 22 "../src/Services/ActionManager.vala"
		case SERVICES_ACTION_MANAGER_APP_PROPERTY:
#line 22 "../src/Services/ActionManager.vala"
		g_value_set_object (value, services_action_manager_get_app (self));
#line 22 "../src/Services/ActionManager.vala"
		break;
#line 22 "../src/Services/ActionManager.vala"
		case SERVICES_ACTION_MANAGER_WINDOW_PROPERTY:
#line 22 "../src/Services/ActionManager.vala"
		g_value_set_object (value, services_action_manager_get_window (self));
#line 22 "../src/Services/ActionManager.vala"
		break;
#line 22 "../src/Services/ActionManager.vala"
		case SERVICES_ACTION_MANAGER_ACTIONS_PROPERTY:
#line 22 "../src/Services/ActionManager.vala"
		g_value_set_object (value, services_action_manager_get_actions (self));
#line 22 "../src/Services/ActionManager.vala"
		break;
#line 2133 "ActionManager.c"
		default:
#line 22 "../src/Services/ActionManager.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 22 "../src/Services/ActionManager.vala"
		break;
#line 2139 "ActionManager.c"
	}
}

static void
_vala_services_action_manager_set_property (GObject * object,
                                            guint property_id,
                                            const GValue * value,
                                            GParamSpec * pspec)
{
	ServicesActionManager * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, SERVICES_TYPE_ACTION_MANAGER, ServicesActionManager);
#line 22 "../src/Services/ActionManager.vala"
	switch (property_id) {
#line 22 "../src/Services/ActionManager.vala"
		case SERVICES_ACTION_MANAGER_APP_PROPERTY:
#line 22 "../src/Services/ActionManager.vala"
		services_action_manager_set_app (self, g_value_get_object (value));
#line 22 "../src/Services/ActionManager.vala"
		break;
#line 22 "../src/Services/ActionManager.vala"
		case SERVICES_ACTION_MANAGER_WINDOW_PROPERTY:
#line 22 "../src/Services/ActionManager.vala"
		services_action_manager_set_window (self, g_value_get_object (value));
#line 22 "../src/Services/ActionManager.vala"
		break;
#line 22 "../src/Services/ActionManager.vala"
		case SERVICES_ACTION_MANAGER_ACTIONS_PROPERTY:
#line 22 "../src/Services/ActionManager.vala"
		services_action_manager_set_actions (self, g_value_get_object (value));
#line 22 "../src/Services/ActionManager.vala"
		break;
#line 2171 "ActionManager.c"
		default:
#line 22 "../src/Services/ActionManager.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 22 "../src/Services/ActionManager.vala"
		break;
#line 2177 "ActionManager.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

