/* DateRange.c generated by valac 0.56.18, the Vala compiler
 * generated from DateRange.vala, do not modify */

/*
 * Copyright 2011-2019 elementary, Inc. (https://elementary.io)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA.
 *
 * Authored by: Corentin Noël <corentin@elementaryos.org>
 */
/* Represents date range from 'first' to 'last' inclusive */

#include <glib-object.h>
#include <gee.h>
#include <glib.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define CALENDAR_EVENTS_UTIL_TYPE_DATE_RANGE (calendar_events_util_date_range_get_type ())
#define CALENDAR_EVENTS_UTIL_DATE_RANGE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), CALENDAR_EVENTS_UTIL_TYPE_DATE_RANGE, CalendarEventsUtilDateRange))
#define CALENDAR_EVENTS_UTIL_DATE_RANGE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), CALENDAR_EVENTS_UTIL_TYPE_DATE_RANGE, CalendarEventsUtilDateRangeClass))
#define CALENDAR_EVENTS_UTIL_IS_DATE_RANGE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), CALENDAR_EVENTS_UTIL_TYPE_DATE_RANGE))
#define CALENDAR_EVENTS_UTIL_IS_DATE_RANGE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), CALENDAR_EVENTS_UTIL_TYPE_DATE_RANGE))
#define CALENDAR_EVENTS_UTIL_DATE_RANGE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), CALENDAR_EVENTS_UTIL_TYPE_DATE_RANGE, CalendarEventsUtilDateRangeClass))

typedef struct _CalendarEventsUtilDateRange CalendarEventsUtilDateRange;
typedef struct _CalendarEventsUtilDateRangeClass CalendarEventsUtilDateRangeClass;
typedef struct _CalendarEventsUtilDateRangePrivate CalendarEventsUtilDateRangePrivate;
enum  {
	CALENDAR_EVENTS_UTIL_DATE_RANGE_0_PROPERTY,
	CALENDAR_EVENTS_UTIL_DATE_RANGE_FIRST_DT_PROPERTY,
	CALENDAR_EVENTS_UTIL_DATE_RANGE_LAST_DT_PROPERTY,
	CALENDAR_EVENTS_UTIL_DATE_RANGE_NUM_PROPERTIES
};
static GParamSpec* calendar_events_util_date_range_properties[CALENDAR_EVENTS_UTIL_DATE_RANGE_NUM_PROPERTIES];
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define CALENDAR_EVENTS_UTIL_TYPE_DATE_ITERATOR (calendar_events_util_date_iterator_get_type ())
#define CALENDAR_EVENTS_UTIL_DATE_ITERATOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), CALENDAR_EVENTS_UTIL_TYPE_DATE_ITERATOR, CalendarEventsUtilDateIterator))
#define CALENDAR_EVENTS_UTIL_DATE_ITERATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), CALENDAR_EVENTS_UTIL_TYPE_DATE_ITERATOR, CalendarEventsUtilDateIteratorClass))
#define CALENDAR_EVENTS_UTIL_IS_DATE_ITERATOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), CALENDAR_EVENTS_UTIL_TYPE_DATE_ITERATOR))
#define CALENDAR_EVENTS_UTIL_IS_DATE_ITERATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), CALENDAR_EVENTS_UTIL_TYPE_DATE_ITERATOR))
#define CALENDAR_EVENTS_UTIL_DATE_ITERATOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), CALENDAR_EVENTS_UTIL_TYPE_DATE_ITERATOR, CalendarEventsUtilDateIteratorClass))

typedef struct _CalendarEventsUtilDateIterator CalendarEventsUtilDateIterator;
typedef struct _CalendarEventsUtilDateIteratorClass CalendarEventsUtilDateIteratorClass;

struct _CalendarEventsUtilDateRange {
	GObject parent_instance;
	CalendarEventsUtilDateRangePrivate * priv;
};

struct _CalendarEventsUtilDateRangeClass {
	GObjectClass parent_class;
};

struct _CalendarEventsUtilDateRangePrivate {
	GDateTime* _first_dt;
	GDateTime* _last_dt;
};

static gint CalendarEventsUtilDateRange_private_offset;
static gpointer calendar_events_util_date_range_parent_class = NULL;
static GeeTraversableIface * calendar_events_util_date_range_gee_traversable_parent_iface = NULL;
static GeeIterableIface * calendar_events_util_date_range_gee_iterable_parent_iface = NULL;

VALA_EXTERN GType calendar_events_util_date_range_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (CalendarEventsUtilDateRange, g_object_unref)
static gboolean calendar_events_util_date_range_real_foreach (GeeTraversable* base,
                                                       GeeForallFunc f,
                                                       gpointer f_target);
VALA_EXTERN CalendarEventsUtilDateRange* calendar_events_util_date_range_new (GDateTime* first,
                                                                  GDateTime* last);
VALA_EXTERN CalendarEventsUtilDateRange* calendar_events_util_date_range_construct (GType object_type,
                                                                        GDateTime* first,
                                                                        GDateTime* last);
VALA_EXTERN gboolean calendar_events_util_date_range_equals (CalendarEventsUtilDateRange* self,
                                                 CalendarEventsUtilDateRange* other);
VALA_EXTERN GDateTime* calendar_events_util_date_range_get_first_dt (CalendarEventsUtilDateRange* self);
VALA_EXTERN GDateTime* calendar_events_util_date_range_get_last_dt (CalendarEventsUtilDateRange* self);
static GeeIterator* calendar_events_util_date_range_real_iterator (GeeIterable* base);
VALA_EXTERN CalendarEventsUtilDateIterator* calendar_events_util_date_iterator_new (CalendarEventsUtilDateRange* range);
VALA_EXTERN CalendarEventsUtilDateIterator* calendar_events_util_date_iterator_construct (GType object_type,
                                                                              CalendarEventsUtilDateRange* range);
VALA_EXTERN GType calendar_events_util_date_iterator_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (CalendarEventsUtilDateIterator, g_object_unref)
VALA_EXTERN GeeList* calendar_events_util_date_range_to_list (CalendarEventsUtilDateRange* self);
static gboolean calendar_events_util_date_range_datetime_equal_func (CalendarEventsUtilDateRange* self,
                                                              GDateTime* a,
                                                              GDateTime* b);
static void calendar_events_util_date_range_set_first_dt (CalendarEventsUtilDateRange* self,
                                                   GDateTime* value);
static void calendar_events_util_date_range_set_last_dt (CalendarEventsUtilDateRange* self,
                                                  GDateTime* value);
static void calendar_events_util_date_range_finalize (GObject * obj);
static GType calendar_events_util_date_range_get_type_once (void);
static void _vala_calendar_events_util_date_range_get_property (GObject * object,
                                                         guint property_id,
                                                         GValue * value,
                                                         GParamSpec * pspec);
static void _vala_calendar_events_util_date_range_set_property (GObject * object,
                                                         guint property_id,
                                                         const GValue * value,
                                                         GParamSpec * pspec);

static inline gpointer
calendar_events_util_date_range_get_instance_private (CalendarEventsUtilDateRange* self)
{
	return G_STRUCT_MEMBER_P (self, CalendarEventsUtilDateRange_private_offset);
}

static gpointer
_g_date_time_ref0 (gpointer self)
{
#line 29 "../src/Services/CalendarEvents/DateRange.vala"
	return self ? g_date_time_ref (self) : NULL;
#line 148 "DateRange.c"
}

static gboolean
calendar_events_util_date_range_real_foreach (GeeTraversable* base,
                                              GeeForallFunc f,
                                              gpointer f_target)
{
	CalendarEventsUtilDateRange * self;
	gboolean result;
#line 27 "../src/Services/CalendarEvents/DateRange.vala"
	self = (CalendarEventsUtilDateRange*) base;
#line 160 "DateRange.c"
	{
		GeeIterator* _date_it = NULL;
		GeeIterator* _tmp0_;
#line 28 "../src/Services/CalendarEvents/DateRange.vala"
		_tmp0_ = gee_iterable_iterator ((GeeIterable*) self);
#line 28 "../src/Services/CalendarEvents/DateRange.vala"
		_date_it = _tmp0_;
#line 28 "../src/Services/CalendarEvents/DateRange.vala"
		while (TRUE) {
#line 170 "DateRange.c"
			GeeIterator* _tmp1_;
			GDateTime* date = NULL;
			GeeIterator* _tmp2_;
			gpointer _tmp3_;
			GDateTime* _tmp4_;
			GDateTime* _tmp5_;
#line 28 "../src/Services/CalendarEvents/DateRange.vala"
			_tmp1_ = _date_it;
#line 28 "../src/Services/CalendarEvents/DateRange.vala"
			if (!gee_iterator_next (_tmp1_)) {
#line 28 "../src/Services/CalendarEvents/DateRange.vala"
				break;
#line 183 "DateRange.c"
			}
#line 28 "../src/Services/CalendarEvents/DateRange.vala"
			_tmp2_ = _date_it;
#line 28 "../src/Services/CalendarEvents/DateRange.vala"
			_tmp3_ = gee_iterator_get (_tmp2_);
#line 28 "../src/Services/CalendarEvents/DateRange.vala"
			date = (GDateTime*) _tmp3_;
#line 29 "../src/Services/CalendarEvents/DateRange.vala"
			_tmp4_ = date;
#line 29 "../src/Services/CalendarEvents/DateRange.vala"
			_tmp5_ = _g_date_time_ref0 (_tmp4_);
#line 29 "../src/Services/CalendarEvents/DateRange.vala"
			if (f (_tmp5_, f_target) == FALSE) {
#line 30 "../src/Services/CalendarEvents/DateRange.vala"
				result = FALSE;
#line 30 "../src/Services/CalendarEvents/DateRange.vala"
				_g_date_time_unref0 (date);
#line 30 "../src/Services/CalendarEvents/DateRange.vala"
				_g_object_unref0 (_date_it);
#line 30 "../src/Services/CalendarEvents/DateRange.vala"
				return result;
#line 205 "DateRange.c"
			}
#line 28 "../src/Services/CalendarEvents/DateRange.vala"
			_g_date_time_unref0 (date);
#line 209 "DateRange.c"
		}
#line 28 "../src/Services/CalendarEvents/DateRange.vala"
		_g_object_unref0 (_date_it);
#line 213 "DateRange.c"
	}
#line 34 "../src/Services/CalendarEvents/DateRange.vala"
	result = TRUE;
#line 34 "../src/Services/CalendarEvents/DateRange.vala"
	return result;
#line 219 "DateRange.c"
}

CalendarEventsUtilDateRange*
calendar_events_util_date_range_construct (GType object_type,
                                           GDateTime* first,
                                           GDateTime* last)
{
	CalendarEventsUtilDateRange * self = NULL;
#line 37 "../src/Services/CalendarEvents/DateRange.vala"
	g_return_val_if_fail (first != NULL, NULL);
#line 37 "../src/Services/CalendarEvents/DateRange.vala"
	g_return_val_if_fail (last != NULL, NULL);
#line 38 "../src/Services/CalendarEvents/DateRange.vala"
	self = (CalendarEventsUtilDateRange*) g_object_new (object_type, "first-dt", first, "last-dt", last, NULL);
#line 37 "../src/Services/CalendarEvents/DateRange.vala"
	return self;
#line 236 "DateRange.c"
}

CalendarEventsUtilDateRange*
calendar_events_util_date_range_new (GDateTime* first,
                                     GDateTime* last)
{
#line 37 "../src/Services/CalendarEvents/DateRange.vala"
	return calendar_events_util_date_range_construct (CALENDAR_EVENTS_UTIL_TYPE_DATE_RANGE, first, last);
#line 245 "DateRange.c"
}

gboolean
calendar_events_util_date_range_equals (CalendarEventsUtilDateRange* self,
                                        CalendarEventsUtilDateRange* other)
{
	gboolean _tmp0_ = FALSE;
	GDateTime* _tmp1_;
	GDateTime* _tmp2_;
	gboolean result;
#line 44 "../src/Services/CalendarEvents/DateRange.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 44 "../src/Services/CalendarEvents/DateRange.vala"
	g_return_val_if_fail (other != NULL, FALSE);
#line 45 "../src/Services/CalendarEvents/DateRange.vala"
	_tmp1_ = self->priv->_first_dt;
#line 45 "../src/Services/CalendarEvents/DateRange.vala"
	_tmp2_ = other->priv->_first_dt;
#line 45 "../src/Services/CalendarEvents/DateRange.vala"
	if (_tmp1_ == _tmp2_) {
#line 266 "DateRange.c"
		GDateTime* _tmp3_;
		GDateTime* _tmp4_;
#line 45 "../src/Services/CalendarEvents/DateRange.vala"
		_tmp3_ = self->priv->_last_dt;
#line 45 "../src/Services/CalendarEvents/DateRange.vala"
		_tmp4_ = other->priv->_last_dt;
#line 45 "../src/Services/CalendarEvents/DateRange.vala"
		_tmp0_ = _tmp3_ == _tmp4_;
#line 275 "DateRange.c"
	} else {
#line 45 "../src/Services/CalendarEvents/DateRange.vala"
		_tmp0_ = FALSE;
#line 279 "DateRange.c"
	}
#line 45 "../src/Services/CalendarEvents/DateRange.vala"
	result = _tmp0_;
#line 45 "../src/Services/CalendarEvents/DateRange.vala"
	return result;
#line 285 "DateRange.c"
}

static GeeIterator*
calendar_events_util_date_range_real_iterator (GeeIterable* base)
{
	CalendarEventsUtilDateRange * self;
	CalendarEventsUtilDateIterator* _tmp0_;
	GeeIterator* result;
#line 48 "../src/Services/CalendarEvents/DateRange.vala"
	self = (CalendarEventsUtilDateRange*) base;
#line 49 "../src/Services/CalendarEvents/DateRange.vala"
	_tmp0_ = calendar_events_util_date_iterator_new (self);
#line 49 "../src/Services/CalendarEvents/DateRange.vala"
	result = (GeeIterator*) _tmp0_;
#line 49 "../src/Services/CalendarEvents/DateRange.vala"
	return result;
#line 302 "DateRange.c"
}

GeeList*
calendar_events_util_date_range_to_list (CalendarEventsUtilDateRange* self)
{
	GeeArrayList* list = NULL;
	GeeArrayList* _tmp0_;
	GeeList* result;
#line 52 "../src/Services/CalendarEvents/DateRange.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 53 "../src/Services/CalendarEvents/DateRange.vala"
	_tmp0_ = gee_array_list_new (G_TYPE_DATE_TIME, (GBoxedCopyFunc) g_date_time_ref, (GDestroyNotify) g_date_time_unref, (GeeEqualDataFunc) calendar_events_util_date_range_datetime_equal_func, g_object_ref (self), g_object_unref);
#line 53 "../src/Services/CalendarEvents/DateRange.vala"
	list = _tmp0_;
#line 317 "DateRange.c"
	{
		GeeIterator* _date_it = NULL;
		GeeIterator* _tmp1_;
#line 55 "../src/Services/CalendarEvents/DateRange.vala"
		_tmp1_ = gee_iterable_iterator ((GeeIterable*) self);
#line 55 "../src/Services/CalendarEvents/DateRange.vala"
		_date_it = _tmp1_;
#line 55 "../src/Services/CalendarEvents/DateRange.vala"
		while (TRUE) {
#line 327 "DateRange.c"
			GeeIterator* _tmp2_;
			GDateTime* date = NULL;
			GeeIterator* _tmp3_;
			gpointer _tmp4_;
			GeeArrayList* _tmp5_;
			GDateTime* _tmp6_;
#line 55 "../src/Services/CalendarEvents/DateRange.vala"
			_tmp2_ = _date_it;
#line 55 "../src/Services/CalendarEvents/DateRange.vala"
			if (!gee_iterator_next (_tmp2_)) {
#line 55 "../src/Services/CalendarEvents/DateRange.vala"
				break;
#line 340 "DateRange.c"
			}
#line 55 "../src/Services/CalendarEvents/DateRange.vala"
			_tmp3_ = _date_it;
#line 55 "../src/Services/CalendarEvents/DateRange.vala"
			_tmp4_ = gee_iterator_get (_tmp3_);
#line 55 "../src/Services/CalendarEvents/DateRange.vala"
			date = (GDateTime*) _tmp4_;
#line 56 "../src/Services/CalendarEvents/DateRange.vala"
			_tmp5_ = list;
#line 56 "../src/Services/CalendarEvents/DateRange.vala"
			_tmp6_ = date;
#line 56 "../src/Services/CalendarEvents/DateRange.vala"
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp5_, _tmp6_);
#line 55 "../src/Services/CalendarEvents/DateRange.vala"
			_g_date_time_unref0 (date);
#line 356 "DateRange.c"
		}
#line 55 "../src/Services/CalendarEvents/DateRange.vala"
		_g_object_unref0 (_date_it);
#line 360 "DateRange.c"
	}
#line 59 "../src/Services/CalendarEvents/DateRange.vala"
	result = (GeeList*) list;
#line 59 "../src/Services/CalendarEvents/DateRange.vala"
	return result;
#line 366 "DateRange.c"
}

static gboolean
calendar_events_util_date_range_datetime_equal_func (CalendarEventsUtilDateRange* self,
                                                     GDateTime* a,
                                                     GDateTime* b)
{
	gboolean result;
#line 63 "../src/Services/CalendarEvents/DateRange.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 63 "../src/Services/CalendarEvents/DateRange.vala"
	g_return_val_if_fail (a != NULL, FALSE);
#line 63 "../src/Services/CalendarEvents/DateRange.vala"
	g_return_val_if_fail (b != NULL, FALSE);
#line 64 "../src/Services/CalendarEvents/DateRange.vala"
	result = g_date_time_equal (a, b);
#line 64 "../src/Services/CalendarEvents/DateRange.vala"
	return result;
#line 385 "DateRange.c"
}

GDateTime*
calendar_events_util_date_range_get_first_dt (CalendarEventsUtilDateRange* self)
{
	GDateTime* result;
	GDateTime* _tmp0_;
#line 24 "../src/Services/CalendarEvents/DateRange.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 24 "../src/Services/CalendarEvents/DateRange.vala"
	_tmp0_ = self->priv->_first_dt;
#line 24 "../src/Services/CalendarEvents/DateRange.vala"
	result = _tmp0_;
#line 24 "../src/Services/CalendarEvents/DateRange.vala"
	return result;
#line 401 "DateRange.c"
}

static void
calendar_events_util_date_range_set_first_dt (CalendarEventsUtilDateRange* self,
                                              GDateTime* value)
{
	GDateTime* old_value;
#line 24 "../src/Services/CalendarEvents/DateRange.vala"
	g_return_if_fail (self != NULL);
#line 24 "../src/Services/CalendarEvents/DateRange.vala"
	old_value = calendar_events_util_date_range_get_first_dt (self);
#line 24 "../src/Services/CalendarEvents/DateRange.vala"
	if (old_value != value) {
#line 415 "DateRange.c"
		GDateTime* _tmp0_;
#line 24 "../src/Services/CalendarEvents/DateRange.vala"
		_tmp0_ = _g_date_time_ref0 (value);
#line 24 "../src/Services/CalendarEvents/DateRange.vala"
		_g_date_time_unref0 (self->priv->_first_dt);
#line 24 "../src/Services/CalendarEvents/DateRange.vala"
		self->priv->_first_dt = _tmp0_;
#line 24 "../src/Services/CalendarEvents/DateRange.vala"
		g_object_notify_by_pspec ((GObject *) self, calendar_events_util_date_range_properties[CALENDAR_EVENTS_UTIL_DATE_RANGE_FIRST_DT_PROPERTY]);
#line 425 "DateRange.c"
	}
}

GDateTime*
calendar_events_util_date_range_get_last_dt (CalendarEventsUtilDateRange* self)
{
	GDateTime* result;
	GDateTime* _tmp0_;
#line 25 "../src/Services/CalendarEvents/DateRange.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 25 "../src/Services/CalendarEvents/DateRange.vala"
	_tmp0_ = self->priv->_last_dt;
#line 25 "../src/Services/CalendarEvents/DateRange.vala"
	result = _tmp0_;
#line 25 "../src/Services/CalendarEvents/DateRange.vala"
	return result;
#line 442 "DateRange.c"
}

static void
calendar_events_util_date_range_set_last_dt (CalendarEventsUtilDateRange* self,
                                             GDateTime* value)
{
	GDateTime* old_value;
#line 25 "../src/Services/CalendarEvents/DateRange.vala"
	g_return_if_fail (self != NULL);
#line 25 "../src/Services/CalendarEvents/DateRange.vala"
	old_value = calendar_events_util_date_range_get_last_dt (self);
#line 25 "../src/Services/CalendarEvents/DateRange.vala"
	if (old_value != value) {
#line 456 "DateRange.c"
		GDateTime* _tmp0_;
#line 25 "../src/Services/CalendarEvents/DateRange.vala"
		_tmp0_ = _g_date_time_ref0 (value);
#line 25 "../src/Services/CalendarEvents/DateRange.vala"
		_g_date_time_unref0 (self->priv->_last_dt);
#line 25 "../src/Services/CalendarEvents/DateRange.vala"
		self->priv->_last_dt = _tmp0_;
#line 25 "../src/Services/CalendarEvents/DateRange.vala"
		g_object_notify_by_pspec ((GObject *) self, calendar_events_util_date_range_properties[CALENDAR_EVENTS_UTIL_DATE_RANGE_LAST_DT_PROPERTY]);
#line 466 "DateRange.c"
	}
}

static void
calendar_events_util_date_range_class_init (CalendarEventsUtilDateRangeClass * klass,
                                            gpointer klass_data)
{
#line 23 "../src/Services/CalendarEvents/DateRange.vala"
	calendar_events_util_date_range_parent_class = g_type_class_peek_parent (klass);
#line 23 "../src/Services/CalendarEvents/DateRange.vala"
	g_type_class_adjust_private_offset (klass, &CalendarEventsUtilDateRange_private_offset);
#line 23 "../src/Services/CalendarEvents/DateRange.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_calendar_events_util_date_range_get_property;
#line 23 "../src/Services/CalendarEvents/DateRange.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_calendar_events_util_date_range_set_property;
#line 23 "../src/Services/CalendarEvents/DateRange.vala"
	G_OBJECT_CLASS (klass)->finalize = calendar_events_util_date_range_finalize;
#line 23 "../src/Services/CalendarEvents/DateRange.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CALENDAR_EVENTS_UTIL_DATE_RANGE_FIRST_DT_PROPERTY, calendar_events_util_date_range_properties[CALENDAR_EVENTS_UTIL_DATE_RANGE_FIRST_DT_PROPERTY] = g_param_spec_boxed ("first-dt", "first-dt", "first-dt", G_TYPE_DATE_TIME, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 23 "../src/Services/CalendarEvents/DateRange.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CALENDAR_EVENTS_UTIL_DATE_RANGE_LAST_DT_PROPERTY, calendar_events_util_date_range_properties[CALENDAR_EVENTS_UTIL_DATE_RANGE_LAST_DT_PROPERTY] = g_param_spec_boxed ("last-dt", "last-dt", "last-dt", G_TYPE_DATE_TIME, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 488 "DateRange.c"
}

static GType
calendar_events_util_date_range_gee_traversable_get_g_type (CalendarEventsUtilDateRange* self)
{
#line 23 "../src/Services/CalendarEvents/DateRange.vala"
	return (GType) G_TYPE_DATE_TIME;
#line 496 "DateRange.c"
}

static GBoxedCopyFunc
calendar_events_util_date_range_gee_traversable_get_g_dup_func (CalendarEventsUtilDateRange* self)
{
#line 23 "../src/Services/CalendarEvents/DateRange.vala"
	return (GBoxedCopyFunc) g_date_time_ref;
#line 504 "DateRange.c"
}

static GDestroyNotify
calendar_events_util_date_range_gee_traversable_get_g_destroy_func (CalendarEventsUtilDateRange* self)
{
#line 23 "../src/Services/CalendarEvents/DateRange.vala"
	return (GDestroyNotify) g_date_time_unref;
#line 512 "DateRange.c"
}

static void
calendar_events_util_date_range_gee_traversable_interface_init (GeeTraversableIface * iface,
                                                                gpointer iface_data)
{
#line 23 "../src/Services/CalendarEvents/DateRange.vala"
	calendar_events_util_date_range_gee_traversable_parent_iface = g_type_interface_peek_parent (iface);
#line 23 "../src/Services/CalendarEvents/DateRange.vala"
	iface->foreach = (gboolean (*) (GeeTraversable*, GeeForallFunc, gpointer)) calendar_events_util_date_range_real_foreach;
#line 23 "../src/Services/CalendarEvents/DateRange.vala"
	iface->get_g_type = (GType (*) (GeeTraversable *)) calendar_events_util_date_range_gee_traversable_get_g_type;
#line 23 "../src/Services/CalendarEvents/DateRange.vala"
	iface->get_g_dup_func = (GBoxedCopyFunc (*) (GeeTraversable *)) calendar_events_util_date_range_gee_traversable_get_g_dup_func;
#line 23 "../src/Services/CalendarEvents/DateRange.vala"
	iface->get_g_destroy_func = (GDestroyNotify (*) (GeeTraversable *)) calendar_events_util_date_range_gee_traversable_get_g_destroy_func;
#line 529 "DateRange.c"
}

static GType
calendar_events_util_date_range_gee_iterable_get_g_type (CalendarEventsUtilDateRange* self)
{
#line 23 "../src/Services/CalendarEvents/DateRange.vala"
	return (GType) G_TYPE_DATE_TIME;
#line 537 "DateRange.c"
}

static GBoxedCopyFunc
calendar_events_util_date_range_gee_iterable_get_g_dup_func (CalendarEventsUtilDateRange* self)
{
#line 23 "../src/Services/CalendarEvents/DateRange.vala"
	return (GBoxedCopyFunc) g_date_time_ref;
#line 545 "DateRange.c"
}

static GDestroyNotify
calendar_events_util_date_range_gee_iterable_get_g_destroy_func (CalendarEventsUtilDateRange* self)
{
#line 23 "../src/Services/CalendarEvents/DateRange.vala"
	return (GDestroyNotify) g_date_time_unref;
#line 553 "DateRange.c"
}

static void
calendar_events_util_date_range_gee_iterable_interface_init (GeeIterableIface * iface,
                                                             gpointer iface_data)
{
#line 23 "../src/Services/CalendarEvents/DateRange.vala"
	calendar_events_util_date_range_gee_iterable_parent_iface = g_type_interface_peek_parent (iface);
#line 23 "../src/Services/CalendarEvents/DateRange.vala"
	iface->iterator = (GeeIterator* (*) (GeeIterable*)) calendar_events_util_date_range_real_iterator;
#line 23 "../src/Services/CalendarEvents/DateRange.vala"
	iface->get_g_type = (GType (*) (GeeIterable *)) calendar_events_util_date_range_gee_iterable_get_g_type;
#line 23 "../src/Services/CalendarEvents/DateRange.vala"
	iface->get_g_dup_func = (GBoxedCopyFunc (*) (GeeIterable *)) calendar_events_util_date_range_gee_iterable_get_g_dup_func;
#line 23 "../src/Services/CalendarEvents/DateRange.vala"
	iface->get_g_destroy_func = (GDestroyNotify (*) (GeeIterable *)) calendar_events_util_date_range_gee_iterable_get_g_destroy_func;
#line 570 "DateRange.c"
}

static void
calendar_events_util_date_range_instance_init (CalendarEventsUtilDateRange * self,
                                               gpointer klass)
{
#line 23 "../src/Services/CalendarEvents/DateRange.vala"
	self->priv = calendar_events_util_date_range_get_instance_private (self);
#line 579 "DateRange.c"
}

static void
calendar_events_util_date_range_finalize (GObject * obj)
{
	CalendarEventsUtilDateRange * self;
#line 23 "../src/Services/CalendarEvents/DateRange.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, CALENDAR_EVENTS_UTIL_TYPE_DATE_RANGE, CalendarEventsUtilDateRange);
#line 24 "../src/Services/CalendarEvents/DateRange.vala"
	_g_date_time_unref0 (self->priv->_first_dt);
#line 25 "../src/Services/CalendarEvents/DateRange.vala"
	_g_date_time_unref0 (self->priv->_last_dt);
#line 23 "../src/Services/CalendarEvents/DateRange.vala"
	G_OBJECT_CLASS (calendar_events_util_date_range_parent_class)->finalize (obj);
#line 594 "DateRange.c"
}

static GType
calendar_events_util_date_range_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (CalendarEventsUtilDateRangeClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) calendar_events_util_date_range_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (CalendarEventsUtilDateRange), 0, (GInstanceInitFunc) calendar_events_util_date_range_instance_init, NULL };
	static const GInterfaceInfo gee_traversable_info = { (GInterfaceInitFunc) calendar_events_util_date_range_gee_traversable_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	static const GInterfaceInfo gee_iterable_info = { (GInterfaceInitFunc) calendar_events_util_date_range_gee_iterable_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType calendar_events_util_date_range_type_id;
	calendar_events_util_date_range_type_id = g_type_register_static (G_TYPE_OBJECT, "CalendarEventsUtilDateRange", &g_define_type_info, 0);
	g_type_add_interface_static (calendar_events_util_date_range_type_id, GEE_TYPE_TRAVERSABLE, &gee_traversable_info);
	g_type_add_interface_static (calendar_events_util_date_range_type_id, GEE_TYPE_ITERABLE, &gee_iterable_info);
	CalendarEventsUtilDateRange_private_offset = g_type_add_instance_private (calendar_events_util_date_range_type_id, sizeof (CalendarEventsUtilDateRangePrivate));
	return calendar_events_util_date_range_type_id;
}

GType
calendar_events_util_date_range_get_type (void)
{
	static volatile gsize calendar_events_util_date_range_type_id__once = 0;
	if (g_once_init_enter (&calendar_events_util_date_range_type_id__once)) {
		GType calendar_events_util_date_range_type_id;
		calendar_events_util_date_range_type_id = calendar_events_util_date_range_get_type_once ();
		g_once_init_leave (&calendar_events_util_date_range_type_id__once, calendar_events_util_date_range_type_id);
	}
	return calendar_events_util_date_range_type_id__once;
}

static void
_vala_calendar_events_util_date_range_get_property (GObject * object,
                                                    guint property_id,
                                                    GValue * value,
                                                    GParamSpec * pspec)
{
	CalendarEventsUtilDateRange * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, CALENDAR_EVENTS_UTIL_TYPE_DATE_RANGE, CalendarEventsUtilDateRange);
#line 23 "../src/Services/CalendarEvents/DateRange.vala"
	switch (property_id) {
#line 23 "../src/Services/CalendarEvents/DateRange.vala"
		case CALENDAR_EVENTS_UTIL_DATE_RANGE_FIRST_DT_PROPERTY:
#line 23 "../src/Services/CalendarEvents/DateRange.vala"
		g_value_set_boxed (value, calendar_events_util_date_range_get_first_dt (self));
#line 23 "../src/Services/CalendarEvents/DateRange.vala"
		break;
#line 23 "../src/Services/CalendarEvents/DateRange.vala"
		case CALENDAR_EVENTS_UTIL_DATE_RANGE_LAST_DT_PROPERTY:
#line 23 "../src/Services/CalendarEvents/DateRange.vala"
		g_value_set_boxed (value, calendar_events_util_date_range_get_last_dt (self));
#line 23 "../src/Services/CalendarEvents/DateRange.vala"
		break;
#line 645 "DateRange.c"
		default:
#line 23 "../src/Services/CalendarEvents/DateRange.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 23 "../src/Services/CalendarEvents/DateRange.vala"
		break;
#line 651 "DateRange.c"
	}
}

static void
_vala_calendar_events_util_date_range_set_property (GObject * object,
                                                    guint property_id,
                                                    const GValue * value,
                                                    GParamSpec * pspec)
{
	CalendarEventsUtilDateRange * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, CALENDAR_EVENTS_UTIL_TYPE_DATE_RANGE, CalendarEventsUtilDateRange);
#line 23 "../src/Services/CalendarEvents/DateRange.vala"
	switch (property_id) {
#line 23 "../src/Services/CalendarEvents/DateRange.vala"
		case CALENDAR_EVENTS_UTIL_DATE_RANGE_FIRST_DT_PROPERTY:
#line 23 "../src/Services/CalendarEvents/DateRange.vala"
		calendar_events_util_date_range_set_first_dt (self, g_value_get_boxed (value));
#line 23 "../src/Services/CalendarEvents/DateRange.vala"
		break;
#line 23 "../src/Services/CalendarEvents/DateRange.vala"
		case CALENDAR_EVENTS_UTIL_DATE_RANGE_LAST_DT_PROPERTY:
#line 23 "../src/Services/CalendarEvents/DateRange.vala"
		calendar_events_util_date_range_set_last_dt (self, g_value_get_boxed (value));
#line 23 "../src/Services/CalendarEvents/DateRange.vala"
		break;
#line 677 "DateRange.c"
		default:
#line 23 "../src/Services/CalendarEvents/DateRange.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 23 "../src/Services/CalendarEvents/DateRange.vala"
		break;
#line 683 "DateRange.c"
	}
}

