/* Util.c generated by valac 0.56.18, the Vala compiler
 * generated from Util.vala, do not modify */

/*
 * Copyright 2011-2019 elementary, Inc. (https://elementary.io)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA.
 *
 * Authored by: Corentin Noël <corentin@elementaryos.org>
 */

#include <glib.h>
#include <float.h>
#include <math.h>
#include <libical-glib/libical-glib.h>
#include <stdlib.h>
#include <string.h>
#include <libedataserver/libedataserver.h>
#include <libecal/libecal.h>
#include <time.h>
#include <glib-object.h>
#include <glib/gi18n-lib.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))
#define _g_time_zone_unref0(var) ((var == NULL) ? NULL : (var = (g_time_zone_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define __vala_ECalComponentId_free0(var) ((var == NULL) ? NULL : (var = (_vala_ECalComponentId_free (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define SERVICES_TYPE_CALENDAR_EVENTS (services_calendar_events_get_type ())
#define SERVICES_CALENDAR_EVENTS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), SERVICES_TYPE_CALENDAR_EVENTS, ServicesCalendarEvents))
#define SERVICES_CALENDAR_EVENTS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), SERVICES_TYPE_CALENDAR_EVENTS, ServicesCalendarEventsClass))
#define SERVICES_IS_CALENDAR_EVENTS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), SERVICES_TYPE_CALENDAR_EVENTS))
#define SERVICES_IS_CALENDAR_EVENTS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), SERVICES_TYPE_CALENDAR_EVENTS))
#define SERVICES_CALENDAR_EVENTS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), SERVICES_TYPE_CALENDAR_EVENTS, ServicesCalendarEventsClass))

typedef struct _ServicesCalendarEvents ServicesCalendarEvents;
typedef struct _ServicesCalendarEventsClass ServicesCalendarEventsClass;
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

VALA_EXTERN GDateTime* calendar_events_util_get_start_of_month (GDateTime* date);
VALA_EXTERN GDateTime* calendar_events_util_strip_time (GDateTime* datetime);
VALA_EXTERN GTimeZone* calendar_events_util_timezone_from_ical (ICalTime* date);
VALA_EXTERN GDateTime* calendar_events_util_ical_to_date_time (ICalTime* date);
VALA_EXTERN gboolean calendar_events_util_is_the_all_day (GDateTime* dtstart,
                                              GDateTime* dtend);
VALA_EXTERN guint calendar_events_util_source_hash_func (ESource* key);
VALA_EXTERN gboolean calendar_events_util_calcomponent_equal_func (ECalComponent* a,
                                                       ECalComponent* b);
static void _vala_ECalComponentId_free (ECalComponentId* self);
VALA_EXTERN gint calendar_events_util_calcomponent_compare_func (ECalComponent* a,
                                                     ECalComponent* b);
VALA_EXTERN gboolean calendar_events_util_calcomp_is_on_day (ECalComponent* comp,
                                                 GDateTime* day);
VALA_EXTERN gboolean calendar_events_util_calcomp_is_on_month (ECalComponent* comp,
                                                   GDateTime* date);
VALA_EXTERN gboolean calendar_events_util_source_equal_func (ESource* a,
                                                 ESource* b);
VALA_EXTERN gchar* calendar_events_util_get_source_location (ESource* source);
VALA_EXTERN GType services_calendar_events_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ServicesCalendarEvents, g_object_unref)
VALA_EXTERN ServicesCalendarEvents* services_calendar_events_get_default (void);
VALA_EXTERN ESourceRegistry* services_calendar_events_get_registry (ServicesCalendarEvents* self);

GDateTime*
calendar_events_util_get_start_of_month (GDateTime* date)
{
	GDateTime* _tmp1_;
	GDateTime* result;
#line 24 "../src/Services/CalendarEvents/Util.vala"
	if (date == NULL) {
#line 108 "Util.c"
		GDateTime* _tmp0_;
#line 25 "../src/Services/CalendarEvents/Util.vala"
		_tmp0_ = g_date_time_new_now_local ();
#line 25 "../src/Services/CalendarEvents/Util.vala"
		_g_date_time_unref0 (date);
#line 25 "../src/Services/CalendarEvents/Util.vala"
		date = _tmp0_;
#line 116 "Util.c"
	}
#line 28 "../src/Services/CalendarEvents/Util.vala"
	_tmp1_ = g_date_time_new_local (g_date_time_get_year (date), g_date_time_get_month (date), 1, 0, 0, (gdouble) 0);
#line 28 "../src/Services/CalendarEvents/Util.vala"
	result = _tmp1_;
#line 28 "../src/Services/CalendarEvents/Util.vala"
	_g_date_time_unref0 (date);
#line 28 "../src/Services/CalendarEvents/Util.vala"
	return result;
#line 126 "Util.c"
}

GDateTime*
calendar_events_util_strip_time (GDateTime* datetime)
{
	GDateTime* _tmp0_;
	GDateTime* result;
#line 31 "../src/Services/CalendarEvents/Util.vala"
	g_return_val_if_fail (datetime != NULL, NULL);
#line 32 "../src/Services/CalendarEvents/Util.vala"
	_tmp0_ = g_date_time_add_full (datetime, 0, 0, 0, -g_date_time_get_hour (datetime), -g_date_time_get_minute (datetime), (gdouble) (-g_date_time_get_second (datetime)));
#line 32 "../src/Services/CalendarEvents/Util.vala"
	result = _tmp0_;
#line 32 "../src/Services/CalendarEvents/Util.vala"
	return result;
#line 142 "Util.c"
}

/**
     * Gets the timezone of the given TimeType as a GLib.TimeZone.
     */
static const gchar*
string_offset (const gchar* self,
               glong offset)
{
	const gchar* result;
#line 1322 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1323 "glib-2.0.vapi"
	result = (const gchar*) (((gchar*) self) + offset);
#line 1323 "glib-2.0.vapi"
	return result;
#line 159 "Util.c"
}

static GTimeZone*
vala_g_time_zone_new_identifier (const gchar* identifier,
                                 GError** error)
{
	GTimeZone* self;
	GError* _inner_error0_ = NULL;
#line 3432 "glib-2.0.vapi"
	self = (GTimeZone*) g_time_zone_new_identifier (identifier);
#line 3433 "glib-2.0.vapi"
	if (((GTimeZone*) self) == NULL) {
#line 172 "Util.c"
		GError* _tmp0_;
#line 3434 "glib-2.0.vapi"
		_tmp0_ = g_error_new_literal (G_CONVERT_ERROR, G_CONVERT_ERROR_ILLEGAL_SEQUENCE, "Invalid identifier argument");
#line 3434 "glib-2.0.vapi"
		_inner_error0_ = _tmp0_;
#line 3434 "glib-2.0.vapi"
		g_propagate_error (error, _inner_error0_);
#line 3434 "glib-2.0.vapi"
		_g_time_zone_unref0 (self);
#line 3434 "glib-2.0.vapi"
		return NULL;
#line 184 "Util.c"
	}
#line 3431 "glib-2.0.vapi"
	return self;
#line 188 "Util.c"
}

GTimeZone*
calendar_events_util_timezone_from_ical (ICalTime* date)
{
	const gchar* tzid = NULL;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
#line 61 "../src/Services/CalendarEvents/Util.vala"
	static const char LIBICAL_TZ_PREFIX[] = "/freeassociation.sourceforge.net/";
#line 199 "Util.c"
	GError* _inner_error0_ = NULL;
	GTimeZone* result;
#line 38 "../src/Services/CalendarEvents/Util.vala"
	g_return_val_if_fail (date != NULL, NULL);
#line 40 "../src/Services/CalendarEvents/Util.vala"
	if (i_cal_time_is_date (date)) {
#line 206 "Util.c"
		GTimeZone* _tmp0_;
#line 41 "../src/Services/CalendarEvents/Util.vala"
		_tmp0_ = g_time_zone_new_local ();
#line 41 "../src/Services/CalendarEvents/Util.vala"
		result = _tmp0_;
#line 41 "../src/Services/CalendarEvents/Util.vala"
		return result;
#line 214 "Util.c"
	}
#line 44 "../src/Services/CalendarEvents/Util.vala"
	_tmp1_ = i_cal_time_get_tzid (date);
#line 44 "../src/Services/CalendarEvents/Util.vala"
	tzid = _tmp1_;
#line 45 "../src/Services/CalendarEvents/Util.vala"
	_tmp2_ = tzid;
#line 45 "../src/Services/CalendarEvents/Util.vala"
	if (_tmp2_ == NULL) {
#line 224 "Util.c"
		ICalTimezone* _tmp3_;
		GTimeZone* _tmp4_;
#line 47 "../src/Services/CalendarEvents/Util.vala"
		_tmp3_ = i_cal_time_get_timezone (date);
#line 47 "../src/Services/CalendarEvents/Util.vala"
		_vala_assert (_tmp3_ == NULL, "date.get_timezone () == null");
#line 48 "../src/Services/CalendarEvents/Util.vala"
		_tmp4_ = g_time_zone_new_local ();
#line 48 "../src/Services/CalendarEvents/Util.vala"
		result = _tmp4_;
#line 48 "../src/Services/CalendarEvents/Util.vala"
		return result;
#line 237 "Util.c"
	}
	{
		const gchar* _tmp5_;
		GTimeZone* _tmp13_ = NULL;
		const gchar* _tmp14_;
		GTimeZone* _tmp15_;
		GTimeZone* _tmp16_;
#line 63 "../src/Services/CalendarEvents/Util.vala"
		_tmp5_ = tzid;
#line 63 "../src/Services/CalendarEvents/Util.vala"
		if (g_str_has_prefix (_tmp5_, LIBICAL_TZ_PREFIX)) {
#line 249 "Util.c"
			GTimeZone* _tmp6_ = NULL;
			const gchar* _tmp7_;
			gint _tmp8_;
			gint _tmp9_;
			const gchar* _tmp10_;
			GTimeZone* _tmp11_;
			GTimeZone* _tmp12_;
#line 66 "../src/Services/CalendarEvents/Util.vala"
			_tmp7_ = tzid;
#line 66 "../src/Services/CalendarEvents/Util.vala"
			_tmp8_ = strlen (LIBICAL_TZ_PREFIX);
#line 66 "../src/Services/CalendarEvents/Util.vala"
			_tmp9_ = _tmp8_;
#line 66 "../src/Services/CalendarEvents/Util.vala"
			_tmp10_ = string_offset (_tmp7_, (glong) _tmp9_);
#line 66 "../src/Services/CalendarEvents/Util.vala"
			_tmp11_ = vala_g_time_zone_new_identifier (_tmp10_, &_inner_error0_);
#line 66 "../src/Services/CalendarEvents/Util.vala"
			_tmp6_ = _tmp11_;
#line 66 "../src/Services/CalendarEvents/Util.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 271 "Util.c"
				goto __catch0_g_error;
			}
#line 66 "../src/Services/CalendarEvents/Util.vala"
			_tmp12_ = _tmp6_;
#line 66 "../src/Services/CalendarEvents/Util.vala"
			_tmp6_ = NULL;
#line 66 "../src/Services/CalendarEvents/Util.vala"
			result = _tmp12_;
#line 66 "../src/Services/CalendarEvents/Util.vala"
			_g_time_zone_unref0 (_tmp6_);
#line 66 "../src/Services/CalendarEvents/Util.vala"
			return result;
#line 284 "Util.c"
		}
#line 70 "../src/Services/CalendarEvents/Util.vala"
		_tmp14_ = tzid;
#line 70 "../src/Services/CalendarEvents/Util.vala"
		_tmp15_ = vala_g_time_zone_new_identifier (_tmp14_, &_inner_error0_);
#line 70 "../src/Services/CalendarEvents/Util.vala"
		_tmp13_ = _tmp15_;
#line 70 "../src/Services/CalendarEvents/Util.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 294 "Util.c"
			goto __catch0_g_error;
		}
#line 70 "../src/Services/CalendarEvents/Util.vala"
		_tmp16_ = _tmp13_;
#line 70 "../src/Services/CalendarEvents/Util.vala"
		_tmp13_ = NULL;
#line 70 "../src/Services/CalendarEvents/Util.vala"
		result = _tmp16_;
#line 70 "../src/Services/CalendarEvents/Util.vala"
		_g_time_zone_unref0 (_tmp13_);
#line 70 "../src/Services/CalendarEvents/Util.vala"
		return result;
#line 307 "Util.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp17_;
		const gchar* _tmp18_;
		GTimeZone* _tmp19_;
#line 62 "../src/Services/CalendarEvents/Util.vala"
		e = _inner_error0_;
#line 62 "../src/Services/CalendarEvents/Util.vala"
		_inner_error0_ = NULL;
#line 73 "../src/Services/CalendarEvents/Util.vala"
		_tmp17_ = e;
#line 73 "../src/Services/CalendarEvents/Util.vala"
		_tmp18_ = _tmp17_->message;
#line 73 "../src/Services/CalendarEvents/Util.vala"
		g_debug ("Util.vala:73: Failed to parse Timezone: %s. Using UTC", _tmp18_);
#line 74 "../src/Services/CalendarEvents/Util.vala"
		_tmp19_ = g_time_zone_new_utc ();
#line 74 "../src/Services/CalendarEvents/Util.vala"
		result = _tmp19_;
#line 74 "../src/Services/CalendarEvents/Util.vala"
		_g_error_free0 (e);
#line 74 "../src/Services/CalendarEvents/Util.vala"
		return result;
#line 334 "Util.c"
	}
	__finally0:
#line 62 "../src/Services/CalendarEvents/Util.vala"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 62 "../src/Services/CalendarEvents/Util.vala"
	g_clear_error (&_inner_error0_);
#line 62 "../src/Services/CalendarEvents/Util.vala"
	return NULL;
#line 343 "Util.c"
}

/**
     * Converts the given ICal.Time to a DateTime.
     * XXX : Track next versions of evolution in order to convert ICal.Timezone to GLib.TimeZone with a dedicated function…
     */
GDateTime*
calendar_events_util_ical_to_date_time (ICalTime* date)
{
	gint year = 0;
	gint month = 0;
	gint day = 0;
	gint hour = 0;
	gint minute = 0;
	gint second = 0;
	gint _tmp0_ = 0;
	gint _tmp1_ = 0;
	gint _tmp2_ = 0;
	gint _tmp3_ = 0;
	gint _tmp4_ = 0;
	gint _tmp5_ = 0;
	GTimeZone* _tmp6_;
	GTimeZone* _tmp7_;
	GDateTime* _tmp8_;
	GDateTime* _tmp9_;
	GDateTime* result;
#line 82 "../src/Services/CalendarEvents/Util.vala"
	g_return_val_if_fail (date != NULL, NULL);
#line 84 "../src/Services/CalendarEvents/Util.vala"
	i_cal_time_get_date (date, &_tmp0_, &_tmp1_, &_tmp2_);
#line 84 "../src/Services/CalendarEvents/Util.vala"
	year = _tmp0_;
#line 84 "../src/Services/CalendarEvents/Util.vala"
	month = _tmp1_;
#line 84 "../src/Services/CalendarEvents/Util.vala"
	day = _tmp2_;
#line 85 "../src/Services/CalendarEvents/Util.vala"
	i_cal_time_get_time (date, &_tmp3_, &_tmp4_, &_tmp5_);
#line 85 "../src/Services/CalendarEvents/Util.vala"
	hour = _tmp3_;
#line 85 "../src/Services/CalendarEvents/Util.vala"
	minute = _tmp4_;
#line 85 "../src/Services/CalendarEvents/Util.vala"
	second = _tmp5_;
#line 86 "../src/Services/CalendarEvents/Util.vala"
	_tmp6_ = calendar_events_util_timezone_from_ical (date);
#line 86 "../src/Services/CalendarEvents/Util.vala"
	_tmp7_ = _tmp6_;
#line 86 "../src/Services/CalendarEvents/Util.vala"
	_tmp8_ = g_date_time_new (_tmp7_, year, month, day, hour, minute, (gdouble) second);
#line 86 "../src/Services/CalendarEvents/Util.vala"
	_tmp9_ = _tmp8_;
#line 86 "../src/Services/CalendarEvents/Util.vala"
	_g_time_zone_unref0 (_tmp7_);
#line 86 "../src/Services/CalendarEvents/Util.vala"
	result = _tmp9_;
#line 86 "../src/Services/CalendarEvents/Util.vala"
	return result;
#line 402 "Util.c"
}

/**
     * Say if an event lasts all day.
     */
gboolean
calendar_events_util_is_the_all_day (GDateTime* dtstart,
                                     GDateTime* dtend)
{
	GDateTime* utc_start = NULL;
	GTimeZone* _tmp0_;
	GTimeZone* _tmp1_;
	GDateTime* _tmp2_;
	GDateTime* _tmp3_;
	GTimeSpan timespan = 0LL;
	gboolean _tmp4_ = FALSE;
	gboolean result;
#line 93 "../src/Services/CalendarEvents/Util.vala"
	g_return_val_if_fail (dtstart != NULL, FALSE);
#line 93 "../src/Services/CalendarEvents/Util.vala"
	g_return_val_if_fail (dtend != NULL, FALSE);
#line 94 "../src/Services/CalendarEvents/Util.vala"
	_tmp0_ = g_time_zone_new_utc ();
#line 94 "../src/Services/CalendarEvents/Util.vala"
	_tmp1_ = _tmp0_;
#line 94 "../src/Services/CalendarEvents/Util.vala"
	_tmp2_ = g_date_time_to_timezone (dtstart, _tmp1_);
#line 94 "../src/Services/CalendarEvents/Util.vala"
	_tmp3_ = _tmp2_;
#line 94 "../src/Services/CalendarEvents/Util.vala"
	_g_time_zone_unref0 (_tmp1_);
#line 94 "../src/Services/CalendarEvents/Util.vala"
	utc_start = _tmp3_;
#line 95 "../src/Services/CalendarEvents/Util.vala"
	timespan = g_date_time_difference (dtend, dtstart);
#line 97 "../src/Services/CalendarEvents/Util.vala"
	if ((timespan % G_TIME_SPAN_DAY) == ((GTimeSpan) 0)) {
#line 440 "Util.c"
		GDateTime* _tmp5_;
#line 97 "../src/Services/CalendarEvents/Util.vala"
		_tmp5_ = utc_start;
#line 97 "../src/Services/CalendarEvents/Util.vala"
		_tmp4_ = g_date_time_get_hour (_tmp5_) == 0;
#line 446 "Util.c"
	} else {
#line 97 "../src/Services/CalendarEvents/Util.vala"
		_tmp4_ = FALSE;
#line 450 "Util.c"
	}
#line 97 "../src/Services/CalendarEvents/Util.vala"
	if (_tmp4_) {
#line 98 "../src/Services/CalendarEvents/Util.vala"
		result = TRUE;
#line 98 "../src/Services/CalendarEvents/Util.vala"
		_g_date_time_unref0 (utc_start);
#line 98 "../src/Services/CalendarEvents/Util.vala"
		return result;
#line 460 "Util.c"
	} else {
#line 100 "../src/Services/CalendarEvents/Util.vala"
		result = FALSE;
#line 100 "../src/Services/CalendarEvents/Util.vala"
		_g_date_time_unref0 (utc_start);
#line 100 "../src/Services/CalendarEvents/Util.vala"
		return result;
#line 468 "Util.c"
	}
}

guint
calendar_events_util_source_hash_func (ESource* key)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	guint _tmp2_;
	guint result;
#line 109 "../src/Services/CalendarEvents/Util.vala"
	g_return_val_if_fail (key != NULL, 0U);
#line 110 "../src/Services/CalendarEvents/Util.vala"
	_tmp0_ = e_source_dup_uid (key);
#line 110 "../src/Services/CalendarEvents/Util.vala"
	_tmp1_ = _tmp0_;
#line 110 "../src/Services/CalendarEvents/Util.vala"
	_tmp2_ = g_str_hash (_tmp1_);
#line 110 "../src/Services/CalendarEvents/Util.vala"
	_g_free0 (_tmp1_);
#line 110 "../src/Services/CalendarEvents/Util.vala"
	result = _tmp2_;
#line 110 "../src/Services/CalendarEvents/Util.vala"
	return result;
#line 493 "Util.c"
}

static void
_vala_ECalComponentId_free (ECalComponentId* self)
{
#line 115 "../src/Services/CalendarEvents/Util.vala"
	g_boxed_free (e_cal_component_id_get_type (), self);
#line 501 "Util.c"
}

gboolean
calendar_events_util_calcomponent_equal_func (ECalComponent* a,
                                              ECalComponent* b)
{
	ECalComponentId* _tmp0_;
	ECalComponentId* _tmp1_;
	ECalComponentId* _tmp2_;
	ECalComponentId* _tmp3_;
	gboolean _tmp4_;
	gboolean result;
#line 114 "../src/Services/CalendarEvents/Util.vala"
	g_return_val_if_fail (a != NULL, FALSE);
#line 114 "../src/Services/CalendarEvents/Util.vala"
	g_return_val_if_fail (b != NULL, FALSE);
#line 115 "../src/Services/CalendarEvents/Util.vala"
	_tmp0_ = e_cal_component_get_id (a);
#line 115 "../src/Services/CalendarEvents/Util.vala"
	_tmp1_ = _tmp0_;
#line 115 "../src/Services/CalendarEvents/Util.vala"
	_tmp2_ = e_cal_component_get_id (b);
#line 115 "../src/Services/CalendarEvents/Util.vala"
	_tmp3_ = _tmp2_;
#line 115 "../src/Services/CalendarEvents/Util.vala"
	_tmp4_ = e_cal_component_id_equal (_tmp1_, _tmp3_);
#line 115 "../src/Services/CalendarEvents/Util.vala"
	__vala_ECalComponentId_free0 (_tmp3_);
#line 115 "../src/Services/CalendarEvents/Util.vala"
	__vala_ECalComponentId_free0 (_tmp1_);
#line 115 "../src/Services/CalendarEvents/Util.vala"
	result = _tmp4_;
#line 115 "../src/Services/CalendarEvents/Util.vala"
	return result;
#line 536 "Util.c"
}

gint
calendar_events_util_calcomponent_compare_func (ECalComponent* a,
                                                ECalComponent* b)
{
	gboolean _tmp0_ = FALSE;
	ECalComponentId* a_id = NULL;
	ECalComponentId* _tmp3_;
	ECalComponentId* b_id = NULL;
	ECalComponentId* _tmp4_;
	gint res = 0;
	GCompareFunc _tmp5_;
	ECalComponentId* _tmp6_;
	const gchar* _tmp7_;
	ECalComponentId* _tmp8_;
	const gchar* _tmp9_;
	gint result;
#line 119 "../src/Services/CalendarEvents/Util.vala"
	if (a == NULL) {
#line 119 "../src/Services/CalendarEvents/Util.vala"
		_tmp0_ = b != NULL;
#line 559 "Util.c"
	} else {
#line 119 "../src/Services/CalendarEvents/Util.vala"
		_tmp0_ = FALSE;
#line 563 "Util.c"
	}
#line 119 "../src/Services/CalendarEvents/Util.vala"
	if (_tmp0_) {
#line 120 "../src/Services/CalendarEvents/Util.vala"
		result = 1;
#line 120 "../src/Services/CalendarEvents/Util.vala"
		return result;
#line 571 "Util.c"
	} else {
		gboolean _tmp1_ = FALSE;
#line 121 "../src/Services/CalendarEvents/Util.vala"
		if (b == NULL) {
#line 121 "../src/Services/CalendarEvents/Util.vala"
			_tmp1_ = a != NULL;
#line 578 "Util.c"
		} else {
#line 121 "../src/Services/CalendarEvents/Util.vala"
			_tmp1_ = FALSE;
#line 582 "Util.c"
		}
#line 121 "../src/Services/CalendarEvents/Util.vala"
		if (_tmp1_) {
#line 122 "../src/Services/CalendarEvents/Util.vala"
			result = -1;
#line 122 "../src/Services/CalendarEvents/Util.vala"
			return result;
#line 590 "Util.c"
		} else {
			gboolean _tmp2_ = FALSE;
#line 123 "../src/Services/CalendarEvents/Util.vala"
			if (b == NULL) {
#line 123 "../src/Services/CalendarEvents/Util.vala"
				_tmp2_ = a == NULL;
#line 597 "Util.c"
			} else {
#line 123 "../src/Services/CalendarEvents/Util.vala"
				_tmp2_ = FALSE;
#line 601 "Util.c"
			}
#line 123 "../src/Services/CalendarEvents/Util.vala"
			if (_tmp2_) {
#line 124 "../src/Services/CalendarEvents/Util.vala"
				result = 0;
#line 124 "../src/Services/CalendarEvents/Util.vala"
				return result;
#line 609 "Util.c"
			}
		}
	}
#line 127 "../src/Services/CalendarEvents/Util.vala"
	_tmp3_ = e_cal_component_get_id (a);
#line 127 "../src/Services/CalendarEvents/Util.vala"
	a_id = _tmp3_;
#line 128 "../src/Services/CalendarEvents/Util.vala"
	_tmp4_ = e_cal_component_get_id (b);
#line 128 "../src/Services/CalendarEvents/Util.vala"
	b_id = _tmp4_;
#line 129 "../src/Services/CalendarEvents/Util.vala"
	_tmp5_ = ((GCompareFunc) g_strcmp0);
#line 129 "../src/Services/CalendarEvents/Util.vala"
	_tmp6_ = a_id;
#line 129 "../src/Services/CalendarEvents/Util.vala"
	_tmp7_ = e_cal_component_id_get_uid (_tmp6_);
#line 129 "../src/Services/CalendarEvents/Util.vala"
	_tmp8_ = b_id;
#line 129 "../src/Services/CalendarEvents/Util.vala"
	_tmp9_ = e_cal_component_id_get_uid (_tmp8_);
#line 129 "../src/Services/CalendarEvents/Util.vala"
	res = _tmp5_ (_tmp7_, _tmp9_);
#line 130 "../src/Services/CalendarEvents/Util.vala"
	if (res == 0) {
#line 635 "Util.c"
		GCompareFunc _tmp10_;
		ECalComponentId* _tmp11_;
		const gchar* _tmp12_;
		ECalComponentId* _tmp13_;
		const gchar* _tmp14_;
#line 131 "../src/Services/CalendarEvents/Util.vala"
		_tmp10_ = ((GCompareFunc) g_strcmp0);
#line 131 "../src/Services/CalendarEvents/Util.vala"
		_tmp11_ = a_id;
#line 131 "../src/Services/CalendarEvents/Util.vala"
		_tmp12_ = e_cal_component_id_get_rid (_tmp11_);
#line 131 "../src/Services/CalendarEvents/Util.vala"
		_tmp13_ = b_id;
#line 131 "../src/Services/CalendarEvents/Util.vala"
		_tmp14_ = e_cal_component_id_get_rid (_tmp13_);
#line 131 "../src/Services/CalendarEvents/Util.vala"
		result = _tmp10_ (_tmp12_, _tmp14_);
#line 131 "../src/Services/CalendarEvents/Util.vala"
		__vala_ECalComponentId_free0 (b_id);
#line 131 "../src/Services/CalendarEvents/Util.vala"
		__vala_ECalComponentId_free0 (a_id);
#line 131 "../src/Services/CalendarEvents/Util.vala"
		return result;
#line 659 "Util.c"
	}
#line 134 "../src/Services/CalendarEvents/Util.vala"
	result = res;
#line 134 "../src/Services/CalendarEvents/Util.vala"
	__vala_ECalComponentId_free0 (b_id);
#line 134 "../src/Services/CalendarEvents/Util.vala"
	__vala_ECalComponentId_free0 (a_id);
#line 134 "../src/Services/CalendarEvents/Util.vala"
	return result;
#line 669 "Util.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 157 "../src/Services/CalendarEvents/Util.vala"
	return self ? g_object_ref (self) : NULL;
#line 677 "Util.c"
}

gboolean
calendar_events_util_calcomp_is_on_day (ECalComponent* comp,
                                        GDateTime* day)
{
	ICalTimezone* system_timezone = NULL;
	ICalTimezone* _tmp0_;
	GDateTime* stripped_time = NULL;
	GDateTime* _tmp1_;
	gint64 selected_date_unix = 0LL;
	GDateTime* _tmp2_;
	gint64 selected_date_unix_next = 0LL;
	GDateTime* _tmp3_;
	GDateTime* _tmp4_;
	GDateTime* _tmp5_;
	gint64 _tmp6_;
	ICalComponent* icomp = NULL;
	ICalComponent* _tmp7_;
	ICalTime* start_time = NULL;
	ICalComponent* _tmp8_;
	ICalTime* _tmp9_;
	ICalTime* due_time = NULL;
	ICalComponent* _tmp10_;
	ICalTime* _tmp11_;
	ICalTime* end_time = NULL;
	ICalComponent* _tmp12_;
	ICalTime* _tmp13_;
	gboolean _tmp14_ = FALSE;
	ICalTime* _tmp15_;
	time_t start_unix = 0;
	ICalTime* _tmp24_;
	ICalTimezone* _tmp25_;
	time_t end_unix = 0;
	ICalTime* _tmp26_;
	ICalTimezone* _tmp27_;
	gboolean _tmp28_ = FALSE;
	gboolean _tmp29_ = FALSE;
	gboolean _tmp30_ = FALSE;
	gboolean _tmp31_ = FALSE;
	gboolean result;
#line 137 "../src/Services/CalendarEvents/Util.vala"
	g_return_val_if_fail (comp != NULL, FALSE);
#line 137 "../src/Services/CalendarEvents/Util.vala"
	g_return_val_if_fail (day != NULL, FALSE);
#line 138 "../src/Services/CalendarEvents/Util.vala"
	_tmp0_ = e_cal_util_get_system_timezone ();
#line 138 "../src/Services/CalendarEvents/Util.vala"
	system_timezone = _tmp0_;
#line 140 "../src/Services/CalendarEvents/Util.vala"
	_tmp1_ = g_date_time_new_local (g_date_time_get_year (day), g_date_time_get_month (day), g_date_time_get_day_of_month (day), 0, 0, (gdouble) 0);
#line 140 "../src/Services/CalendarEvents/Util.vala"
	stripped_time = _tmp1_;
#line 142 "../src/Services/CalendarEvents/Util.vala"
	_tmp2_ = stripped_time;
#line 142 "../src/Services/CalendarEvents/Util.vala"
	selected_date_unix = g_date_time_to_unix (_tmp2_);
#line 143 "../src/Services/CalendarEvents/Util.vala"
	_tmp3_ = stripped_time;
#line 143 "../src/Services/CalendarEvents/Util.vala"
	_tmp4_ = g_date_time_add_days (_tmp3_, 1);
#line 143 "../src/Services/CalendarEvents/Util.vala"
	_tmp5_ = _tmp4_;
#line 143 "../src/Services/CalendarEvents/Util.vala"
	_tmp6_ = g_date_time_to_unix (_tmp5_);
#line 143 "../src/Services/CalendarEvents/Util.vala"
	_g_date_time_unref0 (_tmp5_);
#line 143 "../src/Services/CalendarEvents/Util.vala"
	selected_date_unix_next = _tmp6_;
#line 146 "../src/Services/CalendarEvents/Util.vala"
	_tmp7_ = e_cal_component_get_icalcomponent (comp);
#line 146 "../src/Services/CalendarEvents/Util.vala"
	icomp = _tmp7_;
#line 147 "../src/Services/CalendarEvents/Util.vala"
	_tmp8_ = icomp;
#line 147 "../src/Services/CalendarEvents/Util.vala"
	_tmp9_ = i_cal_component_get_dtstart (_tmp8_);
#line 147 "../src/Services/CalendarEvents/Util.vala"
	start_time = _tmp9_;
#line 148 "../src/Services/CalendarEvents/Util.vala"
	_tmp10_ = icomp;
#line 148 "../src/Services/CalendarEvents/Util.vala"
	_tmp11_ = i_cal_component_get_due (_tmp10_);
#line 148 "../src/Services/CalendarEvents/Util.vala"
	due_time = _tmp11_;
#line 149 "../src/Services/CalendarEvents/Util.vala"
	_tmp12_ = icomp;
#line 149 "../src/Services/CalendarEvents/Util.vala"
	_tmp13_ = i_cal_component_get_dtend (_tmp12_);
#line 149 "../src/Services/CalendarEvents/Util.vala"
	end_time = _tmp13_;
#line 151 "../src/Services/CalendarEvents/Util.vala"
	_tmp15_ = due_time;
#line 151 "../src/Services/CalendarEvents/Util.vala"
	if (_tmp15_ != NULL) {
#line 773 "Util.c"
		ICalTime* _tmp16_;
#line 151 "../src/Services/CalendarEvents/Util.vala"
		_tmp16_ = due_time;
#line 151 "../src/Services/CalendarEvents/Util.vala"
		_tmp14_ = !i_cal_time_is_null_time (_tmp16_);
#line 779 "Util.c"
	} else {
#line 151 "../src/Services/CalendarEvents/Util.vala"
		_tmp14_ = FALSE;
#line 783 "Util.c"
	}
#line 151 "../src/Services/CalendarEvents/Util.vala"
	if (_tmp14_) {
#line 787 "Util.c"
		ICalTime* _tmp17_;
		ICalTime* _tmp18_;
		gboolean _tmp19_ = FALSE;
		ICalTime* _tmp20_;
#line 157 "../src/Services/CalendarEvents/Util.vala"
		_tmp17_ = due_time;
#line 157 "../src/Services/CalendarEvents/Util.vala"
		_tmp18_ = _g_object_ref0 (_tmp17_);
#line 157 "../src/Services/CalendarEvents/Util.vala"
		_g_object_unref0 (end_time);
#line 157 "../src/Services/CalendarEvents/Util.vala"
		end_time = _tmp18_;
#line 159 "../src/Services/CalendarEvents/Util.vala"
		_tmp20_ = start_time;
#line 159 "../src/Services/CalendarEvents/Util.vala"
		if (_tmp20_ == NULL) {
#line 159 "../src/Services/CalendarEvents/Util.vala"
			_tmp19_ = TRUE;
#line 806 "Util.c"
		} else {
			ICalTime* _tmp21_;
#line 159 "../src/Services/CalendarEvents/Util.vala"
			_tmp21_ = start_time;
#line 159 "../src/Services/CalendarEvents/Util.vala"
			_tmp19_ = i_cal_time_is_null_time (_tmp21_);
#line 813 "Util.c"
		}
#line 159 "../src/Services/CalendarEvents/Util.vala"
		if (_tmp19_) {
#line 817 "Util.c"
			ICalTime* _tmp22_;
			ICalTime* _tmp23_;
#line 160 "../src/Services/CalendarEvents/Util.vala"
			_tmp22_ = due_time;
#line 160 "../src/Services/CalendarEvents/Util.vala"
			_tmp23_ = _g_object_ref0 (_tmp22_);
#line 160 "../src/Services/CalendarEvents/Util.vala"
			_g_object_unref0 (start_time);
#line 160 "../src/Services/CalendarEvents/Util.vala"
			start_time = _tmp23_;
#line 828 "Util.c"
		}
	}
#line 164 "../src/Services/CalendarEvents/Util.vala"
	_tmp24_ = start_time;
#line 164 "../src/Services/CalendarEvents/Util.vala"
	_tmp25_ = system_timezone;
#line 164 "../src/Services/CalendarEvents/Util.vala"
	start_unix = i_cal_time_as_timet_with_zone (_tmp24_, _tmp25_);
#line 165 "../src/Services/CalendarEvents/Util.vala"
	_tmp26_ = end_time;
#line 165 "../src/Services/CalendarEvents/Util.vala"
	_tmp27_ = system_timezone;
#line 165 "../src/Services/CalendarEvents/Util.vala"
	end_unix = i_cal_time_as_timet_with_zone (_tmp26_, _tmp27_);
#line 168 "../src/Services/CalendarEvents/Util.vala"
	if (((gint64) start_unix) < selected_date_unix) {
#line 168 "../src/Services/CalendarEvents/Util.vala"
		_tmp28_ = selected_date_unix_next < ((gint64) end_unix);
#line 847 "Util.c"
	} else {
#line 168 "../src/Services/CalendarEvents/Util.vala"
		_tmp28_ = FALSE;
#line 851 "Util.c"
	}
#line 168 "../src/Services/CalendarEvents/Util.vala"
	if (_tmp28_) {
#line 169 "../src/Services/CalendarEvents/Util.vala"
		result = TRUE;
#line 169 "../src/Services/CalendarEvents/Util.vala"
		_g_object_unref0 (end_time);
#line 169 "../src/Services/CalendarEvents/Util.vala"
		_g_object_unref0 (due_time);
#line 169 "../src/Services/CalendarEvents/Util.vala"
		_g_object_unref0 (start_time);
#line 169 "../src/Services/CalendarEvents/Util.vala"
		_g_date_time_unref0 (stripped_time);
#line 169 "../src/Services/CalendarEvents/Util.vala"
		return result;
#line 867 "Util.c"
	}
#line 173 "../src/Services/CalendarEvents/Util.vala"
	if (((gint64) start_unix) < selected_date_unix) {
#line 173 "../src/Services/CalendarEvents/Util.vala"
		_tmp29_ = selected_date_unix < ((gint64) end_unix);
#line 873 "Util.c"
	} else {
#line 173 "../src/Services/CalendarEvents/Util.vala"
		_tmp29_ = FALSE;
#line 877 "Util.c"
	}
#line 173 "../src/Services/CalendarEvents/Util.vala"
	if (_tmp29_) {
#line 174 "../src/Services/CalendarEvents/Util.vala"
		result = TRUE;
#line 174 "../src/Services/CalendarEvents/Util.vala"
		_g_object_unref0 (end_time);
#line 174 "../src/Services/CalendarEvents/Util.vala"
		_g_object_unref0 (due_time);
#line 174 "../src/Services/CalendarEvents/Util.vala"
		_g_object_unref0 (start_time);
#line 174 "../src/Services/CalendarEvents/Util.vala"
		_g_date_time_unref0 (stripped_time);
#line 174 "../src/Services/CalendarEvents/Util.vala"
		return result;
#line 893 "Util.c"
	}
#line 178 "../src/Services/CalendarEvents/Util.vala"
	if (((gint64) start_unix) < selected_date_unix_next) {
#line 178 "../src/Services/CalendarEvents/Util.vala"
		_tmp30_ = selected_date_unix_next < ((gint64) end_unix);
#line 899 "Util.c"
	} else {
#line 178 "../src/Services/CalendarEvents/Util.vala"
		_tmp30_ = FALSE;
#line 903 "Util.c"
	}
#line 178 "../src/Services/CalendarEvents/Util.vala"
	if (_tmp30_) {
#line 179 "../src/Services/CalendarEvents/Util.vala"
		result = TRUE;
#line 179 "../src/Services/CalendarEvents/Util.vala"
		_g_object_unref0 (end_time);
#line 179 "../src/Services/CalendarEvents/Util.vala"
		_g_object_unref0 (due_time);
#line 179 "../src/Services/CalendarEvents/Util.vala"
		_g_object_unref0 (start_time);
#line 179 "../src/Services/CalendarEvents/Util.vala"
		_g_date_time_unref0 (stripped_time);
#line 179 "../src/Services/CalendarEvents/Util.vala"
		return result;
#line 919 "Util.c"
	}
#line 183 "../src/Services/CalendarEvents/Util.vala"
	if (((gint64) start_unix) < selected_date_unix_next) {
#line 183 "../src/Services/CalendarEvents/Util.vala"
		_tmp31_ = selected_date_unix < ((gint64) end_unix);
#line 925 "Util.c"
	} else {
#line 183 "../src/Services/CalendarEvents/Util.vala"
		_tmp31_ = FALSE;
#line 929 "Util.c"
	}
#line 183 "../src/Services/CalendarEvents/Util.vala"
	if (_tmp31_) {
#line 184 "../src/Services/CalendarEvents/Util.vala"
		result = TRUE;
#line 184 "../src/Services/CalendarEvents/Util.vala"
		_g_object_unref0 (end_time);
#line 184 "../src/Services/CalendarEvents/Util.vala"
		_g_object_unref0 (due_time);
#line 184 "../src/Services/CalendarEvents/Util.vala"
		_g_object_unref0 (start_time);
#line 184 "../src/Services/CalendarEvents/Util.vala"
		_g_date_time_unref0 (stripped_time);
#line 184 "../src/Services/CalendarEvents/Util.vala"
		return result;
#line 945 "Util.c"
	}
#line 187 "../src/Services/CalendarEvents/Util.vala"
	result = FALSE;
#line 187 "../src/Services/CalendarEvents/Util.vala"
	_g_object_unref0 (end_time);
#line 187 "../src/Services/CalendarEvents/Util.vala"
	_g_object_unref0 (due_time);
#line 187 "../src/Services/CalendarEvents/Util.vala"
	_g_object_unref0 (start_time);
#line 187 "../src/Services/CalendarEvents/Util.vala"
	_g_date_time_unref0 (stripped_time);
#line 187 "../src/Services/CalendarEvents/Util.vala"
	return result;
#line 959 "Util.c"
}

gboolean
calendar_events_util_calcomp_is_on_month (ECalComponent* comp,
                                          GDateTime* date)
{
	ICalComponent* icomp = NULL;
	ICalComponent* _tmp0_;
	ICalTime* start_time = NULL;
	ICalComponent* _tmp1_;
	ICalTime* _tmp2_;
	ICalTime* due_time = NULL;
	ICalComponent* _tmp3_;
	ICalTime* _tmp4_;
	ICalTime* end_time = NULL;
	ICalComponent* _tmp5_;
	ICalTime* _tmp6_;
	gboolean _tmp7_ = FALSE;
	ICalTime* _tmp8_;
	gboolean _tmp17_ = FALSE;
	ICalTime* _tmp18_;
	gboolean result;
#line 190 "../src/Services/CalendarEvents/Util.vala"
	g_return_val_if_fail (comp != NULL, FALSE);
#line 190 "../src/Services/CalendarEvents/Util.vala"
	g_return_val_if_fail (date != NULL, FALSE);
#line 192 "../src/Services/CalendarEvents/Util.vala"
	_tmp0_ = e_cal_component_get_icalcomponent (comp);
#line 192 "../src/Services/CalendarEvents/Util.vala"
	icomp = _tmp0_;
#line 193 "../src/Services/CalendarEvents/Util.vala"
	_tmp1_ = icomp;
#line 193 "../src/Services/CalendarEvents/Util.vala"
	_tmp2_ = i_cal_component_get_dtstart (_tmp1_);
#line 193 "../src/Services/CalendarEvents/Util.vala"
	start_time = _tmp2_;
#line 194 "../src/Services/CalendarEvents/Util.vala"
	_tmp3_ = icomp;
#line 194 "../src/Services/CalendarEvents/Util.vala"
	_tmp4_ = i_cal_component_get_due (_tmp3_);
#line 194 "../src/Services/CalendarEvents/Util.vala"
	due_time = _tmp4_;
#line 195 "../src/Services/CalendarEvents/Util.vala"
	_tmp5_ = icomp;
#line 195 "../src/Services/CalendarEvents/Util.vala"
	_tmp6_ = i_cal_component_get_dtend (_tmp5_);
#line 195 "../src/Services/CalendarEvents/Util.vala"
	end_time = _tmp6_;
#line 197 "../src/Services/CalendarEvents/Util.vala"
	_tmp8_ = due_time;
#line 197 "../src/Services/CalendarEvents/Util.vala"
	if (_tmp8_ != NULL) {
#line 1012 "Util.c"
		ICalTime* _tmp9_;
#line 197 "../src/Services/CalendarEvents/Util.vala"
		_tmp9_ = due_time;
#line 197 "../src/Services/CalendarEvents/Util.vala"
		_tmp7_ = !i_cal_time_is_null_time (_tmp9_);
#line 1018 "Util.c"
	} else {
#line 197 "../src/Services/CalendarEvents/Util.vala"
		_tmp7_ = FALSE;
#line 1022 "Util.c"
	}
#line 197 "../src/Services/CalendarEvents/Util.vala"
	if (_tmp7_) {
#line 1026 "Util.c"
		ICalTime* _tmp10_;
		ICalTime* _tmp11_;
		gboolean _tmp12_ = FALSE;
		ICalTime* _tmp13_;
#line 203 "../src/Services/CalendarEvents/Util.vala"
		_tmp10_ = due_time;
#line 203 "../src/Services/CalendarEvents/Util.vala"
		_tmp11_ = _g_object_ref0 (_tmp10_);
#line 203 "../src/Services/CalendarEvents/Util.vala"
		_g_object_unref0 (end_time);
#line 203 "../src/Services/CalendarEvents/Util.vala"
		end_time = _tmp11_;
#line 205 "../src/Services/CalendarEvents/Util.vala"
		_tmp13_ = start_time;
#line 205 "../src/Services/CalendarEvents/Util.vala"
		if (_tmp13_ == NULL) {
#line 205 "../src/Services/CalendarEvents/Util.vala"
			_tmp12_ = TRUE;
#line 1045 "Util.c"
		} else {
			ICalTime* _tmp14_;
#line 205 "../src/Services/CalendarEvents/Util.vala"
			_tmp14_ = start_time;
#line 205 "../src/Services/CalendarEvents/Util.vala"
			_tmp12_ = i_cal_time_is_null_time (_tmp14_);
#line 1052 "Util.c"
		}
#line 205 "../src/Services/CalendarEvents/Util.vala"
		if (_tmp12_) {
#line 1056 "Util.c"
			ICalTime* _tmp15_;
			ICalTime* _tmp16_;
#line 206 "../src/Services/CalendarEvents/Util.vala"
			_tmp15_ = due_time;
#line 206 "../src/Services/CalendarEvents/Util.vala"
			_tmp16_ = _g_object_ref0 (_tmp15_);
#line 206 "../src/Services/CalendarEvents/Util.vala"
			_g_object_unref0 (start_time);
#line 206 "../src/Services/CalendarEvents/Util.vala"
			start_time = _tmp16_;
#line 1067 "Util.c"
		}
	}
#line 210 "../src/Services/CalendarEvents/Util.vala"
	_tmp18_ = start_time;
#line 210 "../src/Services/CalendarEvents/Util.vala"
	if (g_date_time_get_month (date) == i_cal_time_get_month (_tmp18_)) {
#line 1074 "Util.c"
		ICalTime* _tmp19_;
#line 210 "../src/Services/CalendarEvents/Util.vala"
		_tmp19_ = start_time;
#line 210 "../src/Services/CalendarEvents/Util.vala"
		_tmp17_ = g_date_time_get_year (date) == i_cal_time_get_year (_tmp19_);
#line 1080 "Util.c"
	} else {
#line 210 "../src/Services/CalendarEvents/Util.vala"
		_tmp17_ = FALSE;
#line 1084 "Util.c"
	}
#line 210 "../src/Services/CalendarEvents/Util.vala"
	result = _tmp17_;
#line 210 "../src/Services/CalendarEvents/Util.vala"
	_g_object_unref0 (end_time);
#line 210 "../src/Services/CalendarEvents/Util.vala"
	_g_object_unref0 (due_time);
#line 210 "../src/Services/CalendarEvents/Util.vala"
	_g_object_unref0 (start_time);
#line 210 "../src/Services/CalendarEvents/Util.vala"
	return result;
#line 1096 "Util.c"
}

gboolean
calendar_events_util_source_equal_func (ESource* a,
                                        ESource* b)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gboolean _tmp4_;
	gboolean result;
#line 214 "../src/Services/CalendarEvents/Util.vala"
	g_return_val_if_fail (a != NULL, FALSE);
#line 214 "../src/Services/CalendarEvents/Util.vala"
	g_return_val_if_fail (b != NULL, FALSE);
#line 215 "../src/Services/CalendarEvents/Util.vala"
	_tmp0_ = e_source_dup_uid (a);
#line 215 "../src/Services/CalendarEvents/Util.vala"
	_tmp1_ = _tmp0_;
#line 215 "../src/Services/CalendarEvents/Util.vala"
	_tmp2_ = e_source_dup_uid (b);
#line 215 "../src/Services/CalendarEvents/Util.vala"
	_tmp3_ = _tmp2_;
#line 215 "../src/Services/CalendarEvents/Util.vala"
	_tmp4_ = g_strcmp0 (_tmp1_, _tmp3_) == 0;
#line 215 "../src/Services/CalendarEvents/Util.vala"
	_g_free0 (_tmp3_);
#line 215 "../src/Services/CalendarEvents/Util.vala"
	_g_free0 (_tmp1_);
#line 215 "../src/Services/CalendarEvents/Util.vala"
	result = _tmp4_;
#line 215 "../src/Services/CalendarEvents/Util.vala"
	return result;
#line 1131 "Util.c"
}

gchar*
calendar_events_util_get_source_location (ESource* source)
{
	ESourceRegistry* registry = NULL;
	ServicesCalendarEvents* _tmp0_;
	ServicesCalendarEvents* _tmp1_;
	ESourceRegistry* _tmp2_;
	ESourceRegistry* _tmp3_;
	ESourceRegistry* _tmp4_;
	ESourceRegistry* _tmp5_;
	gchar* parent_uid = NULL;
	const gchar* _tmp6_;
	const gchar* _tmp7_;
	gchar* _tmp8_;
	ESource* parent_source = NULL;
	ESource* _tmp9_;
	gchar* _tmp41_;
	gchar* result;
#line 218 "../src/Services/CalendarEvents/Util.vala"
	g_return_val_if_fail (source != NULL, NULL);
#line 219 "../src/Services/CalendarEvents/Util.vala"
	_tmp0_ = services_calendar_events_get_default ();
#line 219 "../src/Services/CalendarEvents/Util.vala"
	_tmp1_ = _tmp0_;
#line 219 "../src/Services/CalendarEvents/Util.vala"
	_tmp2_ = services_calendar_events_get_registry (_tmp1_);
#line 219 "../src/Services/CalendarEvents/Util.vala"
	_tmp3_ = _tmp2_;
#line 219 "../src/Services/CalendarEvents/Util.vala"
	_tmp4_ = _g_object_ref0 (_tmp3_);
#line 219 "../src/Services/CalendarEvents/Util.vala"
	_tmp5_ = _tmp4_;
#line 219 "../src/Services/CalendarEvents/Util.vala"
	_g_object_unref0 (_tmp1_);
#line 219 "../src/Services/CalendarEvents/Util.vala"
	registry = _tmp5_;
#line 220 "../src/Services/CalendarEvents/Util.vala"
	_tmp6_ = e_source_get_parent (source);
#line 220 "../src/Services/CalendarEvents/Util.vala"
	_tmp7_ = _tmp6_;
#line 220 "../src/Services/CalendarEvents/Util.vala"
	_tmp8_ = g_strdup (_tmp7_);
#line 220 "../src/Services/CalendarEvents/Util.vala"
	parent_uid = _tmp8_;
#line 221 "../src/Services/CalendarEvents/Util.vala"
	_tmp9_ = _g_object_ref0 (source);
#line 221 "../src/Services/CalendarEvents/Util.vala"
	parent_source = _tmp9_;
#line 222 "../src/Services/CalendarEvents/Util.vala"
	while (TRUE) {
#line 1184 "Util.c"
		ESource* _tmp10_;
		ESource* _tmp11_;
		const gchar* _tmp12_;
		const gchar* _tmp13_;
		gchar* _tmp14_;
		ESource* _tmp15_;
		ESource* _tmp26_;
		const gchar* _tmp37_;
		ESourceRegistry* _tmp38_;
		const gchar* _tmp39_;
		ESource* _tmp40_;
#line 222 "../src/Services/CalendarEvents/Util.vala"
		_tmp10_ = parent_source;
#line 222 "../src/Services/CalendarEvents/Util.vala"
		if (!(_tmp10_ != NULL)) {
#line 222 "../src/Services/CalendarEvents/Util.vala"
			break;
#line 1202 "Util.c"
		}
#line 223 "../src/Services/CalendarEvents/Util.vala"
		_tmp11_ = parent_source;
#line 223 "../src/Services/CalendarEvents/Util.vala"
		_tmp12_ = e_source_get_parent (_tmp11_);
#line 223 "../src/Services/CalendarEvents/Util.vala"
		_tmp13_ = _tmp12_;
#line 223 "../src/Services/CalendarEvents/Util.vala"
		_tmp14_ = g_strdup (_tmp13_);
#line 223 "../src/Services/CalendarEvents/Util.vala"
		_g_free0 (parent_uid);
#line 223 "../src/Services/CalendarEvents/Util.vala"
		parent_uid = _tmp14_;
#line 225 "../src/Services/CalendarEvents/Util.vala"
		_tmp15_ = parent_source;
#line 225 "../src/Services/CalendarEvents/Util.vala"
		if (e_source_has_extension (_tmp15_, E_SOURCE_EXTENSION_AUTHENTICATION)) {
#line 1220 "Util.c"
			ESourceAuthentication* collection = NULL;
			ESource* _tmp16_;
			ESourceExtension* _tmp17_;
			ESourceAuthentication* _tmp18_;
			ESourceAuthentication* _tmp19_;
			const gchar* _tmp20_;
			const gchar* _tmp21_;
#line 226 "../src/Services/CalendarEvents/Util.vala"
			_tmp16_ = parent_source;
#line 226 "../src/Services/CalendarEvents/Util.vala"
			_tmp17_ = e_source_get_extension (_tmp16_, E_SOURCE_EXTENSION_AUTHENTICATION);
#line 226 "../src/Services/CalendarEvents/Util.vala"
			_tmp18_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp17_, e_source_authentication_get_type (), ESourceAuthentication));
#line 226 "../src/Services/CalendarEvents/Util.vala"
			collection = _tmp18_;
#line 227 "../src/Services/CalendarEvents/Util.vala"
			_tmp19_ = collection;
#line 227 "../src/Services/CalendarEvents/Util.vala"
			_tmp20_ = e_source_authentication_get_user (_tmp19_);
#line 227 "../src/Services/CalendarEvents/Util.vala"
			_tmp21_ = _tmp20_;
#line 227 "../src/Services/CalendarEvents/Util.vala"
			if (_tmp21_ != NULL) {
#line 1244 "Util.c"
				ESourceAuthentication* _tmp22_;
				const gchar* _tmp23_;
				const gchar* _tmp24_;
				gchar* _tmp25_;
#line 228 "../src/Services/CalendarEvents/Util.vala"
				_tmp22_ = collection;
#line 228 "../src/Services/CalendarEvents/Util.vala"
				_tmp23_ = e_source_authentication_get_user (_tmp22_);
#line 228 "../src/Services/CalendarEvents/Util.vala"
				_tmp24_ = _tmp23_;
#line 228 "../src/Services/CalendarEvents/Util.vala"
				_tmp25_ = g_strdup (_tmp24_);
#line 228 "../src/Services/CalendarEvents/Util.vala"
				result = _tmp25_;
#line 228 "../src/Services/CalendarEvents/Util.vala"
				_g_object_unref0 (collection);
#line 228 "../src/Services/CalendarEvents/Util.vala"
				_g_object_unref0 (parent_source);
#line 228 "../src/Services/CalendarEvents/Util.vala"
				_g_free0 (parent_uid);
#line 228 "../src/Services/CalendarEvents/Util.vala"
				_g_object_unref0 (registry);
#line 228 "../src/Services/CalendarEvents/Util.vala"
				return result;
#line 1269 "Util.c"
			}
#line 225 "../src/Services/CalendarEvents/Util.vala"
			_g_object_unref0 (collection);
#line 1273 "Util.c"
		}
#line 232 "../src/Services/CalendarEvents/Util.vala"
		_tmp26_ = parent_source;
#line 232 "../src/Services/CalendarEvents/Util.vala"
		if (e_source_has_extension (_tmp26_, E_SOURCE_EXTENSION_COLLECTION)) {
#line 1279 "Util.c"
			ESourceCollection* collection = NULL;
			ESource* _tmp27_;
			ESourceExtension* _tmp28_;
			ESourceCollection* _tmp29_;
			ESourceCollection* _tmp30_;
			const gchar* _tmp31_;
			const gchar* _tmp32_;
#line 233 "../src/Services/CalendarEvents/Util.vala"
			_tmp27_ = parent_source;
#line 233 "../src/Services/CalendarEvents/Util.vala"
			_tmp28_ = e_source_get_extension (_tmp27_, E_SOURCE_EXTENSION_COLLECTION);
#line 233 "../src/Services/CalendarEvents/Util.vala"
			_tmp29_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp28_, e_source_collection_get_type (), ESourceCollection));
#line 233 "../src/Services/CalendarEvents/Util.vala"
			collection = _tmp29_;
#line 234 "../src/Services/CalendarEvents/Util.vala"
			_tmp30_ = collection;
#line 234 "../src/Services/CalendarEvents/Util.vala"
			_tmp31_ = e_source_collection_get_identity (_tmp30_);
#line 234 "../src/Services/CalendarEvents/Util.vala"
			_tmp32_ = _tmp31_;
#line 234 "../src/Services/CalendarEvents/Util.vala"
			if (_tmp32_ != NULL) {
#line 1303 "Util.c"
				ESourceCollection* _tmp33_;
				const gchar* _tmp34_;
				const gchar* _tmp35_;
				gchar* _tmp36_;
#line 235 "../src/Services/CalendarEvents/Util.vala"
				_tmp33_ = collection;
#line 235 "../src/Services/CalendarEvents/Util.vala"
				_tmp34_ = e_source_collection_get_identity (_tmp33_);
#line 235 "../src/Services/CalendarEvents/Util.vala"
				_tmp35_ = _tmp34_;
#line 235 "../src/Services/CalendarEvents/Util.vala"
				_tmp36_ = g_strdup (_tmp35_);
#line 235 "../src/Services/CalendarEvents/Util.vala"
				result = _tmp36_;
#line 235 "../src/Services/CalendarEvents/Util.vala"
				_g_object_unref0 (collection);
#line 235 "../src/Services/CalendarEvents/Util.vala"
				_g_object_unref0 (parent_source);
#line 235 "../src/Services/CalendarEvents/Util.vala"
				_g_free0 (parent_uid);
#line 235 "../src/Services/CalendarEvents/Util.vala"
				_g_object_unref0 (registry);
#line 235 "../src/Services/CalendarEvents/Util.vala"
				return result;
#line 1328 "Util.c"
			}
#line 232 "../src/Services/CalendarEvents/Util.vala"
			_g_object_unref0 (collection);
#line 1332 "Util.c"
		}
#line 239 "../src/Services/CalendarEvents/Util.vala"
		_tmp37_ = parent_uid;
#line 239 "../src/Services/CalendarEvents/Util.vala"
		if (_tmp37_ == NULL) {
#line 240 "../src/Services/CalendarEvents/Util.vala"
			break;
#line 1340 "Util.c"
		}
#line 242 "../src/Services/CalendarEvents/Util.vala"
		_tmp38_ = registry;
#line 242 "../src/Services/CalendarEvents/Util.vala"
		_tmp39_ = parent_uid;
#line 242 "../src/Services/CalendarEvents/Util.vala"
		_tmp40_ = e_source_registry_ref_source (_tmp38_, _tmp39_);
#line 242 "../src/Services/CalendarEvents/Util.vala"
		_g_object_unref0 (parent_source);
#line 242 "../src/Services/CalendarEvents/Util.vala"
		parent_source = _tmp40_;
#line 1352 "Util.c"
	}
#line 245 "../src/Services/CalendarEvents/Util.vala"
	_tmp41_ = g_strdup (_ ("On this computer"));
#line 245 "../src/Services/CalendarEvents/Util.vala"
	result = _tmp41_;
#line 245 "../src/Services/CalendarEvents/Util.vala"
	_g_object_unref0 (parent_source);
#line 245 "../src/Services/CalendarEvents/Util.vala"
	_g_free0 (parent_uid);
#line 245 "../src/Services/CalendarEvents/Util.vala"
	_g_object_unref0 (registry);
#line 245 "../src/Services/CalendarEvents/Util.vala"
	return result;
#line 1366 "Util.c"
}

