/* EditableLabel.c generated by valac 0.56.18, the Vala compiler
 * generated from EditableLabel.vala, do not modify */

/*
* Copyright © 2023 Alain M. (https://github.com/alainm23/planify)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 3 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*
* Authored by: Alain M. <alainmh23@gmail.com>
*/

#include <gtk/gtk.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include "planify.h"
#include <pango/pango.h>
#include <float.h>
#include <math.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define WIDGETS_TYPE_EDITABLE_LABEL (widgets_editable_label_get_type ())
#define WIDGETS_EDITABLE_LABEL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), WIDGETS_TYPE_EDITABLE_LABEL, WidgetsEditableLabel))
#define WIDGETS_EDITABLE_LABEL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), WIDGETS_TYPE_EDITABLE_LABEL, WidgetsEditableLabelClass))
#define WIDGETS_IS_EDITABLE_LABEL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), WIDGETS_TYPE_EDITABLE_LABEL))
#define WIDGETS_IS_EDITABLE_LABEL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), WIDGETS_TYPE_EDITABLE_LABEL))
#define WIDGETS_EDITABLE_LABEL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), WIDGETS_TYPE_EDITABLE_LABEL, WidgetsEditableLabelClass))

typedef struct _WidgetsEditableLabel WidgetsEditableLabel;
typedef struct _WidgetsEditableLabelClass WidgetsEditableLabelClass;
typedef struct _WidgetsEditableLabelPrivate WidgetsEditableLabelPrivate;
enum  {
	WIDGETS_EDITABLE_LABEL_0_PROPERTY,
	WIDGETS_EDITABLE_LABEL_PLACEHOLDER_TEXT_PROPERTY,
	WIDGETS_EDITABLE_LABEL_AUTO_FOCUS_PROPERTY,
	WIDGETS_EDITABLE_LABEL_TEXT_PROPERTY,
	WIDGETS_EDITABLE_LABEL_ENTRY_MENU_OPENED_PROPERTY,
	WIDGETS_EDITABLE_LABEL_IS_EDITING_PROPERTY,
	WIDGETS_EDITABLE_LABEL_SHOW_EDIT_PROPERTY,
	WIDGETS_EDITABLE_LABEL_EDITABLE_PROPERTY,
	WIDGETS_EDITABLE_LABEL_NUM_PROPERTIES
};
static GParamSpec* widgets_editable_label_properties[WIDGETS_EDITABLE_LABEL_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
enum  {
	WIDGETS_EDITABLE_LABEL_FOCUS_CHANGED_SIGNAL,
	WIDGETS_EDITABLE_LABEL_CHANGED_SIGNAL,
	WIDGETS_EDITABLE_LABEL_NUM_SIGNALS
};
static guint widgets_editable_label_signals[WIDGETS_EDITABLE_LABEL_NUM_SIGNALS] = {0};

struct _WidgetsEditableLabel {
	GtkGrid parent_instance;
	WidgetsEditableLabelPrivate * priv;
};

struct _WidgetsEditableLabelClass {
	GtkGridClass parent_class;
};

struct _WidgetsEditableLabelPrivate {
	gchar* _placeholder_text;
	gboolean _auto_focus;
	GtkLabel* title;
	WidgetsEntry* entry;
	GtkStack* stack;
	GtkBox* grid;
	GtkRevealer* edit_revealer;
	gchar* _text;
	gboolean _entry_menu_opened;
};

static gint WidgetsEditableLabel_private_offset;
static gpointer widgets_editable_label_parent_class = NULL;

VALA_EXTERN GType widgets_editable_label_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (WidgetsEditableLabel, g_object_unref)
VALA_EXTERN void widgets_editable_label_editing (WidgetsEditableLabel* self,
                                     gboolean value,
                                     gboolean grab_focus);
VALA_EXTERN const gchar* widgets_editable_label_get_text (WidgetsEditableLabel* self);
VALA_EXTERN void widgets_editable_label_set_text (WidgetsEditableLabel* self,
                                      const gchar* value);
VALA_EXTERN WidgetsEditableLabel* widgets_editable_label_new (const gchar* placeholder_text,
                                                  gboolean auto_focus);
VALA_EXTERN WidgetsEditableLabel* widgets_editable_label_construct (GType object_type,
                                                        const gchar* placeholder_text,
                                                        gboolean auto_focus);
VALA_EXTERN void widgets_editable_label_add_style (WidgetsEditableLabel* self,
                                       const gchar* style);
static void widgets_editable_label_handle_focus_in (WidgetsEditableLabel* self);
VALA_EXTERN void widgets_editable_label_update_on_leave (WidgetsEditableLabel* self);
VALA_EXTERN const gchar* widgets_editable_label_get_placeholder_text (WidgetsEditableLabel* self);
static void widgets_editable_label_set_placeholder_text (WidgetsEditableLabel* self,
                                                  const gchar* value);
VALA_EXTERN gboolean widgets_editable_label_get_auto_focus (WidgetsEditableLabel* self);
static void widgets_editable_label_set_auto_focus (WidgetsEditableLabel* self,
                                            gboolean value);
VALA_EXTERN gboolean widgets_editable_label_get_entry_menu_opened (WidgetsEditableLabel* self);
VALA_EXTERN void widgets_editable_label_set_entry_menu_opened (WidgetsEditableLabel* self,
                                                   gboolean value);
VALA_EXTERN gboolean widgets_editable_label_get_is_editing (WidgetsEditableLabel* self);
VALA_EXTERN void widgets_editable_label_set_show_edit (WidgetsEditableLabel* self,
                                           gboolean value);
VALA_EXTERN void widgets_editable_label_set_editable (WidgetsEditableLabel* self,
                                          gboolean value);
static GObject * widgets_editable_label_constructor (GType type,
                                              guint n_construct_properties,
                                              GObjectConstructParam * construct_properties);
static void _widgets_editable_label____lambda787_ (WidgetsEditableLabel* self);
static void __widgets_editable_label____lambda787__gtk_gesture_click_pressed (GtkGestureClick* _sender,
                                                                       gint n_press,
                                                                       gdouble x,
                                                                       gdouble y,
                                                                       gpointer self);
static void _widgets_editable_label___lambda788_ (WidgetsEditableLabel* self);
static void __widgets_editable_label___lambda788__gtk_entry_activate (GtkEntry* _sender,
                                                               gpointer self);
static void _widgets_editable_label_handle_focus_in_gtk_event_controller_focus_enter (GtkEventControllerFocus* _sender,
                                                                               gpointer self);
static void _widgets_editable_label_update_on_leave_gtk_event_controller_focus_leave (GtkEventControllerFocus* _sender,
                                                                               gpointer self);
static void _widgets_editable_label___lambda789_ (WidgetsEditableLabel* self);
static void __widgets_editable_label___lambda789__gtk_event_controller_focus_leave (GtkEventControllerFocus* _sender,
                                                                             gpointer self);
static void widgets_editable_label_finalize (GObject * obj);
static GType widgets_editable_label_get_type_once (void);
static void _vala_widgets_editable_label_get_property (GObject * object,
                                                guint property_id,
                                                GValue * value,
                                                GParamSpec * pspec);
static void _vala_widgets_editable_label_set_property (GObject * object,
                                                guint property_id,
                                                const GValue * value,
                                                GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

static inline gpointer
widgets_editable_label_get_instance_private (WidgetsEditableLabel* self)
{
	return G_STRUCT_MEMBER_P (self, WidgetsEditableLabel_private_offset);
}

static gchar*
string_strip (const gchar* self)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* result;
#line 1413 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1414 "glib-2.0.vapi"
	_tmp0_ = g_strdup (self);
#line 1414 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1415 "glib-2.0.vapi"
	g_strstrip (_result_);
#line 1416 "glib-2.0.vapi"
	result = _result_;
#line 1416 "glib-2.0.vapi"
	return result;
#line 200 "EditableLabel.c"
}

void
widgets_editable_label_editing (WidgetsEditableLabel* self,
                                gboolean value,
                                gboolean grab_focus)
{
#line 50 "../src/Widgets/EditableLabel.vala"
	g_return_if_fail (self != NULL);
#line 51 "../src/Widgets/EditableLabel.vala"
	g_signal_emit (self, widgets_editable_label_signals[WIDGETS_EDITABLE_LABEL_FOCUS_CHANGED_SIGNAL], 0, value);
#line 53 "../src/Widgets/EditableLabel.vala"
	if (value) {
#line 214 "EditableLabel.c"
		WidgetsEntry* _tmp0_;
		const gchar* _tmp1_;
		GtkStack* _tmp2_;
		WidgetsEntry* _tmp3_;
#line 54 "../src/Widgets/EditableLabel.vala"
		_tmp0_ = self->priv->entry;
#line 54 "../src/Widgets/EditableLabel.vala"
		_tmp1_ = self->priv->_text;
#line 54 "../src/Widgets/EditableLabel.vala"
		gtk_editable_set_text ((GtkEditable*) _tmp0_, _tmp1_);
#line 55 "../src/Widgets/EditableLabel.vala"
		_tmp2_ = self->priv->stack;
#line 55 "../src/Widgets/EditableLabel.vala"
		_tmp3_ = self->priv->entry;
#line 55 "../src/Widgets/EditableLabel.vala"
		gtk_stack_set_visible_child (_tmp2_, (GtkWidget*) _tmp3_);
#line 57 "../src/Widgets/EditableLabel.vala"
		if (grab_focus) {
#line 233 "EditableLabel.c"
			WidgetsEntry* _tmp4_;
#line 58 "../src/Widgets/EditableLabel.vala"
			_tmp4_ = self->priv->entry;
#line 58 "../src/Widgets/EditableLabel.vala"
			gtk_widget_grab_focus ((GtkWidget*) _tmp4_);
#line 239 "EditableLabel.c"
		} else {
			WidgetsEntry* _tmp5_;
			WidgetsEntry* _tmp6_;
			gint _tmp7_;
			gint _tmp8_;
			WidgetsEntry* _tmp9_;
			guint _tmp10_;
			guint _tmp11_;
#line 60 "../src/Widgets/EditableLabel.vala"
			_tmp5_ = self->priv->entry;
#line 60 "../src/Widgets/EditableLabel.vala"
			gtk_entry_grab_focus_without_selecting ((GtkEntry*) _tmp5_);
#line 61 "../src/Widgets/EditableLabel.vala"
			_tmp6_ = self->priv->entry;
#line 61 "../src/Widgets/EditableLabel.vala"
			g_object_get ((GtkEditable*) _tmp6_, "cursor-position", &_tmp7_, NULL);
#line 61 "../src/Widgets/EditableLabel.vala"
			_tmp8_ = _tmp7_;
#line 61 "../src/Widgets/EditableLabel.vala"
			_tmp9_ = self->priv->entry;
#line 61 "../src/Widgets/EditableLabel.vala"
			_tmp10_ = gtk_entry_get_text_length ((GtkEntry*) _tmp9_);
#line 61 "../src/Widgets/EditableLabel.vala"
			_tmp11_ = _tmp10_;
#line 61 "../src/Widgets/EditableLabel.vala"
			if (((guint) _tmp8_) < _tmp11_) {
#line 266 "EditableLabel.c"
				WidgetsEntry* _tmp12_;
				WidgetsEntry* _tmp13_;
				guint _tmp14_;
				guint _tmp15_;
#line 62 "../src/Widgets/EditableLabel.vala"
				_tmp12_ = self->priv->entry;
#line 62 "../src/Widgets/EditableLabel.vala"
				_tmp13_ = self->priv->entry;
#line 62 "../src/Widgets/EditableLabel.vala"
				_tmp14_ = gtk_entry_get_text_length ((GtkEntry*) _tmp13_);
#line 62 "../src/Widgets/EditableLabel.vala"
				_tmp15_ = _tmp14_;
#line 62 "../src/Widgets/EditableLabel.vala"
				gtk_editable_set_position ((GtkEditable*) _tmp12_, (gint) ((gint32) _tmp15_));
#line 281 "EditableLabel.c"
			}
		}
	} else {
		gboolean _tmp16_ = FALSE;
		WidgetsEntry* _tmp17_;
		const gchar* _tmp18_;
		const gchar* _tmp19_;
		gchar* _tmp20_;
		gchar* _tmp21_;
		gboolean _tmp22_;
		GtkStack* _tmp30_;
		GtkBox* _tmp31_;
#line 66 "../src/Widgets/EditableLabel.vala"
		_tmp17_ = self->priv->entry;
#line 66 "../src/Widgets/EditableLabel.vala"
		_tmp18_ = gtk_editable_get_text ((GtkEditable*) _tmp17_);
#line 66 "../src/Widgets/EditableLabel.vala"
		_tmp19_ = _tmp18_;
#line 66 "../src/Widgets/EditableLabel.vala"
		_tmp20_ = string_strip (_tmp19_);
#line 66 "../src/Widgets/EditableLabel.vala"
		_tmp21_ = _tmp20_;
#line 66 "../src/Widgets/EditableLabel.vala"
		_tmp22_ = g_strcmp0 (_tmp21_, "") != 0;
#line 66 "../src/Widgets/EditableLabel.vala"
		_g_free0 (_tmp21_);
#line 66 "../src/Widgets/EditableLabel.vala"
		if (_tmp22_) {
#line 310 "EditableLabel.c"
			const gchar* _tmp23_;
			WidgetsEntry* _tmp24_;
			const gchar* _tmp25_;
			const gchar* _tmp26_;
#line 66 "../src/Widgets/EditableLabel.vala"
			_tmp23_ = self->priv->_text;
#line 66 "../src/Widgets/EditableLabel.vala"
			_tmp24_ = self->priv->entry;
#line 66 "../src/Widgets/EditableLabel.vala"
			_tmp25_ = gtk_editable_get_text ((GtkEditable*) _tmp24_);
#line 66 "../src/Widgets/EditableLabel.vala"
			_tmp26_ = _tmp25_;
#line 66 "../src/Widgets/EditableLabel.vala"
			_tmp16_ = g_strcmp0 (_tmp23_, _tmp26_) != 0;
#line 325 "EditableLabel.c"
		} else {
#line 66 "../src/Widgets/EditableLabel.vala"
			_tmp16_ = FALSE;
#line 329 "EditableLabel.c"
		}
#line 66 "../src/Widgets/EditableLabel.vala"
		if (_tmp16_) {
#line 333 "EditableLabel.c"
			WidgetsEntry* _tmp27_;
			const gchar* _tmp28_;
			const gchar* _tmp29_;
#line 67 "../src/Widgets/EditableLabel.vala"
			_tmp27_ = self->priv->entry;
#line 67 "../src/Widgets/EditableLabel.vala"
			_tmp28_ = gtk_editable_get_text ((GtkEditable*) _tmp27_);
#line 67 "../src/Widgets/EditableLabel.vala"
			_tmp29_ = _tmp28_;
#line 67 "../src/Widgets/EditableLabel.vala"
			widgets_editable_label_set_text (self, _tmp29_);
#line 68 "../src/Widgets/EditableLabel.vala"
			g_signal_emit (self, widgets_editable_label_signals[WIDGETS_EDITABLE_LABEL_CHANGED_SIGNAL], 0);
#line 347 "EditableLabel.c"
		}
#line 71 "../src/Widgets/EditableLabel.vala"
		_tmp30_ = self->priv->stack;
#line 71 "../src/Widgets/EditableLabel.vala"
		_tmp31_ = self->priv->grid;
#line 71 "../src/Widgets/EditableLabel.vala"
		gtk_stack_set_visible_child (_tmp30_, (GtkWidget*) _tmp31_);
#line 355 "EditableLabel.c"
	}
}

WidgetsEditableLabel*
widgets_editable_label_construct (GType object_type,
                                  const gchar* placeholder_text,
                                  gboolean auto_focus)
{
	WidgetsEditableLabel * self = NULL;
#line 81 "../src/Widgets/EditableLabel.vala"
	g_return_val_if_fail (placeholder_text != NULL, NULL);
#line 82 "../src/Widgets/EditableLabel.vala"
	self = (WidgetsEditableLabel*) g_object_new (object_type, "placeholder-text", placeholder_text, "auto-focus", auto_focus, NULL);
#line 81 "../src/Widgets/EditableLabel.vala"
	return self;
#line 371 "EditableLabel.c"
}

WidgetsEditableLabel*
widgets_editable_label_new (const gchar* placeholder_text,
                            gboolean auto_focus)
{
#line 81 "../src/Widgets/EditableLabel.vala"
	return widgets_editable_label_construct (WIDGETS_TYPE_EDITABLE_LABEL, placeholder_text, auto_focus);
#line 380 "EditableLabel.c"
}

void
widgets_editable_label_add_style (WidgetsEditableLabel* self,
                                  const gchar* style)
{
	GtkStack* _tmp0_;
#line 156 "../src/Widgets/EditableLabel.vala"
	g_return_if_fail (self != NULL);
#line 156 "../src/Widgets/EditableLabel.vala"
	g_return_if_fail (style != NULL);
#line 157 "../src/Widgets/EditableLabel.vala"
	_tmp0_ = self->priv->stack;
#line 157 "../src/Widgets/EditableLabel.vala"
	gtk_widget_add_css_class ((GtkWidget*) _tmp0_, style);
#line 396 "EditableLabel.c"
}

static void
widgets_editable_label_handle_focus_in (WidgetsEditableLabel* self)
{
	ServicesEventBus* _tmp0_;
	ServicesEventBus* _tmp1_;
#line 160 "../src/Widgets/EditableLabel.vala"
	g_return_if_fail (self != NULL);
#line 161 "../src/Widgets/EditableLabel.vala"
	_tmp0_ = services_event_bus_get_default ();
#line 161 "../src/Widgets/EditableLabel.vala"
	_tmp1_ = _tmp0_;
#line 161 "../src/Widgets/EditableLabel.vala"
	g_signal_emit_by_name (_tmp1_, "disconnect-typing-accel");
#line 161 "../src/Widgets/EditableLabel.vala"
	_g_object_unref0 (_tmp1_);
#line 414 "EditableLabel.c"
}

void
widgets_editable_label_update_on_leave (WidgetsEditableLabel* self)
{
	ServicesEventBus* _tmp0_;
	ServicesEventBus* _tmp1_;
#line 164 "../src/Widgets/EditableLabel.vala"
	g_return_if_fail (self != NULL);
#line 165 "../src/Widgets/EditableLabel.vala"
	_tmp0_ = services_event_bus_get_default ();
#line 165 "../src/Widgets/EditableLabel.vala"
	_tmp1_ = _tmp0_;
#line 165 "../src/Widgets/EditableLabel.vala"
	g_signal_emit_by_name (_tmp1_, "connect-typing-accel");
#line 165 "../src/Widgets/EditableLabel.vala"
	_g_object_unref0 (_tmp1_);
#line 432 "EditableLabel.c"
}

const gchar*
widgets_editable_label_get_placeholder_text (WidgetsEditableLabel* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 23 "../src/Widgets/EditableLabel.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 23 "../src/Widgets/EditableLabel.vala"
	_tmp0_ = self->priv->_placeholder_text;
#line 23 "../src/Widgets/EditableLabel.vala"
	result = _tmp0_;
#line 23 "../src/Widgets/EditableLabel.vala"
	return result;
#line 448 "EditableLabel.c"
}

static void
widgets_editable_label_set_placeholder_text (WidgetsEditableLabel* self,
                                             const gchar* value)
{
	gchar* old_value;
#line 23 "../src/Widgets/EditableLabel.vala"
	g_return_if_fail (self != NULL);
#line 23 "../src/Widgets/EditableLabel.vala"
	old_value = widgets_editable_label_get_placeholder_text (self);
#line 23 "../src/Widgets/EditableLabel.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 462 "EditableLabel.c"
		gchar* _tmp0_;
#line 23 "../src/Widgets/EditableLabel.vala"
		_tmp0_ = g_strdup (value);
#line 23 "../src/Widgets/EditableLabel.vala"
		_g_free0 (self->priv->_placeholder_text);
#line 23 "../src/Widgets/EditableLabel.vala"
		self->priv->_placeholder_text = _tmp0_;
#line 23 "../src/Widgets/EditableLabel.vala"
		g_object_notify_by_pspec ((GObject *) self, widgets_editable_label_properties[WIDGETS_EDITABLE_LABEL_PLACEHOLDER_TEXT_PROPERTY]);
#line 472 "EditableLabel.c"
	}
}

gboolean
widgets_editable_label_get_auto_focus (WidgetsEditableLabel* self)
{
	gboolean result;
#line 24 "../src/Widgets/EditableLabel.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 24 "../src/Widgets/EditableLabel.vala"
	result = self->priv->_auto_focus;
#line 24 "../src/Widgets/EditableLabel.vala"
	return result;
#line 486 "EditableLabel.c"
}

static void
widgets_editable_label_set_auto_focus (WidgetsEditableLabel* self,
                                       gboolean value)
{
	gboolean old_value;
#line 24 "../src/Widgets/EditableLabel.vala"
	g_return_if_fail (self != NULL);
#line 24 "../src/Widgets/EditableLabel.vala"
	old_value = widgets_editable_label_get_auto_focus (self);
#line 24 "../src/Widgets/EditableLabel.vala"
	if (old_value != value) {
#line 24 "../src/Widgets/EditableLabel.vala"
		self->priv->_auto_focus = value;
#line 24 "../src/Widgets/EditableLabel.vala"
		g_object_notify_by_pspec ((GObject *) self, widgets_editable_label_properties[WIDGETS_EDITABLE_LABEL_AUTO_FOCUS_PROPERTY]);
#line 504 "EditableLabel.c"
	}
}

const gchar*
widgets_editable_label_get_text (WidgetsEditableLabel* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 35 "../src/Widgets/EditableLabel.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 35 "../src/Widgets/EditableLabel.vala"
	_tmp0_ = self->priv->_text;
#line 35 "../src/Widgets/EditableLabel.vala"
	result = _tmp0_;
#line 35 "../src/Widgets/EditableLabel.vala"
	return result;
#line 521 "EditableLabel.c"
}

void
widgets_editable_label_set_text (WidgetsEditableLabel* self,
                                 const gchar* value)
{
	gchar* old_value;
#line 35 "../src/Widgets/EditableLabel.vala"
	g_return_if_fail (self != NULL);
#line 35 "../src/Widgets/EditableLabel.vala"
	old_value = widgets_editable_label_get_text (self);
#line 35 "../src/Widgets/EditableLabel.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 535 "EditableLabel.c"
		gchar* _tmp0_;
#line 35 "../src/Widgets/EditableLabel.vala"
		_tmp0_ = g_strdup (value);
#line 35 "../src/Widgets/EditableLabel.vala"
		_g_free0 (self->priv->_text);
#line 35 "../src/Widgets/EditableLabel.vala"
		self->priv->_text = _tmp0_;
#line 35 "../src/Widgets/EditableLabel.vala"
		g_object_notify_by_pspec ((GObject *) self, widgets_editable_label_properties[WIDGETS_EDITABLE_LABEL_TEXT_PROPERTY]);
#line 545 "EditableLabel.c"
	}
}

gboolean
widgets_editable_label_get_entry_menu_opened (WidgetsEditableLabel* self)
{
	gboolean result;
#line 36 "../src/Widgets/EditableLabel.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 36 "../src/Widgets/EditableLabel.vala"
	result = self->priv->_entry_menu_opened;
#line 36 "../src/Widgets/EditableLabel.vala"
	return result;
#line 559 "EditableLabel.c"
}

void
widgets_editable_label_set_entry_menu_opened (WidgetsEditableLabel* self,
                                              gboolean value)
{
	gboolean old_value;
#line 36 "../src/Widgets/EditableLabel.vala"
	g_return_if_fail (self != NULL);
#line 36 "../src/Widgets/EditableLabel.vala"
	old_value = widgets_editable_label_get_entry_menu_opened (self);
#line 36 "../src/Widgets/EditableLabel.vala"
	if (old_value != value) {
#line 36 "../src/Widgets/EditableLabel.vala"
		self->priv->_entry_menu_opened = value;
#line 36 "../src/Widgets/EditableLabel.vala"
		g_object_notify_by_pspec ((GObject *) self, widgets_editable_label_properties[WIDGETS_EDITABLE_LABEL_ENTRY_MENU_OPENED_PROPERTY]);
#line 577 "EditableLabel.c"
	}
}

gboolean
widgets_editable_label_get_is_editing (WidgetsEditableLabel* self)
{
	gboolean result;
	GtkStack* _tmp0_;
	GtkWidget* _tmp1_;
	GtkWidget* _tmp2_;
	WidgetsEntry* _tmp3_;
#line 39 "../src/Widgets/EditableLabel.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 40 "../src/Widgets/EditableLabel.vala"
	_tmp0_ = self->priv->stack;
#line 40 "../src/Widgets/EditableLabel.vala"
	_tmp1_ = gtk_stack_get_visible_child (_tmp0_);
#line 40 "../src/Widgets/EditableLabel.vala"
	_tmp2_ = _tmp1_;
#line 40 "../src/Widgets/EditableLabel.vala"
	_tmp3_ = self->priv->entry;
#line 40 "../src/Widgets/EditableLabel.vala"
	result = _tmp2_ == G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, gtk_widget_get_type (), GtkWidget);
#line 40 "../src/Widgets/EditableLabel.vala"
	return result;
#line 603 "EditableLabel.c"
}

void
widgets_editable_label_set_show_edit (WidgetsEditableLabel* self,
                                      gboolean value)
{
	GtkRevealer* _tmp0_;
#line 45 "../src/Widgets/EditableLabel.vala"
	g_return_if_fail (self != NULL);
#line 46 "../src/Widgets/EditableLabel.vala"
	_tmp0_ = self->priv->edit_revealer;
#line 46 "../src/Widgets/EditableLabel.vala"
	gtk_revealer_set_reveal_child (_tmp0_, value);
#line 45 "../src/Widgets/EditableLabel.vala"
	g_object_notify_by_pspec ((GObject *) self, widgets_editable_label_properties[WIDGETS_EDITABLE_LABEL_SHOW_EDIT_PROPERTY]);
#line 619 "EditableLabel.c"
}

void
widgets_editable_label_set_editable (WidgetsEditableLabel* self,
                                     gboolean value)
{
	WidgetsEntry* _tmp0_;
#line 76 "../src/Widgets/EditableLabel.vala"
	g_return_if_fail (self != NULL);
#line 77 "../src/Widgets/EditableLabel.vala"
	_tmp0_ = self->priv->entry;
#line 77 "../src/Widgets/EditableLabel.vala"
	gtk_editable_set_editable ((GtkEditable*) _tmp0_, value);
#line 76 "../src/Widgets/EditableLabel.vala"
	g_object_notify_by_pspec ((GObject *) self, widgets_editable_label_properties[WIDGETS_EDITABLE_LABEL_EDITABLE_PROPERTY]);
#line 635 "EditableLabel.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 99 "../src/Widgets/EditableLabel.vala"
	return self ? g_object_ref (self) : NULL;
#line 643 "EditableLabel.c"
}

static void
_widgets_editable_label____lambda787_ (WidgetsEditableLabel* self)
{
#line 133 "../src/Widgets/EditableLabel.vala"
	widgets_editable_label_editing (self, TRUE, FALSE);
#line 651 "EditableLabel.c"
}

static void
__widgets_editable_label____lambda787__gtk_gesture_click_pressed (GtkGestureClick* _sender,
                                                                  gint n_press,
                                                                  gdouble x,
                                                                  gdouble y,
                                                                  gpointer self)
{
#line 132 "../src/Widgets/EditableLabel.vala"
	_widgets_editable_label____lambda787_ ((WidgetsEditableLabel*) self);
#line 663 "EditableLabel.c"
}

static void
_widgets_editable_label___lambda788_ (WidgetsEditableLabel* self)
{
	GtkStack* _tmp0_;
	GtkWidget* _tmp1_;
	GtkWidget* _tmp2_;
	WidgetsEntry* _tmp3_;
#line 138 "../src/Widgets/EditableLabel.vala"
	_tmp0_ = self->priv->stack;
#line 138 "../src/Widgets/EditableLabel.vala"
	_tmp1_ = gtk_stack_get_visible_child (_tmp0_);
#line 138 "../src/Widgets/EditableLabel.vala"
	_tmp2_ = _tmp1_;
#line 138 "../src/Widgets/EditableLabel.vala"
	_tmp3_ = self->priv->entry;
#line 138 "../src/Widgets/EditableLabel.vala"
	if (_tmp2_ == G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, gtk_widget_get_type (), GtkWidget)) {
#line 139 "../src/Widgets/EditableLabel.vala"
		widgets_editable_label_editing (self, FALSE, FALSE);
#line 685 "EditableLabel.c"
	}
}

static void
__widgets_editable_label___lambda788__gtk_entry_activate (GtkEntry* _sender,
                                                          gpointer self)
{
#line 137 "../src/Widgets/EditableLabel.vala"
	_widgets_editable_label___lambda788_ ((WidgetsEditableLabel*) self);
#line 695 "EditableLabel.c"
}

static void
_widgets_editable_label_handle_focus_in_gtk_event_controller_focus_enter (GtkEventControllerFocus* _sender,
                                                                          gpointer self)
{
#line 146 "../src/Widgets/EditableLabel.vala"
	widgets_editable_label_handle_focus_in ((WidgetsEditableLabel*) self);
#line 704 "EditableLabel.c"
}

static void
_widgets_editable_label_update_on_leave_gtk_event_controller_focus_leave (GtkEventControllerFocus* _sender,
                                                                          gpointer self)
{
#line 147 "../src/Widgets/EditableLabel.vala"
	widgets_editable_label_update_on_leave ((WidgetsEditableLabel*) self);
#line 713 "EditableLabel.c"
}

static void
_widgets_editable_label___lambda789_ (WidgetsEditableLabel* self)
{
	gboolean _tmp0_ = FALSE;
	GtkStack* _tmp1_;
	GtkWidget* _tmp2_;
	GtkWidget* _tmp3_;
	WidgetsEntry* _tmp4_;
#line 150 "../src/Widgets/EditableLabel.vala"
	_tmp1_ = self->priv->stack;
#line 150 "../src/Widgets/EditableLabel.vala"
	_tmp2_ = gtk_stack_get_visible_child (_tmp1_);
#line 150 "../src/Widgets/EditableLabel.vala"
	_tmp3_ = _tmp2_;
#line 150 "../src/Widgets/EditableLabel.vala"
	_tmp4_ = self->priv->entry;
#line 150 "../src/Widgets/EditableLabel.vala"
	if (_tmp3_ == G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, gtk_widget_get_type (), GtkWidget)) {
#line 734 "EditableLabel.c"
		gboolean _tmp5_;
#line 150 "../src/Widgets/EditableLabel.vala"
		_tmp5_ = self->priv->_entry_menu_opened;
#line 150 "../src/Widgets/EditableLabel.vala"
		_tmp0_ = !_tmp5_;
#line 740 "EditableLabel.c"
	} else {
#line 150 "../src/Widgets/EditableLabel.vala"
		_tmp0_ = FALSE;
#line 744 "EditableLabel.c"
	}
#line 150 "../src/Widgets/EditableLabel.vala"
	if (_tmp0_) {
#line 151 "../src/Widgets/EditableLabel.vala"
		widgets_editable_label_editing (self, FALSE, FALSE);
#line 750 "EditableLabel.c"
	}
}

static void
__widgets_editable_label___lambda789__gtk_event_controller_focus_leave (GtkEventControllerFocus* _sender,
                                                                        gpointer self)
{
#line 149 "../src/Widgets/EditableLabel.vala"
	_widgets_editable_label___lambda789_ ((WidgetsEditableLabel*) self);
#line 760 "EditableLabel.c"
}

static GObject *
widgets_editable_label_constructor (GType type,
                                    guint n_construct_properties,
                                    GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	WidgetsEditableLabel * self;
	GtkLabel* _tmp0_ = NULL;
	GtkImage* edit_icon = NULL;
	gchar* _tmp1_;
	gchar** _tmp2_;
	GtkImage* _tmp3_ = NULL;
	GtkImage* _tmp4_;
	GtkWidget* _tmp5_;
	GtkRevealer* _tmp6_ = NULL;
	GtkBox* _tmp7_ = NULL;
	GtkBox* _tmp8_;
	GtkLabel* _tmp9_;
	GtkBox* _tmp10_;
	GtkRevealer* _tmp11_;
	const gchar* _tmp12_;
	gchar* _tmp13_;
	gchar* _tmp14_;
	gchar** _tmp15_;
	WidgetsEntry* _tmp16_ = NULL;
	GtkStack* _tmp17_ = NULL;
	GtkStack* _tmp18_;
	GtkBox* _tmp19_;
	GtkStack* _tmp20_;
	WidgetsEntry* _tmp21_;
	GtkStack* _tmp22_;
	GtkLabel* _tmp23_;
	gboolean _tmp24_;
	WidgetsEntry* _tmp29_;
	GtkEventControllerFocus* gesture = NULL;
	GtkEventControllerFocus* _tmp30_;
	WidgetsEntry* _tmp31_;
	GtkEventControllerFocus* _tmp32_;
	GtkEventController* _tmp33_;
	GtkEventControllerFocus* _tmp34_;
	GtkEventControllerFocus* _tmp35_;
	GtkEventControllerFocus* _tmp36_;
#line 88 "../src/Widgets/EditableLabel.vala"
	parent_class = G_OBJECT_CLASS (widgets_editable_label_parent_class);
#line 88 "../src/Widgets/EditableLabel.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 88 "../src/Widgets/EditableLabel.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, WIDGETS_TYPE_EDITABLE_LABEL, WidgetsEditableLabel);
#line 89 "../src/Widgets/EditableLabel.vala"
	_tmp0_ = (GtkLabel*) gtk_label_new (NULL);
#line 89 "../src/Widgets/EditableLabel.vala"
	gtk_label_set_ellipsize (_tmp0_, PANGO_ELLIPSIZE_END);
#line 89 "../src/Widgets/EditableLabel.vala"
	gtk_label_set_xalign (_tmp0_, (gfloat) 0);
#line 89 "../src/Widgets/EditableLabel.vala"
	g_object_ref_sink (_tmp0_);
#line 89 "../src/Widgets/EditableLabel.vala"
	_g_object_unref0 (self->priv->title);
#line 89 "../src/Widgets/EditableLabel.vala"
	self->priv->title = _tmp0_;
#line 94 "../src/Widgets/EditableLabel.vala"
	_tmp1_ = g_strdup ("dim-label");
#line 94 "../src/Widgets/EditableLabel.vala"
	_tmp2_ = g_new0 (gchar*, 1 + 1);
#line 94 "../src/Widgets/EditableLabel.vala"
	_tmp2_[0] = _tmp1_;
#line 94 "../src/Widgets/EditableLabel.vala"
	_tmp3_ = (GtkImage*) gtk_image_new_from_icon_name ("edit-symbolic");
#line 94 "../src/Widgets/EditableLabel.vala"
	gtk_widget_set_css_classes ((GtkWidget*) _tmp3_, _tmp2_);
#line 94 "../src/Widgets/EditableLabel.vala"
	_tmp2_ = (_vala_array_free (_tmp2_, 1, (GDestroyNotify) g_free), NULL);
#line 94 "../src/Widgets/EditableLabel.vala"
	gtk_image_set_pixel_size (_tmp3_, 16);
#line 94 "../src/Widgets/EditableLabel.vala"
	g_object_ref_sink (_tmp3_);
#line 94 "../src/Widgets/EditableLabel.vala"
	edit_icon = _tmp3_;
#line 99 "../src/Widgets/EditableLabel.vala"
	_tmp4_ = edit_icon;
#line 99 "../src/Widgets/EditableLabel.vala"
	_tmp5_ = _g_object_ref0 ((GtkWidget*) _tmp4_);
#line 99 "../src/Widgets/EditableLabel.vala"
	_tmp6_ = (GtkRevealer*) gtk_revealer_new ();
#line 99 "../src/Widgets/EditableLabel.vala"
	gtk_revealer_set_transition_type (_tmp6_, GTK_REVEALER_TRANSITION_TYPE_CROSSFADE);
#line 99 "../src/Widgets/EditableLabel.vala"
	gtk_revealer_set_child (_tmp6_, _tmp5_);
#line 99 "../src/Widgets/EditableLabel.vala"
	_g_object_unref0 (_tmp5_);
#line 99 "../src/Widgets/EditableLabel.vala"
	g_object_ref_sink (_tmp6_);
#line 99 "../src/Widgets/EditableLabel.vala"
	_g_object_unref0 (self->priv->edit_revealer);
#line 99 "../src/Widgets/EditableLabel.vala"
	self->priv->edit_revealer = _tmp6_;
#line 104 "../src/Widgets/EditableLabel.vala"
	_tmp7_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 12);
#line 104 "../src/Widgets/EditableLabel.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp7_, GTK_ALIGN_CENTER);
#line 104 "../src/Widgets/EditableLabel.vala"
	g_object_ref_sink (_tmp7_);
#line 104 "../src/Widgets/EditableLabel.vala"
	_g_object_unref0 (self->priv->grid);
#line 104 "../src/Widgets/EditableLabel.vala"
	self->priv->grid = _tmp7_;
#line 108 "../src/Widgets/EditableLabel.vala"
	_tmp8_ = self->priv->grid;
#line 108 "../src/Widgets/EditableLabel.vala"
	_tmp9_ = self->priv->title;
#line 108 "../src/Widgets/EditableLabel.vala"
	gtk_box_append (_tmp8_, (GtkWidget*) _tmp9_);
#line 109 "../src/Widgets/EditableLabel.vala"
	_tmp10_ = self->priv->grid;
#line 109 "../src/Widgets/EditableLabel.vala"
	_tmp11_ = self->priv->edit_revealer;
#line 109 "../src/Widgets/EditableLabel.vala"
	gtk_box_append (_tmp10_, (GtkWidget*) _tmp11_);
#line 111 "../src/Widgets/EditableLabel.vala"
	_tmp12_ = self->priv->_placeholder_text;
#line 111 "../src/Widgets/EditableLabel.vala"
	_tmp13_ = g_strdup (_tmp12_);
#line 111 "../src/Widgets/EditableLabel.vala"
	_tmp14_ = g_strdup ("editable-label");
#line 111 "../src/Widgets/EditableLabel.vala"
	_tmp15_ = g_new0 (gchar*, 1 + 1);
#line 111 "../src/Widgets/EditableLabel.vala"
	_tmp15_[0] = _tmp14_;
#line 111 "../src/Widgets/EditableLabel.vala"
	_tmp16_ = widgets_entry_new ();
#line 111 "../src/Widgets/EditableLabel.vala"
	gtk_entry_set_placeholder_text ((GtkEntry*) _tmp16_, _tmp13_);
#line 111 "../src/Widgets/EditableLabel.vala"
	_g_free0 (_tmp13_);
#line 111 "../src/Widgets/EditableLabel.vala"
	gtk_widget_set_css_classes ((GtkWidget*) _tmp16_, _tmp15_);
#line 111 "../src/Widgets/EditableLabel.vala"
	_tmp15_ = (_vala_array_free (_tmp15_, 1, (GDestroyNotify) g_free), NULL);
#line 111 "../src/Widgets/EditableLabel.vala"
	g_object_ref_sink (_tmp16_);
#line 111 "../src/Widgets/EditableLabel.vala"
	_g_object_unref0 (self->priv->entry);
#line 111 "../src/Widgets/EditableLabel.vala"
	self->priv->entry = _tmp16_;
#line 116 "../src/Widgets/EditableLabel.vala"
	_tmp17_ = (GtkStack*) gtk_stack_new ();
#line 116 "../src/Widgets/EditableLabel.vala"
	gtk_stack_set_transition_type (_tmp17_, GTK_STACK_TRANSITION_TYPE_CROSSFADE);
#line 116 "../src/Widgets/EditableLabel.vala"
	gtk_stack_set_transition_duration (_tmp17_, (guint) 115);
#line 116 "../src/Widgets/EditableLabel.vala"
	gtk_widget_set_hexpand ((GtkWidget*) _tmp17_, TRUE);
#line 116 "../src/Widgets/EditableLabel.vala"
	g_object_ref_sink (_tmp17_);
#line 116 "../src/Widgets/EditableLabel.vala"
	_g_object_unref0 (self->priv->stack);
#line 116 "../src/Widgets/EditableLabel.vala"
	self->priv->stack = _tmp17_;
#line 122 "../src/Widgets/EditableLabel.vala"
	_tmp18_ = self->priv->stack;
#line 122 "../src/Widgets/EditableLabel.vala"
	_tmp19_ = self->priv->grid;
#line 122 "../src/Widgets/EditableLabel.vala"
	gtk_stack_add_child (_tmp18_, (GtkWidget*) _tmp19_);
#line 123 "../src/Widgets/EditableLabel.vala"
	_tmp20_ = self->priv->stack;
#line 123 "../src/Widgets/EditableLabel.vala"
	_tmp21_ = self->priv->entry;
#line 123 "../src/Widgets/EditableLabel.vala"
	gtk_stack_add_child (_tmp20_, (GtkWidget*) _tmp21_);
#line 125 "../src/Widgets/EditableLabel.vala"
	_tmp22_ = self->priv->stack;
#line 125 "../src/Widgets/EditableLabel.vala"
	gtk_grid_attach ((GtkGrid*) self, (GtkWidget*) _tmp22_, 0, 0, 1, 1);
#line 127 "../src/Widgets/EditableLabel.vala"
	_tmp23_ = self->priv->title;
#line 127 "../src/Widgets/EditableLabel.vala"
	g_object_bind_property_with_closures ((GObject*) self, "text", (GObject*) _tmp23_, "label", G_BINDING_DEFAULT, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
#line 129 "../src/Widgets/EditableLabel.vala"
	_tmp24_ = self->priv->_auto_focus;
#line 129 "../src/Widgets/EditableLabel.vala"
	if (_tmp24_) {
#line 946 "EditableLabel.c"
		GtkGestureClick* gesture_click = NULL;
		GtkGestureClick* _tmp25_;
		GtkGestureClick* _tmp26_;
		GtkEventController* _tmp27_;
		GtkGestureClick* _tmp28_;
#line 130 "../src/Widgets/EditableLabel.vala"
		_tmp25_ = (GtkGestureClick*) gtk_gesture_click_new ();
#line 130 "../src/Widgets/EditableLabel.vala"
		gesture_click = _tmp25_;
#line 131 "../src/Widgets/EditableLabel.vala"
		_tmp26_ = gesture_click;
#line 131 "../src/Widgets/EditableLabel.vala"
		_tmp27_ = _g_object_ref0 ((GtkEventController*) _tmp26_);
#line 131 "../src/Widgets/EditableLabel.vala"
		gtk_widget_add_controller ((GtkWidget*) self, _tmp27_);
#line 132 "../src/Widgets/EditableLabel.vala"
		_tmp28_ = gesture_click;
#line 132 "../src/Widgets/EditableLabel.vala"
		g_signal_connect_object (_tmp28_, "pressed", (GCallback) __widgets_editable_label____lambda787__gtk_gesture_click_pressed, self, 0);
#line 129 "../src/Widgets/EditableLabel.vala"
		_g_object_unref0 (gesture_click);
#line 968 "EditableLabel.c"
	}
#line 137 "../src/Widgets/EditableLabel.vala"
	_tmp29_ = self->priv->entry;
#line 137 "../src/Widgets/EditableLabel.vala"
	g_signal_connect_object ((GtkEntry*) _tmp29_, "activate", (GCallback) __widgets_editable_label___lambda788__gtk_entry_activate, self, 0);
#line 143 "../src/Widgets/EditableLabel.vala"
	_tmp30_ = (GtkEventControllerFocus*) gtk_event_controller_focus_new ();
#line 143 "../src/Widgets/EditableLabel.vala"
	gesture = _tmp30_;
#line 144 "../src/Widgets/EditableLabel.vala"
	_tmp31_ = self->priv->entry;
#line 144 "../src/Widgets/EditableLabel.vala"
	_tmp32_ = gesture;
#line 144 "../src/Widgets/EditableLabel.vala"
	_tmp33_ = _g_object_ref0 ((GtkEventController*) _tmp32_);
#line 144 "../src/Widgets/EditableLabel.vala"
	gtk_widget_add_controller ((GtkWidget*) _tmp31_, _tmp33_);
#line 146 "../src/Widgets/EditableLabel.vala"
	_tmp34_ = gesture;
#line 146 "../src/Widgets/EditableLabel.vala"
	g_signal_connect_object (_tmp34_, "enter", (GCallback) _widgets_editable_label_handle_focus_in_gtk_event_controller_focus_enter, self, 0);
#line 147 "../src/Widgets/EditableLabel.vala"
	_tmp35_ = gesture;
#line 147 "../src/Widgets/EditableLabel.vala"
	g_signal_connect_object (_tmp35_, "leave", (GCallback) _widgets_editable_label_update_on_leave_gtk_event_controller_focus_leave, self, 0);
#line 149 "../src/Widgets/EditableLabel.vala"
	_tmp36_ = gesture;
#line 149 "../src/Widgets/EditableLabel.vala"
	g_signal_connect_object (_tmp36_, "leave", (GCallback) __widgets_editable_label___lambda789__gtk_event_controller_focus_leave, self, 0);
#line 88 "../src/Widgets/EditableLabel.vala"
	_g_object_unref0 (gesture);
#line 88 "../src/Widgets/EditableLabel.vala"
	_g_object_unref0 (edit_icon);
#line 88 "../src/Widgets/EditableLabel.vala"
	return obj;
#line 1004 "EditableLabel.c"
}

static void
widgets_editable_label_class_init (WidgetsEditableLabelClass * klass,
                                   gpointer klass_data)
{
#line 22 "../src/Widgets/EditableLabel.vala"
	widgets_editable_label_parent_class = g_type_class_peek_parent (klass);
#line 22 "../src/Widgets/EditableLabel.vala"
	g_type_class_adjust_private_offset (klass, &WidgetsEditableLabel_private_offset);
#line 22 "../src/Widgets/EditableLabel.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_widgets_editable_label_get_property;
#line 22 "../src/Widgets/EditableLabel.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_widgets_editable_label_set_property;
#line 22 "../src/Widgets/EditableLabel.vala"
	G_OBJECT_CLASS (klass)->constructor = widgets_editable_label_constructor;
#line 22 "../src/Widgets/EditableLabel.vala"
	G_OBJECT_CLASS (klass)->finalize = widgets_editable_label_finalize;
#line 22 "../src/Widgets/EditableLabel.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), WIDGETS_EDITABLE_LABEL_PLACEHOLDER_TEXT_PROPERTY, widgets_editable_label_properties[WIDGETS_EDITABLE_LABEL_PLACEHOLDER_TEXT_PROPERTY] = g_param_spec_string ("placeholder-text", "placeholder-text", "placeholder-text", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 22 "../src/Widgets/EditableLabel.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), WIDGETS_EDITABLE_LABEL_AUTO_FOCUS_PROPERTY, widgets_editable_label_properties[WIDGETS_EDITABLE_LABEL_AUTO_FOCUS_PROPERTY] = g_param_spec_boolean ("auto-focus", "auto-focus", "auto-focus", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 22 "../src/Widgets/EditableLabel.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), WIDGETS_EDITABLE_LABEL_TEXT_PROPERTY, widgets_editable_label_properties[WIDGETS_EDITABLE_LABEL_TEXT_PROPERTY] = g_param_spec_string ("text", "text", "text", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 22 "../src/Widgets/EditableLabel.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), WIDGETS_EDITABLE_LABEL_ENTRY_MENU_OPENED_PROPERTY, widgets_editable_label_properties[WIDGETS_EDITABLE_LABEL_ENTRY_MENU_OPENED_PROPERTY] = g_param_spec_boolean ("entry-menu-opened", "entry-menu-opened", "entry-menu-opened", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 22 "../src/Widgets/EditableLabel.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), WIDGETS_EDITABLE_LABEL_IS_EDITING_PROPERTY, widgets_editable_label_properties[WIDGETS_EDITABLE_LABEL_IS_EDITING_PROPERTY] = g_param_spec_boolean ("is-editing", "is-editing", "is-editing", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 22 "../src/Widgets/EditableLabel.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), WIDGETS_EDITABLE_LABEL_SHOW_EDIT_PROPERTY, widgets_editable_label_properties[WIDGETS_EDITABLE_LABEL_SHOW_EDIT_PROPERTY] = g_param_spec_boolean ("show-edit", "show-edit", "show-edit", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_WRITABLE));
#line 22 "../src/Widgets/EditableLabel.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), WIDGETS_EDITABLE_LABEL_EDITABLE_PROPERTY, widgets_editable_label_properties[WIDGETS_EDITABLE_LABEL_EDITABLE_PROPERTY] = g_param_spec_boolean ("editable", "editable", "editable", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_WRITABLE));
#line 22 "../src/Widgets/EditableLabel.vala"
	widgets_editable_label_signals[WIDGETS_EDITABLE_LABEL_FOCUS_CHANGED_SIGNAL] = g_signal_new ("focus-changed", WIDGETS_TYPE_EDITABLE_LABEL, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__BOOLEAN, G_TYPE_NONE, 1, G_TYPE_BOOLEAN);
#line 22 "../src/Widgets/EditableLabel.vala"
	widgets_editable_label_signals[WIDGETS_EDITABLE_LABEL_CHANGED_SIGNAL] = g_signal_new ("changed", WIDGETS_TYPE_EDITABLE_LABEL, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 1041 "EditableLabel.c"
}

static void
widgets_editable_label_instance_init (WidgetsEditableLabel * self,
                                      gpointer klass)
{
#line 22 "../src/Widgets/EditableLabel.vala"
	self->priv = widgets_editable_label_get_instance_private (self);
#line 36 "../src/Widgets/EditableLabel.vala"
	self->priv->_entry_menu_opened = FALSE;
#line 1052 "EditableLabel.c"
}

static void
widgets_editable_label_finalize (GObject * obj)
{
	WidgetsEditableLabel * self;
#line 22 "../src/Widgets/EditableLabel.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, WIDGETS_TYPE_EDITABLE_LABEL, WidgetsEditableLabel);
#line 23 "../src/Widgets/EditableLabel.vala"
	_g_free0 (self->priv->_placeholder_text);
#line 29 "../src/Widgets/EditableLabel.vala"
	_g_object_unref0 (self->priv->title);
#line 30 "../src/Widgets/EditableLabel.vala"
	_g_object_unref0 (self->priv->entry);
#line 31 "../src/Widgets/EditableLabel.vala"
	_g_object_unref0 (self->priv->stack);
#line 32 "../src/Widgets/EditableLabel.vala"
	_g_object_unref0 (self->priv->grid);
#line 33 "../src/Widgets/EditableLabel.vala"
	_g_object_unref0 (self->priv->edit_revealer);
#line 35 "../src/Widgets/EditableLabel.vala"
	_g_free0 (self->priv->_text);
#line 22 "../src/Widgets/EditableLabel.vala"
	G_OBJECT_CLASS (widgets_editable_label_parent_class)->finalize (obj);
#line 1077 "EditableLabel.c"
}

static GType
widgets_editable_label_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (WidgetsEditableLabelClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) widgets_editable_label_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (WidgetsEditableLabel), 0, (GInstanceInitFunc) widgets_editable_label_instance_init, NULL };
	GType widgets_editable_label_type_id;
	widgets_editable_label_type_id = g_type_register_static (gtk_grid_get_type (), "WidgetsEditableLabel", &g_define_type_info, 0);
	WidgetsEditableLabel_private_offset = g_type_add_instance_private (widgets_editable_label_type_id, sizeof (WidgetsEditableLabelPrivate));
	return widgets_editable_label_type_id;
}

GType
widgets_editable_label_get_type (void)
{
	static volatile gsize widgets_editable_label_type_id__once = 0;
	if (g_once_init_enter (&widgets_editable_label_type_id__once)) {
		GType widgets_editable_label_type_id;
		widgets_editable_label_type_id = widgets_editable_label_get_type_once ();
		g_once_init_leave (&widgets_editable_label_type_id__once, widgets_editable_label_type_id);
	}
	return widgets_editable_label_type_id__once;
}

static void
_vala_widgets_editable_label_get_property (GObject * object,
                                           guint property_id,
                                           GValue * value,
                                           GParamSpec * pspec)
{
	WidgetsEditableLabel * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, WIDGETS_TYPE_EDITABLE_LABEL, WidgetsEditableLabel);
#line 22 "../src/Widgets/EditableLabel.vala"
	switch (property_id) {
#line 22 "../src/Widgets/EditableLabel.vala"
		case WIDGETS_EDITABLE_LABEL_PLACEHOLDER_TEXT_PROPERTY:
#line 22 "../src/Widgets/EditableLabel.vala"
		g_value_set_string (value, widgets_editable_label_get_placeholder_text (self));
#line 22 "../src/Widgets/EditableLabel.vala"
		break;
#line 22 "../src/Widgets/EditableLabel.vala"
		case WIDGETS_EDITABLE_LABEL_AUTO_FOCUS_PROPERTY:
#line 22 "../src/Widgets/EditableLabel.vala"
		g_value_set_boolean (value, widgets_editable_label_get_auto_focus (self));
#line 22 "../src/Widgets/EditableLabel.vala"
		break;
#line 22 "../src/Widgets/EditableLabel.vala"
		case WIDGETS_EDITABLE_LABEL_TEXT_PROPERTY:
#line 22 "../src/Widgets/EditableLabel.vala"
		g_value_set_string (value, widgets_editable_label_get_text (self));
#line 22 "../src/Widgets/EditableLabel.vala"
		break;
#line 22 "../src/Widgets/EditableLabel.vala"
		case WIDGETS_EDITABLE_LABEL_ENTRY_MENU_OPENED_PROPERTY:
#line 22 "../src/Widgets/EditableLabel.vala"
		g_value_set_boolean (value, widgets_editable_label_get_entry_menu_opened (self));
#line 22 "../src/Widgets/EditableLabel.vala"
		break;
#line 22 "../src/Widgets/EditableLabel.vala"
		case WIDGETS_EDITABLE_LABEL_IS_EDITING_PROPERTY:
#line 22 "../src/Widgets/EditableLabel.vala"
		g_value_set_boolean (value, widgets_editable_label_get_is_editing (self));
#line 22 "../src/Widgets/EditableLabel.vala"
		break;
#line 1142 "EditableLabel.c"
		default:
#line 22 "../src/Widgets/EditableLabel.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 22 "../src/Widgets/EditableLabel.vala"
		break;
#line 1148 "EditableLabel.c"
	}
}

static void
_vala_widgets_editable_label_set_property (GObject * object,
                                           guint property_id,
                                           const GValue * value,
                                           GParamSpec * pspec)
{
	WidgetsEditableLabel * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, WIDGETS_TYPE_EDITABLE_LABEL, WidgetsEditableLabel);
#line 22 "../src/Widgets/EditableLabel.vala"
	switch (property_id) {
#line 22 "../src/Widgets/EditableLabel.vala"
		case WIDGETS_EDITABLE_LABEL_PLACEHOLDER_TEXT_PROPERTY:
#line 22 "../src/Widgets/EditableLabel.vala"
		widgets_editable_label_set_placeholder_text (self, g_value_get_string (value));
#line 22 "../src/Widgets/EditableLabel.vala"
		break;
#line 22 "../src/Widgets/EditableLabel.vala"
		case WIDGETS_EDITABLE_LABEL_AUTO_FOCUS_PROPERTY:
#line 22 "../src/Widgets/EditableLabel.vala"
		widgets_editable_label_set_auto_focus (self, g_value_get_boolean (value));
#line 22 "../src/Widgets/EditableLabel.vala"
		break;
#line 22 "../src/Widgets/EditableLabel.vala"
		case WIDGETS_EDITABLE_LABEL_TEXT_PROPERTY:
#line 22 "../src/Widgets/EditableLabel.vala"
		widgets_editable_label_set_text (self, g_value_get_string (value));
#line 22 "../src/Widgets/EditableLabel.vala"
		break;
#line 22 "../src/Widgets/EditableLabel.vala"
		case WIDGETS_EDITABLE_LABEL_ENTRY_MENU_OPENED_PROPERTY:
#line 22 "../src/Widgets/EditableLabel.vala"
		widgets_editable_label_set_entry_menu_opened (self, g_value_get_boolean (value));
#line 22 "../src/Widgets/EditableLabel.vala"
		break;
#line 22 "../src/Widgets/EditableLabel.vala"
		case WIDGETS_EDITABLE_LABEL_SHOW_EDIT_PROPERTY:
#line 22 "../src/Widgets/EditableLabel.vala"
		widgets_editable_label_set_show_edit (self, g_value_get_boolean (value));
#line 22 "../src/Widgets/EditableLabel.vala"
		break;
#line 22 "../src/Widgets/EditableLabel.vala"
		case WIDGETS_EDITABLE_LABEL_EDITABLE_PROPERTY:
#line 22 "../src/Widgets/EditableLabel.vala"
		widgets_editable_label_set_editable (self, g_value_get_boolean (value));
#line 22 "../src/Widgets/EditableLabel.vala"
		break;
#line 1198 "EditableLabel.c"
		default:
#line 22 "../src/Widgets/EditableLabel.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 22 "../src/Widgets/EditableLabel.vala"
		break;
#line 1204 "EditableLabel.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

