/* EditableTextView.c generated by valac 0.56.18, the Vala compiler
 * generated from EditableTextView.vala, do not modify */

/*
* Copyright © 2023 Alain M. (https://github.com/alainm23/planify)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 3 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*
* Authored by: Alain M. <alainmh23@gmail.com>
*/

#include <adwaita.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gtk/gtk.h>
#include "planify.h"
#include <gee.h>
#include <pango/pango.h>
#include <float.h>
#include <math.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define WIDGETS_TYPE_EDITABLE_TEXT_VIEW (widgets_editable_text_view_get_type ())
#define WIDGETS_EDITABLE_TEXT_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), WIDGETS_TYPE_EDITABLE_TEXT_VIEW, WidgetsEditableTextView))
#define WIDGETS_EDITABLE_TEXT_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), WIDGETS_TYPE_EDITABLE_TEXT_VIEW, WidgetsEditableTextViewClass))
#define WIDGETS_IS_EDITABLE_TEXT_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), WIDGETS_TYPE_EDITABLE_TEXT_VIEW))
#define WIDGETS_IS_EDITABLE_TEXT_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), WIDGETS_TYPE_EDITABLE_TEXT_VIEW))
#define WIDGETS_EDITABLE_TEXT_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), WIDGETS_TYPE_EDITABLE_TEXT_VIEW, WidgetsEditableTextViewClass))

typedef struct _WidgetsEditableTextView WidgetsEditableTextView;
typedef struct _WidgetsEditableTextViewClass WidgetsEditableTextViewClass;
typedef struct _WidgetsEditableTextViewPrivate WidgetsEditableTextViewPrivate;
enum  {
	WIDGETS_EDITABLE_TEXT_VIEW_0_PROPERTY,
	WIDGETS_EDITABLE_TEXT_VIEW_PLACEHOLDER_TEXT_PROPERTY,
	WIDGETS_EDITABLE_TEXT_VIEW_TEXT_PROPERTY,
	WIDGETS_EDITABLE_TEXT_VIEW_IS_EDITING_PROPERTY,
	WIDGETS_EDITABLE_TEXT_VIEW_EDITABLE_PROPERTY,
	WIDGETS_EDITABLE_TEXT_VIEW_NUM_PROPERTIES
};
static GParamSpec* widgets_editable_text_view_properties[WIDGETS_EDITABLE_TEXT_VIEW_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
enum  {
	WIDGETS_EDITABLE_TEXT_VIEW_FOCUS_CHANGED_SIGNAL,
	WIDGETS_EDITABLE_TEXT_VIEW_CHANGED_SIGNAL,
	WIDGETS_EDITABLE_TEXT_VIEW_NUM_SIGNALS
};
static guint widgets_editable_text_view_signals[WIDGETS_EDITABLE_TEXT_VIEW_NUM_SIGNALS] = {0};

struct _WidgetsEditableTextView {
	AdwBin parent_instance;
	WidgetsEditableTextViewPrivate * priv;
};

struct _WidgetsEditableTextViewClass {
	AdwBinClass parent_class;
};

struct _WidgetsEditableTextViewPrivate {
	gchar* _placeholder_text;
	GtkLabel* label;
	WidgetsTextView* textview;
	GtkStack* stack;
	gchar* _text;
	GeeHashMap* signal_map;
};

static gint WidgetsEditableTextView_private_offset;
static gpointer widgets_editable_text_view_parent_class = NULL;

VALA_EXTERN GType widgets_editable_text_view_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (WidgetsEditableTextView, g_object_unref)
VALA_EXTERN void widgets_editable_text_view_editing (WidgetsEditableTextView* self,
                                         gboolean value);
VALA_EXTERN const gchar* widgets_editable_text_view_get_text (WidgetsEditableTextView* self);
VALA_EXTERN void widgets_editable_text_view_set_text (WidgetsEditableTextView* self,
                                          const gchar* value);
VALA_EXTERN WidgetsEditableTextView* widgets_editable_text_view_new (const gchar* placeholder_text);
VALA_EXTERN WidgetsEditableTextView* widgets_editable_text_view_construct (GType object_type,
                                                               const gchar* placeholder_text);
VALA_EXTERN const gchar* widgets_editable_text_view_get_placeholder_text (WidgetsEditableTextView* self);
static void widgets_editable_text_view_set_placeholder_text (WidgetsEditableTextView* self,
                                                      const gchar* value);
VALA_EXTERN gboolean widgets_editable_text_view_get_is_editing (WidgetsEditableTextView* self);
VALA_EXTERN void widgets_editable_text_view_set_editable (WidgetsEditableTextView* self,
                                              gboolean value);
static GObject * widgets_editable_text_view_constructor (GType type,
                                                  guint n_construct_properties,
                                                  GObjectConstructParam * construct_properties);
static void _widgets_editable_text_view___lambda536_ (WidgetsEditableTextView* self);
static void __widgets_editable_text_view___lambda536__g_object_notify (GObject* _sender,
                                                                GParamSpec* pspec,
                                                                gpointer self);
static void _widgets_editable_text_view___lambda537_ (WidgetsEditableTextView* self);
static void __widgets_editable_text_view___lambda537__gtk_gesture_click_pressed (GtkGestureClick* _sender,
                                                                          gint n_press,
                                                                          gdouble x,
                                                                          gdouble y,
                                                                          gpointer self);
static void _widgets_editable_text_view___lambda538_ (WidgetsEditableTextView* self);
static void __widgets_editable_text_view___lambda538__gtk_event_controller_focus_leave (GtkEventControllerFocus* _sender,
                                                                                 gpointer self);
static void _widgets_editable_text_view___lambda539_ (WidgetsEditableTextView* self);
static void __widgets_editable_text_view___lambda539__gtk_widget_destroy (GtkWidget* _sender,
                                                                   gpointer self);
static void widgets_editable_text_view_finalize (GObject * obj);
static GType widgets_editable_text_view_get_type_once (void);
static void _vala_widgets_editable_text_view_get_property (GObject * object,
                                                    guint property_id,
                                                    GValue * value,
                                                    GParamSpec * pspec);
static void _vala_widgets_editable_text_view_set_property (GObject * object,
                                                    guint property_id,
                                                    const GValue * value,
                                                    GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

static inline gpointer
widgets_editable_text_view_get_instance_private (WidgetsEditableTextView* self)
{
	return G_STRUCT_MEMBER_P (self, WidgetsEditableTextView_private_offset);
}

void
widgets_editable_text_view_editing (WidgetsEditableTextView* self,
                                    gboolean value)
{
#line 40 "../src/Widgets/EditableTextView.vala"
	g_return_if_fail (self != NULL);
#line 41 "../src/Widgets/EditableTextView.vala"
	g_signal_emit (self, widgets_editable_text_view_signals[WIDGETS_EDITABLE_TEXT_VIEW_FOCUS_CHANGED_SIGNAL], 0, value);
#line 43 "../src/Widgets/EditableTextView.vala"
	if (value) {
#line 173 "EditableTextView.c"
		WidgetsTextView* _tmp0_;
		GtkTextBuffer* _tmp1_;
		GtkTextBuffer* _tmp2_;
		const gchar* _tmp3_;
		GtkStack* _tmp4_;
		WidgetsTextView* _tmp5_;
		WidgetsTextView* _tmp6_;
#line 44 "../src/Widgets/EditableTextView.vala"
		_tmp0_ = self->priv->textview;
#line 44 "../src/Widgets/EditableTextView.vala"
		_tmp1_ = gtk_text_view_get_buffer ((GtkTextView*) _tmp0_);
#line 44 "../src/Widgets/EditableTextView.vala"
		_tmp2_ = _tmp1_;
#line 44 "../src/Widgets/EditableTextView.vala"
		_tmp3_ = self->priv->_text;
#line 44 "../src/Widgets/EditableTextView.vala"
		g_object_set (_tmp2_, "text", _tmp3_, NULL);
#line 45 "../src/Widgets/EditableTextView.vala"
		_tmp4_ = self->priv->stack;
#line 45 "../src/Widgets/EditableTextView.vala"
		_tmp5_ = self->priv->textview;
#line 45 "../src/Widgets/EditableTextView.vala"
		gtk_stack_set_visible_child (_tmp4_, (GtkWidget*) _tmp5_);
#line 46 "../src/Widgets/EditableTextView.vala"
		_tmp6_ = self->priv->textview;
#line 46 "../src/Widgets/EditableTextView.vala"
		gtk_widget_grab_focus ((GtkWidget*) _tmp6_);
#line 201 "EditableTextView.c"
	} else {
		const gchar* _tmp7_;
		WidgetsTextView* _tmp8_;
		GtkTextBuffer* _tmp9_;
		GtkTextBuffer* _tmp10_;
		gchar* _tmp11_;
		gchar* _tmp12_;
		gchar* _tmp13_;
		gboolean _tmp14_;
		GtkStack* _tmp21_;
		GtkLabel* _tmp22_;
#line 48 "../src/Widgets/EditableTextView.vala"
		_tmp7_ = self->priv->_text;
#line 48 "../src/Widgets/EditableTextView.vala"
		_tmp8_ = self->priv->textview;
#line 48 "../src/Widgets/EditableTextView.vala"
		_tmp9_ = gtk_text_view_get_buffer ((GtkTextView*) _tmp8_);
#line 48 "../src/Widgets/EditableTextView.vala"
		_tmp10_ = _tmp9_;
#line 48 "../src/Widgets/EditableTextView.vala"
		g_object_get (_tmp10_, "text", &_tmp11_, NULL);
#line 48 "../src/Widgets/EditableTextView.vala"
		_tmp12_ = _tmp11_;
#line 48 "../src/Widgets/EditableTextView.vala"
		_tmp13_ = _tmp12_;
#line 48 "../src/Widgets/EditableTextView.vala"
		_tmp14_ = g_strcmp0 (_tmp7_, _tmp13_) != 0;
#line 48 "../src/Widgets/EditableTextView.vala"
		_g_free0 (_tmp13_);
#line 48 "../src/Widgets/EditableTextView.vala"
		if (_tmp14_) {
#line 233 "EditableTextView.c"
			WidgetsTextView* _tmp15_;
			GtkTextBuffer* _tmp16_;
			GtkTextBuffer* _tmp17_;
			gchar* _tmp18_;
			gchar* _tmp19_;
			gchar* _tmp20_;
#line 49 "../src/Widgets/EditableTextView.vala"
			_tmp15_ = self->priv->textview;
#line 49 "../src/Widgets/EditableTextView.vala"
			_tmp16_ = gtk_text_view_get_buffer ((GtkTextView*) _tmp15_);
#line 49 "../src/Widgets/EditableTextView.vala"
			_tmp17_ = _tmp16_;
#line 49 "../src/Widgets/EditableTextView.vala"
			g_object_get (_tmp17_, "text", &_tmp18_, NULL);
#line 49 "../src/Widgets/EditableTextView.vala"
			_tmp19_ = _tmp18_;
#line 49 "../src/Widgets/EditableTextView.vala"
			_tmp20_ = _tmp19_;
#line 49 "../src/Widgets/EditableTextView.vala"
			widgets_editable_text_view_set_text (self, _tmp20_);
#line 49 "../src/Widgets/EditableTextView.vala"
			_g_free0 (_tmp20_);
#line 50 "../src/Widgets/EditableTextView.vala"
			g_signal_emit (self, widgets_editable_text_view_signals[WIDGETS_EDITABLE_TEXT_VIEW_CHANGED_SIGNAL], 0);
#line 258 "EditableTextView.c"
		}
#line 53 "../src/Widgets/EditableTextView.vala"
		_tmp21_ = self->priv->stack;
#line 53 "../src/Widgets/EditableTextView.vala"
		_tmp22_ = self->priv->label;
#line 53 "../src/Widgets/EditableTextView.vala"
		gtk_stack_set_visible_child (_tmp21_, (GtkWidget*) _tmp22_);
#line 266 "EditableTextView.c"
	}
}

WidgetsEditableTextView*
widgets_editable_text_view_construct (GType object_type,
                                      const gchar* placeholder_text)
{
	WidgetsEditableTextView * self = NULL;
#line 65 "../src/Widgets/EditableTextView.vala"
	g_return_val_if_fail (placeholder_text != NULL, NULL);
#line 66 "../src/Widgets/EditableTextView.vala"
	self = (WidgetsEditableTextView*) g_object_new (object_type, "placeholder-text", placeholder_text, NULL);
#line 65 "../src/Widgets/EditableTextView.vala"
	return self;
#line 281 "EditableTextView.c"
}

WidgetsEditableTextView*
widgets_editable_text_view_new (const gchar* placeholder_text)
{
#line 65 "../src/Widgets/EditableTextView.vala"
	return widgets_editable_text_view_construct (WIDGETS_TYPE_EDITABLE_TEXT_VIEW, placeholder_text);
#line 289 "EditableTextView.c"
}

const gchar*
widgets_editable_text_view_get_placeholder_text (WidgetsEditableTextView* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 23 "../src/Widgets/EditableTextView.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 23 "../src/Widgets/EditableTextView.vala"
	_tmp0_ = self->priv->_placeholder_text;
#line 23 "../src/Widgets/EditableTextView.vala"
	result = _tmp0_;
#line 23 "../src/Widgets/EditableTextView.vala"
	return result;
#line 305 "EditableTextView.c"
}

static void
widgets_editable_text_view_set_placeholder_text (WidgetsEditableTextView* self,
                                                 const gchar* value)
{
	gchar* old_value;
#line 23 "../src/Widgets/EditableTextView.vala"
	g_return_if_fail (self != NULL);
#line 23 "../src/Widgets/EditableTextView.vala"
	old_value = widgets_editable_text_view_get_placeholder_text (self);
#line 23 "../src/Widgets/EditableTextView.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 319 "EditableTextView.c"
		gchar* _tmp0_;
#line 23 "../src/Widgets/EditableTextView.vala"
		_tmp0_ = g_strdup (value);
#line 23 "../src/Widgets/EditableTextView.vala"
		_g_free0 (self->priv->_placeholder_text);
#line 23 "../src/Widgets/EditableTextView.vala"
		self->priv->_placeholder_text = _tmp0_;
#line 23 "../src/Widgets/EditableTextView.vala"
		g_object_notify_by_pspec ((GObject *) self, widgets_editable_text_view_properties[WIDGETS_EDITABLE_TEXT_VIEW_PLACEHOLDER_TEXT_PROPERTY]);
#line 329 "EditableTextView.c"
	}
}

const gchar*
widgets_editable_text_view_get_text (WidgetsEditableTextView* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 32 "../src/Widgets/EditableTextView.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 32 "../src/Widgets/EditableTextView.vala"
	_tmp0_ = self->priv->_text;
#line 32 "../src/Widgets/EditableTextView.vala"
	result = _tmp0_;
#line 32 "../src/Widgets/EditableTextView.vala"
	return result;
#line 346 "EditableTextView.c"
}

void
widgets_editable_text_view_set_text (WidgetsEditableTextView* self,
                                     const gchar* value)
{
	gchar* old_value;
#line 32 "../src/Widgets/EditableTextView.vala"
	g_return_if_fail (self != NULL);
#line 32 "../src/Widgets/EditableTextView.vala"
	old_value = widgets_editable_text_view_get_text (self);
#line 32 "../src/Widgets/EditableTextView.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 360 "EditableTextView.c"
		gchar* _tmp0_;
#line 32 "../src/Widgets/EditableTextView.vala"
		_tmp0_ = g_strdup (value);
#line 32 "../src/Widgets/EditableTextView.vala"
		_g_free0 (self->priv->_text);
#line 32 "../src/Widgets/EditableTextView.vala"
		self->priv->_text = _tmp0_;
#line 32 "../src/Widgets/EditableTextView.vala"
		g_object_notify_by_pspec ((GObject *) self, widgets_editable_text_view_properties[WIDGETS_EDITABLE_TEXT_VIEW_TEXT_PROPERTY]);
#line 370 "EditableTextView.c"
	}
}

gboolean
widgets_editable_text_view_get_is_editing (WidgetsEditableTextView* self)
{
	gboolean result;
	GtkStack* _tmp0_;
	GtkWidget* _tmp1_;
	GtkWidget* _tmp2_;
	WidgetsTextView* _tmp3_;
#line 35 "../src/Widgets/EditableTextView.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 36 "../src/Widgets/EditableTextView.vala"
	_tmp0_ = self->priv->stack;
#line 36 "../src/Widgets/EditableTextView.vala"
	_tmp1_ = gtk_stack_get_visible_child (_tmp0_);
#line 36 "../src/Widgets/EditableTextView.vala"
	_tmp2_ = _tmp1_;
#line 36 "../src/Widgets/EditableTextView.vala"
	_tmp3_ = self->priv->textview;
#line 36 "../src/Widgets/EditableTextView.vala"
	result = _tmp2_ == G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, gtk_widget_get_type (), GtkWidget);
#line 36 "../src/Widgets/EditableTextView.vala"
	return result;
#line 396 "EditableTextView.c"
}

void
widgets_editable_text_view_set_editable (WidgetsEditableTextView* self,
                                         gboolean value)
{
	WidgetsTextView* _tmp0_;
#line 58 "../src/Widgets/EditableTextView.vala"
	g_return_if_fail (self != NULL);
#line 59 "../src/Widgets/EditableTextView.vala"
	_tmp0_ = self->priv->textview;
#line 59 "../src/Widgets/EditableTextView.vala"
	gtk_text_view_set_editable ((GtkTextView*) _tmp0_, value);
#line 58 "../src/Widgets/EditableTextView.vala"
	g_object_notify_by_pspec ((GObject *) self, widgets_editable_text_view_properties[WIDGETS_EDITABLE_TEXT_VIEW_EDITABLE_PROPERTY]);
#line 412 "EditableTextView.c"
}

static void
_widgets_editable_text_view___lambda536_ (WidgetsEditableTextView* self)
{
	GtkLabel* _tmp0_;
	const gchar* _tmp1_;
	GtkLabel* _tmp2_;
	GtkLabel* _tmp3_;
	const gchar* _tmp4_;
	const gchar* _tmp5_;
	gint _tmp6_;
	gint _tmp7_;
#line 100 "../src/Widgets/EditableTextView.vala"
	_tmp0_ = self->priv->label;
#line 100 "../src/Widgets/EditableTextView.vala"
	_tmp1_ = self->priv->_text;
#line 100 "../src/Widgets/EditableTextView.vala"
	gtk_label_set_label (_tmp0_, _tmp1_);
#line 101 "../src/Widgets/EditableTextView.vala"
	_tmp2_ = self->priv->label;
#line 101 "../src/Widgets/EditableTextView.vala"
	gtk_widget_set_opacity ((GtkWidget*) _tmp2_, (gdouble) 1);
#line 103 "../src/Widgets/EditableTextView.vala"
	_tmp3_ = self->priv->label;
#line 103 "../src/Widgets/EditableTextView.vala"
	_tmp4_ = gtk_label_get_label (_tmp3_);
#line 103 "../src/Widgets/EditableTextView.vala"
	_tmp5_ = _tmp4_;
#line 103 "../src/Widgets/EditableTextView.vala"
	_tmp6_ = strlen (_tmp5_);
#line 103 "../src/Widgets/EditableTextView.vala"
	_tmp7_ = _tmp6_;
#line 103 "../src/Widgets/EditableTextView.vala"
	if (_tmp7_ <= 0) {
#line 448 "EditableTextView.c"
		GtkLabel* _tmp8_;
		const gchar* _tmp9_;
		GtkLabel* _tmp10_;
#line 104 "../src/Widgets/EditableTextView.vala"
		_tmp8_ = self->priv->label;
#line 104 "../src/Widgets/EditableTextView.vala"
		_tmp9_ = self->priv->_placeholder_text;
#line 104 "../src/Widgets/EditableTextView.vala"
		gtk_label_set_label (_tmp8_, _tmp9_);
#line 105 "../src/Widgets/EditableTextView.vala"
		_tmp10_ = self->priv->label;
#line 105 "../src/Widgets/EditableTextView.vala"
		gtk_widget_set_opacity ((GtkWidget*) _tmp10_, 0.7);
#line 462 "EditableTextView.c"
	}
}

static void
__widgets_editable_text_view___lambda536__g_object_notify (GObject* _sender,
                                                           GParamSpec* pspec,
                                                           gpointer self)
{
#line 99 "../src/Widgets/EditableTextView.vala"
	_widgets_editable_text_view___lambda536_ ((WidgetsEditableTextView*) self);
#line 473 "EditableTextView.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 110 "../src/Widgets/EditableTextView.vala"
	return self ? g_object_ref (self) : NULL;
#line 481 "EditableTextView.c"
}

static void
_widgets_editable_text_view___lambda537_ (WidgetsEditableTextView* self)
{
#line 112 "../src/Widgets/EditableTextView.vala"
	widgets_editable_text_view_editing (self, TRUE);
#line 489 "EditableTextView.c"
}

static void
__widgets_editable_text_view___lambda537__gtk_gesture_click_pressed (GtkGestureClick* _sender,
                                                                     gint n_press,
                                                                     gdouble x,
                                                                     gdouble y,
                                                                     gpointer self)
{
#line 111 "../src/Widgets/EditableTextView.vala"
	_widgets_editable_text_view___lambda537_ ((WidgetsEditableTextView*) self);
#line 501 "EditableTextView.c"
}

static void
_widgets_editable_text_view___lambda538_ (WidgetsEditableTextView* self)
{
	GtkStack* _tmp0_;
	GtkWidget* _tmp1_;
	GtkWidget* _tmp2_;
	WidgetsTextView* _tmp3_;
#line 118 "../src/Widgets/EditableTextView.vala"
	_tmp0_ = self->priv->stack;
#line 118 "../src/Widgets/EditableTextView.vala"
	_tmp1_ = gtk_stack_get_visible_child (_tmp0_);
#line 118 "../src/Widgets/EditableTextView.vala"
	_tmp2_ = _tmp1_;
#line 118 "../src/Widgets/EditableTextView.vala"
	_tmp3_ = self->priv->textview;
#line 118 "../src/Widgets/EditableTextView.vala"
	if (_tmp2_ == G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, gtk_widget_get_type (), GtkWidget)) {
#line 119 "../src/Widgets/EditableTextView.vala"
		widgets_editable_text_view_editing (self, FALSE);
#line 523 "EditableTextView.c"
	}
}

static void
__widgets_editable_text_view___lambda538__gtk_event_controller_focus_leave (GtkEventControllerFocus* _sender,
                                                                            gpointer self)
{
#line 117 "../src/Widgets/EditableTextView.vala"
	_widgets_editable_text_view___lambda538_ ((WidgetsEditableTextView*) self);
#line 533 "EditableTextView.c"
}

static void
_widgets_editable_text_view___lambda539_ (WidgetsEditableTextView* self)
{
	GeeHashMap* _tmp15_;
#line 124 "../src/Widgets/EditableTextView.vala"
	g_print ("Widgets.EditableTextView Destroyed\n");
#line 542 "EditableTextView.c"
	{
		GeeIterator* _entry_it = NULL;
		GeeHashMap* _tmp0_;
		GeeSet* _tmp1_;
		GeeSet* _tmp2_;
		GeeSet* _tmp3_;
		GeeIterator* _tmp4_;
		GeeIterator* _tmp5_;
#line 127 "../src/Widgets/EditableTextView.vala"
		_tmp0_ = self->priv->signal_map;
#line 127 "../src/Widgets/EditableTextView.vala"
		_tmp1_ = gee_abstract_map_get_entries ((GeeAbstractMap*) _tmp0_);
#line 127 "../src/Widgets/EditableTextView.vala"
		_tmp2_ = _tmp1_;
#line 127 "../src/Widgets/EditableTextView.vala"
		_tmp3_ = _tmp2_;
#line 127 "../src/Widgets/EditableTextView.vala"
		_tmp4_ = gee_iterable_iterator ((GeeIterable*) _tmp3_);
#line 127 "../src/Widgets/EditableTextView.vala"
		_tmp5_ = _tmp4_;
#line 127 "../src/Widgets/EditableTextView.vala"
		_g_object_unref0 (_tmp3_);
#line 127 "../src/Widgets/EditableTextView.vala"
		_entry_it = _tmp5_;
#line 127 "../src/Widgets/EditableTextView.vala"
		while (TRUE) {
#line 569 "EditableTextView.c"
			GeeIterator* _tmp6_;
			GeeMapEntry* entry = NULL;
			GeeIterator* _tmp7_;
			gpointer _tmp8_;
			GeeMapEntry* _tmp9_;
			gconstpointer _tmp10_;
			gconstpointer _tmp11_;
			GeeMapEntry* _tmp12_;
			gconstpointer _tmp13_;
			gconstpointer _tmp14_;
#line 127 "../src/Widgets/EditableTextView.vala"
			_tmp6_ = _entry_it;
#line 127 "../src/Widgets/EditableTextView.vala"
			if (!gee_iterator_next (_tmp6_)) {
#line 127 "../src/Widgets/EditableTextView.vala"
				break;
#line 586 "EditableTextView.c"
			}
#line 127 "../src/Widgets/EditableTextView.vala"
			_tmp7_ = _entry_it;
#line 127 "../src/Widgets/EditableTextView.vala"
			_tmp8_ = gee_iterator_get (_tmp7_);
#line 127 "../src/Widgets/EditableTextView.vala"
			entry = (GeeMapEntry*) _tmp8_;
#line 128 "../src/Widgets/EditableTextView.vala"
			_tmp9_ = entry;
#line 128 "../src/Widgets/EditableTextView.vala"
			_tmp10_ = gee_map_entry_get_value (_tmp9_);
#line 128 "../src/Widgets/EditableTextView.vala"
			_tmp11_ = _tmp10_;
#line 128 "../src/Widgets/EditableTextView.vala"
			_tmp12_ = entry;
#line 128 "../src/Widgets/EditableTextView.vala"
			_tmp13_ = gee_map_entry_get_key (_tmp12_);
#line 128 "../src/Widgets/EditableTextView.vala"
			_tmp14_ = _tmp13_;
#line 128 "../src/Widgets/EditableTextView.vala"
			g_signal_handler_disconnect ((GObject*) _tmp11_, (gulong) ((guintptr) _tmp14_));
#line 127 "../src/Widgets/EditableTextView.vala"
			_g_object_unref0 (entry);
#line 610 "EditableTextView.c"
		}
#line 127 "../src/Widgets/EditableTextView.vala"
		_g_object_unref0 (_entry_it);
#line 614 "EditableTextView.c"
	}
#line 131 "../src/Widgets/EditableTextView.vala"
	_tmp15_ = self->priv->signal_map;
#line 131 "../src/Widgets/EditableTextView.vala"
	gee_abstract_map_clear ((GeeAbstractMap*) _tmp15_);
#line 620 "EditableTextView.c"
}

static void
__widgets_editable_text_view___lambda539__gtk_widget_destroy (GtkWidget* _sender,
                                                              gpointer self)
{
#line 123 "../src/Widgets/EditableTextView.vala"
	_widgets_editable_text_view___lambda539_ ((WidgetsEditableTextView*) self);
#line 629 "EditableTextView.c"
}

static GObject *
widgets_editable_text_view_constructor (GType type,
                                        guint n_construct_properties,
                                        GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	WidgetsEditableTextView * self;
	GtkLabel* _tmp0_ = NULL;
	gchar** _tmp1_;
	WidgetsTextView* _tmp2_ = NULL;
	GtkStack* _tmp3_ = NULL;
	GtkStack* _tmp4_;
	GtkLabel* _tmp5_;
	GtkStack* _tmp6_;
	WidgetsTextView* _tmp7_;
	GtkStack* _tmp8_;
	GeeHashMap* _tmp9_;
	gulong _tmp10_;
	GtkGestureClick* gesture_click = NULL;
	GtkGestureClick* _tmp11_;
	GtkGestureClick* _tmp12_;
	GtkEventController* _tmp13_;
	GeeHashMap* _tmp14_;
	GtkGestureClick* _tmp15_;
	gulong _tmp16_;
	GtkGestureClick* _tmp17_;
	GtkEventControllerFocus* gesture_focus = NULL;
	GtkEventControllerFocus* _tmp18_;
	WidgetsTextView* _tmp19_;
	GtkEventControllerFocus* _tmp20_;
	GtkEventController* _tmp21_;
	GeeHashMap* _tmp22_;
	GtkEventControllerFocus* _tmp23_;
	gulong _tmp24_;
	GtkEventControllerFocus* _tmp25_;
#line 75 "../src/Widgets/EditableTextView.vala"
	parent_class = G_OBJECT_CLASS (widgets_editable_text_view_parent_class);
#line 75 "../src/Widgets/EditableTextView.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 75 "../src/Widgets/EditableTextView.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, WIDGETS_TYPE_EDITABLE_TEXT_VIEW, WidgetsEditableTextView);
#line 76 "../src/Widgets/EditableTextView.vala"
	_tmp0_ = (GtkLabel*) gtk_label_new (NULL);
#line 76 "../src/Widgets/EditableTextView.vala"
	gtk_label_set_wrap (_tmp0_, TRUE);
#line 76 "../src/Widgets/EditableTextView.vala"
	gtk_label_set_wrap_mode (_tmp0_, PANGO_WRAP_WORD_CHAR);
#line 76 "../src/Widgets/EditableTextView.vala"
	gtk_label_set_xalign (_tmp0_, (gfloat) 0);
#line 76 "../src/Widgets/EditableTextView.vala"
	gtk_label_set_yalign (_tmp0_, (gfloat) 0);
#line 76 "../src/Widgets/EditableTextView.vala"
	g_object_ref_sink (_tmp0_);
#line 76 "../src/Widgets/EditableTextView.vala"
	_g_object_unref0 (self->priv->label);
#line 76 "../src/Widgets/EditableTextView.vala"
	self->priv->label = _tmp0_;
#line 83 "../src/Widgets/EditableTextView.vala"
	_tmp1_ = g_new0 (gchar*, 0 + 1);
#line 83 "../src/Widgets/EditableTextView.vala"
	_tmp2_ = widgets_text_view_new ();
#line 83 "../src/Widgets/EditableTextView.vala"
	gtk_text_view_set_wrap_mode ((GtkTextView*) _tmp2_, GTK_WRAP_WORD_CHAR);
#line 83 "../src/Widgets/EditableTextView.vala"
	gtk_widget_set_css_classes ((GtkWidget*) _tmp2_, _tmp1_);
#line 83 "../src/Widgets/EditableTextView.vala"
	_tmp1_ = (_vala_array_free (_tmp1_, 0, (GDestroyNotify) g_free), NULL);
#line 83 "../src/Widgets/EditableTextView.vala"
	g_object_ref_sink (_tmp2_);
#line 83 "../src/Widgets/EditableTextView.vala"
	_g_object_unref0 (self->priv->textview);
#line 83 "../src/Widgets/EditableTextView.vala"
	self->priv->textview = _tmp2_;
#line 88 "../src/Widgets/EditableTextView.vala"
	_tmp3_ = (GtkStack*) gtk_stack_new ();
#line 88 "../src/Widgets/EditableTextView.vala"
	gtk_stack_set_transition_type (_tmp3_, GTK_STACK_TRANSITION_TYPE_CROSSFADE);
#line 88 "../src/Widgets/EditableTextView.vala"
	gtk_widget_set_hexpand ((GtkWidget*) _tmp3_, TRUE);
#line 88 "../src/Widgets/EditableTextView.vala"
	gtk_stack_set_hhomogeneous (_tmp3_, FALSE);
#line 88 "../src/Widgets/EditableTextView.vala"
	gtk_stack_set_vhomogeneous (_tmp3_, FALSE);
#line 88 "../src/Widgets/EditableTextView.vala"
	g_object_ref_sink (_tmp3_);
#line 88 "../src/Widgets/EditableTextView.vala"
	_g_object_unref0 (self->priv->stack);
#line 88 "../src/Widgets/EditableTextView.vala"
	self->priv->stack = _tmp3_;
#line 95 "../src/Widgets/EditableTextView.vala"
	_tmp4_ = self->priv->stack;
#line 95 "../src/Widgets/EditableTextView.vala"
	_tmp5_ = self->priv->label;
#line 95 "../src/Widgets/EditableTextView.vala"
	gtk_stack_add_child (_tmp4_, (GtkWidget*) _tmp5_);
#line 96 "../src/Widgets/EditableTextView.vala"
	_tmp6_ = self->priv->stack;
#line 96 "../src/Widgets/EditableTextView.vala"
	_tmp7_ = self->priv->textview;
#line 96 "../src/Widgets/EditableTextView.vala"
	gtk_stack_add_child (_tmp6_, (GtkWidget*) _tmp7_);
#line 98 "../src/Widgets/EditableTextView.vala"
	_tmp8_ = self->priv->stack;
#line 98 "../src/Widgets/EditableTextView.vala"
	adw_bin_set_child ((AdwBin*) self, (GtkWidget*) _tmp8_);
#line 99 "../src/Widgets/EditableTextView.vala"
	_tmp9_ = self->priv->signal_map;
#line 99 "../src/Widgets/EditableTextView.vala"
	_tmp10_ = g_signal_connect_object ((GObject*) self, "notify::text", (GCallback) __widgets_editable_text_view___lambda536__g_object_notify, self, 0);
#line 99 "../src/Widgets/EditableTextView.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _tmp9_, (gpointer) ((guintptr) _tmp10_), (GObject*) self);
#line 109 "../src/Widgets/EditableTextView.vala"
	_tmp11_ = (GtkGestureClick*) gtk_gesture_click_new ();
#line 109 "../src/Widgets/EditableTextView.vala"
	gesture_click = _tmp11_;
#line 110 "../src/Widgets/EditableTextView.vala"
	_tmp12_ = gesture_click;
#line 110 "../src/Widgets/EditableTextView.vala"
	_tmp13_ = _g_object_ref0 ((GtkEventController*) _tmp12_);
#line 110 "../src/Widgets/EditableTextView.vala"
	gtk_widget_add_controller ((GtkWidget*) self, _tmp13_);
#line 111 "../src/Widgets/EditableTextView.vala"
	_tmp14_ = self->priv->signal_map;
#line 111 "../src/Widgets/EditableTextView.vala"
	_tmp15_ = gesture_click;
#line 111 "../src/Widgets/EditableTextView.vala"
	_tmp16_ = g_signal_connect_object (_tmp15_, "pressed", (GCallback) __widgets_editable_text_view___lambda537__gtk_gesture_click_pressed, self, 0);
#line 111 "../src/Widgets/EditableTextView.vala"
	_tmp17_ = gesture_click;
#line 111 "../src/Widgets/EditableTextView.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _tmp14_, (gpointer) ((guintptr) _tmp16_), (GObject*) _tmp17_);
#line 115 "../src/Widgets/EditableTextView.vala"
	_tmp18_ = (GtkEventControllerFocus*) gtk_event_controller_focus_new ();
#line 115 "../src/Widgets/EditableTextView.vala"
	gesture_focus = _tmp18_;
#line 116 "../src/Widgets/EditableTextView.vala"
	_tmp19_ = self->priv->textview;
#line 116 "../src/Widgets/EditableTextView.vala"
	_tmp20_ = gesture_focus;
#line 116 "../src/Widgets/EditableTextView.vala"
	_tmp21_ = _g_object_ref0 ((GtkEventController*) _tmp20_);
#line 116 "../src/Widgets/EditableTextView.vala"
	gtk_widget_add_controller ((GtkWidget*) _tmp19_, _tmp21_);
#line 117 "../src/Widgets/EditableTextView.vala"
	_tmp22_ = self->priv->signal_map;
#line 117 "../src/Widgets/EditableTextView.vala"
	_tmp23_ = gesture_focus;
#line 117 "../src/Widgets/EditableTextView.vala"
	_tmp24_ = g_signal_connect_object (_tmp23_, "leave", (GCallback) __widgets_editable_text_view___lambda538__gtk_event_controller_focus_leave, self, 0);
#line 117 "../src/Widgets/EditableTextView.vala"
	_tmp25_ = gesture_focus;
#line 117 "../src/Widgets/EditableTextView.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _tmp22_, (gpointer) ((guintptr) _tmp24_), (GObject*) _tmp25_);
#line 123 "../src/Widgets/EditableTextView.vala"
	g_signal_connect_object ((GtkWidget*) self, "destroy", (GCallback) __widgets_editable_text_view___lambda539__gtk_widget_destroy, self, 0);
#line 75 "../src/Widgets/EditableTextView.vala"
	_g_object_unref0 (gesture_focus);
#line 75 "../src/Widgets/EditableTextView.vala"
	_g_object_unref0 (gesture_click);
#line 75 "../src/Widgets/EditableTextView.vala"
	return obj;
#line 794 "EditableTextView.c"
}

static void
widgets_editable_text_view_class_init (WidgetsEditableTextViewClass * klass,
                                       gpointer klass_data)
{
#line 22 "../src/Widgets/EditableTextView.vala"
	widgets_editable_text_view_parent_class = g_type_class_peek_parent (klass);
#line 22 "../src/Widgets/EditableTextView.vala"
	g_type_class_adjust_private_offset (klass, &WidgetsEditableTextView_private_offset);
#line 22 "../src/Widgets/EditableTextView.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_widgets_editable_text_view_get_property;
#line 22 "../src/Widgets/EditableTextView.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_widgets_editable_text_view_set_property;
#line 22 "../src/Widgets/EditableTextView.vala"
	G_OBJECT_CLASS (klass)->constructor = widgets_editable_text_view_constructor;
#line 22 "../src/Widgets/EditableTextView.vala"
	G_OBJECT_CLASS (klass)->finalize = widgets_editable_text_view_finalize;
#line 22 "../src/Widgets/EditableTextView.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), WIDGETS_EDITABLE_TEXT_VIEW_PLACEHOLDER_TEXT_PROPERTY, widgets_editable_text_view_properties[WIDGETS_EDITABLE_TEXT_VIEW_PLACEHOLDER_TEXT_PROPERTY] = g_param_spec_string ("placeholder-text", "placeholder-text", "placeholder-text", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 22 "../src/Widgets/EditableTextView.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), WIDGETS_EDITABLE_TEXT_VIEW_TEXT_PROPERTY, widgets_editable_text_view_properties[WIDGETS_EDITABLE_TEXT_VIEW_TEXT_PROPERTY] = g_param_spec_string ("text", "text", "text", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 22 "../src/Widgets/EditableTextView.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), WIDGETS_EDITABLE_TEXT_VIEW_IS_EDITING_PROPERTY, widgets_editable_text_view_properties[WIDGETS_EDITABLE_TEXT_VIEW_IS_EDITING_PROPERTY] = g_param_spec_boolean ("is-editing", "is-editing", "is-editing", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 22 "../src/Widgets/EditableTextView.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), WIDGETS_EDITABLE_TEXT_VIEW_EDITABLE_PROPERTY, widgets_editable_text_view_properties[WIDGETS_EDITABLE_TEXT_VIEW_EDITABLE_PROPERTY] = g_param_spec_boolean ("editable", "editable", "editable", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_WRITABLE));
#line 22 "../src/Widgets/EditableTextView.vala"
	widgets_editable_text_view_signals[WIDGETS_EDITABLE_TEXT_VIEW_FOCUS_CHANGED_SIGNAL] = g_signal_new ("focus-changed", WIDGETS_TYPE_EDITABLE_TEXT_VIEW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__BOOLEAN, G_TYPE_NONE, 1, G_TYPE_BOOLEAN);
#line 22 "../src/Widgets/EditableTextView.vala"
	widgets_editable_text_view_signals[WIDGETS_EDITABLE_TEXT_VIEW_CHANGED_SIGNAL] = g_signal_new ("changed", WIDGETS_TYPE_EDITABLE_TEXT_VIEW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 825 "EditableTextView.c"
}

static void
widgets_editable_text_view_instance_init (WidgetsEditableTextView * self,
                                          gpointer klass)
{
	GeeHashMap* _tmp0_;
#line 22 "../src/Widgets/EditableTextView.vala"
	self->priv = widgets_editable_text_view_get_instance_private (self);
#line 63 "../src/Widgets/EditableTextView.vala"
	_tmp0_ = gee_hash_map_new (G_TYPE_ULONG, NULL, NULL, G_TYPE_OBJECT, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 63 "../src/Widgets/EditableTextView.vala"
	self->priv->signal_map = _tmp0_;
#line 839 "EditableTextView.c"
}

static void
widgets_editable_text_view_finalize (GObject * obj)
{
	WidgetsEditableTextView * self;
#line 22 "../src/Widgets/EditableTextView.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, WIDGETS_TYPE_EDITABLE_TEXT_VIEW, WidgetsEditableTextView);
#line 72 "../src/Widgets/EditableTextView.vala"
	g_print ("Destroying Widgets.EditableTextView\n");
#line 23 "../src/Widgets/EditableTextView.vala"
	_g_free0 (self->priv->_placeholder_text);
#line 28 "../src/Widgets/EditableTextView.vala"
	_g_object_unref0 (self->priv->label);
#line 29 "../src/Widgets/EditableTextView.vala"
	_g_object_unref0 (self->priv->textview);
#line 30 "../src/Widgets/EditableTextView.vala"
	_g_object_unref0 (self->priv->stack);
#line 32 "../src/Widgets/EditableTextView.vala"
	_g_free0 (self->priv->_text);
#line 63 "../src/Widgets/EditableTextView.vala"
	_g_object_unref0 (self->priv->signal_map);
#line 22 "../src/Widgets/EditableTextView.vala"
	G_OBJECT_CLASS (widgets_editable_text_view_parent_class)->finalize (obj);
#line 864 "EditableTextView.c"
}

static GType
widgets_editable_text_view_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (WidgetsEditableTextViewClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) widgets_editable_text_view_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (WidgetsEditableTextView), 0, (GInstanceInitFunc) widgets_editable_text_view_instance_init, NULL };
	GType widgets_editable_text_view_type_id;
	widgets_editable_text_view_type_id = g_type_register_static (adw_bin_get_type (), "WidgetsEditableTextView", &g_define_type_info, 0);
	WidgetsEditableTextView_private_offset = g_type_add_instance_private (widgets_editable_text_view_type_id, sizeof (WidgetsEditableTextViewPrivate));
	return widgets_editable_text_view_type_id;
}

GType
widgets_editable_text_view_get_type (void)
{
	static volatile gsize widgets_editable_text_view_type_id__once = 0;
	if (g_once_init_enter (&widgets_editable_text_view_type_id__once)) {
		GType widgets_editable_text_view_type_id;
		widgets_editable_text_view_type_id = widgets_editable_text_view_get_type_once ();
		g_once_init_leave (&widgets_editable_text_view_type_id__once, widgets_editable_text_view_type_id);
	}
	return widgets_editable_text_view_type_id__once;
}

static void
_vala_widgets_editable_text_view_get_property (GObject * object,
                                               guint property_id,
                                               GValue * value,
                                               GParamSpec * pspec)
{
	WidgetsEditableTextView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, WIDGETS_TYPE_EDITABLE_TEXT_VIEW, WidgetsEditableTextView);
#line 22 "../src/Widgets/EditableTextView.vala"
	switch (property_id) {
#line 22 "../src/Widgets/EditableTextView.vala"
		case WIDGETS_EDITABLE_TEXT_VIEW_PLACEHOLDER_TEXT_PROPERTY:
#line 22 "../src/Widgets/EditableTextView.vala"
		g_value_set_string (value, widgets_editable_text_view_get_placeholder_text (self));
#line 22 "../src/Widgets/EditableTextView.vala"
		break;
#line 22 "../src/Widgets/EditableTextView.vala"
		case WIDGETS_EDITABLE_TEXT_VIEW_TEXT_PROPERTY:
#line 22 "../src/Widgets/EditableTextView.vala"
		g_value_set_string (value, widgets_editable_text_view_get_text (self));
#line 22 "../src/Widgets/EditableTextView.vala"
		break;
#line 22 "../src/Widgets/EditableTextView.vala"
		case WIDGETS_EDITABLE_TEXT_VIEW_IS_EDITING_PROPERTY:
#line 22 "../src/Widgets/EditableTextView.vala"
		g_value_set_boolean (value, widgets_editable_text_view_get_is_editing (self));
#line 22 "../src/Widgets/EditableTextView.vala"
		break;
#line 917 "EditableTextView.c"
		default:
#line 22 "../src/Widgets/EditableTextView.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 22 "../src/Widgets/EditableTextView.vala"
		break;
#line 923 "EditableTextView.c"
	}
}

static void
_vala_widgets_editable_text_view_set_property (GObject * object,
                                               guint property_id,
                                               const GValue * value,
                                               GParamSpec * pspec)
{
	WidgetsEditableTextView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, WIDGETS_TYPE_EDITABLE_TEXT_VIEW, WidgetsEditableTextView);
#line 22 "../src/Widgets/EditableTextView.vala"
	switch (property_id) {
#line 22 "../src/Widgets/EditableTextView.vala"
		case WIDGETS_EDITABLE_TEXT_VIEW_PLACEHOLDER_TEXT_PROPERTY:
#line 22 "../src/Widgets/EditableTextView.vala"
		widgets_editable_text_view_set_placeholder_text (self, g_value_get_string (value));
#line 22 "../src/Widgets/EditableTextView.vala"
		break;
#line 22 "../src/Widgets/EditableTextView.vala"
		case WIDGETS_EDITABLE_TEXT_VIEW_TEXT_PROPERTY:
#line 22 "../src/Widgets/EditableTextView.vala"
		widgets_editable_text_view_set_text (self, g_value_get_string (value));
#line 22 "../src/Widgets/EditableTextView.vala"
		break;
#line 22 "../src/Widgets/EditableTextView.vala"
		case WIDGETS_EDITABLE_TEXT_VIEW_EDITABLE_PROPERTY:
#line 22 "../src/Widgets/EditableTextView.vala"
		widgets_editable_text_view_set_editable (self, g_value_get_boolean (value));
#line 22 "../src/Widgets/EditableTextView.vala"
		break;
#line 955 "EditableTextView.c"
		default:
#line 22 "../src/Widgets/EditableTextView.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 22 "../src/Widgets/EditableTextView.vala"
		break;
#line 961 "EditableTextView.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

