/* ErrorView.c generated by valac 0.56.18, the Vala compiler
 * generated from ErrorView.vala, do not modify */

/*
* Copyright © 2023 Alain M. (https://github.com/alainm23/planify)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 3 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*
* Authored by: Alain M. <alainmh23@gmail.com>
*/

#include <adwaita.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <gee.h>
#include <glib/gi18n-lib.h>
#include <gio/gio.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define WIDGETS_TYPE_ERROR_VIEW (widgets_error_view_get_type ())
#define WIDGETS_ERROR_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), WIDGETS_TYPE_ERROR_VIEW, WidgetsErrorView))
#define WIDGETS_ERROR_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), WIDGETS_TYPE_ERROR_VIEW, WidgetsErrorViewClass))
#define WIDGETS_IS_ERROR_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), WIDGETS_TYPE_ERROR_VIEW))
#define WIDGETS_IS_ERROR_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), WIDGETS_TYPE_ERROR_VIEW))
#define WIDGETS_ERROR_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), WIDGETS_TYPE_ERROR_VIEW, WidgetsErrorViewClass))

typedef struct _WidgetsErrorView WidgetsErrorView;
typedef struct _WidgetsErrorViewClass WidgetsErrorViewClass;
typedef struct _WidgetsErrorViewPrivate WidgetsErrorViewPrivate;
enum  {
	WIDGETS_ERROR_VIEW_0_PROPERTY,
	WIDGETS_ERROR_VIEW_ERROR_CODE_PROPERTY,
	WIDGETS_ERROR_VIEW_ERROR_MESSAGE_PROPERTY,
	WIDGETS_ERROR_VIEW_VISIBLE_ISSUE_BUTTON_PROPERTY,
	WIDGETS_ERROR_VIEW_NUM_PROPERTIES
};
static GParamSpec* widgets_error_view_properties[WIDGETS_ERROR_VIEW_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

struct _WidgetsErrorView {
	AdwBin parent_instance;
	WidgetsErrorViewPrivate * priv;
};

struct _WidgetsErrorViewClass {
	AdwBinClass parent_class;
};

struct _WidgetsErrorViewPrivate {
	GtkLabel* error_label;
	GtkLabel* error_code_label;
	GtkTextView* error_textview;
	GtkButton* issue_button;
};

static gint WidgetsErrorView_private_offset;
static gpointer widgets_error_view_parent_class = NULL;

VALA_EXTERN GType widgets_error_view_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (WidgetsErrorView, g_object_unref)
VALA_EXTERN gchar* widgets_error_view_get_http_error (WidgetsErrorView* self,
                                          gint code);
VALA_EXTERN WidgetsErrorView* widgets_error_view_new (void);
VALA_EXTERN WidgetsErrorView* widgets_error_view_construct (GType object_type);
VALA_EXTERN void widgets_error_view_set_error_code (WidgetsErrorView* self,
                                        gint value);
VALA_EXTERN void widgets_error_view_set_error_message (WidgetsErrorView* self,
                                           const gchar* value);
VALA_EXTERN void widgets_error_view_set_visible_issue_button (WidgetsErrorView* self,
                                                  gboolean value);
static GObject * widgets_error_view_constructor (GType type,
                                          guint n_construct_properties,
                                          GObjectConstructParam * construct_properties);
static void _widgets_error_view___lambda349_ (WidgetsErrorView* self);
static void __widgets_error_view___lambda349__gtk_button_clicked (GtkButton* _sender,
                                                           gpointer self);
static void widgets_error_view_finalize (GObject * obj);
static GType widgets_error_view_get_type_once (void);
static void _vala_widgets_error_view_set_property (GObject * object,
                                            guint property_id,
                                            const GValue * value,
                                            GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

static inline gpointer
widgets_error_view_get_instance_private (WidgetsErrorView* self)
{
	return G_STRUCT_MEMBER_P (self, WidgetsErrorView_private_offset);
}

gchar*
widgets_error_view_get_http_error (WidgetsErrorView* self,
                                   gint code)
{
	GeeHashMap* messages = NULL;
	GeeHashMap* _tmp0_;
	GeeHashMap* _tmp1_;
	GeeHashMap* _tmp2_;
	GeeHashMap* _tmp3_;
	GeeHashMap* _tmp4_;
	GeeHashMap* _tmp5_;
	GeeHashMap* _tmp6_;
	GeeHashMap* _tmp7_;
	gchar* _tmp8_ = NULL;
	GeeHashMap* _tmp9_;
	gchar* result;
#line 131 "../src/Widgets/ErrorView.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 132 "../src/Widgets/ErrorView.vala"
	_tmp0_ = gee_hash_map_new (G_TYPE_INT, NULL, NULL, G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 132 "../src/Widgets/ErrorView.vala"
	messages = _tmp0_;
#line 134 "../src/Widgets/ErrorView.vala"
	_tmp1_ = messages;
#line 134 "../src/Widgets/ErrorView.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _tmp1_, (gpointer) ((gintptr) 400), _ ("The request was incorrect."));
#line 135 "../src/Widgets/ErrorView.vala"
	_tmp2_ = messages;
#line 135 "../src/Widgets/ErrorView.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _tmp2_, (gpointer) ((gintptr) 401), _ ("Authentication is required, and has failed, or has not yet been provid" \
"ed."));
#line 136 "../src/Widgets/ErrorView.vala"
	_tmp3_ = messages;
#line 136 "../src/Widgets/ErrorView.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _tmp3_, (gpointer) ((gintptr) 403), _ ("The request was valid, but for something that is forbidden."));
#line 137 "../src/Widgets/ErrorView.vala"
	_tmp4_ = messages;
#line 137 "../src/Widgets/ErrorView.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _tmp4_, (gpointer) ((gintptr) 404), _ ("The requested resource could not be found."));
#line 138 "../src/Widgets/ErrorView.vala"
	_tmp5_ = messages;
#line 138 "../src/Widgets/ErrorView.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _tmp5_, (gpointer) ((gintptr) 429), _ ("The user has sent too many requests in a given amount of time."));
#line 139 "../src/Widgets/ErrorView.vala"
	_tmp6_ = messages;
#line 139 "../src/Widgets/ErrorView.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _tmp6_, (gpointer) ((gintptr) 500), _ ("The request failed due to a server error."));
#line 140 "../src/Widgets/ErrorView.vala"
	_tmp7_ = messages;
#line 140 "../src/Widgets/ErrorView.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _tmp7_, (gpointer) ((gintptr) 503), _ ("The server is currently unable to handle the request."));
#line 142 "../src/Widgets/ErrorView.vala"
	_tmp9_ = messages;
#line 142 "../src/Widgets/ErrorView.vala"
	if (gee_abstract_map_has_key ((GeeAbstractMap*) _tmp9_, (gpointer) ((gintptr) code))) {
#line 186 "ErrorView.c"
		GeeHashMap* _tmp10_;
		gpointer _tmp11_;
#line 142 "../src/Widgets/ErrorView.vala"
		_tmp10_ = messages;
#line 142 "../src/Widgets/ErrorView.vala"
		_tmp11_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp10_, (gpointer) ((gintptr) code));
#line 142 "../src/Widgets/ErrorView.vala"
		_g_free0 (_tmp8_);
#line 142 "../src/Widgets/ErrorView.vala"
		_tmp8_ = (gchar*) _tmp11_;
#line 197 "ErrorView.c"
	} else {
		gchar* _tmp12_;
#line 142 "../src/Widgets/ErrorView.vala"
		_tmp12_ = g_strdup (_ ("Unknown error"));
#line 142 "../src/Widgets/ErrorView.vala"
		_g_free0 (_tmp8_);
#line 142 "../src/Widgets/ErrorView.vala"
		_tmp8_ = _tmp12_;
#line 206 "ErrorView.c"
	}
#line 142 "../src/Widgets/ErrorView.vala"
	result = _tmp8_;
#line 142 "../src/Widgets/ErrorView.vala"
	_g_object_unref0 (messages);
#line 142 "../src/Widgets/ErrorView.vala"
	return result;
#line 214 "ErrorView.c"
}

WidgetsErrorView*
widgets_error_view_construct (GType object_type)
{
	WidgetsErrorView * self = NULL;
#line 22 "../src/Widgets/ErrorView.vala"
	self = (WidgetsErrorView*) g_object_new (object_type, NULL);
#line 22 "../src/Widgets/ErrorView.vala"
	return self;
#line 225 "ErrorView.c"
}

WidgetsErrorView*
widgets_error_view_new (void)
{
#line 22 "../src/Widgets/ErrorView.vala"
	return widgets_error_view_construct (WIDGETS_TYPE_ERROR_VIEW);
#line 233 "ErrorView.c"
}

void
widgets_error_view_set_error_code (WidgetsErrorView* self,
                                   gint value)
{
	GtkLabel* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	GtkLabel* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
#line 29 "../src/Widgets/ErrorView.vala"
	g_return_if_fail (self != NULL);
#line 30 "../src/Widgets/ErrorView.vala"
	_tmp0_ = self->priv->error_label;
#line 30 "../src/Widgets/ErrorView.vala"
	_tmp1_ = widgets_error_view_get_http_error (self, value);
#line 30 "../src/Widgets/ErrorView.vala"
	_tmp2_ = _tmp1_;
#line 30 "../src/Widgets/ErrorView.vala"
	gtk_label_set_label (_tmp0_, _tmp2_);
#line 30 "../src/Widgets/ErrorView.vala"
	_g_free0 (_tmp2_);
#line 31 "../src/Widgets/ErrorView.vala"
	_tmp3_ = self->priv->error_code_label;
#line 31 "../src/Widgets/ErrorView.vala"
	_tmp4_ = g_strdup_printf ("HTTP %d", value);
#line 31 "../src/Widgets/ErrorView.vala"
	_tmp5_ = _tmp4_;
#line 31 "../src/Widgets/ErrorView.vala"
	gtk_label_set_label (_tmp3_, _tmp5_);
#line 31 "../src/Widgets/ErrorView.vala"
	_g_free0 (_tmp5_);
#line 29 "../src/Widgets/ErrorView.vala"
	g_object_notify_by_pspec ((GObject *) self, widgets_error_view_properties[WIDGETS_ERROR_VIEW_ERROR_CODE_PROPERTY]);
#line 270 "ErrorView.c"
}

void
widgets_error_view_set_error_message (WidgetsErrorView* self,
                                      const gchar* value)
{
	GtkTextView* _tmp0_;
	GtkTextBuffer* _tmp1_;
	GtkTextBuffer* _tmp2_;
#line 36 "../src/Widgets/ErrorView.vala"
	g_return_if_fail (self != NULL);
#line 37 "../src/Widgets/ErrorView.vala"
	_tmp0_ = self->priv->error_textview;
#line 37 "../src/Widgets/ErrorView.vala"
	_tmp1_ = gtk_text_view_get_buffer (_tmp0_);
#line 37 "../src/Widgets/ErrorView.vala"
	_tmp2_ = _tmp1_;
#line 37 "../src/Widgets/ErrorView.vala"
	g_object_set (_tmp2_, "text", value, NULL);
#line 36 "../src/Widgets/ErrorView.vala"
	g_object_notify_by_pspec ((GObject *) self, widgets_error_view_properties[WIDGETS_ERROR_VIEW_ERROR_MESSAGE_PROPERTY]);
#line 292 "ErrorView.c"
}

void
widgets_error_view_set_visible_issue_button (WidgetsErrorView* self,
                                             gboolean value)
{
	GtkButton* _tmp0_;
#line 42 "../src/Widgets/ErrorView.vala"
	g_return_if_fail (self != NULL);
#line 43 "../src/Widgets/ErrorView.vala"
	_tmp0_ = self->priv->issue_button;
#line 43 "../src/Widgets/ErrorView.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp0_, value);
#line 42 "../src/Widgets/ErrorView.vala"
	g_object_notify_by_pspec ((GObject *) self, widgets_error_view_properties[WIDGETS_ERROR_VIEW_VISIBLE_ISSUE_BUTTON_PROPERTY]);
#line 308 "ErrorView.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 87 "../src/Widgets/ErrorView.vala"
	return self ? g_object_ref (self) : NULL;
#line 316 "ErrorView.c"
}

static void
_widgets_error_view___lambda349_ (WidgetsErrorView* self)
{
	GError* _inner_error0_ = NULL;
	{
#line 124 "../src/Widgets/ErrorView.vala"
		g_app_info_launch_default_for_uri ("https://github.com/alainm23/planify/issues/new?assignees=&labels=&proj" \
"ects=&template=bug_report.md", NULL, &_inner_error0_);
#line 124 "../src/Widgets/ErrorView.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 328 "ErrorView.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp0_;
		const gchar* _tmp1_;
#line 123 "../src/Widgets/ErrorView.vala"
		e = _inner_error0_;
#line 123 "../src/Widgets/ErrorView.vala"
		_inner_error0_ = NULL;
#line 126 "../src/Widgets/ErrorView.vala"
		_tmp0_ = e;
#line 126 "../src/Widgets/ErrorView.vala"
		_tmp1_ = _tmp0_->message;
#line 126 "../src/Widgets/ErrorView.vala"
		g_warning ("ErrorView.vala:126: %s\n", _tmp1_);
#line 123 "../src/Widgets/ErrorView.vala"
		_g_error_free0 (e);
#line 350 "ErrorView.c"
	}
	__finally0:
#line 123 "../src/Widgets/ErrorView.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 123 "../src/Widgets/ErrorView.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 123 "../src/Widgets/ErrorView.vala"
		g_clear_error (&_inner_error0_);
#line 123 "../src/Widgets/ErrorView.vala"
		return;
#line 361 "ErrorView.c"
	}
}

static void
__widgets_error_view___lambda349__gtk_button_clicked (GtkButton* _sender,
                                                      gpointer self)
{
#line 122 "../src/Widgets/ErrorView.vala"
	_widgets_error_view___lambda349_ ((WidgetsErrorView*) self);
#line 371 "ErrorView.c"
}

static GObject *
widgets_error_view_constructor (GType type,
                                guint n_construct_properties,
                                GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	WidgetsErrorView * self;
	AdwHeaderBar* headerbar = NULL;
	AdwHeaderBar* _tmp0_;
	AdwHeaderBar* _tmp1_;
	GtkImage* error_image = NULL;
	gchar* _tmp2_;
	gchar** _tmp3_;
	GtkImage* _tmp4_ = NULL;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar** _tmp7_;
	GtkLabel* _tmp8_ = NULL;
	gchar* _tmp9_;
	gchar* _tmp10_;
	gchar** _tmp11_;
	GtkLabel* _tmp12_ = NULL;
	GtkTextView* _tmp13_ = NULL;
	GtkTextView* _tmp14_;
	GtkTextView* _tmp15_;
	GtkTextView* _tmp16_;
	GtkScrolledWindow* textview_scrolled_window = NULL;
	GtkTextView* _tmp17_;
	GtkWidget* _tmp18_;
	GtkScrolledWindow* _tmp19_ = NULL;
	GtkFrame* textview_frame = NULL;
	GtkScrolledWindow* _tmp20_;
	GtkWidget* _tmp21_;
	GtkFrame* _tmp22_ = NULL;
	gchar* _tmp23_;
	gchar** _tmp24_;
	GtkButton* _tmp25_ = NULL;
	GtkBox* content_box = NULL;
	GtkBox* _tmp26_;
	GtkBox* _tmp27_;
	AdwHeaderBar* _tmp28_;
	GtkBox* _tmp29_;
	GtkImage* _tmp30_;
	GtkBox* _tmp31_;
	GtkLabel* _tmp32_;
	GtkBox* _tmp33_;
	GtkLabel* _tmp34_;
	GtkBox* _tmp35_;
	GtkFrame* _tmp36_;
	GtkBox* _tmp37_;
	GtkButton* _tmp38_;
	GtkBox* _tmp39_;
	GtkButton* _tmp40_;
#line 47 "../src/Widgets/ErrorView.vala"
	parent_class = G_OBJECT_CLASS (widgets_error_view_parent_class);
#line 47 "../src/Widgets/ErrorView.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 47 "../src/Widgets/ErrorView.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, WIDGETS_TYPE_ERROR_VIEW, WidgetsErrorView);
#line 48 "../src/Widgets/ErrorView.vala"
	_tmp0_ = (AdwHeaderBar*) adw_header_bar_new ();
#line 48 "../src/Widgets/ErrorView.vala"
	g_object_ref_sink (_tmp0_);
#line 48 "../src/Widgets/ErrorView.vala"
	headerbar = _tmp0_;
#line 49 "../src/Widgets/ErrorView.vala"
	_tmp1_ = headerbar;
#line 49 "../src/Widgets/ErrorView.vala"
	gtk_widget_add_css_class ((GtkWidget*) _tmp1_, "flat");
#line 51 "../src/Widgets/ErrorView.vala"
	_tmp2_ = g_strdup ("error");
#line 51 "../src/Widgets/ErrorView.vala"
	_tmp3_ = g_new0 (gchar*, 1 + 1);
#line 51 "../src/Widgets/ErrorView.vala"
	_tmp3_[0] = _tmp2_;
#line 51 "../src/Widgets/ErrorView.vala"
	_tmp4_ = (GtkImage*) gtk_image_new_from_icon_name ("cross-large-circle-outline-symbolic");
#line 51 "../src/Widgets/ErrorView.vala"
	gtk_widget_set_hexpand ((GtkWidget*) _tmp4_, TRUE);
#line 51 "../src/Widgets/ErrorView.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp4_, GTK_ALIGN_CENTER);
#line 51 "../src/Widgets/ErrorView.vala"
	gtk_image_set_pixel_size (_tmp4_, 38);
#line 51 "../src/Widgets/ErrorView.vala"
	gtk_widget_set_css_classes ((GtkWidget*) _tmp4_, _tmp3_);
#line 51 "../src/Widgets/ErrorView.vala"
	_tmp3_ = (_vala_array_free (_tmp3_, 1, (GDestroyNotify) g_free), NULL);
#line 51 "../src/Widgets/ErrorView.vala"
	g_object_ref_sink (_tmp4_);
#line 51 "../src/Widgets/ErrorView.vala"
	error_image = _tmp4_;
#line 58 "../src/Widgets/ErrorView.vala"
	_tmp5_ = g_strdup ("font-bold");
#line 58 "../src/Widgets/ErrorView.vala"
	_tmp6_ = g_strdup ("title-2");
#line 58 "../src/Widgets/ErrorView.vala"
	_tmp7_ = g_new0 (gchar*, 2 + 1);
#line 58 "../src/Widgets/ErrorView.vala"
	_tmp7_[0] = _tmp5_;
#line 58 "../src/Widgets/ErrorView.vala"
	_tmp7_[1] = _tmp6_;
#line 58 "../src/Widgets/ErrorView.vala"
	_tmp8_ = (GtkLabel*) gtk_label_new (NULL);
#line 58 "../src/Widgets/ErrorView.vala"
	gtk_widget_set_hexpand ((GtkWidget*) _tmp8_, TRUE);
#line 58 "../src/Widgets/ErrorView.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp8_, GTK_ALIGN_CENTER);
#line 58 "../src/Widgets/ErrorView.vala"
	gtk_widget_set_css_classes ((GtkWidget*) _tmp8_, _tmp7_);
#line 58 "../src/Widgets/ErrorView.vala"
	_tmp7_ = (_vala_array_free (_tmp7_, 2, (GDestroyNotify) g_free), NULL);
#line 58 "../src/Widgets/ErrorView.vala"
	gtk_widget_set_margin_top ((GtkWidget*) _tmp8_, 12);
#line 58 "../src/Widgets/ErrorView.vala"
	gtk_widget_set_margin_start ((GtkWidget*) _tmp8_, 12);
#line 58 "../src/Widgets/ErrorView.vala"
	gtk_widget_set_margin_end ((GtkWidget*) _tmp8_, 12);
#line 58 "../src/Widgets/ErrorView.vala"
	gtk_label_set_wrap (_tmp8_, TRUE);
#line 58 "../src/Widgets/ErrorView.vala"
	gtk_label_set_justify (_tmp8_, GTK_JUSTIFY_CENTER);
#line 58 "../src/Widgets/ErrorView.vala"
	g_object_ref_sink (_tmp8_);
#line 58 "../src/Widgets/ErrorView.vala"
	_g_object_unref0 (self->priv->error_label);
#line 58 "../src/Widgets/ErrorView.vala"
	self->priv->error_label = _tmp8_;
#line 69 "../src/Widgets/ErrorView.vala"
	_tmp9_ = g_strdup ("dim-label");
#line 69 "../src/Widgets/ErrorView.vala"
	_tmp10_ = g_strdup ("caption");
#line 69 "../src/Widgets/ErrorView.vala"
	_tmp11_ = g_new0 (gchar*, 2 + 1);
#line 69 "../src/Widgets/ErrorView.vala"
	_tmp11_[0] = _tmp9_;
#line 69 "../src/Widgets/ErrorView.vala"
	_tmp11_[1] = _tmp10_;
#line 69 "../src/Widgets/ErrorView.vala"
	_tmp12_ = (GtkLabel*) gtk_label_new (NULL);
#line 69 "../src/Widgets/ErrorView.vala"
	gtk_widget_set_hexpand ((GtkWidget*) _tmp12_, TRUE);
#line 69 "../src/Widgets/ErrorView.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp12_, GTK_ALIGN_CENTER);
#line 69 "../src/Widgets/ErrorView.vala"
	gtk_widget_set_css_classes ((GtkWidget*) _tmp12_, _tmp11_);
#line 69 "../src/Widgets/ErrorView.vala"
	_tmp11_ = (_vala_array_free (_tmp11_, 2, (GDestroyNotify) g_free), NULL);
#line 69 "../src/Widgets/ErrorView.vala"
	gtk_widget_set_margin_top ((GtkWidget*) _tmp12_, 3);
#line 69 "../src/Widgets/ErrorView.vala"
	g_object_ref_sink (_tmp12_);
#line 69 "../src/Widgets/ErrorView.vala"
	_g_object_unref0 (self->priv->error_code_label);
#line 69 "../src/Widgets/ErrorView.vala"
	self->priv->error_code_label = _tmp12_;
#line 76 "../src/Widgets/ErrorView.vala"
	_tmp13_ = (GtkTextView*) gtk_text_view_new ();
#line 76 "../src/Widgets/ErrorView.vala"
	gtk_text_view_set_left_margin (_tmp13_, 12);
#line 76 "../src/Widgets/ErrorView.vala"
	gtk_text_view_set_top_margin (_tmp13_, 12);
#line 76 "../src/Widgets/ErrorView.vala"
	gtk_text_view_set_bottom_margin (_tmp13_, 12);
#line 76 "../src/Widgets/ErrorView.vala"
	gtk_text_view_set_right_margin (_tmp13_, 12);
#line 76 "../src/Widgets/ErrorView.vala"
	gtk_text_view_set_wrap_mode (_tmp13_, GTK_WRAP_WORD);
#line 76 "../src/Widgets/ErrorView.vala"
	g_object_ref_sink (_tmp13_);
#line 76 "../src/Widgets/ErrorView.vala"
	_g_object_unref0 (self->priv->error_textview);
#line 76 "../src/Widgets/ErrorView.vala"
	self->priv->error_textview = _tmp13_;
#line 83 "../src/Widgets/ErrorView.vala"
	_tmp14_ = self->priv->error_textview;
#line 83 "../src/Widgets/ErrorView.vala"
	gtk_widget_add_css_class ((GtkWidget*) _tmp14_, "monospace");
#line 84 "../src/Widgets/ErrorView.vala"
	_tmp15_ = self->priv->error_textview;
#line 84 "../src/Widgets/ErrorView.vala"
	gtk_widget_add_css_class ((GtkWidget*) _tmp15_, "error-message");
#line 85 "../src/Widgets/ErrorView.vala"
	_tmp16_ = self->priv->error_textview;
#line 85 "../src/Widgets/ErrorView.vala"
	gtk_widget_remove_css_class ((GtkWidget*) _tmp16_, "view");
#line 87 "../src/Widgets/ErrorView.vala"
	_tmp17_ = self->priv->error_textview;
#line 87 "../src/Widgets/ErrorView.vala"
	_tmp18_ = _g_object_ref0 ((GtkWidget*) _tmp17_);
#line 87 "../src/Widgets/ErrorView.vala"
	_tmp19_ = (GtkScrolledWindow*) gtk_scrolled_window_new ();
#line 87 "../src/Widgets/ErrorView.vala"
	g_object_set (_tmp19_, "hscrollbar-policy", GTK_POLICY_NEVER, NULL);
#line 87 "../src/Widgets/ErrorView.vala"
	gtk_widget_set_hexpand ((GtkWidget*) _tmp19_, TRUE);
#line 87 "../src/Widgets/ErrorView.vala"
	gtk_widget_set_vexpand ((GtkWidget*) _tmp19_, TRUE);
#line 87 "../src/Widgets/ErrorView.vala"
	gtk_scrolled_window_set_child (_tmp19_, _tmp18_);
#line 87 "../src/Widgets/ErrorView.vala"
	_g_object_unref0 (_tmp18_);
#line 87 "../src/Widgets/ErrorView.vala"
	g_object_set ((GtkWidget*) _tmp19_, "height-request", 275, NULL);
#line 87 "../src/Widgets/ErrorView.vala"
	g_object_ref_sink (_tmp19_);
#line 87 "../src/Widgets/ErrorView.vala"
	textview_scrolled_window = _tmp19_;
#line 95 "../src/Widgets/ErrorView.vala"
	_tmp20_ = textview_scrolled_window;
#line 95 "../src/Widgets/ErrorView.vala"
	_tmp21_ = _g_object_ref0 ((GtkWidget*) _tmp20_);
#line 95 "../src/Widgets/ErrorView.vala"
	_tmp22_ = (GtkFrame*) gtk_frame_new (NULL);
#line 95 "../src/Widgets/ErrorView.vala"
	gtk_frame_set_child (_tmp22_, _tmp21_);
#line 95 "../src/Widgets/ErrorView.vala"
	_g_object_unref0 (_tmp21_);
#line 95 "../src/Widgets/ErrorView.vala"
	gtk_widget_set_margin_top ((GtkWidget*) _tmp22_, 24);
#line 95 "../src/Widgets/ErrorView.vala"
	gtk_widget_set_margin_bottom ((GtkWidget*) _tmp22_, 12);
#line 95 "../src/Widgets/ErrorView.vala"
	gtk_widget_set_margin_start ((GtkWidget*) _tmp22_, 12);
#line 95 "../src/Widgets/ErrorView.vala"
	gtk_widget_set_margin_end ((GtkWidget*) _tmp22_, 12);
#line 95 "../src/Widgets/ErrorView.vala"
	g_object_ref_sink (_tmp22_);
#line 95 "../src/Widgets/ErrorView.vala"
	textview_frame = _tmp22_;
#line 103 "../src/Widgets/ErrorView.vala"
	_tmp23_ = g_strdup ("suggested-action");
#line 103 "../src/Widgets/ErrorView.vala"
	_tmp24_ = g_new0 (gchar*, 1 + 1);
#line 103 "../src/Widgets/ErrorView.vala"
	_tmp24_[0] = _tmp23_;
#line 103 "../src/Widgets/ErrorView.vala"
	_tmp25_ = (GtkButton*) gtk_button_new_with_label (_ ("Report Issue"));
#line 103 "../src/Widgets/ErrorView.vala"
	gtk_widget_set_hexpand ((GtkWidget*) _tmp25_, TRUE);
#line 103 "../src/Widgets/ErrorView.vala"
	gtk_widget_set_margin_top ((GtkWidget*) _tmp25_, 12);
#line 103 "../src/Widgets/ErrorView.vala"
	gtk_widget_set_margin_bottom ((GtkWidget*) _tmp25_, 12);
#line 103 "../src/Widgets/ErrorView.vala"
	gtk_widget_set_margin_start ((GtkWidget*) _tmp25_, 12);
#line 103 "../src/Widgets/ErrorView.vala"
	gtk_widget_set_margin_end ((GtkWidget*) _tmp25_, 12);
#line 103 "../src/Widgets/ErrorView.vala"
	gtk_widget_set_css_classes ((GtkWidget*) _tmp25_, _tmp24_);
#line 103 "../src/Widgets/ErrorView.vala"
	_tmp24_ = (_vala_array_free (_tmp24_, 1, (GDestroyNotify) g_free), NULL);
#line 103 "../src/Widgets/ErrorView.vala"
	g_object_ref_sink (_tmp25_);
#line 103 "../src/Widgets/ErrorView.vala"
	_g_object_unref0 (self->priv->issue_button);
#line 103 "../src/Widgets/ErrorView.vala"
	self->priv->issue_button = _tmp25_;
#line 112 "../src/Widgets/ErrorView.vala"
	_tmp26_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 0);
#line 112 "../src/Widgets/ErrorView.vala"
	g_object_ref_sink (_tmp26_);
#line 112 "../src/Widgets/ErrorView.vala"
	content_box = _tmp26_;
#line 113 "../src/Widgets/ErrorView.vala"
	_tmp27_ = content_box;
#line 113 "../src/Widgets/ErrorView.vala"
	_tmp28_ = headerbar;
#line 113 "../src/Widgets/ErrorView.vala"
	gtk_box_append (_tmp27_, (GtkWidget*) _tmp28_);
#line 114 "../src/Widgets/ErrorView.vala"
	_tmp29_ = content_box;
#line 114 "../src/Widgets/ErrorView.vala"
	_tmp30_ = error_image;
#line 114 "../src/Widgets/ErrorView.vala"
	gtk_box_append (_tmp29_, (GtkWidget*) _tmp30_);
#line 115 "../src/Widgets/ErrorView.vala"
	_tmp31_ = content_box;
#line 115 "../src/Widgets/ErrorView.vala"
	_tmp32_ = self->priv->error_label;
#line 115 "../src/Widgets/ErrorView.vala"
	gtk_box_append (_tmp31_, (GtkWidget*) _tmp32_);
#line 116 "../src/Widgets/ErrorView.vala"
	_tmp33_ = content_box;
#line 116 "../src/Widgets/ErrorView.vala"
	_tmp34_ = self->priv->error_code_label;
#line 116 "../src/Widgets/ErrorView.vala"
	gtk_box_append (_tmp33_, (GtkWidget*) _tmp34_);
#line 117 "../src/Widgets/ErrorView.vala"
	_tmp35_ = content_box;
#line 117 "../src/Widgets/ErrorView.vala"
	_tmp36_ = textview_frame;
#line 117 "../src/Widgets/ErrorView.vala"
	gtk_box_append (_tmp35_, (GtkWidget*) _tmp36_);
#line 118 "../src/Widgets/ErrorView.vala"
	_tmp37_ = content_box;
#line 118 "../src/Widgets/ErrorView.vala"
	_tmp38_ = self->priv->issue_button;
#line 118 "../src/Widgets/ErrorView.vala"
	gtk_box_append (_tmp37_, (GtkWidget*) _tmp38_);
#line 120 "../src/Widgets/ErrorView.vala"
	_tmp39_ = content_box;
#line 120 "../src/Widgets/ErrorView.vala"
	adw_bin_set_child ((AdwBin*) self, (GtkWidget*) _tmp39_);
#line 122 "../src/Widgets/ErrorView.vala"
	_tmp40_ = self->priv->issue_button;
#line 122 "../src/Widgets/ErrorView.vala"
	g_signal_connect_object (_tmp40_, "clicked", (GCallback) __widgets_error_view___lambda349__gtk_button_clicked, self, 0);
#line 47 "../src/Widgets/ErrorView.vala"
	_g_object_unref0 (content_box);
#line 47 "../src/Widgets/ErrorView.vala"
	_g_object_unref0 (textview_frame);
#line 47 "../src/Widgets/ErrorView.vala"
	_g_object_unref0 (textview_scrolled_window);
#line 47 "../src/Widgets/ErrorView.vala"
	_g_object_unref0 (error_image);
#line 47 "../src/Widgets/ErrorView.vala"
	_g_object_unref0 (headerbar);
#line 47 "../src/Widgets/ErrorView.vala"
	return obj;
#line 694 "ErrorView.c"
}

static void
widgets_error_view_class_init (WidgetsErrorViewClass * klass,
                               gpointer klass_data)
{
#line 22 "../src/Widgets/ErrorView.vala"
	widgets_error_view_parent_class = g_type_class_peek_parent (klass);
#line 22 "../src/Widgets/ErrorView.vala"
	g_type_class_adjust_private_offset (klass, &WidgetsErrorView_private_offset);
#line 22 "../src/Widgets/ErrorView.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_widgets_error_view_set_property;
#line 22 "../src/Widgets/ErrorView.vala"
	G_OBJECT_CLASS (klass)->constructor = widgets_error_view_constructor;
#line 22 "../src/Widgets/ErrorView.vala"
	G_OBJECT_CLASS (klass)->finalize = widgets_error_view_finalize;
#line 22 "../src/Widgets/ErrorView.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), WIDGETS_ERROR_VIEW_ERROR_CODE_PROPERTY, widgets_error_view_properties[WIDGETS_ERROR_VIEW_ERROR_CODE_PROPERTY] = g_param_spec_int ("error-code", "error-code", "error-code", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_WRITABLE));
#line 22 "../src/Widgets/ErrorView.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), WIDGETS_ERROR_VIEW_ERROR_MESSAGE_PROPERTY, widgets_error_view_properties[WIDGETS_ERROR_VIEW_ERROR_MESSAGE_PROPERTY] = g_param_spec_string ("error-message", "error-message", "error-message", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_WRITABLE));
#line 22 "../src/Widgets/ErrorView.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), WIDGETS_ERROR_VIEW_VISIBLE_ISSUE_BUTTON_PROPERTY, widgets_error_view_properties[WIDGETS_ERROR_VIEW_VISIBLE_ISSUE_BUTTON_PROPERTY] = g_param_spec_boolean ("visible-issue-button", "visible-issue-button", "visible-issue-button", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_WRITABLE));
#line 717 "ErrorView.c"
}

static void
widgets_error_view_instance_init (WidgetsErrorView * self,
                                  gpointer klass)
{
#line 22 "../src/Widgets/ErrorView.vala"
	self->priv = widgets_error_view_get_instance_private (self);
#line 726 "ErrorView.c"
}

static void
widgets_error_view_finalize (GObject * obj)
{
	WidgetsErrorView * self;
#line 22 "../src/Widgets/ErrorView.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, WIDGETS_TYPE_ERROR_VIEW, WidgetsErrorView);
#line 23 "../src/Widgets/ErrorView.vala"
	_g_object_unref0 (self->priv->error_label);
#line 24 "../src/Widgets/ErrorView.vala"
	_g_object_unref0 (self->priv->error_code_label);
#line 25 "../src/Widgets/ErrorView.vala"
	_g_object_unref0 (self->priv->error_textview);
#line 26 "../src/Widgets/ErrorView.vala"
	_g_object_unref0 (self->priv->issue_button);
#line 22 "../src/Widgets/ErrorView.vala"
	G_OBJECT_CLASS (widgets_error_view_parent_class)->finalize (obj);
#line 745 "ErrorView.c"
}

static GType
widgets_error_view_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (WidgetsErrorViewClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) widgets_error_view_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (WidgetsErrorView), 0, (GInstanceInitFunc) widgets_error_view_instance_init, NULL };
	GType widgets_error_view_type_id;
	widgets_error_view_type_id = g_type_register_static (adw_bin_get_type (), "WidgetsErrorView", &g_define_type_info, 0);
	WidgetsErrorView_private_offset = g_type_add_instance_private (widgets_error_view_type_id, sizeof (WidgetsErrorViewPrivate));
	return widgets_error_view_type_id;
}

GType
widgets_error_view_get_type (void)
{
	static volatile gsize widgets_error_view_type_id__once = 0;
	if (g_once_init_enter (&widgets_error_view_type_id__once)) {
		GType widgets_error_view_type_id;
		widgets_error_view_type_id = widgets_error_view_get_type_once ();
		g_once_init_leave (&widgets_error_view_type_id__once, widgets_error_view_type_id);
	}
	return widgets_error_view_type_id__once;
}

static void
_vala_widgets_error_view_set_property (GObject * object,
                                       guint property_id,
                                       const GValue * value,
                                       GParamSpec * pspec)
{
	WidgetsErrorView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, WIDGETS_TYPE_ERROR_VIEW, WidgetsErrorView);
#line 22 "../src/Widgets/ErrorView.vala"
	switch (property_id) {
#line 22 "../src/Widgets/ErrorView.vala"
		case WIDGETS_ERROR_VIEW_ERROR_CODE_PROPERTY:
#line 22 "../src/Widgets/ErrorView.vala"
		widgets_error_view_set_error_code (self, g_value_get_int (value));
#line 22 "../src/Widgets/ErrorView.vala"
		break;
#line 22 "../src/Widgets/ErrorView.vala"
		case WIDGETS_ERROR_VIEW_ERROR_MESSAGE_PROPERTY:
#line 22 "../src/Widgets/ErrorView.vala"
		widgets_error_view_set_error_message (self, g_value_get_string (value));
#line 22 "../src/Widgets/ErrorView.vala"
		break;
#line 22 "../src/Widgets/ErrorView.vala"
		case WIDGETS_ERROR_VIEW_VISIBLE_ISSUE_BUTTON_PROPERTY:
#line 22 "../src/Widgets/ErrorView.vala"
		widgets_error_view_set_visible_issue_button (self, g_value_get_boolean (value));
#line 22 "../src/Widgets/ErrorView.vala"
		break;
#line 798 "ErrorView.c"
		default:
#line 22 "../src/Widgets/ErrorView.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 22 "../src/Widgets/ErrorView.vala"
		break;
#line 804 "ErrorView.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

