/* EventsList.c generated by valac 0.56.18, the Vala compiler
 * generated from EventsList.vala, do not modify */

/*
* Copyright © 2023 Alain M. (https://github.com/alainm23/planify)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 3 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*
* Authored by: Alain M. <alainmh23@gmail.com>
*/

#include <adwaita.h>
#include <glib-object.h>
#include <glib.h>
#include <gtk/gtk.h>
#include <gee.h>
#include <stdlib.h>
#include <string.h>
#include <libedataserver/libedataserver.h>
#include <libecal/libecal.h>
#include <libical-glib/libical-glib.h>
#include "planify.h"
#include <gio/gio.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define WIDGETS_TYPE_EVENTS_LIST (widgets_events_list_get_type ())
#define WIDGETS_EVENTS_LIST(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), WIDGETS_TYPE_EVENTS_LIST, WidgetsEventsList))
#define WIDGETS_EVENTS_LIST_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), WIDGETS_TYPE_EVENTS_LIST, WidgetsEventsListClass))
#define WIDGETS_IS_EVENTS_LIST(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), WIDGETS_TYPE_EVENTS_LIST))
#define WIDGETS_IS_EVENTS_LIST_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), WIDGETS_TYPE_EVENTS_LIST))
#define WIDGETS_EVENTS_LIST_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), WIDGETS_TYPE_EVENTS_LIST, WidgetsEventsListClass))

typedef struct _WidgetsEventsList WidgetsEventsList;
typedef struct _WidgetsEventsListClass WidgetsEventsListClass;
typedef struct _WidgetsEventsListPrivate WidgetsEventsListPrivate;

#define WIDGETS_TYPE_EVENT_ROW (widgets_event_row_get_type ())
#define WIDGETS_EVENT_ROW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), WIDGETS_TYPE_EVENT_ROW, WidgetsEventRow))
#define WIDGETS_EVENT_ROW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), WIDGETS_TYPE_EVENT_ROW, WidgetsEventRowClass))
#define WIDGETS_IS_EVENT_ROW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), WIDGETS_TYPE_EVENT_ROW))
#define WIDGETS_IS_EVENT_ROW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), WIDGETS_TYPE_EVENT_ROW))
#define WIDGETS_EVENT_ROW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), WIDGETS_TYPE_EVENT_ROW, WidgetsEventRowClass))

typedef struct _WidgetsEventRow WidgetsEventRow;
typedef struct _WidgetsEventRowClass WidgetsEventRowClass;

#define SERVICES_TYPE_CALENDAR_EVENTS (services_calendar_events_get_type ())
#define SERVICES_CALENDAR_EVENTS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), SERVICES_TYPE_CALENDAR_EVENTS, ServicesCalendarEvents))
#define SERVICES_CALENDAR_EVENTS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), SERVICES_TYPE_CALENDAR_EVENTS, ServicesCalendarEventsClass))
#define SERVICES_IS_CALENDAR_EVENTS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), SERVICES_TYPE_CALENDAR_EVENTS))
#define SERVICES_IS_CALENDAR_EVENTS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), SERVICES_TYPE_CALENDAR_EVENTS))
#define SERVICES_CALENDAR_EVENTS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), SERVICES_TYPE_CALENDAR_EVENTS, ServicesCalendarEventsClass))

typedef struct _ServicesCalendarEvents ServicesCalendarEvents;
typedef struct _ServicesCalendarEventsClass ServicesCalendarEventsClass;
enum  {
	WIDGETS_EVENTS_LIST_0_PROPERTY,
	WIDGETS_EVENTS_LIST_START_DATE_PROPERTY,
	WIDGETS_EVENTS_LIST_END_DATE_PROPERTY,
	WIDGETS_EVENTS_LIST_IS_DAY_PROPERTY,
	WIDGETS_EVENTS_LIST_IS_MONTH_PROPERTY,
	WIDGETS_EVENTS_LIST_IS_RANGE_PROPERTY,
	WIDGETS_EVENTS_LIST_HAS_ITEMS_PROPERTY,
	WIDGETS_EVENTS_LIST_NUM_PROPERTIES
};
static GParamSpec* widgets_events_list_properties[WIDGETS_EVENTS_LIST_NUM_PROPERTIES];
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
enum  {
	WIDGETS_EVENTS_LIST_CHANGE_SIGNAL,
	WIDGETS_EVENTS_LIST_NUM_SIGNALS
};
static guint widgets_events_list_signals[WIDGETS_EVENTS_LIST_NUM_SIGNALS] = {0};

struct _WidgetsEventsList {
	AdwBin parent_instance;
	WidgetsEventsListPrivate * priv;
};

struct _WidgetsEventsListClass {
	AdwBinClass parent_class;
};

struct _WidgetsEventsListPrivate {
	GDateTime* _start_date;
	GDateTime* _end_date;
	gboolean _is_day;
	gboolean _is_month;
	gboolean _is_range;
	GtkListBox* listbox;
	GtkRevealer* main_revealer;
	GeeHashMap* event_hashmap;
	ServicesCalendarEvents* event_model;
};

static gint WidgetsEventsList_private_offset;
static gpointer widgets_events_list_parent_class = NULL;

VALA_EXTERN GType widgets_events_list_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (WidgetsEventsList, g_object_unref)
VALA_EXTERN GType widgets_event_row_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (WidgetsEventRow, g_object_unref)
VALA_EXTERN GType services_calendar_events_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ServicesCalendarEvents, g_object_unref)
VALA_EXTERN WidgetsEventsList* widgets_events_list_new_for_day (GDateTime* start_date);
VALA_EXTERN WidgetsEventsList* widgets_events_list_construct_for_day (GType object_type,
                                                          GDateTime* start_date);
VALA_EXTERN WidgetsEventsList* widgets_events_list_new_for_range (GDateTime* start_date,
                                                      GDateTime* end_date);
VALA_EXTERN WidgetsEventsList* widgets_events_list_construct_for_range (GType object_type,
                                                            GDateTime* start_date,
                                                            GDateTime* end_date);
VALA_EXTERN WidgetsEventsList* widgets_events_list_new_for_month (GDateTime* start_date);
VALA_EXTERN WidgetsEventsList* widgets_events_list_construct_for_month (GType object_type,
                                                            GDateTime* start_date);
static void widgets_events_list_add_events (WidgetsEventsList* self);
static void widgets_events_list_add_event_model (WidgetsEventsList* self,
                                          ESource* source,
                                          GeeCollection* components);
static void _widgets_events_list_add_event_model_services_calendar_events_components_added (ServicesCalendarEvents* _sender,
                                                                                     ESource* source,
                                                                                     GeeCollection* components,
                                                                                     gpointer self);
static void widgets_events_list_remove_event_model (WidgetsEventsList* self,
                                             ESource* source,
                                             GeeCollection* events);
static void _widgets_events_list_remove_event_model_services_calendar_events_components_removed (ServicesCalendarEvents* _sender,
                                                                                          ESource* source,
                                                                                          GeeCollection* components,
                                                                                          gpointer self);
VALA_EXTERN gboolean widgets_events_list_get_is_day (WidgetsEventsList* self);
VALA_EXTERN gboolean calendar_events_util_calcomp_is_on_day (ECalComponent* comp,
                                                 GDateTime* day);
VALA_EXTERN GDateTime* widgets_events_list_get_start_date (WidgetsEventsList* self);
static void widgets_events_list_add_row_event (WidgetsEventsList* self,
                                        ECalComponent* component,
                                        ESource* source);
VALA_EXTERN gboolean widgets_events_list_get_is_month (WidgetsEventsList* self);
VALA_EXTERN gboolean calendar_events_util_calcomp_is_on_month (ECalComponent* comp,
                                                   GDateTime* date);
VALA_EXTERN WidgetsEventRow* widgets_event_row_new (ICalComponent* component,
                                        ESource* source);
VALA_EXTERN WidgetsEventRow* widgets_event_row_construct (GType object_type,
                                              ICalComponent* component,
                                              ESource* source);
static gint widgets_events_list_sort_event_function (WidgetsEventsList* self,
                                              GtkListBoxRow* child1,
                                              GtkListBoxRow* child2);
VALA_EXTERN GDateTime* widgets_event_row_get_start_time (WidgetsEventRow* self);
VALA_EXTERN gboolean widgets_event_row_get_is_allday (WidgetsEventRow* self);
VALA_EXTERN WidgetsEventsList* widgets_events_list_new (void);
VALA_EXTERN WidgetsEventsList* widgets_events_list_construct (GType object_type);
static void widgets_events_list_set_start_date (WidgetsEventsList* self,
                                         GDateTime* value);
VALA_EXTERN GDateTime* widgets_events_list_get_end_date (WidgetsEventsList* self);
static void widgets_events_list_set_end_date (WidgetsEventsList* self,
                                       GDateTime* value);
static void widgets_events_list_set_is_day (WidgetsEventsList* self,
                                     gboolean value);
static void widgets_events_list_set_is_month (WidgetsEventsList* self,
                                       gboolean value);
VALA_EXTERN gboolean widgets_events_list_get_is_range (WidgetsEventsList* self);
static void widgets_events_list_set_is_range (WidgetsEventsList* self,
                                       gboolean value);
VALA_EXTERN gboolean widgets_events_list_get_has_items (WidgetsEventsList* self);
static GObject * widgets_events_list_constructor (GType type,
                                           guint n_construct_properties,
                                           GObjectConstructParam * construct_properties);
VALA_EXTERN ServicesCalendarEvents* services_calendar_events_new (GDateTime* month_start);
VALA_EXTERN ServicesCalendarEvents* services_calendar_events_construct (GType object_type,
                                                            GDateTime* month_start);
static gint _widgets_events_list_sort_event_function_gtk_list_box_sort_func (GtkListBoxRow* row1,
                                                                      GtkListBoxRow* row2,
                                                                      gpointer self);
static void _widgets_events_list___lambda651_ (WidgetsEventsList* self);
static void __widgets_events_list___lambda651__g_settings_changed (GSettings* _sender,
                                                            const gchar* key,
                                                            gpointer self);
static void widgets_events_list_finalize (GObject * obj);
static GType widgets_events_list_get_type_once (void);
static void _vala_widgets_events_list_get_property (GObject * object,
                                             guint property_id,
                                             GValue * value,
                                             GParamSpec * pspec);
static void _vala_widgets_events_list_set_property (GObject * object,
                                             guint property_id,
                                             const GValue * value,
                                             GParamSpec * pspec);

static inline gpointer
widgets_events_list_get_instance_private (WidgetsEventsList* self)
{
	return G_STRUCT_MEMBER_P (self, WidgetsEventsList_private_offset);
}

WidgetsEventsList*
widgets_events_list_construct_for_day (GType object_type,
                                       GDateTime* start_date)
{
	WidgetsEventsList * self = NULL;
#line 44 "../src/Widgets/EventsList.vala"
	g_return_val_if_fail (start_date != NULL, NULL);
#line 45 "../src/Widgets/EventsList.vala"
	self = (WidgetsEventsList*) g_object_new (object_type, "start-date", start_date, "end-date", start_date, "is-day", TRUE, "is-range", FALSE, "is-month", FALSE, NULL);
#line 44 "../src/Widgets/EventsList.vala"
	return self;
#line 239 "EventsList.c"
}

WidgetsEventsList*
widgets_events_list_new_for_day (GDateTime* start_date)
{
#line 44 "../src/Widgets/EventsList.vala"
	return widgets_events_list_construct_for_day (WIDGETS_TYPE_EVENTS_LIST, start_date);
#line 247 "EventsList.c"
}

WidgetsEventsList*
widgets_events_list_construct_for_range (GType object_type,
                                         GDateTime* start_date,
                                         GDateTime* end_date)
{
	WidgetsEventsList * self = NULL;
#line 54 "../src/Widgets/EventsList.vala"
	g_return_val_if_fail (start_date != NULL, NULL);
#line 54 "../src/Widgets/EventsList.vala"
	g_return_val_if_fail (end_date != NULL, NULL);
#line 55 "../src/Widgets/EventsList.vala"
	self = (WidgetsEventsList*) g_object_new (object_type, "start-date", start_date, "end-date", end_date, "is-day", FALSE, "is-range", TRUE, "is-month", FALSE, NULL);
#line 54 "../src/Widgets/EventsList.vala"
	return self;
#line 264 "EventsList.c"
}

WidgetsEventsList*
widgets_events_list_new_for_range (GDateTime* start_date,
                                   GDateTime* end_date)
{
#line 54 "../src/Widgets/EventsList.vala"
	return widgets_events_list_construct_for_range (WIDGETS_TYPE_EVENTS_LIST, start_date, end_date);
#line 273 "EventsList.c"
}

WidgetsEventsList*
widgets_events_list_construct_for_month (GType object_type,
                                         GDateTime* start_date)
{
	WidgetsEventsList * self = NULL;
#line 64 "../src/Widgets/EventsList.vala"
	g_return_val_if_fail (start_date != NULL, NULL);
#line 65 "../src/Widgets/EventsList.vala"
	self = (WidgetsEventsList*) g_object_new (object_type, "start-date", start_date, "end-date", start_date, "is-day", FALSE, "is-range", FALSE, "is-month", TRUE, NULL);
#line 64 "../src/Widgets/EventsList.vala"
	return self;
#line 287 "EventsList.c"
}

WidgetsEventsList*
widgets_events_list_new_for_month (GDateTime* start_date)
{
#line 64 "../src/Widgets/EventsList.vala"
	return widgets_events_list_construct_for_month (WIDGETS_TYPE_EVENTS_LIST, start_date);
#line 295 "EventsList.c"
}

static void
_widgets_events_list_add_event_model_services_calendar_events_components_added (ServicesCalendarEvents* _sender,
                                                                                ESource* source,
                                                                                GeeCollection* components,
                                                                                gpointer self)
{
#line 114 "../src/Widgets/EventsList.vala"
	widgets_events_list_add_event_model ((WidgetsEventsList*) self, source, components);
#line 306 "EventsList.c"
}

static void
_widgets_events_list_remove_event_model_services_calendar_events_components_removed (ServicesCalendarEvents* _sender,
                                                                                     ESource* source,
                                                                                     GeeCollection* components,
                                                                                     gpointer self)
{
#line 115 "../src/Widgets/EventsList.vala"
	widgets_events_list_remove_event_model ((WidgetsEventsList*) self, source, components);
#line 317 "EventsList.c"
}

static void
widgets_events_list_add_events (WidgetsEventsList* self)
{
	ServicesCalendarEvents* _tmp0_;
	ServicesCalendarEvents* _tmp1_;
#line 113 "../src/Widgets/EventsList.vala"
	g_return_if_fail (self != NULL);
#line 114 "../src/Widgets/EventsList.vala"
	_tmp0_ = self->priv->event_model;
#line 114 "../src/Widgets/EventsList.vala"
	g_signal_connect_object (_tmp0_, "components-added", (GCallback) _widgets_events_list_add_event_model_services_calendar_events_components_added, self, 0);
#line 115 "../src/Widgets/EventsList.vala"
	_tmp1_ = self->priv->event_model;
#line 115 "../src/Widgets/EventsList.vala"
	g_signal_connect_object (_tmp1_, "components-removed", (GCallback) _widgets_events_list_remove_event_model_services_calendar_events_components_removed, self, 0);
#line 335 "EventsList.c"
}

static void
widgets_events_list_add_event_model (WidgetsEventsList* self,
                                     ESource* source,
                                     GeeCollection* components)
{
#line 118 "../src/Widgets/EventsList.vala"
	g_return_if_fail (self != NULL);
#line 118 "../src/Widgets/EventsList.vala"
	g_return_if_fail (source != NULL);
#line 118 "../src/Widgets/EventsList.vala"
	g_return_if_fail (components != NULL);
#line 349 "EventsList.c"
	{
		GeeIterator* _component_it = NULL;
		GeeIterator* _tmp0_;
#line 119 "../src/Widgets/EventsList.vala"
		_tmp0_ = gee_iterable_iterator ((GeeIterable*) components);
#line 119 "../src/Widgets/EventsList.vala"
		_component_it = _tmp0_;
#line 119 "../src/Widgets/EventsList.vala"
		while (TRUE) {
#line 359 "EventsList.c"
			GeeIterator* _tmp1_;
			ECalComponent* component = NULL;
			GeeIterator* _tmp2_;
			gpointer _tmp3_;
			gboolean _tmp4_;
#line 119 "../src/Widgets/EventsList.vala"
			_tmp1_ = _component_it;
#line 119 "../src/Widgets/EventsList.vala"
			if (!gee_iterator_next (_tmp1_)) {
#line 119 "../src/Widgets/EventsList.vala"
				break;
#line 371 "EventsList.c"
			}
#line 119 "../src/Widgets/EventsList.vala"
			_tmp2_ = _component_it;
#line 119 "../src/Widgets/EventsList.vala"
			_tmp3_ = gee_iterator_get (_tmp2_);
#line 119 "../src/Widgets/EventsList.vala"
			component = (ECalComponent*) _tmp3_;
#line 120 "../src/Widgets/EventsList.vala"
			_tmp4_ = self->priv->_is_day;
#line 120 "../src/Widgets/EventsList.vala"
			if (_tmp4_) {
#line 383 "EventsList.c"
				ECalComponent* _tmp5_;
				GDateTime* _tmp6_;
#line 121 "../src/Widgets/EventsList.vala"
				_tmp5_ = component;
#line 121 "../src/Widgets/EventsList.vala"
				_tmp6_ = self->priv->_start_date;
#line 121 "../src/Widgets/EventsList.vala"
				if (calendar_events_util_calcomp_is_on_day (_tmp5_, _tmp6_)) {
#line 392 "EventsList.c"
					ECalComponent* _tmp7_;
#line 122 "../src/Widgets/EventsList.vala"
					_tmp7_ = component;
#line 122 "../src/Widgets/EventsList.vala"
					widgets_events_list_add_row_event (self, _tmp7_, source);
#line 398 "EventsList.c"
				}
			} else {
				gboolean _tmp8_;
#line 124 "../src/Widgets/EventsList.vala"
				_tmp8_ = self->priv->_is_month;
#line 124 "../src/Widgets/EventsList.vala"
				if (_tmp8_) {
#line 406 "EventsList.c"
					ECalComponent* _tmp9_;
					GDateTime* _tmp10_;
#line 125 "../src/Widgets/EventsList.vala"
					_tmp9_ = component;
#line 125 "../src/Widgets/EventsList.vala"
					_tmp10_ = self->priv->_start_date;
#line 125 "../src/Widgets/EventsList.vala"
					if (calendar_events_util_calcomp_is_on_month (_tmp9_, _tmp10_)) {
#line 415 "EventsList.c"
						ECalComponent* _tmp11_;
#line 126 "../src/Widgets/EventsList.vala"
						_tmp11_ = component;
#line 126 "../src/Widgets/EventsList.vala"
						widgets_events_list_add_row_event (self, _tmp11_, source);
#line 421 "EventsList.c"
					}
				}
			}
#line 119 "../src/Widgets/EventsList.vala"
			_g_object_unref0 (component);
#line 427 "EventsList.c"
		}
#line 119 "../src/Widgets/EventsList.vala"
		_g_object_unref0 (_component_it);
#line 431 "EventsList.c"
	}
}

static void
widgets_events_list_add_row_event (WidgetsEventsList* self,
                                   ECalComponent* component,
                                   ESource* source)
{
	ICalComponent* ical = NULL;
	ICalComponent* _tmp0_;
	gchar* event_uid = NULL;
	ICalComponent* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	GeeHashMap* _tmp4_;
	const gchar* _tmp5_;
#line 132 "../src/Widgets/EventsList.vala"
	g_return_if_fail (self != NULL);
#line 132 "../src/Widgets/EventsList.vala"
	g_return_if_fail (component != NULL);
#line 132 "../src/Widgets/EventsList.vala"
	g_return_if_fail (source != NULL);
#line 133 "../src/Widgets/EventsList.vala"
	_tmp0_ = e_cal_component_get_icalcomponent (component);
#line 133 "../src/Widgets/EventsList.vala"
	ical = _tmp0_;
#line 134 "../src/Widgets/EventsList.vala"
	_tmp1_ = ical;
#line 134 "../src/Widgets/EventsList.vala"
	_tmp2_ = i_cal_component_get_uid (_tmp1_);
#line 134 "../src/Widgets/EventsList.vala"
	_tmp3_ = g_strdup (_tmp2_);
#line 134 "../src/Widgets/EventsList.vala"
	event_uid = _tmp3_;
#line 135 "../src/Widgets/EventsList.vala"
	_tmp4_ = self->priv->event_hashmap;
#line 135 "../src/Widgets/EventsList.vala"
	_tmp5_ = event_uid;
#line 135 "../src/Widgets/EventsList.vala"
	if (!gee_abstract_map_has_key ((GeeAbstractMap*) _tmp4_, _tmp5_)) {
#line 472 "EventsList.c"
		GeeHashMap* _tmp6_;
		const gchar* _tmp7_;
		ICalComponent* _tmp8_;
		WidgetsEventRow* _tmp9_;
		WidgetsEventRow* _tmp10_;
		GtkListBox* _tmp11_;
		GeeHashMap* _tmp12_;
		const gchar* _tmp13_;
		gpointer _tmp14_;
		WidgetsEventRow* _tmp15_;
#line 136 "../src/Widgets/EventsList.vala"
		_tmp6_ = self->priv->event_hashmap;
#line 136 "../src/Widgets/EventsList.vala"
		_tmp7_ = event_uid;
#line 136 "../src/Widgets/EventsList.vala"
		_tmp8_ = ical;
#line 136 "../src/Widgets/EventsList.vala"
		_tmp9_ = widgets_event_row_new (_tmp8_, source);
#line 136 "../src/Widgets/EventsList.vala"
		g_object_ref_sink (_tmp9_);
#line 136 "../src/Widgets/EventsList.vala"
		_tmp10_ = _tmp9_;
#line 136 "../src/Widgets/EventsList.vala"
		gee_abstract_map_set ((GeeAbstractMap*) _tmp6_, _tmp7_, _tmp10_);
#line 136 "../src/Widgets/EventsList.vala"
		_g_object_unref0 (_tmp10_);
#line 137 "../src/Widgets/EventsList.vala"
		_tmp11_ = self->priv->listbox;
#line 137 "../src/Widgets/EventsList.vala"
		_tmp12_ = self->priv->event_hashmap;
#line 137 "../src/Widgets/EventsList.vala"
		_tmp13_ = event_uid;
#line 137 "../src/Widgets/EventsList.vala"
		_tmp14_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp12_, _tmp13_);
#line 137 "../src/Widgets/EventsList.vala"
		_tmp15_ = (WidgetsEventRow*) _tmp14_;
#line 137 "../src/Widgets/EventsList.vala"
		gtk_list_box_append (_tmp11_, (GtkWidget*) _tmp15_);
#line 137 "../src/Widgets/EventsList.vala"
		_g_object_unref0 (_tmp15_);
#line 513 "EventsList.c"
	}
#line 140 "../src/Widgets/EventsList.vala"
	g_signal_emit (self, widgets_events_list_signals[WIDGETS_EVENTS_LIST_CHANGE_SIGNAL], 0);
#line 132 "../src/Widgets/EventsList.vala"
	_g_free0 (event_uid);
#line 519 "EventsList.c"
}

static void
widgets_events_list_remove_event_model (WidgetsEventsList* self,
                                        ESource* source,
                                        GeeCollection* events)
{
#line 143 "../src/Widgets/EventsList.vala"
	g_return_if_fail (self != NULL);
#line 143 "../src/Widgets/EventsList.vala"
	g_return_if_fail (source != NULL);
#line 143 "../src/Widgets/EventsList.vala"
	g_return_if_fail (events != NULL);
#line 533 "EventsList.c"
	{
		GeeIterator* _component_it = NULL;
		GeeIterator* _tmp0_;
#line 144 "../src/Widgets/EventsList.vala"
		_tmp0_ = gee_iterable_iterator ((GeeIterable*) events);
#line 144 "../src/Widgets/EventsList.vala"
		_component_it = _tmp0_;
#line 144 "../src/Widgets/EventsList.vala"
		while (TRUE) {
#line 543 "EventsList.c"
			GeeIterator* _tmp1_;
			ECalComponent* component = NULL;
			GeeIterator* _tmp2_;
			gpointer _tmp3_;
			ICalComponent* ical = NULL;
			ECalComponent* _tmp4_;
			ICalComponent* _tmp5_;
			gchar* event_uid = NULL;
			ICalComponent* _tmp6_;
			const gchar* _tmp7_;
			gchar* _tmp8_;
			WidgetsEventRow* event_row = NULL;
			GeeHashMap* _tmp9_;
			const gchar* _tmp10_;
			gpointer _tmp11_;
			WidgetsEventRow* _tmp12_;
#line 144 "../src/Widgets/EventsList.vala"
			_tmp1_ = _component_it;
#line 144 "../src/Widgets/EventsList.vala"
			if (!gee_iterator_next (_tmp1_)) {
#line 144 "../src/Widgets/EventsList.vala"
				break;
#line 566 "EventsList.c"
			}
#line 144 "../src/Widgets/EventsList.vala"
			_tmp2_ = _component_it;
#line 144 "../src/Widgets/EventsList.vala"
			_tmp3_ = gee_iterator_get (_tmp2_);
#line 144 "../src/Widgets/EventsList.vala"
			component = (ECalComponent*) _tmp3_;
#line 145 "../src/Widgets/EventsList.vala"
			_tmp4_ = component;
#line 145 "../src/Widgets/EventsList.vala"
			_tmp5_ = e_cal_component_get_icalcomponent (_tmp4_);
#line 145 "../src/Widgets/EventsList.vala"
			ical = _tmp5_;
#line 146 "../src/Widgets/EventsList.vala"
			_tmp6_ = ical;
#line 146 "../src/Widgets/EventsList.vala"
			_tmp7_ = i_cal_component_get_uid (_tmp6_);
#line 146 "../src/Widgets/EventsList.vala"
			_tmp8_ = g_strdup (_tmp7_);
#line 146 "../src/Widgets/EventsList.vala"
			event_uid = _tmp8_;
#line 147 "../src/Widgets/EventsList.vala"
			_tmp9_ = self->priv->event_hashmap;
#line 147 "../src/Widgets/EventsList.vala"
			_tmp10_ = event_uid;
#line 147 "../src/Widgets/EventsList.vala"
			_tmp11_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp9_, _tmp10_);
#line 147 "../src/Widgets/EventsList.vala"
			event_row = (WidgetsEventRow*) _tmp11_;
#line 148 "../src/Widgets/EventsList.vala"
			_tmp12_ = event_row;
#line 148 "../src/Widgets/EventsList.vala"
			if (_tmp12_ != NULL) {
#line 600 "EventsList.c"
				WidgetsEventRow* _tmp13_;
				GeeHashMap* _tmp14_;
				const gchar* _tmp15_;
				GtkListBox* _tmp16_;
				WidgetsEventRow* _tmp17_;
#line 149 "../src/Widgets/EventsList.vala"
				_tmp13_ = event_row;
#line 149 "../src/Widgets/EventsList.vala"
				g_signal_emit_by_name ((GtkWidget*) _tmp13_, "destroy");
#line 150 "../src/Widgets/EventsList.vala"
				_tmp14_ = self->priv->event_hashmap;
#line 150 "../src/Widgets/EventsList.vala"
				_tmp15_ = event_uid;
#line 150 "../src/Widgets/EventsList.vala"
				gee_abstract_map_unset ((GeeAbstractMap*) _tmp14_, _tmp15_, NULL);
#line 151 "../src/Widgets/EventsList.vala"
				_tmp16_ = self->priv->listbox;
#line 151 "../src/Widgets/EventsList.vala"
				_tmp17_ = event_row;
#line 151 "../src/Widgets/EventsList.vala"
				gtk_list_box_remove (_tmp16_, (GtkWidget*) _tmp17_);
#line 622 "EventsList.c"
			}
#line 144 "../src/Widgets/EventsList.vala"
			_g_object_unref0 (event_row);
#line 144 "../src/Widgets/EventsList.vala"
			_g_free0 (event_uid);
#line 144 "../src/Widgets/EventsList.vala"
			_g_object_unref0 (component);
#line 630 "EventsList.c"
		}
#line 144 "../src/Widgets/EventsList.vala"
		_g_object_unref0 (_component_it);
#line 634 "EventsList.c"
	}
#line 155 "../src/Widgets/EventsList.vala"
	g_signal_emit (self, widgets_events_list_signals[WIDGETS_EVENTS_LIST_CHANGE_SIGNAL], 0);
#line 638 "EventsList.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 159 "../src/Widgets/EventsList.vala"
	return self ? g_object_ref (self) : NULL;
#line 646 "EventsList.c"
}

static gint
widgets_events_list_sort_event_function (WidgetsEventsList* self,
                                         GtkListBoxRow* child1,
                                         GtkListBoxRow* child2)
{
	WidgetsEventRow* e1 = NULL;
	WidgetsEventRow* _tmp0_;
	WidgetsEventRow* e2 = NULL;
	WidgetsEventRow* _tmp1_;
	WidgetsEventRow* _tmp2_;
	GDateTime* _tmp3_;
	GDateTime* _tmp4_;
	WidgetsEventRow* _tmp5_;
	GDateTime* _tmp6_;
	GDateTime* _tmp7_;
	WidgetsEventRow* _tmp14_;
	gboolean _tmp15_;
	gboolean _tmp16_;
	gint result;
#line 158 "../src/Widgets/EventsList.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 158 "../src/Widgets/EventsList.vala"
	g_return_val_if_fail (child1 != NULL, 0);
#line 158 "../src/Widgets/EventsList.vala"
	g_return_val_if_fail (child2 != NULL, 0);
#line 159 "../src/Widgets/EventsList.vala"
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (child1, WIDGETS_TYPE_EVENT_ROW, WidgetsEventRow));
#line 159 "../src/Widgets/EventsList.vala"
	e1 = _tmp0_;
#line 160 "../src/Widgets/EventsList.vala"
	_tmp1_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (child2, WIDGETS_TYPE_EVENT_ROW, WidgetsEventRow));
#line 160 "../src/Widgets/EventsList.vala"
	e2 = _tmp1_;
#line 162 "../src/Widgets/EventsList.vala"
	_tmp2_ = e1;
#line 162 "../src/Widgets/EventsList.vala"
	_tmp3_ = widgets_event_row_get_start_time (_tmp2_);
#line 162 "../src/Widgets/EventsList.vala"
	_tmp4_ = _tmp3_;
#line 162 "../src/Widgets/EventsList.vala"
	_tmp5_ = e2;
#line 162 "../src/Widgets/EventsList.vala"
	_tmp6_ = widgets_event_row_get_start_time (_tmp5_);
#line 162 "../src/Widgets/EventsList.vala"
	_tmp7_ = _tmp6_;
#line 162 "../src/Widgets/EventsList.vala"
	if (g_date_time_compare (_tmp4_, _tmp7_) != 0) {
#line 696 "EventsList.c"
		WidgetsEventRow* _tmp8_;
		GDateTime* _tmp9_;
		GDateTime* _tmp10_;
		WidgetsEventRow* _tmp11_;
		GDateTime* _tmp12_;
		GDateTime* _tmp13_;
#line 163 "../src/Widgets/EventsList.vala"
		_tmp8_ = e1;
#line 163 "../src/Widgets/EventsList.vala"
		_tmp9_ = widgets_event_row_get_start_time (_tmp8_);
#line 163 "../src/Widgets/EventsList.vala"
		_tmp10_ = _tmp9_;
#line 163 "../src/Widgets/EventsList.vala"
		_tmp11_ = e2;
#line 163 "../src/Widgets/EventsList.vala"
		_tmp12_ = widgets_event_row_get_start_time (_tmp11_);
#line 163 "../src/Widgets/EventsList.vala"
		_tmp13_ = _tmp12_;
#line 163 "../src/Widgets/EventsList.vala"
		result = g_date_time_compare (_tmp10_, _tmp13_);
#line 163 "../src/Widgets/EventsList.vala"
		_g_object_unref0 (e2);
#line 163 "../src/Widgets/EventsList.vala"
		_g_object_unref0 (e1);
#line 163 "../src/Widgets/EventsList.vala"
		return result;
#line 723 "EventsList.c"
	}
#line 167 "../src/Widgets/EventsList.vala"
	_tmp14_ = e1;
#line 167 "../src/Widgets/EventsList.vala"
	_tmp15_ = widgets_event_row_get_is_allday (_tmp14_);
#line 167 "../src/Widgets/EventsList.vala"
	_tmp16_ = _tmp15_;
#line 167 "../src/Widgets/EventsList.vala"
	if (_tmp16_) {
#line 168 "../src/Widgets/EventsList.vala"
		result = -1;
#line 168 "../src/Widgets/EventsList.vala"
		_g_object_unref0 (e2);
#line 168 "../src/Widgets/EventsList.vala"
		_g_object_unref0 (e1);
#line 168 "../src/Widgets/EventsList.vala"
		return result;
#line 741 "EventsList.c"
	} else {
		WidgetsEventRow* _tmp17_;
		gboolean _tmp18_;
		gboolean _tmp19_;
#line 169 "../src/Widgets/EventsList.vala"
		_tmp17_ = e2;
#line 169 "../src/Widgets/EventsList.vala"
		_tmp18_ = widgets_event_row_get_is_allday (_tmp17_);
#line 169 "../src/Widgets/EventsList.vala"
		_tmp19_ = _tmp18_;
#line 169 "../src/Widgets/EventsList.vala"
		if (_tmp19_) {
#line 170 "../src/Widgets/EventsList.vala"
			result = 1;
#line 170 "../src/Widgets/EventsList.vala"
			_g_object_unref0 (e2);
#line 170 "../src/Widgets/EventsList.vala"
			_g_object_unref0 (e1);
#line 170 "../src/Widgets/EventsList.vala"
			return result;
#line 762 "EventsList.c"
		}
	}
#line 173 "../src/Widgets/EventsList.vala"
	result = 0;
#line 173 "../src/Widgets/EventsList.vala"
	_g_object_unref0 (e2);
#line 173 "../src/Widgets/EventsList.vala"
	_g_object_unref0 (e1);
#line 173 "../src/Widgets/EventsList.vala"
	return result;
#line 773 "EventsList.c"
}

WidgetsEventsList*
widgets_events_list_construct (GType object_type)
{
	WidgetsEventsList * self = NULL;
#line 22 "../src/Widgets/EventsList.vala"
	self = (WidgetsEventsList*) g_object_new (object_type, NULL);
#line 22 "../src/Widgets/EventsList.vala"
	return self;
#line 784 "EventsList.c"
}

WidgetsEventsList*
widgets_events_list_new (void)
{
#line 22 "../src/Widgets/EventsList.vala"
	return widgets_events_list_construct (WIDGETS_TYPE_EVENTS_LIST);
#line 792 "EventsList.c"
}

GDateTime*
widgets_events_list_get_start_date (WidgetsEventsList* self)
{
	GDateTime* result;
	GDateTime* _tmp0_;
#line 23 "../src/Widgets/EventsList.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 23 "../src/Widgets/EventsList.vala"
	_tmp0_ = self->priv->_start_date;
#line 23 "../src/Widgets/EventsList.vala"
	result = _tmp0_;
#line 23 "../src/Widgets/EventsList.vala"
	return result;
#line 808 "EventsList.c"
}

static gpointer
_g_date_time_ref0 (gpointer self)
{
#line 23 "../src/Widgets/EventsList.vala"
	return self ? g_date_time_ref (self) : NULL;
#line 816 "EventsList.c"
}

static void
widgets_events_list_set_start_date (WidgetsEventsList* self,
                                    GDateTime* value)
{
	GDateTime* old_value;
#line 23 "../src/Widgets/EventsList.vala"
	g_return_if_fail (self != NULL);
#line 23 "../src/Widgets/EventsList.vala"
	old_value = widgets_events_list_get_start_date (self);
#line 23 "../src/Widgets/EventsList.vala"
	if (old_value != value) {
#line 830 "EventsList.c"
		GDateTime* _tmp0_;
#line 23 "../src/Widgets/EventsList.vala"
		_tmp0_ = _g_date_time_ref0 (value);
#line 23 "../src/Widgets/EventsList.vala"
		_g_date_time_unref0 (self->priv->_start_date);
#line 23 "../src/Widgets/EventsList.vala"
		self->priv->_start_date = _tmp0_;
#line 23 "../src/Widgets/EventsList.vala"
		g_object_notify_by_pspec ((GObject *) self, widgets_events_list_properties[WIDGETS_EVENTS_LIST_START_DATE_PROPERTY]);
#line 840 "EventsList.c"
	}
}

GDateTime*
widgets_events_list_get_end_date (WidgetsEventsList* self)
{
	GDateTime* result;
	GDateTime* _tmp0_;
#line 24 "../src/Widgets/EventsList.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 24 "../src/Widgets/EventsList.vala"
	_tmp0_ = self->priv->_end_date;
#line 24 "../src/Widgets/EventsList.vala"
	result = _tmp0_;
#line 24 "../src/Widgets/EventsList.vala"
	return result;
#line 857 "EventsList.c"
}

static void
widgets_events_list_set_end_date (WidgetsEventsList* self,
                                  GDateTime* value)
{
	GDateTime* old_value;
#line 24 "../src/Widgets/EventsList.vala"
	g_return_if_fail (self != NULL);
#line 24 "../src/Widgets/EventsList.vala"
	old_value = widgets_events_list_get_end_date (self);
#line 24 "../src/Widgets/EventsList.vala"
	if (old_value != value) {
#line 871 "EventsList.c"
		GDateTime* _tmp0_;
#line 24 "../src/Widgets/EventsList.vala"
		_tmp0_ = _g_date_time_ref0 (value);
#line 24 "../src/Widgets/EventsList.vala"
		_g_date_time_unref0 (self->priv->_end_date);
#line 24 "../src/Widgets/EventsList.vala"
		self->priv->_end_date = _tmp0_;
#line 24 "../src/Widgets/EventsList.vala"
		g_object_notify_by_pspec ((GObject *) self, widgets_events_list_properties[WIDGETS_EVENTS_LIST_END_DATE_PROPERTY]);
#line 881 "EventsList.c"
	}
}

gboolean
widgets_events_list_get_is_day (WidgetsEventsList* self)
{
	gboolean result;
#line 26 "../src/Widgets/EventsList.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 26 "../src/Widgets/EventsList.vala"
	result = self->priv->_is_day;
#line 26 "../src/Widgets/EventsList.vala"
	return result;
#line 895 "EventsList.c"
}

static void
widgets_events_list_set_is_day (WidgetsEventsList* self,
                                gboolean value)
{
	gboolean old_value;
#line 26 "../src/Widgets/EventsList.vala"
	g_return_if_fail (self != NULL);
#line 26 "../src/Widgets/EventsList.vala"
	old_value = widgets_events_list_get_is_day (self);
#line 26 "../src/Widgets/EventsList.vala"
	if (old_value != value) {
#line 26 "../src/Widgets/EventsList.vala"
		self->priv->_is_day = value;
#line 26 "../src/Widgets/EventsList.vala"
		g_object_notify_by_pspec ((GObject *) self, widgets_events_list_properties[WIDGETS_EVENTS_LIST_IS_DAY_PROPERTY]);
#line 913 "EventsList.c"
	}
}

gboolean
widgets_events_list_get_is_month (WidgetsEventsList* self)
{
	gboolean result;
#line 27 "../src/Widgets/EventsList.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 27 "../src/Widgets/EventsList.vala"
	result = self->priv->_is_month;
#line 27 "../src/Widgets/EventsList.vala"
	return result;
#line 927 "EventsList.c"
}

static void
widgets_events_list_set_is_month (WidgetsEventsList* self,
                                  gboolean value)
{
	gboolean old_value;
#line 27 "../src/Widgets/EventsList.vala"
	g_return_if_fail (self != NULL);
#line 27 "../src/Widgets/EventsList.vala"
	old_value = widgets_events_list_get_is_month (self);
#line 27 "../src/Widgets/EventsList.vala"
	if (old_value != value) {
#line 27 "../src/Widgets/EventsList.vala"
		self->priv->_is_month = value;
#line 27 "../src/Widgets/EventsList.vala"
		g_object_notify_by_pspec ((GObject *) self, widgets_events_list_properties[WIDGETS_EVENTS_LIST_IS_MONTH_PROPERTY]);
#line 945 "EventsList.c"
	}
}

gboolean
widgets_events_list_get_is_range (WidgetsEventsList* self)
{
	gboolean result;
#line 28 "../src/Widgets/EventsList.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 28 "../src/Widgets/EventsList.vala"
	result = self->priv->_is_range;
#line 28 "../src/Widgets/EventsList.vala"
	return result;
#line 959 "EventsList.c"
}

static void
widgets_events_list_set_is_range (WidgetsEventsList* self,
                                  gboolean value)
{
	gboolean old_value;
#line 28 "../src/Widgets/EventsList.vala"
	g_return_if_fail (self != NULL);
#line 28 "../src/Widgets/EventsList.vala"
	old_value = widgets_events_list_get_is_range (self);
#line 28 "../src/Widgets/EventsList.vala"
	if (old_value != value) {
#line 28 "../src/Widgets/EventsList.vala"
		self->priv->_is_range = value;
#line 28 "../src/Widgets/EventsList.vala"
		g_object_notify_by_pspec ((GObject *) self, widgets_events_list_properties[WIDGETS_EVENTS_LIST_IS_RANGE_PROPERTY]);
#line 977 "EventsList.c"
	}
}

gboolean
widgets_events_list_get_has_items (WidgetsEventsList* self)
{
	gboolean result;
	GeeHashMap* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
#line 39 "../src/Widgets/EventsList.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 40 "../src/Widgets/EventsList.vala"
	_tmp0_ = self->priv->event_hashmap;
#line 40 "../src/Widgets/EventsList.vala"
	_tmp1_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp0_);
#line 40 "../src/Widgets/EventsList.vala"
	_tmp2_ = _tmp1_;
#line 40 "../src/Widgets/EventsList.vala"
	result = _tmp2_ > 0;
#line 40 "../src/Widgets/EventsList.vala"
	return result;
#line 1000 "EventsList.c"
}

static gint
_widgets_events_list_sort_event_function_gtk_list_box_sort_func (GtkListBoxRow* row1,
                                                                 GtkListBoxRow* row2,
                                                                 gpointer self)
{
	gint result;
	result = widgets_events_list_sort_event_function ((WidgetsEventsList*) self, row1, row2);
#line 83 "../src/Widgets/EventsList.vala"
	return result;
#line 1012 "EventsList.c"
}

static void
_widgets_events_list___lambda651_ (WidgetsEventsList* self)
{
	GtkRevealer* _tmp0_;
	ServicesSettings* _tmp1_;
	ServicesSettings* _tmp2_;
	GSettings* _tmp3_;
#line 109 "../src/Widgets/EventsList.vala"
	_tmp0_ = self->priv->main_revealer;
#line 109 "../src/Widgets/EventsList.vala"
	_tmp1_ = services_settings_get_default ();
#line 109 "../src/Widgets/EventsList.vala"
	_tmp2_ = _tmp1_;
#line 109 "../src/Widgets/EventsList.vala"
	_tmp3_ = _tmp2_->settings;
#line 109 "../src/Widgets/EventsList.vala"
	gtk_revealer_set_reveal_child (_tmp0_, g_settings_get_boolean (_tmp3_, "calendar-enabled"));
#line 109 "../src/Widgets/EventsList.vala"
	_g_object_unref0 (_tmp2_);
#line 1034 "EventsList.c"
}

static void
__widgets_events_list___lambda651__g_settings_changed (GSettings* _sender,
                                                       const gchar* key,
                                                       gpointer self)
{
#line 108 "../src/Widgets/EventsList.vala"
	_widgets_events_list___lambda651_ ((WidgetsEventsList*) self);
#line 1044 "EventsList.c"
}

static GObject *
widgets_events_list_constructor (GType type,
                                 guint n_construct_properties,
                                 GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	WidgetsEventsList * self;
	GDateTime* _tmp0_;
	ServicesCalendarEvents* _tmp1_;
	GeeHashMap* _tmp2_;
	GtkListBox* _tmp3_ = NULL;
	GtkListBox* _tmp4_;
	GtkListBox* _tmp5_;
	GtkGrid* listbox_grid = NULL;
	GtkGrid* _tmp6_ = NULL;
	GtkGrid* _tmp7_;
	GtkListBox* _tmp8_;
	GtkGrid* main_grid = NULL;
	GtkGrid* _tmp9_ = NULL;
	GtkGrid* _tmp10_;
	GtkGrid* _tmp11_;
	GtkGrid* _tmp12_;
	ServicesSettings* _tmp13_;
	ServicesSettings* _tmp14_;
	GSettings* _tmp15_;
	GtkGrid* _tmp16_;
	GtkWidget* _tmp17_;
	GtkRevealer* _tmp18_ = NULL;
	GtkRevealer* _tmp19_;
	ServicesSettings* _tmp20_;
	ServicesSettings* _tmp21_;
	GSettings* _tmp22_;
#line 74 "../src/Widgets/EventsList.vala"
	parent_class = G_OBJECT_CLASS (widgets_events_list_parent_class);
#line 74 "../src/Widgets/EventsList.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 74 "../src/Widgets/EventsList.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, WIDGETS_TYPE_EVENTS_LIST, WidgetsEventsList);
#line 75 "../src/Widgets/EventsList.vala"
	_tmp0_ = self->priv->_start_date;
#line 75 "../src/Widgets/EventsList.vala"
	_tmp1_ = services_calendar_events_new (_tmp0_);
#line 75 "../src/Widgets/EventsList.vala"
	_g_object_unref0 (self->priv->event_model);
#line 75 "../src/Widgets/EventsList.vala"
	self->priv->event_model = _tmp1_;
#line 76 "../src/Widgets/EventsList.vala"
	_tmp2_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, WIDGETS_TYPE_EVENT_ROW, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 76 "../src/Widgets/EventsList.vala"
	_g_object_unref0 (self->priv->event_hashmap);
#line 76 "../src/Widgets/EventsList.vala"
	self->priv->event_hashmap = _tmp2_;
#line 78 "../src/Widgets/EventsList.vala"
	_tmp3_ = (GtkListBox*) gtk_list_box_new ();
#line 78 "../src/Widgets/EventsList.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp3_, GTK_ALIGN_START);
#line 78 "../src/Widgets/EventsList.vala"
	gtk_list_box_set_selection_mode (_tmp3_, GTK_SELECTION_NONE);
#line 78 "../src/Widgets/EventsList.vala"
	g_object_ref_sink (_tmp3_);
#line 78 "../src/Widgets/EventsList.vala"
	_g_object_unref0 (self->priv->listbox);
#line 78 "../src/Widgets/EventsList.vala"
	self->priv->listbox = _tmp3_;
#line 83 "../src/Widgets/EventsList.vala"
	_tmp4_ = self->priv->listbox;
#line 83 "../src/Widgets/EventsList.vala"
	gtk_list_box_set_sort_func (_tmp4_, _widgets_events_list_sort_event_function_gtk_list_box_sort_func, g_object_ref (self), g_object_unref);
#line 84 "../src/Widgets/EventsList.vala"
	_tmp5_ = self->priv->listbox;
#line 84 "../src/Widgets/EventsList.vala"
	gtk_widget_add_css_class ((GtkWidget*) _tmp5_, "listbox-background");
#line 86 "../src/Widgets/EventsList.vala"
	_tmp6_ = (GtkGrid*) gtk_grid_new ();
#line 86 "../src/Widgets/EventsList.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp6_, GTK_ALIGN_START);
#line 86 "../src/Widgets/EventsList.vala"
	g_object_ref_sink (_tmp6_);
#line 86 "../src/Widgets/EventsList.vala"
	listbox_grid = _tmp6_;
#line 90 "../src/Widgets/EventsList.vala"
	_tmp7_ = listbox_grid;
#line 90 "../src/Widgets/EventsList.vala"
	_tmp8_ = self->priv->listbox;
#line 90 "../src/Widgets/EventsList.vala"
	gtk_grid_attach (_tmp7_, (GtkWidget*) _tmp8_, 0, 0, 1, 1);
#line 92 "../src/Widgets/EventsList.vala"
	_tmp9_ = (GtkGrid*) gtk_grid_new ();
#line 92 "../src/Widgets/EventsList.vala"
	gtk_widget_set_hexpand ((GtkWidget*) _tmp9_, TRUE);
#line 92 "../src/Widgets/EventsList.vala"
	g_object_ref_sink (_tmp9_);
#line 92 "../src/Widgets/EventsList.vala"
	main_grid = _tmp9_;
#line 96 "../src/Widgets/EventsList.vala"
	_tmp10_ = main_grid;
#line 96 "../src/Widgets/EventsList.vala"
	gtk_widget_add_css_class ((GtkWidget*) _tmp10_, "description-box");
#line 97 "../src/Widgets/EventsList.vala"
	_tmp11_ = main_grid;
#line 97 "../src/Widgets/EventsList.vala"
	_tmp12_ = listbox_grid;
#line 97 "../src/Widgets/EventsList.vala"
	gtk_grid_attach (_tmp11_, (GtkWidget*) _tmp12_, 0, 0, 1, 1);
#line 99 "../src/Widgets/EventsList.vala"
	_tmp13_ = services_settings_get_default ();
#line 99 "../src/Widgets/EventsList.vala"
	_tmp14_ = _tmp13_;
#line 99 "../src/Widgets/EventsList.vala"
	_tmp15_ = _tmp14_->settings;
#line 99 "../src/Widgets/EventsList.vala"
	_tmp16_ = main_grid;
#line 99 "../src/Widgets/EventsList.vala"
	_tmp17_ = _g_object_ref0 ((GtkWidget*) _tmp16_);
#line 99 "../src/Widgets/EventsList.vala"
	_tmp18_ = (GtkRevealer*) gtk_revealer_new ();
#line 99 "../src/Widgets/EventsList.vala"
	gtk_revealer_set_transition_type (_tmp18_, GTK_REVEALER_TRANSITION_TYPE_SLIDE_DOWN);
#line 99 "../src/Widgets/EventsList.vala"
	gtk_revealer_set_reveal_child (_tmp18_, g_settings_get_boolean (_tmp15_, "calendar-enabled"));
#line 99 "../src/Widgets/EventsList.vala"
	gtk_revealer_set_child (_tmp18_, _tmp17_);
#line 99 "../src/Widgets/EventsList.vala"
	_g_object_unref0 (_tmp17_);
#line 99 "../src/Widgets/EventsList.vala"
	g_object_ref_sink (_tmp18_);
#line 99 "../src/Widgets/EventsList.vala"
	_g_object_unref0 (self->priv->main_revealer);
#line 99 "../src/Widgets/EventsList.vala"
	self->priv->main_revealer = _tmp18_;
#line 99 "../src/Widgets/EventsList.vala"
	_g_object_unref0 (_tmp14_);
#line 105 "../src/Widgets/EventsList.vala"
	_tmp19_ = self->priv->main_revealer;
#line 105 "../src/Widgets/EventsList.vala"
	adw_bin_set_child ((AdwBin*) self, (GtkWidget*) _tmp19_);
#line 106 "../src/Widgets/EventsList.vala"
	widgets_events_list_add_events (self);
#line 108 "../src/Widgets/EventsList.vala"
	_tmp20_ = services_settings_get_default ();
#line 108 "../src/Widgets/EventsList.vala"
	_tmp21_ = _tmp20_;
#line 108 "../src/Widgets/EventsList.vala"
	_tmp22_ = _tmp21_->settings;
#line 108 "../src/Widgets/EventsList.vala"
	g_signal_connect_object (_tmp22_, "changed::calendar-enabled", (GCallback) __widgets_events_list___lambda651__g_settings_changed, self, 0);
#line 108 "../src/Widgets/EventsList.vala"
	_g_object_unref0 (_tmp21_);
#line 74 "../src/Widgets/EventsList.vala"
	_g_object_unref0 (main_grid);
#line 74 "../src/Widgets/EventsList.vala"
	_g_object_unref0 (listbox_grid);
#line 74 "../src/Widgets/EventsList.vala"
	return obj;
#line 1202 "EventsList.c"
}

static void
widgets_events_list_class_init (WidgetsEventsListClass * klass,
                                gpointer klass_data)
{
#line 22 "../src/Widgets/EventsList.vala"
	widgets_events_list_parent_class = g_type_class_peek_parent (klass);
#line 22 "../src/Widgets/EventsList.vala"
	g_type_class_adjust_private_offset (klass, &WidgetsEventsList_private_offset);
#line 22 "../src/Widgets/EventsList.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_widgets_events_list_get_property;
#line 22 "../src/Widgets/EventsList.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_widgets_events_list_set_property;
#line 22 "../src/Widgets/EventsList.vala"
	G_OBJECT_CLASS (klass)->constructor = widgets_events_list_constructor;
#line 22 "../src/Widgets/EventsList.vala"
	G_OBJECT_CLASS (klass)->finalize = widgets_events_list_finalize;
#line 22 "../src/Widgets/EventsList.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), WIDGETS_EVENTS_LIST_START_DATE_PROPERTY, widgets_events_list_properties[WIDGETS_EVENTS_LIST_START_DATE_PROPERTY] = g_param_spec_boxed ("start-date", "start-date", "start-date", G_TYPE_DATE_TIME, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 22 "../src/Widgets/EventsList.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), WIDGETS_EVENTS_LIST_END_DATE_PROPERTY, widgets_events_list_properties[WIDGETS_EVENTS_LIST_END_DATE_PROPERTY] = g_param_spec_boxed ("end-date", "end-date", "end-date", G_TYPE_DATE_TIME, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 22 "../src/Widgets/EventsList.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), WIDGETS_EVENTS_LIST_IS_DAY_PROPERTY, widgets_events_list_properties[WIDGETS_EVENTS_LIST_IS_DAY_PROPERTY] = g_param_spec_boolean ("is-day", "is-day", "is-day", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 22 "../src/Widgets/EventsList.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), WIDGETS_EVENTS_LIST_IS_MONTH_PROPERTY, widgets_events_list_properties[WIDGETS_EVENTS_LIST_IS_MONTH_PROPERTY] = g_param_spec_boolean ("is-month", "is-month", "is-month", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 22 "../src/Widgets/EventsList.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), WIDGETS_EVENTS_LIST_IS_RANGE_PROPERTY, widgets_events_list_properties[WIDGETS_EVENTS_LIST_IS_RANGE_PROPERTY] = g_param_spec_boolean ("is-range", "is-range", "is-range", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 22 "../src/Widgets/EventsList.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), WIDGETS_EVENTS_LIST_HAS_ITEMS_PROPERTY, widgets_events_list_properties[WIDGETS_EVENTS_LIST_HAS_ITEMS_PROPERTY] = g_param_spec_boolean ("has-items", "has-items", "has-items", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 22 "../src/Widgets/EventsList.vala"
	widgets_events_list_signals[WIDGETS_EVENTS_LIST_CHANGE_SIGNAL] = g_signal_new ("change", WIDGETS_TYPE_EVENTS_LIST, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 1235 "EventsList.c"
}

static void
widgets_events_list_instance_init (WidgetsEventsList * self,
                                   gpointer klass)
{
#line 22 "../src/Widgets/EventsList.vala"
	self->priv = widgets_events_list_get_instance_private (self);
#line 1244 "EventsList.c"
}

static void
widgets_events_list_finalize (GObject * obj)
{
	WidgetsEventsList * self;
#line 22 "../src/Widgets/EventsList.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, WIDGETS_TYPE_EVENTS_LIST, WidgetsEventsList);
#line 23 "../src/Widgets/EventsList.vala"
	_g_date_time_unref0 (self->priv->_start_date);
#line 24 "../src/Widgets/EventsList.vala"
	_g_date_time_unref0 (self->priv->_end_date);
#line 30 "../src/Widgets/EventsList.vala"
	_g_object_unref0 (self->priv->listbox);
#line 31 "../src/Widgets/EventsList.vala"
	_g_object_unref0 (self->priv->main_revealer);
#line 33 "../src/Widgets/EventsList.vala"
	_g_object_unref0 (self->priv->event_hashmap);
#line 34 "../src/Widgets/EventsList.vala"
	_g_object_unref0 (self->priv->event_model);
#line 22 "../src/Widgets/EventsList.vala"
	G_OBJECT_CLASS (widgets_events_list_parent_class)->finalize (obj);
#line 1267 "EventsList.c"
}

static GType
widgets_events_list_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (WidgetsEventsListClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) widgets_events_list_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (WidgetsEventsList), 0, (GInstanceInitFunc) widgets_events_list_instance_init, NULL };
	GType widgets_events_list_type_id;
	widgets_events_list_type_id = g_type_register_static (adw_bin_get_type (), "WidgetsEventsList", &g_define_type_info, 0);
	WidgetsEventsList_private_offset = g_type_add_instance_private (widgets_events_list_type_id, sizeof (WidgetsEventsListPrivate));
	return widgets_events_list_type_id;
}

GType
widgets_events_list_get_type (void)
{
	static volatile gsize widgets_events_list_type_id__once = 0;
	if (g_once_init_enter (&widgets_events_list_type_id__once)) {
		GType widgets_events_list_type_id;
		widgets_events_list_type_id = widgets_events_list_get_type_once ();
		g_once_init_leave (&widgets_events_list_type_id__once, widgets_events_list_type_id);
	}
	return widgets_events_list_type_id__once;
}

static void
_vala_widgets_events_list_get_property (GObject * object,
                                        guint property_id,
                                        GValue * value,
                                        GParamSpec * pspec)
{
	WidgetsEventsList * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, WIDGETS_TYPE_EVENTS_LIST, WidgetsEventsList);
#line 22 "../src/Widgets/EventsList.vala"
	switch (property_id) {
#line 22 "../src/Widgets/EventsList.vala"
		case WIDGETS_EVENTS_LIST_START_DATE_PROPERTY:
#line 22 "../src/Widgets/EventsList.vala"
		g_value_set_boxed (value, widgets_events_list_get_start_date (self));
#line 22 "../src/Widgets/EventsList.vala"
		break;
#line 22 "../src/Widgets/EventsList.vala"
		case WIDGETS_EVENTS_LIST_END_DATE_PROPERTY:
#line 22 "../src/Widgets/EventsList.vala"
		g_value_set_boxed (value, widgets_events_list_get_end_date (self));
#line 22 "../src/Widgets/EventsList.vala"
		break;
#line 22 "../src/Widgets/EventsList.vala"
		case WIDGETS_EVENTS_LIST_IS_DAY_PROPERTY:
#line 22 "../src/Widgets/EventsList.vala"
		g_value_set_boolean (value, widgets_events_list_get_is_day (self));
#line 22 "../src/Widgets/EventsList.vala"
		break;
#line 22 "../src/Widgets/EventsList.vala"
		case WIDGETS_EVENTS_LIST_IS_MONTH_PROPERTY:
#line 22 "../src/Widgets/EventsList.vala"
		g_value_set_boolean (value, widgets_events_list_get_is_month (self));
#line 22 "../src/Widgets/EventsList.vala"
		break;
#line 22 "../src/Widgets/EventsList.vala"
		case WIDGETS_EVENTS_LIST_IS_RANGE_PROPERTY:
#line 22 "../src/Widgets/EventsList.vala"
		g_value_set_boolean (value, widgets_events_list_get_is_range (self));
#line 22 "../src/Widgets/EventsList.vala"
		break;
#line 22 "../src/Widgets/EventsList.vala"
		case WIDGETS_EVENTS_LIST_HAS_ITEMS_PROPERTY:
#line 22 "../src/Widgets/EventsList.vala"
		g_value_set_boolean (value, widgets_events_list_get_has_items (self));
#line 22 "../src/Widgets/EventsList.vala"
		break;
#line 1338 "EventsList.c"
		default:
#line 22 "../src/Widgets/EventsList.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 22 "../src/Widgets/EventsList.vala"
		break;
#line 1344 "EventsList.c"
	}
}

static void
_vala_widgets_events_list_set_property (GObject * object,
                                        guint property_id,
                                        const GValue * value,
                                        GParamSpec * pspec)
{
	WidgetsEventsList * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, WIDGETS_TYPE_EVENTS_LIST, WidgetsEventsList);
#line 22 "../src/Widgets/EventsList.vala"
	switch (property_id) {
#line 22 "../src/Widgets/EventsList.vala"
		case WIDGETS_EVENTS_LIST_START_DATE_PROPERTY:
#line 22 "../src/Widgets/EventsList.vala"
		widgets_events_list_set_start_date (self, g_value_get_boxed (value));
#line 22 "../src/Widgets/EventsList.vala"
		break;
#line 22 "../src/Widgets/EventsList.vala"
		case WIDGETS_EVENTS_LIST_END_DATE_PROPERTY:
#line 22 "../src/Widgets/EventsList.vala"
		widgets_events_list_set_end_date (self, g_value_get_boxed (value));
#line 22 "../src/Widgets/EventsList.vala"
		break;
#line 22 "../src/Widgets/EventsList.vala"
		case WIDGETS_EVENTS_LIST_IS_DAY_PROPERTY:
#line 22 "../src/Widgets/EventsList.vala"
		widgets_events_list_set_is_day (self, g_value_get_boolean (value));
#line 22 "../src/Widgets/EventsList.vala"
		break;
#line 22 "../src/Widgets/EventsList.vala"
		case WIDGETS_EVENTS_LIST_IS_MONTH_PROPERTY:
#line 22 "../src/Widgets/EventsList.vala"
		widgets_events_list_set_is_month (self, g_value_get_boolean (value));
#line 22 "../src/Widgets/EventsList.vala"
		break;
#line 22 "../src/Widgets/EventsList.vala"
		case WIDGETS_EVENTS_LIST_IS_RANGE_PROPERTY:
#line 22 "../src/Widgets/EventsList.vala"
		widgets_events_list_set_is_range (self, g_value_get_boolean (value));
#line 22 "../src/Widgets/EventsList.vala"
		break;
#line 1388 "EventsList.c"
		default:
#line 22 "../src/Widgets/EventsList.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 22 "../src/Widgets/EventsList.vala"
		break;
#line 1394 "EventsList.c"
	}
}

