/* ScrolledWindow.c generated by valac 0.56.18, the Vala compiler
 * generated from ScrolledWindow.vala, do not modify */

/*
* Copyright © 2023 Alain M. (https://github.com/alainm23/planify)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 3 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*
* Authored by: Alain M. <alainmh23@gmail.com>
*/

#include <adwaita.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <glib.h>
#include "planify.h"
#include <float.h>
#include <math.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define WIDGETS_TYPE_SCROLLED_WINDOW (widgets_scrolled_window_get_type ())
#define WIDGETS_SCROLLED_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), WIDGETS_TYPE_SCROLLED_WINDOW, WidgetsScrolledWindow))
#define WIDGETS_SCROLLED_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), WIDGETS_TYPE_SCROLLED_WINDOW, WidgetsScrolledWindowClass))
#define WIDGETS_IS_SCROLLED_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), WIDGETS_TYPE_SCROLLED_WINDOW))
#define WIDGETS_IS_SCROLLED_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), WIDGETS_TYPE_SCROLLED_WINDOW))
#define WIDGETS_SCROLLED_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), WIDGETS_TYPE_SCROLLED_WINDOW, WidgetsScrolledWindowClass))

typedef struct _WidgetsScrolledWindow WidgetsScrolledWindow;
typedef struct _WidgetsScrolledWindowClass WidgetsScrolledWindowClass;
typedef struct _WidgetsScrolledWindowPrivate WidgetsScrolledWindowPrivate;
enum  {
	WIDGETS_SCROLLED_WINDOW_0_PROPERTY,
	WIDGETS_SCROLLED_WINDOW_WIDGET_PROPERTY,
	WIDGETS_SCROLLED_WINDOW_ORIENTATION_PROPERTY,
	WIDGETS_SCROLLED_WINDOW_MARGIN_PROPERTY,
	WIDGETS_SCROLLED_WINDOW_VADJUSTMENT_PROPERTY,
	WIDGETS_SCROLLED_WINDOW_HADJUSTMENT_PROPERTY,
	WIDGETS_SCROLLED_WINDOW_NUM_PROPERTIES
};
static GParamSpec* widgets_scrolled_window_properties[WIDGETS_SCROLLED_WINDOW_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _WidgetsScrolledWindow {
	AdwBin parent_instance;
	WidgetsScrolledWindowPrivate * priv;
};

struct _WidgetsScrolledWindowClass {
	AdwBinClass parent_class;
};

struct _WidgetsScrolledWindowPrivate {
	GtkWidget* _widget;
	GtkOrientation _orientation;
	gint _margin;
	GtkScrolledWindow* scrolled_window;
	GtkDropControllerMotion* drop_motion_ctrl;
	gboolean scrolling;
};

static gint WidgetsScrolledWindow_private_offset;
static gpointer widgets_scrolled_window_parent_class = NULL;

VALA_EXTERN GType widgets_scrolled_window_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (WidgetsScrolledWindow, g_object_unref)
VALA_EXTERN WidgetsScrolledWindow* widgets_scrolled_window_new (GtkWidget* widget,
                                                    GtkOrientation orientation);
VALA_EXTERN WidgetsScrolledWindow* widgets_scrolled_window_construct (GType object_type,
                                                          GtkWidget* widget,
                                                          GtkOrientation orientation);
static gboolean _widgets_scrolled_window_auto_scroll (WidgetsScrolledWindow* self,
                                               gboolean scroll_up);
VALA_EXTERN GtkOrientation widgets_scrolled_window_get_orientation (WidgetsScrolledWindow* self);
VALA_EXTERN GtkWidget* widgets_scrolled_window_get_widget (WidgetsScrolledWindow* self);
static void widgets_scrolled_window_set_widget (WidgetsScrolledWindow* self,
                                         GtkWidget* value);
static void widgets_scrolled_window_set_orientation (WidgetsScrolledWindow* self,
                                              GtkOrientation value);
VALA_EXTERN gint widgets_scrolled_window_get_margin (WidgetsScrolledWindow* self);
VALA_EXTERN void widgets_scrolled_window_set_margin (WidgetsScrolledWindow* self,
                                         gint value);
VALA_EXTERN GtkAdjustment* widgets_scrolled_window_get_vadjustment (WidgetsScrolledWindow* self);
VALA_EXTERN GtkAdjustment* widgets_scrolled_window_get_hadjustment (WidgetsScrolledWindow* self);
static GObject * widgets_scrolled_window_constructor (GType type,
                                               guint n_construct_properties,
                                               GObjectConstructParam * construct_properties);
static void _widgets_scrolled_window___lambda279_ (WidgetsScrolledWindow* self,
                                            gdouble x,
                                            gdouble y);
static gboolean ____lambda280_ (WidgetsScrolledWindow* self);
static gboolean _____lambda280__gsource_func (gpointer self);
static gboolean _____lambda281_ (WidgetsScrolledWindow* self);
static gboolean ______lambda281__gsource_func (gpointer self);
static gboolean ____lambda282_ (WidgetsScrolledWindow* self);
static gboolean _____lambda282__gsource_func (gpointer self);
static gboolean _____lambda283_ (WidgetsScrolledWindow* self);
static gboolean ______lambda283__gsource_func (gpointer self);
static void __widgets_scrolled_window___lambda279__gtk_drop_controller_motion_motion (GtkDropControllerMotion* _sender,
                                                                               gdouble x,
                                                                               gdouble y,
                                                                               gpointer self);
static void widgets_scrolled_window_finalize (GObject * obj);
static GType widgets_scrolled_window_get_type_once (void);
static void _vala_widgets_scrolled_window_get_property (GObject * object,
                                                 guint property_id,
                                                 GValue * value,
                                                 GParamSpec * pspec);
static void _vala_widgets_scrolled_window_set_property (GObject * object,
                                                 guint property_id,
                                                 const GValue * value,
                                                 GParamSpec * pspec);

static inline gpointer
widgets_scrolled_window_get_instance_private (WidgetsScrolledWindow* self)
{
	return G_STRUCT_MEMBER_P (self, WidgetsScrolledWindow_private_offset);
}

WidgetsScrolledWindow*
widgets_scrolled_window_construct (GType object_type,
                                   GtkWidget* widget,
                                   GtkOrientation orientation)
{
	WidgetsScrolledWindow * self = NULL;
#line 44 "../src/Widgets/ScrolledWindow.vala"
	g_return_val_if_fail (widget != NULL, NULL);
#line 45 "../src/Widgets/ScrolledWindow.vala"
	self = (WidgetsScrolledWindow*) g_object_new (object_type, "widget", widget, "orientation", orientation, NULL);
#line 44 "../src/Widgets/ScrolledWindow.vala"
	return self;
#line 162 "ScrolledWindow.c"
}

WidgetsScrolledWindow*
widgets_scrolled_window_new (GtkWidget* widget,
                             GtkOrientation orientation)
{
#line 44 "../src/Widgets/ScrolledWindow.vala"
	return widgets_scrolled_window_construct (WIDGETS_TYPE_SCROLLED_WINDOW, widget, orientation);
#line 171 "ScrolledWindow.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 101 "../src/Widgets/ScrolledWindow.vala"
	return self ? g_object_ref (self) : NULL;
#line 179 "ScrolledWindow.c"
}

static gboolean
_widgets_scrolled_window_auto_scroll (WidgetsScrolledWindow* self,
                                      gboolean scroll_up)
{
	gboolean _tmp0_ = FALSE;
	GtkAdjustment* _tmp4_ = NULL;
	GtkOrientation _tmp5_;
	GtkAdjustment* adj = NULL;
	GtkAdjustment* _tmp10_;
	gboolean result;
#line 96 "../src/Widgets/ScrolledWindow.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 97 "../src/Widgets/ScrolledWindow.vala"
	if (!self->priv->scrolling) {
#line 97 "../src/Widgets/ScrolledWindow.vala"
		_tmp0_ = TRUE;
#line 198 "ScrolledWindow.c"
	} else {
		GtkDropControllerMotion* _tmp1_;
		gboolean _tmp2_;
		gboolean _tmp3_;
#line 97 "../src/Widgets/ScrolledWindow.vala"
		_tmp1_ = self->priv->drop_motion_ctrl;
#line 97 "../src/Widgets/ScrolledWindow.vala"
		g_object_get (_tmp1_, "contains-pointer", &_tmp2_, NULL);
#line 97 "../src/Widgets/ScrolledWindow.vala"
		_tmp3_ = _tmp2_;
#line 97 "../src/Widgets/ScrolledWindow.vala"
		_tmp0_ = !_tmp3_;
#line 211 "ScrolledWindow.c"
	}
#line 97 "../src/Widgets/ScrolledWindow.vala"
	if (_tmp0_) {
#line 98 "../src/Widgets/ScrolledWindow.vala"
		result = FALSE;
#line 98 "../src/Widgets/ScrolledWindow.vala"
		return result;
#line 219 "ScrolledWindow.c"
	}
#line 101 "../src/Widgets/ScrolledWindow.vala"
	_tmp5_ = self->priv->_orientation;
#line 101 "../src/Widgets/ScrolledWindow.vala"
	if (_tmp5_ == GTK_ORIENTATION_VERTICAL) {
#line 225 "ScrolledWindow.c"
		GtkScrolledWindow* _tmp6_;
		GtkAdjustment* _tmp7_;
#line 101 "../src/Widgets/ScrolledWindow.vala"
		_tmp6_ = self->priv->scrolled_window;
#line 101 "../src/Widgets/ScrolledWindow.vala"
		_tmp7_ = gtk_scrolled_window_get_vadjustment (_tmp6_);
#line 101 "../src/Widgets/ScrolledWindow.vala"
		_tmp4_ = _tmp7_;
#line 234 "ScrolledWindow.c"
	} else {
		GtkScrolledWindow* _tmp8_;
		GtkAdjustment* _tmp9_;
#line 101 "../src/Widgets/ScrolledWindow.vala"
		_tmp8_ = self->priv->scrolled_window;
#line 101 "../src/Widgets/ScrolledWindow.vala"
		_tmp9_ = gtk_scrolled_window_get_hadjustment (_tmp8_);
#line 101 "../src/Widgets/ScrolledWindow.vala"
		_tmp4_ = _tmp9_;
#line 244 "ScrolledWindow.c"
	}
#line 101 "../src/Widgets/ScrolledWindow.vala"
	_tmp10_ = _g_object_ref0 (_tmp4_);
#line 101 "../src/Widgets/ScrolledWindow.vala"
	adj = _tmp10_;
#line 102 "../src/Widgets/ScrolledWindow.vala"
	if (scroll_up) {
#line 252 "ScrolledWindow.c"
		GtkAdjustment* _tmp11_;
		GtkAdjustment* _tmp12_;
#line 103 "../src/Widgets/ScrolledWindow.vala"
		_tmp11_ = adj;
#line 103 "../src/Widgets/ScrolledWindow.vala"
		_tmp12_ = adj;
#line 103 "../src/Widgets/ScrolledWindow.vala"
		gtk_adjustment_set_value (_tmp11_, gtk_adjustment_get_value (_tmp12_) - CONSTANTS_SCROLL_STEPS);
#line 261 "ScrolledWindow.c"
	} else {
		GtkAdjustment* _tmp13_;
		GtkAdjustment* _tmp14_;
#line 105 "../src/Widgets/ScrolledWindow.vala"
		_tmp13_ = adj;
#line 105 "../src/Widgets/ScrolledWindow.vala"
		_tmp14_ = adj;
#line 105 "../src/Widgets/ScrolledWindow.vala"
		gtk_adjustment_set_value (_tmp13_, gtk_adjustment_get_value (_tmp14_) + CONSTANTS_SCROLL_STEPS);
#line 271 "ScrolledWindow.c"
	}
#line 108 "../src/Widgets/ScrolledWindow.vala"
	result = TRUE;
#line 108 "../src/Widgets/ScrolledWindow.vala"
	_g_object_unref0 (adj);
#line 108 "../src/Widgets/ScrolledWindow.vala"
	return result;
#line 279 "ScrolledWindow.c"
}

GtkWidget*
widgets_scrolled_window_get_widget (WidgetsScrolledWindow* self)
{
	GtkWidget* result;
	GtkWidget* _tmp0_;
#line 23 "../src/Widgets/ScrolledWindow.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 23 "../src/Widgets/ScrolledWindow.vala"
	_tmp0_ = self->priv->_widget;
#line 23 "../src/Widgets/ScrolledWindow.vala"
	result = _tmp0_;
#line 23 "../src/Widgets/ScrolledWindow.vala"
	return result;
#line 295 "ScrolledWindow.c"
}

static void
widgets_scrolled_window_set_widget (WidgetsScrolledWindow* self,
                                    GtkWidget* value)
{
	GtkWidget* old_value;
#line 23 "../src/Widgets/ScrolledWindow.vala"
	g_return_if_fail (self != NULL);
#line 23 "../src/Widgets/ScrolledWindow.vala"
	old_value = widgets_scrolled_window_get_widget (self);
#line 23 "../src/Widgets/ScrolledWindow.vala"
	if (old_value != value) {
#line 309 "ScrolledWindow.c"
		GtkWidget* _tmp0_;
#line 23 "../src/Widgets/ScrolledWindow.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 23 "../src/Widgets/ScrolledWindow.vala"
		_g_object_unref0 (self->priv->_widget);
#line 23 "../src/Widgets/ScrolledWindow.vala"
		self->priv->_widget = _tmp0_;
#line 23 "../src/Widgets/ScrolledWindow.vala"
		g_object_notify_by_pspec ((GObject *) self, widgets_scrolled_window_properties[WIDGETS_SCROLLED_WINDOW_WIDGET_PROPERTY]);
#line 319 "ScrolledWindow.c"
	}
}

GtkOrientation
widgets_scrolled_window_get_orientation (WidgetsScrolledWindow* self)
{
	GtkOrientation result;
#line 24 "../src/Widgets/ScrolledWindow.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 24 "../src/Widgets/ScrolledWindow.vala"
	result = self->priv->_orientation;
#line 24 "../src/Widgets/ScrolledWindow.vala"
	return result;
#line 333 "ScrolledWindow.c"
}

static void
widgets_scrolled_window_set_orientation (WidgetsScrolledWindow* self,
                                         GtkOrientation value)
{
	GtkOrientation old_value;
#line 24 "../src/Widgets/ScrolledWindow.vala"
	g_return_if_fail (self != NULL);
#line 24 "../src/Widgets/ScrolledWindow.vala"
	old_value = widgets_scrolled_window_get_orientation (self);
#line 24 "../src/Widgets/ScrolledWindow.vala"
	if (old_value != value) {
#line 24 "../src/Widgets/ScrolledWindow.vala"
		self->priv->_orientation = value;
#line 24 "../src/Widgets/ScrolledWindow.vala"
		g_object_notify_by_pspec ((GObject *) self, widgets_scrolled_window_properties[WIDGETS_SCROLLED_WINDOW_ORIENTATION_PROPERTY]);
#line 351 "ScrolledWindow.c"
	}
}

gint
widgets_scrolled_window_get_margin (WidgetsScrolledWindow* self)
{
	gint result;
#line 25 "../src/Widgets/ScrolledWindow.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 25 "../src/Widgets/ScrolledWindow.vala"
	result = self->priv->_margin;
#line 25 "../src/Widgets/ScrolledWindow.vala"
	return result;
#line 365 "ScrolledWindow.c"
}

void
widgets_scrolled_window_set_margin (WidgetsScrolledWindow* self,
                                    gint value)
{
	gint old_value;
#line 25 "../src/Widgets/ScrolledWindow.vala"
	g_return_if_fail (self != NULL);
#line 25 "../src/Widgets/ScrolledWindow.vala"
	old_value = widgets_scrolled_window_get_margin (self);
#line 25 "../src/Widgets/ScrolledWindow.vala"
	if (old_value != value) {
#line 25 "../src/Widgets/ScrolledWindow.vala"
		self->priv->_margin = value;
#line 25 "../src/Widgets/ScrolledWindow.vala"
		g_object_notify_by_pspec ((GObject *) self, widgets_scrolled_window_properties[WIDGETS_SCROLLED_WINDOW_MARGIN_PROPERTY]);
#line 383 "ScrolledWindow.c"
	}
}

GtkAdjustment*
widgets_scrolled_window_get_vadjustment (WidgetsScrolledWindow* self)
{
	GtkAdjustment* result;
	GtkScrolledWindow* _tmp0_;
	GtkAdjustment* _tmp1_;
	GtkAdjustment* _tmp2_;
#line 33 "../src/Widgets/ScrolledWindow.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 34 "../src/Widgets/ScrolledWindow.vala"
	_tmp0_ = self->priv->scrolled_window;
#line 34 "../src/Widgets/ScrolledWindow.vala"
	_tmp1_ = gtk_scrolled_window_get_vadjustment (_tmp0_);
#line 34 "../src/Widgets/ScrolledWindow.vala"
	_tmp2_ = _tmp1_;
#line 34 "../src/Widgets/ScrolledWindow.vala"
	result = _tmp2_;
#line 34 "../src/Widgets/ScrolledWindow.vala"
	return result;
#line 406 "ScrolledWindow.c"
}

GtkAdjustment*
widgets_scrolled_window_get_hadjustment (WidgetsScrolledWindow* self)
{
	GtkAdjustment* result;
	GtkScrolledWindow* _tmp0_;
	GtkAdjustment* _tmp1_;
	GtkAdjustment* _tmp2_;
#line 39 "../src/Widgets/ScrolledWindow.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 40 "../src/Widgets/ScrolledWindow.vala"
	_tmp0_ = self->priv->scrolled_window;
#line 40 "../src/Widgets/ScrolledWindow.vala"
	_tmp1_ = gtk_scrolled_window_get_hadjustment (_tmp0_);
#line 40 "../src/Widgets/ScrolledWindow.vala"
	_tmp2_ = _tmp1_;
#line 40 "../src/Widgets/ScrolledWindow.vala"
	result = _tmp2_;
#line 40 "../src/Widgets/ScrolledWindow.vala"
	return result;
#line 428 "ScrolledWindow.c"
}

static gboolean
____lambda280_ (WidgetsScrolledWindow* self)
{
	gboolean result;
#line 71 "../src/Widgets/ScrolledWindow.vala"
	result = _widgets_scrolled_window_auto_scroll (self, TRUE);
#line 71 "../src/Widgets/ScrolledWindow.vala"
	return result;
#line 439 "ScrolledWindow.c"
}

static gboolean
_____lambda280__gsource_func (gpointer self)
{
	gboolean result;
	result = ____lambda280_ ((WidgetsScrolledWindow*) self);
#line 71 "../src/Widgets/ScrolledWindow.vala"
	return result;
#line 449 "ScrolledWindow.c"
}

static gboolean
_____lambda281_ (WidgetsScrolledWindow* self)
{
	gboolean result;
#line 74 "../src/Widgets/ScrolledWindow.vala"
	result = _widgets_scrolled_window_auto_scroll (self, FALSE);
#line 74 "../src/Widgets/ScrolledWindow.vala"
	return result;
#line 460 "ScrolledWindow.c"
}

static gboolean
______lambda281__gsource_func (gpointer self)
{
	gboolean result;
	result = _____lambda281_ ((WidgetsScrolledWindow*) self);
#line 74 "../src/Widgets/ScrolledWindow.vala"
	return result;
#line 470 "ScrolledWindow.c"
}

static gboolean
____lambda282_ (WidgetsScrolledWindow* self)
{
	gboolean result;
#line 83 "../src/Widgets/ScrolledWindow.vala"
	result = _widgets_scrolled_window_auto_scroll (self, TRUE);
#line 83 "../src/Widgets/ScrolledWindow.vala"
	return result;
#line 481 "ScrolledWindow.c"
}

static gboolean
_____lambda282__gsource_func (gpointer self)
{
	gboolean result;
	result = ____lambda282_ ((WidgetsScrolledWindow*) self);
#line 83 "../src/Widgets/ScrolledWindow.vala"
	return result;
#line 491 "ScrolledWindow.c"
}

static gboolean
_____lambda283_ (WidgetsScrolledWindow* self)
{
	gboolean result;
#line 86 "../src/Widgets/ScrolledWindow.vala"
	result = _widgets_scrolled_window_auto_scroll (self, FALSE);
#line 86 "../src/Widgets/ScrolledWindow.vala"
	return result;
#line 502 "ScrolledWindow.c"
}

static gboolean
______lambda283__gsource_func (gpointer self)
{
	gboolean result;
	result = _____lambda283_ ((WidgetsScrolledWindow*) self);
#line 86 "../src/Widgets/ScrolledWindow.vala"
	return result;
#line 512 "ScrolledWindow.c"
}

static void
_widgets_scrolled_window___lambda279_ (WidgetsScrolledWindow* self,
                                       gdouble x,
                                       gdouble y)
{
	GtkOrientation _tmp0_;
#line 66 "../src/Widgets/ScrolledWindow.vala"
	_tmp0_ = self->priv->_orientation;
#line 66 "../src/Widgets/ScrolledWindow.vala"
	if (_tmp0_ == GTK_ORIENTATION_VERTICAL) {
#line 525 "ScrolledWindow.c"
		gint height = 0;
		GtkScrolledWindow* _tmp1_;
		gint _tmp2_;
#line 67 "../src/Widgets/ScrolledWindow.vala"
		_tmp1_ = self->priv->scrolled_window;
#line 67 "../src/Widgets/ScrolledWindow.vala"
		height = gtk_widget_get_height ((GtkWidget*) _tmp1_);
#line 69 "../src/Widgets/ScrolledWindow.vala"
		_tmp2_ = self->priv->_margin;
#line 69 "../src/Widgets/ScrolledWindow.vala"
		if (y < ((gdouble) _tmp2_)) {
#line 70 "../src/Widgets/ScrolledWindow.vala"
			self->priv->scrolling = TRUE;
#line 71 "../src/Widgets/ScrolledWindow.vala"
			g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 100, _____lambda280__gsource_func, g_object_ref (self), g_object_unref);
#line 541 "ScrolledWindow.c"
		} else {
			gint _tmp3_;
#line 72 "../src/Widgets/ScrolledWindow.vala"
			_tmp3_ = self->priv->_margin;
#line 72 "../src/Widgets/ScrolledWindow.vala"
			if (y > ((gdouble) (height - _tmp3_))) {
#line 73 "../src/Widgets/ScrolledWindow.vala"
				self->priv->scrolling = TRUE;
#line 74 "../src/Widgets/ScrolledWindow.vala"
				g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 100, ______lambda281__gsource_func, g_object_ref (self), g_object_unref);
#line 552 "ScrolledWindow.c"
			} else {
#line 76 "../src/Widgets/ScrolledWindow.vala"
				self->priv->scrolling = FALSE;
#line 556 "ScrolledWindow.c"
			}
		}
	} else {
		gint width = 0;
		GtkScrolledWindow* _tmp4_;
		gint _tmp5_;
#line 79 "../src/Widgets/ScrolledWindow.vala"
		_tmp4_ = self->priv->scrolled_window;
#line 79 "../src/Widgets/ScrolledWindow.vala"
		width = gtk_widget_get_width ((GtkWidget*) _tmp4_);
#line 81 "../src/Widgets/ScrolledWindow.vala"
		_tmp5_ = self->priv->_margin;
#line 81 "../src/Widgets/ScrolledWindow.vala"
		if (x < ((gdouble) _tmp5_)) {
#line 82 "../src/Widgets/ScrolledWindow.vala"
			self->priv->scrolling = TRUE;
#line 83 "../src/Widgets/ScrolledWindow.vala"
			g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 100, _____lambda282__gsource_func, g_object_ref (self), g_object_unref);
#line 575 "ScrolledWindow.c"
		} else {
			gint _tmp6_;
#line 84 "../src/Widgets/ScrolledWindow.vala"
			_tmp6_ = self->priv->_margin;
#line 84 "../src/Widgets/ScrolledWindow.vala"
			if (x > ((gdouble) (width - _tmp6_))) {
#line 85 "../src/Widgets/ScrolledWindow.vala"
				self->priv->scrolling = TRUE;
#line 86 "../src/Widgets/ScrolledWindow.vala"
				g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 100, ______lambda283__gsource_func, g_object_ref (self), g_object_unref);
#line 586 "ScrolledWindow.c"
			} else {
#line 88 "../src/Widgets/ScrolledWindow.vala"
				self->priv->scrolling = FALSE;
#line 590 "ScrolledWindow.c"
			}
		}
	}
}

static void
__widgets_scrolled_window___lambda279__gtk_drop_controller_motion_motion (GtkDropControllerMotion* _sender,
                                                                          gdouble x,
                                                                          gdouble y,
                                                                          gpointer self)
{
#line 65 "../src/Widgets/ScrolledWindow.vala"
	_widgets_scrolled_window___lambda279_ ((WidgetsScrolledWindow*) self, x, y);
#line 604 "ScrolledWindow.c"
}

static GObject *
widgets_scrolled_window_constructor (GType type,
                                     guint n_construct_properties,
                                     GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	WidgetsScrolledWindow * self;
	GtkPolicyType _tmp0_ = 0;
	GtkOrientation _tmp1_;
	GtkPolicyType _tmp2_ = 0;
	GtkOrientation _tmp3_;
	GtkWidget* _tmp4_;
	GtkWidget* _tmp5_;
	GtkScrolledWindow* _tmp6_ = NULL;
	GtkDropControllerMotion* _tmp7_;
	GtkScrolledWindow* _tmp8_;
	GtkDropControllerMotion* _tmp9_;
	GtkEventController* _tmp10_;
	GtkDropControllerMotion* _tmp11_;
	GtkScrolledWindow* _tmp12_;
#line 51 "../src/Widgets/ScrolledWindow.vala"
	parent_class = G_OBJECT_CLASS (widgets_scrolled_window_parent_class);
#line 51 "../src/Widgets/ScrolledWindow.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 51 "../src/Widgets/ScrolledWindow.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, WIDGETS_TYPE_SCROLLED_WINDOW, WidgetsScrolledWindow);
#line 55 "../src/Widgets/ScrolledWindow.vala"
	_tmp1_ = self->priv->_orientation;
#line 55 "../src/Widgets/ScrolledWindow.vala"
	if (_tmp1_ == GTK_ORIENTATION_VERTICAL) {
#line 55 "../src/Widgets/ScrolledWindow.vala"
		_tmp0_ = GTK_POLICY_NEVER;
#line 640 "ScrolledWindow.c"
	} else {
#line 55 "../src/Widgets/ScrolledWindow.vala"
		_tmp0_ = GTK_POLICY_AUTOMATIC;
#line 644 "ScrolledWindow.c"
	}
#line 56 "../src/Widgets/ScrolledWindow.vala"
	_tmp3_ = self->priv->_orientation;
#line 56 "../src/Widgets/ScrolledWindow.vala"
	if (_tmp3_ == GTK_ORIENTATION_VERTICAL) {
#line 56 "../src/Widgets/ScrolledWindow.vala"
		_tmp2_ = GTK_POLICY_AUTOMATIC;
#line 652 "ScrolledWindow.c"
	} else {
#line 56 "../src/Widgets/ScrolledWindow.vala"
		_tmp2_ = GTK_POLICY_NEVER;
#line 656 "ScrolledWindow.c"
	}
#line 52 "../src/Widgets/ScrolledWindow.vala"
	_tmp4_ = self->priv->_widget;
#line 52 "../src/Widgets/ScrolledWindow.vala"
	_tmp5_ = _g_object_ref0 (_tmp4_);
#line 52 "../src/Widgets/ScrolledWindow.vala"
	_tmp6_ = (GtkScrolledWindow*) gtk_scrolled_window_new ();
#line 52 "../src/Widgets/ScrolledWindow.vala"
	gtk_widget_set_hexpand ((GtkWidget*) _tmp6_, TRUE);
#line 52 "../src/Widgets/ScrolledWindow.vala"
	gtk_widget_set_vexpand ((GtkWidget*) _tmp6_, TRUE);
#line 52 "../src/Widgets/ScrolledWindow.vala"
	g_object_set (_tmp6_, "hscrollbar-policy", _tmp0_, NULL);
#line 52 "../src/Widgets/ScrolledWindow.vala"
	g_object_set (_tmp6_, "vscrollbar-policy", _tmp2_, NULL);
#line 52 "../src/Widgets/ScrolledWindow.vala"
	gtk_scrolled_window_set_child (_tmp6_, _tmp5_);
#line 52 "../src/Widgets/ScrolledWindow.vala"
	_g_object_unref0 (_tmp5_);
#line 52 "../src/Widgets/ScrolledWindow.vala"
	gtk_scrolled_window_set_propagate_natural_height (_tmp6_, TRUE);
#line 52 "../src/Widgets/ScrolledWindow.vala"
	gtk_scrolled_window_set_propagate_natural_width (_tmp6_, TRUE);
#line 52 "../src/Widgets/ScrolledWindow.vala"
	g_object_ref_sink (_tmp6_);
#line 52 "../src/Widgets/ScrolledWindow.vala"
	_g_object_unref0 (self->priv->scrolled_window);
#line 52 "../src/Widgets/ScrolledWindow.vala"
	self->priv->scrolled_window = _tmp6_;
#line 62 "../src/Widgets/ScrolledWindow.vala"
	_tmp7_ = (GtkDropControllerMotion*) gtk_drop_controller_motion_new ();
#line 62 "../src/Widgets/ScrolledWindow.vala"
	_g_object_unref0 (self->priv->drop_motion_ctrl);
#line 62 "../src/Widgets/ScrolledWindow.vala"
	self->priv->drop_motion_ctrl = _tmp7_;
#line 63 "../src/Widgets/ScrolledWindow.vala"
	_tmp8_ = self->priv->scrolled_window;
#line 63 "../src/Widgets/ScrolledWindow.vala"
	_tmp9_ = self->priv->drop_motion_ctrl;
#line 63 "../src/Widgets/ScrolledWindow.vala"
	_tmp10_ = _g_object_ref0 ((GtkEventController*) _tmp9_);
#line 63 "../src/Widgets/ScrolledWindow.vala"
	gtk_widget_add_controller ((GtkWidget*) _tmp8_, _tmp10_);
#line 65 "../src/Widgets/ScrolledWindow.vala"
	_tmp11_ = self->priv->drop_motion_ctrl;
#line 65 "../src/Widgets/ScrolledWindow.vala"
	g_signal_connect_object (_tmp11_, "motion", (GCallback) __widgets_scrolled_window___lambda279__gtk_drop_controller_motion_motion, self, 0);
#line 93 "../src/Widgets/ScrolledWindow.vala"
	_tmp12_ = self->priv->scrolled_window;
#line 93 "../src/Widgets/ScrolledWindow.vala"
	adw_bin_set_child ((AdwBin*) self, (GtkWidget*) _tmp12_);
#line 51 "../src/Widgets/ScrolledWindow.vala"
	return obj;
#line 710 "ScrolledWindow.c"
}

static void
widgets_scrolled_window_class_init (WidgetsScrolledWindowClass * klass,
                                    gpointer klass_data)
{
#line 22 "../src/Widgets/ScrolledWindow.vala"
	widgets_scrolled_window_parent_class = g_type_class_peek_parent (klass);
#line 22 "../src/Widgets/ScrolledWindow.vala"
	g_type_class_adjust_private_offset (klass, &WidgetsScrolledWindow_private_offset);
#line 22 "../src/Widgets/ScrolledWindow.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_widgets_scrolled_window_get_property;
#line 22 "../src/Widgets/ScrolledWindow.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_widgets_scrolled_window_set_property;
#line 22 "../src/Widgets/ScrolledWindow.vala"
	G_OBJECT_CLASS (klass)->constructor = widgets_scrolled_window_constructor;
#line 22 "../src/Widgets/ScrolledWindow.vala"
	G_OBJECT_CLASS (klass)->finalize = widgets_scrolled_window_finalize;
#line 22 "../src/Widgets/ScrolledWindow.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), WIDGETS_SCROLLED_WINDOW_WIDGET_PROPERTY, widgets_scrolled_window_properties[WIDGETS_SCROLLED_WINDOW_WIDGET_PROPERTY] = g_param_spec_object ("widget", "widget", "widget", gtk_widget_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 22 "../src/Widgets/ScrolledWindow.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), WIDGETS_SCROLLED_WINDOW_ORIENTATION_PROPERTY, widgets_scrolled_window_properties[WIDGETS_SCROLLED_WINDOW_ORIENTATION_PROPERTY] = g_param_spec_enum ("orientation", "orientation", "orientation", gtk_orientation_get_type (), 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 22 "../src/Widgets/ScrolledWindow.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), WIDGETS_SCROLLED_WINDOW_MARGIN_PROPERTY, widgets_scrolled_window_properties[WIDGETS_SCROLLED_WINDOW_MARGIN_PROPERTY] = g_param_spec_int ("margin", "margin", "margin", G_MININT, G_MAXINT, 24, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 22 "../src/Widgets/ScrolledWindow.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), WIDGETS_SCROLLED_WINDOW_VADJUSTMENT_PROPERTY, widgets_scrolled_window_properties[WIDGETS_SCROLLED_WINDOW_VADJUSTMENT_PROPERTY] = g_param_spec_object ("vadjustment", "vadjustment", "vadjustment", gtk_adjustment_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 22 "../src/Widgets/ScrolledWindow.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), WIDGETS_SCROLLED_WINDOW_HADJUSTMENT_PROPERTY, widgets_scrolled_window_properties[WIDGETS_SCROLLED_WINDOW_HADJUSTMENT_PROPERTY] = g_param_spec_object ("hadjustment", "hadjustment", "hadjustment", gtk_adjustment_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 739 "ScrolledWindow.c"
}

static void
widgets_scrolled_window_instance_init (WidgetsScrolledWindow * self,
                                       gpointer klass)
{
#line 22 "../src/Widgets/ScrolledWindow.vala"
	self->priv = widgets_scrolled_window_get_instance_private (self);
#line 25 "../src/Widgets/ScrolledWindow.vala"
	self->priv->_margin = 24;
#line 30 "../src/Widgets/ScrolledWindow.vala"
	self->priv->scrolling = FALSE;
#line 752 "ScrolledWindow.c"
}

static void
widgets_scrolled_window_finalize (GObject * obj)
{
	WidgetsScrolledWindow * self;
#line 22 "../src/Widgets/ScrolledWindow.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, WIDGETS_TYPE_SCROLLED_WINDOW, WidgetsScrolledWindow);
#line 23 "../src/Widgets/ScrolledWindow.vala"
	_g_object_unref0 (self->priv->_widget);
#line 27 "../src/Widgets/ScrolledWindow.vala"
	_g_object_unref0 (self->priv->scrolled_window);
#line 28 "../src/Widgets/ScrolledWindow.vala"
	_g_object_unref0 (self->priv->drop_motion_ctrl);
#line 22 "../src/Widgets/ScrolledWindow.vala"
	G_OBJECT_CLASS (widgets_scrolled_window_parent_class)->finalize (obj);
#line 769 "ScrolledWindow.c"
}

static GType
widgets_scrolled_window_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (WidgetsScrolledWindowClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) widgets_scrolled_window_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (WidgetsScrolledWindow), 0, (GInstanceInitFunc) widgets_scrolled_window_instance_init, NULL };
	GType widgets_scrolled_window_type_id;
	widgets_scrolled_window_type_id = g_type_register_static (adw_bin_get_type (), "WidgetsScrolledWindow", &g_define_type_info, 0);
	WidgetsScrolledWindow_private_offset = g_type_add_instance_private (widgets_scrolled_window_type_id, sizeof (WidgetsScrolledWindowPrivate));
	return widgets_scrolled_window_type_id;
}

GType
widgets_scrolled_window_get_type (void)
{
	static volatile gsize widgets_scrolled_window_type_id__once = 0;
	if (g_once_init_enter (&widgets_scrolled_window_type_id__once)) {
		GType widgets_scrolled_window_type_id;
		widgets_scrolled_window_type_id = widgets_scrolled_window_get_type_once ();
		g_once_init_leave (&widgets_scrolled_window_type_id__once, widgets_scrolled_window_type_id);
	}
	return widgets_scrolled_window_type_id__once;
}

static void
_vala_widgets_scrolled_window_get_property (GObject * object,
                                            guint property_id,
                                            GValue * value,
                                            GParamSpec * pspec)
{
	WidgetsScrolledWindow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, WIDGETS_TYPE_SCROLLED_WINDOW, WidgetsScrolledWindow);
#line 22 "../src/Widgets/ScrolledWindow.vala"
	switch (property_id) {
#line 22 "../src/Widgets/ScrolledWindow.vala"
		case WIDGETS_SCROLLED_WINDOW_WIDGET_PROPERTY:
#line 22 "../src/Widgets/ScrolledWindow.vala"
		g_value_set_object (value, widgets_scrolled_window_get_widget (self));
#line 22 "../src/Widgets/ScrolledWindow.vala"
		break;
#line 22 "../src/Widgets/ScrolledWindow.vala"
		case WIDGETS_SCROLLED_WINDOW_ORIENTATION_PROPERTY:
#line 22 "../src/Widgets/ScrolledWindow.vala"
		g_value_set_enum (value, widgets_scrolled_window_get_orientation (self));
#line 22 "../src/Widgets/ScrolledWindow.vala"
		break;
#line 22 "../src/Widgets/ScrolledWindow.vala"
		case WIDGETS_SCROLLED_WINDOW_MARGIN_PROPERTY:
#line 22 "../src/Widgets/ScrolledWindow.vala"
		g_value_set_int (value, widgets_scrolled_window_get_margin (self));
#line 22 "../src/Widgets/ScrolledWindow.vala"
		break;
#line 22 "../src/Widgets/ScrolledWindow.vala"
		case WIDGETS_SCROLLED_WINDOW_VADJUSTMENT_PROPERTY:
#line 22 "../src/Widgets/ScrolledWindow.vala"
		g_value_set_object (value, widgets_scrolled_window_get_vadjustment (self));
#line 22 "../src/Widgets/ScrolledWindow.vala"
		break;
#line 22 "../src/Widgets/ScrolledWindow.vala"
		case WIDGETS_SCROLLED_WINDOW_HADJUSTMENT_PROPERTY:
#line 22 "../src/Widgets/ScrolledWindow.vala"
		g_value_set_object (value, widgets_scrolled_window_get_hadjustment (self));
#line 22 "../src/Widgets/ScrolledWindow.vala"
		break;
#line 834 "ScrolledWindow.c"
		default:
#line 22 "../src/Widgets/ScrolledWindow.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 22 "../src/Widgets/ScrolledWindow.vala"
		break;
#line 840 "ScrolledWindow.c"
	}
}

static void
_vala_widgets_scrolled_window_set_property (GObject * object,
                                            guint property_id,
                                            const GValue * value,
                                            GParamSpec * pspec)
{
	WidgetsScrolledWindow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, WIDGETS_TYPE_SCROLLED_WINDOW, WidgetsScrolledWindow);
#line 22 "../src/Widgets/ScrolledWindow.vala"
	switch (property_id) {
#line 22 "../src/Widgets/ScrolledWindow.vala"
		case WIDGETS_SCROLLED_WINDOW_WIDGET_PROPERTY:
#line 22 "../src/Widgets/ScrolledWindow.vala"
		widgets_scrolled_window_set_widget (self, g_value_get_object (value));
#line 22 "../src/Widgets/ScrolledWindow.vala"
		break;
#line 22 "../src/Widgets/ScrolledWindow.vala"
		case WIDGETS_SCROLLED_WINDOW_ORIENTATION_PROPERTY:
#line 22 "../src/Widgets/ScrolledWindow.vala"
		widgets_scrolled_window_set_orientation (self, g_value_get_enum (value));
#line 22 "../src/Widgets/ScrolledWindow.vala"
		break;
#line 22 "../src/Widgets/ScrolledWindow.vala"
		case WIDGETS_SCROLLED_WINDOW_MARGIN_PROPERTY:
#line 22 "../src/Widgets/ScrolledWindow.vala"
		widgets_scrolled_window_set_margin (self, g_value_get_int (value));
#line 22 "../src/Widgets/ScrolledWindow.vala"
		break;
#line 872 "ScrolledWindow.c"
		default:
#line 22 "../src/Widgets/ScrolledWindow.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 22 "../src/Widgets/ScrolledWindow.vala"
		break;
#line 878 "ScrolledWindow.c"
	}
}

